#!	/usr/cs/bin/csh -f

umask 000

source ~serpent/integ/source/cm/src/dirs

#	files which cannot be checked out
set bad_files = (Makefile Imakefile)

#	following are self-explanatory
set src_dir = src
set include_dir = include
set docs_dir = docs
set externs_dir = externs
set manual_pages_dir = man/man1
set rcs_dir = RCS
set rcs_ext = ,v
set journal_file = check_journal
set do_rcs

#	if no module name, barf
if ($1 == "") then
  echo "USAGE"
  echo "	serpent_source_checkout module_name file_name"
  echo " "
  echo "	where module_name is one of:"
  echo "		$mod_names"
  echo "	and file_name is the file in question (include the extension)"
  exit (1)
endif

#	if no file name, barf
if ($2 == "") then
  echo "	need a file_name"
  exit (1)
endif

#	if the module name is not valid, barf
while (1)
  foreach name ($mod_names)
    if ($name == $1) then
      break; break
    endif
  end
  echo "$1 not a valid module name, contact the libarian"
  exit (1)
end

#	if the file name is not valid, barf
foreach name ($bad_files)
  if ($name == $2) then
    echo "$2 cannot be checked out, contact the libarian"
    exit (1)
  endif
end

#       determine the directory in which to install according to either
#          the module name or the file's extension (or lack of one)
set ext = $2:e
if ($1 == "docs") then
  set dir = $docs_dir 
  if ($ext == "ps") then
    echo "cannot checkout .ps files"
    exit (1)
  endif
else if ( "$1" =~ demo* ) then
  set dir = $1
  set demo = $1:t
else if ( "$1" =~ int/ada* ) then
  set dir = $1
else if ($1 == "man") then
  set dir = $manual_pages_dir 
  if ($ext != "1") then
      echo 'man pages must have a ".1" extension.'
      exit (11)
  endif
else if ($ext == "h") then
  set dir = $1/$include_dir
else if ($ext == "sl") then
  set dir = $1/$src_dir
else if ($ext == "sbm") then
  set dir = $1/$src_dir
else if ($ext == "c") then
  set dir = $1/$src_dir
else if ($ext == "gl") then
  set dir = $1/$src_dir
else if ($ext == "me") then
  set dir = $1/$src_dir
else if ($ext == "at") then
  set dir = $1/$src_dir
else if ($ext == "l") then
  set dir = $1/$src_dir
else if ($ext == "y") then
  set dir = $1/$src_dir
else if ($ext == "sdd") then
  set dir = $1/$src_dir
else if ($ext == "ext") then
  set dir = $1/$include_dir
else if ($ext == "tx") then
  set dir = $1/$src_dir
else if ($ext == "") then
  set dir = $1/$src_dir
else 
  echo "$ext is an unknown file extension, contact the libarian"
  exit (1)
endif

set integdir=$integsrc/$dir
set integfile=$integdir/$2
set integRdir=$integdir/$rcs_dir
set integRfile=$integRdir/$2$rcs_ext

#	move the RCS file over to integ if necesary
if ($?do_rcs) then

# if the file is in integ already, do nothing
  if (-e $integRfile) then
  else if (-e $integfile) then
  else
    echo "$2 is not baselined in the $1 module."
    exit (1)
  endif
endif

#	first check and see if the desired file exists as a link, and delete
#	it if so. then check it out, but first go to the source structure

set localdir=$SERPENT_ROOT/$srcdir/$dir
pushd $localdir >&/dev/null
if (-e $2) then
  ls -F $2 |grep @ >/dev/null
  if ($status == 0) mv $2 .fReD%%shOrts
endif

if ($?do_rcs) then
  co -l $integRfile
  set costat=$status
else
  cp $integfile $2
  set costat=$status
endif

if ($costat == 0) then
  echo "$2	$1	$user	out	`date`" >>$integ/$journal_file
  echo "happy serpenting"

  if (-e .fReD%%shOrts) then
     rm .fReD%%shOrts
  endif

else
  if (-e .fReD%%shOrts) then
     mv .fReD%%shOrts $2
  endif
  echo "sorry"
endif
popd >&/dev/null

echo " "
