static char rcsid [] =
	"$Header: /u/04c/mnt/integ/source/compiler/src/RCS/c22_main.c,v 1.95 91/02/14 13:23:26 little Exp $";

/*--------------------------------------------------------------------------*\
|
|  Name:	c22_main.c
|
|  Description:
|	This is the main program for SLANG.
|
|  Component of:
|	SLANG processor
|
|  Project:
|	SERPENT System
|	User Interface Prototyping
|	Software Engineering Institute
|	Carnegie Mellon University
|	Pittsburgh, PA  15213
|
|  Change History:
$Log:	c22_main.c,v $
 * Revision 1.95  91/02/14  13:23:26  little
 * new version number
 * 
 * Revision 1.94  91/02/12  15:19:57  little
 * redo when the validate_sne instruction is generated & take out the
 * generation of the T_vc_list_init & T_dpt_vc_exists instructions: their
 * functionality has been incorporated into the T_validate_sne_cc instruction.
 * 
 * Revision 1.93  91/02/07  10:20:11  little
 * new version number
 * 
 * Revision 1.92  91/01/31  16:35:35  little
 * new version number
 * 
 * Revision 1.91  91/01/02  17:49:42  dvk
 * Sweeping changes throughout compiler for new interpreted output
 * 
 * Revision 1.90  90/11/12  12:21:38  dvk
 * Version number change
 * 
 * Revision 1.89  90/10/25  17:56:41  little
 * fix parameters in call to c22_error
 *   and new version number
 * 
 * Revision 1.88  90/10/17  13:57:13  little
 * new vewrsion number
 * 
 * Revision 1.87  90/10/09  16:22:23  little
 * new version number
 * 
 * Revision 1.86  90/10/07  17:12:26  little
 * new version number
 * 
 * Revision 1.85  90/10/04  19:22:33  little
 * new version number for the BIG change to the propagate mechanism
 * 
 * Revision 1.84  90/10/01  13:17:15  little
 * add potential firing line stuff
 * 
 * Revision 1.83  90/09/20  13:40:06  dvk
 * version change
 * 
 * Revision 1.82  90/09/17  19:19:35  dvk
 * version change
 * 
 * Revision 1.81  90/08/23  15:12:10  dvk
 * Verion change again for cay.y
 * 
 * Revision 1.80  90/08/22  17:12:15  dvk
 * Version number change reflects change in cay.y
 * 
 * Revision 1.79  90/07/24  19:15:20  dvk
 * Version number change
 * 
 * Revision 1.78  90/07/16  11:10:21  dvk
 * Version change for changes to csc and csc_exp
 * 
 * Revision 1.77  90/07/10  18:09:15  dvk
 * Version number change (changed cam.c, csc.c, csc_exp.c)
 * 
 * Revision 1.76  90/06/16  12:27:00  little
 * add the editor import switch to the parser
 * 
 * Revision 1.75  90/05/11  13:16:50  little
 * new version to correctly save and reset file information in cay.y
 * 
 * Revision 1.74  90/05/10  15:44:27  little
 * fix the usage printout to give correct program name
 * 
 * Revision 1.73  90/05/02  17:49:13  little
 * new version number
 * 
 * Revision 1.72  90/04/20  11:01:12  little
 * new version number
 * 
 * Revision 1.71  90/04/17  14:03:49  little
 * new version number
 * 
 * Revision 1.70  90/04/12  20:13:53  little
 * new verions number
 * 
 * Revision 1.69  90/03/15  11:21:01  dvk
 * Change in version number to reflect changes in cay.y
 * 
 * Revision 1.68  90/03/02  13:45:08  little
 * new version
 * 
 * Revision 1.67  90/02/22  14:51:59  dvk
 * Version change for changes to csc_exp.c
 * 
 * Revision 1.66  90/02/19  11:22:43  little
 * new version number
 * 
 * Revision 1.65  90/02/16  15:12:46  little
 * 
 * new version number
 * n
 * 
 * Revision 1.64  90/02/14  22:10:33  ejh
 * fixed include structure
 * 
 * Revision 1.63  90/02/12  16:55:07  dvk
 * Version change to relect changes in csc_exp
 * 
 * Revision 1.62  90/02/07  18:52:44  dvk
 * Version number upgrade to reflect semantic anaylsis additions to
 * cay.y and c22.h
 * 
 * Revision 1.61  90/02/01  15:53:10  dvk
 * Version change reflecting change to csc.c
 * 
 * Revision 1.60  90/01/29  00:52:58  dvk
 * Vesrion upgrade to match changes to csc.c
 * 
 * Revision 1.59  90/01/23  14:18:02  little
 * change version number
 * 
 * Revision 1.58  90/01/19  16:34:09  dvk
 * Version number change reflects other changes elsewhere
 * 
 * Revision 1.57  90/01/16  15:17:36  little
 * change to do c generation for snippets by vc instead after entire parse
 * new version number
 * 
 * Revision 1.55  90/01/04  17:55:34  dvk
 * Updated version number to reflect changes to parser and lexer
 * 
 * Revision 1.54  89/12/21  11:50:37  little
 * add support for slang file name output during dm run-time error print
 * 
 * Revision 1.53  89/11/08  13:14:34  little
 * change version number
 * 
 * Revision 1.52  89/10/23  19:55:21  ejh
 * took out ops references; declared fopen; switched over to u22_copy_string;
 * new version number
 * 
 * Revision 1.51  89/09/20  11:15:36  little
 * new version number and a new way of using c22_pp_filename which is used
 * for printing file name containing parse errors
 * 
 * Revision 1.50  89/09/01  11:03:52  little
 * bump version number
 * 
 * Revision 1.49  89/08/29  17:29:22  little
 * new vwersio
 * new version number
 * 
 * Revision 1.48  89/07/31  14:31:07  ejh
 * new version number
 * 
 * Revision 1.47  89/07/24  14:51:58  little
 * new version number
 * 
 * Revision 1.46  89/06/14  10:55:40  little
 * change version number
 * 
 * Revision 1.45  89/05/26  10:48:39  little
 * change version number
 * /
 * 
 * Revision 1.44  89/05/19  10:42:51  little
 * change version number
 * 
 * Revision 1.43  89/04/29  09:49:52  little
 * change version number
 * 
 * Revision 1.42  89/04/27  11:18:20  little
 * *** empty log message ***
 * 
 * Revision 1.41  89/04/14  11:27:49  little
 * new version number
 * 
 * Revision 1.40  89/04/12  18:59:39  little
 * new vewrsion number
 * 
 * Revision 1.39  89/04/07  16:13:25  little
 * change versino number
 * 
 * Revision 1.38  89/03/15  17:28:50  little
 * change version number
 * 
 * Revision 1.37  89/03/08  12:02:50  little
 * new version number
 * 
 * Revision 1.36  89/03/07  15:52:04  rcs
 * new version number
 * 
 * Revision 1.35  89/02/28  18:28:23  little
 * new version number
 * 
 * Revision 1.34  89/02/27  17:01:51  little
 * change version number
 * 
 * Revision 1.33  89/02/15  17:34:30  little
 * make the dialogue name a parameter in a lot of places
 * 
 * Revision 1.32  89/02/03  15:58:08  little
 * new version number
 * 
 * Revision 1.31  89/02/01  16:19:34  little
 * new vewrsion number
 * 
 * Revision 1.30  89/01/30  15:14:22  little
 * change version number
 * 
 * Revision 1.29  89/01/26  17:31:39  little
 * new version number
 * 
 * Revision 1.28  89/01/18  14:24:00  ejh
 * new version number
 * 
 * Revision 1.27  89/01/17  16:53:51  little
 * change version number
 * 
 * Revision 1.26  89/01/12  13:26:38  little
 * no changes
 * 
 * Revision 1.25  89/01/12  11:32:20  little
 * no changes
 * 
 * Revision 1.24  89/01/11  19:00:18  little
 * change version number
 * 
 * Revision 1.23  89/01/11  14:04:43  little
 * new version number
 * 
 * Revision 1.22  89/01/09  16:27:46  little
 * change version number
 * 
 * Revision 1.21  89/01/06  16:53:28  little
 * no change
 * 
 * Revision 1.20  89/01/06  14:36:28  little
 * no changes
 * 
 * Revision 1.19  89/01/06  14:30:19  little
 * no changes
 * 
 * Revision 1.18  89/01/06  14:27:56  little
 * no changes
 * 
 * Revision 1.17  89/01/06  14:24:39  little
 * no changes
 * 
 * Revision 1.16  89/01/06  14:17:34  little
 * no changes
 * 
 * Revision 1.15  89/01/04  14:41:05  ejh
 * new version number
 * 
 * Revision 1.14  88/12/21  16:57:20  ejh
 * new version number
 * 
 * Revision 1.13  88/12/20  15:34:29  ejh
 * new version number
 * 
 * Revision 1.12  88/12/15  13:56:55  little
 * change version number
 * 
 * Revision 1.11  88/12/14  10:39:37  little
 * change version number
 * 
 * Revision 1.10  88/12/04  14:02:14  little
 * change version number
 * 
 * Revision 1.9  88/11/03  18:48:58  little
 * change version number
 * 
 * Revision 1.8  88/10/31  15:02:02  little
 * change version number
 * 
 * Revision 1.7  88/10/24  17:01:34  little
 * change version number
 * 
 * Revision 1.6  88/10/11  11:40:52  little
 * change version number
 * 
 * Revision 1.5  88/10/04  17:32:01  little
 * change version number
 * 
 * Revision 1.4  88/10/03  08:57:03  little
 * change the version number
 * 
|
|	01 Mar 1988:	module created
|
\*--------------------------------------------------------------------------*\
|
|   Distribution: Approved for public release; distribution is unlimited.
|
|   Copyright (c) 1989  by  Carnegie  Mellon  University, Pittsburgh, PA.  The
|  Software Engineering  Institute  (SEI) is a federally  funded  research and
|  development center established  and  operated by Carnegie Mellon University
|  (CMU).  Sponsored  by  the  U.S.  Department  of   Defense  under  contract
|  F19628-85-C-0003,  the  SEI  is  supported  by  the  services  and  defense
|  agencies, with the U.S. Air Force as the executive contracting agent.
|
|    Permission to use,  copy,  modify, or  distribute  this  software and its
|  documentation for  any purpose and without fee  is hereby granted, provided
|  that  the above copyright notice appear  in  all copies and that both  that
|  copyright  notice  and   this  permission  notice  appear   in   supporting
|  documentation.   Further,  the  names  Software  Engineering  Institute  or
|  Carnegie  Mellon  University  may  not be used in  advertising or publicity
|  pertaining to distribution of the software without specific, written  prior
|  permission.  CMU makes no claims  or representations  about the suitability
|  of this software for any purpose.  This software is provided "as is" and no
|  warranty,  express  or  implied,  is  made  by  the  SEI  or CMU, as to the
|  accuracy  and  functioning of the program and related program material, nor
|  shall   the  fact of  distribution   constitute  any   such  warranty.   No
|  responsibility is assumed by the SEI or CMU in connection herewith.
|
\*--------------------------------------------------------------------------*/

#define	c22_TOP

#include	<stdio.h>	/* for I/O */
#include	"global.h"
#include	"u22.h"

/*	SLANG specific includes */

#include	"c22.h"	/* SLANG globals */

#define c22_VERSION     "3.04 (interpreter)"

/*--------------------------------------------------------------------------*\
|  Routine: c22_print_usage
|
|  Description:
|     output the help.man infor for the compiler
\*--------------------------------------------------------------------------*/
static void c22_print_usage()
{
   printf ("NAME\n\tslang_comp - compile a slang program\n\n");
   printf ("SYNTAX\n\tslang_comp [options] pre_processed_file dialogue_name\n\n");
   printf ("DESCRIPTION\n");
   printf ("\tThe slang_comp command compiles a Slang program into\n");
   printf ("\tC code.\n");
   printf ("\tThe pre_processed_file is usually the result of passing a\n");
   printf ("\t'raw' Slang file through the C preprocessor (/lib/cpp). The\n");
   printf ("\tdialogue name parameter is used to generated the output\n");
   printf ("\tfile names. It is usually the name of the file input to the\n");
   printf ("\tpreprocessor, w/o the extension. All errors go to either\n");
   printf ("\tstdout or stderr and may be redirected at will\n\n");
   printf ("OPTIONS\n");
   printf ("\t-dn\tsets debug level to n. useful values are 0,1,2,3\n");
   printf ("\t\tdefault is 1\n\n");
   printf ("\t-t\toutput syntax trees to stdout\n");
   printf ("\t\tdefault is to NOT output syntax trees\n\n");
   printf ("EXAMPLE\n\tslang_comp -c -d2 pre-processed_file spider\n");
   printf ("\n\n");
   return;
}					/* end c22_print_usage */

/*--------------------------------------------------------------------------*\
|  Routine: main
|
|  Description:
|     slang compiler main program
\*--------------------------------------------------------------------------*/
main	(argc, argv)
int argc;
string argv [];

{  string file_name;
   FILE	*file_ptr;
   int debug_level, output_debug_code, print_trees;
   char *p;
	/* tell the world we're here */
   fprintf (stdout, "Welcome to SLANG, Version %s\n\n", c22_VERSION);

   if (argc < 3)
      {c22_print_usage ();
      exit (1);
      }
	/* process the parameters */
   argv++;
   argc--;

   output_debug_code = 0;
   debug_level = 0;
   print_trees = 0;
   if (argc > 0) {
      p = *argv;
      if (*p == '-') {
         while ((argc > 0) && (*p++ == '-')) {
            switch (*p) {
               case 'd':
                   debug_level = *++p - '0';
                   break;
                case 'c':
                   fprintf (stderr, "Debug compilation no longer supported\n");
                   break;
                case 't':
                   print_trees = 1;
                   break;
                default:
                   fprintf (stderr, "slang_comp: bad flag -%c\n\n", *p);
                   c22_print_usage ();
                   exit (1);
               }
            argc--;
            argv++;
            p = *argv;
            }
         }
      }

   if (argc < 1) {
      fprintf (stderr, "input file name not provided.\n");
      exit (1);
      }
	/* open the file */
   file_name = u22_copy_string (*argv);
   c22_pp_filename = NULL;
   file_ptr = fopen (file_name, "r");
   if (file_ptr == NULL) {
      c22_error (OPEN_FILE, file_name, -1);
      exit (1);
      }
   argv++;
   argc--;

   if (argc < 1) {
      fprintf (stderr, "dialogue name not provided.\n");
      exit (1);
      }
   fprintf (stdout, "\n\tCompiling dialogue named %s\n\n", *argv);
	/* compile! */
   exit (c22_compile (file_ptr, debug_level, output_debug_code, print_trees,
      FALSE, *argv) ? 0 : 1);

}					/* end main */

