static char rcsid [] = "$Header: /u/04c/mnt/integ/source/compiler/src/RCS/cs2.c,v 1.43 1991/07/10 19:05:37 ejh Exp $";

/*
$Log: cs2.c,v $
 * Revision 1.43  1991/07/10  19:05:37  ejh
 * changed make_full_name so that "string" is passed in instead of without
 * the quotes
 *
 * Revision 1.42  1991/01/08  17:07:55  dvk
 * Added dumping of real constants
 *
 * Revision 1.41  91/01/02  17:48:39  dvk
 * Sweeping changes throughout compiler for new interpreted output
 * 
 * Revision 1.39  90/11/12  12:22:42  dvk
 * Slight change to .dlge.d to match new runit.c
 * 
 * Revision 1.38  90/11/01  15:43:08  little
 * no changes
 * 
 * Revision 1.37  90/10/09  16:22:50  little
 * generate c code for the new propagate mechanism, it is working better now
 * 
 * Revision 1.36  90/10/07  17:12:51  little
 * go back to old propagate mechanism until new one works better
 * 
 * Revision 1.35  90/10/04  19:23:08  little
 * BIG change to the propagate mechanism generate new code to correspond
 * 
 * Revision 1.34  90/10/01  13:17:31  little
 * add potential firing line stuff
 * 
 * Revision 1.33  90/09/17  19:17:15  dvk
 * Changed some printf's to fputs's
 * 
 * Revision 1.32  90/08/03  10:45:01  little
 * fix the code which goes to the s.c file to not use status symbolic
 * constants
 * 
 * Revision 1.31  90/02/14  22:13:05  ejh
 * fixed include structure
 * 
 * Revision 1.30  90/01/16  15:18:07  little
 * change to do c generation for snippets by vc instead after entire parse
 * 
 * Revision 1.29  90/01/12  14:58:04  dvk
 * No longer uses/generates 1.h output file.  No longer outputs DM_NAME...
 * 
 * Revision 1.28  90/01/08  18:36:37  dvk
 * no changes
 * 
 * Revision 1.27  89/10/23  20:01:20  ejh
 * declared fopen; renamed generated files; simplified make_full_name
 * 
 * Revision 1.26  89/10/08  00:45:07  serpent
 * short names: u22_runtime.h => u22_rt.h
 * 
 * Revision 1.25  89/08/29  17:30:00  little
 * change god to eve
 * 
 * Revision 1.24  89/08/23  11:21:48  bmc
 * Fixed erroneous printf statement.
 * 
 * Revision 1.23  89/08/02  13:12:53  little
 * fix up some debug stuff in the generated code for dgr_run_snippet
 * 
 * Revision 1.22  89/08/01  14:29:12  little
 * fix the location of the debug output on the cs2_snip_tags_stream
 * 
 * Revision 1.21  89/07/24  14:52:55  little
 * ops removal
 * 
 * Revision 1.20  89/05/22  17:22:36  bmc
 * Changed definition of dgr_run_snippet (generated code) due to changes
 * in DM run-time routines.
 * 
 * Revision 1.19  89/05/19  10:43:27  little
 * change generated c files to use the "fast" header
 * 
 * Revision 1.18  89/04/14  11:21:27  little
 * add open & close of cs2_ops_find2_stream, which is used to hold
 * find rules for vcs and vars.
 * 
 * Revision 1.17  89/04/07  17:50:47  ljb
 * restore shared data information from vc
 * 
 * Revision 1.16  89/04/03  13:54:14  little
 * no changes
 * 
 * Revision 1.15  89/03/28  12:55:25  serpent
 * changed  #ifdef 0  to  #if 0  to allow sun compile.
 * 
 * Revision 1.14  89/03/15  17:29:20  little
 * add the find & remove ops files.
 * modify the include file names which appear in the output c files.
 * 
 * Revision 1.13  89/03/15  13:57:11  rcs
 * no changes
 * 
 * Revision 1.12  89/02/27  17:06:07  little
 * cahnge csc_is_sd from being defined as static, so outside routines can
 * call it. change fatal_error for call to new and no bound sd into
 * being a compile error.
 * 
 * Revision 1.11  89/02/20  16:20:33  little
 * no changes
 * 
 * Revision 1.10  89/02/15  17:36:44  little
 * make output file (c & ops) names base on the dialogue name
 * 
 * Revision 1.9  89/02/03  15:58:37  little
 * change to put out correct info on the serpent "exec" file when there
 * is not a dm ill file
 * 
 * Revision 1.8  89/01/09  16:29:40  little
 * add some debug print
 * 
 * Revision 1.7  88/12/19  17:29:15  little
 * take out the write of dro_more.h to the oputput c files.
 * 
 * Revision 1.6  88/10/31  15:12:39  little
 * add call to cam_fix_atts in cs2_object.
 * 
 * Revision 1.5  88/10/24  17:04:42  little
 * change methods to not be handled by ops.  do not need to do any ops
 * code generation for methods.
 * 
 * Revision 1.4  88/10/04  17:32:20  little
 * add dialogue_name parameter to a couple of functions
 * 
 * Revision 1.3  88/10/03  09:00:08  little
 * add processing for dm shared data
 * 
*/


/*--------------------------------------------------------------------------*\
|
|   Distribution: Approved for public release; distribution is unlimited.
|
|   Copyright (c) 1989  by  Carnegie  Mellon  University, Pittsburgh, PA.  The
|  Software Engineering  Institute  (SEI) is a federally  funded  research and
|  development center established  and  operated by Carnegie Mellon University
|  (CMU).  Sponsored  by  the  U.S.  Department  of   Defense  under  contract
|  F19628-85-C-0003,  the  SEI  is  supported  by  the  services  and  defense
|  agencies, with the U.S. Air Force as the executive contracting agent.
|
|    Permission to use,  copy,  modify, or  distribute  this  software and its
|  documentation for  any purpose and without fee  is hereby granted, provided
|  that  the above copyright notice appear  in  all copies and that both  that
|  copyright  notice  and   this  permission  notice  appear   in   supporting
|  documentation.   Further,  the  names  Software  Engineering  Institute  or
|  Carnegie  Mellon  University  may  not be used in  advertising or publicity
|  pertaining to distribution of the software without specific, written  prior
|  permission.  CMU makes no claims  or representations  about the suitability
|  of this software for any purpose.  This software is provided "as is" and no
|  warranty,  express  or  implied,  is  made  by  the  SEI  or CMU, as to the
|  accuracy  and  functioning of the program and related program material, nor
|  shall   the  fact of  distribution   constitute  any   such  warranty.   No
|  responsibility is assumed by the SEI or CMU in connection herewith.
|
\*--------------------------------------------------------------------------*/

#define	cs2_TOP
#define	memoryPack

#include	<stdio.h>
#include	<listPack.h>
#include	<global.h>
#include	<cus.h>
#include	<u22.h>
#include	<isc.h>
#include	<c22.h>
#include	<cs2.h>
#include	<csc.h>
#include	<csd.h>
#include	<cam.h>
#include	<dri.h>

static dri_header cs2_dri_header;

/*--------------------------------------------------------------------------*\
|  Routine: cs2_cc_gen
|
|  Description:
|     generates code for the creation cond associated with the input vc
\*--------------------------------------------------------------------------*/
void cs2_cc_gen (vc)
cus_sym vc;
{
   set_status (ok);
   cam_fix_cc (vc);
   csc_cc_write (vc);
}					/* end cs2_cc_gen */

/*--------------------------------------------------------------------------*\
|  Routine: cs2_vars_gen
|
|  Description:
|     generates code for the vars associated with the input vc
\*--------------------------------------------------------------------------*/
int cs2_vars_gen (vc)
cus_sym vc;
{
   char *value, *var;
   set_status (ok);
   if (value = cus_get_prop (vc, variables_prop)) {
      loop_through_list ((LIST) value, var, char *) {
	csc_var_write (var);
	csd_var_write (var);
	}
      }
}					/* end cs2_vars_gen */

/*--------------------------------------------------------------------------*\
|  Routine: cs2_objs_gen
|
|  Description:
|     generates code for the objs associated with the input vc
\*--------------------------------------------------------------------------*/
int cs2_objs_gen (vc)
cus_sym vc;
{  char *obj, *att;
   LIST obj_list, att_list;

   set_status (ok);
   if (obj_list = (LIST) cus_get_prop (vc, objects_prop)) {
      obj_list = copy_list (obj_list, NOT_NODES);
      loop_through_list (obj_list, obj, char *) {
         cus_activate_context (cus_get_prop (obj, owned_context_prop));
         cam_fix_atts (obj);
         if (att_list = (LIST) cus_get_prop (obj, attributes_prop)) {
            loop_through_list (att_list, att, char *) {
               csc_att_write (att);
               csd_att_write (att);
               }
            }
         if (cus_get_prop (obj, methods_prop)) {
            cam_fix_methods (obj);
            csc_meth_write (obj);
            }
         csd_obj_write (obj);
         cus_deactivate_context ();
         }
      }
}					/* end cs2_objs_gen */


/*--------------------------------------------------------------------------*\
|  Routine: cs2_vc_cleanup
|
|  Description:
|     cleanup after generating code for a vc
\*--------------------------------------------------------------------------*/
void cs2_vc_cleanup (vc)
cus_sym vc;
{  char *parm;

	/* Now we restore properties which may have been overwritten by the
	   creation condition */

   if ((parm = cus_get_prop (vc, creating_sd_prop)) && csc_is_sd (parm)) {
      cus_put_prop (parm, created_vcs_prop,
           cus_get_prop (vc,old_created_vcs_prop));
      cus_put_prop (parm, parent_vc_prop,
           cus_get_prop (vc,old_parent_vc_prop));
      cus_put_prop (parm, owned_context_prop,
           cus_get_prop (vc, old_owned_context_prop));
      }
}					/* end cs2_vc_cleanup */

/*--------------------------------------------------------------------------*\
|  Routine: cs2_vc_gen
|
|  Description:
|     generates code for the input vc
\*--------------------------------------------------------------------------*/
int cs2_vc_gen (vc)
cus_sym vc;
{  char *value, *sub_vc;
   char *parm;

   set_status (ok);
	/* cc is in vc's "parents's" context */

   cs2_vars_gen (vc);
   cs2_objs_gen (vc);
   csc_action_write ("create", vc);
   csc_action_write ("destroy", vc);
}

/*--------------------------------------------------------------------------*\
|  Routine: cs2_open_output_file
|
|  Description:
|     open a file on which to put generated code
\*--------------------------------------------------------------------------*/
FILE *cs2_open_output_file (file_name)
string file_name;
{  FILE *stream;

   set_status (ok);
   stream = fopen (file_name, "w");
   if (!stream)
      FATAL_ERROR (fprintf (stderr, "cannot open file %s\n", file_name));
   return (stream);
}

#define make_full_name(ext) \
   u22_concat_string (".", dialogue_name, ext, NULL)

/*--------------------------------------------------------------------------*\
|  Routine: cs2_initialize_output_files
|
|  Description:
|     initialize the files on which generated code is placed
\*--------------------------------------------------------------------------*/
void cs2_initialize_output_files (dialogue_name)
string dialogue_name;
{  string full_name;

   set_status (ok);

   cs2_snip_tags_stream = cs2_open_output_file (make_full_name (".t"));
   cs2_consts_stream = cs2_open_output_file (make_full_name (".z"));
   fseek (cs2_consts_stream, sizeof (dri_header), 0);
   fputc ('\0', cs2_consts_stream);	/* This is simply to make dri_debug */
   fputc ('\0', cs2_consts_stream);	/* work a little neater, and not */
   fputc ('\0', cs2_consts_stream);	/* detect false strings for 0 and 1 */

   cs2_code_stream = cs2_open_output_file (make_full_name (".x"));
   cs2_header_stream = cs2_open_output_file (make_full_name (".h"));

   cs2_externs_stream = cs2_open_output_file (make_full_name (".c"));
   fputs ("#include <sys/types.h>\n", cs2_externs_stream);
   fprintf (cs2_externs_stream, "#include <%s>\n\n", make_full_name (".h"));

   c22_got_dm_box = false;
   cs2_symtab_stream = cs2_open_output_file (make_full_name ("t.d"));
   cs2_dm_init_stream = cs2_open_output_file (make_full_name ("i.d"));
   cs2_dm_exec_stream = cs2_open_output_file (make_full_name ("e.d"));
}

/*--------------------------------------------------------------------------*\
|  Routine: cs2_cleanup_output_files
|
|  Description:
|     add termination infor and close the files on which generated code is
|	placed
\*--------------------------------------------------------------------------*/
void cs2_cleanup_output_files (dialogue_name)
string dialogue_name;
{
   set_status (ok);

   cs2_dri_header.magic = DRI_MAGIC;
   cs2_dri_header.version = DRI_VERSION;
   cs2_dri_header.max_snippets = cs2_current_c_proc_number;
   cs2_dri_header.string_size = ftell (cs2_consts_stream) - sizeof (dri_header);
   cs2_dri_header.int_const_size = csc_dump_int_consts (cs2_consts_stream);
   cs2_dri_header.real_const_size = csc_dump_real_consts (cs2_consts_stream);
   fseek (cs2_consts_stream, 0L, 0);
   fwrite (&cs2_dri_header, sizeof (dri_header), 1, cs2_consts_stream);
   fclose (cs2_consts_stream);
   fclose (cs2_snip_tags_stream);
   fclose (cs2_symtab_stream);
   fclose (cs2_code_stream);
   /*
    * If we didn't write out any external functions, delete the externals
    * and headers files.  Close them, in any case.
    */
   if (ftell (cs2_header_stream) == 0L) {
	unlink (make_full_name (".c"));
	unlink (make_full_name (".h"));
	}
   else
	fputs ("\n\t};\n", cs2_externs_stream);
   fclose (cs2_externs_stream);
   fclose (cs2_header_stream);

   if (!c22_got_dm_box) {
#if 0
      fprintf (cs2_dm_init_stream, "%s %s\n", DM_BOX, NO_ILL_FILE);
#endif
      fprintf (cs2_dm_exec_stream, "%s_EXE %s -\n",
	u22_convert_string (dialogue_name, UPPERCASE), dialogue_name);
      }

   fclose (cs2_dm_init_stream);
   fclose (cs2_dm_exec_stream);
}

/*--------------------------------------------------------------------------*\
|  Routine: cs2_cleanup
|
|  Description:
|     wrapup the the code generation phase
\*--------------------------------------------------------------------------*/
void cs2_cleanup (dialogue_name)
string dialogue_name;
{
   set_status (ok);
   cs2_cleanup_output_files (dialogue_name);
}

/*--------------------------------------------------------------------------*\
|  Routine: cs2_initialize
|
|  Description:
|     initialize the code generation phase
\*--------------------------------------------------------------------------*/
void cs2_initialize (dialogue_name)
string dialogue_name;
{
   set_status (ok);
   cs2_initialize_output_files (dialogue_name);
   cs2_current_c_proc_number = 0;
}

/*--------------------------------------------------------------------------*\
|  Routine: cs2_gen
|
|  Description:
|     perfrom the code generation phase
\*--------------------------------------------------------------------------*/
void cs2_gen (dialogue_name)
string dialogue_name;
{  cus_sym god_vc;

   set_status (ok);

   god_vc = cus_look_up (c22_god_text);
   if (! god_vc) {
      DEBUG1 (fprintf (stderr, "cs2_gen CANNOT FIND HONCHO VC NAMED %s\n",
	c22_god_text))
      return;
      }

   csd_dm_rt_write (dialogue_name);
   csd_ill_files_write ();
   cs2_cleanup (dialogue_name);
}
