static char rcsid [] =
	"$Header: /u/04c/mnt/integ/source/compiler/src/RCS/csc.c,v 1.56 91/04/01 23:27:16 ejh Exp $";

/*
$Log:	csc.c,v $
 * Revision 1.56  91/04/01  23:27:16  ejh
 * took out all references to old_parm_list
 * 
 * Revision 1.55  91/02/12  15:22:38  little
 * redo when the validate_sne instruction is generated & take out the
 * generation of the T_vc_list_init & T_dpt_vc_exists instructions: their
 * functionality has been incorporated into the T_validate_sne_cc instruction.
 * 
 * Revision 1.54  91/02/07  10:20:36  little
 * change the order in which prologue stuff, getting the parent, and
 * valdiating the sne are performed
 * 
 * Revision 1.53  91/01/31  16:36:34  little
 * 
 * add generation of new sne_validate instructions
 * 
 * Revision 1.52  91/01/08  17:08:14  dvk
 * Added warning about functions returning real
 * 
 * Revision 1.51  91/01/07  19:33:15  dvk
 * Fixed a bug with else-less chains of elsif's (manifested itself as a
 * branch to a zero target - oops!
 * 
 * Revision 1.50  91/01/02  17:47:25  dvk
 * Sweeping changes throughout compiler for new interpreted output
 * 
 * Revision 1.48  90/10/10  15:42:13  dvk
 * Tabularized header information for error reporting
 * 
 * Revision 1.47  90/09/17  19:17:50  dvk
 * Changed some printf's to fputs's
 * 
 * Revision 1.46  90/07/16  11:09:09  dvk
 * Fixed so calls to get_atv of a constant of the same type now just prints
 * out the constant
 * 
 * Revision 1.45  90/07/10  18:06:12  dvk
 * Added code to create calls to dro_list_assign.  Changed prologue and
 * header routines to optionally print out declaration and initialization
 * of PARENT variable.
 * 
 * Revision 1.44  90/05/02  17:49:37  little
 * put a formfeed at the end of every generated c routine
 * 
 * Revision 1.43  90/04/20  10:57:50  little
 * set the current slang file name so errors can access it
 * 
 * Revision 1.42  90/04/17  14:05:24  little
 * add c code generation for label and goto statements
 * 
 * Revision 1.41  90/03/02  19:02:52  little
 * change the code generated for methods to NOT deallocate the sne.  it
 * is now being done by the code that runs the method.
 * 
 * Revision 1.39  90/02/21  10:55:57  little
 * change the code generated for the dob_destroy_data_object call
 * to have a second parameter of true (1)
 * 
 * Revision 1.38  90/02/14  22:13:24  ejh
 * fixed include structure
 * 
 * Revision 1.37  90/02/02  09:35:35  dvk
 * No changes.
 * 
 * Revision 1.36  90/02/01  15:52:08  dvk
 * Code generator no longer emits assignments to d22_slang_line_num
 * when line number has not changed.
 * 
 * Revision 1.35  90/01/29  00:52:32  dvk
 * Eliminated a few more extraneous newlines
 * 
 * Revision 1.34  90/01/23  14:24:36  little
 * add the deletion of snippet trees once code generation is done with
 * them (based on the c22_delete_trees_ok global)
 * 
 * 
 * Revision 1.33  90/01/16  15:18:36  little
 * change to do c generation for snippets by vc instead after entire parse
 * 
 * Revision 1.32  90/01/12  14:51:34  dvk
 * 1) Deleted save/restore of global variables in generated C prologue
 * 2) Eliminated superfluous "return"statement from end of snippets
 * 3) Split source line strings into component parts (similar changes in
 *    dm to work with this).
 * 4) No longer uses/generates 1.h file
 * 
 * Revision 1.31  89/12/21  11:52:13  little
 * add support for slang file name output during dm run-time error print
 * 
 * Revision 1.30  89/10/23  19:53:26  ejh
 * defined memoryPack
 * 
 * Revision 1.29  89/09/01  11:04:21  little
 * add name of thingiee (vc, obj, var, att) to runtime error printe striung
 * 
 * Revision 1.27  89/07/24  14:53:22  little
 * ops removal
 * 
 * Revision 1.26  89/05/26  10:49:37  little
 * change generated c code to use the new sne structure
 * 
 * Revision 1.25  89/05/22  17:23:29  bmc
 * Changed some of the generated code to accomodate changes in DM run-time
 * routines.
 * 
 * Revision 1.24  89/04/28  14:33:28  ljb
 * user defined functions debugged
 * new routine read_func_defs added
 * 
 * Revision 1.23  89/04/27  11:16:18  little
 * fix up generated c code for creation condition so everything is
 * correctly done wrt when the creation is true or false (move the
 * call to Ops_is_remove up "inside" the condtion).
 * 
 * Revision 1.22  89/04/25  09:15:51  ljb
 * generate calls to user defined functions
 * (this code hasn't been tested yet, I am checking this in
 * so that Reed can fix another bug)
 * 
 * Revision 1.21  89/04/07  17:49:56  ljb
 * save shared data information across vcs
 * 
 * Revision 1.20  89/03/28  12:54:18  serpent
 * changed  #ifdef 0  to  #if 0  to allow sun compile.
 * 
 * Revision 1.19  89/03/15  13:56:09  rcs
 * no changes
 * 
 * Revision 1.18  89/03/08  12:01:28  little
 * make the routine identification comments output in c code
 * not dependent on c22_output_debug_code
 * 
 * Revision 1.17  89/02/27  17:08:06  little
 * add some debug print
 * 
 * Revision 1.16  89/02/15  17:37:41  little
 * take out all to do with the "modified" file
 * 
 * Revision 1.15  89/02/09  16:30:25  ejh
 * added copyright notice
 * 
 * Revision 1.14  89/02/01  16:20:40  little
 * add test to see if there is a call to new in cc and compiler
 * found no "creating" sd; this is a compiler internal error
 * 
 * Revision 1.13  89/01/30  14:17:36  little
 * fix up so that the routine pet routine definition parameter list is
 * built correctly.
 * 
 * Revision 1.12  89/01/26  17:33:06  little
 * fix some debug statments which were at the wrong level
 * 
 * Revision 1.11  89/01/17  16:54:37  little
 * add some new properties for the "bound" sd data item when it
 * is present in a creation condition.
 * 
 * Revision 1.10  89/01/11  14:41:16  little
 * add generation of call to Ops_is_remove to the else of the
 * check of the creation condition
 * 
 * Revision 1.9  88/12/14  10:59:20  little
 * just a changes to some comments
 * 
 * Revision 1.8  88/12/04  13:24:53  little
 * fix the generated code fot the slang while loopp so that dro_boolean
 * is called in the condition.
 * 
 * Revision 1.7  88/11/08  14:06:07  little
 * generate code at the edn of each snippet to set d22_slang_source to null
 * string, so debug code "in between" snippet calls will not print the
 * particulars of the last snippet called.
 * 
 * Revision 1.6  88/11/04  17:05:33  little
 * generate code to make use of the d22_slang_source runtime var
 * 
 * Revision 1.5  88/10/24  17:08:13  little
 * change c code generated for methods to take the object id as a parameter,
 * instead of a pointer to the id.
 * 
 * Revision 1.4  88/10/04  17:32:45  little
 * add log comment.
 * add parameter number check to csc_fun_call_write
 * 
*/

/*--------------------------------------------------------------------------*\
|
|   Distribution: Approved for public release; distribution is unlimited.
|
|   Copyright (c) 1989  by  Carnegie  Mellon  University, Pittsburgh, PA.  The
|  Software Engineering  Institute  (SEI) is a federally  funded  research and
|  development center established  and  operated by Carnegie Mellon University
|  (CMU).  Sponsored  by  the  U.S.  Department  of   Defense  under  contract
|  F19628-85-C-0003,  the  SEI  is  supported  by  the  services  and  defense
|  agencies, with the U.S. Air Force as the executive contracting agent.
|
|    Permission to use,  copy,  modify, or  distribute  this  software and its
|  documentation for  any purpose and without fee  is hereby granted, provided
|  that  the above copyright notice appear  in  all copies and that both  that
|  copyright  notice  and   this  permission  notice  appear   in   supporting
|  documentation.   Further,  the  names  Software  Engineering  Institute  or
|  Carnegie  Mellon  University  may  not be used in  advertising or publicity
|  pertaining to distribution of the software without specific, written  prior
|  permission.  CMU makes no claims  or representations  about the suitability
|  of this software for any purpose.  This software is provided "as is" and no
|  warranty,  express  or  implied,  is  made  by  the  SEI  or CMU, as to the
|  accuracy  and  functioning of the program and related program material, nor
|  shall   the  fact of  distribution   constitute  any   such  warranty.   No
|  responsibility is assumed by the SEI or CMU in connection herewith.
|
\*--------------------------------------------------------------------------*/

#define	memoryPack

#include	<stdio.h>
#include	<string.h>
#include	<listPack.h>
#include	<hashPack.h>
#include	<global.h>
#include	<cus.h>
#include	<cud.h>
#include	<u22.h>
#include	<iid.h>
#include	<idd.h>
#include	<isc.h>
#include	<c22.h>
#include	<cs2.h>
#include	<ca2.h>
#include	<csc.h>
#include	<dri.h>

#define NEED_PARENT TRUE
#define BUILD_A_SNE TRUE
#define DO_NOT_BUILD_A_SNE FALSE
#define IN_CC TRUE
#define NOT_IN_CC FALSE

static char *csc_gen_attr, *csc_gen_obj, *csc_gen_vc, *csc_gen_var;
static cus_code_type csc_code_type;
static string current_file_name;
static int current_line_number;
static long prologue_remember;

/*--------------------------------------------------------------------------*\
|  Routine: csc_put_val, csc_put_token, csc_put_branch
|
|  Description:
|     Output a word or token to the output file.
\*--------------------------------------------------------------------------*/
void csc_put_val (stream, val)
FILE *stream;
long val;
{
#ifdef READABLE_BINARIES
    fprintf (stream, "%ld, ", val);
#else
    static short prefix_neg = (short)L_negative;
    static short prefix_long = (short)L_long;
    short sval = val;

    /*
     * First, see if the value fits in a short.  If so, output a short (if
     * it is negative, precede it with the L_negative marker).
     *
     * If the value is too big for a short, write it as a long (with the
     * L_long prefix preceding it).
     */
    if (val == sval) {
	if (sval >= 0)
	    (void) fwrite (&sval, sizeof (short), 1, stream);
	else {
	    (void) fwrite (&prefix_neg, sizeof (short), 1, stream);
	    (void) fwrite (&sval, sizeof (short), 1, stream);
	    }
	}
    else {
	(void) fwrite (&prefix_long, sizeof (short), 1, stream);
	sval = val & 0xffff;
	(void) fwrite (&sval, sizeof (short), 1, stream);
	sval = (val >> 16) & 0xffff;
	(void) fwrite (&sval, sizeof (short), 1, stream);
	}
#endif
}

void csc_put_token (stream, token)
FILE *stream;
dri_token token;
{
#ifdef READABLE_BINARIES
    fprintf (stream, "TOKEN<%d>\n", token);
#else
    short stoken = (short)token;

    (void) fwrite (&stoken, sizeof (short), 1, stream);
#endif
}

#define HERE -1L

static void csc_put_target (stream, where, target)
FILE *stream;
long where;
long target;
{
    static short prefix_long = (short)L_long;
    long remember;
    short sval;

    if (where != HERE) {
	remember = ftell (stream);
	(void) fseek (stream, where, 0);
	}
#ifdef READABLE_BINARIES
    fprintf (stream, "%07ld, ", target);
#else
    (void) fwrite (&prefix_long, sizeof (short), 1, stream);
    /*
     * The offsets we get are in bytes, but the interpreter works in shorts
     * (silk boxers, of course).  So, we have to divide the target by 2.
     */
    target /= 2;
    sval = target & 0xffff;
    (void) fwrite (&sval, sizeof (short), 1, stream);
    sval = (target >> 16) & 0xffff;
    (void) fwrite (&sval, sizeof (short), 1, stream);
#endif
    if (where != HERE) {
	(void) fseek (stream, remember, 0);
	if (target == 0L)
	    COMPILE_ERROR (fputs ("Consistancy error - branch to 0\n", stderr))
	}
}

/*--------------------------------------------------------------------------*\
|  Routine: csc_gen_string (and friends)
|
|  Description:
|     Add a string to the "strings" file if not already there, and output
|     the index of the string in the table.
\*--------------------------------------------------------------------------*/
typedef struct { char *s; long idx; } string_t;

#define STR_HASH_SIZE	1031

static int str_match_fn (match, str)
char *match;
string_t *str;
{
    return (strcmp (match, str->s) == 0);
}

static int str_hash_fn (name)
char* name;
{
    register char *cp;
    register int i;
    register int cnt = 0;

    cp = name;
    i = 0;
    while (*cp && ++cnt < 12)
	i = i*4 + *cp++;
    return (i % STR_HASH_SIZE);
}

void csc_gen_string (stream, str)
FILE *stream;
string str;
{
    static HASH string_hash = (HASH)0;
    string_t *entry;

    if (string_hash == 0)
	string_hash = make_hashtable (STR_HASH_SIZE, str_hash_fn, str_match_fn);
    if ((entry = (string_t *)get_from_hashtable (string_hash, str)) == NULL) {
	entry = (string_t *)make_node (sizeof (string_t));
	entry->s = str;
	/*
	 * We have to subtract the size of the header, since strings aren't
	 * at the absolute beginning of the file.
	 */
	entry->idx = ftell (cs2_consts_stream) - sizeof (dri_header);
	(void) add_to_hashtable (string_hash, entry, str);
	fwrite (str, sizeof (char), strlen (str)+1, cs2_consts_stream);
	}
#ifdef READABLE_BINARIES1
    fprintf (stream, "\"%s\" <%ld>, ", entry->s, entry->idx);
#else
    csc_put_val (stream, entry->idx);
#endif
}

/*--------------------------------------------------------------------------*\
|  Routine: csc_gen_user_function
|
|  Description:
|     Add a user routine to the "user routines" file if not already there,
|     and output the index of the routine in the table.
\*--------------------------------------------------------------------------*/
static void csc_gen_user_function (stream, funct, expect_retval)
FILE *stream;
cus_sym funct;
boolean expect_retval;
{
    static HASH funct_hash = (HASH)0;
    static routine_count = 0;
    char *name;
    string_t *entry;

    name = (char *)cus_get_prop (funct, c_function_name_prop);

    if (funct_hash == 0) {
	funct_hash = make_hashtable (STR_HASH_SIZE, str_hash_fn, str_match_fn);
	fputs ("caddr_t (*dri_user_functs []) () =\n", cs2_externs_stream);
	fputs ("\t{\n", cs2_externs_stream);
	}
    if ((entry = (string_t *)get_from_hashtable (funct_hash, name)) == NULL) {
	entry = (string_t *)make_node (sizeof (string_t));
	entry->s = name;
	entry->idx = routine_count++;
	(void) add_to_hashtable (funct_hash, entry, name);
	if (routine_count > 1)
	    fputs (",\n", cs2_externs_stream);
	fprintf (cs2_externs_stream, "\t%s", name);
	fprintf (cs2_header_stream, "extern caddr_t %s ();\n", name);
	}
#ifdef READABLE_BINARIES
    fprintf (stream, "%s <%ld>, ", entry->s, entry->idx);
#else
    csc_put_val (stream, (long)cus_get_prop (funct, num_operands_prop));
    csc_put_val (stream, entry->idx);
#endif

    if ((idd_data_types)cus_get_prop (funct,
		returned_value_conversion_function_prop) == idd_no_data_type) {
	csc_put_token (stream, T_void_user_function);
	if (!expect_retval) {
	    csc_put_token (stream, R_make_undefined_adi);
	    COMPILE_ERROR ( fprintf (stderr, "Void function %s has no return value!\n", entry->s) )
	    }
	}
    else {
	if (expect_retval) {
	    csc_put_token (stream, T_void_user_function);
	    COMPILE_WARNING ( fprintf (stderr, "Return value of function %s is ignored\n", entry->s) )
	    }
	else {
	    csc_put_token (stream, T_user_function);
	    switch ((idd_data_types)cus_get_prop (funct,
			returned_value_conversion_function_prop)) {
		case idd_boolean:
		    csc_put_token (stream, R_make_boolean_constant_adi);
		    break;
		case idd_buffer:
		    csc_put_token (stream, R_make_buffer_constant_adi);
		    break;
		case idd_id:
		    csc_put_token (stream, R_make_id_constant_adi);
		    break;
		case idd_integer:
		    csc_put_token (stream, R_make_integer_constant_adi);
		    break;
		case idd_real:
		    COMPILE_WARNING ( fprintf (stderr, "Return value of type real for function %s may not work\n", entry->s) )
		    csc_put_token (stream, R_make_real_constant_adi);
		    break;
		case idd_string:
		    csc_put_token (stream, R_make_immed_string_constant_adi);
		    break;
		default:
		    FATAL_ERROR ( fprintf (stderr, "Unknown routine return value\n") )
		}
	    }
	}
}

/*--------------------------------------------------------------------------*\
|  Routine: csc_free_tree
|
|  Description:
|     free up space from a tree
\*--------------------------------------------------------------------------*/
static void csc_free_tree (tree)
LIST tree;
{  char *branch;

   if (tree && (!cus_is_sym (tree))) {
      loop_through_list (tree, branch, char *)
         csc_free_tree (branch);
      free_list (tree, NOT_NODES);
      }
}


/*--------------------------------------------------------------------------*\
|  Routine: csc_free_most_of_snippet
|
|  Description:
|     free up space from most of a snippet, save the first element on
|	the list which is the snippet identifier
\*--------------------------------------------------------------------------*/
static void csc_free_most_of_snippet (snippet)
LIST snippet;
{  caddr_t tree, save;

   if (!c22_delete_trees_ok)
      return;

   if (cus_is_sym (snippet))
      return;

	/* save the first element in the snippet, we will need it later, but
	   go ahead and free everything else */

   save = get_from_head (snippet);
   while (tree = get_from_head (snippet))
      csc_free_tree (tree);
				/* now put the saved guy back */
   add_to_head (snippet, save);
}


/*--------------------------------------------------------------------------*\
|  Routine: csc_statements_write
|
|  Description:
|     generate c code for the a "set" of statements
\*--------------------------------------------------------------------------*/
static void csc_statement_write ();	/* Forward declaration */
static void csc_statements_write (stream, statements, current_statement, self)
FILE *stream;
LIST statements;
char *current_statement;
cus_sym self;
{

   set_status (ok);

   while (current_statement != NULL) {
      csc_statement_write (stream, current_statement, self);
      current_statement = get_list_next (statements, current_statement);
      }
}


/*--------------------------------------------------------------------------*\
|  Routine: csc_if_write
|
|  Description:
|     generate c code for an if statement
\*--------------------------------------------------------------------------*/
static void csc_if_write (stream, if_statement, self)
FILE *stream;
LIST if_statement;
cus_sym self;
{
   LIST statements, inner;
   long around_if, around_else;
   boolean saw_else = FALSE;

   set_status (ok);

				/* process the condition */
   csc_exp_write (stream, get_list_pos (if_statement, 2), self, FALSE);
   csc_put_token (stream, R_boolean);
   /*
    * Remember where we were, and output a dummy branch target
    */
   around_if = ftell (stream);
   csc_put_target (stream, HERE, 0L);
   csc_put_token (stream, T_if);
   /*
    * Process the "then" clause
    */
   statements = (LIST) get_list_pos (if_statement, 3);
   csc_statements_write (stream, statements, get_list_next (statements, NULL),
	self);
   /*
    * Process the "else" clause if there is one.  This includes backpatching
    * the "false" branch target (and the branch around the false part if
    * there is an else clause).  Also, process an intermediate "elsif"s
    */
   statements = (LIST) get_list_pos (if_statement, 4);
   if (statements) {
     while (statements) {
	around_else = ftell (stream);
        csc_put_target (stream, HERE, 0L);
        csc_put_token (stream, T_goto);
        csc_put_target (stream, around_if, ftell (stream));
	if ((cus_sym)get_list_head (statements) == car_elsif_symbol) {
	    /*
	     * Process the condition
	     */
	    csc_exp_write (stream, get_list_pos (statements, 2), self, FALSE);
	    csc_put_token (stream, R_boolean);
	    /*
	     * Remember where we were, and output a dummy branch target
	     */
	    around_if = ftell (stream);
	    csc_put_target (stream, HERE, 0L);
	    csc_put_token (stream, T_if);
	    /*
	     * Process the "then" clause
	     */
	    inner = (LIST) get_list_pos (statements, 3);
	    csc_statements_write (stream, inner, get_list_next (inner, NULL),
		 self);
	    csc_put_target (stream, around_else, ftell (stream));
	    statements = (LIST) get_list_next (if_statement, statements);
	    }
	else {
	    saw_else = TRUE;
	    csc_statements_write (stream, statements,
			get_list_next (statements, NULL), self);
	    csc_put_target (stream, around_else, ftell (stream));
	    break;
	    }
	}
     /*
      * This is needed if there is no closing else on a chain of elsif's
      */
     if (! saw_else)
	 csc_put_target (stream, around_if, ftell (stream));
     }
   else
        csc_put_target (stream, around_if, ftell (stream));
}


/*--------------------------------------------------------------------------*\
|  Routine: csc_while_write
|
|  Description:
|     generate c code for a while statement
\*--------------------------------------------------------------------------*/
static void csc_while_write (stream, while_statement, self)
FILE *stream;
LIST while_statement;
cus_sym self;
{
    LIST statements;
    long loop_top_addr;
    long loop_bottom_target;

    set_status (ok);
    loop_top_addr = ftell (stream);
    csc_exp_write (stream, get_list_pos (while_statement, 2), self, FALSE);
    csc_put_token (stream, R_boolean);
    loop_bottom_target = ftell (stream);
    csc_put_target (stream, HERE, 0L);
    csc_put_token (stream, T_if);

    statements = (LIST) get_list_pos (while_statement, 3);
    csc_statements_write (stream, statements, get_list_next (statements, NULL),
	 self);
    csc_put_target (stream, HERE, loop_top_addr);
    csc_put_token (stream, T_goto);
    csc_put_target (stream, loop_bottom_target, ftell (stream));
}


/*--------------------------------------------------------------------------*\
|  Routine: csc_fun_parm_write
|
|  Description:
|     generate c code for the parameter to a function
\*--------------------------------------------------------------------------*/
static void csc_fun_parm_write (stream,  cur_ptr, self, parameter_converter,
                        parameter_count, is_user_function)
FILE *stream;
LIST parameter_converter;
cus_sym self;
char *cur_ptr;
int parameter_count;
boolean is_user_function;
{
  /*
   * This procedure generates code for a single parameter of a function.  
   * If it is not the first parameter then a  ,  is generated prior
   * to generating anything else.  If the parameter is to an external
   * function and needs to be converted, then the call to the
   * conversion routine is generated.
   */

   idd_data_types param_type;

   if (parameter_converter != NULL)
	param_type = (idd_data_types) get_list_pos (parameter_converter,parameter_count);

   if (parameter_converter != NULL && param_type != idd_no_data_type) {
	/*
	 * We have parameters to convert. Now, see if we can shortcut
	 * the call to drc_get_atv by just pumping out the constant.
	 * This can only be done if the constant is converted to the type
	 * it already is (i.e., no conversion).
	 */
	if (cus_is_sym (cur_ptr) &&
	    cus_get_prop (cur_ptr, is_constant_prop) &&
	    (idd_data_types)cus_get_prop (cur_ptr, current_type_prop) == param_type &&
	    (param_type == idd_string ||
	     param_type == idd_integer ||
	     param_type == idd_boolean ||
	     (param_type == idd_id && (int)cus_get_prop (cur_ptr, current_value_prop) == -1))) {
	    /*
	     * If it is a constant, just print it.  We handle integer,
	     * boolean, and id all the same (since in the latter case we
	     * know here that the id's value is -1).
	     */
	    if (param_type == idd_string) {
		csc_gen_string (stream, (char *)cus_get_prop (cur_ptr, current_value_prop));
		if (is_user_function)
		    csc_put_token (stream, T_string_constant);
		}
	    else
		csc_put_val (stream, (long)cus_get_prop (cur_ptr, current_value_prop));
	    }
	else {
	    csc_exp_write (stream, cur_ptr, self, FALSE);
	    switch (param_type) {
	       case idd_boolean:
		   csc_put_token (stream, R_get_boolean_atv);
		   break;
	       case idd_integer:
		   csc_put_token (stream, R_get_integer_atv);
		   break;
	       case idd_real:
		   csc_put_token (stream, R_get_real_atv);
		   break;
	       case idd_string:
		   csc_put_token (stream, R_get_string_atv);
		   break;
	       case idd_record:
		   csc_put_token (stream, R_get_record_atv);
		   break;
	       case idd_id:
		   csc_put_token (stream, R_get_id_atv);
		   break;
	       case idd_buffer:
		   csc_put_token (stream, R_get_buffer_atv);
		   break;
	       case idd_undefined:
		   csc_put_token (stream, R_get_undefined_atv);
		   break;
	       default:
		  FATAL_ERROR (
		     fprintf (stderr,
			   "Type out of range in csc_fun_parm_write\n");
		     );
		     break;
	       }
	    }
	}
    else
	csc_exp_write (stream, cur_ptr, self, FALSE);
}


/*--------------------------------------------------------------------------*\
|  Routine: csc_fun_call_write
|
|  Description:
|     generate c code for a function call
\*--------------------------------------------------------------------------*/
void csc_fun_call_write (stream, fun_call_stmt, self, param_offset,
			    expect_retval)
FILE *stream;
LIST fun_call_stmt;
cus_sym self;
int param_offset;
boolean expect_retval;
{
   char *cur_ptr;
   int num_operands;
   cus_sym funct;
   LIST parameter_converter;
   int parameter_count;
   boolean is_user_function;

   set_status (ok);

   num_operands = list_length (fun_call_stmt) - param_offset;
   funct = (cus_sym) get_list_pos (fun_call_stmt, param_offset);
   if (!cus_get_prop (funct, is_built_in_prop)) {
      COMPILE_ERROR (fprintf (stderr, "%s is not a defined function\n",
			cus_sym_representation (funct)));
      return;
      }
   if (num_operands != (int) cus_get_prop (funct, num_operands_prop)) {
      COMPILE_ERROR (fprintf (stderr,
		       "function has incorrect number of parameters\n");
         fprintf (stderr, "got %d, expected %d\n", num_operands,
		       (int) cus_get_prop (funct, num_operands_prop));
         cud_print_tree (stderr,  fun_call_stmt, ""));
      return;
      }

   /*
    * If the prop "built_in" is 2, the function is not really built in,
    * but is simply "defined".  In this case, it is an external function,
    * and we have to mark it so.  If it is really built in (if the value is
    * not 2, it must be built in, otherwise we wouldn't be here), then
    * output the appropriate token to call the routine.
    */
   is_user_function = ((int)cus_get_prop (funct, is_built_in_prop) == 2);

    /*now generate the code for the function.*/

   parameter_converter = (LIST)cus_get_prop(funct,
      parameter_conversion_functions_prop);

   parameter_count = 1;
   
   if (cur_ptr = get_list_pos (fun_call_stmt, param_offset+1)) {
        csc_fun_parm_write (stream,  cur_ptr, self, parameter_converter,
            parameter_count, is_user_function);
      
      while ((cur_ptr = get_list_next (fun_call_stmt, cur_ptr)) != NULL) {
         parameter_count++;
         csc_fun_parm_write  (stream,  cur_ptr, self, parameter_converter,
             parameter_count, is_user_function);
        }
      }

   if (is_user_function)
       csc_gen_user_function (stream, funct, expect_retval);
   else
       csc_put_token (stream, (long)cus_get_prop (funct, c_function_name_prop));

   set_status (ok);
}


/*--------------------------------------------------------------------------*\
|  Routine: csc_comment_write
|
|  Description:
|     generate c code for a comment
\*--------------------------------------------------------------------------*/
static void csc_comment_write (stream, comment_statement, self)
FILE *stream;
LIST comment_statement;
cus_sym self;
{  char *rest;

   set_status (ok);

#ifdef READABLE_BINARIES
   fputs ("#if  0\n", stream);
   fprintf (stream, "/* %s */\n",
      cus_get_prop (get_list_pos (comment_statement, 2), current_value_prop));
   fputs ("#endif\n", stream);
   if (rest = get_list_pos (comment_statement, 3))
      csc_comment_write (stream, rest, self);
#endif
}


#if 0
/*--------------------------------------------------------------------------*\
|  Routine: csc_list_assign_write
|
|  Description:
|     generate c code for a statement
\*--------------------------------------------------------------------------*/
static void csc_list_assign_write (stream, statements, current_statement, self)
FILE *stream;
LIST statements;
char *current_statement;
cus_sym self;
{
    cus_sym head;
    c22_src_struct *src_info;
    cus_sym lhs, rhs;
    cus_sym_type lhs_type;
    idd_data_types rhs_type;

    set_status (ok);

    while (current_statement != NULL) {
	head = (cus_sym) get_list_head (current_statement);
	src_info = (c22_src_struct *) get_head_val (current_statement);
	if (src_info) {
	    c22_slang_line_num = src_info->line;
	    csc_put_val (stream, (long)c22_slang_line_num);
	    }
	else {
	    csc_put_val (stream, -1L);
	    }

	if (head != car_gets_symbol) {
	    FATAL_ERROR (
		fprintf (stderr, "Did not get a get_statement in csc_list_assign_write\n");
		cud_print_tree (current_statement)
		);
	    }
	if (list_length (current_statement) != 3) {
	    FATAL_ERROR (
		fprintf (stderr, "bad gets_statement\n");
		cud_print_tree (current_statement)
		);
	    }

	rhs = (cus_sym) get_list_pos (current_statement, 3);
	lhs = (cus_sym) get_list_pos (current_statement, 2);
	if (lhs == car_self_symbol) {
	    COMPILE_ERROR ( fprintf (stderr, "cannot assign to self\n"));
	    }
	if (!cus_is_sym (lhs)) {
	    FATAL_ERROR (
		fprintf (stderr, "csc_list_assign_write: got a dot tree\n");
		cud_print_tree (current_statement)
		);
	    }
	lhs_type = (cus_sym_type) cus_get_prop (lhs, type_prop);
	if (lhs_type != attribute_sym) {
	    FATAL_ERROR (
		fprintf (stderr, "Got a non-attribute in csc_list_assign_write\n");
		cud_print_tree (current_statement)
		);
	    }
	rhs_type = (idd_data_types)cus_get_prop(rhs,current_type_prop);
	switch (rhs_type) {
	  case idd_boolean:
	     csc_put_token (stream, C_idd_boolean);
	     csc_gen_string (stream, cus_sym_representation (lhs));
	     csc_put_val (stream, (long)cus_get_prop (rhs, current_value_prop));
	     break;
	  case idd_integer:
	     csc_put_token (stream, C_idd_integer);
	     csc_gen_string (stream, cus_sym_representation (lhs));
	     csc_put_val (stream, (long)cus_get_prop (rhs, current_value_prop));
	     break;
	  case idd_id:
	     csc_put_token (stream, C_idd_id);
	     csc_gen_string (stream, cus_sym_representation (lhs));
	     csc_put_val (stream, (long)cus_get_prop (rhs, current_value_prop));
	     break;
	  case idd_string:
	     csc_put_token (stream, C_idd_string);
	     csc_gen_string (stream, cus_sym_representation (lhs));
	     csc_gen_string (stream, cus_get_prop (rhs, current_value_prop));
	     break;
	  default:
	    FATAL_ERROR (
		fprintf (stderr, "Got an unknown rhs-type in csc_list_assign_write\n");
		cud_print_tree (current_statement)
		);
	  }
	csc_put_token (stream, R_list_assign);
	current_statement = get_list_next (statements, current_statement);
	}
}
#endif


/*--------------------------------------------------------------------------*\
|  Routine: csc_statement_write
|
|  Description:
|     generate c code for a statement
\*--------------------------------------------------------------------------*/
static void csc_statement_write (stream, statement, self)
FILE *stream;
LIST statement;
cus_sym self;
{  cus_sym head;
   c22_src_struct *src_info;

   set_status (ok);

   head = (cus_sym) get_list_head (statement);
   src_info = (c22_src_struct *) get_head_val (statement);
   if (src_info) {
      c22_slang_line_num = src_info -> line;
      c22_pp_filename = src_info -> file_name;
      if (strcmp (current_file_name, c22_pp_filename)) {
	 csc_gen_string (stream, c22_pp_filename);
         csc_put_token (stream, T_slang_file);
         current_file_name = c22_pp_filename;
         }
      if (current_line_number != c22_slang_line_num) {
	 csc_put_val (stream, c22_slang_line_num);
	 csc_put_token (stream, T_slang_line_num);
         current_line_number = c22_slang_line_num;
         }
      }

   if (head == car_if_symbol || head == car_elsif_symbol)
      csc_if_write (stream, statement, self);
    else if (head == car_while_symbol)
      csc_while_write (stream, statement, self);
    else if (head == car_function_call_symbol)
      csc_fun_call_write (stream, statement, self, 2, TRUE);
    else if (head ==  car_gets_symbol)
      csc_gets_write (stream, statement, self);
    else if (head == car_comment_symbol)
      csc_comment_write (stream, statement, self);
    else
      FATAL_ERROR (fprintf (stderr, "UNKNOWN STATEMENT TREE\n");
         cud_print_tree (stderr, statement, "   "));
}


/*--------------------------------------------------------------------------*\
|  Routine: validate_sne_write
|
|  Description:
|     write the code necessary near the front of a snippet to validate the sne
\*--------------------------------------------------------------------------*/
static void validate_sne_write (stream, in_cc)
FILE *stream;
boolean in_cc;
{

   csc_put_token (stream, in_cc ? T_validate_sne_cc : T_validate_sne);
   prologue_remember = ftell (stream);
   csc_put_target (stream, HERE, 0L);
   csc_put_token (stream, T_if);
   return;
}					/* end validate_sne_write */


/*--------------------------------------------------------------------------*\
|  Routine: global_prologue_write
|
|  Description:
|     write the code necessary at the front of every snippet
\*--------------------------------------------------------------------------*/
static void global_prologue_write (stream, file_name, line_num,
					build_sne, need_parent, in_cc)
FILE *stream;
string file_name;
int line_num;
boolean build_sne;
boolean need_parent;
boolean in_cc;
{
   csc_put_val (stream, line_num);
   csc_gen_string (stream, file_name);
   switch (csc_code_type) {
      case cus_ATTR:
	csc_put_token (stream, C_cus_ATTR);
	csc_gen_string (stream, csc_gen_attr);
	csc_gen_string (stream, csc_gen_obj);
	break;
      case cus_CREATE:
	csc_put_token (stream, C_cus_CREATE);
	csc_put_val (stream, 0L);
	csc_put_val (stream, 0L);
	break;
      case cus_DESTROY:
	csc_put_token (stream, C_cus_DESTROY);
	csc_put_val (stream, 0L);
	csc_put_val (stream, 0L);
	break;
      case cus_METH:
	csc_put_token (stream, C_cus_METH);
	csc_put_val (stream, 0L);
	csc_gen_string (stream, csc_gen_obj);
	break;
      case cus_CCOND:
	csc_put_token (stream, C_cus_CCOND);
	csc_put_val (stream, 0L);
	csc_put_val (stream, 0L);
	break;
      case cus_VAR:
	csc_put_token (stream, C_cus_VAR);
	csc_gen_string (stream, csc_gen_var);
	csc_put_val (stream, 0L);
	break;
      default:
	FATAL_ERROR (fprintf (stderr,
	    "global_prologue_write called with invalid csc_code_type\n"));
      }
    /* everything has a vc, so always write it out */
    csc_gen_string (stream, csc_gen_vc);
    csc_put_val (stream, build_sne);
    csc_put_token (stream, T_dmsg_setup);

    validate_sne_write (stream, in_cc);

    if (need_parent)
      csc_put_token (stream, T_get_PARENT_vc);

    return;
}					/* end global_prologue_write */


/*--------------------------------------------------------------------------*\
|  Routine: c_global_epilogue_write
|
|  Description:
|     write the c code needed for restoring the global runtime vars
\*--------------------------------------------------------------------------*/
static void c_global_epilogue_write (stream, in_cc)
FILE *stream;
boolean in_cc;
{
   csc_put_target (stream, prologue_remember, ftell (stream));
   csc_put_token (stream, T_reset_slang_line_num);
   current_line_number = -1;
   csc_put_token (cs2_code_stream, T_return);
   return;
}

#ifdef READABLE_BINARIES
/*--------------------------------------------------------------------------*\
|  Routine: c_header_write
|
|  Description:
|     write the infor needed for the beginning of a c routine
\*--------------------------------------------------------------------------*/
static void c_header_write (stream, routine_name, need_parent)
FILE *stream;
string routine_name;
boolean need_parent;
{

   fprintf (stream, "void %s (sne)\n", routine_name);
   fputs ("dgr_sne *sne;\n", stream);
   fputs ("{   \n", stream);
   if (need_parent)
       fputs ("    static dro_atomic_data_item PARENT;\n", stream);
}
#endif


/*--------------------------------------------------------------------------*\
|  Routine: csc_generic_call_write
|
|  Description:
|     writes info wrt the "generic" calling mechanism used at run-time
|	onto the headers files
\*--------------------------------------------------------------------------*/
static void csc_generic_call_write (sym, proc_name)
cus_sym sym;
string proc_name;
{  

#ifdef READABLE_BINARIES
    fprintf (cs2_header_stream, "void %s ();\t/***** %d *****/\n\n",
		proc_name, cs2_current_c_proc_number);
    fprintf (cs2_snip_tags_stream, "\t%s, (idx = %ld)\n",
		proc_name, ftell (cs2_code_stream));
#else
    /*
     * The index in the snippet tags stream is the offset of the
     * short in the code stream, not the byte offset.
     */
    long where_am_i = ftell (cs2_code_stream) / sizeof (short);

    fwrite (&where_am_i, sizeof (long), 1, cs2_snip_tags_stream);
#endif
    cus_put_prop (sym, c_proc_number_prop, cs2_current_c_proc_number);
    cs2_current_c_proc_number++;
}


/*--------------------------------------------------------------------------*\
|  Routine: csc_snip_write
|
|  Description:
|     generate c code for a snippet
\*--------------------------------------------------------------------------*/
static void csc_snip_write (stream, snippet, self, build_sne)
FILE *stream;
LIST snippet;
cus_sym self;
boolean build_sne;
{  char *snippet_name;
   c22_src_struct *src_info;
   boolean collected;

   set_status (ok);
   if (snippet) {
      snippet_name = get_list_next (snippet, NULL);

      src_info = (c22_src_struct *) get_head_val (snippet);
      if (src_info) {
         c22_slang_line_num = src_info -> line;
         current_line_number = c22_slang_line_num;
         c22_pp_filename = src_info -> file_name;
         current_file_name = c22_pp_filename;
         }

      csc_generic_call_write (snippet_name,
	 cus_sym_representation (snippet_name));

        /* build routine header, parameters, and automatics */

      collected = (boolean) cus_get_prop (self, collected_attr_assign_prop);
#ifdef READABLE_BINARIES
      c_header_write (stream, cus_sym_representation(snippet_name), !collected);
#endif

			/* build routine body */
      global_prologue_write (stream, current_file_name, c22_slang_line_num,
	  build_sne, !collected, NOT_IN_CC);

#if 0
      if (collected)
	  csc_list_assign_write (stream, snippet,
	    get_list_next (snippet, snippet_name), self);
      else
#endif
	  csc_statements_write (stream, snippet,
	    get_list_next (snippet, snippet_name), self);

      c_global_epilogue_write (stream);
      csc_put_token (cs2_code_stream, T_snip_end);
      csc_free_most_of_snippet (snippet);
      }
}					/* end csc_snip_write */

/*--------------------------------------------------------------------------*\
|  Routine: csc_action_prologue
|
|  Description:
|     generate c code for the prologue for create/destroy actions
\*--------------------------------------------------------------------------*/
static void csc_action_prologue (stream, type, vc)
FILE *stream;
string type;
cus_sym vc;
{
   csc_gen_vc = cus_sym_representation (vc);
#ifdef READABLE_BINARIES
   fprintf (stream, "\t/* %s action, vc = %s, u_name = %s */\n", type,
	cus_sym_representation (vc), cus_get_prop (vc, u_name_prop));
#endif
}


/*--------------------------------------------------------------------------*\
|  Routine: csc_action_write
|
|  Description:
|     generate c code for create/destroy actions
\*--------------------------------------------------------------------------*/
void csc_action_write (type, vc)
string type;
cus_sym vc;
{  LIST snippet;

   set_status (ok);

   if (!strcmp (type, "create")) {
      csc_code_type = cus_CREATE;
      snippet = (LIST) cus_get_prop (vc, create_actions_snippet_prop);
      if (snippet) {
         csc_action_prologue (cs2_code_stream, type, vc);
#ifdef READABLE_BINARIES
         csc_action_prologue (cs2_header_stream, type, vc);
#endif
         csc_snip_write (cs2_code_stream, snippet, vc, DO_NOT_BUILD_A_SNE);
         }
      }
    else if (!strcmp (type, "destroy")) {
      csc_code_type = cus_DESTROY;
      snippet = (LIST) cus_get_prop (vc, destroy_actions_snippet_prop);
      if (snippet) {
         csc_action_prologue (cs2_code_stream, type, vc);
#ifdef READABLE_BINARIES
         csc_action_prologue (cs2_header_stream, type, vc);
#endif
         csc_snip_write (cs2_code_stream, snippet, vc, DO_NOT_BUILD_A_SNE);
         }
      }
    else
      FATAL_ERROR (fprintf (stderr,
	"csc_action_write called with invalid type of %s\n", type));
}					/* end csc_action_write */


/*--------------------------------------------------------------------------*\
|  Routine: csc_meth_prologue
|
|  Description:
|     generate c code for the prologue for a method
\*--------------------------------------------------------------------------*/
static void csc_meth_prologue (stream, obj)
FILE *stream;
cus_sym obj;
{  cus_sym parent_vc;

   parent_vc = (cus_sym) cus_get_prop (obj, parent_vc_prop);
   csc_code_type = cus_METH;
   csc_gen_obj = cus_sym_representation (obj);
   csc_gen_vc = cus_sym_representation (parent_vc);
#ifdef READABLE_BINARIES
   fprintf (stream,
      "\t/* method for object = %s, u_name = %s\n\tvc = %s, u_name = %s */\n",
	cus_sym_representation (obj), cus_get_prop (obj, u_name_prop),
	cus_sym_representation (parent_vc),
	cus_get_prop (parent_vc, u_name_prop));
#endif
}


/*--------------------------------------------------------------------------*\
|  Routine: csc_meth_write
|
|  Description:
|     generate c code for a method
\*--------------------------------------------------------------------------*/
void csc_meth_write (obj)
cus_sym obj;
{  LIST snippet;
   cus_sym self;
   char *snippet_name;
   c22_src_struct *src_info;
   long remember;

   set_status (ok);

   snippet = (LIST) cus_get_prop (obj, fixed_method_snippet_prop);
   if (!snippet)
      return;

   csc_meth_prologue (cs2_code_stream, obj);
#ifdef READABLE_BINARIES
   csc_meth_prologue (cs2_header_stream, obj);
#endif
   self = (cus_sym) cus_get_prop (obj, fixed_method_prop);

   snippet_name = get_list_next (snippet, NULL);
   src_info = (c22_src_struct *) get_head_val (snippet);
   if (src_info) {
      c22_slang_line_num = src_info -> line;
      current_line_number = c22_slang_line_num;
      c22_pp_filename = src_info -> file_name;
      current_file_name = c22_pp_filename;
      }

   csc_generic_call_write (snippet_name, cus_sym_representation (snippet_name));

      /* build routine header, parameters, and automatics */

#ifdef READABLE_BINARIES
   c_header_write (cs2_code_stream,
		cus_sym_representation (snippet_name), NEED_PARENT);
#endif

			/* build routine body */

   global_prologue_write (cs2_code_stream, current_file_name,
	c22_slang_line_num, DO_NOT_BUILD_A_SNE, NEED_PARENT, NOT_IN_CC);

			/* now the code to see if we are in the "rite" 
			   snippet */
   csc_gen_string (cs2_code_stream, cus_get_prop (obj, u_name_prop));
   csc_put_token (cs2_code_stream, T_method_verify);
   remember = ftell (cs2_code_stream);
   csc_put_target (cs2_code_stream, HERE, 0L);
   csc_put_token (cs2_code_stream, T_if);
   c_global_epilogue_write (cs2_code_stream);
   csc_put_target (cs2_code_stream, remember, ftell (cs2_code_stream));

			/* now for the "guts" of the body */

   /* epilogue write resets the current line_number - fix it back */
   current_line_number = c22_slang_line_num;
   csc_statements_write (cs2_code_stream, snippet,
	get_list_next (snippet, snippet_name), self);

   c_global_epilogue_write (cs2_code_stream);
   csc_put_token (cs2_code_stream, T_snip_end);
   csc_free_most_of_snippet (snippet);
}


/*--------------------------------------------------------------------------*\
|  Routine: csc_att_prologue
|
|  Description:
|     generate c code for the prologue for an attribute
\*--------------------------------------------------------------------------*/
static void csc_att_prologue (stream, att)
FILE *stream;
cus_sym att;
{  cus_sym parent_obj, parent_vc;

   parent_obj = (cus_sym) cus_get_prop (att, parent_object_prop);
   parent_vc = (cus_sym) cus_get_prop (parent_obj, parent_vc_prop);

   csc_code_type = cus_ATTR;
   csc_gen_attr = cus_sym_representation (att);
   csc_gen_obj = cus_sym_representation (parent_obj);
   csc_gen_vc = cus_sym_representation (parent_vc);

#ifdef READABLE_BINARIES
   fprintf (stream, "\t/* attribute = %s, u_name = %s */\n",
	cus_sym_representation (att), cus_get_prop (att, u_name_prop));

   fprintf (stream, "\t/* object = %s, u_name = %s */\n",
	cus_sym_representation (parent_obj),
	cus_get_prop (parent_obj, u_name_prop));

   fprintf (stream, "\t/* vc = %s, u_name = %s */\n",
	cus_sym_representation (parent_vc),
	cus_get_prop (parent_vc, u_name_prop));
#endif
}


/*--------------------------------------------------------------------------*\
|  Routine: csc_att_write
|
|  Description:
|     generate c code for an attribute
\*--------------------------------------------------------------------------*/
void csc_att_write (att)
cus_sym att;
{  LIST snippet;

   set_status (ok);

   snippet = (LIST) cus_get_prop (att, value_snippet_prop);
   if (snippet) {
      csc_att_prologue (cs2_code_stream, att);
#ifdef READABLE_BINARIES
      csc_att_prologue (cs2_header_stream, att);
#endif
      csc_snip_write (cs2_code_stream, snippet, att, BUILD_A_SNE);
      }
}


/*--------------------------------------------------------------------------*\
|  Routine: csc_var_prologue
|
|  Description:
|     generate c code for the prologue for a var
\*--------------------------------------------------------------------------*/
static void csc_var_prologue (stream, var)
FILE *stream;
cus_sym var;
{  cus_sym parent_vc;

   parent_vc = (cus_sym) cus_get_prop (var, parent_vc_prop);

   csc_code_type = cus_VAR;
   csc_gen_var = cus_sym_representation (var);
   csc_gen_vc = cus_sym_representation (parent_vc);

#ifdef READABLE_BINARIES
   fprintf (stream,
	"\t/* variable = %s, u_name = %s\n\tvc = %s, u_name = %s */\n",
	cus_sym_representation (var), cus_get_prop (var, u_name_prop),
	cus_sym_representation (parent_vc),
        cus_get_prop (parent_vc, u_name_prop));
#endif
}


/*--------------------------------------------------------------------------*\
|  Routine: csc_var_write
|
|  Description:
|     generate c code for a var
\*--------------------------------------------------------------------------*/
void csc_var_write (var)
cus_sym var;
{  LIST snippet;

   set_status (ok);

   snippet = (LIST) cus_get_prop (var, initial_value_snippet_prop);
   if (snippet) {
      csc_var_prologue (cs2_code_stream, var);
#ifdef READABLE_BINARIES
      csc_var_prologue (cs2_header_stream, var);
#endif
      csc_snip_write (cs2_code_stream, snippet, var, BUILD_A_SNE);
      }
}					/* end csc_var_write */


/*--------------------------------------------------------------------------*\
|  Routine: csc_is_sd
|
|  Description:
|     checks to see if the parameter is a shared data element
\*--------------------------------------------------------------------------*/
boolean csc_is_sd (parm)
char * parm;
{  cus_sym ill_entry;

   if (cus_is_sym (parm))
      ill_entry = ca2_get_sd_sym (cus_sym_representation (parm));
   else
/*
???? there is some hair here, change when going to full dot notation
*/
      ill_entry = ca2_get_sd_sym (cus_sym_representation
	(get_list_pos (parm, 2)));

   return (ill_entry != NULL);
}					/* end csc_is_sd */


/*--------------------------------------------------------------------------*\
|  Routine: csc_cc_prologue
|
|  Description:
|     generates c code for the prologue for a creation cond
\*--------------------------------------------------------------------------*/
static void csc_cc_prologue (stream, vc)
FILE *stream;
cus_sym vc;
{
   csc_code_type = cus_CCOND;
   csc_gen_vc = cus_sym_representation (vc);
#ifdef READABLE_BINARIES
   fprintf (stream, "\t/*  pet for %s vc */\n", cus_sym_representation (vc));
#endif
}


/*--------------------------------------------------------------------------*\
|  Routine: csc_cc_write
|
|  Description:
|     generates c code for a creation cond
\* --------------------------------------------------------------------------*/
void csc_cc_write (vc)
cus_sym vc;
{  string p_proc_name, pet_name;
   LIST creation_condition, parm_list;
   int parm_cnt, parm_list_len;
   int sd_id_parm;
   long remember;
   caddr_t parm;
   cus_context_type target_context;
   cus_sym_type parm_type;
   c22_src_struct *src_info;

   set_status (ok);

   if (vc == car_god_vc)                /* don't need a pet for god */
      return;

   if (src_info = (c22_src_struct *) cus_get_prop (vc, cc_lineno_prop)) {
      c22_slang_line_num = src_info -> line;
      current_line_number = c22_slang_line_num;
      c22_pp_filename = src_info -> file_name;
      current_file_name = c22_pp_filename;
      }
     else {
      c22_slang_line_num = -1;
      current_line_number = c22_slang_line_num;
      c22_pp_filename = "";
      current_file_name = c22_pp_filename;
      }

   pet_name =  cus_get_prop (vc, u_name_prop);
   p_proc_name = u22_concat_string (pet_name, "_PET", NULL);
   cus_put_prop (vc, pet_proc_name_prop, p_proc_name);

	/* now find out if we have bound sd and if so saves its position on
	   the parm list and set some stuff in the symbol tab for the vc and
	   bound sd */

   parm_list = (LIST) cus_get_prop (vc, cc_used_vars_prop);
   parm_list_len = list_length (parm_list);
   sd_id_parm = -1;
   for (parm_cnt = 0; parm_cnt < parm_list_len; parm_cnt++) {
      parm = get_list_pos (parm_list, parm_cnt + 1);
      if (csc_is_sd (parm)) {
         sd_id_parm = parm_cnt;
 
 /* save old values attached to creating sd (parm) to be restored at ENDVC */

         cus_put_prop (vc, creating_sd_prop, parm);
         cus_put_prop (vc, old_created_vcs_prop,
             cus_get_prop (parm,created_vcs_prop));
         cus_put_prop (vc, old_parent_vc_prop,
             cus_get_prop (parm,parent_vc_prop));
         cus_put_prop (vc, old_owned_context_prop,
             cus_get_prop (parm, owned_context_prop));

         cus_put_prop (parm, created_vcs_prop, vc);
         cus_put_prop (parm, parent_vc_prop, vc);
         cus_put_prop (parm, owned_context_prop,
	     cus_get_prop (vc, owned_context_prop));
	 }
      }

   csc_cc_prologue (cs2_code_stream, vc);
#ifdef READABLE_BINARIES
   csc_cc_prologue (cs2_header_stream, vc);
#endif

   csc_generic_call_write (vc, p_proc_name);

	/* build routine header, parameters, and automatics */

#ifdef READABLE_BINARIES
   c_header_write (cs2_code_stream, p_proc_name, NEED_PARENT);
#endif

				/* routine body */
   global_prologue_write (cs2_code_stream, current_file_name,
	c22_slang_line_num, BUILD_A_SNE, NEED_PARENT, IN_CC);


				/* now initialize the automatics which contain
				   the various data items participating in the
				   creation condition, they are named PARM_n
				*/
   for (parm_cnt = 0; parm_cnt < parm_list_len; parm_cnt++) {
      parm = get_list_pos (parm_list, parm_cnt + 1);
      if (parm_cnt == sd_id_parm) {
	 csc_put_val (cs2_code_stream, sd_id_parm);
         csc_put_token (cs2_code_stream, T_simple_parm_init);
	 }
      else {
         if (!cus_is_sym (parm))
            FATAL_ERROR (fprintf (stderr,
		"csc_cc_write: new parameter not symbol for vc %s\n",
		cus_sym_representation (vc)));
         csc_put_val (cs2_code_stream, parm_cnt);
         parm_type = (cus_sym_type) cus_get_prop (parm, type_prop);

         switch (parm_type) {
            case vc_sym:
	       target_context = (cus_context_type)
		  cus_get_prop (parm, owned_context_prop);
               break;
            case object_sym:
            case variable_sym:
	       target_context = (cus_context_type)
		  cus_get_prop (cus_get_prop (parm, parent_vc_prop),
			owned_context_prop);
               break;
            default:
		FATAL_ERROR (fprintf (stderr,
       "csc_cc_write: illegal parameter type of %s for %s symbol for vc %s\n",
		cus_type_print_val (parm_type), cus_sym_representation (vc)));
            }

         (void) csc_context_climb_out (cs2_code_stream,
		cus_current_context (), target_context,
		cus_get_prop(vc,parent_vc_prop), 0);

         switch (parm_type) {
            case vc_sym:
	       csc_put_token (cs2_code_stream, C_vc_sym);
               break;
            case object_sym:
	       csc_put_token (cs2_code_stream, C_object_sym);
               break;
            case variable_sym:
	       csc_put_token (cs2_code_stream, C_variable_sym);
               break;
            }
	 csc_gen_string (cs2_code_stream, cus_sym_representation (parm));
         csc_put_token (cs2_code_stream, T_complex_parm_init);
         }
      }

	/* now the check to see if this is the right combination of vc
	   template and bound sd */
/*
??? call dpt_rite rule when not new and have sd
look into (cc of true w/o a creatingsd) and (a cc w/creating sd and no new)
cc_uses_new_prop
*/
   if ((sd_id_parm != iid_null_id) && !(cus_get_prop (vc, cc_uses_new_prop))) {
      csc_put_val (cs2_code_stream, sd_id_parm);
      csc_put_token (cs2_code_stream, T_not_dpt_rite_rule);
      remember = ftell (cs2_code_stream);
      csc_put_target (cs2_code_stream, HERE, 0L);
      csc_put_token (cs2_code_stream, T_if);
      c_global_epilogue_write (cs2_code_stream);
      csc_put_target (cs2_code_stream, remember, ftell (cs2_code_stream));
      }

				/* process the condition */
   if (creation_condition =
	(LIST) cus_get_prop (vc, fixed_creation_condition_prop)) {
      csc_exp_write (cs2_code_stream, creation_condition, vc, TRUE);
      csc_free_tree (creation_condition);
      csc_put_token (cs2_code_stream, R_boolean);
      }
    else
      FATAL_ERROR (fprintf (stderr, "no creation condition for %s\n",
	cus_sym_representation (vc)));

   if (cus_get_prop (vc, cc_uses_new_prop)) {
      if (sd_id_parm != iid_null_id) {
	 csc_put_val (cs2_code_stream, sd_id_parm);
	 csc_put_token (cs2_code_stream, R_validate_object);
	 csc_put_token (cs2_code_stream, T_and);
	 }
       else {
         csc_put_token (cs2_code_stream, T_compile_error);
         COMPILE_ERROR (fprintf (stderr,
  "new parameter is not a shared data element in creation condition for %s\n",
	    cus_sym_representation (vc)));
         }
      }

   csc_gen_string (cs2_code_stream, cus_get_prop (vc, u_name_prop));
   if (sd_id_parm == iid_null_id)
      csc_put_val (cs2_code_stream, 999L);
    else
      csc_put_val (cs2_code_stream, sd_id_parm);

   csc_put_token (cs2_code_stream, T_vc_create);
   c_global_epilogue_write (cs2_code_stream);
   csc_put_token (cs2_code_stream, T_snip_end);
}					/* end csc_cc_write */

