static char rcsid [] =
	"$Header: /u/04c/mnt/integ/source/compiler/src/RCS/csc_exp.c,v 1.34 91/04/01 23:32:34 ejh Exp $";

/*
$Log:	csc_exp.c,v $
 * Revision 1.34  91/04/01  23:32:34  ejh
 * fixed up init. of need_parent and need_more
 * 
 * Revision 1.33  91/01/08  17:09:12  dvk
 * Added use of real constants for interpreter
 * 
 * Revision 1.32  91/01/02  17:48:04  dvk
 * Sweeping changes throughout compiler for new interpreted output
 * 
 * Revision 1.31  90/09/17  19:14:23  dvk
 * Deleted DEBUG statements which used defunct cus_sym_context
 * 
 * Revision 1.30  90/07/24  19:14:19  dvk
 * Added generation of dra_get_sire_vc to reduce code size
 * 
 * Revision 1.29  90/07/16  11:09:55  dvk
 * Fixed so calls to get_atv of a constant of the same type now just prints
 * out the constant
 * 
 * Revision 1.28  90/07/10  18:08:23  dvk
 * Changed csc_context_climb_out to use PARENT.  Also now use new
 * dro_id_assign routine
 * 
 * Revision 1.27  90/04/10  18:26:46  ejh
 * changed strings.h to string.h
 * 
 * Revision 1.26  90/02/22  14:53:25  dvk
 * Fixed some commentary, deleted commented out code.
 * 
 * Revision 1.25  90/02/14  22:14:06  ejh
 * fixed include structure
 * 
 * Revision 1.24  90/02/12  16:55:33  dvk
 * Added calls to dro_string assign.  Changed calls to dro_int_assign and
 * dro_bool_assign to pass in the actual constants (and eliminated a bunch
 * of generated constants in csc_const.c)  Changed calls to dra_ routines
 * where the variable name is constant to use dra_get_OBJECT (from the
 * previous dra_get_object), dra_get_variable_VALUE, dra_put_variable_VALUE,
 * dra_get_component_VALUE, and dra_put_component_VALUE
 * 
 * Revision 1.23  90/01/19  16:27:00  dvk
 * Changed strlen calculations of constant strings to simple constants
 * ID's with value NULL now use a CONSTANT_adi
 * Compressed generated calls to dro_assign in certain special cases to
 * calls to dro_int_assign and dro_bool_assign.
 * 
 * Revision 1.22  90/01/12  14:56:39  dvk
 * Eliminated some extra generated \n's to cut down on dbx information.  Changed
 * output of dob_make_integer_constant_adi to use new dob_int_const[] array.
 * 
 * Revision 1.21  89/12/22  12:59:26  ejh
 * type case to int in switch statements
 * 
 * Revision 1.20  89/10/23  19:54:36  ejh
 * defined memoryPack
 * 
 * Revision 1.19  89/09/22  13:52:19  serpent
 * no change
 * 
 * Revision 1.18  89/09/22  13:47:33  rcs
 * fixed extra paren error with string_constant_adi
 * 
 * Revision 1.17  89/09/20  12:02:46  little
 * fix forward referencing to work for attributes and references to
 * attributes which are not "defined" in the slang program.  spr #0104
 * 
 * Revision 1.16  89/07/24  14:53:49  little
 * ops removal
 * 
 * Revision 1.15  89/04/25  09:18:01  ljb
 * generate code for user defined functions
 * (this hasn't been tested yet, I am checking this in so
 * that Reed can fix another bug
 * 
 * Revision 1.14  89/03/28  12:56:47  serpent
 * changed  #ifdef 0  to  #if 0  to allow sun compile.
 * 
 * Revision 1.13  89/02/27  17:08:39  little
 * add some debug print
 * 
 * Revision 1.12  89/02/09  16:31:35  ejh
 * added copyright notice
 * 
 * Revision 1.11  89/02/03  16:00:17  little
 * change so that simple data item references are actually de-references
 * 
 * Revision 1.10  89/02/01  16:18:23  little
 * allow such attributes as -->  width: command.width, where width
 * is "overloaded"
 * 
 * Revision 1.9  89/01/26  17:33:41  little
 * add capability for lhs of assignment to be a qualified name (ie, use dot
 * notation)
 * 
 * Revision 1.8  89/01/17  16:56:07  little
 * provide for "forward" reference and "single" vc dot notation meaning
 * you can have the following: vc, vc.obj, vc.obj.att, vc.var, obj.att
 * vc.bound_sd_item, vc.bound_sd_item.att, bound_sd_item.att, bound_sd_item
 * as a reference
 * 
 * Revision 1.7  89/01/11  19:01:15  little
 * add and modify debug print
 * 
 * Revision 1.6  89/01/09  16:30:10  little
 * make forward reference to items work
 * .,
 * 
 * Revision 1.5  88/12/15  13:56:08  little
 * fix reference to simple "visible" data items.
 * 
 * Revision 1.4  88/12/14  10:47:16  little
 * start adding dot notation.  the coded added for ture dot notation (using
 * the dot qualifier) does not yet work.  however, accessing any name
 * (vc, object, var, att) which is visible due to scope now works.
 * 
 * Revision 1.3  88/10/31  15:13:34  little
 * change csc_gets_write to print out the representation of the lhs instead
 * of sel when it gets an attribute_sym.  this allows use to "collect"
 * attributes which are set to constant expressions into one
 * routine.
 * 
 * Revision 1.2  88/10/04  17:34:55  little
 * add log comment.
 * add some debug code to csc_exp_write
 * 
*/

/*--------------------------------------------------------------------------*\
|
|   Distribution: Approved for public release; distribution is unlimited.
|
|   Copyright (c) 1989  by  Carnegie  Mellon  University, Pittsburgh, PA.  The
|  Software Engineering  Institute  (SEI) is a federally  funded  research and
|  development center established  and  operated by Carnegie Mellon University
|  (CMU).  Sponsored  by  the  U.S.  Department  of   Defense  under  contract
|  F19628-85-C-0003,  the  SEI  is  supported  by  the  services  and  defense
|  agencies, with the U.S. Air Force as the executive contracting agent.
|
|    Permission to use,  copy,  modify, or  distribute  this  software and its
|  documentation for  any purpose and without fee  is hereby granted, provided
|  that  the above copyright notice appear  in  all copies and that both  that
|  copyright  notice  and   this  permission  notice  appear   in   supporting
|  documentation.   Further,  the  names  Software  Engineering  Institute  or
|  Carnegie  Mellon  University  may  not be used in  advertising or publicity
|  pertaining to distribution of the software without specific, written  prior
|  permission.  CMU makes no claims  or representations  about the suitability
|  of this software for any purpose.  This software is provided "as is" and no
|  warranty,  express  or  implied,  is  made  by  the  SEI  or CMU, as to the
|  accuracy  and  functioning of the program and related program material, nor
|  shall   the  fact of  distribution   constitute  any   such  warranty.   No
|  responsibility is assumed by the SEI or CMU in connection herewith.
|
\*--------------------------------------------------------------------------*/

#define	memoryPack

#include	<stdio.h>
#include	<string.h>
#include	<listPack.h>
#include	<global.h>
#include	<cus.h>
#include	<cud.h>
#include	<idd.h>
#include	<isd.h>
#include	<isc.h>
#include	<c22.h>
#include	<ca2.h>
#include	<csc.h>
#include	<dri.h>

void csc_reference_write ();
static void csc_find_reference ();
static boolean csc_exp_in_cc;

#define GET TRUE
#define PUT FALSE

#define redo_bound_prop(sym,prop,save_list,new_value) \
      add_to_tail_val (save_list, \
		       cus_get_prop (sym, prop), \
                       prop); \
      cus_put_prop (sym, prop, new_value);

/*--------------------------------------------------------------------------*\
|  Routine: csc_look_in_elem
|
|  Description:
|     looks in the element type of the object to see if the candidate is
|	a component
\*--------------------------------------------------------------------------*/
static cus_sym csc_look_in_elem (candidate, obj)
cus_sym candidate;
cus_sym obj;
{  LIST look_list;
   cus_sym found;
   string obj_type, cand_name;
   int the_length, the_offset, the_position;
   idd_data_definition the_dd;

   cand_name = (string) cus_sym_representation (candidate);

   obj_type = cus_sym_representation (cus_get_prop (obj, object_type_prop));
   the_dd = (idd_data_definition) cus_get_prop (
	cus_get_prop (obj, data_definition_prop), idd_handle_prop);
   found = (cus_sym) NULL;
				/* now make sure that the candidate is really
				   a component of the obj
				*/
   if (the_dd) {
      if (idd_validate_component (the_dd, obj_type, cand_name))
         found = candidate;
      }

   return (found);
}					/* end csc_look_in_elem */


/* -------------------------------------------     csc_try_redefined */
static boolean csc_try_redefined (stream, ref, self)
FILE *stream;
cus_sym ref;
cus_sym self;
/*
??? how about selfs which are other than attributes ?
*/
{  cus_sym parent_vc, obj, found;
   LIST objects;
   boolean redefine_it;
   string ref_string;

   redefine_it = FALSE;
   ref_string = cus_sym_representation (ref);
   found = NULL;
   objects = (LIST) NULL;

				/* if we are in an attribute snippet */
   if ((cus_sym_type) cus_get_prop (self, type_prop) == attribute_sym) {
				/* check to see if atribute is a component
				   of the object itself by looking into
				   the object type element
				*/
      if (!redefine_it) {
         obj = (cus_sym) cus_get_prop (self, parent_object_prop);
         redefine_it = (boolean) csc_look_in_elem (ref, obj);
         if (redefine_it)
            cus_put_prop (ref, redefined_prop, obj);

         }
				/* see if there is another object in the
				   parent vc with this name
				*/
      if (!redefine_it && (parent_vc = (cus_sym) cus_get_prop (
	cus_get_prop (self, parent_object_prop), parent_vc_prop)) &&
	(objects = (LIST) cus_get_prop (parent_vc, objects_prop)))
         {
	 objects = copy_list (objects, NOT_NODES);
         obj = (cus_sym) get_list_next (objects, NULL);
         while ((obj != (cus_sym) NULL) && (found == (cus_sym) NULL)) {
            if (!strcmp (cus_sym_representation (obj), ref_string)) {
               found = obj;
               cus_put_prop (ref, redefined_prop, obj);
               redefine_it = TRUE;
               }
             else
               obj = (cus_sym) get_list_next (objects, obj);
            }
         }
      }

   if (!redefine_it) {
      COMPILE_ERROR (fprintf (stderr,
	"csc_try_redefined: %s is probably undefined\n", ref_string));
      csc_put_token (stream, T_compile_error);
      }

   if (objects)
      free_list (objects, NOT_NODES);

   return (redefine_it);
}					/* end csc_try_redefined */

/* -------------------------------------------     csc_names_equal */
static int csc_names_equal (ptr, element)
NODE ptr;
NODE element;
{  boolean r_equal;
   string ele_name;

   ele_name = cus_sym_representation (element);

   r_equal = (!strcmp (ptr, ele_name));

   return (r_equal);
}					/* end csc_names_equal */

/* -------------------------------------------     csc_look_in_vc */
static cus_sym csc_look_in_vc (candidate, vc)
cus_sym candidate;
cus_sym vc;
{  LIST look_list;
   cus_sym found;
   string cand_name;

   cand_name = (string) cus_sym_representation (candidate);

   found = (cus_sym) NULL;

   look_list = (LIST) cus_get_prop (vc, variables_prop);
   if (!found && look_list)
      found = (cus_sym) search_list (look_list, cand_name, csc_names_equal);

   look_list = (LIST) cus_get_prop (vc, objects_prop);
   if (!found && look_list)
      found = (cus_sym) search_list (look_list, cand_name, csc_names_equal);

   look_list = (LIST) cus_get_prop (vc, sub_vcs_prop);
   if (!found && look_list)
      found = (cus_sym) search_list (look_list, cand_name, csc_names_equal);

/* ?? do we need to worry about the "creating sd"? (i {reed} think not) */

   return (found);
}					/* end csc_look_in_vc */

/* -------------------------------------------     csc_dot_comp_write*/
static void csc_dot_comp_write (stream, exp, self, context, elem_num, att_num,
				is_get)
FILE *stream;
LIST exp;
cus_sym self;
cus_context_type context;
int elem_num, att_num;
boolean is_get;
{  cus_sym elem, att;
   int the_length, the_offset, the_position;
   idd_data_definition ill;

   att = (cus_sym) get_list_pos (exp, att_num);
   elem = (cus_sym) get_list_pos (exp, elem_num);

   ill = (idd_data_definition) cus_get_prop (cus_get_prop (elem,
	  data_definition_prop), idd_handle_prop);

   if (!idd_validate_component (ill,
          cus_sym_representation (cus_get_prop (elem, object_type_prop)),
          cus_sym_representation (att)))
      {
      COMPILE_ERROR (fprintf (stderr,
  	    "csc_dot_comp_write: elem = %s does not contain attribute = %s\n",
	    cus_sym_representation (elem), cus_sym_representation (att)));
      csc_put_token (stream, T_compile_error);
      }
   else
      csc_find_reference (stream, att, context, cus_get_prop (elem,
	owned_context_prop), self, cus_sym_representation (elem), is_get);
}

/* -------------------------------------------     csc_try_bound_elem */
static LIST csc_try_bound_elem (cand_sym)
cus_sym cand_sym;
{  cus_sym ill, target_vc;
   cus_context_type context;
   LIST old_values, ret_val;

   ret_val = (LIST) NULL;
   if (target_vc = (cus_sym) cus_get_prop (cand_sym, created_vcs_prop)) {
      ill = ca2_get_sd_sym (cus_sym_representation (cand_sym));
      if (!ill)
        FATAL_ERROR (fprintf (stderr,
	    "csc_try_bound: could not find ill file for %s\n",
	    cus_sym_representation (cand_sym)));
      old_values = make_list ();

      redo_bound_prop (cand_sym, data_definition_prop, old_values, ill);
      redo_bound_prop (cand_sym, object_type_prop, old_values, cand_sym);
      redo_bound_prop (cand_sym, type_prop, old_values, bound_elem_sym);
      redo_bound_prop (cand_sym, parent_vc_prop, old_values, target_vc);

      ret_val = old_values;
      }

   return (ret_val);
}					/* end csc_try_bound_elem */

/* -------------------------------------------     csc_restore_bound_elem */
static void csc_restore_bound_elem (sym, old_values)
cus_sym_type sym;
LIST old_values;
{  caddr_t value;
   cus_property_type prop;

   if (old_values) {
      prop =  (cus_property_type) get_head_val (old_values);
      value = get_from_head (old_values);
      while (value) {
         cus_put_prop (sym, prop, value);
         prop = (cus_property_type) get_head_val (old_values);
         value = get_from_head (old_values);
         }
      }

   free_list (old_values, NOT_NODES);
}

/* -------------------------------------------     csc_object_dot_write */
static void csc_object_dot_write (stream, exp, self, is_get, context)
FILE *stream;
LIST exp;
cus_sym self;
boolean is_get;
cus_context_type context;
{  cus_sym_type old_type;

   if (!get_list_pos (exp, 3))
      FATAL_ERROR (fprintf (stderr,
	   "csc_object_dot_write: could not find the att in obj.att\n"));
   old_type = (cus_sym_type) cus_get_prop (get_list_pos (exp, 3), type_prop);
   cus_put_prop (get_list_pos (exp, 3), type_prop, attribute_sym);
   csc_dot_comp_write (stream, exp, self, context, 2, 3, is_get);
   cus_put_prop (get_list_pos (exp, 3), type_prop, old_type);
}

/* -------------------------------------------     csc_dot_write*/
static void csc_dot_write (stream, exp, self, is_get)
FILE *stream;
LIST exp;
cus_sym self;
boolean is_get;
{  char * elem;
   int counter;
   cus_sym_type first_type, second_type;
   cus_sym look_obj, target_vc, var, parent, obj;
   cus_context_type context;
   LIST obj_list, save_props;
   cus_sym_type old_type;
   boolean found_it;
   string target;

/* this guy will "handle" all data item references and will NOT
   invoke csc_exp_write recursively */

   context = cus_current_context ();

   first_type = (cus_sym_type) cus_get_prop (get_list_pos (exp, 2),type_prop);
   switch (first_type) {
      case vc_sym:
         second_type = (cus_sym_type) cus_get_prop (get_list_pos (exp, 3),
						      type_prop);
         switch (second_type) {
            case object_sym:
               obj = csc_look_in_vc (get_list_pos (exp, 3),
				     get_list_pos (exp, 2));
      					/* if vc does not contain object, we
      					   have a user error */
               if (!obj) {
                  COMPILE_ERROR (fprintf (stderr,
            	  "csc_dot_write: vc = %s does not contain object = %s\n",
            		   cus_sym_representation (get_list_pos (exp, 2)),
            		   cus_sym_representation (get_list_pos (exp, 3))));
                  csc_put_token (stream, T_compile_error);
                  goto DONE;
                  }
               if (get_list_pos (exp, 4)) {
                  old_type = (cus_sym_type) cus_get_prop (get_list_pos (exp,
			4), type_prop);
                  cus_put_prop (get_list_pos (exp, 4), type_prop,
				 attribute_sym);
	          csc_dot_comp_write (stream, exp, self, context, 3, 4,
			is_get);
                  cus_put_prop (get_list_pos (exp, 4), type_prop, old_type);
                  }
                else {
                  parent = (cus_sym) cus_get_prop (obj, parent_vc_prop);
                  if (!parent)
                     FATAL_ERROR (fprintf (stderr,
	     "csc_dot_write: cannot get parent object for att in obj.att\n"));
                  csc_find_reference (stream, obj, context,
		        cus_get_prop (parent, owned_context_prop), self,
			"ERROR FROM csc_dot_write 0", is_get);
                  }
               break;

            case variable_sym:
               var = csc_look_in_vc (get_list_pos (exp, 3), get_list_pos (exp,
		2));
      					/* if vc does not contain vart, we
      					   have a user error */
               if (!var) {
                  COMPILE_ERROR (fprintf (stderr,
      		  "csc_dot_write: vc = %s does not contain variable = %s\n",
      		   cus_sym_representation (get_list_pos (exp, 2)),
      		   cus_sym_representation (get_list_pos (exp, 3))));
                  csc_put_token (stream, T_compile_error);
                  goto DONE;
                  }
               parent = (cus_sym) cus_get_prop (var, parent_vc_prop);
               csc_find_reference (stream, var, context,
		cus_get_prop (parent, owned_context_prop), self,
		"ERROR FROM csc_dot_write 1", is_get);
               break;

            case id_sym:
            case bound_elem_sym:
				/* if this is the creating sd as
				   indicated by having the created_vcs_prop
				   set */
               if (save_props = csc_try_bound_elem (get_list_pos (exp, 3))) {
                  if (get_list_pos (exp, 4)) {
                     old_type = (cus_sym_type) cus_get_prop (get_list_pos
			(exp, 4), type_prop);
                     cus_put_prop (get_list_pos (exp, 4), type_prop,
				    bound_comp_sym);
                     csc_dot_comp_write (stream, exp, self, context, 3, 4,
					 is_get);
                     cus_put_prop (get_list_pos (exp, 4), type_prop,old_type);
                     }
                   else {
                     target_vc = (cus_sym)cus_get_prop (get_list_pos(exp, 3),
							  parent_vc_prop);
                     csc_find_reference (stream, get_list_pos(exp,3), context,
			cus_get_prop (target_vc, owned_context_prop), self, 
			"ERROR FROM csc_dot_write 2", is_get);
                     }
                  csc_restore_bound_elem (get_list_pos (exp, 3), save_props);
                  }
                 else {
                   COMPILE_ERROR (fprintf (stderr,
		      "csc_dot_write: 0 vc = %s does not contain item = %s\n",
		      cus_sym_representation (get_list_pos (exp, 2)),
		      cus_sym_representation (get_list_pos (exp, 3))));
                   csc_put_token (stream, T_compile_error);
                   goto DONE;
                   }
               break;

            default:
                COMPILE_ERROR (fprintf (stderr,
		      "csc_dot_write: 1 vc = %s does not contain item = %s\n",
		      cus_sym_representation (get_list_pos (exp, 2)),
		      cus_sym_representation (get_list_pos (exp, 3))));
                csc_put_token (stream, T_compile_error);
                goto DONE;
            }
         break;

      case object_sym:
         csc_object_dot_write (stream, exp, self, is_get, context);
         break;

      case id_sym:
		    /* this might be a forward reference, see if
		     * the first element is another object in the
		     * parent vc
		     */

				/* first find the parent vc */
         if ((cus_sym_type) cus_get_prop (self, type_prop) == attribute_sym) {
            parent = (cus_sym) cus_get_prop (self, parent_object_prop);
            if (parent)
               parent = (cus_sym) cus_get_prop (parent, parent_vc_prop);
            }
           else
            parent = NULL;
				/* now look through the obj list for the
				   reference
				*/
         found_it = FALSE;
         if ((parent) &&
		(obj_list = (LIST) cus_get_prop (parent, objects_prop))) {
            look_obj = (cus_sym) get_list_next (obj_list, NULL);
            target = cus_sym_representation (get_list_pos (exp, 2));
            while ((look_obj != NULL) && (!found_it)) {
               found_it = !strcmp (target, cus_sym_representation(look_obj));
               if (!found_it)
                  look_obj = (cus_sym) get_list_next (obj_list, look_obj);
               }
            }
				/* found the reference in the parent vc's
				   object list.  replace the symbol in the dot
				   tree with the "real" one and access like
				   an object.att reference
				*/
         if (found_it) {
            delete_list_pos (exp, 2);
            insert_list_pos (exp, look_obj, 2);
            csc_object_dot_write (stream, exp, self, is_get, context);
            break;
            }

					/* %%%%%%%%%%%%%%%%%%%%%%% */
					/* FALL THROUGH IS OK HERE */
					/* %%%%%%%%%%%%%%%%%%%%%%% */

/* ?? do we need to do a refine somehere around here ??*/

      case bound_elem_sym:

				/* if this is the creating sd as
				   indicated by having the created_vcs_prop
				   set */
         if (save_props = csc_try_bound_elem (get_list_pos (exp, 2))) {
            if (get_list_pos (exp, 3)) {
               old_type = (cus_sym_type) cus_get_prop (get_list_pos(exp, 3),
							type_prop);
               cus_put_prop (get_list_pos(exp, 3), type_prop, bound_comp_sym);
               csc_dot_comp_write (stream, exp, self, context, 2, 3, is_get);
               cus_put_prop (get_list_pos(exp, 3), type_prop, old_type);
               }
             else {
               target_vc = (cus_sym)cus_get_prop (get_list_pos (exp, 3),
		 				   parent_vc_prop);
               csc_find_reference (stream, get_list_pos(exp,2), context,
		cus_get_prop (target_vc, owned_context_prop), self,
		"ERROR FROM csc_dot_write 3", is_get);
               }
             csc_restore_bound_elem (get_list_pos (exp, 2), save_props);
             }
          else {
            COMPILE_ERROR (fprintf (stderr,
		"csc_dot_write: 0 %s cannot be accessed\n",
		cus_sym_representation (get_list_pos (exp, 2))));
            csc_put_token (stream, T_compile_error);
            goto DONE;
            }
          break;

      default:
         COMPILE_ERROR (fprintf (stderr,
	        "csc_dot_write: 1 %s cannot be accessed\n",
		 cus_sym_representation (get_list_pos (exp, 2))));
            csc_put_token (stream, T_compile_error);
            goto DONE;
      }

DONE:
   return;
}					/* end csc_dot_write */

/*
??? csc_cc_dot_write only works for pseudo dot notation in creation conditions
only sd gets are supported, it should probably go away when real dot notation
comes in
*/
/* -------------------------------------------     csc_cc_dot_write*/
static void csc_cc_dot_write (stream, exp, self)
FILE *stream;
LIST exp;
cus_sym self;
{  cus_sym element, component, ill_entry;
   idd_data_types data_type;

   element = (cus_sym) get_list_pos (exp, 2);
   if (!cus_is_sym (element)) {
      COMPILE_ERROR (fprintf (stderr, "first parameter to dot not symbol"));
      return;
      }
   component = (cus_sym) get_list_pos (exp, 3);
   if (!cus_is_sym (component)) {
      COMPILE_ERROR (fprintf (stderr, "second parameter to dot not symbol"));
      return;
      }

   csc_put_val (stream, cus_get_prop (element, num_operands_prop));
   csc_gen_string (stream, cus_sym_representation (component));
   csc_put_token (stream, T_component_value_from_parm);
}

/* -------------------------------------------     csc_exp_write*/
void csc_exp_write (stream, exp, self, in_cc)
FILE *stream;
LIST exp;
cus_sym self;
boolean in_cc;
{  int cnt, param_offset;
   cus_sym pseudo_fun_name;

   set_status (ok);
   csc_exp_in_cc = in_cc;

   if (cus_is_sym (exp)) {
      /* expression is a single symbol.  ie. constant or variable*/
      if (cus_get_prop (exp, is_constant_prop))
         csc_constant_write (stream, exp, self);
       else if ((cus_sym) exp == car_undefined_symbol)
         csc_put_token (stream, R_make_undefined_adi);
       else
         csc_reference_write (stream, exp, self);
      }
    else {

      /*expression is compound expression.  ie. function or 
        dot notation (arithmetic operators are functions)*/

      pseudo_fun_name = (cus_sym) get_list_pos (exp, 1);
      if (pseudo_fun_name == car_function_call_symbol) {
         pseudo_fun_name = (cus_sym) get_list_pos (exp, 2);
         param_offset = 2;
         }
       else
         param_offset = 1;

      if (pseudo_fun_name == car_dot_symbol)
         csc_dot_write (stream, exp, self, GET);
       else if (pseudo_fun_name == car_cc_dot_symbol)
          csc_cc_dot_write (stream, exp, self);
       else
         csc_fun_call_write (stream, exp, self, param_offset, FALSE);
      }
}

/* -------------------------------------------     csc_get_parent */
static cus_sym csc_get_parent (child)
cus_sym child;
{  cus_sym the_type, ret_val;

   ret_val = (cus_sym) NULL;
   the_type = (cus_sym) cus_get_prop (child, type_prop);

   switch ((int) the_type) {
      case vc_sym:
      case object_sym:
      case variable_sym:
         ret_val = (cus_sym) cus_get_prop (child, parent_vc_prop);
         break;
      case bound_comp_sym:
      case attribute_sym:
         ret_val = (cus_sym) cus_get_prop (child, parent_object_prop);
         break;
      default:
         FATAL_ERROR (fprintf (stderr,
			"csc_get_parent got a child of unknown type, %s\n",
			cus_type_print_val (the_type)));
         break;
      }

   return (ret_val);
}					/* end csc_get_parent */

/* -------------------------------------------     csc_contexts_equal */
static int csc_contexts_equal (ptr, element)
NODE ptr;
NODE element;
{
   return (ptr == cus_get_prop (element, owned_context_prop));
}

/* -------------------------------------------     csc_context_climb_out */
boolean csc_context_climb_out (stream, context, target_context, self, start_level)
FILE *stream;
cus_sym self;
cus_context_type context;
cus_context_type target_context;
int start_level;
{  cus_sym obj;
   cus_sym_type the_type;
   LIST look_list;
   int i;


/* ?? do we need to worry about sd bound to created vc ?? */
/* if so, look in cus_put_prop (vc, creating_sd_prop, parm); */

   while (context != target_context) {
      the_type = (cus_sym_type) cus_get_prop (self, type_prop);
      if (the_type == vc_sym) {
         look_list = (LIST) cus_get_prop (self, objects_prop);
         if (look_list &&
             (obj = (cus_sym) search_list (look_list, target_context,
					 csc_contexts_equal)))
	    break;
	 else
	    start_level++;
         }
      self = csc_get_parent (self);
      if (!self)
	 return FALSE;
      context = (cus_context_type)cus_get_prop (self, owned_context_prop);
      }
    switch (start_level) {
      case 0:
	csc_put_token (stream, C_SELF);
	csc_put_token (stream, R_make_id_constant_adi);
	break;
      case 1:
	csc_put_token (stream, C_PARENT);
	break;
      case 2:
	csc_put_token (stream, C_PARENT);
	csc_put_token (stream, R_get_parent_vc);
	break;
      default:
	csc_put_token (stream, C_PARENT);
	csc_put_val (stream, start_level-1);
	csc_put_token (stream, R_get_sire_vc);
				/* start_level-1 because we start at PARENT */
	break;
      }
    return TRUE;
}

/* -------------------------------------------     csc_climb_out */
static boolean csc_climb_out (stream, ref, context, target_context, self)
FILE *stream;
cus_sym ref;
cus_context_type context;
cus_context_type target_context;
cus_sym self;
{  cus_sym guy, the_type;
   LIST guys_to_unredefine;
   boolean ret_val;
   int start_level;

   guys_to_unredefine = make_list ();

TRY_AGAIN:

   start_level = 0;
   the_type = (cus_sym) cus_get_prop (self, type_prop);

   switch ((int) the_type) {
				/* need to get to a thingie which has context,
				   atts and vars do not have context. */
      case attribute_sym:
      case variable_sym:
      case bound_comp_sym:
	/*
	 * This indicates that we need to do an initial get_parent inside
	 * of csc_context_climb_out (which may get optimized out anyway).
	 */
	 start_level = 1;
         break;
      case id_sym:
         if (csc_try_redefined (stream, ref, self)) {
            add_to_tail (guys_to_unredefine, ref);
            goto TRY_AGAIN;
            }
         return;
         break;
				/* need do nothing for vc or obj, already 
				   "in" self's context */ 
      case vc_sym:
      case object_sym:
         break;
      default:
         FATAL_ERROR (
	    fprintf (stderr,
	     "csc_climb_out: found unknown type of %d for self named %s\n",
	     the_type, cus_sym_representation (self));
	     );
      }      

   ret_val = csc_context_climb_out (stream, context, target_context, self,
					   start_level);

DONE:

   loop_through_list (guys_to_unredefine, guy, cus_sym)
      cus_put_prop (guy, redefined_prop, NULL);
   free_list (guys_to_unredefine, NOT_NODES);

   return (ret_val);
}					/* end csc_climb_out */

/* -------------------------------------------     csc_find_reference */
static void csc_find_reference (stream, ref, context, target_context, self,
				object_name, is_get)
FILE *stream;
cus_sym ref;
cus_context_type context;
cus_context_type target_context;
cus_sym self;
string object_name;
boolean is_get;
{  cus_sym_type ref_type, self_type;
   cus_sym good_ref;
   boolean need_parent, need_more = TRUE;

   self_type = (cus_sym_type) cus_get_prop (self, type_prop);
   ref_type =  (cus_sym_type) cus_get_prop (ref, type_prop);
   good_ref = (cus_sym) NULL;

				/* look for the reference in the local area */
   if (context == target_context) {
     switch (self_type) {
				/* if we are in a variable snippet, look for
				   the reference in the parent vc */
      case variable_sym:
         good_ref = csc_look_in_vc (ref, cus_get_prop (self, parent_vc_prop));
         break;
				/* if we are in a attribute, first look in the
				   parent object. if nothing there, then look
				   in the parent vc */
      case attribute_sym:
/*
?? what about just making and adi with self & comp name, instead of calling
    get comp value
*/
         good_ref = csc_look_in_elem (ref,
			cus_get_prop (self, parent_object_prop));
         if (good_ref) {
	    csc_put_token (stream, C_SELF);
	    csc_put_token (stream, R_make_id_constant_adi);
            csc_gen_string (stream, cus_sym_representation (good_ref));
	    if (is_get)
		csc_put_token (stream, R_get_component_VALUE);
	    else
		csc_put_token (stream, R_put_component_VALUE);
            need_more = FALSE;
            break;
            }
         good_ref = csc_look_in_vc (ref, cus_get_prop (
		cus_get_prop (self, parent_object_prop), parent_vc_prop));
         break;
				/* if we are in create or destroy action
				   snippet (the type of self is vc), just look
				   in the vc */
      case vc_sym:
         good_ref = csc_look_in_vc (ref, self);
         break;
      default:
         COMPILE_ERROR (fprintf (stderr,
		 "csc_find_reference: got an illegal self type of %s\n",
		cus_type_print_val (self_type)));
         csc_put_token (stream, T_compile_error);
         good_ref = (cus_sym) TRUE;
         need_more = FALSE;
         break;
      }
    }

   if (need_more) {
       need_parent = (self_type != vc_sym) && good_ref;
       /*
	* This is a simple optimization that eliminates a pair of routine
	* calls from the generated code
	*/
       if (need_parent) {
	  csc_put_token (stream, C_PARENT);
	 /*
	  * cannot get a vc "locally", this is a forward reference to a sub vc
	  */
	  if ((cus_sym_type) cus_get_prop (good_ref, type_prop) == vc_sym) {
	     COMPILE_ERROR (fprintf (stderr,
	  "csc_find_reference: illegal forward reference of sub-vc named %s\n",
		 cus_sym_representation (good_ref)));
	     csc_put_token (stream, T_compile_error);
	     }
	  }
       else {
			     /* same check as above */
	   if (good_ref) {
	      if ((cus_sym_type) cus_get_prop (good_ref, type_prop) == vc_sym) {
		 COMPILE_ERROR (fprintf (stderr,
	      "csc_find_reference: illegal forward reference of sub-vc named %s\n",
		     cus_sym_representation (good_ref)));
		 csc_put_token (stream, T_compile_error);
		 }
	       else
				     /* we found ref locally, it is easily
					accessable via SELF */
		 csc_put_token (stream, C_SELF);
		 csc_put_token (stream, R_make_id_constant_adi);
	      }
	    else
				     /* we did not find the reference "locally"
					go look up the context tree */
	      if (!csc_climb_out (stream, ref, context, target_context, self)) {
		 COMPILE_ERROR (fprintf (stderr,
				  "csc_find_reference: cannot reference item %s\n",
				  cus_sym_representation (ref)));
		 csc_put_token (stream, T_compile_error);
		 }
	   if (need_parent)
	      csc_put_token (stream, R_get_parent_vc);
	  }

      switch (ref_type) {
         case object_sym:
	    csc_gen_string (stream, cus_sym_representation (ref));
	    if (is_get)
		csc_put_token (stream, R_get_OBJECT);
	    else {
		COMPILE_ERROR (fprintf (stderr,
		    "csc_find_reference: illegal R_put_OBJECT\n"));
		csc_put_token (stream, T_compile_error);
		}
            break;
         case vc_sym:
            break;
         case variable_sym:
	    csc_gen_string (stream, cus_sym_representation (ref));
	    if (is_get)
		csc_put_token (stream, R_get_variable_VALUE);
	    else
		csc_put_token (stream, R_put_variable_VALUE);
            break;
         case attribute_sym:
	    csc_gen_string (stream, object_name);
	    csc_put_token (stream, R_get_OBJECT);
	    csc_gen_string (stream, cus_sym_representation (ref));
	    if (is_get)
		csc_put_token (stream, R_get_component_VALUE);
	    else
		csc_put_token (stream, R_put_component_VALUE);
            break;
         case bound_elem_sym:
            if (!is_get) {
               COMPILE_ERROR (fprintf (stderr,
 	          "csc_find_reference: illegal store into element named %s\n",
      	           cus_sym_representation (ref)));
               csc_put_token (stream, T_compile_error);
               }
             else
               csc_put_token (stream, R_get_creating_sd);
            break; 
         case bound_comp_sym:
	    csc_put_token (stream, R_get_creating_sd);
	    csc_gen_string (stream, cus_sym_representation (ref));
	    if (is_get)
		csc_put_token (stream, R_get_component_VALUE);
	    else
		csc_put_token (stream, R_put_component_VALUE);
            break;
         default:
            COMPILE_ERROR (fprintf (stderr,
   		 "csc_find_reference: got an illegal ref type of %s\n",
   		cus_type_print_val (ref_type)));
            csc_put_token (stream, T_compile_error);
            break;
         }
      }
}

/* -------------------------------------------     csc_gets_write */
void csc_gets_write (stream, gets_statement, self)
FILE *stream;
LIST gets_statement;
cus_sym self;
{  cus_sym lhs, rhs, lhs_type, parent;
   idd_data_types rhs_type;
   cus_context_type current_context;
   LIST save_props;

   set_status (ok);

   if (list_length (gets_statement) != 3)
      FATAL_ERROR (fprintf (stderr, "bad gets_statement\n");
                   cud_print_tree (gets_statement));

   lhs = (cus_sym) get_list_pos (gets_statement, 2);
   rhs = (cus_sym) get_list_pos (gets_statement, 3);

   lhs_type = (cus_sym) cus_get_prop (lhs, type_prop);

   current_context = cus_current_context ();

   if (!cus_is_sym (lhs)) {
      csc_exp_write (stream, rhs, self, FALSE);
      csc_dot_write (stream, lhs, self, PUT);
      }
   else if (lhs == car_self_symbol) {
      COMPILE_ERROR (fprintf (stderr, "cannot assign to self\n"));
      csc_put_token (stream, T_compile_error);
      }
   else

      switch ((int) lhs_type) {
	 case variable_sym:
	    parent = (cus_sym) cus_get_prop (lhs, parent_vc_prop);

	    if (!csc_climb_out (stream, lhs, current_context,
			   cus_get_prop (parent, owned_context_prop), self)) {
	       COMPILE_ERROR (fprintf (stderr,
				"csc_gets_write: cannot reference item %s\n",
				cus_sym_representation (lhs)));
	       csc_put_token (stream, T_compile_error);
	       }

	    csc_gen_string (stream, cus_sym_representation (lhs));
	    csc_exp_write (stream, rhs, self, FALSE);
	    csc_put_token (stream, R_put_variable_VALUE);
	    break;
	 case attribute_sym:
   /* ??? check to ensure att is "in" the element this obj is defined as,
      ???  probably can use csc_look_in_elem when it is fixed  */
	    /*
	     * If the assignment is a simple attribute assignment (that is, if
	     * it is just "attr : 3;" or something similar), then put out the
	     * smaller assignment statement.
	     */
	    rhs_type = (idd_data_types)cus_get_prop(rhs,current_type_prop);
	    if ((cus_is_sym(rhs) && cus_get_prop(rhs, is_constant_prop)) &&
		((rhs_type == idd_boolean) || (rhs_type == idd_integer) ||
		 (rhs_type == idd_string) || (rhs_type == idd_id))) {

	       csc_gen_string (stream, cus_sym_representation (lhs));
	       switch (rhs_type) {
		 case idd_boolean:
		   csc_put_val (stream, cus_get_prop (rhs, current_value_prop));
		   csc_put_token (stream, R_bool_assign);
		   break;
		 case idd_integer:
		   csc_put_val (stream, cus_get_prop (rhs, current_value_prop));
		   csc_put_token (stream, R_int_assign);
		   break;
		 case idd_id:
		   csc_put_val (stream, cus_get_prop (rhs, current_value_prop));
		   csc_put_token (stream, R_id_assign);
		   break;
		 case idd_string:
		   csc_gen_string (stream,
				cus_get_prop (rhs, current_value_prop));
		   csc_put_token (stream, R_string_assign);
		   break;
		 }
	       }
	    /*
	     * If you can't optimize, then do it the old fashioned way
	     */
	    else {
		csc_gen_string (stream, cus_sym_representation (lhs));
		csc_put_token (stream, R_make_adi);
		csc_exp_write (stream, rhs, self, FALSE);
		csc_put_token (stream, cus_get_prop (car_gets_symbol,
			 c_function_name_prop));
		}
	    break;
	 case id_sym:
	    if (save_props = csc_try_bound_elem (lhs)) {
	       COMPILE_ERROR (fprintf (stderr,
		  "csc_gets_write: illegal store into element named %s\n",
		  cus_sym_representation (lhs)));
		csc_restore_bound_elem (lhs, save_props);
		}
	     else {
	       COMPILE_ERROR (fprintf (stderr,
		  "csc_gets_write: %s is probably an undefined variable\n",
		  cus_sym_representation (lhs)));
	       }
	    csc_put_token (stream, T_compile_error);
	    break;
	 default:
	    FATAL_ERROR (fprintf (stderr,
			    "csc_gets_write: got illegal type of %s for lhs\n",
			    cus_type_print_val (lhs_type)));
	    break;
	 }
}

/* -------------------------------------------     csc_constant_write */
void csc_constant_write (stream, the_const, self)
FILE *stream;
cus_sym the_const;
cus_sym self;
{  idd_data_types type;
   double *real_ptr;
   int id_val;

   type = (idd_data_types) cus_get_prop (the_const, current_type_prop);
   switch (type) {
      case idd_string:
	 csc_gen_string (stream, cus_get_prop (the_const, current_value_prop));
         csc_put_token (stream, R_make_indir_string_constant_adi);
         break;
					/* integer type guys */
      case idd_boolean:
	 if (cus_get_prop (the_const, current_value_prop))
	    csc_put_token (stream, C_dob_bool_TRUE);
	 else
	    csc_put_token (stream, C_dob_bool_FALSE);
         break;
      case idd_integer:
	 csc_put_val (stream, csc_gen_int_const(cus_get_prop (the_const, current_value_prop)));
	 csc_put_token (stream, C_dob_int_const);
         break;
      case idd_id:
	 id_val = (int)cus_get_prop (the_const, current_value_prop);
	 if (id_val == -1)
	     csc_put_token (stream, C_dob_id_NULL);
	 else {
	     csc_put_val (stream, id_val);
	     csc_put_token (stream, R_make_id_constant_adi);
	     }
         break;
      case idd_real:
         real_ptr =  (double *) cus_get_prop (the_const, current_value_prop);
	 csc_put_val (stream, csc_gen_real_const (*real_ptr));
	 csc_put_token (stream, C_dob_real_const);
         break;
      case idd_record:
         FATAL_ERROR (fprintf (stderr, "record constant encountered\n"))
         break;
      case idd_buffer:
         FATAL_ERROR (fprintf (stderr, "buffer constant encountered\n"))
         break;
      default:
         FATAL_ERROR (fprintf (stderr,
		"constant of unknown type = %d encountered\n", type););
         break;
      }
}

/* -------------------------------------------     csc_reference_write */
void csc_reference_write (stream, ref, self)
FILE *stream;
cus_sym ref;
cus_sym self;
{  cus_sym guy, parent;
   cus_sym_type ref_type;
   cus_context_type current_context;
   LIST guys_to_unredefine, save_props;
   string ref_string;

   ref_string = cus_sym_representation (ref);

   guys_to_unredefine = make_list ();
   current_context = cus_current_context ();

TRY_AGAIN:
   ref_type = (cus_sym_type) cus_get_prop (ref, type_prop);
   if ((ref != self) && (ref != car_self_symbol) &&
       (!cus_get_prop (ref, is_ok_id_name_prop)))

				/* "complex" ref reference, need to generate
				   "navigation" function call(s) */
      {

      switch (ref_type) {
         case vc_sym:
            csc_find_reference (stream, ref, current_context,
			  cus_get_prop (ref, owned_context_prop), self,
			  "ERROR FROM csc_reference_write 0", GET);
            break;
         case object_sym:
            parent = (cus_sym) cus_get_prop (ref, parent_vc_prop);
            csc_find_reference (stream, ref, current_context,
			  cus_get_prop (parent, owned_context_prop), self,
			  "ERROR FROM csc_reference_write 1", GET);
            break;
         case variable_sym:
            parent = (cus_sym) cus_get_prop (ref, parent_vc_prop);
            csc_find_reference (stream, ref, current_context,
                cus_get_prop (parent, owned_context_prop), self,
		"ERROR FROM csc_reference_write 2", GET);
            break;

         case attribute_sym:
/* ??? do we need a call to csc_find_reference here ?
     if so be careful with using the last parameter  */
	    csc_gen_string (stream, ref_string);
	    csc_put_token (stream, R_make_adi);
            break;

          case id_sym:
             if (save_props = csc_try_bound_elem (ref)) {
                parent = (cus_sym) cus_get_prop (ref, parent_vc_prop);
                csc_find_reference (stream, ref, current_context,
    			  cus_get_prop (parent, owned_context_prop), self,
    			  "ERROR FROM csc_reference_write 5", GET);
                 csc_restore_bound_elem (ref, save_props);
                 }
              else if (csc_try_redefined (stream, ref, self)) {
                add_to_tail (guys_to_unredefine, ref);
                goto TRY_AGAIN;
                }
             break;

         case bound_elem_sym:
            parent = (cus_sym) cus_get_prop (ref, parent_vc_prop);
            csc_find_reference (stream, ref, current_context,
			  cus_get_prop (parent, owned_context_prop), self,
			  "ERROR FROM csc_reference_write 3", GET);
            break;

#if  0
/* ?? maybe this is never used, and sould be deleted so default takes over */
         case bound_comp_sym:
            parent = (cus_sym) cus_get_prop (ref, parent_vc_prop);
            csc_find_reference (stream, ref, current_context,
			  cus_get_prop (parent, owned_context_prop), self,
			  "ERROR FROM csc_reference_write 4", GET);
            break;
#endif

         default:
            FATAL_ERROR (fprintf (stderr,
	 "csc_reference_write: got unknown type of %s for complex self/ref\n",
   		cus_type_print_val (ref_type)));
            break;
         }
      }
    else {
				/* "simple"  ref reference */
      if (ref == car_self_symbol)
         ref_type = (cus_sym_type) cus_get_prop (self, type_prop);
       else
         ref_type = (cus_sym_type) cus_get_prop (ref, type_prop);
      switch (ref_type) {
         case vc_sym:
	    csc_put_token (stream, C_SELF);
            csc_put_token (stream, R_make_id_constant_adi);
            break;
         case object_sym:
            FATAL_ERROR (fprintf(stderr,
		"csc_reference_write got a ref which is an object\n"));
            break;
         case variable_sym:
	    csc_put_token (stream, C_SELF);
            csc_put_token (stream, R_make_id_constant_adi);
            break;
         case attribute_sym:
            if (ref == car_self_symbol) {
		csc_put_token (stream, C_SELF);
		csc_put_token (stream, R_make_id_constant_adi);
		}
             else {
		csc_gen_string (stream, ref_string);
		csc_put_token (stream, R_make_adi);
		}
            break;
         case id_sym:
            if (!cus_get_prop (ref, is_ok_id_name_prop)) {
               if (csc_try_redefined (stream, ref, self)) {
                  add_to_tail (guys_to_unredefine, ref);
                  goto TRY_AGAIN;
                  }
               }
             else
	       csc_put_val (stream, cus_get_prop (ref, num_operands_prop));
	       csc_put_token (stream, T_adi_from_parm);
            break;
         default:
            FATAL_ERROR (fprintf (stderr,
		  "csc_reference_write got unknown type of %s for self/ref\n",
   		cus_type_print_val (ref_type)));
            break;
         }
      }

   loop_through_list (guys_to_unredefine, guy, cus_sym)
      cus_put_prop (guy, redefined_prop, NULL);
   free_list (guys_to_unredefine, NOT_NODES);
}					/* end csc_reference_write */
