static char rcsid [] = "$Header: /u/04c/mnt/integ/source/compiler/src/RCS/csd.c,v 1.19 91/01/02 17:49:57 dvk Exp $";


/*
$Log:	csd.c,v $
 * Revision 1.19  91/01/02  17:49:57  dvk
 * Sweeping changes throughout compiler for new interpreted output
 * 
 * Revision 1.18  90/11/12  12:23:33  dvk
 * Slight change to .dlge.d to match new runit.c
 * 
 * Revision 1.17  90/10/08  16:33:57  dvk
 * Now generates smaller xxxt.d file (shortened some types)
 * 
 * Revision 1.16  90/04/10  18:27:47  ejh
 * changed strings.h to string.h
 * 
 * Revision 1.15  90/02/14  22:14:29  ejh
 * fixed include structure
 * 
 * Revision 1.14  90/01/19  16:26:01  dvk
 * Changed strlen calculations of constant strings to simple constants
 * 
 * Revision 1.13  89/10/23  20:04:05  ejh
 * defined memoryPack
 * 
 * Revision 1.12  89/07/24  14:54:39  little
 * ops removal
 * 
 * Revision 1.11  89/05/09  11:06:33  little
 * no changes
 * 
 * Revision 1.10  89/02/27  17:09:21  little
 * add some debug print
 * 
 * Revision 1.9  89/02/15  17:38:30  little
 * write the dialogue name onto the "exec" file for the command name
 * for the dm
 * 
 * Revision 1.8  89/02/09  16:32:45  ejh
 * added copyright notice
 * 
 * Revision 1.7  89/01/26  17:34:32  little
 * add some debug statements
 * 
 * Revision 1.6  89/01/18  14:25:49  ejh
 * changed the writing of .dial.init and .exec.dm_rt to reflect the new ill
 * file preamble
 * 
 * Revision 1.5  89/01/09  16:30:57  little
 * add some debug print.  add the mailbox_name_prop to sym tab infor
 * passed to run-time for objects.  
 * 
 * Revision 1.4  88/10/31  15:18:09  little
 * a couple of castes to make the compiler happy
 * 
 * Revision 1.3  88/10/24  17:09:09  little
 * put out a new property for objects (fixed_method_snippet_prop) which
 * at run-time is the snippet number of the method associated with the object.
 * note, this is different from the compile-time use of
 * fixed_method_snippet_prop, which astually holds the snippet tree.
 * 
 * Revision 1.2  88/10/03  08:59:16  little
 * add processing for dm shared data and add some casts to make saber happy
 * 
*/

/*--------------------------------------------------------------------------*\
|
|   Distribution: Approved for public release; distribution is unlimited.
|
|   Copyright (c) 1989  by  Carnegie  Mellon  University, Pittsburgh, PA.  The
|  Software Engineering  Institute  (SEI) is a federally  funded  research and
|  development center established  and  operated by Carnegie Mellon University
|  (CMU).  Sponsored  by  the  U.S.  Department  of   Defense  under  contract
|  F19628-85-C-0003,  the  SEI  is  supported  by  the  services  and  defense
|  agencies, with the U.S. Air Force as the executive contracting agent.
|
|    Permission to use,  copy,  modify, or  distribute  this  software and its
|  documentation for  any purpose and without fee  is hereby granted, provided
|  that  the above copyright notice appear  in  all copies and that both  that
|  copyright  notice  and   this  permission  notice  appear   in   supporting
|  documentation.   Further,  the  names  Software  Engineering  Institute  or
|  Carnegie  Mellon  University  may  not be used in  advertising or publicity
|  pertaining to distribution of the software without specific, written  prior
|  permission.  CMU makes no claims  or representations  about the suitability
|  of this software for any purpose.  This software is provided "as is" and no
|  warranty,  express  or  implied,  is  made  by  the  SEI  or CMU, as to the
|  accuracy  and  functioning of the program and related program material, nor
|  shall   the  fact of  distribution   constitute  any   such  warranty.   No
|  responsibility is assumed by the SEI or CMU in connection herewith.
|
\*--------------------------------------------------------------------------*/

#define	memoryPack

#include	<stdio.h>
#include	<string.h>
#include	<listPack.h>
#include	<global.h>
#include	<cus.h>
#include	<u22.h>
#include	<idd.h>
#include	<ipb.h>
#include	<c22.h>
#include	<cs2.h>
#include	<csd.h>
#include	<din.h>
#include	<dgr.h>

static void csd_string_write ();
static void csd_prop_write ();
static void csd_symbol_write ();
static void csd_integer_write ();

static string great_big_string;

#define smart_loop_through_list(list, item_name, statement)\
   {LIST value; char *item_name;\
   if (value = (LIST) list)\
      loop_through_list (value, item, char *)\
         {statement;}\
   }

#define csd_list_write(stream, statement)\
   fwrite (OPEN_LIST_ESCAPE, 1, ESCAPE_LENGTH, stream);\
   statement;\
   fwrite (CLOSE_LIST_ESCAPE,1, ESCAPE_LENGTH, stream);

/*--------------------------------------------------------------------------*\
|  Routine: csd_dm_rt_write
|
|  Description:
|     writes the run-time file which contains information about which tap
|	processess to fire up and their parameters (also includes the name of
|	dm process)
\*--------------------------------------------------------------------------*/
void csd_dm_rt_write (dialogue_name)
string dialogue_name;
{
    string dialogue_name_UC = u22_convert_string (dialogue_name, UPPERCASE);

    smart_loop_through_list (cus_get_prop (car_god_vc, ill_files_prop), item,
	{
	if (strcmp (cus_get_prop (item, mailbox_name_prop), DM_BOX) == 0) {
	    fprintf (cs2_dm_init_stream, "%s_BOX %s\n",
		dialogue_name_UC,
		cus_get_prop (item, ill_file_name_prop));
	    fprintf (cs2_dm_exec_stream, "%s_EXE %s -\n",
		dialogue_name_UC,
		dialogue_name);
	    c22_got_dm_box = true;
	    }
	else {
	    fprintf (cs2_dm_init_stream, "%s %s\n",
		cus_get_prop (item, mailbox_name_prop),
		cus_get_prop (item, ill_file_name_prop));
	    if (strcmp (cus_get_prop (item, exec_command_prop), "dm") != 0)
		fprintf (cs2_dm_exec_stream, "%s %s\n",
		    cus_get_prop (item, execution_name_prop),
		    cus_get_prop (item, exec_command_prop));
	    }
	}
	)
}

/*--------------------------------------------------------------------------*\
|  Routine: csd_var_write
|
|  Description:
|     writes all info wrt vars onto the dm run-time sym tab init file
\*--------------------------------------------------------------------------*/
void csd_var_write (var)
cus_sym var;
{   LIST value;

    fwrite (BEGIN_SYMBOL_ENTRY_ESCAPE, 1, ESCAPE_LENGTH, cs2_symtab_stream);

    csd_symbol_write (cs2_symtab_stream, cus_get_prop (var, u_name_prop),
	variable_sym);
    csd_prop_write (cs2_symtab_stream, original_name_prop);
    csd_string_write (cs2_symtab_stream, cus_sym_representation (var));
    csd_prop_write (cs2_symtab_stream, instances_prop);
    csd_list_write (cs2_symtab_stream, 1)
    csd_prop_write (cs2_symtab_stream, initial_value_snippet_prop);
    if (value = (LIST) cus_get_prop (var, initial_value_snippet_prop))
	csd_integer_write (cs2_symtab_stream,
	    (int) cus_get_prop (get_list_head (value), c_proc_number_prop));
    else
	csd_integer_write (cs2_symtab_stream, NO_GENERIC_ROUTINE);

    fwrite (END_SYMBOL_ENTRY_ESCAPE, 1, ESCAPE_LENGTH, cs2_symtab_stream);
}

/*--------------------------------------------------------------------------*\
|  Routine: csd_att_write
|
|  Description:
|     writes all info wrt atts onto the dm run-time sym tab init file
\*--------------------------------------------------------------------------*/
void csd_att_write (att)
cus_sym att;
{   LIST value;

    fwrite (BEGIN_SYMBOL_ENTRY_ESCAPE, 1, ESCAPE_LENGTH, cs2_symtab_stream);
    csd_symbol_write (cs2_symtab_stream, cus_get_prop (att, u_name_prop),
	attribute_sym);
    csd_prop_write (cs2_symtab_stream, value_snippet_prop);
    if (value = (LIST) cus_get_prop (att, value_snippet_prop))
	csd_integer_write (cs2_symtab_stream,
	    (int) cus_get_prop (get_list_head (value), c_proc_number_prop));
    else
	csd_integer_write (cs2_symtab_stream, NO_GENERIC_ROUTINE);
    fwrite (END_SYMBOL_ENTRY_ESCAPE, 1, ESCAPE_LENGTH, cs2_symtab_stream);
}

/*--------------------------------------------------------------------------*\
|  Routine: csd_vc_write
|
|  Description:
|     writes all info wrt vcs onto the dm run-time sym tab init file
\*--------------------------------------------------------------------------*/
void csd_vc_write (vc)
cus_sym vc;
{   LIST value;
    string vc_name;
    cus_sym creating_sd;

    vc_name = cus_sym_representation (vc);

    fwrite (BEGIN_SYMBOL_ENTRY_ESCAPE, 1, ESCAPE_LENGTH, cs2_symtab_stream);
    csd_symbol_write (cs2_symtab_stream, cus_get_prop (vc, u_name_prop),
	vc_sym);
    csd_prop_write (cs2_symtab_stream, original_name_prop);
    csd_string_write (cs2_symtab_stream, cus_sym_representation (vc));

    if (creating_sd = (cus_sym) cus_get_prop (vc, creating_sd_prop))
	{
	csd_prop_write (cs2_symtab_stream, creating_sd_prop);
	great_big_string = u22_concat_string (SD_QUALIFIER_STRING,
	    cus_sym_representation (creating_sd), NULL);
	csd_symbol_write (cs2_symtab_stream, great_big_string, sd_sym);
	}
    csd_prop_write (cs2_symtab_stream, variables_prop);
    csd_list_write (cs2_symtab_stream, smart_loop_through_list
	(cus_get_prop (vc, variables_prop), item, csd_symbol_write
	    (cs2_symtab_stream, cus_get_prop (item, u_name_prop),
	    variable_sym)));
    csd_prop_write (cs2_symtab_stream, objects_prop);
    csd_list_write (cs2_symtab_stream, smart_loop_through_list
	(cus_get_prop (vc, objects_prop), item, csd_symbol_write
	    (cs2_symtab_stream, cus_get_prop (item, u_name_prop),
	    object_sym)));
    csd_prop_write (cs2_symtab_stream, sub_vcs_prop);
    csd_list_write (cs2_symtab_stream, smart_loop_through_list
	(cus_get_prop (vc, sub_vcs_prop), item, csd_symbol_write
	    (cs2_symtab_stream, cus_get_prop (item, u_name_prop),
	    object_sym)));
    csd_prop_write (cs2_symtab_stream, instances_prop);
    csd_list_write (cs2_symtab_stream, 1)
    csd_prop_write (cs2_symtab_stream, value_snippet_prop);
    csd_integer_write (cs2_symtab_stream, cus_get_prop (vc,
	c_proc_number_prop));
    csd_prop_write (cs2_symtab_stream, create_actions_snippet_prop);
    if (value = (LIST) cus_get_prop (vc, create_actions_snippet_prop))
	csd_integer_write (cs2_symtab_stream,
	    (int) cus_get_prop (get_list_head (value), c_proc_number_prop));
    else
	csd_integer_write (cs2_symtab_stream, NO_GENERIC_ROUTINE);

    csd_prop_write (cs2_symtab_stream, destroy_actions_snippet_prop);
    if (value = (LIST) cus_get_prop (vc, destroy_actions_snippet_prop))
	csd_integer_write (cs2_symtab_stream,
	    (int) cus_get_prop (get_list_head (value), c_proc_number_prop));
    else
	csd_integer_write (cs2_symtab_stream, NO_GENERIC_ROUTINE);

    fwrite (END_SYMBOL_ENTRY_ESCAPE, 1, ESCAPE_LENGTH, cs2_symtab_stream);
}

/*--------------------------------------------------------------------------*\
|  Routine: csd_obj_write
|
|  Description:
|     writes all info wrt objs onto the dm run-time sym tab init file
\*--------------------------------------------------------------------------*/
void csd_obj_write (obj)
cus_sym obj;
{   cus_sym m_proc_name, dd_def;
    string mailbox, object_type;
    LIST atts, method_prop;

    fwrite (BEGIN_SYMBOL_ENTRY_ESCAPE, 1, ESCAPE_LENGTH, cs2_symtab_stream);

    csd_symbol_write (cs2_symtab_stream, cus_get_prop (obj, u_name_prop),
	object_sym);

    csd_prop_write (cs2_symtab_stream, original_name_prop);
    csd_string_write (cs2_symtab_stream, cus_sym_representation (obj));

    csd_prop_write (cs2_symtab_stream, mailbox_name_prop);
    dd_def = (cus_sym) cus_get_prop (obj, data_definition_prop);
    mailbox = (string) cus_get_prop (dd_def, mailbox_name_prop);
    csd_string_write (cs2_symtab_stream, mailbox);

    csd_prop_write (cs2_symtab_stream, object_type_prop);
    object_type = cus_sym_representation (cus_get_prop (obj,
	object_type_prop));

    csd_string_write (cs2_symtab_stream, object_type);

    csd_prop_write (cs2_symtab_stream, instances_prop);
    csd_list_write (cs2_symtab_stream, 1)

    if (method_prop = (LIST) cus_get_prop (obj, fixed_method_snippet_prop))
	{
	m_proc_name = (cus_sym) get_list_next (method_prop, NULL);
	csd_prop_write (cs2_symtab_stream, fixed_method_snippet_prop);
	csd_integer_write (cs2_symtab_stream, (int) cus_get_prop (m_proc_name,
	    c_proc_number_prop));
	}

    csd_prop_write (cs2_symtab_stream, attributes_prop);
    atts = (LIST) cus_get_prop (obj, attributes_prop);
    csd_list_write (cs2_symtab_stream, smart_loop_through_list (atts, item,
	csd_symbol_write (cs2_symtab_stream, cus_get_prop (item, u_name_prop),
	attribute_sym)));

    fwrite (END_SYMBOL_ENTRY_ESCAPE, 1, ESCAPE_LENGTH, cs2_symtab_stream);
}

/*--------------------------------------------------------------------------*\
|  Routine: csd_integer_write
|
|  Description:
|     writes an integer onto the dm run-time sym tab init file
\*--------------------------------------------------------------------------*/
static void csd_integer_write (stream, the_int)
FILE *stream;
int the_int;
{
   fwrite (INTEGER_ESCAPE, 1, ESCAPE_LENGTH, stream);
   fwrite (&the_int, 1, sizeof (int), stream);
}

/*--------------------------------------------------------------------------*\
|  Routine: csd_symbol_write
|
|  Description:
|     writes a symbol onto the dm run-time sym tab init file
\*--------------------------------------------------------------------------*/
static void csd_symbol_write (stream, name, type)
FILE *stream;
string name;
cus_sym_type type;

{  id_length len;
   symtype_length s_type = (symtype_length)type;

   len = strlen (name);
   fwrite (SYMBOL_ESCAPE, 1, ESCAPE_LENGTH, stream);
   fwrite (&len, 1, sizeof (id_length), stream);
   fwrite (name, 1, len, stream);
   fwrite (&s_type, 1, sizeof (symtype_length), stream);
}

/*--------------------------------------------------------------------------*\
|  Routine: csd_prop_write
|
|  Description:
|     writes a property id onto the dm run-time sym tab init file
\*--------------------------------------------------------------------------*/
static void csd_prop_write (stream, prop)
FILE *stream;
cus_property_type prop;
{
    proptype_length p_prop = (proptype_length)prop;

    fwrite (PROPERTY_ESCAPE, 1, ESCAPE_LENGTH, stream);
    fwrite (&p_prop, sizeof (proptype_length), 1, stream);
}

/*--------------------------------------------------------------------------*\
|  Routine: csd_string_write
|
|  Description:
|     writes a string onto the dm run-time sym tab init file
\*--------------------------------------------------------------------------*/
static void csd_string_write (stream, the_string)
FILE *stream;
string the_string;
{  string_length len;

extern void csc_gen_string();

   len = strlen (the_string);
   fwrite (STRING_ESCAPE, 1, ESCAPE_LENGTH, stream);
   fwrite (&len, 1, sizeof (string_length), stream);
   fwrite (the_string, 1, len, stream);
}

/*--------------------------------------------------------------------------*\
|  Routine: csd_sdd_element_write
|
|  Description:
|     writes all info (sd template) wrt a particular sd element onto the dm
|	run-time sym tab init file
\*--------------------------------------------------------------------------*/
static void csd_sdd_element_write (dummy, element)
char *dummy;
char *element;
{   string element_name;
    LIST value;
    int new;

    element_name = idd_get_name (element);

    fwrite (BEGIN_SYMBOL_ENTRY_ESCAPE, 1, ESCAPE_LENGTH, cs2_symtab_stream);
	/* create a unique symbol for the element and write it out */
    great_big_string = u22_concat_string (SD_QUALIFIER_STRING, element_name,
	NULL);
    csd_symbol_write (cs2_symtab_stream, great_big_string, sd_sym);

    csd_prop_write (cs2_symtab_stream, potential_vcs_prop);
    csd_list_write (cs2_symtab_stream, 1)

    csd_prop_write (cs2_symtab_stream, instances_prop);
    csd_list_write (cs2_symtab_stream, 1)

    fwrite (END_SYMBOL_ENTRY_ESCAPE, 1, ESCAPE_LENGTH, cs2_symtab_stream);
}

/*--------------------------------------------------------------------------*\
|  Routine: csd_ill_files_write
|
|  Description:
|     writes all info (sd templates) wrt all sd descriptions which were used
|	in the slang program onto the dm run-time sym tab init file
\*--------------------------------------------------------------------------*/
void csd_ill_files_write ()
{   LIST ills;
    cus_sym ill_sym;
    idd_data_definition current_data_definition;

    ills = (LIST) cus_get_prop (car_god_vc, ill_files_prop);
    if (list_length (ills) > 0)
	loop_through_list (ills, ill_sym, cus_sym)
	    {
	    current_data_definition =
		(idd_data_definition) cus_get_prop (ill_sym, idd_handle_prop);
	    idd_walk_data_definition (current_data_definition,
		csd_sdd_element_write, NULL);
	    }
}
