/* $Header: /u/04c/mnt/integ/source/de/include/RCS/cmd_defs.h,v 1.9 91/03/20 23:40:58 little Exp $ */
/*--------------------------------------------------------------------------*\
|   
|  Name:  cmd_defs
|
|  Description:  
|     The cmd_defs file contains an enumeration of the different command
|     types and parameters that are shared between the application and
|     the dialogue.
|
|  Component of:
|     Dialoge Editor Dialogue.
|
|  Project:
|     Serpent
|     User Interface Prototyping
|     Software Engineering Institute
|     Carnegie Mellon University
|     Pittsburgh, PA  15213
|
|
|  Change History:
|     $Log:	cmd_defs.h,v $
 * Revision 1.9  91/03/20  23:40:58  little
 * add definition for new_dialogue_cmd
 * 
 * Revision 1.8  90/07/05  15:13:38  little
 * more structure and visualizer parts integration
 * 
 * Revision 1.7  90/06/21  13:26:48  rcs
 * added a bunch of new commands
 * 
 * Revision 1.6  90/06/18  14:35:54  rcs
 * added visualize commands
 * 
 * Revision 1.5  90/05/21  13:40:02  little
 * fix up for multiple includes & start mods for visu/struc editor integration
 * 
 * Revision 1.4  89/12/18  14:57:51  rcs
 * added commands
 * 
 * Revision 1.3  89/12/12  07:48:42  rcs
 * fixed bugs found during integration testing
 * 
 * Revision 1.2  89/12/08  13:12:06  rcs
 * added some commands
 * 
 * Revision 1.1  89/11/29  09:55:48  trm
 * Initial revision
 * 
 * Revision 1.3  89/11/21  18:11:24  rcs
 * added get_variables_cmd
 * 
 * Revision 1.2  89/11/21  18:05:03  rcs
 * modified list of commands
 * 
 * Revision 1.1  89/09/28  11:00:23  rcs
 * Initial revision
 * 
|     September 27, 1989: Module created.
|
\*--------------------------------------------------------------------------*\
|
|   Distribution: Approved for public release; distribution is unlimited.
|
|   Copyright (c) 1989  by  Carnegie  Mellon  University, Pittsburgh, PA.  The
|  Software Engineering  Institute  (SEI) is a federally  funded  research and
|  development center established  and  operated by Carnegie Mellon University
|  (CMU).  Sponsored  by  the  U.S.  Department  of   Defense  under  contract
|  F19628-85-C-0003,  the  SEI  is  supported  by  the  services  and  defense
|  agencies, with the U.S. Air Force as the executive contracting agent.
|
|    Permission to use,  copy,  modify, or  distribute  this  software and its
|  documentation for  any purpose and without fee  is hereby granted, provided
|  that  the above copyright notice appear  in  all copies and that both  that
|  copyright  notice  and   this  permission  notice  appear   in   supporting
|  documentation.   Further,  the  names  Software  Engineering  Institute  or
|  Carnegie  Mellon  University  may  not be used in  advertising or publicity
|  pertaining to distribution of the software without specific, written  prior
|  permission.  CMU makes no claims  or representations  about the suitability
|  of this software for any purpose.  This software is provided "as is" and no
|  warranty,  express  or  implied,  is  made  by  the  SEI  or CMU, as to the
|  accuracy  and  functioning of the program and related program material, nor
|  shall   the  fact of  distribution   constitute  any   such  warranty.   No
|  responsibility is assumed by the SEI or CMU in connection herewith.
|
\*--------------------------------------------------------------------------*/
#define no_command 0
#define load_dialogue_cmd 1
#define save_dialogue_cmd 2
#define unload_dialogue_cmd 3
#define import_cmd 4
#define add_vc_cmd 5
#define copy_vc_cmd 6
#define move_vc_cmd 7
#define delete_vc_cmd 8
#define get_subvcs_cmd 9	
#define get_objects_cmd 10
#define add_object_cmd 11
#define copy_object_cmd 12
#define move_object_cmd 13
#define delete_object_cmd 14
#define get_attribute_cmd 15
#define get_method_cmd 16
#define add_attribute_cmd 17
#define delete_attribute_cmd 18
#define add_object_instance_cmd 19
#define copy_object_instance_cmd 20
#define export_cmd 21
#define delete_object_instance_cmd 22
#define add_attribute_instance_cmd 23
#define delete_attribute_instance_cmd 24
#define add_variable_cmd 25
#define delete_variable_cmd 26
#define set_technology_cmd 27
#define get_dialogue_technologies_cmd 28
#define exit_cmd 29
#define get_technologies_cmd 30
#define get_object_types_cmd 31
#define get_attributes_cmd 32
#define get_methods_cmd 33
#define get_variables_cmd 34
#define copy_variable_cmd 35
#define move_variable_cmd 36
#define instantiate_cmd 37
#define uninstantiate_cmd 38
#define remove_cmd 39
#define remove_subvcs_cmd 40
#define remove_objects_cmd 41
#define remove_attributes_cmd 42
#define remove_methods_cmd 43
#define remove_variables_cmd 44
#define other_cmd 45
#define new_dialogue_cmd 46

