/*
$Header: /u/04c/mnt/integ/source/de/include/RCS/ea2.h,v 1.9 90/09/17 22:21:15 little Exp $
*/

/*--------------------------------------------------------------------------*\
|   
|  Name:  Dialoge Editor AbstractionS global header file
|
|  Description:  
|     provides a place to put the shit all the editor abstractions use
|
|
|  Project:
|     SERPENT System
|     User Interface Prototyping
|     Software Engineering Institute
|     Carnegie Mellon University
|     Pittsburgh, PA  15213
|

$Log:	ea2.h,v $
 * Revision 1.9  90/09/17  22:21:15  little
 * add check for buffer.length != 1 to printable_buffer
 * 
 * Revision 1.8  90/05/22  17:19:15  little
 * put :protection" around define of memoryPack
 * 
 * Revision 1.7  90/05/21  13:41:05  little
 * fix up for multiple includes & start mods for visu/struc editor integration
 * 
 * Revision 1.6  89/12/15  19:30:51  bmc
 * add ea2_free_node
 * 
 * Revision 1.5  89/12/12  17:12:27  bmc
 * Fixed name of ea2_check_vc().
 * 
 * Revision 1.4  89/12/12  16:55:33  bmc
 * Added ea2_check_vc() macro.
 * 
 * Revision 1.3  89/12/12  07:49:51  rcs
 * fixed bugs found during integration testing
 * 
 * 
 * Revision 1.2  89/12/07  15:14:56  little
 * add definitions for check_parm_type and ea2_in_list
 * 
 * Revision 1.1  89/11/29  09:59:29  bmc
 * Initial revision
 * 

|
|-----------------------------------------------------------------------------
|
|   Distribution: Approved for public release; distribution is unlimited.
|
|   Copyright (c) 1989  by  Carnegie  Mellon  University, Pittsburgh, PA.  The
|  Software Engineering  Institute  (SEI) is a federally  funded  research and
|  development center established  and  operated by Carnegie Mellon University
|  (CMU).  Sponsored  by  the  U.S.  Department  of   Defense  under  contract
|  F19628-85-C-0003,  the  SEI  is  supported  by  the  services  and  defense
|  agencies, with the U.S. Air Force as the executive contracting agent.
|
|    Permission to use,  copy,  modify, or  distribute  this  software and its
|  documentation for  any purpose and without fee  is hereby granted, provided
|  that  the above copyright notice appear  in  all copies and that both  that
|  copyright  notice  and   this  permission  notice  appear   in   supporting
|  documentation.   Further,  the  names  Software  Engineering  Institute  or
|  Carnegie  Mellon  University  may  not be used in  advertising or publicity
|  pertaining to distribution of the software without specific, written  prior
|  permission.  CMU makes no claims  or representations  about the suitability
|  of this software for any purpose.  This software is provided "as is" and no
|  warranty,  express  or  implied,  is  made  by  the  SEI  or CMU, as to the
|  accuracy  and  functioning of the program and related program material, nor
|  shall   the  fact of  distribution   constitute  any   such  warranty.   No
|  responsibility is assumed by the SEI or CMU in connection herewith.
|
\*--------------------------------------------------------------------------*/



#ifndef ea2
#define ea2

#include "edg.h"
#include "idd.h"
#include "ubo.h"
#ifndef memoryPack
#define memoryPack              /* use memoryPack rather than mallocPack    */
#endif  memoryPack
#include "memoryPack.h"
#include <stdio.h>
#include <sys/types.h>



/*--------------------------------------------------------------------------*\
|  Macro: ea2_check_vc
|
|  Description:
|    checks a vc to see if it's really the main dialogue, setting it to Eve
|    if it is.
|
\* Definition:                                                              */

#define ea2_check_vc(the_vc) \
    if (edg_is_dialogue (the_vc)) \
	the_vc = edg_get_vc (the_vc)


/*--------------------------------------------------------------------------*\
|  Macro: ea2_free_node
|
|  Description:
|    frees a node if it's non-NULL.
|
\* Definition:                                                              */

#define ea2_free_node(thing) \
    if (thing != NULL) \
	free_node (thing)

/*--------------------------------------------------------------------------*\
|  Macro: ea2_printable_buffer
|
|  Description:
|    determines if a buffer contains anything
|
\* Definition:                                                              */

#define ea2_printable_buffer(a_buffer) \
   (!ubo_is_empty ((a_buffer)) && !ubo_is_undefined ((a_buffer)) && \
    (a_buffer.length != 1))


/*--------------------------------------------------------------------------*\
|  Macro: check_parm_type
|
|  Description:
|    checks a command parameter from the dialogue for the correct type
|
\* Definition:                                                              */
#define check_parm_type(the_parm, req_type, err_msg) \
   if ((idd_data_types) ((the_parm-> value).type) != req_type) \
      {DEBUG1 (fprintf (stderr, err_msg)); \
      set_status (bad_parameter); \
      return; \
      }


/*--------------------------------------------------------------------------*\
|  Type: ea2_element_type
|
|  Description:
|    Enumeration of valid dialogue element types.
|
\* Definition:                                                              */

	typedef enum element_types {
	  no_element_type,
	  dialogue_element,
	  vc_element,
	  object_element,
	  attribute_element,
	  method_element
	} ea2_element_type;

/*--------------------------------------------------------------------------*\
|  Type: ea2_node_selection
|
|  Description:
|    Defines an enumeration of selection types used to modify various
|    routines througout the application.
|
\* Definition:                                                              */

typedef enum
    {
    ea2_subtree,
    ea2_node
    }
ea2_node_selection;

#define EA2_SUBTREE	ea2_subtree
#define EA2_NODE        ea2_node

/*
\*--------------------------------------------------------------------------*/

/*--------------------------------------------------------------------------*\
|  Routine:  ea2_in_list
|
|  Description:
|     checks a list of things (depending on what is handed in through the
|       the_list and name_fetch_function  parameters for a thing named
|       the_name
\*--------------------------------------------------------------------------*/
    caddr_t ea2_in_list
	(
    /*	the_name	: in string	*/
    /*	the_list	: in LIST	*/
    /*	name_fetch_func	: in string (*name_fetch_function) () */
	);


#endif

