/* $Header: /u/04c/mnt/integ/source/de/include/RCS/eac_cmd.h,v 1.6 90/05/21 13:42:15 little Exp $ */

/*--------------------------------------------------------------------------*\
|   
|  Name:  Dialogue Editor Attribute Command Definitions (eac)
|
|  Description:  
|     contains the definition
|     of the attribute commands supported by the DEA.  This component accesses
|     retained data stored in the dialogue editor command interpreter
|     component.
|
|  Component of:
|     Dialoge Editor Layer.
|
|  Project:
|     SERPENT System
|     User Interface Prototyping
|     Software Engineering Institute
|     Carnegie Mellon University
|     Pittsburgh, PA  15213
|
|  Change History:
$Log:	eac_cmd.h,v $
 * Revision 1.6  90/05/21  13:42:15  little
 * fix up for multiple includes & start mods for visu/struc editor integration
 * 
 * Revision 1.5  89/12/20  14:49:40  rcs
 * integration testing
 * 
 * Revision 1.4  89/12/12  17:02:30  little
 * change the local debug value to 1
 * 
 * Revision 1.3  89/12/12  16:53:14  little
 * no changes.
 * 
 * Revision 1.2  89/12/12  15:19:12  little
 * add definition for eac_delete_attribute
 * 
 * Revision 1.1  89/12/07  15:13:24  little
 * Initial revision
 * 
|     6 dec 1989 : Module created.
|
\*--------------------------------------------------------------------------*\
|
|   Distribution: Approved for public release; distribution is unlimited.
|
|   Copyright (c) 1989  by  Carnegie  Mellon  University, Pittsburgh, PA.  The
|  Software Engineering  Institute  (SEI) is a federally  funded  research and
|  development center established  and  operated by Carnegie Mellon University
|  (CMU).  Sponsored  by  the  U.S.  Department  of   Defense  under  contract
|  F19628-85-C-0003,  the  SEI  is  supported  by  the  services  and  defense
|  agencies, with the U.S. Air Force as the executive contracting agent.
|
|    Permission to use,  copy,  modify, or  distribute  this  software and its
|  documentation for  any purpose and without fee  is hereby granted, provided
|  that  the above copyright notice appear  in  all copies and that both  that
|  copyright  notice  and   this  permission  notice  appear   in   supporting
|  documentation.   Further,  the  names  Software  Engineering  Institute  or
|  Carnegie  Mellon  University  may  not be used in  advertising or publicity
|  pertaining to distribution of the software without specific, written  prior
|  permission.  CMU makes no claims  or representations  about the suitability
|  of this software for any purpose.  This software is provided "as is" and no
|  warranty,  express  or  implied,  is  made  by  the  SEI  or CMU, as to the
|  accuracy  and  functioning of the program and related program material, nor
|  shall   the  fact of  distribution   constitute  any   such  warranty.   No
|  responsibility is assumed by the SEI or CMU in connection herewith.
|
\*--------------------------------------------------------------------------*/

#ifndef eac
#define eac
/*--------------------------------------------------------------------------*\
|  Global Variable: eac_debug
|
|  Description:
|     Debug variable for the abstraction.
|
\* Definition:                                                              */

#ifdef eac_main
  int eac_debug = 1;
#else
  extern int eac_debug;
#endif

/*
\*--------------------------------------------------------------------------*/


/*--------------------------------------------------------------------------*\
|  Routine:  eac_get_attribute
|
|  Description:
|     gets the specified (by a command parameter from the dialogue) attribute
|     from the abstraction and places it into a transaction
|
\* Syntax:                                                                  */

	void eac_get_attribute(
	  /* command : in command_sdd *	 		*/
	  /* transaction : in out transaction_type 	*/
	);


/*
|  Parameters:
|     command - the command parameter.
|     transaction - The transaction to send out changes on.
|
|  Returns:
|     Void.
|
|  Statuses:
|     ok, out_of_memory.
|
\*--------------------------------------------------------------------------*/

/*--------------------------------------------------------------------------*\
|  Routine:  eac_delete_attribute
|
|  Description:
|     deletes the specified (by a command parameter from the dialogue) att and
|       places a remove sd request into the transaction (not currently used).
|
\* Syntax:                                                                  */

	void eac_delete_attribute(
          /* command : in command_sdd *                 */
          /* transaction : in out transaction_type      */
	);

/*
|  Parameters:
|     command - the command parameter.
|     transaction - The transaction to send out changes on.
|
|  Returns:
|     Void.
|
|  Statuses:
|     ok, out_of_memory.
|
\*--------------------------------------------------------------------------*/
#endif

