/*
$Header: /u/04c/mnt/integ/source/de/include/RCS/eat_priv.h,v 1.2 90/05/21 13:48:37 little Exp $
*/

/*--------------------------------------------------------------------------*\
|   
|  Name:  Dialogue Editor Attribute Abstraction (eat) Private Declarations
|
|  Description:  
|     This header file defines routines that must be exported from the
|     EAT abstraction for use by other low-level abstractions.  These routines
|     should ONLY be called by other abstractions (such as EOB, for example).
|
|  Component of:
|     Dialogue Editor Layer.
|
|  Project:
|     SERPENT System
|     User Interface Prototyping
|     Software Engineering Institute
|     Carnegie Mellon University
|     Pittsburgh, PA  15213
|
|  Version: 1.0
|
|  Project Leader:  
|     Len Bass
|     ljb@sei.cmu.edu
|

$Log:	eat_priv.h,v $
 * Revision 1.2  90/05/21  13:48:37  little
 * fix up for multiple includes & start mods for visu/struc editor integration
 * 
 * Revision 1.1  89/11/29  10:01:55  bmc
 * Initial revision
 * 

|
|-----------------------------------------------------------------------------
|
|   Distribution: Approved for public release; distribution is unlimited.
|
|   Copyright (c) 1989  by  Carnegie  Mellon  University, Pittsburgh, PA.  The
|  Software Engineering  Institute  (SEI) is a federally  funded  research and
|  development center established  and  operated by Carnegie Mellon University
|  (CMU).  Sponsored  by  the  U.S.  Department  of   Defense  under  contract
|  F19628-85-C-0003,  the  SEI  is  supported  by  the  services  and  defense
|  agencies, with the U.S. Air Force as the executive contracting agent.
|
|    Permission to use,  copy,  modify, or  distribute  this  software and its
|  documentation for  any purpose and without fee  is hereby granted, provided
|  that  the above copyright notice appear  in  all copies and that both  that
|  copyright  notice  and   this  permission  notice  appear   in   supporting
|  documentation.   Further,  the  names  Software  Engineering  Institute  or
|  Carnegie  Mellon  University  may  not be used in  advertising or publicity
|  pertaining to distribution of the software without specific, written  prior
|  permission.  CMU makes no claims  or representations  about the suitability
|  of this software for any purpose.  This software is provided "as is" and no
|  warranty,  express  or  implied,  is  made  by  the  SEI  or CMU, as to the
|  accuracy  and  functioning of the program and related program material, nor
|  shall   the  fact of  distribution   constitute  any   such  warranty.   No
|  responsibility is assumed by the SEI or CMU in connection herewith.
|
\*--------------------------------------------------------------------------*/

#ifndef eat_private
#define eat_private

#include "eob.h"

/*--------------------------------------------------------------------------*\
|  Routine: eat_set_parent
| 
|  Description:  
|     squirrels away parent for a attribute
|
\* Syntax:                                                                  */

	void eat_set_parent (
	  /* the_attribute : in out eat_attribute */
	  /* the_parent: in eob_object */
	);

/*
|  Parameters:
|     the_attribute - attribute in question
|     the_parent - parent to be saved
|
\*--------------------------------------------------------------------------*/

#endif eat_private
