/* $Header: /u/04c/mnt/integ/source/de/include/RCS/ect.h,v 1.2 90/05/21 13:49:46 little Exp $ */
/*--------------------------------------------------------------------------*\
|   
|  Name:  Dialogue Editor Command Definitions (ect)
|
|  Description:  
|     The dialogue editor command definitions contains the definition
|     of the commands supported by the DEA.  This component accesses
|     retained data stored in the dialogue editor command interpreter
|     component.
|
|  Component of:
|     Dialoge Editor Layer.
|
|  Project:
|     SERPENT System
|     User Interface Prototyping
|     Software Engineering Institute
|     Carnegie Mellon University
|     Pittsburgh, PA  15213
|
|
|  Change History:
|     $Log:	ect.h,v $
 * Revision 1.2  90/05/21  13:49:46  little
 * fix up for multiple includes & start mods for visu/struc editor integration
 * 
|
 * Revision 1.1  89/11/28  18:21:54  rcs
 * Initial revision
 * 
|
\*--------------------------------------------------------------------------*\
|
|   Distribution: Approved for public release; distribution is unlimited.
|
|   Copyright (c) 1989  by  Carnegie  Mellon  University, Pittsburgh, PA.  The
|  Software Engineering  Institute  (SEI) is a federally  funded  research and
|  development center established  and  operated by Carnegie Mellon University
|  (CMU).  Sponsored  by  the  U.S.  Department  of   Defense  under  contract
|  F19628-85-C-0003,  the  SEI  is  supported  by  the  services  and  defense
|  agencies, with the U.S. Air Force as the executive contracting agent.
|
|    Permission to use,  copy,  modify, or  distribute  this  software and its
|  documentation for  any purpose and without fee  is hereby granted, provided
|  that  the above copyright notice appear  in  all copies and that both  that
|  copyright  notice  and   this  permission  notice  appear   in   supporting
|  documentation.   Further,  the  names  Software  Engineering  Institute  or
|  Carnegie  Mellon  University  may  not be used in  advertising or publicity
|  pertaining to distribution of the software without specific, written  prior
|  permission.  CMU makes no claims  or representations  about the suitability
|  of this software for any purpose.  This software is provided "as is" and no
|  warranty,  express  or  implied,  is  made  by  the  SEI  or CMU, as to the
|  accuracy  and  functioning of the program and related program material, nor
|  shall   the  fact of  distribution   constitute  any   such  warranty.   No
|  responsibility is assumed by the SEI or CMU in connection herewith.
|
\*--------------------------------------------------------------------------*/

#ifndef ect
#define ect


/*--------------------------------------------------------------------------*\
|  Global Variable: ect_debug
|
|  Description:
|     Debug variable for the abstraction.
|
\* Definition:                                                              */

#ifdef ect_main
  int ect_debug = 1;
#else
  extern int ect_debug;
#endif

/*
\*--------------------------------------------------------------------------*/

/*--------------------------------------------------------------------------*\
|  Routine: ect_get_technologies
| 
|  Description:
|     Command to get a list of available technologies.  The application
|     does not maintain a mapping for these technologies since the data
|     is never changed.
|
\* Syntax:                                                                  */

	void ect_get_technologies(
	  /* tansaction	: in transaction_type	*/
	);

/*
|  Parameters:
|     vc - VC for which to create shared data record.
|
|  Returns:
|      A handle to the newly created vc shared data record.
|
|  Statuses:
|     ok, out_of_memory.
|
\*--------------------------------------------------------------------------*/

/*--------------------------------------------------------------------------*\
|  Routine: ect_get_object_types
| 
|  Description:
|     Creates a vc shared data record for a specified vc.
|
\* Syntax:                                                                  */

	void ect_get_object_types(
          /* command	: in command_sdd * 	*/
	  /* tansaction	: in transaction_type	*/
	);

/*
|  Parameters:
|     vc - VC for which to create shared data record.
|
|  Returns:
|      A handle to the newly created vc shared data record.
|
|  Statuses:
|     ok, out_of_memory.
|
\*--------------------------------------------------------------------------*/

/*--------------------------------------------------------------------------*\
|  Routine: ect_get_attributes
| 
|  Description:
|     Creates a vc shared data record for a specified vc.
|
\* Syntax:                                                                  */

	void ect_get_attributes(
          /* command	: in command_sdd * 	*/
	  /* tansaction	: in transaction_type	*/
	);

/*
|  Parameters:
|     vc - VC for which to create shared data record.
|
|  Returns:
|      A handle to the newly created vc shared data record.
|
|  Statuses:
|     ok, out_of_memory.
|
\*--------------------------------------------------------------------------*/

/*--------------------------------------------------------------------------*\
|  Routine: ect_get_methods
| 
|  Description:
|     Creates a vc shared data record for a specified vc.
|
\* Syntax:                                                                  */

	void ect_get_methods(
          /* command	: in command_sdd * 	*/
	  /* tansaction	: in transaction_type	*/
	);

/*
|  Parameters:
|     vc - VC for which to create shared data record.
|
|  Returns:
|      A handle to the newly created vc shared data record.
|
|  Statuses:
|     ok, out_of_memory.
|
\*--------------------------------------------------------------------------*/
#endif
