/*
$Header: /u/04c/mnt/integ/source/de/include/RCS/edy.h,v 1.3 90/05/21 13:51:00 little Exp $
*/

		!!!!! THIS FILE IS NOT USED AT THIS TIME !!!!!
		!!!!! THIS FILE IS NOT USED AT THIS TIME !!!!!
		!!!!! THIS FILE IS NOT USED AT THIS TIME !!!!!
		!!!!! THIS FILE IS NOT USED AT THIS TIME !!!!!
		!!!!! THIS FILE IS NOT USED AT THIS TIME !!!!!
		!!!!! THIS FILE IS NOT USED AT THIS TIME !!!!!


/*--------------------------------------------------------------------------*\
|
|  Name:  Dialogue Editor Display Abstraction (edy)
|
|  Description:  
|     The dialogue editor display abstraction provides an abstract display
|     mechanism used during visualization.  Object instances are implicitly
|     associated with a display, which may or may not be active.
|
|  Component of:
|     Dialogue Editor Layer.
|

$Log:	edy.h,v $
 * Revision 1.3  90/05/21  13:51:00  little
 * fix up for multiple includes & start mods for visu/struc editor integration
 * 
 * Revision 1.2  90/01/08  19:01:46  bmc
 * fixed typo
 * 
 * Revision 1.1  90/01/08  17:07:55  bmc
 * Initial revision
 * 

|
|-----------------------------------------------------------------------------
|
|   Distribution: Approved for public release; distribution is unlimited.
|
|   Copyright (c) 1989  by  Carnegie  Mellon  University, Pittsburgh, PA.  The
|  Software Engineering  Institute  (SEI) is a federally  funded  research and
|  development center established  and  operated by Carnegie Mellon University
|  (CMU).  Sponsored  by  the  U.S.  Department  of   Defense  under  contract
|  F19628-85-C-0003,  the  SEI  is  supported  by  the  services  and  defense
|  agencies, with the U.S. Air Force as the executive contracting agent.
|
|    Permission to use,  copy,  modify, or  distribute  this  software and its
|  documentation for  any purpose and without fee  is hereby granted, provided
|  that  the above copyright notice appear  in  all copies and that both  that
|  copyright  notice  and   this  permission  notice  appear   in   supporting
|  documentation.   Further,  the  names  Software  Engineering  Institute  or
|  Carnegie  Mellon  University  may  not be used in  advertising or publicity
|  pertaining to distribution of the software without specific, written  prior
|  permission.  CMU makes no claims  or representations  about the suitability
|  of this software for any purpose.  This software is provided "as is" and no
|  warranty,  express  or  implied,  is  made  by  the  SEI  or CMU, as to the
|  accuracy  and  functioning of the program and related program material, nor
|  shall   the  fact of  distribution   constitute  any   such  warranty.   No
|  responsibility is assumed by the SEI or CMU in connection herewith.
|
\*--------------------------------------------------------------------------*/

#ifndef edy
#define edy

/*--------------------------------------------------------------------------*\
|  General Purpose Includes: General-purpose definitions 
|
\* Definition:                                                              */

#ifndef memoryPack
#define memoryPack              /* use memoryPack rather than mallocPack    */
#endif  memoryPack

#include <listPack.h>           /* C Toolbox - listPack                     */
#include "global.h"

/*--------------------------------------------------------------------------*\
|  Global Variable: edy_debug
|
|  Description:
|     Debug variable for the abstraction.
|
\* Definition:                                                              */

#ifdef edy_main
  int edy_debug = 1;
#else
  extern int edy_debug;
#endif

/*
\*--------------------------------------------------------------------------*/

/*--------------------------------------------------------------------------*\
|  Abstract Type: edy_display
|
|  Description:
|    The edy_display abstract type provides a handle to a visualization display.
|
\* Definition:                                                              */

	typedef private edy_display;

#define edy_no_display		((edy_display) NULL)
#define EDY_NO_DISPLAY		edy_no_display

#define edy_no_more_displays	((edy_display) 1)
#define EDY_NO_MORE_DISPLAYS	edy_no_more_displays


/*--------------------------------------------------------------------------*\
|  Other Abstraction Includes: Definitions for other editor abstraction
|     packages.
|
|  WARNING: These include directives must appear after the type definition
|  for edy_no_display!
\*                                                                          */

#include "edg.h"			/* dialogue abstraction		    */
#include "eoi.h"			/* object instance abstraction	    */

/*--------------------------------------------------------------------------*\
|  Routine: edy_create_display
| 
|  Description:
|     Creates a new display.
|
\* Syntax:                                                                  */

	edy_display edy_create_display ();

/*
|  Parameters:
|     None.
|
|  Returns:
|      The newly created display, or EDY_NO_DISPLAY if the creation failed.
|
|  Statuses:
|     ok, out_of_memory.
|
\*--------------------------------------------------------------------------*/


/*--------------------------------------------------------------------------*\
|  Routine: edy_destroy_display
| 
|  Description:  
|     Destroys a specific display and any object instances associated with
|     the display.
|
\* Syntax:                                                                  */

	void edy_destroy_display
	    (
	/*  display	: in edy_display	*/
	    );

/*
|  Parameters:
|     display - The display to destroy.
|
|  Returns:
|     Nothing
\*--------------------------------------------------------------------------*/


/*--------------------------------------------------------------------------*\
|  Routine: edy_add_object_instance
| 
|  Description:  
|     Adds an object instance to a display.
|
\* Syntax:                                                                  */

	void edy_add_object_instance
	    (
	/*  display	: in edy_display	*/
	/*  instance	: in eoi_obj_instance	*/
	    );

/*
|  Parameters:
|     display  - The display to which to add the object instance.
|     instance - The object instance to add.
|
|  Returns:
|     Nothing
\*--------------------------------------------------------------------------*/


/*--------------------------------------------------------------------------*\
|  Routine: edy_delete_object_instance
| 
|  Description:  
|     Deletes an object instance from a display.
|
\* Syntax:                                                                  */

	eoi_obj_instance edy_delete_object_instance
	    (
	/*  display	: in edy_display	*/
	/*  instance	: in eoi_obj_instance	*/
	    );

/*
|  Parameters:
|     display  - The display from which to delete the object instance.
|     instance - The object instance to delete.
|
|  Returns:
|     The object instance descriptor for the object that was deleted (i.e.,
|     a duplicate of the 'instance' parameter), or EOI_NO_OBJ_INSTANCE if
|     the object wasn't part of the specified display.
|
\*--------------------------------------------------------------------------*/


/*--------------------------------------------------------------------------*\
|  Routine: edy_get_object_list
| 
|  Description:  
|     Returns a list containing the object instances associated with the
|     specified display.
|
\* Syntax:                                                                  */

	LIST edy_get_object_list
	    (
	/*  display	: in edy_display	*/
	    );

/*
|  Parameters:
|     display  - The display to query.
|
|  Returns:
|     A list of the object instances.  Each element in the list is an
|     object instance descriptor of type 'eoi_obj_instance'; each descriptor
|     specifies the actual object instance, not a copy.  Storage for the
|     list itself is allocated; disposition of that storage is the
|     responsibility of the calling routine.
|     
|     A return value of NULLlist indicates that there are no object
|     instances associated with the display.
|
\*--------------------------------------------------------------------------*/

#endif
