/*
$Header: /u/04c/mnt/integ/source/de/include/RCS/eob_priv.h,v 1.3 90/05/21 13:53:46 little Exp $
*/

/*--------------------------------------------------------------------------*\
|   
|  Name:  Dialogue Editor Object Abstraction (eob) Private Declarations
|
|  Description:  
|     This header file defines routines that must be exported from the
|     EOB abstraction for use by other low-level abstractions.  These routines
|     should ONLY be called by other abstractions (such as EVC, for example).
|
|  Component of:
|     Dialogue Editor Layer.
|
|  Project:
|     SERPENT System
|     User Interface Prototyping
|     Software Engineering Institute
|     Carnegie Mellon University
|     Pittsburgh, PA  15213
|
|

$Log:	eob_priv.h,v $
 * Revision 1.3  90/05/21  13:53:46  little
 * fix up for multiple includes & start mods for visu/struc editor integration
 * 
 * Revision 1.2  89/12/04  17:23:36  bmc
 * added eob_set_type
 * 
 * Revision 1.1  89/11/29  10:05:29  bmc
 * Initial revision
 * 

|
|-----------------------------------------------------------------------------
|
|   Distribution: Approved for public release; distribution is unlimited.
|
|   Copyright (c) 1989  by  Carnegie  Mellon  University, Pittsburgh, PA.  The
|  Software Engineering  Institute  (SEI) is a federally  funded  research and
|  development center established  and  operated by Carnegie Mellon University
|  (CMU).  Sponsored  by  the  U.S.  Department  of   Defense  under  contract
|  F19628-85-C-0003,  the  SEI  is  supported  by  the  services  and  defense
|  agencies, with the U.S. Air Force as the executive contracting agent.
|
|    Permission to use,  copy,  modify, or  distribute  this  software and its
|  documentation for  any purpose and without fee  is hereby granted, provided
|  that  the above copyright notice appear  in  all copies and that both  that
|  copyright  notice  and   this  permission  notice  appear   in   supporting
|  documentation.   Further,  the  names  Software  Engineering  Institute  or
|  Carnegie  Mellon  University  may  not be used in  advertising or publicity
|  pertaining to distribution of the software without specific, written  prior
|  permission.  CMU makes no claims  or representations  about the suitability
|  of this software for any purpose.  This software is provided "as is" and no
|  warranty,  express  or  implied,  is  made  by  the  SEI  or CMU, as to the
|  accuracy  and  functioning of the program and related program material, nor
|  shall   the  fact of  distribution   constitute  any   such  warranty.   No
|  responsibility is assumed by the SEI or CMU in connection herewith.
|
\*--------------------------------------------------------------------------*/

#ifndef eob_private
#define eob_private

#include "evc.h"


/*--------------------------------------------------------------------------*\
|  Routine: eob_set_parent
| 
|  Description:
|     Sets the parent VC for an object.
|
\* Syntax:                                                                  */

	void eob_set_parent
	    (
        /*  object	: in out eob_object	*/
	/*  new_parent	: in evc_vc		*/
	    );

/*
|  Parameters:
|     object     - object to be parented.
|     new_parent - the new parent of the object.
|
|  Returns:
|      Nothing.
\*--------------------------------------------------------------------------*/


/*--------------------------------------------------------------------------*\
|  Routine: eob_set_type
|
|  Description:
|     Sets the type of an object
|
\* Syntax:                                                                  */

	void eob_set_type
	    (
	/*  the_object : in eob_object, */
	/*  new_type   : in string 	*/
	    );

/*
|  Parameters:
|     the_object - object to set type for
|     new_type   - the new type to be set
|
|  Returns:
|      Nothing.
|
\*--------------------------------------------------------------------------*/

#endif eob_private
