/*
$Header: /u/04c/mnt/integ/source/de/include/RCS/eoc_cmd.h,v 1.2 90/05/21 13:54:03 little Exp $
*/

/*--------------------------------------------------------------------------*\
|   
|  Name:  Dialogue Editor Object Command Handlers (eoc_cmd.h)
|
|  Description:  
|     Handles the commands for objects.
|
|  Component of:
|     Dialogue Editor Layer.
|
|  Project:
|     Serpent
|     User Interface Prototyping
|     Software Engineering Institute
|     Carnegie Mellon University
|     Pittsburgh, PA  15213

$Log:	eoc_cmd.h,v $
 * Revision 1.2  90/05/21  13:54:03  little
 * fix up for multiple includes & start mods for visu/struc editor integration
 * 
 * Revision 1.1  89/12/12  12:57:31  bmc
 * Initial revision
 * 

|
\*--------------------------------------------------------------------------*\
|
|   Distribution: Approved for public release; distribution is unlimited.
|
|   Copyright (c) 1989  by  Carnegie  Mellon  University, Pittsburgh, PA.  The
|  Software Engineering  Institute  (SEI) is a federally  funded  research and
|  development center established  and  operated by Carnegie Mellon University
|  (CMU).  Sponsored  by  the  U.S.  Department  of   Defense  under  contract
|  F19628-85-C-0003,  the  SEI  is  supported  by  the  services  and  defense
|  agencies, with the U.S. Air Force as the executive contracting agent.
|
|    Permission to use,  copy,  modify, or  distribute  this  software and its
|  documentation for  any purpose and without fee  is hereby granted, provided
|  that  the above copyright notice appear  in  all copies and that both  that
|  copyright  notice  and   this  permission  notice  appear   in   supporting
|  documentation.   Further,  the  names  Software  Engineering  Institute  or
|  Carnegie  Mellon  University  may  not be used in  advertising or publicity
|  pertaining to distribution of the software without specific, written  prior
|  permission.  CMU makes no claims  or representations  about the suitability
|  of this software for any purpose.  This software is provided "as is" and no
|  warranty,  express  or  implied,  is  made  by  the  SEI  or CMU, as to the
|  accuracy  and  functioning of the program and related program material, nor
|  shall   the  fact of  distribution   constitute  any   such  warranty.   No
|  responsibility is assumed by the SEI or CMU in connection herewith.
|
\*--------------------------------------------------------------------------*/

#ifndef eoc
#define eoc

/*--------------------------------------------------------------------------*\
|  Global Variable: eoc_debug
|
|  Description:
|     Debug variable for the abstraction.
|
\* Definition:                                                              */

#ifdef eoc_main
  int eoc_debug = 1;
#else
  extern int eoc_debug;
#endif

/*
\*--------------------------------------------------------------------------*/

/*--------------------------------------------------------------------------*\
|  Routine:  eoc_add_object
|
|  Description:
|     The eoc_insert_object routine is used to create and insert an object
|     into an existing VC.
|
\* Definition:                                                              */

	void eoc_add_object
	    (
	/*  command	: in pointer to command_sdd */
	/*  transaction	: in transaction_type */
	    );

/*
|  Parameters:
|     command     - Command shared data record.
|     transaction - Transaction containing shared data info.
|
|  Returns:
|     Nothing
\*--------------------------------------------------------------------------*/

/*--------------------------------------------------------------------------*\
|  Routine:  eoc_copy_object
|
|  Description:
|     The eoc_copy_object routine copies an object to a parent vc.
|
\* Definition:                                                              */

	void eoc_copy_object
	    (
	/*  command	: in pointer to command_sdd */
	/*  transaction	: in transaction_type */
	    );

/*
|  Parameters:
|     command     - Command shared data record.
|     transaction - Transaction containing shared data info.
|
|  Returns:
|     Nothing
\*--------------------------------------------------------------------------*/

/*--------------------------------------------------------------------------*\
|  Routine:  eoc_move_object
|
|  Description:
|     The eoc_move_object routine moves an object from one VC to another.
|
\* Definition:                                                              */

	void eoc_move_object
	    (
	/*  command	: in pointer to command_sdd */
	/*  transaction	: in transaction_type */
	    );

/*
|  Parameters:
|     command     - Command shared data record.
|     transaction - Transaction containing shared data info.
|
|  Returns:
|     Nothing
\*--------------------------------------------------------------------------*/

/*--------------------------------------------------------------------------*\
|  Routine:  eoc_delete_object
|
|  Description:
|     The eoc_delete_object removes an object from its parent VC and destroys
|
\* Definition:                                                              */

	void eoc_delete_object
	    (
	/*  command	: in pointer to command_sdd */
	/*  transaction	: in transaction_type */
	    );

/*
|  Parameters:
|     command     - Command shared data record.
|     transaction - Transaction containing shared data info.
|
|  Returns:
|     Nothing
\*--------------------------------------------------------------------------*/

/*--------------------------------------------------------------------------*\
|  Routine:  eoc_get_objects
|
|  Description:
|     Gets the objects associated with a VC and places them into shared data.
|     The VC is specified via a command from the dialogue.
|     it.
|
\* Definition:                                                              */

	void eoc_get_objects
	    (
	/*  command	: in pointer to command_sdd */
	/*  transaction	: in transaction_type */
	    );

/*
|  Parameters:
|     command     - Command shared data record.
|     transaction - Transaction containing shared data info.
|
|  Returns:
|     Nothing
\*--------------------------------------------------------------------------*/

#endif
