/* $Header: /u/04c/mnt/integ/source/de/include/RCS/esa_sd.h,v 1.7 90/10/23 13:55:12 little Exp $ */

/*--------------------------------------------------------------------------*\
|   
|  Name:  Dialoge Editor Attribute Shared Data Shit
|
|  Description:  
|     provides attribute shared data functions
|
|  Component of:
|     Dialoge Editor Layer.
|
|  Project:
|     SERPENT System
|     User Interface Prototyping
|     Software Engineering Institute
|     Carnegie Mellon University
|     Pittsburgh, PA  15213
|
|  Change History:
|     $Log:	esa_sd.h,v $
 * Revision 1.7  90/10/23  13:55:12  little
 * no change
 * 
 * Revision 1.6  90/07/05  15:16:32  little
 * more structure and visualizer parts integration
 * 
 * Revision 1.5  90/06/14  13:58:06  little
 * more changes to integrate visulization and structure editors
 * 
 * Revision 1.4  90/05/21  13:55:50  little
 * fix up for multiple includes & start mods for visu/struc editor integration
 * 
 * Revision 1.3  89/12/20  14:47:52  rcs
 * integration testing
 * 
 * Revision 1.2  89/12/12  15:19:51  little
 * no changes, nevermind
 * 
 * Revision 1.1  89/12/07  15:17:12  little
 * Initial revision
 * 
|     6 dec 1989 : Module created.
|
\*--------------------------------------------------------------------------*\
|
|   Distribution: Approved for public release; distribution is unlimited.
|
|   Copyright (c) 1989  by  Carnegie  Mellon  University, Pittsburgh, PA.  The
|  Software Engineering  Institute   (SEI) is a federally  funded  research and
|  development center established  and  operated by Carnegie Mellon University
|   (CMU).  Sponsored  by  the  U.S.  Department  of   Defense  under  contract
|  F19628-85-C-0003,  the  SEI  is  supported  by  the  services  and  defense
|  agencies, with the U.S. Air Force as the executive contracting agent.
|
|    Permission to use,  copy,  modify, or  distribute  this  software and its
|  documentation for  any purpose and without fee  is hereby granted, provided
|  that  the above copyright notice appear  in  all copies and that both  that
|  copyright  notice  and   this  permission  notice  appear   in   supporting
|  documentation.   Further,  the  names  Software  Engineering  Institute  or
|  Carnegie  Mellon  University  may  not be used in  advertising or publicity
|  pertaining to distribution of the software without specific, written  prior
|  permission.  CMU makes no claims  or representations  about the suitability
|  of this software for any purpose.  This software is provided "as is" and no
|  warranty,  express  or  implied,  is  made  by  the  SEI  or CMU, as to the
|  accuracy  and  functioning of the program and related program material, nor
|  shall   the  fact of  distribution   constitute  any   such  warranty.   No
|  responsibility is assumed by the SEI or CMU in connection herewith.
|
\*--------------------------------------------------------------------------*/

#ifndef esa
#define esa

#include "se.h"


/*--------------------------------------------------------------------------*\
|  Global Variable: esa_debug
|
|  Description:
|     Debug variable for the abstraction.
|
\* Definition:                                                              */

#ifdef esa_main
  int esa_debug = 1;
#else
  extern int esa_debug;
#endif

/*
\*--------------------------------------------------------------------------*/


/*--------------------------------------------------------------------------*\
|  Routine: esa_make_sd_struct
|
|  Description:
|     Creates a shared data description corresponding to the attribute.
|
\* Syntax:                                                                  */

	attribute_sdd esa_make_sd_struct(
	  /* attribute: in eat_attribute */
	);

/*
|  Parameters:
|     attribute - The attribute.
|
|  Returns:
|     A shared data description corresponding to the attribute.
|
|  Statuses:
|     ok, out_of_memory.
|
\*--------------------------------------------------------------------------*/


/*--------------------------------------------------------------------------*\
|  Routine: esa_create_sd
|
|  Description:
|     Creates a shared data element for a specified attribute and adds it to
|     the specified transaction.
|
\* Syntax:                                                                  */

	void esa_create_sd (
	  /* transaction: in out transaction_type */
	  /* attribute: in eat_attribute */
	);

/*
|  Parameters:
|     transaction - The transaction to send out changes on.
|     attribute - The attribute.
|
|  Returns:
|     A shared data description corresponding to the attribute.
|
|  Statuses:
|     ok, out_of_memory.
|
\*--------------------------------------------------------------------------*/

/*--------------------------------------------------------------------------*\
|  Routine: esa_modify_sd
|
|  Description:
|     modifies a shared data element for a specified attribute
|
\* Syntax:                                                                  */

	void esa_modify_sd (
	  /* transaction: in out transaction_type */
	  /* attribute: in eat_attribute */
	);

/*
|  Parameters:
|     transaction - The transaction to send out changes on.
|     attribute - The attribute.
|
|  Returns:
|     A shared data description corresponding to the attribute.
|
|  Statuses:
|     ok, out_of_memory.
|
\*--------------------------------------------------------------------------*/

/*--------------------------------------------------------------------------*\
|  Routine: esa_remove_from_sd
|
|  Description:
|     Removes an att from the shared database.
|
\* Syntax:                                                                  */

	void esa_remove_from_sd (
	  /* transaction: in out transaction_type */
	  /* attribute: in eat_attribute */
	);

/*
|  Parameters:
|     transaction - The transaction to send out changes on.
|     attribute - The attribute.
|
|  Returns:
|     A shared data description corresponding to the attribute.
|
|  Statuses:
|     ok, out_of_memory.
|
\*--------------------------------------------------------------------------*/

/*--------------------------------------------------------------------------*\
|  Routine: esa_modify_attribute
|
|  Description:
|     Modifies the various parts of an existing attribute as specified by a
|     shared data record and then destroys the shared data record.
|
|     Note:  This routine can not be used to reparent a attribute.
|
|
\* Syntax:                                                                  */

	void esa_modify_attribute (
	  /* transaction: in trasnaction_type */
	  /* attribute: in out eat_attribute */
	  /* attribute_sd: in attribute_sdd */
	);

/*
|  Parameters:
|     transaction - The transaction to send out changes on for the instance
|     attribute - The attribute.
|     attribute_sd - The shared data to use when updating the attribute.
|
|  Returns:
|     A shared data description corresponding to the attribute.
|
|  Statuses:
|     ok, out_of_memory.
|
\*--------------------------------------------------------------------------*/


/*--------------------------------------------------------------------------*\
|  Routine: esa_make_inst_sd_struct
|
|  Description:
|     Creates a shared data structure for an object instance
\*--------------------------------------------------------------------------*/
object_instance_attribute_sdd *esa_make_inst_sd_struct (
/* att*/
	);
/*
eat_attribute att;
*/

#endif

