/*
$Header: /u/04c/mnt/integ/source/de/include/RCS/esi.h,v 1.4 90/09/11 08:37:55 little Exp $
*/

/*--------------------------------------------------------------------------*\
|
|   Dialogue Editor Source I/O Abstraction
|
|

$Log:	esi.h,v $
 * Revision 1.4  90/09/11  08:37:55  little
 * add thied parameter to definition of esi_buffer_src_write
 * 
 * Revision 1.3  90/08/06  16:42:55  little
 * add definition of esi_free_parse_tree
 * 
 * Revision 1.2  90/05/21  15:01:31  little
 * fix up for multiple includes & start mods for visu/struc editor integration
 * 
 * Revision 1.1  89/11/29  10:06:30  bmc
 * Initial revision
 * 

|
|-----------------------------------------------------------------------------
|
|   Distribution: Approved for public release; distribution is unlimited.
|
|   Copyright (c) 1989  by  Carnegie  Mellon  University, Pittsburgh, PA.  The
|  Software Engineering  Institute  (SEI) is a federally  funded  research and
|  development center established  and  operated by Carnegie Mellon University
|  (CMU).  Sponsored  by  the  U.S.  Department  of   Defense  under  contract
|  F19628-85-C-0003,  the  SEI  is  supported  by  the  services  and  defense
|  agencies, with the U.S. Air Force as the executive contracting agent.
|
|    Permission to use,  copy,  modify, or  distribute  this  software and its
|  documentation for  any purpose and without fee  is hereby granted, provided
|  that  the above copyright notice appear  in  all copies and that both  that
|  copyright  notice  and   this  permission  notice  appear   in   supporting
|  documentation.   Further,  the  names  Software  Engineering  Institute  or
|  Carnegie  Mellon  University  may  not be used in  advertising or publicity
|  pertaining to distribution of the software without specific, written  prior
|  permission.  CMU makes no claims  or representations  about the suitability
|  of this software for any purpose.  This software is provided "as is" and no
|  warranty,  express  or  implied,  is  made  by  the  SEI  or CMU, as to the
|  accuracy  and  functioning of the program and related program material, nor
|  shall   the  fact of  distribution   constitute  any   such  warranty.   No
|  responsibility is assumed by the SEI or CMU in connection herewith.
|
\*--------------------------------------------------------------------------*/

#ifndef esi
#define esi


#include "serpent.h"


/*--------------------------------------------------------------------------*\
|  Global Variable: esi_debug
|
|  Description:
|     Debug variable for the abstraction.
|
\* Definition:                                                              */

#ifdef esi_main
  int esi_debug = 1;
#else
  extern int esi_debug;
#endif


/*--------------------------------------------------------------------------*\
|  Routine: esi_buffer_src_write
|
|  Description:
|     Write a buffer to a source stream.
\*--------------------------------------------------------------------------*/
void esi_buffer_src_write (
/* stream, the_buffer */
	);
/*
buffer the_buffer;
FILE *stream;
boolean need_semi;
*/


/*--------------------------------------------------------------------------*\
|  Routine: esi_snip_2_text
|
|  Description:
|     convert a snippet to text
\*--------------------------------------------------------------------------*/
buffer esi_snip_2_text (
/* snippet */
	);
/*
LIST snippet;
*/


/*--------------------------------------------------------------------------*\
|  Routine: esi_comments_2_text
|
|  Description:
|     convert a snippet to text
\*--------------------------------------------------------------------------*/
buffer esi_comments_2_text (
/* comments */
	);
/*
LIST comments;
*/


/*--------------------------------------------------------------------------*\
|  Routine: esi_cc_2_text
|
|  Description:
|     convert a cc to text
\*--------------------------------------------------------------------------*/
buffer esi_cc_2_text (
/* cc */
	);
/*
LIST cc;
*/

/*--------------------------------------------------------------------------*\
|  Routine: esi_externs_2_text
|
|  Description:
|     convert the dialogue externs to text
\*--------------------------------------------------------------------------*/
buffer esi_externs_2_text (
/* externs_list */
	);
/*
LIST externs_list;
*/


/*--------------------------------------------------------------------------*\
|  Routine: esi_free_parse_tree
|
|  Description:
|     frees up the space used by a parse tree
\*--------------------------------------------------------------------------*/
void esi_free_parse_tree (
/* the_tree */
	);
/*
LIST the_tree;
*/

#endif

