/* $Header: /u/04c/mnt/integ/source/de/include/RCS/esm_sd.h,v 1.2 90/05/21 15:02:11 little Exp $ */
/*--------------------------------------------------------------------------*\
|   
|  Name:  Dialoge Editor Method Shared Data Shit
|
|  Description:  
|     provides method shared data functions
|
|  Component of:
|     Dialoge Editor Layer.
|
|  Project:
|     SERPENT System
|     User Interface Prototyping
|     Software Engineering Institute
|     Carnegie Mellon University
|     Pittsburgh, PA  15213
|
|  Change History:
|     $Log:	esm_sd.h,v $
 * Revision 1.2  90/05/21  15:02:11  little
 * fix up for multiple includes & start mods for visu/struc editor integration
 * 
 * Revision 1.1  89/12/19  14:25:46  rcs
 * Initial revision
 * 
|     December 15, 1989 : Module created.
|
\*--------------------------------------------------------------------------*\
|
|   Distribution: Approved for public release; distribution is unlimited.
|
|   Copyright (c) 1989  by  Carnegie  Mellon  University, Pittsburgh, PA.  The
|  Software Engineering  Institute   (SEI) is a federally  funded  research and
|  development center established  and  operated by Carnegie Mellon University
|   (CMU).  Sponsored  by  the  U.S.  Department  of   Defense  under  contract
|  F19628-85-C-0003,  the  SEI  is  supported  by  the  services  and  defense
|  agencies, with the U.S. Air Force as the executive contracting agent.
|
|    Permission to use,  copy,  modify, or  distribute  this  software and its
|  documentation for  any purpose and without fee  is hereby granted, provided
|  that  the above copyright notice appear  in  all copies and that both  that
|  copyright  notice  and   this  permission  notice  appear   in   supporting
|  documentation.   Further,  the  names  Software  Engineering  Institute  or
|  Carnegie  Mellon  University  may  not be used in  advertising or publicity
|  pertaining to distribution of the software without specific, written  prior
|  permission.  CMU makes no claims  or representations  about the suitability
|  of this software for any purpose.  This software is provided "as is" and no
|  warranty,  express  or  implied,  is  made  by  the  SEI  or CMU, as to the
|  accuracy  and  functioning of the program and related program material, nor
|  shall   the  fact of  distribution   constitute  any   such  warranty.   No
|  responsibility is assumed by the SEI or CMU in connection herewith.
|
\*--------------------------------------------------------------------------*/

#ifndef esm
#define esm

#include "se.h"

/*--------------------------------------------------------------------------*\
|  Global Variable: esm_debug
|
|  Description:
|     Debug variable for the abstraction.
|
\* Definition:                                                              */

#ifdef esm_main
  int esm_debug = 1;
#else
  extern int esm_debug;
#endif

/*
\*--------------------------------------------------------------------------*/

/*--------------------------------------------------------------------------*\
|  Routine: esm_make_sd_struct
|
|  Description:
|     Creates a shared data description corresponding to the method.
|
\* Syntax:                                                                  */

	method_sdd esm_make_sd_struct(
	  /* method: in eat_method */
	);

/*
|  Parameters:
|     method - The method.
|
|  Returns:
|     A shared data description corresponding to the method.
|
|  Statuses:
|     ok, out_of_memory.
|
\*--------------------------------------------------------------------------*/

/*--------------------------------------------------------------------------*\
|  Routine: esm_create_sd
|
|  Description:
|     Creates a shared data element for a specified method and adds it to
|     the specified transaction.
|
\* Syntax:                                                                  */

	void esm_create_sd (
	  /* transaction: in out transaction_type */
	  /* method: in eat_method */
	);

/*
|  Parameters:
|     transaction - The transaction to send out changes on.
|     method - The method.
|
|  Returns:
|     A shared data description corresponding to the method.
|
|  Statuses:
|     ok, out_of_memory.
|
\*--------------------------------------------------------------------------*/

/*--------------------------------------------------------------------------*\
|  Routine: esm_modify_sd
|
|  Description:
|     modifies a shared data element for a specified method
|
\* Syntax:                                                                  */

	void esm_modify_sd (
	  /* transaction: in out transaction_type */
	  /* method: in eat_method */
	);

/*
|  Parameters:
|     transaction - The transaction to send out changes on.
|     method - The method.
|
|  Returns:
|     A shared data description corresponding to the method.
|
|  Statuses:
|     ok, out_of_memory.
|
\*--------------------------------------------------------------------------*/

/*--------------------------------------------------------------------------*\
|  Routine: esm_remove_from_sd
|
|  Description:
|     Removes an att from the shared database.
|
\* Syntax:                                                                  */

	void esm_remove_from_sd (
	  /* transaction: in out transaction_type */
	  /* method: in eat_method */
	);

/*
|  Parameters:
|     transaction - The transaction to send out changes on.
|     method - The method.
|
|  Returns:
|     A shared data description corresponding to the method.
|
|  Statuses:
|     ok, out_of_memory.
|
\*--------------------------------------------------------------------------*/

/*--------------------------------------------------------------------------*\
|  Routine: esm_modify_method
|
|  Description:
|     Modifies the various parts of an existing method as specified by a
|     shared data record and then destroys the shared data record.
|
|     Note:  This routine can not be used to reparent a method.
|
|
\* Syntax:                                                                  */

	void esm_modify_method (
	  /* method: in out eat_method */
	  /* method_sd: in method_sdd */
	);

/*
|  Parameters:
|     method - The method.
|     method_sd - The shared data to use when updating the method.
|
|  Returns:
|     A shared data description corresponding to the method.
|
|  Statuses:
|     ok, out_of_memory.
|
\*--------------------------------------------------------------------------*/
#endif

