/* $Header: /u/04c/mnt/integ/source/de/include/RCS/esx_sd.h,v 1.6 90/05/21 15:39:51 little Exp $ */

/*--------------------------------------------------------------------------*\
|   
|  Name:  Dialoge Editor Variable Shared Data shit
|
|  Description:  
|     provides variable shared data functions

|  Component of:
|     Dialoge Editor Layer.
|
|  Project:
|     SERPENT System
|     User Interface Prototyping
|     Software Engineering Institute
|     Carnegie Mellon University
|     Pittsburgh, PA  15213
|
|  Change History:
|     $Log:	esx_sd.h,v $
 * Revision 1.6  90/05/21  15:39:51  little
 * fix up for multiple includes & start mods for visu/struc editor integration
 * 
 * Revision 1.5  89/12/12  10:57:24  little
 * redo the mevore parameters yet again
 * 
 * Revision 1.4  89/12/12  10:34:12  little
 * change parameter "definition" for exs_remove_sd
 * 
 * Revision 1.3  89/12/11  16:37:38  little
 * do not remember the changes, sorry
 * 
 * Revision 1.2  89/12/07  17:28:02  rcs
 * added header for set routine
 * 
 * Revision 1.1  89/12/07  15:18:10  little
 * Initial revision
 * 
|     7 dec 1989 : Module created.
|
\*--------------------------------------------------------------------------*\
|
|   Distribution: Approved for public release; distribution is unlimited.
|
|   Copyright (c) 1989  by  Carnegie  Mellon  University, Pittsburgh, PA.  The
|  Software Engineering  Institute   (SEI) is a federally  funded  research and
|  development center established  and  operated by Carnegie Mellon University
|   (CMU).  Sponsored  by  the  U.S.  Department  of   Defense  under  contract
|  F19628-85-C-0003,  the  SEI  is  supported  by  the  services  and  defense
|  agencies, with the U.S. Air Force as the executive contracting agent.
|
|    Permission to use,  copy,  modify, or  distribute  this  software and its
|  documentation for  any purpose and without fee  is hereby granted, provided
|  that  the above copyright notice appear  in  all copies and that both  that
|  copyright  notice  and   this  permission  notice  appear   in   supporting
|  documentation.   Further,  the  names  Software  Engineering  Institute  or
|  Carnegie  Mellon  University  may  not be used in  advertising or publicity
|  pertaining to distribution of the software without specific, written  prior
|  permission.  CMU makes no claims  or representations  about the suitability
|  of this software for any purpose.  This software is provided "as is" and no
|  warranty,  express  or  implied,  is  made  by  the  SEI  or CMU, as to the
|  accuracy  and  functioning of the program and related program material, nor
|  shall   the  fact of  distribution   constitute  any   such  warranty.   No
|  responsibility is assumed by the SEI or CMU in connection herewith.
|
\*--------------------------------------------------------------------------*/

#ifndef esx
#define esx

#include "se.h"


/*--------------------------------------------------------------------------*\
|  Global Variable: esx_debug
|
|  Description:
|     Debug variable for the abstraction.
|
\* Definition:                                                              */

#ifdef esx_main
  int esx_debug = 1;
#else
  extern int esx_debug;
#endif

/*
\*--------------------------------------------------------------------------*/


/*--------------------------------------------------------------------------*\
|  Routine: esx_create_sd
|
|  Description:
|     Creates a shared data element for a specified variable and adds it to
|     the specified transaction.
\*--------------------------------------------------------------------------*/
void esx_create_sd (
	/* transaction, variable */
		);
/*
transaction_type transaction;
eat_variable variable;
*/

/*--------------------------------------------------------------------------*\
|  Routine: esx_make_sd_struct
|
|  Description:
|     creates an sd structure for an variable
\*--------------------------------------------------------------------------*/
variable_sdd esx_make_sd_struct (
	/* variable */
		);
/*
eva_variable variable;
*/


/*--------------------------------------------------------------------------*\
|  Routine: esx_modify_sd
|
|  Description:
|     modifies a shared data element for a specified variable
\*--------------------------------------------------------------------------*/
void esx_modify_sd (
	/* transaction, variable */
		);
/*
transaction_type transaction;
eva_variable variable;
*/


/*--------------------------------------------------------------------------*\
|  Routine: esx_remove_from_sd
|
|  Description:
|     Removes an var from the shared database.
\*--------------------------------------------------------------------------*/
void esx_remove_from_sd (
	/* transaction, variable */
		);
/*
transaction_type transaction;
eva_variable variable;
*/


/*--------------------------------------------------------------------------*\
|  Routine: esx_modify_variable
|
|  Description:
|     Modifies the various parts of an existing variable as specified by a
|     shared data record and then destroys the shared data record.
|
|     Note:  This routine can not be used to reparent a variable.
|
\*--------------------------------------------------------------------------*/
void esx_modify_variable (
	/* variable, variable_sd */
		);
/*
eva_variable variable;
variable_sdd variable_sd;
*/


#endif

