/* $Header: /u/04c/mnt/integ/source/de/include/RCS/evc_cmd.h,v 1.1 90/07/10 17:15:54 little Exp $ */
/*--------------------------------------------------------------------------*\
|     
|  Name:  View Controller Command Definitions 
|
|  Description:  
|     The dialogue editor command definitions contains the definition
|     of the commands supported by the DEA.  This component accesses
|     retained data stored in the dialogue editor command interpreter
|     component.
|
|  Component of:
|     Dialoge Editor Layer.
|
|  Project:
|     Serpent
|     User Interface Prototyping
|     Software Engineering Institute
|     Carnegie Mellon University
|     Pittsburgh, PA  15213
|
|  Change History:
|     $Log:	evc_cmd.h,v $
 * Revision 1.1  90/07/10  17:15:54  little
 * Initial revision
 * 
|
|  change history when file was ecv.h

 * Revision 1.2  90/05/21  13:50:10  little
 * fix up for multiple includes & start mods for visu/struc editor integration
 * 
 * Revision 1.1  89/12/12  07:51:10  rcs
 * Initial revision
 * 
 * Revision 1.2  89/11/30  12:55:10  rcs
 * fixed spelling error
 * 
 * Revision 1.1  89/11/28  18:00:16  rcs
 * Initial revision
 * 
|
\*--------------------------------------------------------------------------*\
|
|   Distribution: Approved for public release; distribution is unlimited.
|
|   Copyright (c) 1989  by  Carnegie  Mellon  University, Pittsburgh, PA.  The
|  Software Engineering  Institute  (SEI) is a federally  funded  research and
|  development center established  and  operated by Carnegie Mellon University
|  (CMU).  Sponsored  by  the  U.S.  Department  of   Defense  under  contract
|  F19628-85-C-0003,  the  SEI  is  supported  by  the  services  and  defense
|  agencies, with the U.S. Air Force as the executive contracting agent.
|
|    Permission to use,  copy,  modify, or  distribute  this  software and its
|  documentation for  any purpose and without fee  is hereby granted, provided
|  that  the above copyright notice appear  in  all copies and that both  that
|  copyright  notice  and   this  permission  notice  appear   in   supporting
|  documentation.   Further,  the  names  Software  Engineering  Institute  or
|  Carnegie  Mellon  University  may  not be used in  advertising or publicity
|  pertaining to distribution of the software without specific, written  prior
|  permission.  CMU makes no claims  or representations  about the suitability
|  of this software for any purpose.  This software is provided "as is" and no
|  warranty,  express  or  implied,  is  made  by  the  SEI  or CMU, as to the
|  accuracy  and  functioning of the program and related program material, nor
|  shall   the  fact of  distribution   constitute  any   such  warranty.   No
|  responsibility is assumed by the SEI or CMU in connection herewith.
|
\*--------------------------------------------------------------------------*/

#ifndef evc_cmd
#define evc_cmd



/*--------------------------------------------------------------------------*\
|  Routine:  evc_insert_vc_cmd
| 
|  Description:  
|     create and insert a VC into an existing VC.
|
\* Syntax:                                                                  */

	void evc_insert_vc_cmd (
	  /* command : in command_sdd * 	*/
	  /* transaction: in transaction_type	*/
	);

/*
|  Parameters:
|     command -  the actual command sdd.
|     transaction - outgoing transaction.
|
|  Returns:
|      Void.
|
|  Statuses:
|     ok, out_of_memory.
|
\*--------------------------------------------------------------------------*/

/*--------------------------------------------------------------------------*\
|  Routine:  evc_copy_vc_cmd
| 
|  Description:  
|     copies a vc to a parent vc.
|
\* Syntax:                                                                  */

	void evc_copy_vc_cmd (
	  /* command : in command_sdd * 	*/
	  /* transaction: in transaction_type	*/
	);

/*
|  Parameters:
|     command -  the actual command sdd.
|     transaction - outgoing transaction.
|
|  Returns:
|      Void.
|
|  Statuses:
|     ok, out_of_memory.
|
\*--------------------------------------------------------------------------*/

/*--------------------------------------------------------------------------*\
|  Routine:  evc_move_vc_cmd
| 
|  Description:  
|     moves a vc to a parent vc.
|
\* Syntax:                                                                  */

	void evc_move_vc_cmd (
	  /* command : in command_sdd * 	*/
	  /* transaction: in transaction_type	*/
	);

/*
|  Parameters:
|     command -  the actual command sdd.
|     transaction - outgoing transaction.
|
|  Returns:
|      Void.
|
|  Statuses:
|     ok, out_of_memory.
|
\*--------------------------------------------------------------------------*/

/*--------------------------------------------------------------------------*\
|  Routine:  evc_delete_vc_cmd
| 
|  Description:  
|     deletes a vc to a parent vc.
|
\* Syntax:                                                                  */

	void evc_delete_vc_cmd (
	  /* command : in command_sdd * 	*/
	  /* transaction: in transaction_type	*/
	);

/*
|  Parameters:
|     command -  the actual command sdd.
|     transaction - outgoing transaction.
|
|  Returns:
|      Void.
|
|  Statuses:
|     ok, out_of_memory.
|
\*--------------------------------------------------------------------------*/

/*--------------------------------------------------------------------------*\
|  Routine:  evc_get_subvcs_cmd
| 
|  Description:  
|     Gets the list of subvcs for a given vc.
|
\* Syntax:                                                                  */

	void evc_get_subvcs_cmd (
	  /* command : in command_sdd * 	*/
	  /* transaction: in transaction_type	*/
	);

/*
|  Parameters:
|     command -  the actual command sdd.
|     transaction - outgoing transaction.
|
|  Returns:
|      Void.
|
|  Statuses:
|     ok, out_of_memory.
|
\*--------------------------------------------------------------------------*/


/*--------------------------------------------------------------------------*\
|  Routine:  evc_instantiate_guys_cmd
|
|  Description:
|     handle the object templates instantiate commands
\*--------------------------------------------------------------------------*/
void evc_instantiate_guys_cmd (
/* command, out_transaction */
	);
/*
command_sdd *command;
transaction_type out_transaction;
*/

#endif

