/* $Header: /u/04c/mnt/integ/source/de/include/RCS/exc_cmd.h,v 1.6 90/05/21 15:43:54 little Exp $ */

/*--------------------------------------------------------------------------*\
|   
|  Name:  Dialogue Editor Variable Command Definitions (exc)
|
|  Description:  
|     contains the definition
|     of the variable commands supported by the DEA.  This component accesses
|     retained data stored in the dialogue editor command interpreter
|     component.
|
|  Component of:
|     Dialoge Editor Layer.
|
|  Project:
|     SERPENT System
|     User Interface Prototyping
|     Software Engineering Institute
|     Carnegie Mellon University
|     Pittsburgh, PA  15213
|
|  Change History:
$Log:	exc_cmd.h,v $
 * Revision 1.6  90/05/21  15:43:54  little
 * fix up for multiple includes & start mods for visu/struc editor integration
 * 
 * Revision 1.5  89/12/11  16:38:09  little
 * add definitions for move and copy
 * 
 * Revision 1.4  89/12/08  13:20:03  little
 * add exc_add_variable
 * 
 * Revision 1.3  89/12/07  17:45:38  little
 * changed exc_get_variable to exc_get_variables
 * 
 * Revision 1.2  89/12/07  17:27:24  rcs
 * changed debug to 3
 * 
 * Revision 1.1  89/12/07  15:14:35  little
 * Initial revision
 * 
|     7 dec 1989 : Module created.
|
\*--------------------------------------------------------------------------*\
|
|   Distribution: Approved for public release; distribution is unlimited.
|
|   Copyright (c) 1989  by  Carnegie  Mellon  University, Pittsburgh, PA.  The
|  Software Engineering  Institute  (SEI) is a federally  funded  research and
|  development center established  and  operated by Carnegie Mellon University
|  (CMU).  Sponsored  by  the  U.S.  Department  of   Defense  under  contract
|  F19628-85-C-0003,  the  SEI  is  supported  by  the  services  and  defense
|  agencies, with the U.S. Air Force as the executive contracting agent.
|
|    Permission to use,  copy,  modify, or  distribute  this  software and its
|  documentation for  any purpose and without fee  is hereby granted, provided
|  that  the above copyright notice appear  in  all copies and that both  that
|  copyright  notice  and   this  permission  notice  appear   in   supporting
|  documentation.   Further,  the  names  Software  Engineering  Institute  or
|  Carnegie  Mellon  University  may  not be used in  advertising or publicity
|  pertaining to distribution of the software without specific, written  prior
|  permission.  CMU makes no claims  or representations  about the suitability
|  of this software for any purpose.  This software is provided "as is" and no
|  warranty,  express  or  implied,  is  made  by  the  SEI  or CMU, as to the
|  accuracy  and  functioning of the program and related program material, nor
|  shall   the  fact of  distribution   constitute  any   such  warranty.   No
|  responsibility is assumed by the SEI or CMU in connection herewith.
|
\*--------------------------------------------------------------------------*/

#ifndef exc
#define exc


/*--------------------------------------------------------------------------*\
|  Global Variable: exc_debug
|
|  Description:
|     Debug variable for the abstraction.
|
\* Definition:                                                              */

#ifdef exc_main
  int exc_debug = 1;
#else
  extern int exc_debug;
#endif

/*
\*--------------------------------------------------------------------------*/


/*--------------------------------------------------------------------------*\
|  Routine:  exc_get_variables
|
|  Description:
|     gets the specified (by a command parameter from the dialogue) variable
|     from the abstraction and places it into a transaction
\*--------------------------------------------------------------------------*/
void exc_get_variables (
	/* command, transaction */
		);
/*
command_sdd *command;
transaction_type transaction;
*/


/*--------------------------------------------------------------------------*\
|  Routine:  exc_add_variable
|
|  Description:
|     adds a newly created variable to the specified (by a command parameter
|       from the dialogue) vc and places it into a transaction
\*--------------------------------------------------------------------------*/
void exc_add_variable (
		/* command, transaction */
		);
/*
command_sdd *command;
transaction_type transaction;
*/


/*--------------------------------------------------------------------------*\
|  Routine:  exc_delete_variable
|
|  Description:
|     deletes the specified (by a command parameter from the dialogue) var and
|       places a remove sd request into the transaction
\*--------------------------------------------------------------------------*/
void exc_delete_variable (
	/* command, transaction */
		);
/*
command_sdd *command;
transaction_type transaction;
*/


/*--------------------------------------------------------------------------*\
|  Routine:  exc_copy_variable
|
|  Description:
|     generates a copy of the specified variable and adds it to the target vc
\*--------------------------------------------------------------------------*/
void exc_copy_variable (
	/* command, transaction */
		);
/*
command_sdd *command;
transaction_type transaction;
*/


/*--------------------------------------------------------------------------*\
|  Routine:  exc_move_variable
|
|  Description:
|     moves the specified variable to the specified vc
\*--------------------------------------------------------------------------*/
void exc_move_variable (
	/* command, transaction */
		);
/*
command_sdd *command;
transaction_type transaction;
*/


#endif

