/* $Header: /u/04c/mnt/integ/source/de/include/RCS/saw_defs.h,v 1.5 90/08/22 18:30:17 rcs Exp $ */
/*--------------------------------------------------------------------------*\
|   
|  Name:  saw_defs
|
|  Description:  
|     The saw_defs file contains an enumeration of the different object,
|     attributes and methods supported in the saw technology.  This file
|     should be included by both the application and the dialogue to 
|     ensure consistency between the layers.
|
|  Component of:
|     Dialoge Editor Dialogue.
|
|  Related files:
|     saw_defs.h - contains the external definition of the saw_defs 
|	abstraction. 
|
|  Project:
|     Serpent
|     User Interface Prototyping
|     Software Engineering Institute
|     Carnegie Mellon University
|     Pittsburgh, PA  15213
|
|  Version: 1.0
|
|  Project Leader:  
|     Len Bass
|     ljb@sei.cmu.edu
|
|  Author:  
|     Robert C. Seacord
|     rcs@sei.cmu.edu  
|
|  Change History:
|     $Log:	saw_defs.h,v $
 * Revision 1.5  90/08/22  18:30:17  rcs
 * *** empty log message ***
 * 
 * Revision 1.4  90/05/21  15:44:10  little
 * fix up for multiple includes & start mods for visu/struc editor integration
 * 
 * Revision 1.3  90/03/23  14:24:39  rcs
 * *** empty log message ***
 * 
 * Revision 1.2  90/03/01  10:59:27  rcs
 * added saw specific constants
 * 
 * Revision 1.1  89/11/29  09:57:31  trm
 * Initial revision
 * 
 * Revision 1.1  89/09/28  12:11:39  rcs
 * Initial revision
 * 
|     September 27, 1989: Module created.
|
\*--------------------------------------------------------------------------*\
|
|   Distribution: Approved for public release; distribution is unlimited.
|
|   Copyright (c) 1989  by  Carnegie  Mellon  University, Pittsburgh, PA.  The
|  Software Engineering  Institute  (SEI) is a federally  funded  research and
|  development center established  and  operated by Carnegie Mellon University
|  (CMU).  Sponsored  by  the  U.S.  Department  of   Defense  under  contract
|  F19628-85-C-0003,  the  SEI  is  supported  by  the  services  and  defense
|  agencies, with the U.S. Air Force as the executive contracting agent.
|
|    Permission to use,  copy,  modify, or  distribute  this  software and its
|  documentation for  any purpose and without fee  is hereby granted, provided
|  that  the above copyright notice appear  in  all copies and that both  that
|  copyright  notice  and   this  permission  notice  appear   in   supporting
|  documentation.   Further,  the  names  Software  Engineering  Institute  or
|  Carnegie  Mellon  University  may  not be used in  advertising or publicity
|  pertaining to distribution of the software without specific, written  prior
|  permission.  CMU makes no claims  or representations  about the suitability
|  of this software for any purpose.  This software is provided "as is" and no
|  warranty,  express  or  implied,  is  made  by  the  SEI  or CMU, as to the
|  accuracy  and  functioning of the program and related program material, nor
|  shall   the  fact of  distribution   constitute  any   such  warranty.   No
|  responsibility is assumed by the SEI or CMU in connection herewith.
|
\*--------------------------------------------------------------------------*/
/*
   The following are defines for object types supported by saw.
*/

#define undefined_object_type -1
#define arc_object_type 0
#define box_widget_type 1
#define canvas_widget_type 2
#define command_widget_type 3
#define dialog_widget_type 4
#define form_widget_type 5
#define group_object_type 6
#define label_widget_type 7
#define line_object_type 8
#define pixmap_object_type 9
#define point_type 10
#define polygon_object_type 11
#define rectangle_object_type 12
#define scrollbar_widget_type 13
#define shell_widget_type 14
#define text_object_type 15
#define viewport_widget_type 16
#define vpane_widget_type 17

/*
   The following are defines for saw object attributes.
*/

#define parent_attribute 0
#define label_text_attribute 1
#define x_attribute 2
#define y_attribute 3
#define width_attribute 4
#define height_attribute 5
#define foreground_color_attribute 6
#define background_color_attribute 7
#define border_width_attribute 8
#define border_color_attribute 9
#define vert_distance_attribute 10
#define from_vert_attribute 11
#define horiz_distance_attribute 12
#define from_horiz_attribute 13
#define sensitive_attribute 14
#define justify_attribute 15
#define internal_width_attribute 16
#define internal_height_attribute 17
#define min_height_attribute 18
#define max_height_attribute 19
#define skip_adjust_attribute 20
#define resizable_attribute 21
#define allow_resize_attribute 22
#define mapped_when_managed_attribute 23

/*
   The following constants are used to create enumerations 
   for defined values for various attributes.
*/
/* edit type attribute values */
#define READ 0
#define APPEND 1
#define EDIT 2

/* adjustment attribute values  */
#define LEFT   0
#define CENTER 1
#define RIGHT  2
