/* $Header: /u/04c/mnt/integ/source/de/src/RCS/de.sl,v 1.30 1991/07/05 22:22:55 dvk Exp $ */

/*--------------------------------------------------------------------------*\
|   
|  Name:  dialogue editor
|
|  Description:  
|     The dialogue editor abstraction actually implements the top level
|     of the structure editor.
|
|  Component of:
|     Dialoge Editor Dialogue.
|
|  Related files:
|     de.sl - contains the implementation of the structure editor.
|     de_obj.sl - contains the implementation of the objects of the
|	object portion of the structure editor.
|
|  Project:
|     Serpent
|     User Interface Prototyping
|     Software Engineering Institute
|     Carnegie Mellon University
|     Pittsburgh, PA  15213
|
|  Version: 1.0
|
|  Project Leader:  
|     Len Bass
|     ljb@sei.cmu.edu
|
|  Author:  
|     Robert C. Seacord
|     rcs@sei.cmu.edu  
|
|  Change History:
|     $Log: de.sl,v $
% Revision 1.30  1991/07/05  22:22:55  dvk
% Got technologieds list to disply properly (added idx shared data component)
%
% Revision 1.29  1991/05/17  21:11:14  rcs
% *** empty log message ***
%
% Revision 1.28  90/11/29  17:34:58  rcs
% *** empty log message ***
% 
% Revision 1.27  90/11/09  17:18:45  rcs
% *** empty log message ***
% 
% Revision 1.26  90/10/10  22:39:51  rcs
% new widget names
% 
% Revision 1.25  90/10/10  16:45:39  rm
% new sat names
% 
% Revision 1.24  90/10/09  22:05:27  rcs
% new sat attribute names & generic editor stuff
% 
% Revision 1.23  90/09/19  23:42:12  rcs
% fixed geo met tree
% 
% Revision 1.22  90/09/19  17:13:06  rm
% changed form width to 149
% 
% Revision 1.21  90/09/17  21:39:39  rcs
% *** empty log message ***
% 
% Revision 1.20  90/09/11  20:37:03  rcs
% *** empty log message ***
% 
% Revision 1.19  90/08/30  21:32:51  rcs
% *** empty log message ***
% 
% Revision 1.18  90/08/29  21:51:01  rcs
% *** empty log message ***
% 
% Revision 1.17  90/08/29  15:26:03  rcs
% *** empty log message ***
% 
% Revision 1.16  90/08/27  20:46:36  rcs
% *** empty log message ***
% 
% Revision 1.15  90/08/22  18:24:23  rcs
% *** empty log message ***
% 
% Revision 1.14  90/07/02  23:23:10  rcs
% *** empty log message ***
% 
% Revision 1.13  90/06/25  19:33:28  rcs
% *** empty log message ***
% 
% Revision 1.12  90/06/18  11:58:45  rcs
% update integ
% 
% Revision 1.11  90/05/10  12:51:56  rcs
% *** empty log message ***
% 
% Revision 1.10  90/03/14  08:59:28  rm
% not changed
% 
% Revision 1.9  90/01/24  17:22:12  trm
% no changes
% 
% Revision 1.8  90/01/17  16:54:34  trm
% removed some variables no longer used.
% also, moved where xxx.user_created components set.
% 
% Revision 1.7  90/01/09  14:45:25  trm
% basically, got rid of anything that 
% had to do with text_sdd. add the "text_template" 
% to be used instead. THis was to correct the 
% free-floating text_sdd that could cause 
% problems when "parent" vc's went away.
% 
% Revision 1.6  89/12/22  15:12:54  trm
% took out some local (for VCs) help variables
% and used the global (comments, initialization,
% and termination). 
% 
% Revision 1.4  89/12/14  08:11:55  trm
% some more integration adjustments.
% 
% Revision 1.3  89/12/08  17:18:36  trm
% no changes.
% 
% Revision 1.2  89/12/08  15:49:49  trm
% a lot of changes for everything. VCs, Objects, 
% dialogues, variables, attributes. etc...
% 
% Revision 1.1  89/11/29  09:35:39  trm
% Initial revision
% 
% Revision 1.4  89/10/13  10:56:59  trm
% added vcs, variables, and other stuff.
% 
% Revision 1.2  89/10/05  15:18:23  trm
% added various stuff for VCs.
% 
% Revision 1.1  89/09/28  12:59:58  rcs
% Initial revision
% 
|     September 27, 1989: Module created.
|
\*--------------------------------------------------------------------------*\
|
|   Distribution: Approved for public release; distribution is unlimited.
|
|   Copyright (c) 1989  by  Carnegie  Mellon  University, Pittsburgh, PA.  The
|  Software Engineering  Institute  (SEI) is a federally  funded  research and
|  development center established  and  operated by Carnegie Mellon University
|  (CMU).  Sponsored  by  the  U.S.  Department  of   Defense  under  contract
|  F19628-85-C-0003,  the  SEI  is  supported  by  the  services  and  defense
|  agencies, with the U.S. Air Force as the executive contracting agent.
|
|    Permission to use,  copy,  modify, or  distribute  this  software and its
|  documentation for  any purpose and without fee  is hereby granted, provided
|  that  the above copyright notice appear  in  all copies and that both  that
|  copyright  notice  and   this  permission  notice  appear   in   supporting
|  documentation.   Further,  the  names  Software  Engineering  Institute  or
|  Carnegie  Mellon  University  may  not be used in  advertising or publicity
|  pertaining to distribution of the software without specific, written  prior
|  permission.  CMU makes no claims  or representations  about the suitability
|  of this software for any purpose.  This software is provided "as is" and no
|  warranty,  express  or  implied,  is  made  by  the  SEI  or CMU, as to the
|  accuracy  and  functioning of the program and related program material, nor
|  shall   the  fact of  distribution   constitute  any   such  warranty.   No
|  responsibility is assumed by the SEI or CMU in connection herewith.
|
\*--------------------------------------------------------------------------*/
 
/*--------------------------------------------------------------------------*\
|  VC: display_dialogue_vc
|
|  Description:
|    Displays a dialogue record
\*--------------------------------------------------------------------------*/
   VC: display_dialogue_vc

    Creation condition: (new("dialogue_sdd"))

    Variables:
/*
   Various shared data ID variables - for VCs, variables, and objects.
*/
      vc_sd: NULL;
      vc_list_sd: NULL;
      object_list_sd: NULL;
      object_sd: NULL;
      var_list_sd: NULL;
      variable_sd: NULL;

/*
   Parent is the dialogue's ID.
*/
      parental_unit: dialogue_sdd;
/*
   The following variables are used to prevent menu items which
   create shared data elements from creating them more than once,
   until they're specifically cancelled.
*/
      prologue_displayed: false;
      includes_displayed: false;
      initialization_displayed: false;
      termination_displayed: false;
      macros_displayed: false;
      externs_displayed: false;
      sdd_displayed: false;

      dialogue_variables_displayed: false;
      dialogue_objects_displayed: false;
      dialogue_vcs_displayed: false;
      display_include_menu: false;

    Objects:

      dialogue_form: XawBboard {
        Attributes:
          parent: workspace;
          width: 151;
          height: 262;
          allowUserMove: true;
          horizDistance: x;
          vertDistance: y;
      }

      title_bar(
        dialogue_form_title, 
        dialogue_form,
        append_text_name(label,"Dialogue: ",dialogue_sdd.name),
        149
      )

/*
   SCOPE buttons: Add the NODE, SUBTREE  and TARGET buttons.
*/
      make_node_button(
        dialogue,dialogue_form,dialogue_sdd.name,dialogue_sdd,dialogue_sdd,
        DIALOGUE_TYPE,230,20 
      )

      make_subtree_button(
        dialogue,dialogue_form,dialogue_sdd.name,dialogue_sdd,dialogue_sdd,
        DIALOGUE_TYPE,230,50 
      )

      make_target_button(
        dialogue, 
        dialogue_form,
        dialogue_sdd.name,
        dialogue_sdd,
	DIALOGUE_TYPE,
        230,
	110 
      )

      menu_item(
        prolog_menu_item,
        dialogue_form,
        1,
        "Prologue",
        {
/*
   If the prologue for this dialogue is not already displayed, display it
   and set the the display flag to true.
*/
          if (NOT prologue_displayed) then
            prologue_displayed := true;
            message := "Enter prologue text.";
          end if;

        }
      )
 
      menu_item(
        macros_menu_item,
        dialogue_form,
        2,
        "Macros",
        {
/*
   If the macros for this dialogue are not already displayed, display
   it and set the display flag to true.
*/
          if (NOT macros_displayed) then
            macros_displayed := true;
            message := "Enter macro definitions";
          end if;
        }
      )

      menu_item(
        externs_menu_item,
        dialogue_form,
        3,
        "Externals",
        {
/*
   If the externs for this dialogue are not already displayed, display
   it and set the display flag to true.
*/
          if (NOT externs_displayed) then
            externs_displayed := true;
            message := "Enter externs definitions";
          end if;

        }
      )

      menu_item(
        include_menu_item,
        dialogue_form,
        4,
        "Includes",
        { 
/*
   Display the include menu if the technologies window is not displayed.
*/
          if (NOT includes_displayed) then
            includes_displayed := true;
            display_include_menu := true; 
            message := "";
          end if;
        }
      )
 
      menu_item(
        variables_menu_item,
        dialogue_form,
        5,
        "Variables",
        {
/*
   If the variables for this dialogue are not already displayed, 
   display them and set the the display flag to true.
*/
          if (NOT dialogue_variables_displayed) then

            dialogue_variables_displayed := true;
/*
   Allow for the creation of a new variable list.
*/
            var_list_sd := create_sd_instance("variable_list_sdd","DM_BOX");
/*
   var_list_sd.parent = dialogue_sdd; 
*/
            put_sd_value(var_list_sd,"parent",dialogue_sdd);
/*
   Ask application for any variables associated with this dialogue.
*/
	    make_command_and_parameter(
  	      selected_command,
	      parameter_list,
	      get_variables_cmd,
              dialogue_sdd 
            )
 
          endif;
        }
      )

      menu_item(
        initialization_menu_item,
        dialogue_form,
        6,
        "On Create",
        {
/*
   If the initialization for this dialogue is not already displayed, display
   it and set the display flag to true.
*/
          if (NOT initialization_displayed) then

            initialization_displayed := true;

            message := "Enter intialization actions.";

          end if;

        }
      )

      menu_item(
        termination_menu_item, 
        dialogue_form,
        7,
        "On Destroy",
        {
/*
   If the termination for this dialogue is not already displayed, display
   it and set the display flag to true.
*/
          if (NOT termination_displayed) then

            termination_displayed := true;

            message := "Enter termination actions.";

          end if;

        }
      )


      menu_item(
        objects_menu_item,
        dialogue_form,
        8,
        "Objects",
        {
/*
   If the objects for this dialogue are not already displayed,
   display them and set the the display flag to true.
*/
          if (NOT dialogue_objects_displayed) then

            dialogue_objects_displayed := true;
/*
   Allow for the creation of a new object list.
*/
            object_list_sd := create_sd_instance(
              "object_list_sdd","DM_BOX"
            );
/*
   object_list_sd.parent = dialogue_sdd; 
*/
            put_sd_value(object_list_sd,"parent",dialogue_sdd);
/*
   ask application for the objects associated with this dialogue. 
*/
            make_command_and_parameter(
              selected_command,
	      parameter_list,
              get_objects_cmd,
              dialogue_sdd 
            )

          end if;
        }
      )

      menu_item(
        vc_menu_item,
        dialogue_form,
        9,
        "View Controllers",
        {
/*
   If the vcs for this dialogue are not already displayed, 
   display them and set the the display flag to true.
*/
          if (NOT dialogue_vcs_displayed) then

            dialogue_vcs_displayed := true;
/*
   Allow for the creation of a new vc list.
*/
            vc_list_sd := create_sd_instance("vc_list_sdd","DM_BOX");
/*
   vc_list_sd.parent = dialogue_sdd; 
*/
            put_sd_value(vc_list_sd,"parent",dialogue_sdd);
/*
    Create a new command_sdd element to get the list of
    view controllers defined for this dialogue.
*/
	    make_command_and_parameter(
              selected_command,
              parameter_list,
	      get_subvcs_cmd,
              dialogue_sdd 
            )

         endif;

        }
      )
 
    On Create: {
/*
   ??? If multiple dialogues at once, probably can't use.
*/
      current_dialogue_sd := dialogue_sdd;
/*
    Set current dialogue file name and message.
*/
      if ((dialogue_sdd.name = UNDEFINED) OR (dialogue_sdd.name = "" )) then
        current_dialogue_filename := "Unnamed";
        message := "New dialogue";
      else
        current_dialogue_filename := dialogue_sdd.name;
        message := string_append(
          string_append("Dialogue ",current_dialogue_filename),
          " loaded."
        );
      endif;
/*
**  On create increment the x and y positions and assign to the corresponding
**  attributes in the dialogue form.
*/
      adjust_x_and_y_for_new_menu(x_position,y_position)

      dialogue_form.horizDistance := x_position;
      dialogue_form.vertDistance := y_position;
/*
**  Create the id table that is used in visualization.  One table
**  is being used across technologies so that all object instances
**  will be in the same name space.  
*/
      create_id_table();

    }						/* end actions on create    */
  
    On Destroy: {
/*
   Remove sub VCs, Objects, and Variables lists, if approriate.
*/
      if (object_list_sd <> NULL) then
        destroy_sd_instance(object_list_sd);
      end if;
      if (vc_list_sd <> NULL) then
        destroy_sd_instance(vc_list_sd);
      end if;
      if (var_list_sd <> NULL) then
        destroy_sd_instance(var_list_sd);
      end if;
/*
   Reset global variables for the single dialogue.
*/
      current_dialogue_sd := NULL;
      current_dialogue_filename := "";
/*
**  Destroy the id table.
*/
      destroy_id_table();

     }

/*
   The text buffers for all the dialogue stuff.
*/		
    text_template(			/* Prologue			    */
      prologue_displayed,
      "Prologue: ",
      dialogue_sdd.prologue,
      dialogue_sdd.name,
      prologue_help 
    );

    text_template(			/* Macros			    */
      macros_displayed,
      "Macros: ",
      dialogue_sdd.macros,
      dialogue_sdd.name,
      macros_help 
    );

    text_template(			/* Externs			    */
      externs_displayed,
      "Externals: ",
      dialogue_sdd.externs,
      dialogue_sdd.name,
      externs_help 
    );


    text_template(			/* Shared Data			    */
      sdd_displayed,
      "Shared Data: ",
      dialogue_sdd.shared_data,
      dialogue_sdd.name,
      sdd_help 
    );

    text_template(			/* On Create			    */
      initialization_displayed,
      "On Create: ",
      dialogue_sdd.initialization,
      dialogue_sdd.name,
      initialization_help
    );

    text_template(			/* On Destroy		    	    */
      termination_displayed,
      "On Destroy: ",
      dialogue_sdd.termination,
      dialogue_sdd.name,
      termination_help 
    );

/*------ Object editor component of the Structure Editor -------------------*/
 
#include "de_obj.sl"

/*--------------------------------------------------------------------------*\
|  VC: include_vc
|
|  Description:
|    Displays a menu which allows the user to include sdds, technologies,
|    functions, or add functions.
\*--------------------------------------------------------------------------*/

    VC: include_menu_vc

      Creation condition: (display_include_menu)

      Variables:

        parental_unit: dialogue_sdd;
        technology_list_sd: NULL;
        technology_sd: NULL;
        
      Objects:

        include_menu_form: XawBboard {
          Attributes:
            parent: workspace;
            width: 151;
            height: 142;
            allowUserMove: true;
            horizDistance: 500;
            vertDistance: 200;
#ifdef SMOT
            x: 500;
            y: 200;
#endif
        }

        title_bar(
          include_menu_form_title, 
          include_menu_form,
          append_text_name(label,"Includes: ",dialogue_sdd.name),
          149
        )

        menu_item(
          sdd_menu_item,
          include_menu_form,
          1,
          "Shared Data Definitions",
          {
/*
   If the shared data definitions for this dialogue are not already displayed,
    display them and set the display flag to true.
*/
            if (NOT sdd_displayed) then
              sdd_displayed := true;
              message := "Enter Shared Data definitions.";
            end if;

            includes_displayed := false;
            display_include_menu := false;
          }
        )

        menu_item(
          tech_menu_item,
          include_menu_form,
          2,
          "Technologies",
          { 
/*
   Allow for the creation of a technology list and save in 
   a local variable so we can get rid of it later.
*/
            technology_list_sd := create_sd_instance(
              "technology_list_sdd","DM_BOX" 
            );
/*
   technology_list_sd.parent = dialogue_sdd; 
*/
            put_sd_value(technology_list_sd,"parent",dialogue_sdd);
/*
    Create a new command_sdd element to get the list of technologies
    defined for this dialogue.
*/
            make_command_and_parameter(
	      selected_command,
	      parameter_list,
	      get_dialogue_technologies_cmd,
	      dialogue_sdd 
            )
/*
   Cause this menu to be removed from the display.
*/   
	      includes_displayed := false;
              display_include_menu := false;
          }
        )

        new_button(
          cancel_button,
          include_menu_form,
          50,
          2 * 20 + 40,
          "Cancel",
          {
	      includes_displayed := false;
              display_include_menu := false;
          }
        )

   end VC include_menu_vc

/*--------------------------------------------------------------------------*\
|  VC: technologies_vc
|
|  Description:
|    Allows the user to examine a list of technologies which have been 
|    integrated into serpent and registered with the editor and select
|    which technologies should be included with the current dialogue.
\*--------------------------------------------------------------------------*/
    VC: technologies_vc

      Creation condition:
        (new("technology_list_sdd") AND 
	         technology_list_sdd.parent = parental_unit)

#define technology_list_length 7

      Objects:

        technologies_form: XawBboard {
          Attributes:
            parent: workspace;
            width: 302;
            height: 82 + (20 * technology_list_length);
            allowUserMove: true;
            horizDistance: 500;
            vertDistance: 200;
#ifdef SMOT
            x: 500;
            y: 200;
#endif
        }

        title_bar(
          technologies_form_title, 
          technologies_form,
          append_text_name(label,"Technologies: ",dialogue_sdd.name),
          300
        ) 

        new_button(
          ok_button,
          technologies_form,
          70,
          50 + (20 * technology_list_length),
          "OK",
          {
            includes_displayed := false;
            destroy_sd_instance(technology_list_sdd);
          }
        )

        new_button(
          help_button,
          technologies_form,
          170,
          50 + (20 * technology_list_length),
          "Help",
          {
            technologies_help := true;
          }
        )

/*--------------------------------------------------------------------------*\
|  VC: technology_vc
|
|  Description:
|    Displays a selectable technology item.
\*--------------------------------------------------------------------------*/
      VC: technology_vc

        Creation condition:
          (
            (new("technology_sdd")) AND 
                (technology_sdd.parent = parental_unit )
          )

        Objects:

          select_item(
            technology,
            technologies_form,
            technology_sdd.idx,
            set_text_name(label,technology_sdd.long_name),
            technology_sdd.included,
            {

	printf("technology_sdd.idx = %d.\n",  technology_sdd.idx);
	      DEBUG3(	
	printf("technology_sdd.included = %s.\n",  technology_sdd.included);
	      )

		technology_sdd.included := NOT technology_sdd.included;

                DEBUG3(
	printf("technology_sdd.included = %s.\n",  technology_sdd.included);
		)
/*
   Set the technology to current status. The 1st parameter is the 
   dialogue id (parental_unit).
*/
	   	make_command_and_parameter(
                  selected_command,
                  parameter_list,
                  set_technology_cmd,
                  parental_unit 
                )
/*
   2nd parameter is (short) technology name.
*/
                make_another_parameter(
		  parameter_list,technology_sdd.short_name 
                )
/*
   3rd parameter is whether it's included or not.
*/
                DEBUG3(
	printf("technology_sdd.included = %s.\n",  technology_sdd.included);
		)

                make_another_parameter(parameter_list,technology_sdd.included)

	      	DEBUG3(
	printf("technology_sdd.included = %s.\n",  technology_sdd.included);
        printf("parm.value = %s.\n",  get_sd_value(parameter_list,"value"));
		)

      	      }
          ) 

        On Destroy: {
          destroy_sd_instance(technology_sdd);
	} 

      end VC technology_vc

    end VC technologies_vc

/*--------------------------------------------------------------------------*\
|  VC: vc_list_vc
|
|  Description:
|    Displays the lists of vc's defined at a certain level.  Instantiates
|    on new vc list shared data element.
\*--------------------------------------------------------------------------*/
    VC: vc_list_vc

      Creation condition: (new("vc_list_sdd"))

#define vc_list_length 7

      Variables:
        parental_unit: vc_list_sdd.parent;  /* PARENT == list's parent  */
	parent_name: get_sd_value(parental_unit,"name");

        destroy_vc_sdd: false;		/* Whether any vc_sdd's with this VC*/
					/*   as parent should be destroyed  */
					/*      when "Returning".	    */
      Objects:

        vcs_bboard: XawBboard {		/* vc form object	    */
          Attributes:
            parent: workspace;
            width: 151;
            height: 92 + (20 * vc_list_length); 
            allowUserMove: true;
        }			/* end VC form object			    */

        title_bar(
          vc_title, 
          vcs_bboard,
          append_text_name(label,"VC List: ",parent_name),
          149
        )

        vcs_viewport: XawViewport {
          Attributes:
            parent: vcs_bboard;
            vertDistance: 40;
            width: 146;
            height: 20 * vc_list_length;
            allowVert: true;
            useRight: true;
            borderColor: "white";
            managedWhenCreated: false;
	}

        vcs_box: XawBox {
          Attributes:
            parent: vcs_viewport;
            horizDistance: 0;
	}
/*
**  Menu item for "New" button.
*/
    insert_button(
      vc_menu_item,
      vcs_bboard,
      {
/*
**  Create a new command_sdd element to tell application we want a new VC.
*/
	make_command_and_parameter(
          selected_command,parameter_list,add_vc_cmd,parental_unit 
        )
      }
    )
/*
   The return button causes the list of vcs to be removed.
*/
        new_button(
          return_button,
          vcs_bboard,
          50,
          50 + (20 * vc_list_length),
          RETURN_BUTTON_TEXT,
          {
/*
   Check if this is Dialogue's VC or a VC's SUBVC list.  This is so 
   we can reset the appropriate parental_unit display variable.
   Also want to reset the vc_list_sd variable present in my parent.
*/

/*
   Dialogue was my parent.
*/
	    if (parental_unit = current_dialogue_sd ) then
                 dialogue_vcs_displayed := false;
                 vc_list_sd 		 := NULL;
	    else
/*
   A VC was my parent. 
*/
		 put_variable_value(
		     get_vc(parental_unit,"vc_button_vc"),
		  	 "vc_subvcs_displayed",false );
		 put_variable_value(
		     get_vc(parental_unit,"vc_button_vc"),
		  	 "vc_list_sd",NULL );
	    endif;
/*
   Also, set flag to indicate to enclosed vc_button_vc (vc_sdd) 
   that vc_sdd should also be destroyed since this is a "return"
   initiated by the user.
*/
	    destroy_vc_sdd := true;
/*
   Destroy the vc_list_sdd instance that caused this vc to be created.
*/
            destroy_sd_instance(vc_list_sdd);
            
          }
        )
/*
   On Create increment the x and y positions for the next object.
*/
      On Create: {

        adjust_x_and_y_for_new_menu(x_position,y_position)

        vcs_bboard.horizDistance := x_position;
        vcs_bboard.vertDistance := y_position;

      }
 
 
/*--------------------------------------------------------------------------*\
|  VC: vc_button_vc
|
|  Description:
|    For each new subvc that goes on this vc list add a button.
\*--------------------------------------------------------------------------*/
      VC: vc_button_vc

        Creation condition: 
          ((new("vc_sdd")) AND (vc_sdd.parent = parental_unit))

        Variables:
	  vc_variables_displayed: false;	/* Control VC lists         */
	  vc_objects_displayed: false;	/*   displays.	     	    */
	  vc_subvcs_displayed: false;
/*
**  Various shared data lists used by a VC.
*/
          vc_list_sd: NULL;
          var_list_sd: NULL;
          object_list_sd: NULL;

          display_vc: false;

          error_flag: false;	   /* Used by any set_error */
          error_sdi: NULL;

        Objects:

          fast_menu_entry(
            vc_menu_item,
            vcs_box,
            set_text_name(label,vc_sdd.name),
            vc_sdd.name,
            vc_sdd,
            vc_list_sdd.parent,         /* vc or dialogue */
            VC_TYPE,
            {
              display_vc := true;
	    }
          )

        On Create: {
/*
**  If this vc is result of an add_vc_cmd, then display it
**  right away. Then reset the user_created field.
*/
          if (vc_sdd.user_created = true) then
	    vc_sdd.user_created := false;
            display_vc := true;
          end if;
        }

        On Destroy: {
/*
   If the user caused this deletion (by "return" in the parent
   vc_list_vc), then destroy the shared data; else the shared
   data will be destroyed by the application.
*/
          if (destroy_vc_sdd) then
            destroy_sd_instance(vc_sdd);
	  endif;
	}

/*--------------------------------------------------------------------------*\
|  VC: vc_vc
|
|  Description:
|    Displays the components of a VC.
\*--------------------------------------------------------------------------*/
        VC: vc_vc

          Creation condition: (display_vc)

          Variables:
/*
   Various variables used to prevent multiple displays of
   textual components.
*/
            display_comments: false;
            display_creation_condition: false;
            display_on_create: false;
            display_on_destroy: false;

/*
   Used by textual components of VC.
*/
            send_flag: 0;
 
          Objects:

            vc_form: XawBboard {
              Attributes:
                parent: workspace;
                width: 151;		/* width + 2 * borderWidth	    */
                height: 262;
                allowUserMove: true;
            }

            editable_title_bar(
              vc_form_title, 
              vc_form,
              "VC: ",
              30,
              vc_sdd.name,
              120,
	      {
/*
** Update this VC's sdd name.
*/
	        vc_sdd.name := vc_form_title_text.textBuffer;
	        send_flag := 0;
	      }
            )
/*
   SCOPE buttons: Add the NODE, SUBTREE  and TARGET buttons.
*/
            make_node_button(
              vc_node,vc_form,vc_sdd.name,vc_sdd,vc_sdd.parent,VC_TYPE,230,20 
            )

            make_subtree_button(
              vc_subtree,vc_form,vc_sdd.name,vc_sdd,vc_sdd.parent,
	      VC_TYPE,230,50 
            )

            make_target_button(
              vc_target,vc_form,vc_sdd.name,vc_sdd,VC_TYPE,230,110
            )
/*
   All the menu items follow.
*/
            menu_item(
              comments_menu_item,
              vc_form,
              1,
              "Comments",
	      {
/*
   If the comments for this VC is not already displayed, display it
   and set the the display flag to true.
*/
                if (NOT display_comments) then
                  display_comments := true;
                  message := "Enter comments text.";
                end if;
              }


            )

            menu_item(
              cc_menu_item,
              vc_form,
              2,
              "Creation condition",
           {
/*
   If the Creation Conditions for this VC is not already displayed, display it
   and set the the display flag to true.
*/
          if (NOT display_creation_condition) then

            display_creation_condition := true;

            message := "Enter creation conditions text.";

          end if;
         }

            )

            menu_item(
              on_create_menu_item,
              vc_form,
              3,
              "On Create",
	      {
/*
   If the Creation Actions for this VC is not already displayed, display it
   and set the the display flag to true.
*/
                if (NOT display_on_create) then
                  display_on_create := true;
                  message := "Enter On Creation actions text.";
                end if;
              }

            )

            menu_item(
              on_destroy_menu_item,
              vc_form,
              4,
              "On Destroy",
              {
/*
   If the Destroy Actions for this VC is not already displayed, display it
   and set the the display flag to true.
*/
                if (NOT display_on_destroy) then 
                  display_on_destroy := true;
                  message := "Enter On Destroy actions text.";
                end if;
              }
            )


      menu_item(
        variables_menu_item,
        vc_form,
        5,
        "Variables",
        {
/*
   If the variables for this dialogue are not already displayed, 
   display them and set the the display flag to true.
*/
          if (NOT vc_variables_displayed) then

            vc_variables_displayed := true;
/*
   Allow for the creation of a new variable list.
*/
            var_list_sd := create_sd_instance(
	      "variable_list_sdd","DM_BOX"
            );
/*
   variable_list_sd.parent = vc_sdd; 
*/
            put_sd_value(var_list_sd,"parent",vc_sdd);
/*
   ask application for the variables associated with this VC. 
*/
	    make_command_and_parameter(
              selected_command,
              parameter_list,
	      get_variables_cmd,
	      vc_sdd 
            )
 
	  endif;
        }
      )

 
            menu_item(
              objects_menu_item,
              vc_form,
              6,
              "Objects",
              {
/*
   If the objects for this dialogue are not already displayed, 
   display them and set the the display flag to true.
*/
                if (NOT vc_objects_displayed) then

                    vc_objects_displayed := true;

/*
    Create an object_list_sd element to cause the list of objects 
    for this VC to be displayed.
*/
                    object_list_sd := create_sd_instance(
                        "object_list_sdd",
                           "DM_BOX" );
/*
   object_list_sd.parent = vc_sdd; 
*/
                    put_sd_value(object_list_sd,"parent",vc_sdd);
/*
   Ask application for the OBJECTS associated with this VC. 
*/
	            make_command_and_parameter(
		          selected_command,
		            parameter_list,
		              get_objects_cmd,
			          vc_sdd )
 	  endif;
	}
    )

 

            menu_item(
              subvcs_menu_item,
              vc_form,
              7,
              "Subview Controllers",
              {
/*
   If the objects for this dialogue are not already displayed, 
   display them and set the the display flag to true.
*/
           if (NOT vc_subvcs_displayed) then

                 vc_subvcs_displayed := true;

/*
   Allow for the creation of a new vc list and save in a local variable
   so we can get rid of it later.
*/
                  vc_list_sd := create_sd_instance("vc_list_sdd","DM_BOX");
/*
**  vc_list_sd.parent = vc_sdd; 
*/
                  put_sd_value(vc_list_sd,"parent",vc_sdd);
/*
**  Ask application for the Subview Controllers associated with this VC. 
*/
	          make_command_and_parameter(
		      selected_command,
		        parameter_list,
		          get_subvcs_cmd,
			     vc_sdd )

         endif;
       }
     )

 
     new_button(
       return_button,
       vc_form,
       50,
       50 + (20 * 7),
       RETURN_BUTTON_TEXT,
       {
/*
**  Reset parent's vc_button_vc display variables for use again.
*/
       	 vc_variables_displayed := false;
         vc_objects_displayed := false;
         vc_subvcs_displayed := false;
/*
**  And destroy this VC.
*/
         display_vc := false;
       }
     )
/*
**  On Create increment the x and y positions for the next object.
*/
          On Create: {

            adjust_x_and_y_for_new_menu(x_position,y_position)

            vc_form.horizDistance := x_position;
            vc_form.vertDistance := y_position;
 
	  }				/* end On Create 	    */
  
	  On Destroy: {
/*
**   Remove subvc VCs, Object, and Variable lists, if approriate.
*/
                    if (object_list_sd <> NULL) then
                      destroy_sd_instance(object_list_sd);
                    end if;
                    if (vc_list_sd <> NULL) then
                      destroy_sd_instance(vc_list_sd);
                    end if;
                    if (var_list_sd <> NULL) then
                      destroy_sd_instance(var_list_sd);
                    end if;
/*
   and reset parent's list variables.
*/
		    vc_list_sd := NULL;
		    object_list_sd := NULL;
		    var_list_sd := NULL;

	   }				/* end On Destroy	    */


/*
   The following macros instantiate VCs which enable the textual components
   of shared data elements to be input. These take the place of text_sdd
   which had been previously used.
*/

    text_template(			/* Comments			    */
      display_comments,
      "Comments: ",
      vc_sdd.comment,
      vc_sdd.name,
      comments_help 
    );

    text_template(			/* Creation Conditions		    */
      display_creation_condition,
      "Creation Conditions: ",
      vc_sdd.create_condition,
      vc_sdd.name,
      creation_conditions_help 
    );

    text_template(			/* On Creation actions		    */
      display_on_create,
      "On Creation actions: ",
      vc_sdd.create_action,
      vc_sdd.name,
      initialization_help 
    );


    text_template(			/* On Destroy actions		    */
      display_on_destroy,
      "On Destroy actions: ",
      vc_sdd.destroy_action,
      vc_sdd.name,
      termination_help 
    );

  end VC vc_vc				/* displays vc template		    */

 end VC vc_button_vc			/* created on new vc_sdd	    */

end VC vc_list_vc			/* created on new vc_list_sdd	    */

 

/*--------------------------------------------------------------------------*\
|  VC: variable_list_vc
|
|  Description:
|    Displays the lists of variables's defined at a certain level.  
|    Instantiates on new variable list shared data element.
\*--------------------------------------------------------------------------*/
    VC: variable_list_vc

      Creation condition: (new("variable_list_sdd"))

#define var_list_length 7

      Variables:
        parental_unit: variable_list_sdd.parent;
        parental_name: get_sd_value(parental_unit,"name");

/*
**  The following variable decides whether any var_sdd's with this
**  as parent should be destroyed when "Returning".
*/
        destroy_var_sdd: false;		


      Objects:

        variables_bboard: XawBboard {		/* var form object	    */
          Attributes:
            parent: workspace;
            width: 151;
            height: 92 + (20 * var_list_length); 
            allowUserMove: true;
        }			/* end VC form object			    */

        title_bar(
          var_title, 
          variables_bboard,
          append_text_name(label,"Variables: ",parental_name),
          149
        )

	variables_viewport: XawViewport {
          Attributes:
            parent: variables_bboard;
            vertDistance: 40;
            width: 146;
            height: 20 * var_list_length;
            allowvert: true;
            useright: true;
	    borderColor: "white";
            managedWhenCreated: false;
	 }

        variables_box: XawBox {
          Attributes:
            parent: variables_viewport;
            horizDistance: 0;
        }
/*
**  Menu item for "New" button.
*/
    insert_button(
      var_new_menu_item,
      variables_bboard,
      {
/*
**  Create a new command_sdd element to tell application we want a new VC.
*/
	make_command_and_parameter(
          selected_command,parameter_list,add_variable_cmd,parental_unit 
        )
      }
    )

/*
   The return button causes the list of variables to be removed.
*/
        new_button(
          return_button,
          variables_bboard,
          50,
          50 + (20 * var_list_length),
          RETURN_BUTTON_TEXT,
          {
/*
   Check if this is Dialogue's Variable or a VC's Variable list.
   This is so we can reset the appropriate parental_unit display variable.
   Also want to reset the var_list_sd variable present in my parent.
*/

/*
   Dialogue was my parent.
*/
	    if (parental_unit = current_dialogue_sd ) then
                 dialogue_variables_displayed := false;
                 var_list_sd := NULL;
	    else
/*
   A VC was my parent. 
*/
		 put_variable_value(
		     get_vc(parental_unit,"vc_button_vc"),
		  	 "vc_variables_displayed",false );
		 put_variable_value(
		     get_vc(parental_unit,"vc_button_vc"),
		  	 "var_list_sd",NULL );
	    endif;
/*
   Also, set flag to indicate to enclosed var_button_vc (variable_sdd) 
   that var_sdd should also be destroyed since it was user who picked
   the "return" button.
*/
	    destroy_var_sdd := true;
/*
   Destroy the variable_list_sdd instance that caused this vc to be created 
*/
            destroy_sd_instance(variable_list_sdd);
          }
        )

/*
   On Create increment the x and y positions for the next object.
*/
      On Create: {

        adjust_x_and_y_for_new_menu(x_position,y_position )

        variables_bboard.horizDistance := x_position;
        variables_bboard.vertDistance := y_position;

      }


/*--------------------------------------------------------------------------*\
|  VC: var_button_vc
|
|  Description:
|    For each new variable that goes on this variable list add a button.
\*--------------------------------------------------------------------------*/
      VC: var_button_vc

        Creation condition: 
          (new("variable_sdd") AND (variable_sdd.parent = parental_unit))

        Variables:
          display_variable: false;	/* Controls display of the variable */

        Objects:

          fast_menu_entry(
            var_menu_item,
            variables_box,
            set_text_name(label,variable_sdd.name),
            variable_sdd.name,
            variable_sdd,
            variable_list_sdd.parent,         /* vc or dialogue */
            VARIABLE_TYPE,
            {
              display_variable := true;
            }
          )

        On Create: {
/*
**  If this variable is result of an add_variable_cmd, then display it
**  right away. Then reset the user_created field.
*/
          if (variable_sdd.user_created = true) then
	    variable_sdd.user_created := false;
            display_variable := true;
          end if; 
        }

        On Destroy: {
/*
**  If the user caused this deletion (by "return" in the parent
**  var_list_vc), then destroy the shared data; else the shared
**  data will be destroyed by the application.
*/
          if (destroy_var_sdd ) then
            destroy_sd_instance(variable_sdd);
	  endif;
        }


/*--------------------------------------------------------------------------*\
|  VC: var_vc
|
|  Description:
|    Displays a Variable shared data or template.
\*--------------------------------------------------------------------------*/
        VC: var_vc

          Creation condition: (display_variable)

          Variables:

            send_flag: 0;		/* Used by text_sdd stuff 	    */
 	    error_sdi;			/* Used for error macro.	    */
	    error_flag: false;

          Objects:

      	    var_form: XawBboard {
               Attributes:
          	 parent: workspace;
          	 width: 410;
          	 height: 251;
          	 allowUserMove: true;
      	    }

            editable_title_bar(
              var_title,
              var_form,
              "Variable: ",
              10 * TITLE_FONT_WIDTH,
              variable_sdd.name,
              409 - (10 * TITLE_FONT_WIDTH),
	      {
/*
   Update this VAR's sdd name.
*/
	         variable_sdd.name := var_title_text.textBuffer;
	         send_flag := 0;
	       }
             )

            var_text: XawText {
               Attributes:
                 parent: var_form;
                 width: 400;
                 height: 168;
                 vertDistance: 23;
		 sendBuffer: 0;
                 textBuffer: variable_sdd.value;
               Methods:
                 send: {
/*
**  Return text buffer in specified location.
*/
                   variable_sdd.value := var_text.textBuffer;

/*            	   put_sd_value(variable_sdd,"value",textBuffer);  */
	  	   display_variable := false;
                 }
	    }

            button(
              ok_button,
              var_form,
              20,
              var_text,
              105,
              NULL,
              "OK",
              {
                var_text.sendBuffer := 1;
                var_title_text.sendBuffer := 1;
              }
            )

            button(
             cancel_button,
             var_form,
             20,
             var_text,
             175,
             NULL,
             "Cancel",
             {
	        display_variable := false;
             }
           )
/*
   The help_button provides help information for the specific 
   text window.  When selected, the help_button sets the variable
   specified in the text_sdd to true.  NOTE:  It is assumed this
   variable exists in the topmost layer of the dialogue.
*/
            button(
             help_button,
             var_form,
             20,
             var_text,
             245,
             NULL,
             "Help",
             {
               variables_help := true;
             }
           )

/*
**  SCOPE buttons: Add the NODE button. Variables can't be
**  either a TARGET or a SUBTREE.
*/
            make_node_button(
              var_node, 
              var_form,
              variable_sdd.name,
              variable_sdd,
              variable_list_sdd.parent,		/* vc or dialogue */
	      VARIABLE_TYPE,
              220,
	      40 
            )

         On Create: {
/*
   On Create increment the x and y positions for the next object.
*/
            adjust_x_and_y_for_new_menu(x_position,y_position)

            var_form.horizDistance := x_position;
            var_form.vertDistance := y_position;
          }

        end VC var_vc			/* displays variable template	    */

      end VC var_button_vc		/* created on new variable_sdd	    */

   end VC variable_list_vc		/* end variable_list_sdd	    */

/*----- Include the source code for the visualization tool -----------------*/
#include "ve.sl"

 end VC display_dialogue_vc		/* end display_dialogue_vc          */


