/* $Header: /usr/users/rcs/serpent/sun/de/src/RCS/de_obj.sl,v 1.30 1991/05/17 21:11:55 rcs Exp $ */
/*--------------------------------------------------------------------------*\
|   
|  Name:  Utilities (utils.sl)
|
|  Description:  
|     This file contains macros to implement various general utilites
|     in the editor dialogue including buttons and menus.
|
|  Component of:
|     Serpent editor dialogue layer.
|
|  Related files:
|     utils.sl - contains the slang source for slang utilities.
|
|  Project:
|     Serpent
|     User Interface Project
|     Software Engineering Institute
|     Carnegie Mellon University
|     Pittsburgh, PA  15213
|
|  Version: 1.0
|
|  Project Leader:  
|     Len Bass
|     ljb@sei.cmu.edu
|
|  Author:  
|     Robert C. Seacord
|     rcs@sei.cmu.edu  
|
|  Change History:
|	Feb. 24, 1989: Module created.
|	$Log: de_obj.sl,v $
% Revision 1.30  1991/05/17  21:11:55  rcs
% fast path source selection
%
% Revision 1.29  1991/04/23  18:00:10  ljb
% change some names so that there is no conflict with new gw.sl and
% its macros
%
% Revision 1.28  1991/03/13  07:12:57  rcs
% fix bugs
%
% Revision 1.27  90/11/29  17:35:20  rcs
% *** empty log message ***
% 
% Revision 1.26  90/11/09  17:19:08  rcs
% *** empty log message ***
% 
% Revision 1.25  90/10/30  15:59:25  rm
% changed to viewport widget
% 
% Revision 1.24  90/10/10  22:40:25  rcs
% new widget names
% 
% Revision 1.23  90/10/10  16:47:44  rm
% new sat names
% 
% Revision 1.22  90/10/09  22:07:52  rcs
% new sat attribute names & generic editor stuff
% 
% Revision 1.21  90/09/17  21:40:47  rcs
% *** empty log message ***
% 
% Revision 1.20  90/08/30  23:29:06  rcs
% *** empty log message ***
% 
% Revision 1.19  90/08/30  21:33:26  rcs
% *** empty log message ***
% 
% Revision 1.18  90/08/29  21:50:31  rcs
% *** empty log message ***
% 
% Revision 1.17  90/08/27  20:46:14  rcs
% *** empty log message ***
% 
% Revision 1.16  90/08/22  18:25:05  rcs
% *** empty log message ***
% 
% Revision 1.15  90/07/02  23:24:00  rcs
% *** empty log message ***
% 
% Revision 1.14  90/06/25  19:33:51  rcs
% *** empty log message ***
% 
% Revision 1.13  90/06/18  11:59:11  rcs
% *** empty log message ***
% 
% Revision 1.12  90/06/01  09:02:48  clc
% The last two changes didn't actually get saved with the checkin.
% Should work this time.
% 
% Revision 1.11  90/05/29  16:09:49  clc
% amended last fix by changing the creation conditions for object
% attributes to depend on the object_sdd, not the selected values.
% object_button's notify method returned to previous state.
% 
% Revision 1.10  90/05/29  15:29:24  clc
% Allowed the attributes of a selected object to appear
% by setting the technology and type appropriatly in the 
% object_button's notify method.
% 
% Revision 1.9  90/03/09  10:10:38  rm
% checked out by mistake
% 
% Revision 1.8  90/01/19  08:42:26  trm
% just added comments and cleaned up some unused variables.
% 
% Revision 1.7  90/01/09  14:57:28  trm
% Again, anything to do with text_sdd was 
% taken out. text_sdd was formerly used to
% input some textual information, but there
% was a problem since it was independent of
% the VC which created it.
% 
% Revision 1.6  89/12/22  15:15:01  trm
% nothing substantial.
% 
% Revision 1.5  89/12/20  15:02:22  trm
% addition of VCs to allow attribute and 
% method names (which are in text sdd) to
% change when their parent object's name
% changes. Also, some slight restructuring
% of VCs and addition of some CC's.
% 
% Revision 1.4  89/12/14  08:12:42  trm
% some more integration adjustments.
% 
% Revision 1.3  89/12/08  17:19:08  trm
% no changes.
% 
% Revision 1.2  89/12/08  16:06:34  trm
% A lot of changes that touched most everything.
% VCs, dialogues, objects, variables, etc..
% 
% Revision 1.1  89/11/29  09:36:36  trm
% Initial revision
% 
% Revision 1.3  89/10/13  10:58:55  trm
% some minor changes for objects.
% 
% Revision 1.2  89/10/05  15:48:41  trm
% added paging and attr_vc stuff.
% 
|
\*--------------------------------------------------------------------------*\
|
|   Distribution: Approved for public release; distribution is unlimited.
|
|   Copyright (c) 1989  by  Carnegie  Mellon  University, Pittsburgh, PA.  The
|  Software Engineering  Institute  (SEI) is a federally  funded  research and
|  development center established  and  operated by Carnegie Mellon University
|  (CMU).  Sponsored  by  the  U.S.  Department  of   Defense  under  contract
|  F19628-85-C-0003,  the  SEI  is  supported  by  the  services  and  defense
|  agencies, with the U.S. Air Force as the executive contracting agent.
|
|    Permission to use,  copy,  modify, or  distribute  this  software and its
|  documentation for  any purpose and without fee  is hereby granted, provided
|  that  the above copyright notice appear  in  all copies and that both  that
|  copyright  notice  and   this  permission  notice  appear   in   supporting
|  documentation.   Further,  the  names  Software  Engineering  Institute  or
|  Carnegie  Mellon  University  may  not be used in  advertising or publicity
|  pertaining to distribution of the software without specific, written  prior
|  permission.  CMU makes no claims  or representations  about the suitability
|  of this software for any purpose.  This software is provided "as is" and no
|  warranty,  express  or  implied,  is  made  by  the  SEI  or CMU, as to the
|  accuracy  and  functioning of the program and related program material, nor
|  shall   the  fact of  distribution   constitute  any   such  warranty.   No
|  responsibility is assumed by the SEI or CMU in connection herewith.
|
\*--------------------------------------------------------------------------*/

/*--------------------------- Constants ------------------------------------*/

#define  START_OF_ATTRIBUTES  1		/* Starting positions in object	    */
#define  START_OF_METHODS     9		/*   menu of attrs and methods	    */
  
/*--------------------------------------------------------------------------*\
|  Name: object_list_vc
|
|  Description:
|    Displays the lists of object defined for a given VC.  Instantiates
|    on new object list shared data element.
\*--------------------------------------------------------------------------*/
VC: object_list_vc

  Creation condition: (new("object_list_sdd"))

#define object_list_length 7

  Variables:
					/* Parent =list's parent.	    */
    parental_unit: object_list_sdd.parent;
    parent_name: get_sd_value(parental_unit,"name");
					/*    "NEW" button.		    */
    avail_tech_list_sd;			/* some variables used to save      */
    avail_tech_sd;			/*   shared data IDs.		    */
/*
**  Whether any object_sdd with this list as parent should be
**  should be destroyed when hitting RETURN_BUTTON_TEXT button.
*/
    destroy_object_sdd: false;

  Objects:

    objects_bboard: XawBboard {
      Attributes:
        parent: workspace;
        width: 151;
        height: 232;
        allowUserMove: true;
    }

    title_bar(	
      object_title, 
      objects_bboard,
      append_text_name(label,"Object List: ",parent_name),
      148
    )

    objects_viewport: XawViewport {
      Attributes:
        parent: objects_bboard;
        vertDistance: 40;
        horizDistance: 0;
        width: 146;
        height: 20 * object_list_length;
        allowvert: true;
        useright: true;
        borderColor: "white";
        managedWhenCreated: false;
    }
	
    objects_box: XawBox {
      Attributes:
        parent: objects_viewport;
        horizDistance: 0;
    }
/*
**  Menu item for "New" (ADD) button.
*/
    sensitive_insert_button(
      new_object_menu_item,
      objects_bboard,
      (toolbox_object_type <> UNDEFINED),
      {
/*
**  Create a new command_sdd element to tell application that we want
**  a new technology object.  
**       1st parameter is the parent name
**	 2nd parameter is selected technology's short name.
**	 3nd parameter is the name of the object (i.e. XawLabel)
*/
        make_command_and_parameter(
          selected_command,parameter_list,add_object_cmd,parental_unit 
        )
        make_another_parameter(parameter_list,toolbox_tech_type)
        make_another_parameter(parameter_list,toolbox_object_type)
/*
**  Send back to application to and ask for a specific object_sdd's
**  technology's accompanying attributes and methods.
**	1st parameter is "technology" name.
**	2nd parameter is object type (name).
*/
        make_command_and_parameter(
          selected_command,parameter_list,get_attributes_cmd,toolbox_tech_type
        )
        make_another_parameter(parameter_list,toolbox_object_type)
/*
**  Methods. Same as attributes.
*/
        make_command_and_parameter(
          selected_command,parameter_list,get_methods_cmd,toolbox_tech_type
        )
        make_another_parameter(parameter_list,toolbox_object_type)
      }
    )
/*
**  RETURN button resets some display and list variables, and causes
**  this VC to go away.
*/
    new_button(
      return_button,
      objects_bboard,
      50,
      50 + (20 * 7),
      RETURN_BUTTON_TEXT,
      {
/*
   Check if this is Dialogue's OBJ or a VC's OBJ list.  This is so
   we can reset the appropriate parental_unit display variable.
   Also want to reset the object_list_sd variable present in my parent
   so that this VC can be instantiated again by my parent.
*/

/*
   Dialogue was my parent.
*/
            if (parental_unit = current_dialogue_sd ) then
                 dialogue_objects_displayed := false;
                 object_list_sd := NULL;
            else
/*
   Else, a VC was my parent.
*/
                 put_variable_value(
                     get_vc(parental_unit,"vc_button_vc"),
                     "vc_objects_displayed",false 
                 );
                 put_variable_value(
                     get_vc(parental_unit,"vc_button_vc"),
                     "object_list_sd",NULL 
                 );
            endif;
/*
   Also, set flag to indicate to enclosed object_button_vc that
   object_sdd should also be destroyed since it's not caused by
   a "delete" operation. That is, a delete operation would cause
   the application to destroy the object. Otherwise, the dialogue
   in this case must destroy the object.
*/
            destroy_object_sdd := true;

/*
   Destory the object list shared data element that instantiated this VC.
*/
            destroy_sd_instance(object_list_sdd);
      }
    )

/*
**  On Create increment the x and y positions for the next object.
*/
  On Create: {

         adjust_x_and_y_for_new_menu(x_position,y_position)

         objects_bboard.horizDistance := x_position;
         objects_bboard.vertDistance := y_position;

  }						/* end actions on create    */

/*--------------------------------------------------------------------------*\
|  Name: object_button_vc
|
|  Description:
|    For each new object that goes on this object list add a button.
\*--------------------------------------------------------------------------*/
  VC: object_button_vc

    Creation condition: 
      ((new("object_sdd")) AND (object_sdd.parent = parental_unit))

    Variables:
      display_object: false;
      parent_object: object_sdd;

      error_sdi: NULL;	/* Used for errors sdd.		    */
      error_flag: false;
      object_type: object_sdd.type;
      object_tech: object_sdd.technology;
 
    Objects:

      fast_menu_entry(
        object_menu_item,
        objects_box,
        set_text_name(label,object_sdd.name),
        object_sdd.name,
        object_sdd,
        object_list_sdd.parent,         /* vc or dialogue */
        OBJECT_TYPE,
        {
/*
**  Send back to application to and ask for a specific object_sdd's
**  technology's accompanying attributes and methods.
** 	  1st parameter is "technology" name.
**	  2nd parameter is object type (i.e. XawLabel).
*/
          make_command_and_parameter(
            selected_command,parameter_list,get_attributes_cmd,
	    object_sdd.technology 
          )
          make_another_parameter(parameter_list,object_sdd.type)
/*
**  Methods. Same as attributes.
*/
           make_command_and_parameter(
             selected_command,parameter_list,get_methods_cmd,
	     object_sdd.technology 
	   )
           make_another_parameter(parameter_list,object_sdd.type)
/*
**  Display the object's attributes/methods form.
*/
           display_object := true;
        }
      )

    On Create: {

      DEBUG2(
        printf("object_button_vc: object type = %s.\n",object_sdd.type);
        printf("object_button_vc: object tech = %s.\n",object_sdd.technology);
      )
/*
**  If created with an "add_object_cmd", then it will automatically display.
**  But, also reset the user_created field so in future it doesn't 
**  automatically display.
*/
      if (object_sdd.user_created = true) then
        object_sdd.user_created := false;
	display_object := true;
      endif;
 
    }

    On Destroy: {
/* 
**  If the user requested this by parent vc_list "return" button,
**  then destroy the shared data; else the shared data will be 
**  destroyed by the application.
*/
      if (destroy_object_sdd) then
 	destroy_sd_instance(object_sdd);
      endif;

    }

/*--------------------------------------------------------------------------*\
|  Name: object_vc
|
|  Description:
|    Displays an object and all its associated attributes and methods.
\*--------------------------------------------------------------------------*/
    VC: object_vc

      Creation condition:  (display_object)

      Variables:
        object_list_sd: NULL;
        send_flag: 0;
 	temp_obj_type: string_append(object_sdd.type,": ");
	
      Objects:

        object_board: XawBboard {
          Attributes:
            parent: workspace;
            width: 222;
            height: 372;
            allowUserMove: true;
	}

        editable_title_bar(
          object_form_title, 
          object_board,
	  temp_obj_type,
          110,
          object_sdd.name,
          110,
	  {
/*
**  Update the object's sdd name and global name.
*/
             object_sdd.name := object_form_title_text.textBuffer;
	     send_flag := 0;
	  }
        )
/*
**  Add the NODE and TARGET buttons, objects don't need the SUBTREE button.
*/
        make_node_button(
          obj_node,
          object_board,
          object_sdd.name,
          object_sdd,
          object_list_sdd.parent,	/* vc or dialogue	*/
          OBJECT_TYPE,
          350,
          20 
        )
/*
**  Attributes area of form.
*/
	attr_label: XawLabel {
	  Attributes:
	    parent: object_board;
	    vertDistance: 20;
	    label: "Attributes:";
	    width: 220;
	    height: 18;
	    borderColor: "white";
	}

        attr_viewport: XawViewport {
          Attributes:
            parent: object_board;
            vertDistance: 40;
            horizDistance: 0;
            width: 218;
            height: 142;
            useright: true;
            allowvert: true;
            borderColor: "white";
            managedWhenCreated: false;
        }

        attr_box: XawBox {
          Attributes:
            parent: attr_viewport;
            horizDistance: 0;
        }
/*
**  Method area of form.
*/
	method_label: XawLabel {
	  Attributes:
	    parent: object_board;
	    vertDistance: START_OF_METHODS * 22;
	    label: "Methods:";
	    width: 220;
	    height: 18;
	    borderColor: "white";
	}

        method_viewport: XawViewport {
          Attributes:
            parent: object_board;
            vertDistance: (START_OF_METHODS + 1) * 22;
            width: 218;
            height: 80;
            useright: true;
            allowvert: true;
            borderColor: "white";
            managedWhenCreated: false;
        }

        method_box: XawBox {
          Attributes:
            parent: method_viewport;
            horizDistance: 0;
        }

        new_button(
          return_button,
          object_board,
          85,
          310,
          RETURN_BUTTON_TEXT,
          {
            display_object := false;
          }
        )
 
        On Create: {
/*
   On Create increment the x and y positions for the next object.
*/
            adjust_x_and_y_for_new_menu(x_position,y_position)

            object_board.horizDistance := x_position;
            object_board.vertDistance := y_position;
        }

/*--------------------------------------------------------------------------*\
|  VC: attr_type_vc
|
|  Description:
|    Displays ALL attributes associated with this TYPE of object.
\*--------------------------------------------------------------------------*/
      VC: attr_type_vc

      Creation condition: (
        new("attribute_type_sdd") AND
        (attribute_type_sdd.obj_type = object_type) AND
	(attribute_type_sdd.tech  = object_tech)
      )

          Variables:
		   attribute_type_name: attribute_type_sdd.name;
		   attr_type_menu_position: 1;
		   current_attr_type_page: 1;
		   display_attribute: false;
	     	   attr_value_sdi: NULL;
 
          Objects:

	   attr_type_item: XawCommand {
	     Attributes:
	       parent: attr_box;
	       label: set_text_name(label,attribute_type_sdd.name);
	       width: 193;
	       height: 18;
	       borderColor: "white";
	       horizDistance: 1;
 	       justify: LEFT;
	     Methods:
              notify: {
/*
**  Create a new command_sdd element to get the attribute requested
**  for this parent object.
*/
          	 make_command_and_parameter(
               	   selected_command,
                   parameter_list,
                   get_attribute_cmd,
       	           parent_object 
                 )
/*
   The second parameter is the attribute's name.
*/
       	        make_another_parameter(parameter_list,attribute_type_sdd.name)
/*
   Also set to display the attribute.
*/
		 display_attribute := true;
               }
             }
 
/*--------------------------------------------------------------------------*\
|  VC: attr_vc
|
|  Description:
|    Instantiates on display_attributes associated with above object.
\*--------------------------------------------------------------------------*/
      VC: attr_vc

          Creation condition:  (
            new("attribute_sdd") AND
            (attribute_sdd.parent = parent_object) AND 
	    (attribute_sdd.name = attribute_type_name) AND
	    display_attribute 
          )

    Variables: 
      save_changes: false;
      construction_area;

    Objects:

      display_attribute_text_form: XawBboard {
        Attributes:
          parent: workspace;
          width: 410;
          height: 251;
          allowUserMove: true;
          vertDistance: DISPLAY_HEIGHT / 2 - height / 2;
          horizDistance: DISPLAY_WIDTH / 2 - width / 2;
      }

      title_bar(
        text_title,
        display_attribute_text_form,
        construction_area,
        408
      )

      display_attribute_text: XawText {
        Attributes:
          parent: display_attribute_text_form;
          width: 400;
          height: 168;
          vertDistance: 23;

          textBuffer: attribute_sdd.value; 
        Methods:
          send: {
	      attribute_sdd.value := textBuffer;
              display_attribute := false;
          }
      }

      button(
        ok_button,
        display_attribute_text_form,
        20,
        display_attribute_text,
        105,
        NULL,
        "OK",
        {
          display_attribute_text.sendBuffer := 1;
          dialogue_changed := true;
          message := ""; 
        }
      )

       button(
        cancel_button,
        display_attribute_text_form,
        20,
        display_attribute_text,
        175,
        NULL,
        "Cancel",
        {
/* 
**  Set the displayed variable to false so this text can be selected again. 
*/
          display_attribute := false;
          message := ""; 
        }
      )

       button(
        help_button,
        display_attribute_text_form,
        20,
        display_attribute_text,
        245,
        NULL,
        "Help",
        {
          attribute_help := true;
          message := ""; 
        }
      )
 
          On Create: {
            message := "Enter attribute value.";

            if (
              (object_sdd.name = UNDEFINED) OR 
              (object_sdd.name = "" ) OR 
              (object_sdd.name = "Unnamed")
            ) then 
              construction_area := string_append("Attribute: ","Unnamed");
            else 
              construction_area := string_append(
                "Attribute: ",object_sdd.name
              );
            endif; 

            construction_area := string_append(construction_area, ".");
            construction_area := string_append(
              construction_area,attribute_sdd.name
            );

          }

          On Destroy: {
/* 
   If the display_attribute is still set, but the VC is going to be 
   destroyed, then give user a chance to save any changes.         
*/
            if (display_attribute) then 
              save_changes := true; 
            endif; 
          }

   end VC attr_vc

  end VC attr_type_vc

/*--------------------------------------------------------------------------*\
|  VC: method_type_vc
|
|  Description:
|    Displays all methods associated with this TYPE of object.
\*--------------------------------------------------------------------------*/
      VC: method_type_vc

        Creation condition: (
 	  new("method_type_sdd") AND
	  (method_type_sdd.obj_type = object_type) AND
	  (method_type_sdd.tech = object_tech)
        )

        Variables:
	  method_type_name: method_type_sdd.name;
	  method_type_menu_position: 1;
	  current_method_type_page: 1;
	  display_method: false;
	  method_action_sdi: NULL;
	
        Objects:

	  method_type_item: XawCommand {
	    Attributes:
	      parent: method_box;
	      label: set_text_name(label,method_type_sdd.name);
	      width: 193;
	       height: 18;
	      borderColor: "white";
	      horizDistance: 1;
 	      justify: LEFT;
	    Methods:
             notify: {
/*
   Create a new command_sdd element to get the attribute requested.
   The 1st parameter is the object which is the parent.
*/
          	 make_command_and_parameter(
             	   selected_command,
                   parameter_list,
                   get_method_cmd,
       	           parent_object)
/*
    The 2nd parameter is the method's name.
*/
          	 make_another_parameter(parameter_list,method_type_sdd.name)
/*
   Also set to display the method.
*/
		 display_method := true;
	       }
	    }

/*--------------------------------------------------------------------------*\
|  VC: method_vc
|
|  Description:
|    Displays methods associated with this object (if there)
\*--------------------------------------------------------------------------*/
      VC: method_vc

        Creation condition:  (
          new("method_sdd") AND 
	  (method_sdd.parent = parent_object) AND
	  (method_sdd.name = method_type_name) AND
	  display_method
        )

        Variables: 
          save_changes: false;
	  construction_area;

        Objects:

          display_method_text_form: XawBboard {
            Attributes:
              parent: workspace;
              width: 410;
              height: 251;
              allowUserMove: true;
              vertDistance: 200;
              horizDistance: 500;
          }

          title_bar(
            text_title,
            display_method_text_form,
    	    construction_area,
            408
          )

          display_method_text: XawText {
            Attributes:
              parent: display_method_text_form;
              width: 400;
              height: 168;
              vertDistance: 23;

              textBuffer: method_sdd.actions; 
            Methods:
              send: {
/*
   Return text buffer in specified location. 
*/
                method_sdd.actions := textBuffer;
/* 
   Set the displayed variable to false so this text can be selected again. 
*/
                display_method := false;
              }
          }

          button(
            ok_button,
            display_method_text_form,
            20,
            display_method_text,
            105,
            NULL,
            "OK",
            {
              display_method_text.sendBuffer := 1;
              dialogue_changed := true;
              message := ""; 
            }
          )

          button(
            cancel_button,
            display_method_text_form,
            20,
            display_method_text,
            175,
            NULL,
            "Cancel",
            {
              display_method := false;
              message := ""; 
            }
          )

          button(
            help_button,
            display_method_text_form,
            20,
            display_method_text,
            245,
            NULL,
            "Help",
            {
              method_help := true;
              message := ""; 
            }
          )

          On Create: {
            message := "Enter method actions";

            if (
              (object_sdd.name = UNDEFINED) OR 
              (object_sdd.name = "" ) OR 
              (object_sdd.name = "Unnamed")
            ) then 
              construction_area := string_append("Method: ","Unnamed");
            else 
              construction_area := string_append(
                "Method: ",object_sdd.name
              );
            endif; 

            construction_area := string_append(construction_area, " ");
            construction_area := string_append(
              construction_area,method_sdd.name
            );

          }

         On Destroy: {
/* 
   If the display_method is still set, but the VC is going to be 
   destroyed, then give user a chance to save any changes.         
*/
           if (display_method) then 
             save_changes := true; 
          end if; 
         }
 
        end VC method_vc	/* edit actual method			    */

      end VC method_type_vc     /* fills out buttons on object form	    */
 
    end VC object_vc		/* displays base form for an object         */
 
  end VC object_button_vc	/* displays a button for each object	    */
 
end VC object_list_vc		/* displays a form for each object list     */
