/* $Header: /usr/users/rcs/serpent/source/de/src/RCS/ded.sl,v 1.57 1991/06/19 20:02:30 rcs Exp $ */

#define SAW
/* #define COLOR	*/
/* #define NDEBUG	*/
 
#include "se.ill"		/* application shared data	*/
#include "de.ill"		/* dialogue manager shared data	*/

#include "sat.ill"		/* athena widgets		*/
#include "smo.ill"		/* motif widgets		*/

|||

/*--------------------------------------------------------------------------*\
|   
|  Name:  Serpent Editor (ded)
|
|  Description:  
|     This is the topmost component for the dialogue editor dialogue.
|     It provides the environment and system level menus in which the
|     dialogue editor and visualization tool live.
|
|  Component of:
|     Serpent editor dialogue layer.
|
|  Related files:
|     ded.sl - contains the slang source for the serpent editor.
|
|  Project:
|     Serpent
|     User Interface Project
|     Software Engineering Institute
|     Carnegie Mellon University
|     Pittsburgh, PA  15213
|
|  Version: 1.0
|
|  Project Leader:  
|     Len Bass
|     ljb@sei.cmu.edu
|
|  Author:  
|     Robert C. Seacord
|     rcs@sei.cmu.edu  
|
|  Change History:
|	Feb. 24, 1989 : Module created.
|	$Log: ded.sl,v $
% Revision 1.57  1991/06/19  20:02:30  rcs
% not sure why i had this checked out
%
% Revision 1.56  1991/05/22  19:58:40  ejh
% made inclusion of smo.ill conditional on having motif
%
% Revision 1.55  1991/05/17  21:13:07  rcs
% *** empty log message ***
%
% Revision 1.54  1991/04/26  15:50:36  rcs
% no change
%
% Revision 1.53  1991/04/11  18:05:25  rcs
% *** empty log message ***
%
% Revision 1.52  91/03/19  19:55:51  rcs
% new variables and stuff
% 
% Revision 1.51  91/03/13  07:13:28  rcs
% modified global vars
% 
% Revision 1.50  91/02/01  16:33:40  mpottier
% tried to shrink menu bar...
% 
% Revision 1.49  91/02/01  14:44:26  mpottier
% REMOVED OLD MENU STRUCTURES
% 
% Revision 1.48  91/01/31  10:39:12  rm
% no change
% 
% Revision 1.47  90/11/29  17:36:01  rcs
% *** empty log message ***
% 
% Revision 1.46  90/11/13  14:25:36  rcs
% new motif names
% 
% Revision 1.45  90/11/09  17:19:42  rcs
% *** empty log message ***
% 
% Revision 1.44  90/10/10  22:40:43  rcs
% new widget names
% 
% 
% Revision 1.43  90/10/09  22:09:51  rcs
% new sat attribute names & generic editor stuff
% 
% Revision 1.42  90/10/04  20:06:59  rcs
% changed include structure
% 
% Revision 1.41  90/10/04  19:51:01  clc
% Added the variables widthgrid and heightgrid.
% 
% Revision 1.40  90/09/25  21:37:05  rcs
% fixed staging problem
% 
% Revision 1.38  90/09/21  10:16:15  rcs
% added external hashing function
% 
% Revision 1.37  90/09/19  23:36:22  rcs
% fixed geometry
% 
% Revision 1.36  90/09/19  17:10:43  rm
% sorry
% 
% Revision 1.35  90/09/19  17:06:29  rm
% changed system_menu width to 20 from 22
% 
% Revision 1.33  90/08/29  21:51:27  rcs
% ls *sl
% 
% Revision 1.27  90/06/25  13:07:39  rcs
% added include for help_menu
% 
% Revision 1.25  90/05/25  10:37:58  rm
% added variable define for no_menus_down
% 
% Revision 1.20  90/01/24  17:19:10  trm
% took out some debug stuff.
% 
% Revision 1.19  90/01/17  16:59:53  trm
% 1. added some attribute_help variables and menu items
% 2. commented out text_sdd VC
% 3. changed some text or label attributes to not contain a '\'.
% 
% Revision 1.18  90/01/09  16:42:03  trm
% changed includes back.
% 
% Revision 1.17  90/01/09  16:39:48  trm
% temporarily added  "test_text.sl" to work
% around a compile problem.
% 
% Revision 1.16  90/01/09  14:26:16  trm
% took out "ADD" menu item and added "load_filename" variable.
% also removed the temporary additions of the help_templates.
% put the "help2.sl" back in.
% 
% Revision 1.15  90/01/05  07:13:09  trm
% Includes again. my fault.
% 
% Revision 1.14  90/01/04  17:59:35  dvk
% In all slang/sdd files as a result of lexer/parser changes: 1) Changed
% all instances of "else if" to "elsif".  2) Changed variables named "create"
% to "create_it" or "create_btn" as needed ("create" is now a reserved word).
% 
% Revision 1.13  90/01/04  16:10:41  trm
% added a bunch of help_templates (which will eventually
% go into help.sl).
% 
% Revision 1.12  90/01/02  02:17:27  trm
% no changes. 
% 
% Revision 1.11  89/12/26  15:35:33  ejh
% fixed includes
% 
% Revision 1.10  89/12/22  15:10:19  trm
% fixed status_status and added a lot 
% of help stuff.
% 
% Revision 1.9  89/12/22  07:50:10  trm
% fixed export command.
% 
% Revision 1.8  89/12/20  14:55:16  trm
% very minor changes; comments; etc..
% 
% Revision 1.7  89/12/18  11:16:20  trm
% really fixed includes this time.
% 
% Revision 1.6  89/12/14  11:44:49  trm
% put where includes found back to original form.
% 
% Revision 1.5  89/12/14  08:10:48  trm
% some more integration adjustments.
% 
% Revision 1.4  89/12/08  17:17:19  trm
% changed send methods in Load, Save.. import and export.
% 
% Revision 1.3  89/12/08  16:11:05  trm
% A lot of changes that touched about everyting.
% 
% Revision 1.2  89/12/01  14:22:43  trm
% some minor, inconsequential changes.
% 
% Revision 1.1  89/11/30  10:44:58  trm
% Initial revision
% 
% Revision 1.1  89/11/29  09:33:22  trm
% Initial revision
% 
% Revision 1.2  89/10/13  11:01:36  trm
% changes for VCs, variables, and objects. Mainly
% for the imminent testing with the application.
% 
|	Revision 1.6  89/08/22  13:17:12  rcs
|	modified to work with se.ill
|	added message area
|
|	Revision 1.5  89/08/03  17:32:22  rcs
|	changed the way function defs work, for one thing
|
|	Revision 1.4  89/07/18  09:52:53  rcc
|	changed stuff here too
|
|	Revision 1.3  89/06/21  15:14:12  rcs
|	integrated with visulalize.slang and new macros
|
\*--------------------------------------------------------------------------*\
|
|   Distribution: Approved for public release; distribution is unlimited.
|
|   Copyright (c) 1989  by  Carnegie  Mellon  University, Pittsburgh, PA.  The
|  Software Engineering  Institute  (SEI) is a federally  funded  research and
|  development center established  and  operated by Carnegie Mellon University
|  (CMU).  Sponsored  by  the  U.S.  Department  of   Defense  under  contract
|  F19628-85-C-0003,  the  SEI  is  supported  by  the  services  and  defense
|  agencies, with the U.S. Air Force as the executive contracting agent.
|
|    Permission to use,  copy,  modify, or  distribute  this  software and its
|  documentation for  any purpose and without fee  is hereby granted, provided
|  that  the above copyright notice appear  in  all copies and that both  that
|  copyright  notice  and   this  permission  notice  appear   in   supporting
|  documentation.   Further,  the  names  Software  Engineering  Institute  or
|  Carnegie  Mellon  University  may  not be used in  advertising or publicity
|  pertaining to distribution of the software without specific, written  prior
|  permission.  CMU makes no claims  or representations  about the suitability
|  of this software for any purpose.  This software is provided "as is" and no
|  warranty,  express  or  implied,  is  made  by  the  SEI  or CMU, as to the
|  accuracy  and  functioning of the program and related program material, nor
|  shall   the  fact of  distribution   constitute  any   such  warranty.   No
|  responsibility is assumed by the SEI or CMU in connection herewith.
|
\*--------------------------------------------------------------------------*/

/*------------------- constants --------------------------------------------*/

#define DEBUG1(statement) SERPENT_DEBUG1(se_debug, statement)
#define DEBUG2(statement) SERPENT_DEBUG2(se_debug, statement)
#define DEBUG3(statement) SERPENT_DEBUG3(se_debug, statement)

#define C_NULL 0
#define RETURN_BUTTON_TEXT "Exit"

/* Font attributes */
#define  TITLE_FONT_WIDTH 7 
#define  FONT_WIDTH       6
#define  FONT_HEIGHT      15


/* Display and Attribute value constants. */
#ifdef mc68000
#define DISPLAY_WIDTH         1136
#define DISPLAY_HEIGHT        866
#else
#define DISPLAY_WIDTH         950
#define DISPLAY_HEIGHT        800
#endif

/*  the first number is multiplied by a factor, then summed with 10 */
#define ATTR_HEIGHT           25 + 10
 
/* x-y coordinates are adjusted this amount each time. */
#define X_ADJUSTMENT          20
#define Y_ADJUSTMENT          20

 
/* The Origin of the Forms - by Les Char Windar */
#define START_X_POSITION      20
#define START_Y_POSITION      45
 
/*
   The maximum (from lower right or upper right) position 
   that a form will move to before subsequent forms reverse
   direction. See also:  adjust_x_and_y_for_new_menu macro.
*/
#define MAX_POSITION          100

/*
   Types of things that exist to be targets or sources.
   Not all combinations are valid tho'.  That is, you
   can't copy a VC to a VARIABLE. See edit.sl for 
   details.
*/
#define DIALOGUE_TYPE   0
#define VC_TYPE         1
#define OBJECT_TYPE     2
#define VARIABLE_TYPE   3
#define ATTRIBUTE_TYPE  4
#define METHOD_TYPE     5
#define OBJECT_INSTANCE_TYPE 6

/* To check Save and Load filename length */
#define MAX_FILE_NAME_LENGTH 32
 
/*  New function names	*/
#define record recording_on

/*------------------- includes ---------------------------------------------*/

#include "data_types.h"
#include "cmd_defs.h"
#include "saw_defs.h"
#include "ist.h"

#ifdef SAW
#include "utils.sl"
#include "utils2.sl"
#include "ve_macros.sl"
#endif

/*------------------- externals --------------------------------------------*/

  Externals:

    void system(string);
    string getenv(string);

#include "arith.ext"
#include "sstring.ext"
#include "alist.ext"
#include "sstdio.ext"

#include "eit.ext"
/* 
   The following externals support the font selector.
*/
    integer howmany_of(integer);
    string fetch_val(integer,integer);
    boolean font_exists(string,string,string,string);
    integer int_max(integer,integer);
    string font_str(string,string,string,string);
/*
**  External bindings for the glue interface.
*/

#include "gif.ext"
#define glue_get_object_abbr glue_get_userdef 
 
  Objects:

    display: screenObject { }

  On Create: {				/* actions on create		    */
    recording_on("dr", "dialogue recording");
  }					/* end actions on create	    */

  VC:  top_level

  Creation Condition: (display.width <> UNDEFINED)

/*------------------- variables --------------------------------------------*/

  Variables:
/*
**  Include debug variables.
*/

#include "debug.sl"

    current_dialogue_sd: NULL;  /* shared data for the "current" dlg        */
    current_dialogue_filename: ""; /* shared data for the "current" dlg     */
    dialogue_changed : false;	/* has current dialogue been changed at all */
/*
**  Error stuff.
*/
    error_id;			/* used to save the id of an error_sd      */
    error_flag: false;		/* used by set_error              */
    error_name;			/* name of object associated with error     */
    error_sdi: NULL;

    prototype: true;		/* ??? temp fix	*/
/*
**  Color values based on display.color.
*/
    normal_foreground_color: set_color(normal_foreground,"blue","black");
    normal_background_color: set_color(normal_background,"white","white");

    help_foreground_color: set_color(help_foreground,"blue","black");
    help_background_color: set_color(help_background,"white","white");

    selected_foreground_color: set_color(selected_foreground,"white","white");
    selected_background_color: set_color(selected_background,"blue","black");

    hilite_foreground_color: set_color(hilite_foreground,"blue","black");
    hilite_background_color: set_color(hilite_background,"white","white");

    error_foreground_color: set_color(error_foreground,"white","black");
    error_background_color: set_color(error_background,"red","white");
    error_border_color: set_color(error_border,"yellow","black");
/*
** Athena hard coded variables that shouldn't be.
*/
    athena_prototype: false;	/* if the prototyper is on or off           */
    athena_toolkit: false;	/* if the toolkit is on or off              */
    athena_toolbox_id;		/* shared data used to instantiate toolbox */
    athena_id;
    sat_handle;			/* sat glue technology handle		    */
/*
**  Motif hard coded variables that shouldn't be.
*/
    motif_prototype: false;	/* if the prototyper is on or off           */
    motif_toolkit: false;	/* if the toolkit is on or off           */
    motif_toolbox_id;		/* shared data used to instantiate toolbox */
    motif_id;
    smo_handle;			/* smo glue technology handle		    */

    grid_snap: false;           /* grid snap on or off                      */
    xgrid: 10;                  /* interval to snap for x      */
    ygrid: 10;                  /* interval to snap for y      */
    widthgrid: 10;              /* interval to snap for width  */
    heightgrid: 10;             /* interval to snap for height */

    message: "";		/* used to display message in message       */
				/*   bar area.				    */
    draw_command: false;	/* true if a draw command selected	    */
    selected_command;		/* currently selected command		    */
    parameter_list;  		/* currently selected command's first       */
    parameter_sdi;   		/*   and subsequent parameter sdds          */
    temp_id: NULL;		/* temporary variable to hold ids in        */
    command_id;			/* used to save the id of a command	    */
    parm_id;			/* used to save the id of a parameter	    */

    positive_Y_direction : true;/* Initial direction of menu positions      */
				/*    is down and to right.                 */

    send_flag : 0;		/* Used by XawTexts          	    */

				/* Used to save the filename entered in     */
    save_filename        : "";  /*   either "Save", "Save As..", "Load" or  */
    save_export_filename : "";  /*     "Export" in case there's a problem.  */
    load_filename 	 : "";  /*       Only save_filename used currently. */
/*
**  Visualization variables.
*/
    edit_attr_form_not_displayed: true;
    next_id;                    /* holds forward pointer for children list */
    previous_id;                /* holds forward pointer for children list */
    current_id;                 /* holds current node id        */
    object_instance_sdi;        /* id for object instance       */
    flip_flop_flag: true;       /* used to flip flop between build vcs used
                                for reparenting */
    toolbox_object;
/*
**  Help menus.
*/
    commands_help_menu: false;
    slang_constructs_help_menu: false;
    athena_objects_help_menu: false;
    motif_objects_help_menu: false;
    draw_commands_help_menu: false;
    exit_commands_help_menu: false;
/*
**  Command information.
*/
    command_type;			/* used internally by menus*/
    current_command_name;		/* string for current command name */
    subtree: false;
    source_name;			/* source thingee name	*/
    target_name;			/* target thingee name	*/
    source_id: NULL;			/* id of source thingee sdd	*/
    source_vc_id: NULL;			/* id of vc source thingee in	*/
    target_id: NULL;			/* id of target thingee sdd     */
    source_type;			/* vc, var, obj, etc.	*/
    target_type;			/* hopefully a vc	*/

    source_mailbox;			/* mailbox name		*/
    source_tech_type: "";		/* sat, smo, etc.	*/
    source_object_type: "";		/* cw, fw, lw, tw, etc.	*/
/*
**  Command information associated with the toolbox.
*/
    toolbox_mailbox;			/* mailbox name 	*/
    toolbox_tech_type;			/* sat, smo, etc.       */
    toolbox_object_type: UNDEFINED;	/* cw, fw, lw, tw, etc.	*/
/* 
**  Used to enable file name entry for LOAD or SAVE or SAVE AS..
*/
    display_get_file_name_form      : false;
    display_get_load_file_name_form : false;
/*
   Used to remind user that the quit or exit might
   require a save first.
*/
    display_are_you_sure: false;
    display_confirm_quit: false;
    display_confirm_exit: false;
/*
   Command forms.
*/
    display_export_menu     : false;
    display_import_menu     : false;
    display_run_form : false;
    set_grid_snap_values: false;
/*
   Current x and y position of language component forms.  These variables
   are incremented by 20 for each displayed form, mod the screen size in 
*/
    x_position: START_X_POSITION;
    y_position: START_Y_POSITION;

    display_about_serpent: false;  /* used to display 'about' information */

/*------------ Help Flags --------------------------------------------------*/

#include "help_vars.sl"
 
/*--------------------------- Objects start here ---------------------------*/

   Objects:
/*
**  Where all the menus are parented.
*/
    se_shell: XawTopLevelShell {
      Attributes:
        iconname: "Serpent";
        iconpixmap: "se_bitmap";
	title: "Serpent Editor";
    }

    workspace: XawBboard {
      Attributes:
        parent:  se_shell;
        width: display.width - 25;
        height: display.height - 45;
        borderColor: "white";
#ifdef SMOT
        resizePolicy: false;
#endif
    }

/*----------------------------- Message Bar --------------------------------*/

system_menu_form : XawBboard {
    Attributes:
        parent          : workspace;
        width           : display.width-25;
        vertDistance    : 0;
        horizDistance   : 0;
        height          : 12;
        background      : "black";
}

/*
    Label for status area.
*/
    message_bar_label: XawLabel {
      Attributes:
        parent: system_menu_form;
        borderWidth: 0;
        background: "black";
        foreground: "white";
        height: 20;
        label: "Status:";
        width: 50;
        x: 420;
#ifdef SAW
        vertDistance: 3;
        horizDistance: 420;
#endif
        justify: LEFT;
    }
/*
   Current status.
*/
    message_text: XawLabel {
      Attributes:
        parent: system_menu_form;
        borderWidth: 0;
        background: "black";
        foreground: "white";
        width: display.width - 505;
        height: 20;
        label: message;
        x: 480;
#ifdef SAW
        vertDistance: 3;
        horizDistance: 480;
#endif
        justify: LEFT;
    }

#include "menus.sl"

/*--------------------------------------------------------------------------*\
|  Name: display_error_vc
|
|  Description:
|    Generalized view controller to display error information.
\*--------------------------------------------------------------------------*/
  VC: display_error_vc

    Creation condition: (new("error_sdd"))

    Objects:

      error_shell: XawTopLevelShell {
        Attributes:
          iconname: "Error";
          iconpixmap: "se_bitmap";
          title: string_append("Error: ", error_sdd.title);
      }

      error_form: XawBboard {
        Attributes:
          parent: error_shell;
          background: error_background_color;
          width: 410;
          height: error_sdd.height * 20 + 80;
      }

      error_text: XawText {
        Attributes:
          parent: error_form;
          borderColor: "white";
          background: error_background_color;
          foreground: error_foreground_color;
          width: 350;
          height: error_sdd.height * 20;
#ifdef SAW
          vertDistance: 10;
          horizDistance: 25;
#endif
          textBuffer: error_sdd.message;
	  editType: READ;
      }

      error_button(
        ok_button,
        error_form,
        180,
        error_sdd.height * FONT_HEIGHT + 25,
        "OK",
        {
/*
**  Destroy the shared data that caused this VC to be instantiated.
*/
          destroy_sd_instance(error_sdd);          
        }
      )

  end VC display_error_vc

/*--------------------------------------------------------------------------*\
|  Name: display_help_vc
|
|  Description:
|    Generalized view controller for displaying help information contained
|    in a help shared data record.
\*--------------------------------------------------------------------------*/
  VC: display_help_vc

    Creation condition: (new("help_sdd"))

    Objects:

      help_shell: XawTopLevelShell {
        Attributes:
          iconname: "Help Dialogue";
          iconpixmap: "se_bitmap";
          title: "Help Dialogue";
      }

      help_form: XawBboard {
        Attributes:
          parent: help_shell;
          background: help_background_color;
          width: 410;
          height: help_sdd.height * 20 + 100;
      }

      title_bar(
        help_title,
        help_form,
        string_append("Error: ", help_sdd.title),
        408
      )

      help_text: XawText {
        Attributes:
          parent: help_form;
          borderColor: "white";
          background: help_background_color;
          foreground: help_foreground_color;
          width: 350;
          height: help_sdd.height * 20;
#ifdef SAW
          vertDistance: 30;
          horizDistance: 25;
#endif
          textBuffer: help_sdd.message;
	  editType: READ;
      }

      new_button(
        ok_button,
        help_form,
        180,
        help_sdd.height * FONT_HEIGHT + 55,
        "OK",
        {
/*
**  Destroy the shared data that caused this VC to be instantiated.
*/
          destroy_sd_instance(help_sdd);          
        }
      )

  end VC display_help_vc
 
/*----- Include the source code for the dialogue editor --------------------*/
#include "de.sl"

/*----- Include source code for about Serpent ------------------------------*/
#include "about.sl"

/*----- Include the source code for the help displays ----------------------*/
#include "help_cmds.sl"
#include "help_sl.sl"

/*----- Include the source code for forms ----------------------------------*/
#include "forms.sl"

end VC top_level;
