static char rcsid [] =
"$Header: /u/04c/mnt/integ/source/de/src/RCS/ea2_util.c,v 1.2 90/05/21 13:31:38 little Exp $";

/*--------------------------------------------------------------------------*\
|     
|  Name:  Dialogue Editor Utilities
|
|  Description:  
|     definitions of functions useful throughout the editor
|
|  Component of:
|     Dialoge Editor Layer.
|
|  Project:
|     Serpent
|     User Interface Prototyping
|     Software Engineering Institute
|     Carnegie Mellon University
|     Pittsburgh, PA  15213
|
|  Change History:
|     $Log:	ea2_util.c,v $
 * Revision 1.2  90/05/21  13:31:38  little
 * fix up for multiple includes & start mods for visu/struc editor integration
 * 
 * Revision 1.1  89/12/07  15:09:53  little
 * Initial revision
 * 
|
|   created 7 dec 1989
|
\*--------------------------------------------------------------------------*\
|
|   Distribution: Approved for public release; distribution is unlimited.
|
|   Copyright (c) 1989  by  Carnegie  Mellon  University, Pittsburgh, PA.  The
|  Software Engineering  Institute   (SEI) is a federally  funded  research and
|  development center established  and  operated by Carnegie Mellon University
|   (CMU).  Sponsored  by  the  U.S.  Department  of   Defense  under  contract
|  F19628-85-C-0003,  the  SEI  is  supported  by  the  services  and  defense
|  agencies, with the U.S. Air Force as the executive contracting agent.
|
|    Permission to use,  copy,  modify, or  distribute  this  software and its
|  documentation for  any purpose and without fee  is hereby granted, provided
|  that  the above copyright notice appear  in  all copies and that both  that
|  copyright  notice  and   this  permission  notice  appear   in   supporting
|  documentation.   Further,  the  names  Software  Engineering  Institute  or
|  Carnegie  Mellon  University  may  not be used in  advertising or publicity
|  pertaining to distribution of the software without specific, written  prior
|  permission.  CMU makes no claims  or representations  about the suitability
|  of this software for any purpose.  This software is provided "as is" and no
|  warranty,  express  or  implied,  is  made  by  the  SEI  or CMU, as to the
|  accuracy  and  functioning of the program and related program material, nor
|  shall   the  fact of  distribution   constitute  any   such  warranty.   No
|  responsibility is assumed by the SEI or CMU in connection herewith.
|
\*--------------------------------------------------------------------------*/


#include "ea2_util.h"
#include "ea2.h"
#include "u22.h"
#include "serpent.h"
#ifndef memoryPack
#define memoryPack
#endif
#include "hashPack.h"
#include <string.h>



/*--------------------------------------------------------------------------*\
|  Routine:  ea2_in_list
|
|  Description:
|     checks a list of things (depending on what is handed in through the
|	the_list and name_fetch_function  parameters for a thing named
|	the_name
\*--------------------------------------------------------------------------*/
caddr_t ea2_in_list (the_name, the_list, name_fetch_function)
string the_name;
LIST the_list;
string (*name_fetch_function) ();
{  caddr_t the_element;

   if (the_list)
      loop_through_list (the_list, the_element, caddr_t)
         {if (!strcmp (the_name, name_fetch_function (the_element)))
            return (the_element);
         }
   return (NULL);
}					/* end ea2_in_list */


/*--------------------------------------------------------------------------*\
|  Routine:  ea2_string_lower
|
|  Description:
|     Converts every upper-case character in a string to lower-case.
\*--------------------------------------------------------------------------*/
string ea2_string_lower (the_string)
string  the_string;

{  int length;
   string result = NULL;
   string s;

if ((length = strlen (the_string)) > 0 )
   {if ((result = (string) make_node (length + 1)) == NULL )
      {fprintf (stderr,
                "string_lower: cannot allocate memory for function result.\n");
      return (NULL);
      }
    else
      {for (s = result; *the_string != '\0'; s++, the_string++)
         if (isupper (*the_string))
            *s = tolower (*the_string);
          else
            *s = *the_string;
         *s = '\0';
       }
   }
   return (result);
}						/* end ea2_string_lower */

