static char rcsid [] =
        "$Header: /usr/users/little/serpent/mips/de/src/RCS/eat.c,v 1.26 1991/05/30 14:53:08 little Exp $";

/*--------------------------------------------------------------------------*\
|   
|  Name:  Dialogue Editor Attribute Abstraction (eat)
|
|  Description:  
|     The dialogue editor attribute abstraction provides operations on the
|     attribute abstract type.
|
|  Component of:
|     Dialogue Editor Layer.
|
$Log: eat.c,v $
 * Revision 1.26  1991/05/30  14:53:08  little
 * change att_is_string_type_p to also return true for the font types
 *
 * Revision 1.25  1991/05/14  22:27:45  little
 * fix things so the parent att works when instinstiating
 *
 * Revision 1.24  1991/05/07  18:24:25  little
 * make attributes of GT_Pixel string type
 *
 * Revision 1.23  1990/12/17  17:42:11  little
 * change att_is_string_type_p (used to be att_is_string_type) so it uses
 * the x_type to determine stringness
 *
 * Revision 1.22  90/12/17  13:22:49  little
 * change eat_temp_from_inst so it does not put instance value in snippet
 * if the value is the null string
 * 
 * Revision 1.21  90/11/29  09:51:35  rcs
 * symbol table fix?
 * 
 * Revision 1.20  90/10/23  14:00:30  little
 * add is_instantiable_attribute routine
 * 
 * change things to use tx files instead of being hardwired
 * 
 * change so that att_is_string_type uses two parameters (new one is an att)
 * 
 * change eat_create_attribute to need a parm (the att name)
 * 
 * Revision 1.19  90/09/20  15:53:59  rcs
 * added debug
 * 
 * Revision 1.18  90/09/18  14:38:19  little
 * fix eat_snippet_2_constant so the output strings are acceptable to x, ie
 *   have no white space at either end and other things
 * 
 * Revision 1.17  90/09/17  22:18:41  little
 * fix duplication
 * 
 * Revision 1.16  90/09/11  08:30:07  little
 * make eat_snippet_constant_p smarter
 * add thrid parameter to  esi_buffer_src_write calls
 * change eat_snippet_2_constant so strings constants do not contain
 *    double quotes
 * 
 * Revision 1.15  90/09/07  18:24:54  little
 * make is_snippet_constant_p a little smarter
 * 
 * Revision 1.14  90/08/30  17:38:05  little
 * make those who call get_prop & donot care about status, set it ok
 * 
 * Revision 1.13  90/08/07  16:17:25  little
 * no changes
 * 
 * Revision 1.12  90/07/31  17:34:27  little
 * add a set of the snippet_constant_p_prop to true in eat_create_attribute
 * 
 * Revision 1.11  90/07/19  16:59:36  little
 * in eat_inst_from_temp: doe not set the template snippet if the instance
 * is undefined.
 * 
 * Revision 1.10  90/07/05  15:02:45  little
 * more structure and visualizer parts integration
 * 
 * Revision 1.9  90/06/14  13:53:16  little
 *  more changes to integrate visulization and structure editors
 * 
 * Revision 1.8  90/06/06  18:03:58  little
 * parital update to support combination of visual and structural editor
 * 
 * Revision 1.7  90/05/21  13:32:36  little
 * fix up for multiple includes & start mods for visu/struc editor integration
 * 
 * Revision 1.6  89/12/18  15:11:09  bmc
 * eat_bin_read now sets comment property
 * 
 * Revision 1.5  89/12/18  14:17:58  little
 * fixed some shit that was wrong
 * 
 * Revision 1.4  89/12/15  20:31:11  bmc
 * Added binary read routine.
 * 
 * Revision 1.3  89/12/15  11:57:48  little
 * add bin_write
 * 
 * Revision 1.2  89/12/14  19:43:39  rcs
 * probably changed something
 * 
 * Revision 1.1  89/11/29  09:37:09  bmc
 * Initial revision
 * 
|
|-----------------------------------------------------------------------------
|
|   Distribution: Approved for public release; distribution is unlimited.
|
|   Copyright (c) 1989  by  Carnegie  Mellon  University, Pittsburgh, PA.  The
|  Software Engineering  Institute  (SEI) is a federally  funded  research and
|  development center established  and  operated by Carnegie Mellon University
|  (CMU).  Sponsored  by  the  U.S.  Department  of   Defense  under  contract
|  F19628-85-C-0003,  the  SEI  is  supported  by  the  services  and  defense
|  agencies, with the U.S. Air Force as the executive contracting agent.
|
|    Permission to use,  copy,  modify, or  distribute  this  software and its
|  documentation for  any purpose and without fee  is hereby granted, provided
|  that  the above copyright notice appear  in  all copies and that both  that
|  copyright  notice  and   this  permission  notice  appear   in   supporting
|  documentation.   Further,  the  names  Software  Engineering  Institute  or
|  Carnegie  Mellon  University  may  not be used in  advertising or publicity
|  pertaining to distribution of the software without specific, written  prior
|  permission.  CMU makes no claims  or representations  about the suitability
|  of this software for any purpose.  This software is provided "as is" and no
|  warranty,  express  or  implied,  is  made  by  the  SEI  or CMU, as to the
|  accuracy  and  functioning of the program and related program material, nor
|  shall   the  fact of  distribution   constitute  any   such  warranty.   No
|  responsibility is assumed by the SEI or CMU in connection herewith.
|
\*--------------------------------------------------------------------------*/


#define eat_main
#include "eat.h"
#include "eob.h"
#include "esi.h"
#include "est.h"
#include "ebi.h"
#include "esa_sd.h"
#include "ea2.h"
#include "glue_intf.h"
#include "cus.h"
#include "ubo.h"
#include "se.h"
#include "gt_type.h"
#include "serpent.h"
#include "listPack.h"
#include <stdio.h>


#define DEBUG1(statement) SERPENT_DEBUG1(eat_debug, statement)
#define DEBUG2(statement) SERPENT_DEBUG2(eat_debug, statement)
#define DEBUG3(statement) SERPENT_DEBUG3(eat_debug, statement)

#define WHITE_SPACE "\b\f\n\r\t\v "

#define write_buffer(stream, buffer, the_selector) \
{  ebi_buffer a_buffer; \
   a_buffer.actual_buffer = buffer; \
   a_buffer.selector = the_selector; \
   if (!ebi_write_buffer (stream, a_buffer)) \
      {set_status (system_operation_failed); \
      return; \
      } \
}

#define write_open_record(stream) \
   if (!ebi_write_open_record (stream)) \
      {set_status (system_operation_failed); \
      return; \
      }

#define write_close_record(stream) \
   if (!ebi_write_close_record (stream)) \
      {set_status (system_operation_failed); \
      return; \
      }

			/* this is used by eob to clean up those instances which
			   were made before their parent */
LIST ea2_object_instances_not_completely_done;


/*--------------------------------------------------------------------------*\
|  Routine: is_instantiable_attribute
|
|  Description:
|     determines if the parameter att is is of instantiable type, ie an att
|	which is needed for instantiation
\*--------------------------------------------------------------------------*/
static boolean is_instantiable_attribute (att_name, the_obj)
string att_name;
eob_object the_obj;
{  ATTR *glue_attr;

   glue_attr = glue_get_attribute (eob_get_widget (the_obj), att_name,
				   SERP_NAMES);
   if (!glue_attr)
      {fprintf (stderr,
       "is_instantiable_attribute: couldn't find att %s for obj of type %s\n",
           att_name, eob_get_type (the_obj));
      exit (1);
      }

   if ((glue_attr-> x_type == GT_MethodName) ||
       (glue_attr-> x_type == GT_Window) ||
       (glue_attr-> x_type == GT_Colormap) ||
       (glue_attr-> x_type == GT_Screen) ||
       (glue_attr-> x_type == GT_XID) ||
       (glue_attr-> x_type == GT_XmCreatePopupChildProc) ||
       (glue_attr-> x_type == GT_XmStringList) ||
       (glue_attr-> x_type == GT_WidgetClass) ||
       (glue_attr-> x_type == GT_WidgetList) ||
       (glue_attr-> x_type == GT_XawTextSelectType_star))
      return FALSE;
   else
      return TRUE;
}					/* end is_instantiable_attribute */


/*--------------------------------------------------------------------------*\
|  Routine: att_is_string_type_p
|
|  Description:
|     determines if the parameter att is of string type
\*--------------------------------------------------------------------------*/
static boolean att_is_string_type_p (the_att, att_name)
eat_attribute the_att;
string att_name;
{  ATTR *glue_attr;

   glue_attr = glue_get_attribute (eob_get_widget (eat_get_parent (the_att)),
				   att_name,
				   SERP_NAMES);
   if (!glue_attr)
      {fprintf (stderr,
	   "att_is_string_type_p: could not find att %s for obj of type %s\n",
	   att_name, eob_get_type (eat_get_parent (the_att)));
      exit (1);
      }
   if ((glue_attr-> x_type == GT_String) ||
       (glue_attr-> x_type == GT_XmString) ||
       (glue_attr-> x_type == GT_XmStringTable) ||
       (glue_attr-> x_type == GT_Pixel) ||
       (glue_attr-> x_type == GT_XFontStruct) ||
       (glue_attr-> x_type == GT_XmFontList) ||
       (glue_attr-> x_type == GT_XmStringList))
      return TRUE;
   else
      return FALSE;
}                                       /* end att_is_string_type_p */


/*--------------------------------------------------------------------------*\
|  Routine: eat_snippet_constant_p
|
|  Description:
|     tests a snippet for constantness
\*--------------------------------------------------------------------------*/
static boolean eat_snippet_constant_p (the_snip)
buffer the_snip;
{  boolean got_quote;
   char *last, *look;
   char *got_first_quote, *got_last_quote;

   got_first_quote = (char *) NULL; got_last_quote = (char *) NULL;

			/* empty buffer of all types */
   if (the_snip.length < 2)
      return (FALSE);
/* ??    need better algorithm for determining if a snip is constant
         need to be aware of one of reserved words (false, true, undefined,
	 null, etc)
*/
   got_quote = (boolean) strpbrk (the_snip.body, "\042");
   if (got_quote)
			/* we have at least one double quote in the snippet,
			   proceed with the understanding that it is a string
			   constant */
      {last = the_snip.body + the_snip.length - 1;

			/* start at end of snippet and back up over any null
			   characters */
      for (look = last; *look == '\000'; look--)
         1;
			/* now step through each of the characters of the
			   snippet, backwards */
      for (; look >= the_snip.body; look--)
         {if (*look ==  '\042')
			/* if we currently are looking at a double quote do
			   some special processing */
            {if (got_last_quote)
			/* if we have already seen a double quote toward the
			   end of the snippet */
               {if (got_first_quote)
			/* this means we have seen at least three quotes, (two
			   already and one now) so it is probably not a good
			   string constant */
                  return (FALSE);
               else 
			/* this is where we see what we think is a left most
			   double quote */
                  got_first_quote = look;
               }
            else
			/* this is where we see what we think is a right-most
			   double quote */
               got_last_quote = look;
            }
			/* we are not looking at a double quote and we are not
			   within a literal string, so these characers
			   indicate that we are not in a constant snippet */
         else if (!got_last_quote && strchr ("{}+-/*", *look) )
            return (FALSE);
         }
			/* we have passed the test of two and only two double
			   quotes in the snippet, probably a good string
			   constant */

      return (TRUE);
      }
			/* this is not a string constant, so the set of
			   characters that cannot be in a non-string constant
			   are checked */
   if (strpbrk (the_snip.body, "abcdefghijklmnopqrstuvwxyz{}+-/*"))
      return (FALSE);
			/* the snippet failed to fail the know tests, so it
			   must be a good constant (at least probably a good
			   one) */
   return (TRUE);
}					/* end eat_snippet_constant_p */


/*--------------------------------------------------------------------------*\
|  Routine: eat_create_attribute
|
|  Description:
|     Creates a new attribute
|	property name			use
|       ---------------------------------------------------------
|	value_snippet_text_prop		the string which is the snippet for
|					the attribute
|
|	snippet_constant_p_prop		indicates whether the snippet is a
|					slang constant
|
|	object_comments_text_prop	actually holds the retained comments
|					for the att.  the object name is used
|					so we did not have to add a new prop
|
|	name_text_prop			the name of the attribute which is also
|					the same as the technology component
|					name in the object record
\*--------------------------------------------------------------------------*/
eat_attribute eat_create_attribute (att_name)
string att_name;
{  eat_attribute new_attribute;
   buffer new_buff;

   new_attribute = (eat_attribute) cus_gensym(
     "EDITOR_ATT", attribute_sym, NO_SEED
   );
					/*
					   Okay to use a local buffer, since
					   est_set_buffer_property make a copy
					   before storing in the symbol table.
					*/
   init_buffer (new_buff);
   est_set_buffer_property ((cus_sym) new_attribute,
			    value_snippet_text_prop,
			    new_buff);
   cus_put_prop (new_attribute, snippet_constant_p_prop, TRUE);


                                /* rcs said to use object_comments_text_prop
                                   here, and i agreed with him.  so there */
   est_set_buffer_property ((cus_sym) new_attribute,
			    object_comments_text_prop, 
			    new_buff);
   eat_set_ghost (new_attribute);
   eat_set_name (new_attribute, att_name);
   return (new_attribute);
}					/* end eat_create_attribute */


/*--------------------------------------------------------------------------*\
|  Routine: eat_destroy_attribute
|
|  Description:
|     Destroys a specified attribute and any sub-components.
\*--------------------------------------------------------------------------*/
void eat_destroy_attribute (the_attribute)
eat_attribute the_attribute;
{

   DEBUG2(
     fprintf(stderr, "eat_destroy_attribute: call\n");
   );

   est_clear_buffer_property((cus_sym)the_attribute, value_snippet_text_prop);
   est_clear_string_property((cus_sym)the_attribute, name_text_prop);
   cus_delete_sym(the_attribute);

   DEBUG2(
     fprintf(stderr, "eat_destroy_attribute: exit\n");
   );

   return;
}					/* end eat_destroy_attribute */

/*--------------------------------------------------------------------------*\
|  Routine: eat_duplicate_attribute
|
|  Description:
|     Duplicates a specified attribute.
\*--------------------------------------------------------------------------*/
eat_attribute eat_duplicate_attribute(the_attribute)
eat_attribute the_attribute;
{  eat_attribute new_attribute;

   if ((new_attribute = eat_create_attribute (eat_get_name (the_attribute)))
        != EAT_NO_ATTRIBUTE)
      {est_copy_buffer_property ((cus_sym) new_attribute,
				(cus_sym) the_attribute,
				value_snippet_text_prop);
      est_copy_string_property ((cus_sym) new_attribute,
				(cus_sym) the_attribute,
				name_text_prop);
      }
   return (new_attribute);
}


/*--------------------------------------------------------------------------*\
|  Routine: eat_set_snippet
|
|  Description:
|     squirrels away a snippet for a attribute
\*--------------------------------------------------------------------------*/
void eat_set_snippet (the_attribute, the_snip)
eat_attribute the_attribute;
buffer the_snip;
{
   est_set_buffer_property (the_attribute, value_snippet_text_prop, the_snip);
   if (eat_snippet_constant_p (the_snip))
      cus_put_prop (the_attribute, snippet_constant_p_prop, TRUE);
    else
      cus_put_prop (the_attribute, snippet_constant_p_prop, NULL);

   return;
}					/* end eat_set_snippet */


/*--------------------------------------------------------------------------*\
|  Routine: eat_get_snippet
|
|  Description:
|      fetches the squirreled away snippet for a attribute
\*--------------------------------------------------------------------------*/
buffer eat_get_snippet (the_attribute)
eat_attribute the_attribute;
{  buffer the_snippet;

   the_snippet = est_get_buffer_property (the_attribute,value_snippet_text_prop);
   return (the_snippet);
}					/* end eat_get_snippet */


/*--------------------------------------------------------------------------*\
|  Routine: eat_set_comment
|
|  Description:
|     squirrels away a comment for a attribute
\*--------------------------------------------------------------------------*/
void eat_set_comment (the_attribute, the_comment)
eat_attribute the_attribute;
buffer the_comment;
{
                                /* rcs said to use object_comments_text_prop
                                   here, and i agreed with him.  so there */
   est_set_buffer_property (the_attribute, object_comments_text_prop,
			    the_comment);
   return;
}					/* end eat_set_comment */


/*--------------------------------------------------------------------------*\
|  Routine: eat_get_comment
|
|  Description:
|      fetches the squirreled away comment for a attribute
\*--------------------------------------------------------------------------*/
buffer eat_get_comment (the_attribute)
eat_attribute the_attribute;
{  buffer the_comment;

				/* rcs said to use object_comments_text_prop
				   here, and i agreed with him.  so there */
   the_comment = est_get_buffer_property (the_attribute,
					  object_comments_text_prop);
   return (the_comment);
}					/* end eat_get_comment */


/*--------------------------------------------------------------------------*\
|  Routine: eat_set_parent
|
|  Description:
|     squirrels away a parent for a attribute
\*--------------------------------------------------------------------------*/
void eat_set_parent (the_attribute, the_parent)
eat_attribute the_attribute;
eob_object the_parent;
{
   cus_put_prop (the_attribute, parent_object_prop, the_parent);
   return;
}					/* end eat_set_parent */


/*--------------------------------------------------------------------------*\
|  Routine: eat_get_parent
|
|  Description:
|      fetches the squirreled away parent for a attribute
\*--------------------------------------------------------------------------*/
eob_object eat_get_parent (the_attribute)
eat_attribute the_attribute;
{  eob_object the_parent;

   the_parent = cus_get_prop (the_attribute, parent_object_prop);
   return (the_parent);
}					/* end eat_get_parent */


/*--------------------------------------------------------------------------*\
|  Routine: eat_set_name
|
|  Description:
|     squirrels away a name for a attribute
\*--------------------------------------------------------------------------*/
void eat_set_name (the_attribute, the_name)
eat_attribute the_attribute;
string the_name;
{
   est_set_string_property (the_attribute, name_text_prop, the_name);
   return;
}					/* end eat_set_name */


/*--------------------------------------------------------------------------*\
|  Routine: eat_get_name
|
|  Description:
|      fetches the squirreled away name for a attribute
\*--------------------------------------------------------------------------*/
string eat_get_name (the_attribute)
eat_attribute the_attribute;
{  string the_name;

   the_name = cus_get_prop (the_attribute, name_text_prop);
   return (the_name);
}					/* end eat_get_name */


/*--------------------------------------------------------------------------*\
|  Routine: eat_parse_attribute_2_ed
|
|  Description:
|     convert the parser version of the attribute to editor version
\*--------------------------------------------------------------------------*/
eat_attribute eat_parse_attribute_2_ed (attribute)
cus_sym attribute;
{  eat_attribute ed_att;
   LIST snippet;
   buffer ed_snippet;

   ed_att = eat_create_attribute (cus_sym_representation (attribute));

   if (snippet = (LIST) cus_get_prop (attribute, value_snippet_prop))
      {ed_snippet = esi_snip_2_text (snippet);
      eat_set_snippet (ed_att, ed_snippet);
      }

   return (ed_att);
}					/* end eat_parse_attribute_2_ed */


/*--------------------------------------------------------------------------*\
|  Routine: eat_src_write
|
|  Description:
|     write a attribute to a source stream
\*--------------------------------------------------------------------------*/
void eat_src_write (the_attribute, stream)
eat_attribute the_attribute;
FILE *stream;
{
   buffer the_snippet;


   the_snippet = eat_get_snippet (the_attribute);
   if (ea2_printable_buffer (the_snippet))
      {fprintf (stream, "%s: ", eat_get_name (the_attribute));
      esi_buffer_src_write (the_snippet, stream, TRUE);
      }

   return;
}					/* end eat_src_write */


/*--------------------------------------------------------------------------*\
|  Routine: eat_bin_write
|
|  Description:
|     write an attribute to a binary stream
\*--------------------------------------------------------------------------*/
void eat_bin_write (the_attribute, stream)
eat_attribute the_attribute;
FILE *stream;
{

   write_open_record (stream);
   ebi_write_token_char (stream, EBI_ATTRIBUTE_SELECTOR);

   fprintf (stream, "%d ", the_attribute);

   fprintf (stream, "%d ", eat_get_instance (the_attribute));

   ebi_write_token (stream, eat_get_name (the_attribute));

   ebi_write_token (stream, cus_sym_representation (the_attribute));

   write_buffer (stream, eat_get_comment(the_attribute), EBI_COMMENTS_SELECTOR);

   write_buffer (stream, eat_get_snippet (the_attribute), EBI_SNIPPET_SELECTOR);

   write_close_record (stream);

   return;
}					/* end eat_bin_write */


/*--------------------------------------------------------------------------*\
|  Routine: eat_bin_read
|
|  Description:
|     read an attribute from a binary stream
\*--------------------------------------------------------------------------*/
eat_attribute eat_bin_read (stream)
FILE *stream;
{  eat_attribute attr = EAT_NO_ATTRIBUTE;
   char tc;
   string unique_name = NULL;
   string name = NULL;
   ebi_buffer snippet;
   ebi_buffer comment;
   int old_temp_handle, old_instance_handle;
   eat_template_hash_entry *hash_entry;

    /*
    ** A binary attribute has the following form (line breaks are
    ** insignificant):
    **
    ** EBI_OPEN_RECORD
    **   EBI_ATTRIBUTE_SELECTOR attribute_name unique_name attribute_snippet
    ** EBI_CLOSE_RECORD
    */
    set_status (ok);
    snippet.selector = EBI_INVALID_SELECTOR;
    comment.selector = EBI_INVALID_SELECTOR;

    if ((tc = ebi_read_token_char (stream)) == EBI_CLOSE_RECORD)
	{
	/* End of list.  Stop here.  Push the end of list character back
	** onto the input token stream.
	*/
	attr = EAT_NO_MORE_ATTRIBUTES;
	if (! ebi_push_token_char (EBI_CLOSE_RECORD))
	    {
	    /* Assume status is already set. */
	    attr = EAT_NO_ATTRIBUTE; /* to indicate error */
	    DEBUG1 (fprintf (stderr,
		"eat_bin_read: can't push `%c' back onto token stream\n",
		EBI_CLOSE_RECORD););
	    }
	}

    else if (tc != EBI_OPEN_RECORD)
	{
	set_status (invalid_attribute);
	DEBUG1 (fprintf (stderr,
	    "eat_bin_read: missing open record `%c' character\n",
	    EBI_OPEN_RECORD););
	}

    else if ( (tc = ebi_read_token_char (stream)) != EBI_ATTRIBUTE_SELECTOR )
	{set_status (invalid_attribute);
	DEBUG1 (fprintf (stderr,
	    "eat_bin_read: bad selector character -- `%c'\n", tc););
	}

    else if (fscanf (stream, "%d", &(old_temp_handle)) != 1)
	{set_status (invalid_attribute);
	DEBUG1 (fprintf (stderr,
			"eat_bin_read: missing attribute old_temp_handle\n"););
	}

                        /* we are ignoring the instance for now, but we mite
                           use it later on when we want to do more error
                           checking */
    else if (fscanf (stream, "%d", &(old_instance_handle)) != 1)
	{set_status (invalid_attribute);
	DEBUG1 (fprintf (stderr,
		"eat_bin_read: missing attribute old_instance_handle\n"););
	}

    else if ( (name = ebi_read_token (stream)) == NULL )
	{set_status (invalid_attribute);
	DEBUG1 (fprintf (stderr, "eat_bin_read: missing attribute name\n"););
	}

    else if ( (unique_name = ebi_read_token (stream)) == NULL )
	{
	set_status (invalid_attribute);
	DEBUG1 (fprintf (stderr, "eat_bin_read: missing unique name\n"););
	}

    /*
    ** The commas in the following two expressions are INTENTIONAL, and
    ** represent perfectly legal C.  See K&R (edition 1), p. 192 for details.
    */

    else if (comment = ebi_read_buffer (stream),
	     comment.selector != EBI_COMMENTS_SELECTOR)
	{
	set_status (invalid_attribute);
	DEBUG1 (fprintf (stderr,
	    "eat_bin_read: Expected `%c' buffer, found `%c' buffer.\n",
	    EBI_COMMENTS_SELECTOR, snippet.selector););
	}

    else if (snippet = ebi_read_buffer (stream),
	     snippet.selector != EBI_SNIPPET_SELECTOR)
	{
	set_status (invalid_attribute);
	DEBUG1 (fprintf (stderr,
	    "eat_bin_read: Expected `%c' buffer, found `%c' buffer.\n",
	    EBI_SNIPPET_SELECTOR, snippet.selector););
	}

    else if (ebi_read_token_char (stream) != EBI_CLOSE_RECORD)
	{
	set_status (invalid_attribute);
	fprintf (stderr, "eat_bin_read: Missing close record `%c' character\n",
	    EBI_CLOSE_RECORD);
	}


    else if ((attr = eat_create_attribute (name)) == EAT_NO_ATTRIBUTE)
	{set_status (out_of_memory);
	fprintf (stderr, "eat_bin_read: can't create attribute\n");
	}

    else
	{
	/*
	** We have all the pieces.  Store 'em.  (We're ignoring the
	** unique name for now.);
	*/
	eat_set_snippet (attr, snippet.actual_buffer);
	eat_set_comment (attr, comment.actual_buffer);

                        /* now put the new template handle into the hash table
                           with the old template handle as its index, this will
                           be used by the instance reader to set up the instance
                           property */
        hash_entry = (eat_template_hash_entry *)
                          make_node (sizeof (eat_template_hash_entry));
        hash_entry -> old_template = old_temp_handle;
        hash_entry -> new_template = attr;
        add_to_hashtable (eat_template_hash, hash_entry, old_temp_handle);
	}

    if (get_status () != ok)
	{
	/* Problem.  Release storage. */

	if ( (attr != EAT_NO_ATTRIBUTE) && (attr != EAT_NO_MORE_ATTRIBUTES) )
	    {
	    eat_destroy_attribute (attr);
	    attr = EAT_NO_ATTRIBUTE;
	    }

	ea2_free_node (name);
	ea2_free_node (unique_name);

	if (snippet.selector != EBI_INVALID_SELECTOR)
	    ubo_destroy_buffer (snippet.actual_buffer);
	if (comment.selector != EBI_INVALID_SELECTOR)
	    ubo_destroy_buffer (comment.actual_buffer);
	}

    return (attr);
}


/*--------------------------------------------------------------------------*\
|  Routine: eat_inst_2_temp
|
|  Description:
|     moves an instance value to a template
\*--------------------------------------------------------------------------*/
void eat_inst_2_temp (the_att, name, value)
eat_attribute the_att;
string name;
string value;
{  buffer new_buff;
   boolean string_p, undefined_p;

   set_status (ok);
			/* if the currrent snippent in the template is not a
			   ghost (meaning it has been written into by the
			   structure part of the editor) and it is not a
			   constant we should not modify it from the instance */
   if (!eat_get_ghost (the_att) ||
       !eat_get_snip_constant_p (the_att))
      return;

   string_p = att_is_string_type_p (the_att, name);

/* ?? mite want to base UNDEFINED on something from the dm conversion
          routine area */
   undefined_p = !strcmp (value, "UNDEFINED");
   new_buff.length = strlen (value) + (string_p ? 5 : 3);
   new_buff.body = make_node (new_buff.length);
   new_buff.type = idd_string;
   if (! new_buff.body)
      {fprintf (stderr,
                "eat_inst_2_temp: cannot allocate mem for att snippet\n");
      set_status (out_of_memory);
      return;
      }
   if (string_p && !undefined_p)
      {strcpy (new_buff.body, "\"");
      strcat (new_buff.body, value);
      strcat (new_buff.body, "\";\n");
      }
    else
      {new_buff.body = make_node (new_buff.length);
      strcpy (new_buff.body, value);
      strcat (new_buff.body, ";\n");
      }
   
/* ??    what about the old buffer in the symbol table,
              should free it's body some how, or delve into the internals
              of eat to efficiently change the snippet property, maybe to use
              ubo_destroy_buffer (idd_buffer_type *buff)  */
   
   eat_set_snippet (the_att, new_buff);
   
   free_node (new_buff.body);
   
   return;
}					/* end eat_inst_2_temp */


/*--------------------------------------------------------------------------*\
|  Routine: eat_set_instance
| 
|  Description:
|     Sets the instance of an attribute
\*--------------------------------------------------------------------------*/
void eat_set_instance (the_att, att_instance)
eat_attribute the_att;
object_instance_attribute_sdd *att_instance;
{
    set_status (ok);
    if (the_att == EAT_NO_ATTRIBUTE)
	set_status (invalid_attribute);
    else
      cus_put_prop (the_att, instances_prop, att_instance);

    return;
}					/* end eat_set_instance */


/*--------------------------------------------------------------------------*\
|  Routine: eat_get_instance
| 
|  Description:
|     Gets the instance of an attribute, if there is one.
\*--------------------------------------------------------------------------*/
object_instance_attribute_sdd *eat_get_instance (the_att)
eat_attribute the_att;
{
    object_instance_attribute_sdd *att_instance;

    set_status (ok);
    if (the_att == EAT_NO_ATTRIBUTE)
	set_status (invalid_attribute);
    else
	{att_instance = (object_instance_attribute_sdd *)
                           cus_get_prop (the_att, instances_prop);
			/* we do no care about status here */
        set_status (ok);
        }

    return (att_instance);
}					/*end eat_get_instance */


/*--------------------------------------------------------------------------*\
|  Routine: eat_set_sd_element
| 
|  Description:
|     Sets the sd_element of an attribute
\*--------------------------------------------------------------------------*/
void eat_set_sd_element (the_att, att_sd_element)
eat_attribute the_att;
id_type att_sd_element;
{
    set_status (ok);
    if (the_att == EAT_NO_ATTRIBUTE)
	set_status (invalid_attribute);
    else
      cus_put_prop (the_att, shared_data_prop, att_sd_element);

    return;
}					/* end eat_set_sd_element */


/*--------------------------------------------------------------------------*\
|  Routine: eat_get_sd_element
| 
|  Description:
|     Gets the sd_element of an attribute, if there is one.
\*--------------------------------------------------------------------------*/
id_type eat_get_sd_element (the_att)
eat_attribute the_att;
{
    id_type att_sd_element;

   set_status (ok);
   if (the_att == EAT_NO_ATTRIBUTE)
      {set_status (invalid_attribute);
      att_sd_element = (id_type) NULL;
      }
    else
      att_sd_element = (id_type) cus_get_prop (the_att, shared_data_prop);

    return (att_sd_element);
}					/*end eat_get_sd_element */


/*--------------------------------------------------------------------------*\
|  Routine: eat_clear_sd_element
| 
|  Description:
|     Clears the sd_element of an attribute
\*--------------------------------------------------------------------------*/
void eat_clear_sd_element (the_att)
eat_attribute the_att;
{
    set_status (ok);
    if (the_att == EAT_NO_ATTRIBUTE)
	set_status (invalid_attribute);
    else
      cus_put_prop (the_att, shared_data_prop, NULL);

    return;
}					/* end eat_clear_sd_element */


/*--------------------------------------------------------------------------*\
|  Routine: eat_set_ghost
| 
|  Description:
|     Sets the ghost of an attribute
\*--------------------------------------------------------------------------*/
void eat_set_ghost (the_att)
eat_attribute the_att;
{
    set_status (ok);
    if (the_att == EAT_NO_ATTRIBUTE)
	set_status (invalid_attribute);
    else
      cus_put_prop (the_att, ghost_p_prop, TRUE);
    return;
}					/* end eat_set_ghost */


/*--------------------------------------------------------------------------*\
|  Routine: eat_get_ghost
| 
|  Description:
|     Gets the ghost of an attribute, if there is one.
\*--------------------------------------------------------------------------*/
boolean eat_get_ghost (the_att)
eat_attribute the_att;
{  boolean att_ghost;

   set_status (ok);
   if (the_att == EAT_NO_ATTRIBUTE)
      {set_status (invalid_attribute);
      att_ghost = (boolean) NULL;
      }
    else
      {att_ghost = (boolean) cus_get_prop (the_att, ghost_p_prop);
      set_status (ok);
      }

    return (att_ghost);
}					/*end eat_get_ghost */


/*--------------------------------------------------------------------------*\
|  Routine: eat_clear_ghost
| 
|  Description:
|     Clears the ghost of an attribute
\*--------------------------------------------------------------------------*/
void eat_clear_ghost (the_att)
eat_attribute the_att;
{
    set_status (ok);
    if (the_att == EAT_NO_ATTRIBUTE)
	set_status (invalid_attribute);
    else
      cus_put_prop (the_att, ghost_p_prop, NULL);

    return;
}					/* end eat_clear_ghost */


/*--------------------------------------------------------------------------*\
|  Routine: eat_get_snip_constant_p
| 
|  Description:
|     Gets the snippet_constant_p_prop of an attribute
\*--------------------------------------------------------------------------*/
boolean eat_get_snip_constant_p (the_att)
eat_attribute the_att;
{  boolean const_p;

   set_status (ok);
   if (the_att == EAT_NO_ATTRIBUTE)
      {set_status (invalid_attribute);
      const_p = (boolean) NULL;
      }
    else
      {const_p = (boolean) cus_get_prop (the_att, snippet_constant_p_prop);
      set_status (ok);
      }

    return (const_p);
}					/*end eat_get_snip_constant_p */


/*--------------------------------------------------------------------------*\
|  Routine: eat_snippet_2_constant
| 
|  Description:
|    moves an att's snippet value to a string, ensures it is a constant
\*--------------------------------------------------------------------------*/
string eat_snippet_2_constant (the_att, the_string, the_length)
eat_attribute the_att;
string the_string;
int the_length;
{  buffer snippet;
   char *a_ptr, *i, *next;
   boolean in_quote = FALSE;

   set_status (ok);
			/* we have to have an att and the snippet must be a 
			   constant */
   if (!(the_att && eat_get_snip_constant_p (the_att)))
      return (NULL);
   snippet = eat_get_snippet (the_att);
			/* this must be something in the snippet */
   if (snippet.length < 1)
      return (NULL);
			/* the snippet must fit in the target space */
   if (snippet.length > the_length)
      return (NULL);

			/* flush all white space at front of snippet */
   for (i = snippet.body; *i != '\0'; i++)
      if (!strchr (WHITE_SPACE, *i))
         break;

			/* if nothing left of snippet we are done */
   if (! *i)
      return (NULL);

			/* now look at the snippet's chars one by one, i is
			   pointing to the first non-white char  */
   for (next = the_string; *i != '\0'; i++, next++)
			/* if we have a double quote, do some special
			   processing */
      {if (*i == '\042')
         {if (in_quote)
			/* this is the second double quote, we are at the end
			   of the literal string, put in the null character
			   and dump out of the loop looking at the chars */
            {*next = '\0';
            break;
            }
         else
			/* this is the first double quote, we are at the 
			   beginning of a literal string.  next is decremented
			   to keep us from putting anything out for the
			   double quote */
            {--next;
            in_quote = TRUE;
            continue;
            }
         }
			/* if we are not within a literal string ignore the 
			   semicolon */
      else if (!in_quote && *i == ';')
         --next;
			/* if we are not in a literal string and we get white
			   space, things are over so get out of the loop */
      else if (!in_quote && strchr (WHITE_SPACE, *i))
         {*next = '\0';
         break;
         }
			/* otherwise just copy the character over */
      else
         *next = *i;
      }

   return (the_string);
}					/* end eat_snippet_2_constant */




#define TEMPLATE_HASH_TABLE_SIZE 511


/*--------------------------------------------------------------------------*\
|  Local Routine: eat_template_hash_fcn
| 
|  Description:
|     Calculates the hash index for the template hash table
\*--------------------------------------------------------------------------*/
static int eat_template_hash_fcn (ident)
int ident;
{
    return (ident % TEMPLATE_HASH_TABLE_SIZE);
}					/* eat_template_hash_fcn */


/*--------------------------------------------------------------------------*\
|  Local Routine: eat_template_match
| 
|  Description:
|     Determines whether a template matches an existing template in the hash
|	table
\*--------------------------------------------------------------------------*/
static boolean eat_template_match (ident, entry)
int ident;
eat_template_hash_entry *entry;
{

   return (ident== (entry-> old_template));
}					/* eat_template_match */


/*--------------------------------------------------------------------------*\
|  Routine: eat_init_template_hash
| 
|  Description:
|     initializes the att template hash table used when reading in dialogue
|	binaries
\*--------------------------------------------------------------------------*/
void eat_init_template_hash ()
{
   eat_template_hash = make_hashtable (TEMPLATE_HASH_TABLE_SIZE,
                                       eat_template_hash_fcn,
                                       eat_template_match);
   return;
}					/* end eat_init_template_hash  */


/*--------------------------------------------------------------------------*\
|  Routine: eat_free_template_hash
| 
|  Description:
|    destroys the att template hash table used when reading in dialogue 
|	binaries
\*--------------------------------------------------------------------------*/
void eat_free_template_hash ()
{
   free_hashtable (eat_template_hash, AND_NODES);
   return;
}					/* end eat_free_template_hash  */


/*--------------------------------------------------------------------------*\
|  Routine: eat_temp_from_inst
| 
|  Description:
|    creates an att template based on an instance
\*--------------------------------------------------------------------------*/
eat_attribute eat_temp_from_inst (att_inst, parent_obj)
object_instance_attribute_sdd *att_inst;
eob_object parent_obj;
{  eat_attribute att_temp;

                        /* create an att template and set it up */
   att_temp = eat_create_attribute (att_inst-> name);
   rcheck_status ("eat_temp_from_inst: bad status from eat_create_attr",
          FALSE);
   eob_add_attribute (parent_obj, att_temp);

			/* if the instance has a value, put it in the snippet */
   if (strcmp (att_inst-> value, UNDEFINED_STRING) &&
       (strlen (att_inst-> value) > 0))
      {eat_inst_2_temp (att_temp, att_inst-> name, att_inst-> value);
      if (get_status ())
         {fprintf (stderr,
              "eat_temp_from_inst: cannot set att template snippet\n");
         return ((eat_attribute) NULL);
         }
      }

                  /* set the att instance to point at the att template */
   att_inst-> template = (id_type) att_temp;

                  /* set att template to point to att instance */
   eat_set_instance (att_temp, att_inst);

   return (att_temp);
}					/* end eat_temp_from_inst */


/*--------------------------------------------------------------------------*\
|  Routine: eat_inst_from_temp
| 
|  Description:
|    creates an att instance based on a template or creates the template if
|	one does not exist
\*--------------------------------------------------------------------------*/
object_instance_attribute_sdd *eat_inst_from_temp (att_name, the_obj)
string att_name;
eob_object the_obj;
{  eat_attribute att_temp;
   object_instance_attribute_sdd *att_inst;
   object_instance_sdd *parent_obj_instance;
   eob_object parent_obj_template;
   boolean put_on_list, have_parent_att;

   set_status (ok);
   have_parent_att = FALSE;
   put_on_list = FALSE;
   parent_obj_template = (eob_object) NULL;
   parent_obj_instance = (object_instance_sdd *) NULL;
   att_temp = eob_get_att_by_name (the_obj, att_name);

			/* need to do some fancy footwork for the parent
			   attribute and if there is a snippet */
   if (!strcmp (att_name, "parent") && att_temp)
      {parent_obj_template = (eob_object)
				eob_find_parent_object_template (att_temp);
      have_parent_att = TRUE;
      if (parent_obj_template)
         {parent_obj_instance = eob_get_instance (parent_obj_template);
         if (!parent_obj_instance)
            put_on_list = TRUE;
         }
      }
			/* proceed with instantiation only if the type is
			   "approved" */
   else if (!is_instantiable_attribute (att_name, the_obj))
      {set_status (ok);
      return ((object_instance_attribute_sdd *) NULL);
      }

   if (!att_temp)
      {att_temp = eat_create_attribute (att_name);
      rcheck_status ("eat_inst_from_temp: bad status from eat_create_attr",
                     (object_instance_attribute_sdd *) NULL);
      eob_add_attribute (the_obj, att_temp);
      }
                     /* if we have trouble creating the inst, error */
   if (!(att_inst = esa_make_inst_sd_struct (att_temp)))
      {set_status (invalid_object);
      fprintf (stderr,
	       "eat_inst_from_temp: cannot make att sd w/name %s in obj %s\n",
  	       att_name, eob_get_name (the_obj));
      return ((object_instance_attribute_sdd *) NULL);
      }

   if (put_on_list)
      add_to_tail_val (ea2_object_instances_not_completely_done,
		       att_inst, parent_obj_template);

   if (have_parent_att && parent_obj_instance)
      strncpy (att_inst-> value, parent_obj_instance-> name,
                sizeof (att_inst-> value));
                     /* now try to move the snippet from the temp to the
                        inst.  if we could move the snippet from the template
			it must have been a constant otherwise put undefined
			in */
   else if (! eat_snippet_2_constant (att_temp, att_inst-> value,
                                 sizeof (att_inst-> value)))
      strcpy (att_inst-> value,  UNDEFINED_STRING);

   return (att_inst);
}					/* end eat_inst_from_temp */


