static char rcsid [] =
        "$Header: /u/04c/mnt/integ/source/de/src/RCS/eci.c,v 1.26 1991/07/05 21:55:39 dvk Exp $";
/*--------------------------------------------------------------------------*\
|   
|  Name:  Dialoge Editor Command Interpreter (eci)
|
|  Description:  
|     The dialogue editor command interpreter is the topmost level of the
|     dialogue editor application.  The command interpreter is responsible
|     for interpreting user commands which are returned through the 
|     shared data interface with the dialogue editor dialogue, and calling
|     the proper routines to handle these commands.
|
|  Component of:
|     Dialoge Editor Layer.
|
|  Change History:
|     $Log: eci.c,v $
 * Revision 1.26  1991/07/05  21:55:39  dvk
 * No changes
 *
 * Revision 1.25  1991/05/14  22:28:49  little
 * fix things so the parent att works when instinstiating
 *
 * Revision 1.24  1991/05/07  17:41:26  little
 * move the dialogue extern to e22.h and change name to e22_dialogue.
 * take out some #if 0 stuff
 *
 * Revision 1.23  1991/03/31  11:01:26  little
 * save the value returned fromo the import function in the dialogue global
 *
 * Revision 1.22  91/03/20  23:37:45  little
 * take out the automatic creation of a dialogue at the begining of main
 * 
 * Revision 1.21  91/02/12  15:40:33  little
 * take out all DEBUGx statements, they drive dbx crazy.
 * 
 * Revision 1.20  90/12/05  19:38:11  little
 * take out is_a_change = FALSE from end of first main loop in eci_router
 * 
 * Revision 1.19  90/10/23  14:03:11  little
 * take out call to eob_init_shit
 * 
 * Revision 1.18  90/09/18  14:39:19  little
 * new version number
 * 
 * Revision 1.17  90/09/11  08:32:40  little
 * update version number
 * 
 * Revision 1.16  90/08/30  21:29:09  rcs
 * fixed core dump problem with deleting dialogue sdd records
 * 
 * Revision 1.15  90/08/30  17:36:01  little
 * make those who call get_prop & donot care about status, set it ok
 * 
 * Revision 1.14  90/08/29  18:29:41  little
 * add integer read/write
 * 
 * Revision 1.13  90/08/08  15:13:11  little
 * put record start under DEBUG2 control
 * 
 * Revision 1.12  90/08/06  16:34:13  little
 * change the hardwired technology in the initial dialogue to sat.
 * 
 * Revision 1.11  90/07/05  15:04:09  little
 *  more structure and visualizer parts integration
 * 
 * Revision 1.10  90/06/14  13:53:45  little
 *  more changes to integrate visulization and structure editors
 * 
 * Revision 1.9  90/06/06  18:04:35  little
 * parital update to support combination of visual and structural editor
 * 
 * Revision 1.8  90/05/21  13:33:09  little
 * fix up for multiple includes & start mods for visu/struc editor integration
 * 
 * Revision 1.7  90/03/23  14:23:15  rcs
 * *** empty log message ***
 * 
 * Revision 1.6  90/03/19  13:57:00  rcs
 * temp fix for export string problem
 * 
 * Revision 1.5  90/02/14  13:01:39  bmc
 * Now handles object instances.
 * 
 * Revision 1.4  89/12/20  14:42:35  rcs
 * integration testing
 * 
 * Revision 1.3  89/12/12  09:16:51  rcs
 * fixed bugs found during integration testing
 * 
 * Revision 1.2  89/11/30  13:40:12  rcs
 * fixed spelling
 * 
 * Revision 1.1  89/11/28  18:36:24  rcs
 * Initial revision
 * 
|
\*--------------------------------------------------------------------------*\
|
|   Distribution: Approved for public release; distribution is unlimited.
|
|   Copyright (c) 1989  by  Carnegie  Mellon  University, Pittsburgh, PA.  The
|  Software Engineering  Institute  (SEI) is a federally  funded  research and
|  development center established  and  operated by Carnegie Mellon University
|  (CMU).  Sponsored  by  the  U.S.  Department  of   Defense  under  contract
|  F19628-85-C-0003,  the  SEI  is  supported  by  the  services  and  defense
|  agencies, with the U.S. Air Force as the executive contracting agent.
|
|    Permission to use,  copy,  modify, or  distribute  this  software and its
|  documentation for  any purpose and without fee  is hereby granted, provided
|  that  the above copyright notice appear  in  all copies and that both  that
|  copyright  notice  and   this  permission  notice  appear   in   supporting
|  documentation.   Further,  the  names  Software  Engineering  Institute  or
|  Carnegie  Mellon  University  may  not be used in  advertising or publicity
|  pertaining to distribution of the software without specific, written  prior
|  permission.  CMU makes no claims  or representations  about the suitability
|  of this software for any purpose.  This software is provided "as is" and no
|  warranty,  express  or  implied,  is  made  by  the  SEI  or CMU, as to the
|  accuracy  and  functioning of the program and related program material, nor
|  shall   the  fact of  distribution   constitute  any   such  warranty.   No
|  responsibility is assumed by the SEI or CMU in connection herewith.
|
\*--------------------------------------------------------------------------*/


/*-------------------- Includes --------------------------------------------*/

#include "cmd_defs.h"		/* command definitions shared between 
				   application and dialogue		    */
#include <signal.h>		/* unix signal stuff			    */
#include "ect.h"
#include "ehf.h"                /* hash functions                      	    */
#include "emp.h"                /* mapping abstraction 		            */
#include "evc.h"
#include "evc_cmd.h"
#include "eva.h"		/* variable abstraction			    */
#include "esx_sd.h"		/* variable sd abstraction		    */
#include "exc_cmd.h"		/* variable command abstraction		    */
#include "eat.h"		/* attribute abstraction		    */
#include "esa_sd.h"		/* attribute sd abstraction		    */
#include "eac_cmd.h"		/* attribute command abstraction	    */
#include "eta.h"
#include "eme.h"		/* method abstraction			    */
#include "esm_sd.h"		/* method sd abstraction		    */
#include "emc_cmd.h"		/* method command abstraction		    */

#include "eob.h"		/* object abstraction		 	    */
#include "eso_sd.h"		/* object sd abstraction		    */
#include "eoc_cmd.h"		/* object command abstraction	 	    */

#include "esv.h"                /* vc sdd abstraction 		            */
#include "esd.h"                /* dialogue sdd abstraction                 */
#include "ecd.h"		/* dialogue editor dialogue abstraction	    */

#define _e22__main
#include "e22.h"


#define DEBUG1(statement) SERPENT_DEBUG1(eci_debug, statement)
#define DEBUG2(statement) SERPENT_DEBUG2(eci_debug, statement)
#define DEBUG3(statement) SERPENT_DEBUG3(eci_debug, statement)

#define VERSION_NUMBER "0.12"


static int eci_debug = 0;
static LIST command_list;	/* ordered list of commands to execute */



/*--------------------------------------------------------------------------*\
|  Routine: eci_quit
| 
|  Description:  
|     this interrupt handler is here because the dm sends a control-c to 
|     the application.  this interrupt handler should be replaced with a 
|     big no-op, or better still this entire interrupt handler removed
|     when the dm is fixed.
\*--------------------------------------------------------------------------*/
void eci_quit()
{
/* ?? need to have something to keep from interrupting "atomic actions
       (like save) */

			/* Perform cleanup.  */
  eta_cleanup ();
  serpent_cleanup ();
  check_status ("eci_quit:  bad status from serpent_cleanup.");

  fprintf (stdout, "\n\nDialogue editor application exiting.\n");

  exit(0);
  
}				/* end eci_quit				    */


/*--------------------------------------------------------------------------*\
|  Routine: eci_send_status_2_dialogue
| 
|  Description:  
|     send s status element off to the dialogue
\*--------------------------------------------------------------------------*/
static void eci_send_status_2_dialogue (command, the_status, change_flag,
				        outgoing)
int command;
int the_status;
boolean change_flag;
transaction_type outgoing;
{  status_sdd status_sd;
                        
   status_sd.command = command;
   status_sd.status = the_status;
   status_sd.dialogue_changed = change_flag;
   add_shared_data (outgoing, "status_sdd", NULL, &status_sd);
   check_status ("eci_send_status_2_dialogue:bad status from add_shared_data");
   return;
}					/* end eci_send_status_2_dialogue */


/*--------------------------------------------------------------------------*\
|  Routine: eci_router
| 
|  Description:  
|     The eci_router routine will either update the data base if the given
|     id corresponds to a data element, or invoke the proper routine to 
|     execute the command if the id corresponds to a command.
\*--------------------------------------------------------------------------*/
void eci_router(incoming, outgoing)
transaction_type incoming;
transaction_type outgoing;
{  change_type change;
   string element_name;
   command_sdd *command;
   parameter_sdd *parameter;
   evc_vc vc;
   vc_sdd vc_sd;
   eva_variable variable;
   variable_sdd variable_sd;
   eob_object object;
   object_sdd object_sd;
   eat_attribute attribute;
   attribute_sdd attribute_sd;
   eme_method method;
   method_sdd method_sd;
   dialogue_sdd dialogue_sd;
   id_type id, temp_id;
   parameter_sdd *temp_parm;
   LIST obj_inst_creates, obj_inst_removes;
   object_instance_sdd *obj_inst;
   object_instance_attribute_sdd *att_inst;
   caddr_t save_it, save_it_1;
   boolean something_worked, is_a_change;

			/* Get the first changed element from the transaction
			   and the element name.  */
	
   obj_inst_creates = make_list ();
   obj_inst_removes = make_list ();
   something_worked = FALSE;
   is_a_change = FALSE;

   id = get_first_changed_element (incoming);
   check_status ("eci_router: bad status from get_first_changed_element.");

			/* Process the elements in the transaction.  */
   while (id != null_id) {

/*--------------------------------------------------------------------------*\
|
|  For each element:  
|
|	If command -> add to ordered command list.
|	else if parameter -> add to local parameter hash table
|	else if object instance -> process it
|	else if atribute instance -> process it
|	else if data element 
|         if create -> add to local parameter table
|         else modify -> incorporate change
|
|  Constraints:
|
|	1.  Commands and associated parameters are always packaged in the
|	    same transaction.
|	2.  There may be multiple commands per transaction.
|	3.  The commands are not in any defined order.
|	4.  The commands/parameters may be intermixed with data elements.
|
\*--------------------------------------------------------------------------*/

   element_name = get_element_name(incoming, id);
   check_status ("eci_router:  bad status from get_element_name.");

			/* Determine change type */
   change = get_change_type(incoming, id);
   check_status("eci_router:  bad status from get_change_type.");

/* -------------------------  command_sdd  -----------------------------*/
   if (strcmp(element_name, "command_sdd") == 0)
			/* command	    */
      {
			/* Get command record and insert it into the command
			   list.  */
      command = (command_sdd *)get_shared_data(incoming, id, NULL);
      check_status("eci_router:  bad status from get_shared_data.");

      insert_list_val(command_list, command, id);
			/* Remove command_sd instance from shared database. */
      remove_shared_data(outgoing, "command_sdd", id);
      check_status("eci_router: bad status from remove_shared_data.");

    }				/* end if element is a command		    */

/* -------------------------  parameter_sdd  -----------------------------*/
    else if (strcmp(element_name, "parameter_sdd") == 0) { /* parameter	    */


      parameter = (parameter_sdd *)isd_get_shared_data(incoming, id, NULL);
      check_status("eci_router:  bad status from isd_get_shared_data.");

      parameter->self = id; 

      add_to_hashtable(parameter_table, parameter, id);
      remove_shared_data(outgoing, "parameter", id);
      check_status("eci_router: bad status from remove_shared_data.");
    }				/* end else if element is a parameter	    */

/* -------------------------  object_instance_sdd  --------------------------*/
    else if (!strcmp(element_name, "object_instance_sdd"))
      {switch (change)
         {case create:

            obj_inst = (object_instance_sdd *)
			   get_shared_data (incoming, id, NULL);
            check_status ("eci_router:  bad status from gsd for object sdd");
            emp_create_map (id, obj_inst);
            add_to_tail (obj_inst_creates, obj_inst);
            break;

         case modify:
            obj_inst = (object_instance_sdd *) emp_get_de(id);

			/* save some stuff , in case the dialogue
			   trashed the component */
            save_it = (caddr_t) obj_inst-> template;
            save_it_1 = (caddr_t) obj_inst-> attr_list;

            incorporate_changes (incoming, id, obj_inst);

			/* now restore the saved stuff */
            obj_inst-> template = (id_type) save_it;
            obj_inst-> attr_list = (id_type) save_it_1;

			/* change name in template if different from that in
			   instance */
            if (strcmp (eob_get_name (obj_inst-> template), obj_inst-> name))
               {eob_set_name (obj_inst-> template, obj_inst-> name);
                        /* if the dialogue knows about the template associated
                           with this instance (as indicated by an entry in the
                           mapping table) update the associated sd */
               if (emp_get_id (obj_inst-> template) != null_id)
                  eso_modify_sd (outgoing, obj_inst-> template);
               }
            is_a_change = TRUE;
            something_worked = TRUE;
            break;

         case remove:
            obj_inst = (object_instance_sdd *) emp_get_de(id);
            add_to_tail (obj_inst_removes, obj_inst);
            break;

         default:
            fprintf(stderr,
                     "eci_router: unknown change type of %d for object sdd\n",
                     change);
            break;
         }
      }				/* end if object_instance_sdd */

/* -------------------------  object_instance_attribute_sdd  ----------------*/
    else if (!strcmp(element_name, "object_instance_attribute_sdd"))
      {switch (change)
         {case create:
            att_inst = (object_instance_attribute_sdd *)
                           get_shared_data (incoming, id, NULL);
            check_status ("eci_router:  bad status from gsd for att sdd");
            emp_create_map (id, att_inst);
            break;

         case modify:
            att_inst = (object_instance_attribute_sdd *) emp_get_de (id);
			/* save some stuff, in case the dialogue
			   trashed the component */
            save_it = (caddr_t) att_inst-> template;
            save_it_1 = (caddr_t) att_inst-> attr_list;
            incorporate_changes (incoming, id, att_inst);
			/* now restore the saved stuff*/
            att_inst-> template = (id_type) save_it;
            att_inst-> attr_list = (id_type) save_it_1;
            eat_inst_2_temp (save_it, att_inst-> name, att_inst-> value);
            if (get_status ())
               fprintf (stderr,
	"eci_router: cannot update an att template w/new instance value\n");

			/* if the dialogue knows about the template associated
			   with this instance (as indicated by an entry in the
			   mapping table) update the associated sd */
            if (emp_get_id (att_inst-> template) != null_id)
               esa_modify_sd (outgoing, att_inst-> template);
            is_a_change = TRUE;
            something_worked = TRUE;
            break;

         case remove:
			/* Need do nothing for remove of attribute, the remove
			   of the object will cause all the attrs to be
			   removed */
            break;

         default:
            fprintf (stderr,
              "eci_router: unknown change type of %d for att sdd\n",
              change);
            break;
         }			/* end switch				*/

      }				/* end if object_instance_attribute_sdd */

    else
			/* we have a data element	    */
      {
			/* If change type is modify correlate id with existing
			   data element.  */
      if (change == isd_modify)
         {
			/* Depending on the element type call the appropriate
			   modification routine.  */
         if (strcmp(element_name, "dialogue_sdd") == 0)

/*-------------------------- dialogue_sdd  ----------------------------------*/
            {
			/*  The following line shouldn't really be necessary
			   since we actually know which dialogue it is.
			   however, this will be useful later on when we
			   support multiple dialogues.  */
            e22_dialogue = (edg_dialogue)emp_get_de(id);

			/* Recreate the shared data element then incorporate
			   the changes.  */
            dialogue_sd = esd_set_dialogue_sdd (e22_dialogue);
            check_status("eci_router:  bad status from esv_set_vc_sdd.");

            incorporate_changes(incoming, id, &dialogue_sd);
            check_status("eci_router:  bad status from incorporate_changes.");

			/* Modify the dialouge according to the data in the
			   dialogue_sd.  */
            esd_modify_dialogue (e22_dialogue, dialogue_sd);  
            check_status("eci_router:  bad status from esd_modify_dialogue.");
            is_a_change = TRUE;
            something_worked = TRUE;
	    }						/* end if dialogue  */

/*-------------------------- vc_sdd  ----------------------------------------*/

         else if (strcmp(element_name, "vc_sdd") == 0)
            {vc = (evc_vc)emp_get_de(id);

			/* Recreate the shared data element then incorporate
			   the changes.  */
            vc_sd = esv_set_vc_sdd(vc);
            check_status("eci_router:  bad status from esv_set_vc_sdd.");
            incorporate_changes(incoming, id, &vc_sd);
            check_status("eci_router:  bad status from incorporate_changes.");

			/* Modify the vc according to the data in the vc_sd.  */
            esv_modify_vc(vc, vc_sd);
            check_status("eci_router:  bad status from esv_modify_vc.");
            is_a_change = TRUE;
            something_worked = TRUE;
	    }						/* end else if vc   */

/*-------------------------- variable_sdd  ---------------------------------*/

         else if (strcmp(element_name, "variable_sdd") == 0)
            {variable = (eva_variable)emp_get_de(id);

			/* Recreate the shared data element then incorporate
			   the changes.  */
            variable_sd = esx_make_sd_struct(variable);
            check_status("eci_router:  bad status from esv_set_variable_sdd.");
            incorporate_changes(incoming, id, &variable_sd);
            check_status("eci_router:  bad status from incorporate_changes.");

			/* Modify the variable according to the data in the
			   variable_sd.  */
            esx_modify_variable(variable, variable_sd);
            check_status("eci_router:  bad status from esx_modify_variable.");
            is_a_change = TRUE;
            something_worked = TRUE;
	    }					/* end else if variable   */

/*-------------------------- object_sdd  -----------------------------------*/

        else if (strcmp(element_name, "object_sdd") == 0)
            {object = (eob_object) emp_get_de(id);

			/* Recreate the shared data element then incorporate the
			   changes */
            object_sd = eso_make_sd_struct(object);
            check_status ("eci_router:  bad status from esv_set_object_sdd.");
            incorporate_changes (incoming, id, &object_sd);
            check_status ("eci_router:  bad status from incorporate_changes.");

			/* Modify the object according to the data in the
			   object_sd */
            eso_modify_object (outgoing, object, object_sd);
            check_status ("eci_router:  bad status from eso_modify_object.");
            is_a_change = TRUE;
            something_worked = TRUE;
	    }					/* end else if object   */

/*-------------------------- attribute_sdd  ---------------------------------*/

        else if (strcmp(element_name, "attribute_sdd") == 0)
            {attribute = (eat_attribute) emp_get_de (id);

			/* get a shared data element then incorporate the
			   changes */
            attribute_sd = esa_make_sd_struct (attribute);
            check_status ("eci_router:  bad status from esa_make_sd_struct");
            incorporate_changes (incoming, id, &attribute_sd);
            check_status ("eci_router:  bad status from incorporate_changes.");

			/* Modify the attribute template according to the data
			   in the attribute_sd */
            esa_modify_attribute (outgoing, attribute, attribute_sd);
            check_status ("eci_router:  bad status from esa_modify_attribute");
            is_a_change = TRUE;
            something_worked = TRUE;
            }					/* end else if attribute   */

/*-------------------------- method_sdd  ------------------------------------*/

        else if (strcmp(element_name, "method_sdd") == 0)
            {method = (eme_method)emp_get_de(id);

			/* Recreate the shared data element then incorporate
			   the changes.  */
            method_sd = esm_make_sd_struct(method);
            check_status("eci_router:  bad status from esv_set_method_sdd.");
            incorporate_changes(incoming, id, &method_sd);
            check_status("eci_router:  bad status from incorporate_changes.");

			/* Modify the method according to the data in the
			   method_sd.  */
            esm_modify_method(method, method_sd);
            check_status("eci_router:  bad status from esv_modify_method.");
            is_a_change = TRUE;
            something_worked = TRUE;
	    }					/* end else if method   */

/*-------------------------- Unknown ---------------------------------------*/

	else
			/* unknow shared data element	    */
            {fprintf (stderr,
		      "eci_router: unknown shared data element of %s\n",
		      element_name);
	    }				/* end else unkown shared data elem */

      }				/* end if change type is modify		    */

			/* If change type of remove the dialogue has deleted a
			   dialogue element, therefore remove it from the
			   shared data mapping and destroy the element.  */
      else if (change == isd_remove)
         {
			/* Delete the mapping from the id_table if one exists */
         if ((strcmp(element_name, "status_sdd") != 0)
                &&
             (strcmp(element_name, "technology_sdd") != 0))
            {emp_destroy_map_by_id(id);
            check_status("eci_router:  bad status from emp_destroy_map.");
	    }
        
         }
      else
			/* any other change type */
         {fprintf (stderr, "eci_router: unknown change type of %d\n", change);
         }			/* end of bad change type */

			/* if a problem happened, notify dialogue */
      if (get_status ())
         {eci_send_status_2_dialogue (other_cmd, get_status(), is_a_change,
                                      outgoing);
         break;
         }
			/* if this did NOT have to do with a status, mark to
			   send through a status */
      if (strcmp (element_name, "status_sdd"))
         something_worked = TRUE;
      }				/* end else element is a data element	    */

   id = get_next_changed_element(incoming);
   check_status("eci_router:  bad status from get_next_changed_elem.");

   }                             /* end while remaining changed elements     */


			/* now do the instance stuff, we had to wait until the
			   entire transaction was read. */

			/* Process all the object creates */
   loop_through_list (obj_inst_creates, obj_inst, object_instance_sdd *)
      {is_a_change = TRUE;
      if (! evc_add_object_instance (edg_get_vc (e22_dialogue), obj_inst,
				      outgoing))
			/* if we have an error creating the instance,
			   notify the dialogue */
         {eci_send_status_2_dialogue (add_object_instance_cmd, get_status (),
				      is_a_change, outgoing);
         break;
         }
      something_worked = TRUE;
      }
   free_list (obj_inst_creates, NOT_NODES);

			/* Process all the object removes */
   loop_through_list (obj_inst_removes, obj_inst, object_instance_sdd *)
      {is_a_change = TRUE;
      if (! evc_remove_object_instance (edg_get_vc (e22_dialogue), obj_inst,
					outgoing))
			/* if we have an error deleting the instance,
			   notify the dialogue */
         {eci_send_status_2_dialogue (delete_object_instance_cmd, get_status(),
				      is_a_change, outgoing);
         break;
         }
      something_worked = TRUE;
      }
   free_list (obj_inst_removes, NOT_NODES);

			/* now, if something worked ok, tell the dialogue */
   if (something_worked)
      eci_send_status_2_dialogue (other_cmd, ok, is_a_change, outgoing);


			/* now do the commands, we had to wait until the
			   entire transaction was read.  Execute command list
			   (commands are sorted in ascending order).  */

			/* Get the first command.  */
  command = (command_sdd *)get_from_head(command_list);

  while (command != NULL)
    {is_a_change = FALSE;
    switch (command->type) {	/* swith on command name    */

/*--------------------------- New Dialogue --------------------------------*/

      case new_dialogue_cmd:
        e22_dialogue = ecd_new_dialogue (command, outgoing);
        break;

/*--------------------------- Load Dialogue --------------------------------*/

      case load_dialogue_cmd:
        e22_dialogue = ecd_load_dialogue (command, outgoing);
        break;

/*--------------------------- Save Dialogue --------------------------------*/

      case save_dialogue_cmd:
        ecd_save_dialogue(command, outgoing);
        break;

/*--------------------------- Unload Dialogue ------------------------------*/

      case unload_dialogue_cmd:
        ecd_unload_dialogue(command, outgoing);
        break;

/*--------------------------- Import Dialogue ------------------------------*/

      case import_cmd:
        e22_dialogue = ecd_import_dialogue(command, outgoing);
        break;

/*--------------------------- Export Dialogue ------------------------------*/

      case export_cmd:
        ecd_export_dialogue(command, outgoing);
        break;


/*--------------------------- Get Dialogue Technologies --------------------*/

      case get_dialogue_technologies_cmd:
        ecd_get_dialogue_technologies(command, outgoing);
        break;

/*--------------------------- Set Dialogue Technologies --------------------*/

      case set_technology_cmd:
        ecd_set_technology(command, outgoing);
        is_a_change = TRUE;
        break;

/*--------------------------- Insert VC ------------------------------------*/

      case add_vc_cmd:
        evc_insert_vc_cmd (command, outgoing);
        is_a_change = TRUE;
        break;

/*--------------------------- Copy VC --------------------------------------*/

      case copy_vc_cmd:
        evc_copy_vc_cmd (command, outgoing);
        is_a_change = TRUE;
        break;

/*--------------------------- Move VC --------------------------------------*/

      case move_vc_cmd:
        evc_move_vc_cmd (command, outgoing);
        is_a_change = TRUE;
        break;

/*--------------------------- Delete VC ------------------------------------*/

      case delete_vc_cmd:
        evc_delete_vc_cmd (command, outgoing);
        is_a_change = TRUE;
        break;

/*--------------------------- Get Subvcs -----------------------------------*/

      case get_subvcs_cmd:
        evc_get_subvcs_cmd (command, outgoing);
        break;

/*--------------------------- VC Instantiate Stuff -------------------------*/

      case instantiate_cmd:
      case uninstantiate_cmd:
      case remove_cmd:
        evc_instantiate_guys_cmd (command, outgoing);
        is_a_change = TRUE;
        break;

/*--------------------------- Get Technologies -----------------------------*/

      case get_technologies_cmd:
        ect_get_technologies(outgoing);
        break;

/*--------------------------- Get Object Types -----------------------------*/

      case get_object_types_cmd:
        ect_get_object_types(command, outgoing);
        break;

/*--------------------------- Get Attributes -------------------------------*/

      case get_attributes_cmd:
        ect_get_attributes(command, outgoing);
        break;

/*--------------------------- Get Methods ----------------------------------*/

      case get_methods_cmd:
        ect_get_methods(command, outgoing);
        break;

/*--------------------------- Get Objects ----------------------------------*/

      case get_objects_cmd:
        eoc_get_objects(command, outgoing);
        break;

/*--------------------------- Insert Object --------------------------------*/

      case add_object_cmd:
        eoc_add_object(command, outgoing);
        is_a_change = TRUE;
        break;

/*--------------------------- Copy Object ----------------------------------*/

      case copy_object_cmd:
        eoc_copy_object(command, outgoing);
        is_a_change = TRUE;
        break;

/*--------------------------- Move Object ----------------------------------*/

      case move_object_cmd:
        eoc_move_object(command, outgoing);
        is_a_change = TRUE;
        break;

/*--------------------------- Delete Object --------------------------------*/

      case delete_object_cmd:
        eoc_delete_object(command, outgoing);
        is_a_change = TRUE;
        break;

/*--------------------------- Add Variable -------------------------------*/

      case add_variable_cmd:
        exc_add_variable(command, outgoing);
        is_a_change = TRUE;
        break;

/*--------------------------- Get Variables -------------------------------*/

      case get_variables_cmd:
        exc_get_variables(command, outgoing);
        break;

/*--------------------------- Copy Variables -------------------------------*/

      case copy_variable_cmd:
        exc_copy_variable(command, outgoing);
        is_a_change = TRUE;
        break;

/*--------------------------- Move Variables -------------------------------*/

      case move_variable_cmd:
        exc_move_variable(command, outgoing);
        is_a_change = TRUE;
        break;

/*--------------------------- Delete Variables -----------------------------*/

      case delete_variable_cmd:
        exc_delete_variable(command, outgoing);
        is_a_change = TRUE;
        break;

/*--------------------------- Get Attribute --------------------------------*/

      case get_attribute_cmd:
        eac_get_attribute(command, outgoing);
        break;

/*--------------------------- Get Method ----------------------------------*/

      case get_method_cmd:
        emc_get_method(command, outgoing);
        break;

/*--------------------------- Instance Guys --------------------------------*/
      case add_object_instance_cmd:
      case copy_object_instance_cmd:
      case delete_object_instance_cmd:
      case add_attribute_instance_cmd:
      case delete_attribute_instance_cmd:
        fprintf (stderr, "eci_router: unused instance type command, %d\n",
		 command-> type);
        set_status (invalid_request);
        break;

/*--------------------------- Invalid Command ------------------------------*/

      default:
        fprintf (stderr, "eci_router:  invalid command type = %d.\n", 
                 command->type);
        break;
    }					/* end switch			    */

			/* Notify dialogue of status of each command */
   eci_send_status_2_dialogue (command-> type, get_status (), is_a_change,
                               outgoing);
 
			/* Free parameters and commands structure.  */
   temp_id = command->parameters;

			/* free space for all parameters */
   while (temp_id != null_id)
      {temp_parm = (parameter_sdd *)delete_from_hashtable (parameter_table,
        						   temp_id);
      temp_id = temp_parm->next;
      free_node(temp_parm);            
      }					/* end while more paramters	    */

   free_node(command);

			/* Get the next command.  */
   command = (command_sdd *)get_from_head(command_list);

   }				/* end while command list not empty	    */

  return;
}					/* end eci_router */

  
/*--------------------------------------------------------------------------*\
|  Routine: dea.main
| 
|  Description:  
|     Command Interpretor for the dialogue editor dialogue.
\*--------------------------------------------------------------------------*/
main(argc,argv,envp)
int argc;
char **argv,**envp;
{  id_type id;
   int debug_level;
   boolean dialogue_specified = false;
   dialogue_sdd dialogue_sd;
   int i;
   transaction_type outgoing;
   transaction_type incoming;

  fprintf (stdout, "Welcome to the Dialogue Editor Application, Version %s\n", 
           VERSION_NUMBER);

   emp_debug = 1;

  signal(SIGINT, eci_quit);

/*----------------  Parse Command line. ------------------------------------*/

/*
   Parse command line:  de [dialogue_name] [-dn];  where n is the debug
   level in the range 0..2.
*/
  if (argc == 2) {			/* one parameter		    */
    if (argv[1][0] != '-') {		/* if first parameter is not a flag */
      dialogue_specified = true;
    }					/* end if first parm is not a flag  */
    else if (argv[1][1] == 'd') {	/* "-d" flag detected		    */
      debug_level = atoi(argv[1][2]);
      evc_debug = debug_level;
#if 0
      eio_debug = debug_level;
#endif
    }					/* end else if "-d" flag deteted    */
    else {				/* invalid flag			    */
      fprintf(stderr, "Invalid flag '%s'.\n", argv[1]);
      return;
    }					/* end else invalid flag	    */
  }					/* end if single parameter	    */

  else if (argc == 3) {			/* two parameters		    */

    if ((argv[2][0] == '-') && (argv[2][1] == 'd')) {	/* debug flag	    */
      debug_level = atoi(argv[2][2]);
      evc_debug = debug_level;
    }					/* end else debug flag		    */
    else {				/* invalid second parameter	    */
      fprintf(stderr, "Invalid second parameter.\n");
      return;
    }					/* end else invalid 2nd parameter   */
  }					/* end if 			    */

  else if (argc > 3) {			/* more than 2 parameters	    */
    fprintf(stderr, "Too many parameters.\n");
    return;
  }					/* end if too many parameters	    */
/*
   If dialogue specified load dialogue otherwise create new dialogue.
*/
  if (dialogue_specified) {		/* dialogue specified		    */
#if 0
/* ?? why is this ifed out */
    dialogue = eio_load_dialogue(argv[1]);
    if (get_status()) {			/* load failed			    */
      fprintf(stderr, "Dialogue '%s' missing or not found.\n", argv[1]);
      return;
    }					/* end if load failed		    */
#endif
  }					/* end if dialogue specified	    */


/*---------  Initialize Stuff ----------------------------------------------*/

/*
   Initialize Serpent
*/
  serpent_init(MAIL_BOX, ILL_FILE);
  check_status("dea.main:  bad status from serpent_init.");

  eta_init("techs.tx");
  check_status("dea.main:  bad status from eta_init.");  

   start_recording ("ar", "no comment at this time");


/*
   Create the id and elem hashtables.  These tables contain emp_map
   records which map all the shared data elements currently in 
   the shared data base to elements in the actual dialogue.  The 
   id_table is hashed by the id and the elem table is hashed by 
   the element handle.
*/
  id_table = make_hashtable(MAX_HASH, ehf_hash_id, ehf_match_id);
  check_null(
    id_table,
    "dea.main:  out of memory.",
    out_of_memory
  );

  elem_table = make_hashtable(MAX_HASH, ehf_hash_elem, ehf_match_elem);
  check_null(
    id_table,
    "dea.main:  out of memory.",
    out_of_memory
  );


/*-------- Wait for and Interpret Commands from DED ------------------------*/

/*
   Create the command list and parameter hash tables.
*/
  command_list = make_list();
  check_null(
    command_list,
    "dea.main:  out_of_memory during make_list.",
    out_of_memory
  );
/*
   Make a hash table to store parameters in.
*/
  parameter_table = make_hashtable(
    PARM_HASH_SIZE, 
    ehf_hash_parm, 
    ehf_match_parm
  );
  check_null (parameter_table,
              "dea.main:  out_of_memory during make_hashtable.",
              out_of_memory);

   fprintf (stdout, "Dialogue Editor Application ready\n");

			/* Process all transactions from the dialogue editor
			   dialogue.  */

  while (true) {		/* main loop				    */
/*
   Get the next transaction.
*/
    incoming = get_transaction();
    check_status("dea.main: bad status from get_transaction.");
/*
   Start a transaction.  The execution of commands will potentially result
   in shared data elements being added to this transaction, otherwise 
   and empty transaction is sent to the dialogue manager.
*/
    outgoing = start_transaction();
    check_status("eci_router:  bad status from start_transaction.");
/*
   Call router to process the transaction.
*/
    eci_router(incoming, outgoing);
/*
   Purge incoming transaction.
*/
    isd_purge_transaction(incoming);
    check_status("dm.main:  bad status from isd_purge.");
/*
   Commit outgoing transaction.
*/
    commit_transaction(outgoing);
    check_status("dea.main:  bad status from commit_transaction.");
    
  }				/* end main loop			    */
}				/* end main				    */



