static char rcsid [] =
        "$Header: /usr/users/little/serpent/mips/de/src/RCS/eob.c,v 1.23 1991/05/14 22:29:24 little Exp $";

/*--------------------------------------------------------------------------*\
|   
|  Name:  Dialogue Editor Object Abstraction (eob)
|
|  Description:  
|     The dialogue editor object abstraction provides operaions on the object
|     abstract type.
|
|

$Log: eob.c,v $
 * Revision 1.23  1991/05/14  22:29:24  little
 * fix things so the parent att works when instinstiating
 *
 * Revision 1.22  1991/05/07  17:47:01  little
 * remove the DEBUG statements so dbx does not get confused
 * add object counting functionality
 *
 * Revision 1.21  1990/12/21  14:23:07  ejh
 * strings.h => string.h
 *
 * Revision 1.20  90/12/05  19:37:26  little
 * add transaction parm to eso_make_inst_sd_struct call
 * 
 * Revision 1.19  90/11/29  10:01:50  rcs
 * fixed symbol table problem
 * 
 * Revision 1.18  90/11/09  14:38:47  ejh
 * an fprintf was missing stderr
 * 
 * Revision 1.17  90/10/23  14:05:51  little
 * add a new prop to an object: object_type_prop which contains the glue widget
 *    "associated" with the object.  also add routines to [sg]et this new prop.
 * make the calls to eta routines expect alists instead of lists.
 * change to use tx info instead of hardwired athena widget names
 *    and attribute names and order
 * 
 * Revision 1.16  90/09/20  15:54:41  rcs
 * no change
 * 
 * Revision 1.15  90/09/17  22:19:07  little
 * fix duplication
 * 
 * Revision 1.14  90/09/11  08:34:43  little
 * add third parameter to esi_buffer_src_write calls
 * add duplicating the methods to eob_duplicate
 * 
 * Revision 1.13  90/09/07  18:27:39  little
 * no changes
 * 
 * Revision 1.12  90/08/07  16:17:45  little
 * no changes
 * 
 * Revision 1.11  90/08/06  16:37:26  little
 * change eob_destroy_object so it actually destroys the lists of things
 * within objects
 * i mean so that is destroys the instance associated wiht an object.
 * 
 * Revision 1.10  90/07/05  15:05:56  little
 *  more structure and visualizer parts integration
 * 
 * Revision 1.9  90/06/14  13:54:34  little
 *  more changes to integrate visulization and structure editors
 * 
 * Revision 1.8  90/06/06  18:05:11  little
 * parital update to support combination of visual and structural editor
 * 
 * Revision 1.7  90/05/21  13:35:11  little
 * fix up for multiple includes & start mods for visu/struc editor integration
 * 
 * Revision 1.6  89/12/18  14:55:09  bmc
 * no changes.
 * 
 * Revision 1.5  89/12/18  14:20:05  little
 * fixed some shit that was wrong
 * 
 * Revision 1.4  89/12/12  16:43:33  bmc
 * eob_create_object now correctly initializes parent to EVC_NO_VC instead of
 * EOB_NO_OBJECT.
 * 
 * Revision 1.3  89/12/11  17:42:40  little
 * change eob_set_type to use est_set_string_property
 * 
 * Revision 1.2  89/12/04  17:24:35  bmc
 * objects now store technology name and type
 * 
 * Revision 1.1  89/11/29  09:38:42  bmc
 * Initial revision
 * 

|
|-----------------------------------------------------------------------------
|
|   Distribution: Approved for public release; distribution is unlimited.
|
|   Copyright (c) 1989  by  Carnegie  Mellon  University, Pittsburgh, PA.  The
|  Software Engineering  Institute  (SEI) is a federally  funded  research and
|  development center established  and  operated by Carnegie Mellon University
|  (CMU).  Sponsored  by  the  U.S.  Department  of   Defense  under  contract
|  F19628-85-C-0003,  the  SEI  is  supported  by  the  services  and  defense
|  agencies, with the U.S. Air Force as the executive contracting agent.
|
|    Permission to use,  copy,  modify, or  distribute  this  software and its
|  documentation for  any purpose and without fee  is hereby granted, provided
|  that  the above copyright notice appear  in  all copies and that both  that
|  copyright  notice  and   this  permission  notice  appear   in   supporting
|  documentation.   Further,  the  names  Software  Engineering  Institute  or
|  Carnegie  Mellon  University  may  not be used in  advertising or publicity
|  pertaining to distribution of the software without specific, written  prior
|  permission.  CMU makes no claims  or representations  about the suitability
|  of this software for any purpose.  This software is provided "as is" and no
|  warranty,  express  or  implied,  is  made  by  the  SEI  or CMU, as to the
|  accuracy  and  functioning of the program and related program material, nor
|  shall   the  fact of  distribution   constitute  any   such  warranty.   No
|  responsibility is assumed by the SEI or CMU in connection herewith.
|
\*--------------------------------------------------------------------------*/

/*-------------------- Includes --------------------------------------------*/

#define eob_main
#include "eat.h"
#include "eme.h"
#include "eat_priv.h"
#include "eob.h"
#include "eob_priv.h"
#include "est.h"
#include "esi.h"
#include "ebi.h"
#include "eso_sd.h"
#include "esa_sd.h"
#include "eta.h"
#include "ea2.h"
#include "e22.h"
#include "cus.h"
#include "serpent.h"
#include "ubo.h"
#include "u22.h"
#include <string.h>



#undef DEBUG1
#undef DEBUG2
#undef DEBUG3
#define DEBUG1(statement) SERPENT_DEBUG1(eob_debug, statement)
#define DEBUG2(statement) SERPENT_DEBUG2(eob_debug, statement)
#define DEBUG3(statement) SERPENT_DEBUG3(eob_debug, statement)

#define OBJECT_SYMBOL_PREFIX	"EOB"


#define print_object(prefix,the_object) \
    (void) fprintf (stderr, "%s %s (%s)\n", prefix, \
	eob_get_name (the_object), \
	cus_sym_representation ((cus_sym) the_object));

#define no_object_specified(routine) \
    (void) fprintf (stderr, "%s: empty object specified\n", routine)

#define no_variable_specified(routine) \
    (void) fprintf (stderr, "%s: empty variable specified\n", routine)

#define no_attribute_specified(routine) \
    (void) fprintf (stderr, "%s: empty attribute specified\n", routine)

#define no_method_specified(routine) \
    (void) fprintf (stderr, "%s: empty method specified\n", routine)

#define vc_name(the_vc) \
    (the_vc == EVC_NO_VC ? "No VC" : evc_get_name (the_vc))

#define attribute_name(the_attribute) \
    (the_attribute == EAT_NO_ATTRIBUTE ? "No Attribute" :\
    eat_get_name (the_attribute))

#define method_name(the_method) \
    (the_method == EME_NO_METHOD ? "No Attribute" :\
    eme_get_name (the_method))

#define bum_obj \
   {set_status (system_operation_failed); \
   return (EOB_NO_OBJECT); \
   }

#define write_buffer(stream, buffer, the_selector) \
{  ebi_buffer a_buffer; \
   a_buffer.actual_buffer = buffer; \
   a_buffer.selector = the_selector; \
   if (!ebi_write_buffer (stream, a_buffer)) \
      {set_status (system_operation_failed); \
      return; \
      } \
}

#define write_open_record(stream) \
   if (!ebi_write_open_record (stream)) \
      {set_status (system_operation_failed); \
      return; \
      }

#define write_close_record(stream) \
   if (!ebi_write_close_record (stream)) \
      {set_status (system_operation_failed); \
      return; \
      }

#define read_open_record(stream) \
   if (!(ebi_read_token_char (stream) == EBI_OPEN_RECORD)) \
      bum_obj;

#define read_close_record(stream) \
   if (!(ebi_read_token_char (stream) == EBI_CLOSE_RECORD)) \
      bum_obj;

#define read_buffer(stream, some_buffer, the_selector) \
   some_buffer = ebi_read_buffer (stream); \
   if (some_buffer.selector != the_selector) \
      bum_obj;


/*--------------------------------------------------------------------------*\
|  Routine: eob_create_object
| 
|  Description:  
|     Creates a new object.  objects use symbol table properties as follows
|
|       property name                   use
|       ---------------------------------------------------------
|	parent_vc_prop			object's parent vc 
|	obj_type_text_prop		text version of object type (widget
|					name)
|	object_technology_prop		text version of technology which the
|					object is a part of
|	name_text_prop			name of object (that given by the
|					editor type person)
|	attributes_prop			attributes of object
|	methods_prop			methods of object
|	object_comments_text_prop	retained comments for object
|	object_type_prop		the glue widget type of the object
|
\*--------------------------------------------------------------------------*/
eob_object eob_create_object (object_type, technology)
string object_type;
string technology;
{  cus_sym object_ste = (cus_sym) EOB_NO_OBJECT;
   buffer dummy_buffer;
   WIDG *the_widget;

   set_status (ok);

   object_ste = cus_gensym (OBJECT_SYMBOL_PREFIX, object_sym, NO_SEED);
   if (get_status () != ok)
      fprintf (stderr,
	       "eob_create_object: can't add object to symbol table.\n");

   else if (!(the_widget = eta_get_glue_widget (technology, object_type)))
      fprintf (stderr,
               "eob_create_object: cannot get glue widget for object\n");

   else
			/* Initialize all fields in created object. */
      {eob_set_parent (object_ste, EVC_NO_VC);
      eob_set_type (object_ste, object_type);
      est_set_string_property (object_ste, object_technology_prop, technology);
      est_set_string_property (object_ste, name_text_prop, EST_DEFAULT_NAME);
      cus_put_prop (object_ste, attributes_prop, make_list ());
      cus_put_prop (object_ste, methods_prop, make_list ());
      eob_set_widget (object_ste, the_widget);

			/* It's okay to use a local buffer, since
			   est_set_buffer_property stores a copy of the buffer,
			   not the buffer itself.  */
      init_buffer (dummy_buffer);
      est_set_buffer_property (object_ste, object_comments_text_prop,
			       dummy_buffer);
      edg_increment_object_count (e22_dialogue, technology);
      }

   return ((eob_object) object_ste);
}					/* end eob_create_object */


/*--------------------------------------------------------------------------*\
|  Routine: eob_destroy_object
| 
|  Description:  
|     Destroys a specified object and all its attributes
\*--------------------------------------------------------------------------*/
void eob_destroy_object (the_object, out_trans)
eob_object the_object;
transaction_type out_trans;
{
   LIST list;
   eat_attribute attribute;
   object_instance_sdd *the_instance;


    est_clear_buffer_property((cus_sym)the_object, object_comments_text_prop);
    est_clear_string_property((cus_sym)the_object, name_text_prop);
/* 
**  Destroy each attribute, then the atttribute list.
*/
    if ( (list = (LIST) cus_get_prop ((cus_sym) the_object,
				      attributes_prop)) != NULL) {
	loop_through_list (list, attribute, eat_attribute) {
	    eat_destroy_attribute (attribute);
	}

	est_free_list_property ((cus_sym) the_object, attributes_prop);
     }
/* 
**  If there is an instance and we were given a good
**  outgoing transaction, destroy the instance 
*/

   if ((the_instance = eob_get_instance (the_object)) && out_trans)
      {eoi_destroy_object_instance(the_instance, out_trans);
      check_status (
           "eob_destroy_object: bad status from eoi_destroy_object_instance");
      }

   edg_decrement_object_count (e22_dialogue, eob_get_technology (the_object));
   cus_delete_sym (the_object);

   return;
}					/* end eob_destroy_object */


/*--------------------------------------------------------------------------*\
|  Routine: eob_duplicate_object
|
|  Description:
|     Duplicates the contents of an object, returning the new object.
\*--------------------------------------------------------------------------*/
eob_object eob_duplicate_object (the_object)
eob_object the_object;
{  LIST list;
   eat_attribute cur_attribute, new_attribute;
   eob_object new_object;
   eme_method cur_method, new_method;

/* ???? should eob_duplicate_object worry about duplicating the instance */

   set_status (ok);
   if (the_object == EOB_NO_OBJECT)
      {set_status (invalid_object);
      }

    else if ((new_object = eob_create_object (eob_get_type (the_object),
					       eob_get_technology (the_object)
	      )) != EOB_NO_OBJECT )
	{est_copy_buffer_property ((cus_sym) new_object,
				  (cus_sym) the_object,
				  object_comments_text_prop);
	est_copy_string_property ((cus_sym) new_object,
				  (cus_sym) the_object,
				  name_text_prop);

				/* Copy each attribute in the attribute list */
	if ((list = (LIST) cus_get_prop ((cus_sym) the_object,
					  attributes_prop)) != NULL)
	    loop_through_list (list, cur_attribute, eat_attribute)
		{new_attribute = eat_duplicate_attribute (cur_attribute);
		if (new_attribute == EAT_NO_ATTRIBUTE)
		    /* status already set */
		    break; /* break out of loop the only way possible */

	        eob_add_attribute (new_object, new_attribute);
		}

				/* Copy each method in the methods list */
         if ((list = (LIST) cus_get_prop (the_object, methods_prop)) != NULL)
	    loop_through_list (list, cur_method, eme_method)
               {new_method = eme_duplicate_method (cur_method);
	       if (new_method == EME_NO_METHOD)
		    /* status already set */
	          break; /* break out of loop the only way possible */
	       eob_add_method (new_object, new_method);
	       }

	if (get_status () != ok)
	    {eob_destroy_object (new_object, NULL);
	    new_object = EOB_NO_OBJECT;
	    }
	} /* end if successfully created object */

    return (new_object);
}					/* end eob_duplicate_object */


/*--------------------------------------------------------------------------*\
|  Routine: eob_get_technology
| 
|  Description:
|     Returns the technology associated with an object.
\*--------------------------------------------------------------------------*/
string eob_get_technology (the_object)
eob_object the_object;
{
    string the_technology;

    set_status (ok);
    if (the_object == EOB_NO_OBJECT)
	set_status (invalid_object);

    else
	the_technology = (string) cus_get_prop ((cus_sym) the_object,
					        object_technology_prop);

    return (the_technology);
}					/* end eob_get_technology */


/*--------------------------------------------------------------------------*\
|  Routine: eob_set_parent
| 
|  Description:
|     Sets the parent of an object
\*--------------------------------------------------------------------------*/
void eob_set_parent (the_object, new_parent)
eob_object the_object;
evc_vc new_parent;
{
    set_status (ok);
    if (the_object == EOB_NO_OBJECT)
	set_status (invalid_object);

    else
	cus_put_prop ((cus_sym) the_object, parent_vc_prop, new_parent);

    return;
}					/* end eob_set_parent */


/*--------------------------------------------------------------------------*\
|  Routine: eob_get_parent
| 
|  Description:
|     Gets the parent of an object, if there is one.
\*--------------------------------------------------------------------------*/
evc_vc eob_get_parent (the_object)
eob_object the_object;
{
    evc_vc the_parent = EVC_NO_VC;


    set_status (ok);
    if (the_object == EOB_NO_OBJECT)
	set_status (invalid_object);

    else
	the_parent = (evc_vc) cus_get_prop ((cus_sym) the_object,
					    parent_vc_prop);
    return (the_parent);
}					/* end eob_get_parent */


/*--------------------------------------------------------------------------*\
|  Routine: eob_set_type
| 
|  Description:
|     Sets the type of an object
\*--------------------------------------------------------------------------*/
void eob_set_type (the_object, new_type)
eob_object the_object;
string new_type;
{
    set_status (ok);
    if (the_object == EOB_NO_OBJECT)
	set_status (invalid_object);
    else
	est_set_string_property (the_object, obj_type_text_prop, new_type);

    return;
}					/* end eob_set_type */


/*--------------------------------------------------------------------------*\
|  Routine: eob_get_type
| 
|  Description:
|     Gets the type of an object, if there is one.
\*--------------------------------------------------------------------------*/
string eob_get_type (the_object)
eob_object the_object;
{
    string the_type = NULL;

    set_status (ok);
    if (the_object == EOB_NO_OBJECT)
	set_status (invalid_object);
    else
	the_type = cus_get_prop (the_object, obj_type_text_prop);
    return (the_type);
}					/*end eob_get_type */


/*--------------------------------------------------------------------------*\
|  Routine: eob_set_name
| 
|  Description:
|     Sets the name of an object
\*--------------------------------------------------------------------------*/
void eob_set_name (the_object, new_name)
eob_object the_object;
string new_name;
{
    set_status (ok);
    if (the_object == EOB_NO_OBJECT)
	set_status (invalid_object);

    else
	est_set_string_property ((cus_sym) the_object,
				 name_text_prop,
				 new_name);

    return;
}						/* end eob_set_name */


/*--------------------------------------------------------------------------*\
|  Routine: eob_get_name
| 
|  Description:
|     Gets the name of an object
\*--------------------------------------------------------------------------*/
string eob_get_name (the_object)
eob_object the_object;
{
    string the_name = NULL;


    set_status (ok);
    if (the_object == EOB_NO_OBJECT)
	set_status (invalid_object);

    else
	the_name = (string) cus_get_prop ((cus_sym) the_object, name_text_prop);

    return (the_name);
}					/* end eob_get_name */


/*--------------------------------------------------------------------------*\
|  Routine: eob_set_comments
| 
|  Description:
|     Sets an objects's retained comments field.
\*--------------------------------------------------------------------------*/
void eob_set_comments (the_object, the_comments)
eob_object the_object;
buffer the_comments;
{
    set_status (ok);
    if (the_object == EOB_NO_OBJECT)
	set_status (invalid_object);

    else
	est_set_buffer_property ((cus_sym) the_object,
				 object_comments_text_prop,
				 the_comments);

    return;
}					/* end eob_set_comments */


/*--------------------------------------------------------------------------*\
|  Routine: eob_get_comments
| 
|  Description:
|     Gets an object's retained comments field.
|
\*--------------------------------------------------------------------------*/
buffer eob_get_comments (the_object)
eob_object the_object;
{
    buffer the_comments;


    set_status (ok);
    if (the_object == EOB_NO_OBJECT)
	{
	set_status (invalid_object);
	init_buffer (the_comments);
	}

    else
	the_comments = est_get_buffer_property ((cus_sym) the_object,
					      object_comments_text_prop);

    return (the_comments);
}					/* end eob_get_comments */


/*--------------------------------------------------------------------------*\
|  Routine: eob_add_attribute
|
|  Description:
|     Adds an attribute to the set of attributes associated with an object.
\*--------------------------------------------------------------------------*/
void eob_add_attribute (the_object, attribute)
eob_object the_object;
eat_attribute attribute;
{  LIST list;

    if (the_object == EOB_NO_OBJECT)
	set_status (invalid_object);

    else if ( (list = (LIST) cus_get_prop ((cus_sym) the_object,
					   attributes_prop)) == NULL )
	set_status (invalid_list);

    else if (! in_list (list, (NODE) attribute) )
	{eat_set_parent (attribute, the_object);
	add_to_tail (list, (NODE) attribute);
	}

    return;
}					/* end eob_add_attribute */


/*--------------------------------------------------------------------------*\
|  Routine: eob_remove_attribute
|
|  Description:
|     Removes an attribute from the set of objects associated with an object.
\*--------------------------------------------------------------------------*/
eat_attribute eob_remove_attribute (attribute)
eat_attribute attribute;
{
    eob_object parent_object;
    LIST list;


    if ( attribute == EAT_NO_ATTRIBUTE )
	set_status (invalid_attribute);

    else if ( (parent_object = eat_get_parent (attribute)) == EOB_NO_OBJECT )
	{
	set_status (invalid_attribute);
	(void) fprintf (stderr,
	    "eob_remove_attribute: can't get parent object for attribute\n");
	}

    else if ( (list = (LIST) cus_get_prop ((cus_sym) parent_object,
					   attributes_prop)) == NULL )
	set_status (invalid_list);

    else if (in_list (list, (NODE) attribute) )
	{
	eat_set_parent (attribute, EOB_NO_OBJECT);
	(void) delete_list_node (list, (NODE) attribute);
	}

    return (attribute);
}					/* end eob_remove_attribute */


/*--------------------------------------------------------------------------*\
|  Routine: eob_get_attributes
|
|  Description:
|     Returns the set of objects associated with an object, in the form of a
|     Zimmermann list.
\*--------------------------------------------------------------------------*/
LIST eob_get_attributes (the_object)
eob_object the_object;
{
    LIST real_list;
    LIST copy_of_list = NULL;


    if (the_object == EOB_NO_OBJECT)
	set_status (invalid_object);

    else if ( (real_list = (LIST) cus_get_prop ((cus_sym) the_object,
						attributes_prop)) == NULL )
	{set_status (invalid_list);
	print_object ("eob_get_attributes: null attributes_prop for obj. ",
			  the_object);
	}

    else if ( (copy_of_list = copy_list (real_list, NOT_NODES)) == NULL )
	{set_status (out_of_memory);
	print_object ("eob_get_attributes: can't build attr. list for obj ",
			  the_object);
	}

    return (copy_of_list);
}					/* end eob_get_attributes */


/*--------------------------------------------------------------------------*\
|  Routine: eob_add_method
|
|  Description:
|     Adds an method to the set of methods associated with an object.
\*--------------------------------------------------------------------------*/
void eob_add_method (the_object, method)
eob_object the_object;
eme_method method;
{  LIST list;

    if (the_object == EOB_NO_OBJECT)
	set_status (invalid_object);

    else if ( (list = (LIST) cus_get_prop ((cus_sym) the_object,
					   methods_prop)) == NULL )
	{set_status (invalid_list);
	print_object ("eob_add_method: null methods_prop for object ",
			  the_object);
	}

    else if (! in_list (list, (NODE) method) )
	{
	eme_set_parent (method, the_object);
	(void) add_to_tail (list, (NODE) method);
	}

    return;
}					/* end eob_add_method */


/*--------------------------------------------------------------------------*\
|  Routine: eob_remove_method
|
|  Description:
|     Removes an method from the set of objects associated with an object.
\*--------------------------------------------------------------------------*/
eob_object eob_remove_method (method)
eme_method method;
{  eob_object parent_object;
   LIST list;


    if ( method == EME_NO_METHOD)
	set_status (invalid_method);

    else if ( (parent_object = eme_get_parent (method)) == EOB_NO_OBJECT )
	{
	set_status (invalid_method);
	(void) fprintf (stderr,
	    "eob_remove_method: can't get parent object for method\n");
	}

    else if ( (list = (LIST) cus_get_prop ((cus_sym) parent_object,
					   methods_prop)) == NULL )
	{set_status (invalid_list);
	print_object ("eob_add_method: null methods_prop for object ",
			  parent_object);
	}

    else if (in_list (list, (NODE) method) )
	{
	eme_set_parent (method, EOB_NO_OBJECT);
	(void) delete_list_node (list, (NODE) method);
	}

    return (method);
}					/* end eob_remove_method */


/*--------------------------------------------------------------------------*\
|  Routine: eob_get_methods
|
|  Description:
|     Returns the set of objects associated with an object, in the form of a
|     Zimmermann list.
\*--------------------------------------------------------------------------*/
LIST eob_get_methods (the_object)
eob_object the_object;
{  LIST real_list;
   LIST copy_of_list = NULL;


    if (the_object == EOB_NO_OBJECT)
	set_status (invalid_object);

    else if ( (real_list = (LIST) cus_get_prop ((cus_sym) the_object,
						methods_prop)) == NULL )
	{set_status (invalid_list);
	print_object ("eob_add_method: null methods_prop for object ",
			  the_object);
        }

    else if ( (copy_of_list = copy_list (real_list, NOT_NODES)) == NULL )
	{set_status (out_of_memory);
	print_object ("eob_add_method: can't build methods list for obj ",
			  the_object);
	}

    return (copy_of_list);
}					/* end eob_get_methods */


/*--------------------------------------------------------------------------*\
|  Routine: eob_parse_object_2_ed
|
|  Description:
|     convert the parser version of the variable to editor version
\*--------------------------------------------------------------------------*/
eob_object eob_parse_object_2_ed (the_object)
cus_sym the_object;
{  eob_object ed_obj;
   LIST guys, comment;
   buffer ed_comment;
   caddr_t guy;
   eat_attribute ed_att;
   eme_method ed_meth;

   ed_obj = eob_create_object (
		 cus_sym_representation (cus_get_prop (the_object,
						       object_type_prop)),
                 u22_convert_string (
			cus_sym_representation (cus_get_prop (the_object,
						       data_definition_prop)),
			LOWERCASE));

   eob_set_name (ed_obj, cus_sym_representation (the_object));

   if (comment = (LIST) cus_get_prop (the_object, object_comments_prop))
      {ed_comment = esi_comments_2_text (comment);
      eob_set_comments (ed_obj, ed_comment);
      }

   if (guys = (LIST) cus_get_prop (the_object, attributes_prop))
      {loop_through_list (guys, guy, caddr_t)
         {ed_att = eat_parse_attribute_2_ed (guy);
         eob_add_attribute (ed_obj, ed_att);
         }
      }

   if (guys = (LIST) cus_get_prop (the_object, methods_prop))
      {loop_through_list (guys, guy, caddr_t)
         {ed_meth = eme_parse_method_2_ed (guy);
         eob_add_method (ed_obj, ed_meth);
         }
      }

   return (ed_obj);
}					/* end eob_parse_object_2_ed */


/*--------------------------------------------------------------------------*\
|  Routine: eob_src_write
|
|  Description:
|     write a vc to a source stream
\*--------------------------------------------------------------------------*/
void eob_src_write (the_obj, stream)
eob_object the_obj;
FILE *stream;
{  buffer the_comment;
   LIST guys;
   caddr_t guy;

   fprintf (stream, "%s: %s\n", eob_get_name (the_obj),
                           eob_get_type (the_obj));

   the_comment = eob_get_comments (the_obj);
   if (ea2_printable_buffer (the_comment))
      esi_buffer_src_write (the_comment, stream, FALSE);

   fprintf (stream, "{\n");

   if ((guys = (LIST)eob_get_attributes (the_obj)) && (list_length (guys) > 0))
      {fprintf (stream, "ATTRIBUTES:\n");
      loop_through_list (guys, guy, caddr_t)
         {eat_src_write (guy, stream);
         }
      }

   if ((guys = (LIST) eob_get_methods (the_obj)) && (list_length (guys) > 0))
      {fprintf (stream, "METHODS:\n");
      loop_through_list (guys, guy, caddr_t)
         {eme_src_write (guy, stream);
         }
      }

   fprintf (stream, "}\n");

   return;
}                                       /* end eob_src_write */


/*--------------------------------------------------------------------------*\
|  Routine: eob_bin_write
|
|  Description:
|     write an obj template to a binary stream
\*--------------------------------------------------------------------------*/
void eob_bin_write (the_obj, stream)
eob_object the_obj;
FILE *stream;
{  LIST guys;
   caddr_t guy;

   write_open_record (stream);
   ebi_write_token_char (stream, EBI_OBJECT_SELECTOR);

   fprintf (stream, "%d ", the_obj);

   fprintf (stream, "%d ", eob_get_instance (the_obj));

   ebi_write_token (stream, eob_get_name (the_obj));

   ebi_write_token (stream, cus_sym_representation (the_obj));

   ebi_write_token (stream, eob_get_type (the_obj));

   ebi_write_token (stream, eob_get_technology (the_obj));

   write_buffer (stream, eob_get_comments (the_obj),
                 EBI_COMMENTS_SELECTOR);

   write_open_record (stream);
   if ((guys = (LIST)eob_get_attributes (the_obj)))
      loop_through_list (guys, guy, caddr_t)
         eat_bin_write (guy, stream);
   write_close_record (stream);

   write_open_record (stream);
   if ((guys = (LIST) eob_get_methods (the_obj)))
      loop_through_list (guys, guy, caddr_t)
         eme_bin_write (guy, stream);
   write_close_record (stream);

   write_close_record (stream);

   return;
}                                       /* end eob_bin_write */


/*--------------------------------------------------------------------------*\
|  Routine: eob_bin_read
|
|  Description:
|     read a vc to a binary stream
\*--------------------------------------------------------------------------*/
eob_object eob_bin_read (stream)
FILE *stream;
{  eme_method the_meth;
   eat_attribute the_att;
   string the_stupid_name, the_stupid_type, the_stupid_tech, the_token;
   eob_object the_obj;
   ebi_buffer the_buffer;
   int old_temp_handle, old_instance_handle;
   eob_template_hash_entry *hash_entry;

   the_token = ebi_read_token (stream);
   if (*the_token == EBI_BAD_CHAR)
      bum_obj;
   if (*the_token == EBI_CLOSE_RECORD)
      {if (ebi_push_token (the_token))
         return (EOB_NO_MORE_OBJECTS);
        else
         bum_obj;
      }
   if (*the_token != EBI_OPEN_RECORD)
      bum_obj;

   if (!(ebi_read_token_char (stream) == EBI_OBJECT_SELECTOR))
      bum_obj;

   if (fscanf (stream, "%d", &(old_temp_handle)) != 1)
      bum_obj;

			/* we are ignoring the instance for now, but we mite
			   use it later on when we want to do more error
			   checking */
   if (fscanf (stream, "%d", &(old_instance_handle)) != 1)
      bum_obj;

   if (!(the_stupid_name = ebi_read_token (stream)))
      bum_obj;

				/* we are not using the unique name for now */
   if (!(the_token = ebi_read_token (stream)))
      bum_obj;

   if (!(the_stupid_type = ebi_read_token (stream)))
      bum_obj;

   if (!(the_stupid_tech = ebi_read_token (stream)))
      bum_obj;

   if ((the_obj = eob_create_object (the_stupid_type, the_stupid_tech))
	==  EOB_NO_OBJECT)
      bum_obj;
   eob_set_name (the_obj, the_stupid_name);

   read_buffer (stream, the_buffer, EBI_COMMENTS_SELECTOR);
   eob_set_comments (the_obj, the_buffer.actual_buffer);

   read_open_record (stream);
   while ((the_att = eat_bin_read (stream)) != EAT_NO_MORE_ATTRIBUTES)
      {if (the_att == EAT_NO_ATTRIBUTE)
         bum_obj;
      eob_add_attribute (the_obj, the_att);
      }
   read_close_record (stream);

   read_open_record (stream);
   while ((the_meth = eme_bin_read (stream)) != EME_NO_MORE_METHODS)
      {if (the_meth == EME_NO_METHOD)
         bum_obj;
      eob_add_method (the_obj, the_meth);
      }
   read_close_record (stream);

   read_close_record (stream);

			/* now put the new template handle into the hash table
			   with the old template handle as its index, this will
			   be used by the instance reader to set up the instance
			   property */
   hash_entry = (eob_template_hash_entry *)
                       make_node (sizeof (eob_template_hash_entry));
   hash_entry -> old_template = old_temp_handle;
   hash_entry -> new_template = the_obj;
   add_to_hashtable (eob_template_hash, hash_entry, old_temp_handle);

   return (the_obj);
}                                       /* end eob_bin_read */


/*--------------------------------------------------------------------------*\
|  Routine: eob_set_instance
| 
|  Description:
|     Sets the instance of an object
\*--------------------------------------------------------------------------*/
void eob_set_instance (the_object, obj_instance)
eob_object the_object;
object_instance_sdd *obj_instance;
{
    set_status (ok);
    if (the_object == EOB_NO_OBJECT)
	set_status (invalid_object);
    else
      cus_put_prop (the_object, object_instances_prop, obj_instance);

    return;
}					/* end eob_set_instance */


/*--------------------------------------------------------------------------*\
|  Routine: eob_get_instance
| 
|  Description:
|     Gets the instance of an object, if there is one.
\*--------------------------------------------------------------------------*/
object_instance_sdd *eob_get_instance (the_object)
eob_object the_object;
{  object_instance_sdd *obj_instance;

   set_status (ok);
   if (the_object == EOB_NO_OBJECT)
      {set_status (invalid_object);
       obj_instance = (object_instance_sdd *) NULL;
       }
    else
      obj_instance = (object_instance_sdd *)
                           cus_get_prop (the_object, object_instances_prop);

   return (obj_instance);
}					/*end eob_get_instance */



#define TEMPLATE_HASH_TABLE_SIZE 511


/*--------------------------------------------------------------------------*\
|  Local Routine: eob_template_hash_fcn
| 
|  Description:
|     Calculates the hash index for the template hash table
\*--------------------------------------------------------------------------*/
static int eob_template_hash_fcn (ident)
int ident;
{
    return (ident % TEMPLATE_HASH_TABLE_SIZE);
}					/* eob_template_hash_fcn */


/*--------------------------------------------------------------------------*\
|  Local Routine: eob_template_match
| 
|  Description:
|     Determines whether a template matches an existing template in the hash
|	table
\*--------------------------------------------------------------------------*/
static boolean eob_template_match (ident, entry)
int ident;
eob_template_hash_entry *entry;
{
   return (ident== (entry-> old_template));
}					/* eob_template_match */


/*--------------------------------------------------------------------------*\
|  Routine: eob_init_template_hash
| 
|  Description:
|     initializes the obj template hash table used when reading in dialogue
|	binaries
\*--------------------------------------------------------------------------*/
void eob_init_template_hash ()
{
   eob_template_hash = make_hashtable (TEMPLATE_HASH_TABLE_SIZE,
                                       eob_template_hash_fcn,
                                       eob_template_match);
   return;
}					/* end eob_init_template_hash  */


/*--------------------------------------------------------------------------*\
|  Routine: eob_free_template_hash
| 
|  Description:
|    destroys the obj template hash table used when reading in dialogue 
|	binaries
\*--------------------------------------------------------------------------*/
void eob_free_template_hash ()
{
   free_hashtable (eob_template_hash, AND_NODES);
   return;
}					/* end eob_free_template_hash  */


/*--------------------------------------------------------------------------*\
|  Routine: eob_get_att_by_name
| 
|  Description:
|    get the attribute with the given name
\*--------------------------------------------------------------------------*/
eat_attribute eob_get_att_by_name (the_obj, att_name)
eob_object the_obj;
string att_name;
{  LIST the_atts;
   eat_attribute an_att;

   set_status (ok);
   the_atts = eob_get_attributes (the_obj);
   loop_through_list (the_atts, an_att, eat_attribute)
      if (!strcmp (att_name, eat_get_name (an_att)))
         return (an_att);
   return ((eat_attribute) NULL);
}					/* end eob_get_att_by_name */


/*--------------------------------------------------------------------------*\
|  Routine: eob_make_atts_instances
|
|  Description:
|    make the att sd instances for an object instance
\*--------------------------------------------------------------------------*/
static LIST eob_make_atts_instances (the_obj, obj_inst)
eob_object the_obj;
object_instance_sdd *obj_inst;
{  ALIST att_name_alist;
   string att_name, obj_type;
   object_instance_attribute_sdd *att_inst;
   caddr_t att_ptr;
   LIST att_inst_list;

   set_status (ok);

   obj_type = eob_get_type (the_obj);
   att_name_alist = eta_get_attributes (eob_get_technology (the_obj),
				        obj_type, NULL);
			/* it is assumed that eta_get_attributes culls the
			   attribute named method from the returned alist */
   if (!att_name_alist)
      {fprintf (stderr,
	 "eob_make_atts_instances: cannot get att namess for obj type of %s\n",
          obj_type);
      set_status (not_found);
      return ((LIST) FALSE);
      }

   att_ptr = NULL;
   att_inst_list = make_list ();
   loop_through_alist (att_name_alist, att_name, string) 
      {if (!(att_inst = eat_inst_from_temp (att_name, the_obj)))
			/* eat_inst_from_temp returns null when it could not
			   create an instance.  it is ok to not be able to
			   create an instance, but if there is really a problem
			   the status will be set */
         {if (get_status () != ok)
            {set_status (invalid_object);
            fprintf (stderr,
		  "eob_make_atts_instances: att error - att = %s, obj = %s\n",
	 	  att_name, eob_get_name (the_obj));
            return ((LIST) NULL);
            }
         }
      else
			/* set up the linked list */
         {att_inst -> attr_list = (id_type) att_ptr;
         att_ptr = (caddr_t) att_inst;
         add_to_tail (att_inst_list, att_inst);
         }
      }
			/* now set the obj instance to point to the head
			   of the att inst linked list */
   obj_inst-> attr_list = (id_type) att_ptr;
			/* remember, we should free lists returned by
			   eta_get_attributes */
   free_alist (att_name_alist, NOT_NODES);

   return (att_inst_list);
}					/* end eob_make_atts_instances */


/*--------------------------------------------------------------------------*\
|  Routine: eob_off_to_the_dialogue_lizard
| 
|  Description:
|    update an obj instance wrt the dialogue
\*--------------------------------------------------------------------------*/
void eob_off_to_the_dialogue_lizard (obj_inst, out_transaction, visibility)
object_instance_sdd *obj_inst;
transaction_type out_transaction;
boolean visibility;
{  id_type id;

   set_status (ok);
   obj_inst-> visible = visibility;
   id = emp_get_id (obj_inst);
   put_shared_data (out_transaction, id, "object_instance_sdd",
                    "visible", &(obj_inst-> visible));
   return;
}					/* end eob_off_to_the_dialogue_lizard */

/*--------------------------------------------------------------------------*\
|  routine: eob_instantiate
| 
|  Description:
|    instantiate an object if it has not already been and send to dialogue
\*--------------------------------------------------------------------------*/
void eob_instantiate (the_obj, out_transaction)
eob_object the_obj;
transaction_type out_transaction;
{  object_instance_sdd *obj_instance;
   string obj_type;
   LIST att_list;

   set_status (ok);
			/* if we do not have an instance, make one */
   if (!(obj_instance = eob_get_instance (the_obj)))
      {obj_instance = eso_make_inst_sd_struct (the_obj, out_transaction);
      if (!(att_list = eob_make_atts_instances (the_obj, obj_instance)))
         {fprintf (stderr, "eob_instantiate: cannot make att list for %s\n",
	   	   eob_get_name (the_obj));
         set_status (invalid_object_instance);
         return;
         }
      eob_set_instance (the_obj, obj_instance);
			/* now visulaize the newly made instance */
      if (!eoi_visu_obj_instance (obj_instance, att_list, out_transaction))
         {fprintf (stderr, "eob_instantiate: cannot visualize %s\n",
	   	   eob_get_name (the_obj));
         set_status (invalid_object_instance);
         return;
         }
			/* do not need this guy anymore */
      free_list (att_list, NOT_NODES);
      }
    else
			/* we already had an instance around, if it aint
			   visible, visulize it */
      {if (!obj_instance-> visible)
         {eob_off_to_the_dialogue_lizard (obj_instance, out_transaction, TRUE);
         check_status (
	    "eob_instantiate: error updating object instance wrt dialogue\n");
         }
      }

   return;
}					/* end eob_instantiate */


/*--------------------------------------------------------------------------*\
|  Routine: eob_uninstantiate
| 
|  Description:
|    uninstantiates an object - remove from screen and take out of the
|	application data base
\*--------------------------------------------------------------------------*/
void eob_uninstantiate (the_obj, out_transaction)
eob_object the_obj;
transaction_type out_transaction;
{
			/* if we do not have an instance, need do nothing */
   if (!eob_get_instance (the_obj))
      return;
   eoi_destroy_object_instance (eob_get_instance (the_obj), out_transaction);
   check_status ("eob_uninstantiate: problem getting rid of obj inst");

   return;
}					/* end eob_uninstantiate */


/*--------------------------------------------------------------------------*\
|  Routine: eob_remove_instance
| 
|  Description:
|    remove an instance - remove from screen but leave in the app data base
\*--------------------------------------------------------------------------*/
void eob_remove_instance (the_obj, out_transaction)
eob_object the_obj;
transaction_type out_transaction;
{  object_instance_sdd *obj_instance;

   set_status (ok);

                        /* if we do not have an instance, or it is not visible,
			   nothing to do */
   if ((obj_instance = eob_get_instance (the_obj)) &&
       (obj_instance-> visible))
      {eob_off_to_the_dialogue_lizard (obj_instance, out_transaction, FALSE);
      check_status (
            "eob_instantiate: error updating object instance wrt dialogue\n");
      }
   return;
}					/* end eob_remove */


/*--------------------------------------------------------------------------*\
|  Routine: eob_set_widget
| 
|  Description:
|     Sets the glue widget of an object
\*--------------------------------------------------------------------------*/
void eob_set_widget (the_object, new_widget)
eob_object the_object;
WIDG *new_widget;
{
    set_status (ok);
    if (the_object == EOB_NO_OBJECT)
	set_status (invalid_object);
    else
	cus_put_prop (the_object, object_type_prop, new_widget);
    return;
}					/* end eob_set_widget */


/*--------------------------------------------------------------------------*\
|  Routine: eob_get_widget
| 
|  Description:
|     Gets the glue widget of an object, if there is one.
\*--------------------------------------------------------------------------*/
WIDG *eob_get_widget (the_object)
eob_object the_object;
{  WIDG *the_widget = (WIDG *) NULL;

    set_status (ok);
    if (the_object == EOB_NO_OBJECT)
	set_status (invalid_object);
    else
	the_widget = (WIDG *) cus_get_prop (the_object, object_type_prop);
    return (the_widget);
}					/*end eob_get_widget */


/*--------------------------------------------------------------------------*\
|  Routine: eob_find_parent_object_template
| 
|  Description:
|     finds the parent template for a particular object template.  NOTE: this
|	is NOT the parent as determined by the vc/object hierarchy, this is
|	the parent as indicated in the snippet of the parent attribute of
|	an object
\*--------------------------------------------------------------------------*/
eob_object eob_find_parent_object_template (att_template)
eat_attribute att_template;
{  eob_object parent_template;
   LIST objs;
   eob_object an_object;
   evc_vc a_vc;
   buffer snippet;
   char  *snippet_string, *look;

   parent_template = (eob_object) NULL;
   snippet_string = (char *) NULL;

   snippet = eat_get_snippet (att_template);
   if (snippet.type != idd_string)
      return (eob_object) NULL;

   snippet_string = u22_convert_string (snippet.body, LOWERCASE);
   look = snippet_string + snippet.length - 1;
   while (*snippet_string < '\040')
      snippet_string++;
   while ((*look < '\040') ||
          (*look == ';'))
      look--;
   look++;
   *look = '\000';

   look = (char *) NULL;
   a_vc = eob_get_parent (eat_get_parent (att_template));
   while (a_vc != NULL)
      {objs = (LIST) evc_get_objects (a_vc);
      loop_through_list (objs, an_object, eob_object)
         {look = u22_convert_string (eob_get_name (an_object, LOWERCASE));
         if (!strcmp (snippet_string, look))
            {parent_template = an_object;
            goto DONE;
            }
         free_node (look);
         look = (char *) NULL;
         }
      a_vc = evc_get_parent (a_vc);
      }

DONE:
   if (snippet_string)
      free_node (snippet_string);
   if (look)
      free_node (look);
   return parent_template;
}				/* end eob_find_parent_object_template */


