static char rcsid [] =
        "$Header: /usr/users/little/serpent/sunos4/de/src/RCS/eoi.c,v 1.14 1991/07/08 19:38:28 little Exp $";

/*--------------------------------------------------------------------------*\
|   
|  Name:  Dialogue Editor Object Instance Abstraction (eoi)
|
|  Description:  
|     The dialogue editor object abstraction provides operaions on the object
|     instance abstract type.
|
|

$Log: eoi.c,v $
 * Revision 1.14  1991/07/08  19:38:28  little
 * fix up a dangling parent problem
 *
 * Revision 1.13  1991/05/07  17:49:11  little
 * add object counting functionality
 * use e22.h for the e22_dialogue external
 *
 * Revision 1.12  1991/02/07  10:28:06  little
 * add the tech name and mailbox_name to the the binary i/o for
 * object instances
 *
 * Revision 1.11  90/12/21  14:25:17  ejh
 * strings.h => string.h
 * 
 * Revision 1.10  90/11/09  14:36:29  ejh
 * a couple fprintf's were missing stderr
 * 
 * Revision 1.9  90/10/23  14:08:44  little
 * add the setting of the attr instance type to bin read.  we are getting it
 *    from glue so we need not save it on att inst bin write.
 * 
 * Revision 1.8  90/07/05  15:07:01  little
 *  more structure and visualizer parts integration
 * 
 * Revision 1.7  90/06/14  13:54:56  little
 *  more changes to integrate visulization and structure editors
 * 
 * Revision 1.6  90/06/06  18:05:28  little
 * parital update to support combination of visual and structural editor
 * 
 * Revision 1.5  90/05/21  13:35:52  little
 * fix up for multiple includes & start mods for visu/struc editor integration
 * 
 * Revision 1.4  90/03/23  14:23:40  rcs
 * *** empty log message ***
 * 
 * Revision 1.3  90/03/19  16:43:13  rcs
 * sleazed attribute code generation
 * 
 * Revision 1.2  90/03/19  13:55:51  rcs
 * good file squirreled away in sun dir
 * 
 * Revision 1.1  90/02/14  12:59:42  bmc
 * Initial revision
 * 

|
|-----------------------------------------------------------------------------
|
|   Distribution: Approved for public release; distribution is unlimited.
|
|   Copyright (c) 1989  by  Carnegie  Mellon  University, Pittsburgh, PA.  The
|  Software Engineering  Institute  (SEI) is a federally  funded  research and
|  development center established  and  operated by Carnegie Mellon University
|  (CMU).  Sponsored  by  the  U.S.  Department  of   Defense  under  contract
|  F19628-85-C-0003,  the  SEI  is  supported  by  the  services  and  defense
|  agencies, with the U.S. Air Force as the executive contracting agent.
|
|    Permission to use,  copy,  modify, or  distribute  this  software and its
|  documentation for  any purpose and without fee  is hereby granted, provided
|  that  the above copyright notice appear  in  all copies and that both  that
|  copyright  notice  and   this  permission  notice  appear   in   supporting
|  documentation.   Further,  the  names  Software  Engineering  Institute  or
|  Carnegie  Mellon  University  may  not be used in  advertising or publicity
|  pertaining to distribution of the software without specific, written  prior
|  permission.  CMU makes no claims  or representations  about the suitability
|  of this software for any purpose.  This software is provided "as is" and no
|  warranty,  express  or  implied,  is  made  by  the  SEI  or CMU, as to the
|  accuracy  and  functioning of the program and related program material, nor
|  shall   the  fact of  distribution   constitute  any   such  warranty.   No
|  responsibility is assumed by the SEI or CMU in connection herewith.
|
\*--------------------------------------------------------------------------*/

/*-------------------- Includes --------------------------------------------*/

#define eoi_main
#include "ea2_util.h"
#include "cus.h"
#include "serpent.h"
#include "ubo.h"
#include "eoi.h"
#include "emp.h"
#include "ebi.h"
#include "eob.h"
#include "e22.h"
#include "glue_intf.h"
#include <ctype.h>
#include <string.h>

#ifndef memoryPack
#define memoryPack
#endif  memoryPack
#include "memoryPack.h"
#include "hashPack.h"

                         /* this is set by eat for those instances which
                           were made before their parent */
extern LIST ea2_object_instances_not_completely_done;


#define DUMMY_TEMPLATE_NAME	"no_template"
#define NULL_ATTR_INSTANCE	((object_instance_attribute_sdd *) NULL)




#undef DEBUG1
#undef DEBUG2
#undef DEBUG3
#define DEBUG1(statement) SERPENT_DEBUG1(eoi_debug, statement)
#define DEBUG2(statement) SERPENT_DEBUG2(eoi_debug, statement)
#define DEBUG3(statement) SERPENT_DEBUG3(eoi_debug, statement)


#if 0
        typedef struct {
          int     length;
          caddr_t body;
          idd_data_types type;
        } idd_buffer_type;
#endif

#define zero_obj_instance(sdd) \
    {\
    (sdd)->template = null_id;\
    (sdd)->name [0]  = '\0';\
    (sdd)->type [0]  = '\0';\
    (sdd)->visible   = false;\
    (sdd)->tech [0]  = '\0'; \
    (sdd)->attr_list = null_id;\
    }


#define zero_attr_instance(sdd) \
    {\
    (sdd)->template = null_id;\
    (sdd)->name [0]  = '\0';\
    (sdd)->value [0] = '\0';\
    (sdd)->attr_list = null_id;\
    }


/*--------------------------------------------------------------------------*\
|  Local Routine: eoi_alloc_object_instance
| 
|  Description:  
|     Allocates and initializes an object_instance_sdd record.
|
|  Parameters:
|     None.
\*--------------------------------------------------------------------------*/
static object_instance_sdd *eoi_alloc_object_instance ()
{  object_instance_sdd *instance_sd;

   set_status (ok);
   instance_sd = (object_instance_sdd *) make_node (sizeof (*instance_sd));
   if (instance_sd == EOI_NO_OBJ_INSTANCE)
      set_status (out_of_memory);
    else
      zero_obj_instance (instance_sd);

   return (instance_sd);
}				/* end eoi_alloc_object_instance */


/*--------------------------------------------------------------------------*\
|  Local Routine: eoi_alloc_attr_instance
| 
|  Description:  
|     Allocates and initializes an object_instance_attribute_sdd record.
|
|  Parameters:
|     None.
\*--------------------------------------------------------------------------*/
static object_instance_attribute_sdd *eoi_alloc_attr_instance ()
{
    object_instance_attribute_sdd *instance_sd;


    set_status (ok);
    instance_sd = (object_instance_attribute_sdd *)
		  make_node (sizeof (*instance_sd));

    if (instance_sd == NULL_ATTR_INSTANCE)
	set_status (out_of_memory);

    else
	zero_attr_instance (instance_sd);

    return (instance_sd);
}				/* end eoi_alloc_attr_instance */


/*--------------------------------------------------------------------------*\
|  Local Routine: eoi_visu_att_instance
| 
|  Description:  
|     Inserts an attribute instance into shared data and links it to an
|     object.
|
\*--------------------------------------------------------------------------*/
static id_type eoi_visu_att_instance (att, ptr_id, transaction)
object_instance_attribute_sdd *att;
id_type ptr_id;
transaction_type transaction;
{  id_type attr_id;
   caddr_t save_ptr;

			/* save ptr version of attr_list info and put in id
			   version */
   save_ptr = (caddr_t) att-> attr_list;
   att-> attr_list = ptr_id;

			/* send att instance to dialogue */
   attr_id = add_shared_data (transaction,
			       "object_instance_attribute_sdd",
			       NULL,
			       (caddr_t) att);
   if (get_status () != ok)
      fprintf (stderr,
	       "eoi_visu_att_instance: can't send instance %s to dialogue\n",
	        att-> name);
     else
			/* Create the map entry */
      {emp_create_map (attr_id, att);
      if (get_status () != ok)
         fprintf (stderr,
		  "eoi_visu_att_instance: can't map obj %s\n", att-> name);
      }
			/* now restore the list ptr to be the handle */
   att-> attr_list = (id_type) save_ptr;
   return (attr_id);
}				/* end eoi_visu_att_instance */


/*--------------------------------------------------------------------------*\
|  Routine: eoi_visu_obj_instance
|
|  Description:
|     send obj instance on to the dialogue
|     NOTE: the att_list parameter contains the attributes in reverse order
|	    from what the dialogue expects.
\*--------------------------------------------------------------------------*/
boolean eoi_visu_obj_instance (obj_inst, att_list, trans)
object_instance_sdd *obj_inst;
LIST att_list;
transaction_type trans;
{  id_type current_id, obj_id;
   object_instance_attribute_sdd *att;
   caddr_t save_ptr;

   set_status (ok);

			/* mark the instance visible */
   obj_inst-> visible = TRUE;

			/* Loop through list of attributes and add them to
			   shared data */
   current_id = null_id;
   loop_through_list (att_list, att, object_instance_attribute_sdd *)
      {current_id = eoi_visu_att_instance (att, current_id, trans);
      if (get_status ())
          break;
      }

   if (get_status ())
      return (get_status () == ok);

                        /* save ptr version of attr_list info and put in id
                           version */
   save_ptr = (caddr_t) obj_inst-> attr_list;
   obj_inst-> attr_list = current_id;

			/* send object instance to dialogue  */
   obj_id = add_shared_data (trans, "object_instance_sdd", NULL, obj_inst);
   if (get_status ())
      {fprintf (stderr,
        "eoi_visu_obj_instance: can't send instance %s to dialogue\n",
        att-> name);
      }
    else
			/* Create map entry. */
        emp_create_map (obj_id, obj_inst);

                        /* now restore the list ptr to be the handle */
   obj_inst-> attr_list = (id_type) save_ptr;

   return (get_status () == ok);
}                               /* end eoi_visu_obj_instance */


/*--------------------------------------------------------------------------*\
|  Routine: eoi_destroy_object_instance
| 
|  Description:  
|     Destroys a specified object instance and all sub-components, unmapping
|     them and removing them from shared data.
\*--------------------------------------------------------------------------*/
void eoi_destroy_object_instance (obj_inst, transaction)
object_instance_sdd *obj_inst;
transaction_type transaction;
{  id_type obj_id, att_id;
   object_instance_attribute_sdd *att, *next_att;

   set_status (ok);
			/* First, loop through all attributes and:
			     1 - remove them from shared data
			     2 - destroy the storage they occupy */

   next_att = (object_instance_attribute_sdd *) obj_inst-> attr_list;
   while ((next_att != NULL) && (get_status () == ok))
      {att = next_att;
      if ((att_id = emp_get_id (att) == null_id))
         {fprintf (stderr,
		   "eoi_destroy_object_instance: cannot get id for att %s\n",
		   att-> name);
         set_status (invalid_object_instance);
         break;
         }
      remove_shared_data (transaction, "object_instance_attribute_sdd",
   			  att_id);
      check_status ("eoi_destroy_object_instance: can't remove sd");
			/* unlink att instance from template, if we can get to
			   template */
      if (!att-> template)
         {fprintf (stderr,
                "eoi_destroy_object_instance: att inst %s has not template\n",
                   att-> name);
         set_status (invalid_object_instance);
         break;
         }
       else
         eat_set_instance (att-> template, NULL);

			/* Save the handle to the next attribute and free the
			   storage associated with this one.  */
      next_att = (object_instance_attribute_sdd *) att-> attr_list;
      emp_destroy_map_by_de (att);
      free_node (att);
      } /* end while */

   if (get_status () == ok)
			/* Killing the attributes worked out all right.  Kill
			   the object. */
      {obj_id = emp_get_id (obj_inst);
      remove_shared_data (transaction, "object_instance_sdd", obj_id);
      check_status ("eoi_destroy_object_instance: can't remove object sd");
      emp_destroy_map_by_de (obj_inst);

			/* unlink obj instance from template, if we can get to
			   template */
      if (!obj_inst-> template)
         {fprintf (stderr,
                "eoi_destroy_object_instance: obj inst %s has not template\n",
                   obj_inst-> name);
         set_status (invalid_object_instance);
         }
       else
         eob_set_instance (obj_inst-> template, NULL);
			/* now reduce the number of objects associated with
			   this instance's technology */
      edg_decrement_object_count (e22_dialogue, obj_inst-> tech);
      free_node (obj_inst);
      }

   return;
}				/* end eoi_destroy_object_instance */


/*--------------------------------------------------------------------------*\
|  Local Routine: eoi_bin_read_attr
| 
|  Description:  
|     Reads a single att instance from an open dialogue file.
\*--------------------------------------------------------------------------*/
static object_instance_attribute_sdd *eoi_bin_read_attr (stream)
FILE *stream;
{  object_instance_attribute_sdd *attr = NULL_ATTR_INSTANCE;
   char tc;
   char *s;
   int old_template_id, old_instance_id;
   eat_template_hash_entry *hash_entry;
   ATTR *glue_attr;

   set_status (ok);

   if ( (tc = ebi_read_token_char (stream)) == EBI_CLOSE_RECORD)
		/* End of list.  Stop here.  Push the end of list character
		   back onto the input token stream.  The good status will
		   indicate that no error occurred.  */
	{if (! ebi_push_token_char (EBI_CLOSE_RECORD))
	    	/* Assume status is already set. */
	    {fprintf (stderr,
		"eoi_bin_read_attr: can't push `%c' back onto token stream\n",
		EBI_CLOSE_RECORD);
	    }
	}

    else if (tc != EBI_OPEN_RECORD)
	{set_status (invalid_object_instance);
	fprintf (stderr,
	"eoi_bin_read_attr: missing open record `%c' for attr inst\n",
	    EBI_OPEN_RECORD);
	}

    else if ( (tc = ebi_read_token_char (stream)) !=
				    EBI_OBJ_ATTR_INSTANCE_SELECTOR )
	{set_status (invalid_object_instance);
	fprintf (stderr,
	"eoi_bin_read_attr: bad selector character -- `%c'\n", tc);
	}

    else if ( (attr = eoi_alloc_attr_instance ()) == NULL_ATTR_INSTANCE )
	{set_status (out_of_memory);
	fprintf (stderr,
	"eoi_bin_read_attr: can't allocate memory for attribute\n");
	}

    else if (fscanf (stream, "%d", &(old_instance_id)) != 1)
        {set_status (invalid_attribute);
        fprintf (stderr,
            "eoi_bin_read_attr: bad old att instance id\n");
        }

    else if (fscanf (stream, "%d", &(old_template_id)) != 1)
        {set_status (invalid_attribute);
        fprintf (stderr,
            "eoi_bin_read_attr: bad old att template id\n");
        }

    else if ((s = ebi_read_token (stream)) == NULL )
	{set_status (invalid_object_instance);
	fprintf (stderr,
	    "eoi_bin_read_attr: missing attribute instance name\n");
	}

    /*
    ** The commas in the following two expressions are INTENTIONAL, and
    ** represent perfectly legal C.  See K&R (edition 1), p. 192 for details.
    ** This syntax allows us to save the previously parsed string and attempt
    ** to parse the next one, testing the success of the parse operation.
    */

    else if (strncpy (attr->name, s, sizeof (attr->name)) ,
	     ((s = ebi_read_string (stream,EBI_OBJECT_INSTANCE_VALUE_SELECTOR))
		== NULL) )
	{set_status (invalid_object_instance);
	fprintf (stderr,
	"eoi_bin_read_attr: bad attribute instance value for %s\n",
	    attr->name);
	}

    else if (strncpy (attr->value, s, sizeof (attr->value)) ,
	     (ebi_read_token_char (stream) != EBI_CLOSE_RECORD) )
	{set_status (invalid_object_instance);
	fprintf (stderr,
	    "eoi_bin_read_attr: missing close record for attr instance %s\n",
	    attr->name);
	}

    else
			/* reads worked ok, now do finaly processing */
       {if (! (hash_entry = (eat_template_hash_entry *)
                                  get_from_hashtable (eat_template_hash,
                                                      old_template_id)))
          {set_status (invalid_attribute);
          fprintf (stderr,
          "eoi_bin_read_attr: cannot map old template id for att w/name %s\n",
          attr->name);
          }
        else
                        /* everything was read in fine, do some final fixing */

          {
			/* now set the instance to point to the template and
                           vice versa */
          attr-> template = (id_type) hash_entry-> new_template;
          eat_set_instance (attr-> template , attr);

			/* set up some stuff in the sd for the dialogue */
          glue_attr = glue_get_attribute
			(eob_get_widget (eat_get_parent (attr-> template)),
                         attr-> name, SERP_NAMES);
          attr-> type = glue_attr-> x_type;
          }
       }

			/* now clean up */
    if ( (get_status () != ok) &&
	 (attr != NULL_ATTR_INSTANCE) )
		/* Problem.  Free the storage. */
	{free_node ((NODE) attr);
	attr = NULL_ATTR_INSTANCE;
	}

    return (attr);
}				/* end eoi_bin_read_attr */


/*--------------------------------------------------------------------------*\
|  Local Routine: eoi_bin_read_attr_list
| 
|  Description:  
|     Reads a list of attribute instances from an open dialogue file.
|     NOTE: the returned list is in reverse order from how it appeared in the
|           binary file.  the order in the binary file is the order which the
|	    dialogue expects.
\*--------------------------------------------------------------------------*/
static LIST eoi_bin_read_attr_list (stream)
FILE *stream;
{  LIST attr_list = NULLlist;
   boolean done_reading = false;
   object_instance_attribute_sdd *attr;
   eob_object parent_obj_template;

   if (ebi_read_token_char (stream) != EBI_OPEN_RECORD)
      {set_status (invalid_object_instance);
      fprintf (stderr,
	    "eoi_bin_read_attr_list: missing open record for attr list\n");
      }

   else if ((attr_list = make_list ()) == NULLlist )
      {set_status (out_of_memory);
      fprintf (stderr,
	    "eoi_bin_read_attr_list: can't allocate memory for list\n");
      }

			/* everything ok so far, loop through list of
			   attributes */
    else
      {while (! done_reading)
         {if ((attr = eoi_bin_read_attr (stream)) == NULL_ATTR_INSTANCE)
            done_reading = true; /* status set if error occurred */
	   else
			/* The order of the att/value pairs is coupled to
			   eoi_fix_attr_instance */
            add_to_head (attr_list, (NODE) attr);
			/* if this the parent attribute we have to do some
			  extra work.  just put it on the "to do" list,
			  the cleanup routine will handle the real work */
         if (attr && !get_status () && !strcmp (attr->name, "parent") &&
	     attr->template &&
             (parent_obj_template = (eob_object)
                              eob_find_parent_object_template (attr->template)))
            add_to_tail_val (ea2_object_instances_not_completely_done,
                             attr, parent_obj_template);

         }

			/* We've finished reading the contents of the list.  It
			   has to end with an end record.  */
      if ((get_status () == ok) &&
          (ebi_read_token_char (stream) != EBI_CLOSE_RECORD) )
         {set_status (invalid_object_instance);
         fprintf (stderr,
	       "eoi_bin_read_attr_list: missing close record for attr list\n");
         }
      } 

   if (get_status () != ok)
      {free_list (attr_list, AND_NODES);
      attr_list = NULLlist;
      }

   return (attr_list);
}				/* end eoi_bin_read_attr_list */


/*--------------------------------------------------------------------------*\
|  Local Routine: eoi_fix_obj_instance
| 
|  Description:  
|     links all the att instances together and with the object inst
|
|  Parameters:
|     the_instance - Allocated object instance
|     attr_list    - List of attribute records to be linked into the object.
\*--------------------------------------------------------------------------*/
static void eoi_fix_obj_instance (obj_instance_sd, attr_list)
object_instance_sdd *obj_instance_sd;
LIST attr_list;
{  id_type obj_id;
   object_instance_attribute_sdd *attr;
   caddr_t next;

   set_status (ok);
   next = NULL;
			/* Loop through list of attributes and link them.
			   Note the attr_list is in reverse order from how
			   the dialogue needs the att instances */
   loop_through_list (attr_list, attr, object_instance_attribute_sdd *)
      {attr-> attr_list = (id_type) next;
      next = (caddr_t) attr;
      }

			/* set set the obj instance to point to the "first"
			   att instance */
   obj_instance_sd-> attr_list = (id_type) next;

   return;
}				/* end eoi_fix_obj_instance */


/*--------------------------------------------------------------------------*\
|  eoi_bin_read
| 
|  Description:  
|     Reads an object instance from an open dialogue binary file
\*--------------------------------------------------------------------------*/

object_instance_sdd *eoi_bin_read (stream, transaction)
FILE *stream;
transaction_type transaction;
{  object_instance_sdd *obj = EOI_NO_OBJ_INSTANCE;
   char tc;
   string s = NULL;
   LIST attr_list;
   int old_template_id, old_instance_id;
   eob_template_hash_entry *hash_entry;

   set_status (ok);

    if ((tc = ebi_read_token_char (stream)) == EBI_CLOSE_RECORD)
			/* End of list.  Stop here.  Push the end of list
			   character back ** onto the input token stream.
			*/
	{if (! ebi_push_token_char (EBI_CLOSE_RECORD))
	    	/* Assume status is already set. */
	    {fprintf (stderr,
		"eoi_bin_read: can't push `%c' back onto token stream\n",
		EBI_CLOSE_RECORD);
	    }
	}

    else if ( (obj = eoi_alloc_object_instance ()) == EOI_NO_OBJ_INSTANCE )
	{set_status (out_of_memory);
	fprintf (stderr,
	    "eoi_bin_read: can't create object\n");
	}

    else if (tc != EBI_OPEN_RECORD)
	{set_status (invalid_object_instance);
	fprintf (stderr,
	    "eoi_bin_read: missing open record character\n");
	}

    else if ( (tc = ebi_read_token_char (stream)) != EBI_OBJ_INSTANCE_SELECTOR )
	{set_status (invalid_object_instance);
	fprintf (stderr,
	    "eoi_bin_read: bad selector character -- `%c'\n", tc);
	}

			/* we are not using the old instance id for now,
			   we mite use it for additional error checking
			   in the furure  */
    else if (fscanf (stream, "%d", &(old_instance_id)) != 1)
	{set_status (invalid_object_instance);
	fprintf (stderr,
	    "eoi_bin_read: bad old object instance id\n");
	}

    else if (fscanf (stream, "%d", &(old_template_id)) != 1)
	{set_status (invalid_object_instance);
	fprintf (stderr,
	    "eoi_bin_read: bad old object template id\n");
	}

    else if ((s = ebi_read_token (stream)) == NULL )
	{set_status (invalid_object_instance);
	fprintf (stderr,
	    "eoi_bin_read: missing object instance name\n");
	}

			/**** The commas in the following two expressions are
			   INTENTIONAL, and represent perfectly legal C.  See
			   K&R (edition 1), p. 192 for details.  This syntax
			   allows us to save the previously parsed string and
			   attempt to parse the next one, testing the success
			   of the parse operation.
			*/

    else if (strncpy (obj->name, s, sizeof (obj->name)) ,
	     ((s = ebi_read_token (stream)) == NULL) )
	{set_status (invalid_object_instance);
	fprintf (stderr,
	 "eoi_bin_read: no object instance type for object w/ name %s\n",
	    obj->name);
	}

    else if (strncpy (obj->type, s, sizeof (obj->type)) ,
	     ((s = ebi_read_token (stream)) == NULL) )
	{set_status (invalid_object_instance);
	fprintf (stderr,
	    "eoi_bin_read: bad tech value for object w/ name %s\n",
	    obj->name);
	}

    else if (strncpy (obj->tech, s, sizeof (obj->tech)) ,
	     ((s = ebi_read_token (stream)) == NULL) )
	{set_status (invalid_object_instance);
	fprintf (stderr,
	    "eoi_bin_read: bad mailbox value for object w/ name %s\n",
	    obj->name);
	}

    else if (strncpy (obj->mailbox, s, sizeof (obj->mailbox)) ,
	     (! ebi_read_boolean (stream, & (obj->visible))) )
	{set_status (invalid_object_instance);
	fprintf (stderr,
	    "eoi_bin_read: bad `visible' value for object w/ name %s\n",
	    obj->name);
	}

    else if ( (attr_list = eoi_bin_read_attr_list (stream)) == NULLlist )
	{
			/* status already set and error already reported */
	}

    else if (ebi_read_token_char (stream) != EBI_CLOSE_RECORD)
	{set_status (invalid_object_instance);
        fprintf (stderr,
	    "eoi_bin_read: missing close record for object w/name %s\n",
	    obj->name);
	}


    else
			/* all reads worked fine, now do final processing */
         {if (! (hash_entry = (eob_template_hash_entry *)
                                  get_from_hashtable (eob_template_hash,
      			     			      old_template_id)))
            {set_status (invalid_object_instance);
            fprintf (stderr,
      	    "eoi_bin_read: cannot map old template id for object w/name %s\n",
      	    obj->name);
            }
          else
			/* now set the instance to point to the template and
			   vice versa */
            {obj-> template = (id_type) hash_entry-> new_template;
            eob_set_instance (obj-> template, obj);

			/* link up all the att instances to themselves and
			   to the obj instance */
            eoi_fix_obj_instance (obj, attr_list);

            edg_increment_object_count (e22_dialogue, obj->tech);

			/* send instance on over to dialogue if it should be
			   visible on screen */
            if (obj->visible &&
                (!eoi_visu_obj_instance (obj, attr_list, transaction)))
               {set_status (invalid_object_instance);
               fprintf (stderr, "cannot visualize object named %s\n",
                            obj->name);
               }
			/* do not need this anymore */
            free_list (attr_list, NOT_NODES);
            }
         }

    if ( (get_status () != ok) && (obj != EOI_NO_OBJ_INSTANCE) )
/* ?? Should probably free all the attributes too  */
	{free_node ((NODE) obj);
	obj = EOI_NO_OBJ_INSTANCE;
	}

   return (obj);

}				/* end eoi_bin_read */


/*--------------------------------------------------------------------------*\
|  Local Routine: eoi_bin_write_attr_list
| 
|  Description:  
|     Writes an object instance attribute list to a binary stream.
\*--------------------------------------------------------------------------*/
static boolean eoi_bin_write_attr_list (stream, att)
FILE *stream;
caddr_t att;
{  object_instance_attribute_sdd *attribute;

   set_status (ok);

    if (! ebi_write_open_record (stream)) /* open list */
	{set_status (io_failure);
	fprintf (stderr,
	    "eoi_bin_write_attr_list: can't write initial open record\n");
	}

    else
	{while ( (att != NULL) && (get_status () == ok) )
	    {attribute = (object_instance_attribute_sdd *) att;
	    if (! ebi_write_open_record (stream)) /* open this attr */
		{set_status (io_failure);
		fprintf (stderr,
		"eoi_bin_write_attr_list: can't write attr. open record\n");
		}

	    else if (! ebi_write_token_char (stream,
                                             EBI_OBJ_ATTR_INSTANCE_SELECTOR))
		{set_status (io_failure);
		fprintf (stderr,
		    "eoi_bin_write: can't write selector %c\n",
		    EBI_OBJ_ATTR_INSTANCE_SELECTOR);
		}

            else if (fprintf (stream, "%d ", attribute) == EOF)
                {set_status (io_failure);
                fprintf (stderr,
                    "eoi_bin_write: can't write att instance pointer \n");
                }

            else if (fprintf (stream, "%d ", attribute-> template) == EOF)
                {set_status (io_failure);
                fprintf (stderr,
                    "eoi_bin_write: can't write att template pointer\n");
                }

	    else if (! ebi_write_token (stream, attribute->name))
		{set_status (io_failure);
		fprintf (stderr,
		    "eoi_bin_write_attr_list: can't write attr. name \"%s\"\n",
		    attribute->name);
		}

	    else if (! ebi_write_string (stream, attribute->value,
					 EBI_OBJECT_INSTANCE_VALUE_SELECTOR))
		{set_status (io_failure);
		fprintf (stderr,
		    "eoi_bin_write: can't write attr. value \"%s\"\n",
		    attribute->value);
		}

	    else if (! ebi_write_close_record (stream)) /* close this attr */
		{set_status (io_failure);
		fprintf (stderr,
		"eoi_bin_write_attr_list: can't write attr. close record\n");
		}

	    else
			/* next att, please. */
		{att = (caddr_t) attribute->attr_list;
		}

	    } /* end while */


	/* Write the close record for the list. */

	if (! ebi_write_close_record (stream))
	    {set_status (io_failure);
	    fprintf (stderr,
		"eoi_bin_write_attr_list: can't write close record\n");
	    }
	} /* end else */

    return (get_status () == ok);
}				/* end eoi_bin_write_attr_list */


/*--------------------------------------------------------------------------*\
|  Routine: eoi_bin_write
| 
|  Description:  
|     Writes an object instance to a binary stream.
\*--------------------------------------------------------------------------*/

void eoi_bin_write (stream, instance)
FILE *stream;
object_instance_sdd *instance;
{
    DEBUG2 (fprintf (stderr, "eoi_bin_write: entry\n"););
    set_status (ok);

    if (! ebi_write_open_record (stream))
	{set_status (io_failure);
	fprintf (stderr,
	    "eoi_bin_write: can't write initial open record\n");
	}

    else if (! ebi_write_token_char (stream, EBI_OBJ_INSTANCE_SELECTOR))
	{set_status (io_failure);
	fprintf (stderr,
	    "eoi_bin_write: can't write selector %c\n",
	    EBI_OBJ_INSTANCE_SELECTOR);
	}

    else if (fprintf (stream, "%d ", instance) == EOF)
	{set_status (io_failure);
	fprintf (stderr,
	    "eoi_bin_write: can't write object instance pointer \n");
	}
    else if (fprintf (stream, "%d ", instance-> template) == EOF)
	{set_status (io_failure);
	fprintf (stderr,
	    "eoi_bin_write: can't write object template pointer\n");
	}

    else if (! ebi_write_token (stream, instance->name))
	{set_status (io_failure);
	fprintf (stderr,
	    "eoi_bin_write: can't write object instance name \"%s\"\n",
	    instance->name);
	}

    else if (! ebi_write_token (stream, instance->type))
	{set_status (io_failure);
	fprintf (stderr,
	    "eoi_bin_write: can't write object instance type \"%s\"\n",
	    instance->type);
	}

    else if (! ebi_write_token (stream, instance->tech))
	{set_status (io_failure);
	fprintf (stderr,
	    "eoi_bin_write: can't write object instance tech\"%s\"\n",
	    instance->tech);
	}

    else if (! ebi_write_token (stream, instance->mailbox))
	{set_status (io_failure);
	fprintf (stderr,
	    "eoi_bin_write: can't write object instance mailbox \"%s\"\n",
	    instance->mailbox);
	}

    else if (! ebi_write_boolean (stream, instance->visible))
	{set_status (io_failure);
	fprintf (stderr, "eoi_bin_write: can't write boolean\n");
	}

    else if (! eoi_bin_write_attr_list (stream, instance->attr_list))

	/* already reported. */
	;

    else if (! ebi_write_close_record (stream))
	{set_status (io_failure);
	fprintf (stderr, "eoi_bin_write: can't write close record\n");
	}

    DEBUG2 (fprintf (stderr, "eoi_bin_write: exit\n"););
    return;
}				/* end eoi_bin_write */


#if 0
/*
       is_integer is not used now, but let us leave the source here for
       a while just in case
*/
/*--------------------------------------------------------------------------*\
|  Routine: is_integer
|
|  Description:
|     Check if an ascii string is a integer string
\*--------------------------------------------------------------------------*/
static int is_integer(str)
char *str;
{
   long num;
   char *dummy;
   long strtol();
   int return_val;

    DEBUG2 (fprintf (stderr, "isinteger: call.\n"));

   num = strtol(str, &dummy, 10);

   if (*dummy == '\0')
      return_val = 1;
    else
      return_val = NULL;

  DEBUG2 (fprintf (stderr, "isinteger: exit.\n"));

  return (return_val);
}					/* end is_integer */
#endif


#if 0
/*
       is_real is not used now, but let us leave the source here for
       a while just in case
*/
/*--------------------------------------------------------------------------*\
| Routine: is_real 
| 
| Description: 
|   Check if an ascii string is a real string.
\*--------------------------------------------------------------------------*/
static int is_real(str)
char *str;

{ double num;
  char *dummy;
  double strtod();
  int return_val;

  DEBUG2 (fprintf (stderr, "isreal: call.\n"));

   num = strtod(str, &dummy);

   if (*dummy == '\0')
      return_val = 1;
   else
      return_val = 0;

   if (strcmp(str,"+") == 0)
      return_val = 0;

   if (strcmp(str,"-") == 0)
        return_val = 0;
  

  DEBUG2 (fprintf (stderr, "isreal: exit.\n"));

  return (return_val);
}					/* end is_real */
#endif


#if 0
/*
       eoi_src_write is not used now, but let us leave the source here for
       a while just in case
*/
/*--------------------------------------------------------------------------*\
|  Routine: eoi_src_write
| 
|  Description:  
|     Writes an object instance to a stream in Slang source format.
\*--------------------------------------------------------------------------*/
void eoi_src_write (stream, instance)
FILE *stream;
object_instance_sdd *instance;
{
    id_type id;
    object_instance_attribute_sdd *attribute;
    string lower;


    set_status (ok);
    DEBUG2 (fprintf (stderr, "eoi_src_write: entry\n"););

    fprintf (stream, "%s: %s\n", instance->name, instance->type);
    fputs ("\t{\n", stream);
    fputs ("\tATTRIBUTES:\n", stream);

    id = instance->attr_list;
    while ( (id != null_id) && (get_status () == ok) )	{
	attribute = (object_instance_attribute_sdd *) emp_get_de (id);
	if ( (attribute == NULL_ATTR_INSTANCE) || (get_status () != ok) )
            {set_status (invalid_id);
	    fprintf (stderr,
		"eoi_src_write: unmappable attribute id -- %d\n",
		id);
            }
			/* If not a string print out without quotes.
			   this is real sleazy and technology specific
			*/
	else
          {lower = ea2_string_lower(attribute->value);

          if ( 
            (is_integer(attribute->value)) || 
            (is_real(attribute->value)) ||
            (strcmp(lower, "undefined") == 0) ||
            (strcmp(lower, "null") == 0) ||
            (strcmp(lower, "true") == 0) ||
            (strcmp(lower, "false") == 0) ||
            (strcmp(attribute->name, "parent") == 0) ||
            (strcmp(attribute->name, "from_vert") == 0) ||
            (strcmp(attribute->name, "from_horiz") == 0) 
             )
            {fprintf (stream, "\t\t%s: %s;\n", attribute->name,
                      attribute->value);
            }
			/* Print out strings using quotes.  */
          else
            {fprintf (stream, "\t\t%s: \"%s\";\n", attribute->name,
                      attribute->value);
            }
			/* Free storage for lower and bump pointer.  */
          free_node(lower);
          id = attribute->attr_list;
        } 	

    } /* end while */


    fputs ("\t}\n", stream);

    DEBUG2 (fprintf (stderr, "eoi_src_write: exit\n"););
    return;
}
#endif

