static char rcsid [] =
        "$Header: /usr/users/little/serpent/sunos4/de/src/RCS/evc.c,v 1.23 1991/07/08 19:37:58 little Exp $";

/*--------------------------------------------------------------------------*\
|   
|  Name:  Dialogue Editor VC Abstraction (evc)
|
|  Description:  
|     The dialogue editor VC abstraction provides operations on the VC
|     abstract type.
|
|  Component of:
|     Dialogue Editor Layer.
|

$Log: evc.c,v $
 * Revision 1.23  1991/07/08  19:37:58  little
 * fix up a dangling parent problem
 *
 * Revision 1.22  1991/05/14  22:29:42  little
 * fix things so the parent att works when instinstiating
 *
 * Revision 1.21  1991/05/07  17:50:43  little
 * add object counting functionality
 * use e22.h for the e22_dialogue external
 *
 * Revision 1.20  1991/02/12  15:41:11  little
 * take out all DEBUGx statements, they drive dbx crazy.
 *
 * Revision 1.19  90/12/21  14:34:27  ejh
 * strings.h => string.h
 * 
 * Revision 1.18  90/11/29  10:03:46  rcs
 * fixed symbol table problem
 * 
 * Revision 1.17  90/11/01  17:25:11  little
 * make sure all internal de elements wet creation condition
 * use the creation_condition_text_prop
 * 
 * Revision 1.16  90/09/20  15:55:55  rcs
 * fixed attribute delete problem
 * 
 * Revision 1.15  90/09/19  16:42:10  rcs
 * mainly cosmetic
 * 
 * Revision 1.14  90/09/17  22:19:52  little
 * fix duplication
 * 
 * Revision 1.13  90/09/11  08:36:46  little
 * add third parameter to esi_buffer_src_write calls
 * 
 * Revision 1.12  90/09/07  18:33:18  little
 * no changes
 * 
 * Revision 1.11  90/08/30  17:37:44  little
 * make those who call get_prop & donot care about status, set it ok
 * 
 * Revision 1.10  90/08/06  16:41:05  little
 * change destroy_vc so that is really does destroy the things on lists
 * within the vc.
 * 
 * Revision 1.9  90/07/19  17:02:12  little
 * change an error message a little
 * 
 * Revision 1.8  90/07/05  15:10:04  little
 *  more structure and visualizer parts integration
 * 
 * Revision 1.7  90/05/21  13:39:13  little
 * fix up for multiple includes & start mods for visu/struc editor integration
 * 
 * Revision 1.6  90/03/23  14:23:58  rcs
 * *** empty log message ***
 * 
 * Revision 1.5  89/12/18  15:13:22  bmc
 * removed extraneous indent() routine
 * 
 * Revision 1.4  89/12/18  14:20:28  little
 * fixed some shit that was wrong
 * 
 * Revision 1.3  89/12/12  11:10:53  rcs
 * no change
 * 
 * Revision 1.2  89/12/12  09:18:27  rcs
 * fixed bugs found during integration testing
 * 
 * Revision 1.1  89/11/29  09:41:13  bmc
 * Initial revision
 * 

|
|-----------------------------------------------------------------------------
|
|   Distribution: Approved for public release; distribution is unlimited.
|
|   Copyright (c) 1989  by  Carnegie  Mellon  University, Pittsburgh, PA.  The
|  Software Engineering  Institute  (SEI) is a federally  funded  research and
|  development center established  and  operated by Carnegie Mellon University
|  (CMU).  Sponsored  by  the  U.S.  Department  of   Defense  under  contract
|  F19628-85-C-0003,  the  SEI  is  supported  by  the  services  and  defense
|  agencies, with the U.S. Air Force as the executive contracting agent.
|
|    Permission to use,  copy,  modify, or  distribute  this  software and its
|  documentation for  any purpose and without fee  is hereby granted, provided
|  that  the above copyright notice appear  in  all copies and that both  that
|  copyright  notice  and   this  permission  notice  appear   in   supporting
|  documentation.   Further,  the  names  Software  Engineering  Institute  or
|  Carnegie  Mellon  University  may  not be used in  advertising or publicity
|  pertaining to distribution of the software without specific, written  prior
|  permission.  CMU makes no claims  or representations  about the suitability
|  of this software for any purpose.  This software is provided "as is" and no
|  warranty,  express  or  implied,  is  made  by  the  SEI  or CMU, as to the
|  accuracy  and  functioning of the program and related program material, nor
|  shall   the  fact of  distribution   constitute  any   such  warranty.   No
|  responsibility is assumed by the SEI or CMU in connection herewith.
|
\*--------------------------------------------------------------------------*/

/*-------------------- Includes --------------------------------------------*/

#define evc_main
#include "evc_cmd.h"
#include "evc.h"
#include "eva.h"
#include "eso_sd.h"
#include "eva_priv.h"
#include "eob.h"
#include "eob_priv.h"
#include "est.h"
#include "esi.h"
#include "ebi.h"
#include "eoi.h"
#include "ea2.h"
#include "e22.h"
#include "cmd_defs.h"
#include "cus.h"
#include "serpent.h"
#include "ubo.h"
#include <string.h>

/*-------------------- Constants -------------------------------------------*/

#undef DEBUG1
#undef DEBUG2
#undef DEBUG3
#define DEBUG1(statement) SERPENT_DEBUG1(evc_debug, statement)
#define DEBUG2(statement) SERPENT_DEBUG2(evc_debug, statement)
#define DEBUG3(statement) SERPENT_DEBUG3(evc_debug, statement)

#define VC_PREFIX		"EVC"

#define no_vc_specified(routine) \
    (void) fprintf (stderr, "%s: empty VC specified\n", routine)

#define no_object_specified(routine) \
    (void) fprintf (stderr, "%s: empty object specified\n", routine)

#define no_variable_specified(routine) \
    (void) fprintf (stderr, "%s: empty variable specified\n", routine)

#define write_buffer(stream, buffer, the_selector) \
{  ebi_buffer a_buffer; \
   a_buffer.actual_buffer = buffer; \
   a_buffer.selector = the_selector; \
   if (!ebi_write_buffer (stream, a_buffer)) \
      {set_status (system_operation_failed); \
      return; \
      } \
}

#define write_open_record(stream) \
   if (!ebi_write_open_record (stream)) \
      {set_status (system_operation_failed); \
      return; \
      }

#define write_close_record(stream) \
   if (!ebi_write_close_record (stream)) \
      {set_status (system_operation_failed); \
      return; \
      }

#define bum_vc \
   {set_status (system_operation_failed); \
   return (EVC_NO_VC); \
   };

#define read_open_record(stream) \
   if (!(ebi_read_token_char (stream) == EBI_OPEN_RECORD)) \
      bum_vc;

#define read_close_record(stream) \
   if (!(ebi_read_token_char (stream) == EBI_CLOSE_RECORD)) \
      bum_vc;

#define read_buffer(stream, some_buffer, the_selector) \
   some_buffer = ebi_read_buffer (stream); \
   if (some_buffer.selector != the_selector) \
      bum_vc;


                         /* this is set by eat for those instances which
                           were made before their parent */
extern LIST ea2_object_instances_not_completely_done;


/*--------------------------------------------------------------------------*\
|  Routine: evc_print_vc_tree
| 
|  Description:
|     Prints a VC subtree.  Useful mainly for debugging.
\*--------------------------------------------------------------------------*/
void evc_print_vc_tree (the_vc, indent_level)
evc_vc the_vc;
int indent_level;
{
    LIST list;
    evc_vc sub_vc;
    int i;


					/* indent to the correct level. */
    for (i = 0; i < indent_level; i++)
	{
        (void) putc (' ', stderr);
        (void) putc (' ', stderr);
        (void) putc (' ', stderr);
	}

    (void) fprintf (stderr, "VC = %s (%s)\n",
	evc_get_name (the_vc), cus_sym_representation ((cus_sym) the_vc));

    list = (LIST) cus_get_prop ((cus_sym) the_vc, sub_vcs_prop);
    loop_through_list (list, sub_vc, evc_vc)
	evc_print_vc_tree (sub_vc, indent_level + 1);
}

/*--------------------------------------------------------------------------*\
|  Routine: evc_node_print_value
| 
|  Description:
|     Provides a print string for a variable of type evc_node_selection.
|     Useful mainly for debugging.
|
\*--------------------------------------------------------------------------*/
string evc_node_print_value (val)
evc_node_selection val;
{
    switch (val)
	{
	case EVC_ENTIRE_HIERARCHY:
	    return "EVC_ENTIRE_HIERARCHY";

	case EVC_VC_ONLY:
	    return "EVC_VC_ONLY";

	default:
	    return "Illegal evc_node_selection value";
	}
}					/* end evc_node_print_value */


/*--------------------------------------------------------------------------*\
|  Routine: evc_create_vc
| 
|  Description:  
|     Creates a new vc
\*--------------------------------------------------------------------------*/
evc_vc evc_create_vc ()
{
    cus_sym vc_ste;
    buffer dummy_buffer;

    set_status (ok);

    vc_ste = cus_gensym (VC_PREFIX, vc_sym, NO_SEED);

    if (get_status () != ok)
	{
	vc_ste = (cus_sym) EVC_NO_VC;
	(void) fprintf (stderr,
	    "evc_create_vc: can't add VC to symbol table.\n");
	}

    else
	{ 			/* Initialize all fields. */

	cus_put_prop (vc_ste, parent_vc_prop, EVC_NO_VC);
	cus_put_prop (vc_ste, parent_dialogue_prop, EDG_NO_DIALOGUE);
	est_set_string_property (vc_ste, name_text_prop, EST_DEFAULT_NAME);

				/*
				   It's okay to use a local buffer, since
				   est_set_buffer_property stores a copy
				   of the buffer, not the buffer itself.
				*/
	init_buffer (dummy_buffer);
	est_set_buffer_property (vc_ste,
				 vc_comments_text_prop,
				 dummy_buffer);
	est_set_buffer_property (vc_ste,
				 creation_condition_text_prop,
				 dummy_buffer);
	est_set_buffer_property (vc_ste,
				 create_actions_snippet_text_prop,
				 dummy_buffer);
	est_set_buffer_property (vc_ste,
				 destroy_actions_snippet_text_prop,
				 dummy_buffer);
	cus_put_prop (vc_ste, objects_prop,	make_list ());
	cus_put_prop (vc_ste, variables_prop,	make_list ());
	cus_put_prop (vc_ste, sub_vcs_prop,	make_list ());
	}

    return ((evc_vc) vc_ste);
}					/* end evc_create_vc */


/*--------------------------------------------------------------------------*\
|  Routine: evc_destroy_vc
| 
|  Description:  
|     Destroys a VC and, optionally, its subcomponents.
\*--------------------------------------------------------------------------*/

void evc_destroy_vc (the_vc, how, out_trans)
evc_vc the_vc;
evc_node_selection how;
transaction_type out_trans;
{  LIST list;
   evc_vc parent_vc;
   evc_vc sub_vc;
   eva_variable variable;
   eob_object object;

   parent_vc = (evc_vc) cus_get_prop ((cus_sym) the_vc, parent_vc_prop);

   est_clear_buffer_property (the_vc, vc_comments_text_prop);
   est_clear_buffer_property (the_vc, creation_condition_text_prop);
   est_clear_buffer_property (the_vc, create_actions_snippet_text_prop);
   est_clear_buffer_property (the_vc, destroy_actions_snippet_text_prop);

   if (how == EVC_VC_ONLY)
					/* There'd better be a parent. */
      {if (parent_vc == EVC_NO_VC)
         {set_status (invalid_vc);
	 fprintf (stderr,
		"evc_destroy_vc: can't re-parent subordinates: no parent\n");
         }
       else
				/* Let evc_remove_vc handle it. */
         {evc_remove_vc (the_vc, EVC_NO_VC);
	 }
      }

    else
					/* Destroy each list of sub-things. */
      {if ((list = (LIST) cus_get_prop (the_vc, objects_prop)) != NULL )
         {loop_through_list (list, object, eob_object)
            eob_destroy_object (object, out_trans);
         est_free_list_property ((cus_sym) the_vc, objects_prop);
         }

      if ((list = (LIST) cus_get_prop (the_vc, variables_prop)) != NULL )
         {loop_through_list (list, variable, eva_variable)
            eva_destroy_variable (variable);
         est_free_list_property ((cus_sym) the_vc, variables_prop);
         }

      if ((list = (LIST) cus_get_prop (the_vc, sub_vcs_prop)) != NULL )
         {loop_through_list (list, sub_vc, evc_vc)
            evc_destroy_vc (sub_vc, EVC_ENTIRE_HIERARCHY);
         est_free_list_property ((cus_sym) the_vc, sub_vcs_prop);
         }
      }

   cus_delete_sym ((cus_sym) the_vc);

   return;
}					/* end evc_destroy_vc */


/*--------------------------------------------------------------------------*\
|  Routine: evc_duplicate_vc
|
|  Description:
|     Duplicates the contents of VC, returning the new VC.
\*--------------------------------------------------------------------------*/
evc_vc evc_duplicate_vc (the_vc, how_to_dup)
evc_vc the_vc;
evc_node_selection how_to_dup;
{
    LIST list;
    evc_vc new_vc;
    evc_vc new_sub_vc;
    evc_vc cur_sub_vc;
    eob_object new_object;
    eob_object cur_object;
    eva_variable new_variable;
    eva_variable cur_variable;

    if (the_vc == EVC_NO_VC)
	{set_status (invalid_vc);
	}

    else if ((new_vc = evc_create_vc ()) != EVC_NO_VC )
	{est_copy_string_property ((cus_sym) new_vc,
				  (cus_sym) the_vc,
				  name_text_prop);
	est_copy_buffer_property ((cus_sym) new_vc,
				  (cus_sym) the_vc,
				  vc_comments_text_prop);
	est_copy_buffer_property ((cus_sym) new_vc,
				  (cus_sym) the_vc,
				  creation_condition_text_prop);
	est_copy_buffer_property ((cus_sym) new_vc,
				  (cus_sym) the_vc,
				  create_actions_snippet_text_prop);
	est_copy_buffer_property ((cus_sym) new_vc,
				  (cus_sym) the_vc,
				  destroy_actions_snippet_text_prop);

	if (how_to_dup == EVC_ENTIRE_HIERARCHY)
	    {
					/*
					** Duplicate list of objects attached
					** to this VC.
					*/
	    list = (LIST) cus_get_prop ((cus_sym) the_vc, objects_prop);
	    if (list != NULL)
		{loop_through_list (list, cur_object, eob_object)
		    {new_object = eob_duplicate_object (cur_object);
		    if (new_object == EOB_NO_OBJECT)
			/* status is already set */
			break; /* break out of loop the only way possible */
	 	    evc_add_object (new_vc, new_object);
		    } /* end loop */
		}
					/*
					** Duplicate list of variables attached
					** to this VC.
					*/

	    list = (LIST) cus_get_prop ((cus_sym) the_vc, variables_prop);
	    if (list != NULL)
		{loop_through_list (list, cur_variable, eva_variable)
		    {new_variable = eva_duplicate_variable (cur_variable);
		    if (new_variable == EVA_NO_VARIABLE)
			/* status is already set */
			break; /* break out of loop the only way possible */

		    evc_add_variable (new_vc, new_variable);
		    }
		}

					/*
					** Duplicate list of sub-VCs attached
					** to this VC.
					*/

	    list = (LIST) cus_get_prop ((cus_sym) the_vc, sub_vcs_prop);
	    if (list != NULL)
		{loop_through_list (list, cur_sub_vc, evc_vc)
		    {new_sub_vc = evc_duplicate_vc (cur_sub_vc,
						   EVC_ENTIRE_HIERARCHY);
		    if (new_sub_vc == EVC_NO_VC)
			/* status is already set */

			break; /* break out of loop the only way possible */

		    evc_add_vc (new_vc, new_sub_vc);
		    }
		} /* end if sub-vc list non-null */

	    } /* end if copy entire hierarchy */

	} /* end else creation worked */

    if (get_status () != ok)
	{
	if (new_vc != EVC_NO_VC)
	    evc_destroy_vc (new_vc, EVC_ENTIRE_HIERARCHY, NULL);
	new_vc = EVC_NO_VC;
	}

    return (new_vc);
}					/* end evc_duplicate_vc */


/*--------------------------------------------------------------------------*\
|  Routine: evc_set_parent
| 
|  Description:
|     Sets the parent of a VC.
\*--------------------------------------------------------------------------*/
void evc_set_parent (the_vc, new_parent)
evc_vc the_vc;
evc_vc new_parent;
{
    set_status (ok);
    if (the_vc == EVC_NO_VC)
	{
	set_status (invalid_vc);
	}

    else
	cus_put_prop ((cus_sym) the_vc, parent_vc_prop, new_parent);

    return;
}					/* end evc_set_parent */


/*--------------------------------------------------------------------------*\
|  Routine: evc_get_parent
| 
|  Description:
|     Gets the parent of a VC, if there is one.
\*--------------------------------------------------------------------------*/
evc_vc evc_get_parent (the_vc)
evc_vc the_vc;
{
    evc_vc the_parent = EVC_NO_VC;
    set_status (ok);
    if (the_vc == EVC_NO_VC)
	{
	set_status (invalid_vc);
	}

    else
	the_parent = (evc_vc) cus_get_prop ((cus_sym) the_vc, parent_vc_prop);

    return (the_parent);
}					/* end evc_get_parent */


/*--------------------------------------------------------------------------*\
|  Routine: evc_set_dialogue
| 
|  Description:
|     Sets the dialogue to which a VC is hooked (i.e., makes the VC think
|     it's Eve).
\*--------------------------------------------------------------------------*/
void evc_set_dialogue (the_vc, dialogue)
evc_vc the_vc;
edg_dialogue dialogue;
{
    set_status (ok);
    cus_put_prop ((cus_sym) the_vc,
		  parent_dialogue_prop,
		  (caddr_t) dialogue);

    return;
}					/* end evc_set_dialogue */


/*--------------------------------------------------------------------------*\
|  Routine: evc_get_dialogue
| 
|  Description:
|     Gets the dialogue to which a VC is hooked, if there is one.
\*--------------------------------------------------------------------------*/
edg_dialogue evc_get_dialogue (the_vc)
evc_vc the_vc;
{  evc_vc the_parent = EVC_NO_VC;

   set_status (ok);
   if (the_vc == EVC_NO_VC)
      {set_status (invalid_vc);
      }
    else
      the_parent = (evc_vc) cus_get_prop ((cus_sym) the_vc,
					    parent_dialogue_prop);

   return (the_parent);
}					/* end evc_get_dialogue */



/*--------------------------------------------------------------------------*\
|  Routine: evc_set_name
| 
|  Description:
|     Sets the name of a VC.
\*--------------------------------------------------------------------------*/
void evc_set_name (the_vc, new_name)
evc_vc the_vc;
string new_name;
{
    set_status (ok);
    if (the_vc == EVC_NO_VC)
	{
	set_status (invalid_vc);
	}

    else
	est_set_string_property ((cus_sym) the_vc, name_text_prop, new_name);

    return;
}					/* end evc_set_name */


/*--------------------------------------------------------------------------*\
|  Routine: evc_get_name
| 
|  Description:
|     Gets the name of a VC.
\*--------------------------------------------------------------------------*/
string evc_get_name (the_vc)
evc_vc the_vc;
{
    string the_name = NULL;


    set_status (ok);
    if (the_vc == EVC_NO_VC)
	{
	set_status (invalid_vc);
	}
    else
	the_name = (string) cus_get_prop ((cus_sym) the_vc, name_text_prop);

    return (the_name);
}					/* end evc_get_name */


/*--------------------------------------------------------------------------*\
|  Routine: evc_set_comments
| 
|  Description:
|     Sets a VC's retained comments field.
\*--------------------------------------------------------------------------*/
void evc_set_comments (the_vc, the_comments)
evc_vc the_vc;
buffer the_comments;
{
    set_status (ok);
    if (the_vc == EVC_NO_VC)
	{
	set_status (invalid_vc);
	}

    else
	est_set_buffer_property ((cus_sym) the_vc,
				 vc_comments_text_prop,
				 the_comments);
    return;
}					/* end evc_set_comments */


/*--------------------------------------------------------------------------*\
|  Routine: evc_get_comments
| 
|  Description:
|     Gets a VC's retained comments field.
|
\*--------------------------------------------------------------------------*/
buffer evc_get_comments (the_vc)
evc_vc the_vc;
{
    buffer the_comments;

    set_status (ok);
    if (the_vc == EVC_NO_VC)
	{
	set_status (invalid_vc);
	init_buffer (the_comments);
	no_vc_specified ("evc_get_comments");
	}
    else
	the_comments = est_get_buffer_property ((cus_sym) the_vc,
						vc_comments_text_prop);

    return (the_comments);
}					/* end evc_get_comments */


/*--------------------------------------------------------------------------*\
|  Routine: evc_set_creation_condition
| 
|  Description:
|     sets the creation condition attribute of a vc
\*--------------------------------------------------------------------------*/
void evc_set_creation_condition (the_vc, the_creation_condition)
evc_vc the_vc;
buffer the_creation_condition;
{
    set_status (ok);
    if (the_vc == EVC_NO_VC)
	{
	set_status (invalid_vc);
	}

    else
	est_set_buffer_property ((cus_sym) the_vc,
				 creation_condition_text_prop,
				 the_creation_condition);
    return;
}					/* end evc_set_creation_condition */


/*--------------------------------------------------------------------------*\
|  Routine: evc_get_creation_condition
| 
|  Description:
|     gets the creation condition attribute of a vc
\*--------------------------------------------------------------------------*/
buffer evc_get_creation_condition (the_vc)
evc_vc the_vc;
{
    buffer the_creation_condition;

    set_status (ok);
    if (the_vc == EVC_NO_VC)
	{
	set_status (invalid_vc);
	init_buffer (the_creation_condition);
	no_vc_specified ("evc_get_creation_condition");
	}
    else
	the_creation_condition = est_get_buffer_property ((cus_sym) the_vc,
						creation_condition_text_prop);

    return (the_creation_condition);
}					/* end evc_get_creation_condition */


/*--------------------------------------------------------------------------*\
|  Routine: evc_set_create_actions
| 
|  Description:
|     sets the creation actions attribute of a vc
\*--------------------------------------------------------------------------*/
void evc_set_create_actions (the_vc, create_actions)
evc_vc the_vc;
buffer create_actions;
{
    set_status (ok);
    if (the_vc == EVC_NO_VC)
	{
	set_status (invalid_vc);
	}

    else
	est_set_buffer_property ((cus_sym) the_vc,
				 create_actions_snippet_text_prop,
				 create_actions);
    return;
}					/* end evc_set_create_actions */


/*--------------------------------------------------------------------------*\
|  Routine: evc_get_create_actions
| 
|  Description:
|     gets the creation actions attribute of a vc
|
\*--------------------------------------------------------------------------*/
buffer evc_get_create_actions (the_vc)
evc_vc the_vc;
{
    buffer the_create_actions;

    set_status (ok);

    if (the_vc == EVC_NO_VC)
	{
	set_status (invalid_vc);
	no_vc_specified ("evc_get_create_actions");
	}
    else
	the_create_actions = est_get_buffer_property ((cus_sym) the_vc,
					create_actions_snippet_text_prop);

    return (the_create_actions);
}						/*end evc_get_create_actions */


/*--------------------------------------------------------------------------*\
|  Routine: evc_set_destroy_actions
| 
|  Description:
|     sets the creation condition attribute of a vc
\*--------------------------------------------------------------------------*/
void evc_set_destroy_actions (the_vc, destroy_actions)
evc_vc the_vc;
buffer destroy_actions;
{
    set_status (ok);
    if (the_vc == EVC_NO_VC)
	{
	set_status (invalid_vc);
	}

    else
	est_set_buffer_property ((cus_sym) the_vc,
				 destroy_actions_snippet_text_prop,
				 destroy_actions);
    return;
}					/* end evc_set_destroy_actions */


/*--------------------------------------------------------------------------*\
|  Routine: evc_get_destroy_actions
| 
|  Description:
|     gets the destroy actions attribute of a vc
\*--------------------------------------------------------------------------*/
buffer evc_get_destroy_actions (the_vc)
evc_vc the_vc;
{
    buffer the_destroy_actions;


    set_status (ok);

    if (the_vc == EVC_NO_VC)
	{
	set_status (invalid_vc);
	init_buffer (the_destroy_actions);
	no_vc_specified ("evc_get_destroy_actions");
	}
    else
	the_destroy_actions = est_get_buffer_property ((cus_sym) the_vc,
					destroy_actions_snippet_text_prop);

    return (the_destroy_actions);
}					/* end evc_get_destroy_actions */


/*--------------------------------------------------------------------------*\
|  Routine: evc_add_object
|
|  Description:
|     Adds an object to the set of objects associated with a VC.
\*--------------------------------------------------------------------------*/
void evc_add_object (the_vc, object)
evc_vc the_vc;
eob_object object;
{
    LIST list;

    if (the_vc == EVC_NO_VC)
	{
	set_status (invalid_vc);
	}

    else if ( (list = (LIST) cus_get_prop ((cus_sym) the_vc,
					   objects_prop)) == NULL )
	{
	set_status (invalid_list);
	(void) fprintf (stderr,
	    "evc_add_object: unexpected null objects_prop for vc %s\n",
	    cus_sym_representation (the_vc));
	}

    else if (! in_list (list, (NODE) object) )
	{
	eob_set_parent (object, the_vc);
	(void) add_to_tail (list, (NODE) object);
	}

    return;
}					/* end evc_add_object */


/*--------------------------------------------------------------------------*\
|  Routine: evc_remove_object
|
|  Description:
|     Removes an object from the set of objects associated with a VC.
\*--------------------------------------------------------------------------*/
eob_object evc_remove_object (object)
eob_object object;
{  evc_vc parent_vc;
   LIST list;


   if (object == EOB_NO_OBJECT)
      {set_status (invalid_object);
      }

   else if ((parent_vc = eob_get_parent (object)) == EVC_NO_VC )
      {set_status (invalid_vc);
      fprintf (stderr,
	    "evc_remove_object: can't get parent VC for object\n");
      }

   else if ((list = (LIST) cus_get_prop ((cus_sym) parent_vc,
					  objects_prop)) == NULL )
      {set_status (invalid_list);
      fprintf (stderr,
	    "evc_remove_object: unexpected null objects_prop for vc %s\n",
	    cus_sym_representation (parent_vc));
      }

   else if (in_list (list, (NODE) object) )
      {delete_list_node (list, (NODE) object);
      eob_set_parent (object, EVC_NO_VC);
      }

   return (object);
}					/* end evc_remove_object */
 

/*--------------------------------------------------------------------------*\
|  Routine: evc_get_objects
|
|  Description:
|     Returns the set of objects associated with a VC, in the form of a
|     Zimmermann list.
\*--------------------------------------------------------------------------*/
LIST evc_get_objects (the_vc)
evc_vc the_vc;
{
    LIST real_list;
    LIST copy_of_list = NULL;


    set_status (ok);

    if (the_vc == EVC_NO_VC)
	{
	set_status (invalid_vc);
	}

    else if ( (real_list = (LIST) cus_get_prop ((cus_sym) the_vc,
						objects_prop)) == NULL )
	{
	set_status (invalid_list);
	(void) fprintf (stderr,
	    "evc_get_objects: unexpected null objects_prop for vc %s\n",
	    cus_sym_representation (the_vc));
	}

    else if ( (copy_of_list = copy_list (real_list, NOT_NODES)) == NULL )
	{
	set_status (out_of_memory);
	(void) fprintf (stderr,
	    "evc_get_objects: can't build objects list from vc %s\n",
	    cus_sym_representation (the_vc));
	}

    return (copy_of_list);
}						/* end evc_get_objects */


/*--------------------------------------------------------------------------*\
|  Routine: evc_add_variable
|
|  Description:
|     Adds an variable to the set of variables associated with a VC.
\*--------------------------------------------------------------------------*/
void evc_add_variable (the_vc, variable)
evc_vc the_vc;
eva_variable variable;
{
    LIST list;

    if (the_vc == EVC_NO_VC)
	{
	set_status (invalid_vc);
	}

    else if (variable == EVA_NO_VARIABLE)
	{
	set_status (invalid_variable);
	}

    else if ( ( list = (LIST) cus_get_prop ((cus_sym) the_vc,
					    variables_prop)) == NULL )
	{
	set_status (invalid_list);
	(void) fprintf (stderr,
	    "evc_add_variable: unexpected null variables_prop for vc %s\n",
	    cus_sym_representation (the_vc));
	}

    else if (! in_list (list, (NODE) variable) )
	{
	eva_set_parent (variable, the_vc);
	(void) add_to_tail (list, (NODE) variable);
	}

    return;
}						/* end evc_add_variable */


/*--------------------------------------------------------------------------*\
|  Routine: evc_remove_variable
|
|  Description:
|     Removes an variable from the set of variables associated with a VC.
\*--------------------------------------------------------------------------*/
eva_variable evc_remove_variable (variable)
eva_variable variable;
{
    evc_vc parent_vc;
    LIST list;

    if (variable == EVA_NO_VARIABLE)
	{
	set_status (invalid_variable);
	}

    else if ( (parent_vc = eva_get_parent (variable)) == EVC_NO_VC )
	{
	set_status (invalid_vc);
	(void) fprintf (stderr,
	    "evc_remove_variable: can't get parent VC for variable\n");
	}

    else if ( (list = (LIST) cus_get_prop ((cus_sym) parent_vc,
					   variables_prop)) == NULL )
	{
	set_status (invalid_list);
	(void) fprintf (stderr,
	    "evc_remove_variable: unexpected null variables_prop for vc %s\n",
	    cus_sym_representation (parent_vc));
	}

    else if ( in_list (list, (NODE) variable) )
	{
	(void) delete_list_node (list, (NODE) variable);
	eva_set_parent (variable, EVC_NO_VC);
	}

    return (variable);
}					/* end evc_remove_variable */


/*--------------------------------------------------------------------------*\
|  Routine: evc_get_variables
|
|  Description:
|     Returns the set of variables associated with a VC, in the form of a
|     Zimmermann list.
\*--------------------------------------------------------------------------*/
LIST evc_get_variables (the_vc)
evc_vc the_vc;
{
    LIST real_list;
    LIST copy_of_list = NULL;

    set_status (ok);

    if (the_vc == EVC_NO_VC)
	{
	set_status (invalid_vc);
	}

    else if ( (real_list = (LIST) cus_get_prop ((cus_sym) the_vc,
						variables_prop)) == NULL )
	{
	set_status (invalid_list);
	(void) fprintf (stderr,
	    "evc_get_variables: unexpected null variables_prop for vc %s\n",
	    cus_sym_representation (the_vc));
	}

    else if ( (copy_of_list = copy_list (real_list, NOT_NODES)) == NULL )
	{
	set_status (out_of_memory);
	(void) fprintf (stderr,
	    "evc_get_variables: can't build variables list from vc %s\n",
	    cus_sym_representation (the_vc));
	}

    return (copy_of_list);
}						/* end evc_get_variables */


/*--------------------------------------------------------------------------*\
|  Routine: evc_add_vc
|
|  Description:
|     Adds a VC to the set of sub-VCs associated with a VC.
\*--------------------------------------------------------------------------*/
void evc_add_vc (parent_vc, vc_to_add)
evc_vc parent_vc;
evc_vc vc_to_add;
{
    LIST list;

    if (parent_vc == EVC_NO_VC)
	{
	set_status (invalid_vc);
	}

    else if (vc_to_add == EVC_NO_VC)
	{
	set_status (invalid_vc);
	}

    else if ( (list = (LIST) cus_get_prop ((cus_sym) parent_vc,
					   sub_vcs_prop)) == NULL )
	{
	set_status (invalid_list);
	(void) fprintf (stderr,
	    "evc_add_vc: unexpected null sub_vcs_prop for vc %s\n",
	    cus_sym_representation (parent_vc));
	}

    else if (! in_list (list, (NODE) vc_to_add) )
	{evc_set_parent (vc_to_add, parent_vc);
	add_to_tail (list, (NODE) vc_to_add);
	}

    return;
}					/* end evc_add_vc */


/*--------------------------------------------------------------------------*\
|  Routine: evc_get_vcs
|
|  Description:
|     Returns the set of sub-VCs associated with a VC, in the form of a
|     Zimmermann list.
\*--------------------------------------------------------------------------*/
LIST evc_get_vcs (the_vc)
evc_vc the_vc;
{
    LIST real_list;
    LIST copy_of_list = NULL;


    set_status (ok);

    if (the_vc == EVC_NO_VC)
	{
	set_status (invalid_vc);
	}

    else if ( (real_list = (LIST) cus_get_prop ((cus_sym) the_vc,
					        sub_vcs_prop)) == NULL )
	{
	set_status (invalid_list);
	(void) fprintf (stderr,
	    "evc_get_vcs: unexpected null sub_vcs_prop for vc %s\n",
	    cus_sym_representation (the_vc));
	}

    else if ( (copy_of_list = copy_list (real_list, NOT_NODES)) == NULL )
	{
	set_status (out_of_memory);
	(void) fprintf (stderr,
	    "evc_get_vcs: can't build vcs list from vc %s\n",
	    cus_sym_representation (the_vc));
	}

    return (copy_of_list);
}					/* end evc_get_vcs */


/*--------------------------------------------------------------------------*\
|  Local routine: evc_re_parent_list
|
|  Description:
|     Re-parents all items in a list contained within a symbol table property.
|
|  Parameters
|     to_vc         - The new parent.
|     from_vc       - The VC containing the list to be re-parented.
|     property_name - The name of the symbol table property containing the
|                     list to be re-parented.
|     set_parent    - Pointer to the function that retrieves the parent VC
|                     for the objects in the list.
\*--------------------------------------------------------------------------*/
static void evc_re_parent_list (to_vc, from_vc, property_name, set_parent)
evc_vc to_vc;
evc_vc from_vc;
cus_property_type property_name;
void (* set_parent) ();
{
#   define re_parent_list_error(from_vc, to_vc, property, offending_vc) \
	(void) fprintf (stderr,	                                            \
	    "evc_re_parent_list: re-parent prop. %s from VC %s to VC %s:\n", \
	    cus_prop_print_val (property),                                  \
	    cus_sym_representation (from_vc),                               \
	    cus_sym_representation (to_vc));                                \
	(void) fprintf (stderr,                                             \
	    "                    unexpected null list in VC %s\n",          \
	    cus_sym_representation (offending_vc))

    LIST list_to_re_parent;
    LIST target_list;
    caddr_t thing;


				/*
				   Don't set the status to 'ok'.   Only
				   set it if there's an error.
				*/
    if ( (list_to_re_parent = (LIST) cus_get_prop ((cus_sym) from_vc,
						   property_name)) == NULL )
	{
	set_status (invalid_list);
	re_parent_list_error (from_vc, to_vc, property_name, from_vc);
	}

    else if( (target_list = (LIST) cus_get_prop ((cus_sym) to_vc,
						 property_name)) == NULL )
	{
	set_status (invalid_list);
	re_parent_list_error (from_vc, to_vc, property_name, to_vc);
	}

    else
	{
				/*
				   First we have to re-parent every element
				   in the list; then, we can move the list
				   itself to the new parent.
				*/
	loop_through_list (list_to_re_parent, thing, caddr_t)
	    {
	    (* set_parent) (thing, to_vc);
	    }

	(void) append_list (target_list, list_to_re_parent);
	}

    return;
}					/* end evc_re_parent_list */


/*--------------------------------------------------------------------------*\
|  Routine: evc_remove_vc
|
|  Description:
|     Removes the specified VC from the internal hierarchy.  Allows the
|     caller to remove just the VC node or the entire hierarchy contained by
|     the VC.
\*--------------------------------------------------------------------------*/

evc_vc evc_remove_vc (the_vc, how_to_remove)
evc_vc the_vc;
evc_node_selection how_to_remove;
{
    evc_vc parent_vc;
    LIST list;

    set_status (ok);
				/*
				   Unconditionally remove the VC from its
				   parent.
				*/
    if (the_vc == EVC_NO_VC)
	{
	set_status (invalid_vc);
	}

    else if ( (parent_vc = evc_get_parent (the_vc)) == EVC_NO_VC )
	{
				/* No error.  Quietly return. */
#if 0
	set_status (invalid_vc);
	(void) fprintf (stderr,
	    "evc_remove_vc: can't get parent VC for vc %s\n",
	    cus_sym_representation (the_vc));
#endif
	}

    else if ( (list = (LIST) cus_get_prop ((cus_sym) parent_vc,
					   sub_vcs_prop)) == NULL )
	{
	set_status (invalid_list);
	(void) fprintf (stderr,
	    "evc_remove_vc: unexpected null sub_vcs_prop for vc %s\n",
	    cus_sym_representation (parent_vc));
	}

    else if ( in_list (list, (NODE) the_vc) )
	{delete_list_node (list, (NODE) the_vc);

				/*
				   Now, do we re-parent all the stuff the
				   VC contains?
				*/

	if (how_to_remove == EVC_VC_ONLY)       /* Yes. */
	   {
	   evc_re_parent_list (parent_vc,
			       the_vc,
			       variables_prop,
			       eva_set_parent);
	   evc_re_parent_list (parent_vc,
			       the_vc,
			       sub_vcs_prop,
			       evc_set_parent);
	   evc_re_parent_list (parent_vc,
			       the_vc,
			       objects_prop,
			       eob_set_parent);
	   }
	} /* end else if ( in_list (list, (NODE) the_vc) ) */

    return (the_vc);
}					/* end evc_remove_vc */


/*--------------------------------------------------------------------------*\
|  Routine: cs2_vc_gen
|
|  Description:
|     convert a vc read in by the parser into the editor form (ie, snippets
|	are in buffers as strings instead of parser trees).  this routine is
|	named this way because this is what the parser calls.
\*--------------------------------------------------------------------------*/
void cs2_vc_gen (parse_vc)
cus_sym parse_vc;
{  evc_vc ed_vc, ed_parent;
   cus_sym parse_parent;

   ed_vc = evc_parse_vc_2_ed (parse_vc);

   parse_parent = (cus_sym) cus_get_prop (parse_vc, parent_vc_prop);
			/* null parent indicates this is god */
   if (parse_parent)
      {ed_parent = (evc_vc) cus_get_prop (parse_parent, old_parent_vc_prop);
      evc_set_parent (ed_vc, ed_parent);
      evc_add_vc (ed_parent, ed_vc);
      }
    else
      edg_set_vc (evc_imported_dialogue, ed_vc);

			/* we are using the old_parent_vc_prop property to hold
			   the ed parent vc.  it is used by the slang code
			   generator and nowhere else.  using this method for
			   saving the ed_vc within the parse_vc works only
			   cs2_vc_gen is called for a vc before the vc's
			   sub-vcs are processed.  this ensures the the
			   old_parent_vc_prop will be set for all parent vcs */
   cus_put_prop (parse_vc, old_parent_vc_prop, ed_vc);

   return;
}					/* end cs2_vc_gen */


/*--------------------------------------------------------------------------*\
|  Routine: evc_parse_vc_2_ed
|
|  Description:
|     convert the parser version of the vc to editor version
\*--------------------------------------------------------------------------*/
evc_vc evc_parse_vc_2_ed (vc)
cus_sym vc;
{  evc_vc ed_sub_vc, ed_vc;
   LIST snippet, comments, guys;
   buffer ed_snippet, ed_comments;
   cus_sym guy;
   eva_variable ed_var;
   eob_object ed_obj;

   ed_vc = evc_create_vc ();

   evc_set_name (ed_vc, cus_sym_representation (vc));

   if (comments = (LIST) cus_get_prop (vc, vc_comments_prop))
      {ed_comments = esi_comments_2_text (comments);
      evc_set_comments (ed_vc, ed_comments);
      }

   if (snippet = (LIST) cus_get_prop (vc, creation_condition_prop))
      {ed_snippet  = esi_cc_2_text (snippet);
      evc_set_creation_condition (ed_vc, ed_snippet);
      }

   if (guys = (LIST) cus_get_prop (vc, variables_prop))
      {loop_through_list (guys, guy, cus_sym)
         {ed_var = eva_parse_variable_2_ed (guy);
         evc_add_variable (ed_vc, ed_var);
         }
      }

   if (guys = (LIST) cus_get_prop (vc, objects_prop))
      {loop_through_list (guys, guy, cus_sym)
         {ed_obj = eob_parse_object_2_ed (guy);
         evc_add_object (ed_vc, ed_obj);
         }
      }

   if (snippet = (LIST) cus_get_prop (vc, create_actions_snippet_prop))
      {ed_snippet = esi_snip_2_text (snippet);
      evc_set_create_actions (ed_vc, ed_snippet);
      }

   if (snippet = (LIST) cus_get_prop (vc, destroy_actions_snippet_prop))
      {ed_snippet = esi_snip_2_text (snippet);
      evc_set_destroy_actions (ed_vc, ed_snippet);
      }

   return (ed_vc);
}                                       /* end evc_parse_vc_2_ed */


/*--------------------------------------------------------------------------*\
|  Routine: evc_src_write
|
|  Description:
|     write a vc to a source stream
\*--------------------------------------------------------------------------*/
void evc_src_write (the_vc, stream)
FILE *stream;
evc_vc the_vc;
{  buffer the_snippet, the_comment;
   LIST guys;
   caddr_t guy;
   boolean is_eve;

   is_eve = (evc_get_parent (the_vc) == EVC_NO_VC);

   if (!is_eve)
      fprintf (stream, "VC: %s\n", evc_get_name (the_vc));

   the_comment = evc_get_comments (the_vc);
   if (ea2_printable_buffer (the_comment))
      {esi_buffer_src_write (the_comment, stream, FALSE);
      fprintf (stream, "\n");
      }

   if (!is_eve)
      {fprintf (stream, "CREATION CONDITION: \n");
      esi_buffer_src_write (evc_get_creation_condition (the_vc), stream, FALSE);
      fprintf (stream, "\n");
      }
   
   if ((guys = (LIST) evc_get_variables (the_vc)) && (list_length (guys) > 0))
      {fprintf (stream, "VARIABLES:\n");
      loop_through_list (guys, guy, caddr_t)
         {eva_src_write (guy, stream);
         }
      fprintf (stream, "\n");
      }

   if ((guys = (LIST) evc_get_objects (the_vc)) && (list_length (guys) > 0))
      {fprintf (stream, "OBJECTS:\n");
      loop_through_list (guys, guy, caddr_t)
         {eob_src_write (guy, stream);
         }
      fprintf (stream, "\n");
      }

   the_snippet = evc_get_create_actions (the_vc);
   if (ea2_printable_buffer (the_snippet))
      {fprintf (stream, "ON CREATE:\n");
      esi_buffer_src_write (the_snippet, stream, FALSE);
      fprintf (stream, "\n");
      }

   the_snippet = evc_get_destroy_actions (the_vc);
   if (ea2_printable_buffer (the_snippet))
      {fprintf (stream, "ON DESTROY:\n");
      esi_buffer_src_write (the_snippet, stream, FALSE);
      fprintf (stream, "\n");
      }

   if ((guys = (LIST) evc_get_vcs (the_vc))  && (list_length (guys) > 0))
      {loop_through_list (guys, guy, caddr_t)
         {evc_src_write (guy, stream);
         }
      }

   if (!is_eve)
      fprintf (stream, "ENDVC %s\n\n", evc_get_name (the_vc));

   return;
}                                       /* end evc_src_write */


/*--------------------------------------------------------------------------*\
|  Routine: evc_bin_write
|
|  Description:
|     write a vc to a source stream
\*--------------------------------------------------------------------------*/
void evc_bin_write (the_vc, stream)
FILE *stream;
evc_vc the_vc;
{  LIST guys;
   caddr_t guy;
   object_instance_sdd *obj_inst;

   write_open_record (stream);
   ebi_write_token_char (stream, EBI_VC_SELECTOR);

   ebi_write_token (stream, evc_get_name (the_vc));

   ebi_write_token (stream, cus_sym_representation (the_vc));

   write_buffer (stream, evc_get_comments (the_vc),
		 EBI_COMMENTS_SELECTOR);

   write_buffer (stream, evc_get_creation_condition (the_vc),
		 EBI_CREATION_COND_SELECTOR);

   write_open_record (stream);
   if ((guys = (LIST) evc_get_variables (the_vc)))
      loop_through_list (guys, guy, caddr_t)
         eva_bin_write (guy, stream);
   write_close_record (stream);

   write_open_record (stream);
   if ((guys = (LIST) evc_get_objects (the_vc)))
      loop_through_list (guys, guy, caddr_t)
         eob_bin_write (guy, stream);
   write_close_record (stream);

   write_buffer (stream, evc_get_create_actions (the_vc),
		 EBI_ON_CREATE_SELECTOR);

   write_buffer (stream, evc_get_destroy_actions (the_vc),
		 EBI_ON_DESTROY_SELECTOR);

			/* now for the sub-vcs */
   write_open_record (stream);
   if ((guys = (LIST) evc_get_vcs (the_vc)))
      loop_through_list (guys, guy, caddr_t)
         evc_bin_write (guy, stream);
   write_close_record (stream);

			/* now for the obj instances.  obj instances
			   have to be after their templates in the bin file
			   for everyhting to work correctly */
   write_open_record (stream);
   if ((guys = (LIST) evc_get_objects (the_vc)))
      loop_through_list (guys, guy, caddr_t)
         {if ((obj_inst = eob_get_instance (guy)))
            eoi_bin_write (stream, obj_inst);
         if (get_status () != ok)
            break;
         }
   write_close_record (stream);

			/* close the vc */
   write_close_record (stream);

   return;
}                                       /* end evc_bin_write */


/*--------------------------------------------------------------------------*\
|  Routine: evc_cleanup_instances
|
|  Description:
|     cleanup dangling parents for instances
\*--------------------------------------------------------------------------*/
static void evc_cleanup_instances (out_transaction)
transaction_type out_transaction;
{
   eob_object obj;
   id_type obj_id;
   object_instance_sdd *parent_obj_instance;
   object_instance_attribute_sdd *att_instance;

   obj = (eob_object) get_head_val (ea2_object_instances_not_completely_done);
   att_instance = (object_instance_attribute_sdd *)
		    get_from_head(ea2_object_instances_not_completely_done);
   while (att_instance)
      {parent_obj_instance = eob_get_instance (obj);
      if (parent_obj_instance && att_instance)
         {strncpy (att_instance-> value, parent_obj_instance-> name,
                sizeof (att_instance-> value));
         obj_id = emp_get_id (att_instance);
         if (obj_id != null_id)
            {put_shared_data (out_transaction, obj_id,
			      "object_instance_attribute_sdd", "value",
			      att_instance-> value);
               if (get_status ())
                  fprintf (stderr,
	"evc_instantiate_guys: couldn't update parent att value field\n");
            }
         }

      obj = (eob_object)get_head_val(ea2_object_instances_not_completely_done);
      att_instance = (object_instance_attribute_sdd *)
		   get_from_head(ea2_object_instances_not_completely_done);
      }

   free_list (ea2_object_instances_not_completely_done, NOT_NODES);
   return;
}					/* end evc_cleanup_instances */


/*--------------------------------------------------------------------------*\
|  Routine: evc_bin_read
|
|  Description:
|     read a vc from a binary stream
\*--------------------------------------------------------------------------*/
evc_vc evc_bin_read (stream, transaction)
FILE *stream;
transaction_type transaction;
{  evc_vc the_sub_vc, the_vc;
   string the_token;
   ebi_buffer the_buffer;
   eob_object the_obj;
   eva_variable the_var;
   object_instance_sdd *obj;

   the_token = ebi_read_token (stream);
   if (*the_token == EBI_BAD_CHAR)
      bum_vc;
   if (*the_token == EBI_CLOSE_RECORD)
      {if (ebi_push_token (the_token))
         return (EVC_NO_MORE_VCS);
        else
         bum_vc;
      }
   if (*the_token != EBI_OPEN_RECORD)
      bum_vc;

   if ((the_vc = evc_create_vc ()) ==  EVC_NO_VC)
      bum_vc;

   if (!(ebi_read_token_char (stream) == EBI_VC_SELECTOR))
      bum_vc;

   if (!(the_token = ebi_read_token (stream)))
      bum_vc;
   evc_set_name (the_vc, the_token);

				/* we are not putting the old save unique name
				   anywhere, for now */
   if (!(the_token = ebi_read_token (stream)))
      bum_vc;

   read_buffer (stream, the_buffer, EBI_COMMENTS_SELECTOR);
   evc_set_comments (the_vc, the_buffer.actual_buffer);

   read_buffer (stream, the_buffer, EBI_CREATION_COND_SELECTOR);
   evc_set_creation_condition (the_vc, the_buffer.actual_buffer);

   read_open_record (stream);
   while ((the_var = eva_bin_read (stream)) != EVA_NO_MORE_VARIABLES)
      {if (the_var == EVA_NO_VARIABLE)
         bum_vc;
      evc_add_variable (the_vc, the_var);
      }
   read_close_record (stream);

   read_open_record (stream);
   while ((the_obj = eob_bin_read (stream)) != EOB_NO_MORE_OBJECTS)
      {if (the_obj == EOB_NO_OBJECT)
         bum_vc;
      evc_add_object (the_vc, the_obj);
      }
   read_close_record (stream);

   read_buffer (stream, the_buffer, EBI_ON_CREATE_SELECTOR);
   evc_set_create_actions (the_vc, the_buffer.actual_buffer);

   read_buffer (stream, the_buffer, EBI_ON_DESTROY_SELECTOR);
   evc_set_destroy_actions (the_vc, the_buffer.actual_buffer);

			/* now for the sub-vcs */
   read_open_record (stream);
   while ((the_sub_vc = evc_bin_read (stream, transaction)) != EVC_NO_MORE_VCS)
      {if (the_sub_vc == EVC_NO_VC)
         bum_vc;
      evc_add_vc (the_vc, the_sub_vc);
      }
   read_close_record (stream);

   ea2_object_instances_not_completely_done = make_list ();

                        /* Read list of object instances and  set them
                           up.  these instances should not cause a template to
                           be created since the template was saved out in the
                           file also */
   read_open_record (stream);
   while (((obj = eoi_bin_read (stream, transaction)) != EOI_NO_OBJ_INSTANCE)&&
          (!get_status ()))
			/* there is nothing else to dow for an instance */
      {1;
      }
   if (get_status () != ok)
      bum_vc;
   read_close_record (stream); /* end of object instance list */
   evc_cleanup_instances (transaction);

   read_close_record (stream);

   return (the_vc);
}					/* end evc_bin_read */


/*--------------------------------------------------------------------------*\
|  Routine: evc_instantiate_guys
|
|  Description:
|     do the instantiate type shit for a vc template
\*--------------------------------------------------------------------------*/
void evc_instantiate_guys (the_vc, extent, command, out_transaction)
evc_vc the_vc;
evc_node_selection extent;
int command;
transaction_type out_transaction;
{  LIST sub_vcs, objs;
   evc_vc sub_vc;
   eob_object obj;
   id_type obj_id;
   object_instance_sdd *parent_obj_instance;
   object_instance_attribute_sdd *att_instance;

   ea2_object_instances_not_completely_done = make_list ();

			/* do the action for all objects in vc */
   if ((objs = (LIST) evc_get_objects (the_vc)))
      loop_through_list (objs, obj, eob_object)
         switch (command)
            {case instantiate_cmd:
               eob_instantiate (obj, out_transaction);
               break;
            case uninstantiate_cmd:
               eob_uninstantiate (obj, out_transaction);
               break;
            case remove_cmd:
               eob_remove_instance (obj, out_transaction);
               break;
            default:
               fprintf (stderr, "evc_instantiate_guys: invalid command %d\n",
                        command);
               set_status (unknown_handling);
               return;
            }

   evc_cleanup_instances (out_transaction);

#if 0
   obj = (eob_object) get_head_val (ea2_object_instances_not_completely_done);
   att_instance = (object_instance_attribute_sdd *)
		    get_from_head(ea2_object_instances_not_completely_done);
   while (att_instance)
      {parent_obj_instance = eob_get_instance (obj);
      if (parent_obj_instance && att_instance)
         {strncpy (att_instance-> value, parent_obj_instance-> name,
                sizeof (att_instance-> value));
         obj_id = emp_get_id (att_instance);
         if (obj_id != null_id)
            {put_shared_data (out_transaction, obj_id,
			      "object_instance_attribute_sdd", "value",
			      att_instance-> value);
               if (get_status ())
                  fprintf (stderr,
	"evc_instantiate_guys: couldn't update parent att value field\n");
            }
         }

      obj = (eob_object)get_head_val(ea2_object_instances_not_completely_done);
      att_instance = (object_instance_attribute_sdd *)
		   get_from_head(ea2_object_instances_not_completely_done);
      }

   free_list (ea2_object_instances_not_completely_done, NOT_NODES);
#endif


			/* now do action for all sub-vcs in the vc, if tree
			   action is requested */
   if ((extent == EVC_ENTIRE_HIERARCHY) &&
       (sub_vcs = (LIST) evc_get_vcs (the_vc)))
      loop_through_list (sub_vcs, sub_vc, evc_vc)
         evc_instantiate_guys (sub_vc, extent, command, out_transaction);
      
   return;
}					/* end evc_instantiate_guys */


/*--------------------------------------------------------------------------*\
|  Routine: evc_add_object_instance
| 
|  Description:  
|     Adds an object instance to a vc
\*--------------------------------------------------------------------------*/
boolean evc_add_object_instance (the_vc, obj_instance, transaction)
evc_vc the_vc;
object_instance_sdd *obj_instance;
transaction_type transaction;
{  eob_object the_obj_template;
   eat_attribute an_att_template;
   LIST list;
   object_instance_attribute_sdd *att_instance;
   id_type id;

   set_status (ok);

			/* create the template for the new instance & tie them
			   together if creation went ok */
   if ((the_obj_template = eob_create_object (obj_instance->type,
                                           obj_instance->tech))
             == EOB_NO_OBJECT )
      {fprintf (stderr, "evc_add_object_instance: can't create object\n");
      set_status (invalid_object);
      }
    else
			/* set up all the relevant obj template values */
      {eob_set_parent (the_obj_template, the_vc);
      eob_set_name (the_obj_template, obj_instance->name);
      evc_add_object (the_vc, the_obj_template);
      eob_set_instance (the_obj_template, obj_instance);

			/* set the obj instance to point to the obj template 
			   NOTE: the structure thinks it is an id, but we are
			   really putting in a handle to the template */
      obj_instance->template = (id_type)  the_obj_template;

			/* notify dialogue of new template */
      eso_create_sd (transaction, the_obj_template);

      id = obj_instance->attr_list;
			/* change things so the att instance list is via
			   sdd handles instead of ids */
      if (id != null_id)
         obj_instance->attr_list = emp_get_de (id);
       else
         obj_instance->attr_list = NULL;

			/* now loop thorough all the attributes, doing good
			   stuff */
      while ( (id != null_id) && (get_status () == ok) )
         {att_instance = (object_instance_attribute_sdd *) emp_get_de (id);
         if ((att_instance == NULL) || (get_status () != ok))
             {fprintf (stderr,
                     "evc_add_object_instance: unmappable attribute id -- %d\n",
                       id);
             set_status (invalid_id);
             return (FALSE);
             }
         if (!(an_att_template =
		eat_temp_from_inst (att_instance, the_obj_template)))
            {fprintf (stderr,
	      "evc_add_object_instance: bad status from eat_temp_from_inst\n");
            set_status (invalid_object_instance);
            return (FALSE);
            }

			/* next id, please. */
         id = att_instance->attr_list;
			/* change things so the att instance list is via
			   sdd handles instead of ids */
         if (id != null_id)
            att_instance->attr_list = emp_get_de (id);
          else
            att_instance->attr_list = NULL;
         } /* end while */
      }

   if (get_status () == ok)
      edg_increment_object_count (e22_dialogue, obj_instance->tech);

   return (get_status () == ok);
}					/* end evc_add_object_instance	    */


/*--------------------------------------------------------------------------*\
|  Routine: evc_remove_object_instance
| 
|  Description:  
|     Removes an object instance and the associated object template if
|     it is a ghost.
\*--------------------------------------------------------------------------*/
boolean evc_remove_object_instance (the_vc, obj_instance, out_trans)
evc_vc the_vc;
object_instance_sdd *obj_instance;
transaction_type out_trans;
{  
   object_instance_attribute_sdd *att_instance, *save_instance;
   id_type id;
   boolean delete_template;
   eat_attribute att_template;

   set_status (ok);
/* 
** initialize the list which will hold the att templates 
*/
   delete_template = TRUE;
   att_instance = (object_instance_attribute_sdd *)obj_instance->attr_list;
/* 
**  Loop thorough all the attributes to determine if the template is
**  a ghost and needs to be deleted.
*/
  while ( (att_instance != NULL) && (get_status() == ok) )  {

    delete_template = delete_template && 
      eat_get_ghost(att_instance->template);
    att_instance = (object_instance_attribute_sdd *)att_instance->attr_list;
  }
/*
**  If the template was a ghost, delete the object template including
**  the attributes and methods and free the object instance and
**  object attribute instances.
*/
   if (delete_template) {

      evc_remove_object(obj_instance->template);
      check_status(
        "evc_remove_object_instance: can't remove object from parent."
      );
      eso_remove_from_sd(out_trans, obj_instance->template);
      eob_destroy_object(obj_instance->template, out_trans);
   }
/* 
**  Else get rid of of the object and attribute instances.
*/
   else {
     eoi_destroy_object_instance(obj_instance, out_trans);
   }

   return (get_status() == ok);
}					/* end evc_remove_object_instance   */


