/* $Header: /u/04b/mnt/ljb/RCS/font.sl,v 1.6 1991/04/23 17:56:32 ljb Exp $ */
/*--------------------------------------------------------------------------*\
|  
|  Name:  Integer Xtype Editor (font.sl)
|
|  Description:  
|     This file contains the Slang code to implement the edit 
|     field for font attributes. 
|
|  Component of:
|     Dialogue editor dialogue.
|
|  Related files:
|     gw.slang - generic widget code.
|
|  Project:
|     Serpent
|     User Interface Project
|     Software Engineering Institute
|     Carnegie Mellon University
|     Pittsburgh, PA  15213
|
|  Version: 1.0
|
|  Project Leader:  
|     Len Bass
|     ljb@sei.cmu.edu
|
|  Author:  
|     Robert C. Seacord
|     rcs@sei.cmu.edu 
|     Modified by Roger Moos to support color
| 
|
|  Change History:
|     Nov 21, 1990 : Module created.
|     $Log: font.sl,v $
% Revision 1.6  1991/04/23  17:56:32  ljb
% change background to form rather than box
%
% Revision 1.5  1991/04/11  18:05:49  rcs
% *** empty log message ***
%
% Revision 1.4  91/03/21  17:13:48  rcs
% *** empty log message ***
% 
% Revision 1.3  91/03/19  19:58:59  rcs
% delete shared data instance in on delete
% 
% Revision 1.2  91/02/04  13:35:25  rm
% bug fix
% 
% Revision 1.1  91/01/31  11:57:27  rm
% Initial revision
% 
% Revision 1.1  91/01/31  10:31:37  rm
% Initial revision
% 
% Revision 1.1  90/11/29  18:44:24  rcs
% Initial revision
% 
\*--------------------------------------------------------------------------*\
|
|   Distribution: Approved for public release; distribution is unlimited.
|
|   Copyright (c) 1989  by  Carnegie  Mellon  University, Pittsburgh, PA.  The
|  Software Engineering  Institute  (SEI) is a federally  funded  research and
|  development center established  and  operated by Carnegie Mellon University
|  (CMU).  Sponsored  by  the  U.S.  Department  of   Defense  under  contract
|  F19628-85-C-0003,  the  SEI  is  supported  by  the  services  and  defense
|  agencies, with the U.S. Air Force as the executive contracting agent.
|
|    Permission to use,  copy,  modify, or  distribute  this  software and its
|  documentation for  any purpose and without fee  is hereby granted, provided
|  that  the above copyright notice appear  in  all copies and that both  that
|  copyright  notice  and   this  permission  notice  appear   in   supporting
|  documentation.   Further,  the  names  Software  Engineering  Institute  or
|  Carnegie  Mellon  University  may  not be used in  advertising or publicity
|  pertaining to distribution of the software without specific, written  prior
|  permission.  CMU makes no claims  or representations  about the suitability
|  of this software for any purpose.  This software is provided "as is" and no
|  warranty,  express  or  implied,  is  made  by  the  SEI  or CMU, as to the
|  accuracy  and  functioning of the program and related program material, nor
|  shall   the  fact of  distribution   constitute  any   such  warranty.   No
|  responsibility is assumed by the SEI or CMU in connection herewith.
|
\*--------------------------------------------------------------------------*/

/*------------------- constants --------------------------------------------*/

#undef DEBUG1
#undef DEBUG2
#undef DEBUG3

#define DEBUG1(statement) SERPENT_DEBUG1(font_debug, statement)
#define DEBUG2(statement) SERPENT_DEBUG2(font_debug, statement)
#define DEBUG3(statement) SERPENT_DEBUG3(font_debug, statement)

/*--------------------------------------------------------------------------*\
|  Name:  gt_font_vc
|
|  Description:
|    The font x type vc supports the editing of font attributes.
\*--------------------------------------------------------------------------*/
VC: gt_font_vc

Creation Condition: (new("xfontstruct_xtype_sdd"))

Variables:
  xfontstruct_help_id: true;
  font_attr_error_id;		/* id of error sdd	*/
  attr_name: get_sd_value(xfontstruct_xtype_sdd.attribute,"name");
  attr_value: { attr_value := get_sd_value(xfontstruct_xtype_sdd.attribute,"value");}

Objects:

  attribute_box(xfontstruct)

  attribute_label(xfontstruct)

  font_attr_text: XawTextentry {
    Attributes: 
      parent: xfontstruct_attr_box; 
      width: ATTR_WIDTH; 
      height: ATTRIBUTE_HEIGHT; 
      borderColor: "white"; 
      textBuffer: { 
        if (attr_value = UNDEFINED) then 
          textBuffer := glue_get_attr_default( 
            widget_handle,attr_name,SERPENT_DEFAULT 
        ); 
        else 
          textBuffer := attr_value;
        end if; 
      } 
      horizdistance: xfontstruct_attr_label.width + 3;
    Methods: 
/*
**  Send method.
*/
      send: {
        DEBUG2(
          printf("font_attr_text: send method called.\n",""); 
          printf("font_attr_text: name = %s.\n",attr_name); 
          printf("font_attr_text: textBuffer = %s.\n",textBuffer); 
        ) 
/*
**  Update the application value.
*/
        put_sd_value(xfontstruct_xtype_sdd.attribute,"value",textBuffer);
/*
**  Update the display value.
*/
        if (id_exists(object_id)) then
          put_sd_value(object_id,attr_name,textBuffer);
        end if;

        DEBUG2(
          printf("font_attr_text: exit.\n",""); 
        ) 
      }
/*
** Focus method.
*/
      focus: {
        if (id_exists(current_focus)) then
          put_sd_value(current_focus,"font","6x13");
        end if;
        xfontstruct_attr_box.focus := SELF;
        current_focus := SELF;
        font := "*";
      }
  }

font_attr_button: XawCommand {
  Attributes: 
    parent: xfontstruct_attr_box;
    label: "F"; 
    width: 18; 
    height: 18; 
    borderwidth: 1;
    horizdistance: xfontstruct_attr_box.width - 25;

  Methods: 
    notify: {
      fontsel := TRUE; 
      fs_attr:= attr_name;
      fs_object := object_instance_sdd.name; 
      fs_object_id := object_instance_sdd; 
      fs_attr_id := xfontstruct_xtype_sdd.attribute;
      fs_object_instance_id:= object_id;
    }
}

/*
** Destroy the shared data instance that caused this view controller
** to be created.
*/
  On Destroy: {
    destroy_sd_instance(xfontstruct_xtype_sdd);
  }

end VC gt_font_vc;
