/* $Header: /u/04c/mnt/integ/source/de/src/RCS/fontsel.sl,v 1.10 91/02/04 13:34:58 rm Exp $ */
/*--------------------------------------------------------------------------*\
|  
|  Name:  fontsel.sl
|
|  Description:  
|     This file contains the dialogue for the font selector.
|
|  Component of:
|     Dialogue editor dialogue.
|
|  Related files:
|     fontsel.c - implementation of c routines for font selector.
|     fontsel.sl -  font selector dialogue.
|
|  Project:
|     Serpent
|     User Interface Project
|     Software Engineering Institute
|     Carnegie Mellon University
|     Pittsburgh, PA  15213
|
|  Version: 1.0
|
|  Project Leader:  
|     Len Bass
|     ljb@sei.cmu.edu
|
|  Author: 
|     Dan Klein
|     dvk@sei.cmu.edu
|
|     Robert C. Seacord
|     rcs@sei.cmu.edu  
|
|  Change History:
|     June 20, 1990 : Module created.
|     $Log:	fontsel.sl,v $
% Revision 1.10  91/02/04  13:34:58  rm
% add putsd to update display value
% 
% Revision 1.9  90/11/29  18:37:55  rcs
% *** empty log message ***
% 
% Revision 1.8  90/11/09  17:20:34  rcs
% *** empty log message ***
% 
% Revision 1.7  90/10/10  22:41:09  rcs
% new widget names
% 
% Revision 1.6  90/10/10  16:51:14  rm
% new sat names
% 
% Revision 1.5  90/10/09  22:10:27  rcs
% new sat attribute names & generic editor stuff
% 
% Revision 1.4  90/08/22  18:26:21  rcs
% *** empty log message ***
% 
% Revision 1.3  90/07/13  12:48:33  rcs
% leaving for 2 weeks
% 
% Revision 1.2  90/07/02  23:24:17  rcs
% *** empty log message ***
% 
% Revision 1.1  90/06/20  11:16:54  rcs
% Initial revision
% 
|
\*--------------------------------------------------------------------------*\
|
|   Distribution: Approved for public release; distribution is unlimited.
|
|   Copyright (c) 1989  by  Carnegie  Mellon  University, Pittsburgh, PA.  The
|  Software Engineering  Institute  (SEI) is a federally  funded  research and
|  development center established  and  operated by Carnegie Mellon University
|  (CMU).  Sponsored  by  the  U.S.  Department  of   Defense  under  contract
|  F19628-85-C-0003,  the  SEI  is  supported  by  the  services  and  defense
|  agencies, with the U.S. Air Force as the executive contracting agent.
|
|    Permission to use,  copy,  modify, or  distribute  this  software and its
|  documentation for  any purpose and without fee  is hereby granted, provided
|  that  the above copyright notice appear  in  all copies and that both  that
|  copyright  notice  and   this  permission  notice  appear   in   supporting
|  documentation.   Further,  the  names  Software  Engineering  Institute  or
|  Carnegie  Mellon  University  may  not be used in  advertising or publicity
|  pertaining to distribution of the software without specific, written  prior
|  permission.  CMU makes no claims  or representations  about the suitability
|  of this software for any purpose.  This software is provided "as is" and no
|  warranty,  express  or  implied,  is  made  by  the  SEI  or CMU, as to the
|  accuracy  and  functioning of the program and related program material, nor
|  shall   the  fact of  distribution   constitute  any   such  warranty.   No
|  responsibility is assumed by the SEI or CMU in connection herewith.
|
\*--------------------------------------------------------------------------*/

#define fs_slang
#include "fontsel.h"

/*------------------- constants --------------------------------------------*/

#undef DEBUG1
#undef DEBUG2
#undef DEBUG3

#define DEBUG1(statement) SERPENT_DEBUG1(fs_debug, statement)
#define DEBUG2(statement) SERPENT_DEBUG2(fs_debug, statement)
#define DEBUG3(statement) SERPENT_DEBUG3(fs_debug, statement)

#define TOPLINE_TOP	10
#define TOPLINE_HEIGHT	20
#define DOIT_WIDTH	50
#define SAMPLE_TOP	TOPLINE_TOP+TOPLINE_HEIGHT
#define SAMPLE_HEIGHT	50
#define SAMPLE_OFFSET	10
#define NAME_TOP	SAMPLE_TOP+SAMPLE_HEIGHT+10
#define NAME_HEIGHT	20
#define NAME_WIDTH	165
#define NAME_OFFSET	SAMPLE_OFFSET
#define SLANT_TOP	SAMPLE_TOP+SAMPLE_HEIGHT+10
#define SLANT_HEIGHT	20
#define SLANT_WIDTH	80
#define SLANT_OFFSET	NAME_OFFSET+NAME_WIDTH+10
#define WEIGHT_TOP	\
    SAMPLE_TOP+SAMPLE_HEIGHT+10+(howmany_of(FONT_SLANT)+2)*SLANT_HEIGHT
#define WEIGHT_HEIGHT	SLANT_HEIGHT
#define WEIGHT_WIDTH	SLANT_WIDTH
#define WEIGHT_OFFSET	SLANT_OFFSET
#define SIZE_TOP	SAMPLE_TOP+SAMPLE_HEIGHT+10
#define SIZE_HEIGHT	20
#define SIZE_WIDTH	50
#define SIZE_OFFSET	WEIGHT_OFFSET+WEIGHT_WIDTH+10

/*--------------------------------------------------------------------------*\
|  Name: font_selector
|
|  Description:
|    The font_selector view controller controls the overall visibility
|    of the font selector.
\*--------------------------------------------------------------------------*/
VC : font_selector

    CREATION CONDITION: (fontsel)

    VARIABLES:
	i;
	max;
	fid;
	cur_name : "*";
	cur_size : "*";
	cur_slant : "*";
	cur_weight : "*";
	cur_name_id;
	cur_size_id;
	cur_slant_id;
	cur_weight_id;

        cur_string;

	cur_name_idx : 0;	/* TODO: initialize to the current settings */
	cur_size_idx : 0;
	cur_slant_idx : 0;
	cur_weight_idx : 0;

    OBJECTS:

        fs_shell: XawTopLevelShell {
            Attributes:
              iconname: "Font";
              title: "Font Selector";
       }

	fs_form : XawBboard {
	    ATTRIBUTES:
                parent : fs_shell;
		width : SIZE_OFFSET+SIZE_WIDTH + 13;
		height : int_max( 
                  howmany_of(FONT_SIZE)*SIZE_HEIGHT,
		  howmany_of(FONT_NAME)*NAME_HEIGHT 
                ) + SIZE_TOP + 20;
		allowUserMove : TRUE;
		horizDistance : 100;
		vertDistance : 250;
#ifdef SMOT
		x : 0;
		y : 0;
#endif
	    }

        fontsel_title: XawLabel {
          Attributes:
            parent: fs_form;
            borderWidth: 0;
            background: "black";
            foreground: "white";
            height: 18;
            horizDistance: 1;
            vertDistance: 1;
            width: SIZE_OFFSET+SIZE_WIDTH + 11;
            label: string_append("Font: ", fs_object);
            justify: LEFT;
        }

        new_button(
          apply_button,
          fs_form,
          25,
          fs_form.height - 60,
          "Apply",
         {
/*
   Generate the current string from the selected buttons.
*/

            put_sd_value(
              fs_attr_id, 
              "value", 
              sample.font
            );
            if (id_exists(fs_object_instance_id)) then
              put_sd_value(fs_object_instance_id,fs_attr,sample.font);
            end if;
          }
        )

        new_button(
          quit_button,
          fs_form,
          100,
          fs_form.height - 60,
          "Done",
          {
            fontsel := FALSE;
          }
        )

        new_button(
          help_button,
          fs_form,
          175,
          fs_form.height - 60,
          "Help",
          {
            font_selector_help := true;
          }
        )

	sample : XawText {
	    ATTRIBUTES:
		parent : fs_form;
		width : (SIZE_OFFSET+SIZE_WIDTH)-SAMPLE_OFFSET;
		height : SAMPLE_HEIGHT;
		font : font_str(cur_name,cur_size,cur_slant,cur_weight);
		textBuffer : "Font Sample";
		horizDistance : NAME_OFFSET;
		vertDistance : SAMPLE_TOP;
	    }

    ON CREATE: {
/*
   Read in all the font names.
*/
	i := 0;
	max := howmany_of(FONT_NAME);
	WHILE (i < max) DO
	    fid := create_sd_instance("fontname", "DM_BOX");
	    put_sd_value(fid, "idx", i);
	    put_sd_value(fid, "vert", NAME_TOP+(i*NAME_HEIGHT));
	    put_sd_value(fid, "name", fetch_val(FONT_NAME, i));
	    i := i + 1;
	END WHILE;
/*
**  Read in the font sizes.
*/
	i := 0;
	max := howmany_of(FONT_SIZE);
 
        DEBUG3(
          printf("on create:  number of font sizes = %s.\n", max);
        )
        
	WHILE (i < max) DO
	    fid := create_sd_instance("fontsize", "DM_BOX");
	    put_sd_value(fid, "idx", i);
	    put_sd_value(fid, "vert", SIZE_TOP+(i*SIZE_HEIGHT));
	    put_sd_value(fid, "size", fetch_val(FONT_SIZE, i));
 
            DEBUG3(
              printf("on create: size = %s.\n", fetch_val(FONT_SIZE, i));
            )

	    i := i + 1;
	END WHILE;
/*
**  Read in all the font slants.
*/
	i := 0;
	max := howmany_of(FONT_SLANT);
	WHILE (i < max) DO
	    fid := create_sd_instance("fontslant", "DM_BOX");
	    put_sd_value(fid, "idx", i);
	    put_sd_value(fid, "vert", SLANT_TOP+(i*SLANT_HEIGHT));
	    put_sd_value(fid, "slant", fetch_val(FONT_SLANT, i));
	    i := i + 1;
	END WHILE;
/*
**  Read in all the font weights.
*/
	i := 0;
	max := howmany_of(FONT_WEIGHT);
	WHILE (i < max) DO
	    fid := create_sd_instance("fontweight", "DM_BOX");
	    put_sd_value(fid, "idx", i);
	    put_sd_value(fid, "vert", WEIGHT_TOP+(i*WEIGHT_HEIGHT));
	    put_sd_value(fid, "weight", fetch_val(FONT_WEIGHT, i));
	    i := i + 1;
	END WHILE;
	}

/*--------------------------------------------------------------------------*\
|  Name: font_name
|
|  Description:
|    The font_name view controller is instantiated on the fontname dm.sdd
|    element and is used to create buttons for each font found.
\*--------------------------------------------------------------------------*/
    VC : font_name

	CREATION CONDITION: ( new("fontname") )

	OBJECTS:
	    selector : XawCommand {
		ATTRIBUTES:
		    parent: fs_form;
		    height: NAME_HEIGHT;
		    width: NAME_WIDTH;
		    foreground : "black";
		    background : "white";
		    label: fontname.name;
		    sensitive: font_exists(
                      fontname.name,cur_size,cur_slant,cur_weight
                    );
		    horizDistance : NAME_OFFSET;
		    vertDistance : fontname.vert;
		METHODS:
		    notify : {
			put_sd_value(cur_name_id,"foreground","black");
			put_sd_value(cur_name_id,"background","white");
			foreground := "white";
			background := "black";
			cur_name := fontname.name;
			cur_name_id := selector;
			cur_name_idx := fontname.idx;
			}
		}

	ON CREATE: {
	    IF (fontname.idx = cur_name_idx) THEN
		cur_name := fontname.name;
		cur_name_id := selector;
		selector.foreground := "white";
		selector.background := "black";
	    END IF;
	    }
    END VC font_name;

/*--------------------------------------------------------------------------*\
|  Name: font_size
|
|  Description:
|    The font_size view controller is instantiated on the fontsize dm.sdd
|    element and is used to create buttons for each font found.
\*--------------------------------------------------------------------------*/
    VC : font_size
	CREATION CONDITION: ( new("fontsize") )

	OBJECTS:
	    selector : XawCommand {
		ATTRIBUTES:
		    parent: fs_form;
		    height: SIZE_HEIGHT;
		    width: SIZE_WIDTH;
		    foreground : "black";
		    background : "white";
		    label: fontsize.size;
		    sensitive: font_exists(
                      cur_name,fontsize.size,cur_slant,cur_weight
                    );
		    horizDistance : SIZE_OFFSET;
		    vertDistance : fontsize.vert;
		METHODS:
		    notify : {
			put_sd_value(cur_size_id,"foreground","black");
			put_sd_value(cur_size_id,"background","white");
			foreground := "white";
			background := "black";
			cur_size := fontsize.size;
			cur_size_id := selector;
			cur_size_idx := fontsize.idx;
			}
		}

	ON CREATE: {
	    IF (fontsize.idx = cur_size_idx) THEN
		cur_size := fontsize.size;
		cur_size_id := selector;
		selector.foreground := "white";
		selector.background := "black";
	    END IF;
	    }
    END VC font_size;

/*--------------------------------------------------------------------------*\
|  Name: font_slant
|
|  Description:
|    The font_slant view controller is instantiated on the fontslant dm.sdd
|    element and is used to create buttons for each font found.
\*--------------------------------------------------------------------------*/
    VC : font_slant
	CREATION CONDITION: ( new("fontslant") )

	OBJECTS:
	    selector : XawCommand {
		ATTRIBUTES:
		    parent: fs_form;
		    height: SLANT_HEIGHT;
		    width: SLANT_WIDTH;
		    foreground : "black";
		    background : "white";
		    label: fontslant.slant;
		    sensitive: font_exists(cur_name,cur_size,fontslant.slant,cur_weight);
		    horizDistance : SLANT_OFFSET;
		    vertDistance : fontslant.vert;
		METHODS:
		    notify : {
			put_sd_value(cur_slant_id,"foreground","black");
			put_sd_value(cur_slant_id,"background","white");
			foreground := "white";
			background := "black";
			cur_slant := fontslant.slant;
			cur_slant_id := selector;
			cur_slant_idx := fontslant.idx;
			}
		}

	ON CREATE: {
	    IF (fontslant.idx = cur_slant_idx) THEN
		cur_slant := fontslant.slant;
		cur_slant_id := selector;
		selector.foreground := "white";
		selector.background := "black";
	    END IF;
	    }
    END VC font_slant;

/*--------------------------------------------------------------------------*\
|  Name: font_weight
|
|  Description:
|    The font_weight view controller is instantiated on the fontweight dm.sdd
|    element and is used to create buttons for each font found.
\*--------------------------------------------------------------------------*/
    VC : font_weight
	CREATION CONDITION: ( new("fontweight") )

	OBJECTS:
	    selector : XawCommand {
		ATTRIBUTES:
		    parent: fs_form;
		    height: WEIGHT_HEIGHT;
		    width: WEIGHT_WIDTH;
		    foreground : "black";
		    background : "white";
		    label: fontweight.weight;
		    sensitive: font_exists(cur_name,cur_size,cur_slant,fontweight.weight);
		    horizDistance : WEIGHT_OFFSET;
		    vertDistance : fontweight.vert;
		METHODS:
		    notify : {
	   	      put_sd_value(cur_weight_id,"foreground","black");
 		      put_sd_value(cur_weight_id,"background","white");
		      foreground := "white";
		      background := "black";
		      cur_weight := fontweight.weight;
		      cur_weight_id := selector;
		      cur_weight_idx := fontweight.idx;
		    }
		}

	ON CREATE: {
	    IF (fontweight.idx = cur_weight_idx) THEN
		cur_weight := fontweight.weight;
		cur_weight_id := selector;
		selector.foreground := "white";
		selector.background := "black";
	    END IF;
	    }
    END VC font_weight;

END VC font_selector;
