/* $Header: /usr/users/rcs/serpent/source/de/src/RCS/forms.sl,v 1.18 1991/06/19 20:01:58 rcs Exp $ */
/*--------------------------------------------------------------------------*\
|   
|  Name:  menus
|
|  Description:  
|     This file contains the slang for the system menu bar.
|
|  Component of:
|     Serpent visualization editor dialogue layer.
|
|  Related files:
|     help_menus.sl - contains the slang source for the help menus.
|
|  Project:
|     Serpent
|     User Interface Project
|     Software Engineering Institute
|     Carnegie Mellon University
|     Pittsburgh, PA  15213
|
|  Version: 1.0
|
|  Project Leader:  
|     Len Bass
|     ljb@sei.cmu.edu
|
|  Author:  
|     Robert C. Seacord
|     rcs@sei.cmu.edu  
|
|  Change History:
|	Feb. 24, 1989 : Module created.
|	$Log: forms.sl,v $
% Revision 1.18  1991/06/19  20:01:58  rcs
% fixed layout of grid snap form
%
% Revision 1.17  1991/04/26  18:57:45  ljb
% align error messages better
%
% Revision 1.16  1991/04/26  16:06:36  rcs
% changed text of quit warning message
%
% Revision 1.15  91/03/21  17:14:11  rcs
% *** empty log message ***
% 
% Revision 1.14  91/03/19  19:56:43  rcs
% *** empty log message ***
% 
% Revision 1.13  91/03/13  07:14:40  rcs
% *** empty log message ***
% 
% Revision 1.12  90/11/29  18:38:14  rcs
% *** empty log message ***
% 
% Revision 1.11  90/11/09  17:20:49  rcs
% *** empty log message ***
% 
% Revision 1.10  90/10/10  22:41:32  rcs
% new widget names
% 
% Revision 1.9  90/10/10  17:05:49  rm
% new sat names
% 
% Revision 1.8  90/10/09  22:10:57  rcs
% *** empty log message ***
% 
% Revision 1.7  90/09/19  17:41:20  rcs
% fixed problem with current file name getting trashed
% 
% Revision 1.6  90/09/17  21:41:15  rcs
% *** empty log message ***
% 
% Revision 1.5  90/08/29  21:51:56  rcs
% *** empty log message ***
% 
% Revision 1.4  90/08/22  18:26:37  rcs
% *** empty log message ***
% 
% Revision 1.3  90/07/02  23:23:37  rcs
% *** empty log message ***
% 
% Revision 1.2  90/06/25  19:31:11  rcs
% a little better than the last
% 
% Revision 1.1  90/06/18  12:01:00  rcs
% Initial revision
% 
% Revision 1.11  90/06/01  09:01:22  clc
% gave a decent message for exit_sure_text widget.
% 
% Revision 1.10  90/05/29  18:40:49  rcs
% new style menu bars
% 
% Revision 1.7  90/05/10  12:53:31  rcs
% *** empty log message ***
% 
% Revision 1.6  90/03/23  14:19:39  rcs
% fixed someting
% 
% Revision 1.5  90/03/15  11:37:51  rcs
% shut off help menu; add type abbr to drawables
% 
% Revision 1.4  90/03/08  13:09:55  rcs
% fixed up some of the font stuff
% 
% Revision 1.3  90/03/07  10:13:03  rcs
% changed contents of exit menu
% 
% Revision 1.2  90/03/01  11:37:36  rcs
% make the actuals for some methods smaller
% 
% Revision 1.1  90/02/28  11:43:43  rcs
% Initial revision
% 
|
\*--------------------------------------------------------------------------*\
|
|   Distribution: Approved for public release; distribution is unlimited.
|
|   Copyright (c) 1989  by  Carnegie  Mellon  University, Pittsburgh, PA.  The
|  Software Engineering  Institute  (SEI) is a federally  funded  research and
|  development center established  and  operated by Carnegie Mellon University
|  (CMU).  Sponsored  by  the  U.S.  Department  of   Defense  under  contract
|  F19628-85-C-0003,  the  SEI  is  supported  by  the  services  and  defense
|  agencies, with the U.S. Air Force as the executive contracting agent.
|
|    Permission to use,  copy,  modify, or  distribute  this  software and its
|  documentation for  any purpose and without fee  is hereby granted, provided
|  that  the above copyright notice appear  in  all copies and that both  that
|  copyright  notice  and   this  permission  notice  appear   in   supporting
|  documentation.   Further,  the  names  Software  Engineering  Institute  or
|  Carnegie  Mellon  University  may  not be used in  advertising or publicity
|  pertaining to distribution of the software without specific, written  prior
|  permission.  CMU makes no claims  or representations  about the suitability
|  of this software for any purpose.  This software is provided "as is" and no
|  warranty,  express  or  implied,  is  made  by  the  SEI  or CMU, as to the
|  accuracy  and  functioning of the program and related program material, nor
|  shall   the  fact of  distribution   constitute  any   such  warranty.   No
|  responsibility is assumed by the SEI or CMU in connection herewith.
|
\*--------------------------------------------------------------------------*/

#undef DEBUG1
#undef DEBUG2
#undef DEBUG3

#define DEBUG1(statement) SERPENT_DEBUG1(forms_debug, statement)
#define DEBUG2(statement) SERPENT_DEBUG2(forms_debug, statement)
#define DEBUG3(statement) SERPENT_DEBUG3(forms_debug, statement)

/*--------------------------------------------------------------------------*\
|  Name: run_form_vc
|
|  Description:
|    The import menu allows the user to import slang source.
|    ??? this could be expanded to support clg options.
\*--------------------------------------------------------------------------*/
  VC: run_form_vc

    Creation condition: (display_run_form)
 
    Variables:
        error_sdi;		/* temp variable used by set_error macro */
        error_flag : false;

    Objects:

      run_shell: XawTopLevelShell {
        Attributes:
          iconname: "Serpent Editor";
          iconpixmap: "se_bitmap";
          title: "Run Command";
      }

      run_menu_form: XawBboard {
        Attributes:
          parent: run_shell;
          width: 302;
          height: 122;
      }

     run_file_name_label: XawLabel {
       Attributes:
         parent: run_menu_form;
         borderColor: "white";
         label: "Run exported dialogue:";
         justify: LEFT;
         horizDistance: 18;
         vertDistance: 10;
      }

      run_filename_text: XawTextentry {
        Attributes:
          parent: run_menu_form;
          width: 260;
          height: 20;
          textBuffer: current_dialogue_filename;
          vertDistance: 40;
          horizDistance: 20;
          sendBuffer: 0;
        Methods:
          send: {
/* 
**  Some rudimentary checking of the file name.
*/
            if (string_length(textBuffer) > 0) then
/*
**  Spawn a process to compile, link and execute the dialogue.
*/
          system(
            string_append(
              string_append("serpent -clg ", textBuffer)," &"
            )
          );
/*
**  Set the status message.
*/
          message := string_append("Running ", textBuffer);
/*
**  Else 
*/
            else
              set_error("Error: Null file name",
                "Import Slang Source",error_sdi,error_flag
              )
            endif;
            display_run_form := false;
          }
      }

      new_big_button(
        save_button,
        run_menu_form,
        45,
        80,
        "Run",
        {
          run_filename_text.sendBuffer := 1;
        }
      ) 

      new_big_button( 
        cancel_button,
        run_menu_form,
        120,
        80,
        "Cancel",
        {
          display_run_form := false;
        }
      ) 

      new_big_button(
        help_button,run_menu_form,195,80,"Help",
        { 
          run_cmd_help := true;
        }
      ) 

end VC run_form_vc

/*--------------------------------------------------------------------------*\
|  Name: import_form_vc
|
|  Description:
|    The import menu allows the user to import slang source.
\*--------------------------------------------------------------------------*/
  VC: import_form_vc

    Creation condition: (display_import_menu)
 
    Variables:
        error_sdi;		/* temp variable used by set_error macro */
        error_flag : false;

    Objects:

      import_shell: XawTopLevelShell {
        Attributes:
          iconname: "Serpent Editor";
          iconpixmap: "se_bitmap";
          title: "Import Command";
      }

      import_menu_form: XawBboard {
        Attributes:
          parent: import_shell;
          width: 302;
          height: 122;
      }

     import_file_name_label: XawLabel {
       Attributes:
         parent: import_menu_form;
         borderColor: "white";
         label: "Import slang from:";
         justify: LEFT;
         horizDistance: 18;
         vertDistance: 10;
      }

      import_filename_text: XawTextentry {
        Attributes:
          parent: import_menu_form;
          width: 260;
          height: 20;
          textBuffer: current_dialogue_filename;
          vertDistance: 40;
          horizDistance: 10;
          sendBuffer: 0;
        Methods:
          send: {
/* 
   Some rudimentary checking of the file name.
*/

            if (string_length(textBuffer) > 0) then
/*
**  Create a new command_sdd element to tell application that this is 
**  a request for import of slang source.
*/
	      make_command_and_parameter(
                selected_command,parameter_list,import_cmd,textBuffer 
              )
              error_name := textBuffer;
/*
   Set the status message.
*/
          message := string_append("Importing ", textBuffer);
/* 
**  Else 
*/
            else
              set_error("Error: Null file name",
                "Import Slang Source",error_sdi,error_flag
              )
            endif;
            display_import_menu := false;
          }
      }

      new_big_button(
        save_button,
        import_menu_form,
        45,
        80,
        "Import",
        {
          import_filename_text.sendBuffer := 1;
        }
      ) 

      new_big_button( 
        cancel_button,
        import_menu_form,
        120,
        80,
        "Cancel",
        {
          display_import_menu := false;
        }
      ) 

      new_big_button(
        help_button,
        import_menu_form,
        195,
        80,
        "Help" ,
        { 
          import_cmd_help := true;
        }
      ) 

end VC import_form_vc


/*--------------------------------------------------------------------------*\
|  Name: export_form_vc
|
|  Description:
|    The export menu allows the user to export slang source.
\*--------------------------------------------------------------------------*/
  VC: export_form_vc

    Creation condition: (display_export_menu)
 
    Variables:
        error_sdi;
        error_flag  : false;
        err_msg     : "Error in EXPORT File Name.\nFile name must be 1 to 32 chars in length.";
        err_title   : "Export Slang Source";

    Objects:

      export_shell: XawTopLevelShell {
        Attributes:
          iconname: "Serpent Editor";
          iconpixmap: "se_bitmap";
          title: "Export Command";
      }

      export_menu_form: XawBboard {
        Attributes:
          parent: export_shell;
          width: 302;
          height: 122;
      }

     export_file_name_label: XawLabel {
       Attributes:
         parent: export_menu_form;
         borderColor: "white";
         label: "Export slang to:";
         justify: LEFT;
#ifdef SMOT
         x: 18;
         y: 10;
#endif
#ifdef SAW
         horizDistance: 18;
         vertDistance: 10;
#endif
      }

      export_filename_text: XawTextentry {
        Attributes:
          parent: export_menu_form;
          width: 260;
          height: 20;
          textBuffer: current_dialogue_filename;
#ifdef SMOT
          y: 40;
          x: 10;
#endif
#ifdef SAW
          vertDistance: 40;
          horizDistance: 10;
#endif
          sendBuffer: 0;
        Methods:
          send: {
/*
   If file name valid send command.
*/
            if (string_length(textBuffer) > 0) then
/*
   Create a new command_sdd element to tell application that this is 
   a request for export of slang source. 1st param is the dialogue ID.
*/
              make_command_and_parameter(
	        selected_command,
	        parameter_list,
	        export_cmd,
	        current_dialogue_sd 
              )
/*
   2nd param is the file name.
*/
	      make_another_parameter(parameter_list, textBuffer)
/*
   3rd parameter is whether to overwrite or not.
   Assume OVERWRITE here. 
*/
	      make_another_parameter(parameter_list, true)
/*
   Save this filename in case command bombs, and we have to 
   try again.
*/
              error_name := textBuffer;
/*
   Set the status message.
*/
          message := string_append("Exporting ", textBuffer);
/* 
   Else, ERROR 
*/
            else
              set_error(err_msg,err_title,error_sdi,error_flag)
            endif;

            display_export_menu := false;
          }
      }

      new_big_button(
        save_button,
        export_menu_form,
        45,
        80,
        "Export",
        {
          export_filename_text.sendBuffer := 1;
        }
     ) 

      new_big_button( 
        cancel_button,
        export_menu_form,
        120,
        80,
        "Cancel",
        {
          display_export_menu := false;
        }
      ) 

      new_big_button(
        help_button,
        export_menu_form,
        195,
        80,
        "Help",
        { 
          export_cmd_help := true;
        }
      ) 


end VC export_form_vc
 
/*--------------------------------------------------------------------------*\
|  Name: get_file_name_vc
|
|  Description:
|    Gets the name of the file in which to "Save" or "Save as.." the dialogue.
\*--------------------------------------------------------------------------*/
  VC: get_file_name_vc

    Creation condition: (display_get_file_name_form)

    Variables:
        error_sdi;
        error_flag : false;
        err_msg    : "Error in SAVE File Name.\nFile name must be 1 to 32 chars in length.";
        err_title  : "GET_FILE_NAME VC";

    Objects:

      get_file_name_shell: XawTopLevelShell {
        Attributes:
          iconname: "Serpent Editor";
          iconpixmap: "se_bitmap";
          title: "Save Command";
      }

      get_file_name_form: XawBboard {
        Attributes:
          parent: get_file_name_shell;
          width: 302;
          height: 122;
      }

     get_file_name_label: XawLabel {
       Attributes:
         parent: get_file_name_form;
         borderColor: "white";
         label: "Save dialogue name:";
         justify: LEFT;
#ifdef SMOT
         x: 18;
         y: 10;
#endif
#ifdef SAW
         horizDistance: 18;
         vertDistance: 10;
#endif
      }

      current_object_text: XawTextentry {
        Attributes:
          parent: get_file_name_form;
          width: 260;
          height: 20;
          textBuffer: set_text_name(textBuffer, current_dialogue_filename);
#ifdef SAW
          y: 40;
          x: 10;
#endif
#ifdef SAW
          vertDistance: 40;
          horizDistance: 10;
#endif
          sendBuffer: 0;

        Methods:
          send: {
/* 
   Some rudimentary checking of the file name.
*/
            if (string_length(textBuffer) > 0) then
/*
   Create a new command_sdd element to tell application that this is 
   a request for a save.
*/
              make_command_and_parameter(
                selected_command,
		parameter_list,
		save_dialogue_cmd,
		current_dialogue_sd
              )
/*
   Filename to save it in.
*/
              make_another_parameter(parameter_list, textBuffer)
/*
   Don't assume OVERWRITE here. File might already exist.
*/
 	      make_another_parameter(parameter_list, false)
/*
   Save this filename in case command bombs, and we have to 
   try again. (See display_save_status_vc).  
*/
              error_name := textBuffer;

              save_filename := textBuffer;
/*
**   Set the status message.
*/
          message := string_append("Saving ", textBuffer);
/* 
   Else, ERROR 
*/
              else
                set_error(err_msg,err_title,error_sdi,error_flag)
              endif;

              display_get_file_name_form := false;
          }
      }
 
      new_big_button(
        save_button,
        get_file_name_form,
        45,
        80,
        "Save",
        {
           current_object_text.sendBuffer := 1;
        }
     ) 

      new_big_button( 
        cancel_button,
        get_file_name_form,
        120,
        80,
        "Cancel",
        {
          display_get_file_name_form := false;
        }
      ) 

      new_big_button(
        help_button,
        get_file_name_form,
        195,
        80,
        "Help",
        { 
          save_cmd_help := true;
        }
      ) 

  end VC get_file_name_vc

/*--------------------------------------------------------------------------*\
|  Name: get_load_file_name_vc
|
|  Description:
|    Gets the name of the file from which to load the dialogue.
\*--------------------------------------------------------------------------*/
  VC: get_load_file_name_vc

    Creation condition: (display_get_load_file_name_form)
 
    Variables:
        error_sdi;
        error_flag : false;
        err_msg    : "Error in LOAD File Name.\nFile name must be 1 to 32 chars in length.";
        err_title  : "GET_LOAD_FILE_NAME VC";

    Objects:

      load_shell: XawTopLevelShell {
        Attributes:
          iconname: "Serpent Editor";
          iconpixmap: "se_bitmap";
          title: "Load Command";
      }

      get_load_file_name_form: XawBboard {
        Attributes:
          parent: load_shell;
          width: 302;
          height: 122;
      }

     get_load_file_name_label: XawLabel {
       Attributes:
         parent: get_load_file_name_form;
         borderColor: "white";
         label: "Load dialogue from:";
         justify: LEFT;
#ifdef SMOT
         x: 18;
         y: 10;
#endif
#ifdef SAW
         horizDistance: 18;
         vertDistance: 10;
#endif
      }

      current_load_object_text: XawTextentry {
        Attributes:
          parent: get_load_file_name_form;
          width: 260;
          height: 20;
          textBuffer: "";
#ifdef SMOT
          y: 40;
          x: 10;
#endif
#ifdef SAW
          vertDistance: 40;
          horizDistance: 10;
#endif
          sendBuffer: 0;
        Methods:
          send: {
/*
   Send load command if valid filename.
*/
            if (string_length(textBuffer) > 0) then

	      make_command_and_parameter(
	        selected_command,
		parameter_list,
		load_dialogue_cmd,
		textBuffer 
              )
/*
   Save this filename as the source name in case command bombs.
*/
              error_name := textBuffer;
/*
   Set the status message.
*/
              message := string_append("Loading ", textBuffer);
/* 
   Else error condition.
*/
            else
              set_error(err_msg,err_title,error_sdi,error_flag)
            endif;

            display_get_load_file_name_form := false;
          }
      }

 
      new_big_button(
        save_button,
        get_load_file_name_form,
        45,
        80,
        "Load",
        {
           current_load_object_text.sendBuffer := 1;
        }
      ) 
 
      new_big_button( 
        cancel_button,
        get_load_file_name_form,
        120,
        80,
        "Cancel",
        {
          display_get_load_file_name_form := false;
        }
      ) 

      new_big_button(
        help_button,
        get_load_file_name_form,
        195,
        80,
        "Help",
        { 
          load_cmd_help := true;
        }
      ) 

  end VC get_load_file_name_vc

/*--------------------------------------------------------------------------*\
|  Name: display_confirm_quit_vc
|
|  Description:
|    View controller to make sure the user understands he's about to Quit
|    and that no changes that he/she has made will be saved.
\*--------------------------------------------------------------------------*/
  VC: display_confirm_quit_vc

    Creation condition: (display_confirm_quit)

    Objects:

      unload_shell: XawTopLevelShell {
        Attributes:
          iconname: "Serpent Editor";
          iconpixmap: "se_bitmap";
          title: string_append("Unload: ", current_dialogue_filename);
      }

      sure_form: XawBboard {
        Attributes:
          parent: unload_shell;
          width: 410;
          height: 6 * FONT_HEIGHT + 60;
      }

      sure_text: XawText {
        Attributes:
          parent: sure_form;
	  editType: READ;
          borderColor: "white";
          width: 350;
          height: 6 * FONT_HEIGHT;
#ifdef SMOT
          y: 10;
          x: 25;
#endif
#ifdef SAW
          vertDistance: 10;
          horizDistance: 25;
#endif
          textBuffer: "\nWarning:  The dialogue has been changed.\n\nTo unload the dialogue without saving these changes select\nthe 'Unload' button.\n\nTo cancel this command select the 'Cancel' button";
      }

      new_button(
        quit_button,
        sure_form,
        77,
        6 * FONT_HEIGHT + 25,
        "Unload",
        {
/*
   Create request to application to quit.
*/
          make_command_and_parameter(
            selected_command,
            parameter_list,
            unload_dialogue_cmd,
            current_dialogue_sd 
          )
/*
   Set error name in case command bombs.
*/
          error_name := current_dialogue_filename;
/*
   Reset current dialogue globals.
*/
	  current_dialogue_sd := NULL;
          current_dialogue_filename := "";
/*
   If there is no dialogue we don't want to allow prototyping.
*/
          prototype := false;
/*
   Disembody this VC.
*/
          display_confirm_quit := false;          
        }
      )

      new_button(
        cancel_button,
        sure_form,
        282,
        6 * FONT_HEIGHT + 25,
        "Cancel",
        {
          display_confirm_quit := false;          
        }
      )

end VC display_confirm_quit_vc

/*--------------------------------------------------------------------------*\
|  Name: display_confirm_exit_vc
|
|  Description:
|    View controller to make sure the user understands he/she's about to Exit
|    and that no changes that he/she has made will be saved.
\*--------------------------------------------------------------------------*/
  VC: display_confirm_exit_vc

    Creation condition: (display_confirm_exit)

    Objects:

      quit_shell: XawTopLevelShell {
        Attributes:
          iconname: "Serpent Editor";
          iconpixmap: "se_bitmap";
          title: "Quit";
      }

      exit_sure_form: XawBboard {
        Attributes:
          parent: quit_shell;
          width: 410;
          height: 6 * FONT_HEIGHT + 50;
      }

      exit_sure_text: XawText {
        Attributes:
          parent: exit_sure_form;
	  editType: READ;
          borderColor: "white";
          width: 350;
          height: 6 * FONT_HEIGHT;
#ifdef SMOT
          y: 10;
          x: 25;
#endif
#ifdef SAW
          vertDistance: 10;
          horizDistance: 25;
#endif
          textBuffer: "\nWarning:  The dialogue has been changed.\n\nTo exit the dialogue without saving these changes\nselect the 'Quit' button.\n\nTo cancel this command select the 'Cancel' button.";
      }

      new_button(
        quit_button,
        exit_sure_form,
        77,
        6 * FONT_HEIGHT + 25,
        "Quit",
        {
          exit();
          display_confirm_exit := false;          
        }
      )

      new_button(
        cancel_button,
        exit_sure_form,
        282,
        6 * FONT_HEIGHT + 25,
        "Cancel",
        {
          display_confirm_exit := false;          
        }
      )

end VC display_confirm_exit_vc

/*--------------------------------------------------------------------------*\
|  Name: toolbox_vc
|
|  Description:
|    The toolbox_vc is used to control the display of toolboxes for
|    the various toolkit objects.  
\*--------------------------------------------------------------------------*/
  VC: toolbox_vc

    Creation condition: (new("toolbox_sdd"))

    Variables:
      tech_name: toolbox_sdd.tech;
      last_object: NULL;
      icon: true;	/* icon format true by default	*/

    Objects:

      toolbox_shell: XawTopLevelShell {
        Attributes:
          iconname: "Toolbox";
          iconpixmap: "se_bitmap";
          title: toolbox_sdd.tech;
      }

      toolbox_viewport: XawViewport {
        Attributes:
	  parent: toolbox_shell;
	  width: 766;
          height: 118;
          allowVert: true;
	  useright: true;
	  managedWhenCreated: false;
      }

      toolbox_box: XawBox {
        Attributes:
          parent: toolbox_viewport;	  	
      }

     On Create: {
/*
** Create a new command_sdd element to get the list of objects
** that are in the selected technology.
*/
       make_command_and_parameter(
         selected_command,parameter_list,get_object_types_cmd,tech_name
       )

     }

/*--------------------------------------------------------------------------*\
|  VC: display_icon_vc
|
|  Description:
|    Displays a selectable object_type available in the selected available
|    technologies.
\*--------------------------------------------------------------------------*/
    VC: display_icon_vc

    Creation condition: (
      new("obj_type_sdd") AND (obj_type_sdd.tech = tech_name) AND icon
    )

    Objects:

      object_type_icon: XawCommand { 
        Attributes: 
          parent: toolbox_box;
          borderColor: "white";
	  foreground: {
 	    if (toolbox_object = SELF) then
	      foreground := selected_foreground_color;
	    else
              foreground := normal_foreground_color;
	    end if;
	  }
	  background: {
 	    if (toolbox_object = SELF) then
	      background := selected_background_color;
	    else
              background := normal_background_color;
	    end if;
	  }
          bitmap: string_append(obj_type_sdd.abbr,".sbm");
        Methods:
          notify: {
            if  (toolbox_object = SELF) then
              toolbox_mailbox := UNDEFINED;
              toolbox_tech_type := UNDEFINED;
              toolbox_object_type := UNDEFINED;
              message := "";
              toolbox_object := UNDEFINED;
              draw_command := false;
	    else
              toolbox_mailbox := toolbox_sdd.mailbox;
              toolbox_tech_type := tech_name;
              toolbox_object_type := obj_type_sdd.name;
              message := 
		"Select position in visualization area to draw object.";
              toolbox_object := SELF;
              draw_command := true;
	    end if;
  	  }
	}

      end VC display_icon_vc

/*--------------------------------------------------------------------------*\
|  VC: display_object_name_vc
|
|  Description:
|    Displays a selectable object type name.
\*--------------------------------------------------------------------------*/
    VC: display_object_name_vc

    Creation condition: (
      new("obj_type_sdd") AND (obj_type_sdd.tech = tech_name) AND NOT icon
    )

    Objects:
 
      object_type_label: XawCommand { 
        Attributes: 
          parent: toolbox_box;
          borderColor: "white";
	  foreground: {
            if (toolbox_object = SELF) then
	      foreground := selected_foreground_color;
	    else
              foreground := normal_foreground_color;
	    end if;
	  }
	  background: {
            if (toolbox_object = SELF) then
	      background := selected_background_color;
	    else
              background := normal_background_color;
	    end if;
	  }
          label: obj_type_sdd.name; 
          height: 18; 
        Methods:
          notify: {
            if  (toolbox_object = SELF) then
              toolbox_mailbox := UNDEFINED;
              toolbox_tech_type := UNDEFINED;
              toolbox_object_type := UNDEFINED;
              message := "";
              toolbox_object := UNDEFINED;
              draw_command := false;
	    else
              toolbox_mailbox := toolbox_sdd.mailbox;
              toolbox_tech_type := tech_name;
              toolbox_object_type := obj_type_sdd.name;
              message := "Select position on canvas to draw object.";
              toolbox_object := SELF;
              draw_command := true;
	    end if;
  	  }
	}

      end VC display_object_name_vc

  end VC toolbox_vc
 
/*--------------------------------------------------------------------------*\
|  Name: bad_status_vc
|
|  Description:
|    This view controller instantiates whenever a bad status is returned 
|    from a command.  It contains subview controllers that instantiate
|    differently based on the command and the actual status.
\*--------------------------------------------------------------------------*/
  VC: bad_status_vc

    Creation condition: 
      (new("status_sdd") AND (status_sdd.status <> ok))

/*--------------------------------------------------------------------------*\
|  Name: display_bad_status_vc
|
|  Description:
|    This view controller displays a very general status message for
|    everything BUT a file_already_exists from the save command.
\*--------------------------------------------------------------------------*/
    VC: display_bad_status_vc

    Creation condition:
      (
        (status_sdd.command <> save_dialogue_cmd) OR
	(
          (status_sdd.command = save_dialogue_cmd) AND 
          (status_sdd.status <> file_already_exists)
        )
      )

    Variables:
      status_description;

    Objects:

      status_form: XawBboard {
        Attributes:
          parent: workspace;
          background: error_background_color;
          width: 410;
          height:  20 + 80;
          allowUserMove: true;
#ifdef SAW
          vertDistance: 45;
          horizDistance: DISPLAY_WIDTH - 500;
#endif
#ifdef SMOT
          x: 0;
          y: 0;
          resizePolicy: false;
#endif
      }

      title_bar(
        stus_title,
        status_form,
        string_append(
          current_command_name, 
          string_append(": ", source_name)
        ),
        408
      )

      status_text: XawText {
        Attributes:
          parent: status_form;
	  editType: READ;
          borderColor: error_border_color;
          background: error_background_color;
          foreground: error_foreground_color;
          width: 350;
          height: 20;
#ifdef SAW
          vertDistance: 10;
          horizDistance: 25;
#endif
          textBuffer: string_append("Error:  ", status_description);
      }

      error_button(
        ok_button,
        status_form,
        180,
        60,
        "OK",
        {
/*
   Destroy the shared data that caused this VC to be instantiated.
*/
          destroy_sd_instance(status_sdd);          
        }
      )
  
    On Create: {                                /* actions on create        */
/*
    Now get the correct status meaning. These are defined in status.h.
*/
      if (status_sdd.status = invalid_dialogue) then
        status_description := "Invalid dialogue";
      elsif (status_sdd.status = invalid_vc) then
        status_description := "Invalid VC";
      elsif (status_sdd.status = invalid_list) then
        status_description := "Invalid list";
      elsif (status_sdd.status = invalid_integer) then
        status_description := "Invalid integer";
      elsif (status_sdd.status = invalid_string) then
        status_description := "Invalid string";
      elsif (status_sdd.status = invalid_buffer) then
        status_description := "Invalid buffer";
      elsif (status_sdd.status = invalid_object) then
        status_description := "Invalid object";
      elsif (status_sdd.status = invalid_attribute) then
        status_description := "Invalid attribute";
      elsif (status_sdd.status = invalid_method) then
        status_description := "Invalid method";
      elsif (status_sdd.status = invalid_object_instance) then
        status_description := "Invalid object instance";
      elsif (status_sdd.status = invalid_variable) then
        status_description := "Invalid variable";
      elsif (status_sdd.status = file_already_exists) then
        status_description := "File already exists";
      elsif (status_sdd.status = file_not_found) then
        status_description := "File not found";
      elsif (status_sdd.status = invalid_bin_file) then
        status_description := "Invalid binary file";
      elsif (status_sdd.status = invalid_src_file) then
        status_description := "Invalid Slang file";
      else 
        status_description := string_append(
          "System error # ", status_sdd.status
        );
      endif;

    }                                           /* end actions on create    */

end VC bad_status_vc

/*--------------------------------------------------------------------------*\
|  Name: display_save_status_vc
|
|  Description:
|    Special handling for a saving a file that already exists.
\*--------------------------------------------------------------------------*/
  VC: display_save_status_vc

    Creation condition: 
      (
        (status_sdd.command = save_dialogue_cmd) AND 
        (status_sdd.status = file_already_exists)
      )
 
    Objects:

      save_status_form: XawBboard {
        Attributes:
          parent: workspace;
          width: 410;
          height: 5 * FONT_HEIGHT + 80;
          allowUserMove: true;
#ifdef SAW
          vertDistance: 45;
          horizDistance: DISPLAY_WIDTH - 500;
#endif
#ifdef SMOT
          x: DISPLAY_WIDTH - 500;
          y: 45;
          resizePolicy: false;
#endif
      }

      title_bar(
        save_title,
        save_status_form,
        string_append("Save: ", save_filename),
        408
      )

      save_text: XawText {
        Attributes:
          parent: save_status_form;
	  editType: READ;
          borderColor: "white";
          width: 350;
          height: 5 * FONT_HEIGHT;
#ifdef SMOT
          x: 25;
          y: 10;
#endif
#ifdef SAW
          horizDistance: 25;
          vertDistance: 10;
#endif
          textBuffer: "\nWarning:  Named file already exists.\n\nTo write over the existing file, select\nthe 'OK' button.\n\nTo cancel this command select the 'Cancel' button"; 
      }

      new_button(
        ok_button,
        save_status_form,
        77,
        5 * FONT_HEIGHT + 25,
        "OK",
        {
/*
   The user wants to overwrite the file that already exists.  Send another
   command to the application specifying overwrite as true.
*/
	  make_command_and_parameter(
            selected_command,
            parameter_list,
            save_dialogue_cmd,
            current_dialogue_sd
          )
/*
   Filename to save it in.
*/
	  make_another_parameter(
	    parameter_list,save_filename 
          )
/*
   Force overwrite here.
*/
	   make_another_parameter(
             parameter_list,true 
           )
/*
   Set error name in case command bombs.
*/
           error_name := save_filename;

           destroy_sd_instance(status_sdd);
        }
      )

      new_button(
        cancel_button,
        save_status_form,
        282,
        5 * FONT_HEIGHT + 25,
        "Cancel",
        {
/* 
   Just Cancel the save.
*/
          destroy_sd_instance(status_sdd);
        }
      )

  end VC display_save_status_vc

end VC bad_status_vc

/*--------------------------------------------------------------------------*\
|  Name: ok_status_vc
|
|  Description:
|    View controller to display status information on the LOAD command.
|    ??? it might make sense to rest command operands here instead of in menus
\*--------------------------------------------------------------------------*/
  VC: ok_status_vc

    Creation condition: 
      (new("status_sdd") AND (status_sdd.status = ok))
 
    On Create: {                                /* actions on create        */

      DEBUG2(
        printf("ok_status_vc:  On Create: enter.\n", "");
        printf("ok_status_vc:  command = %s.\n", status_sdd.command);
      )
/*
**  Modify dialogue changed variable based on command.
*/
      if (
        (status_sdd.command = save_dialogue_cmd) OR
        (status_sdd.command = load_dialogue_cmd) OR 
        (status_sdd.command = unload_dialogue_cmd)
      ) then

        dialogue_changed := false;

        DEBUG3(
          printf("ok_status_vc: On Create: dialogue_changed set false\n", "");
        )

      else 

        DEBUG3(
          printf(
            "ok_status_vc: On Create: dialogue_changed := %s\n",
            status_sdd.dialogue_changed
          );
        )
/*
**  If the dialogue is changed or the current command changed it, 
**  set dialogue changed to true.
*/
        dialogue_changed := dialogue_changed OR status_sdd.dialogue_changed;
      endif;
/*
**  If save command succesful modify the dialogue name and the 
**  current dialogue filename.
*/

/* 
   ?????? the following stuff has to change because it causes the 
   dialogue to be immediately modified.
*/

      if (status_sdd.command = save_dialogue_cmd) then
        current_dialogue_filename := save_filename;
        put_sd_value(current_dialogue_sd, "name", save_filename);
/*
**  Reset parameters.
*/
      elsif (status_sdd.command = add_object_cmd) then
        toolbox_tech_type := UNDEFINED;
        toolbox_object_type := UNDEFINED;
        toolbox_tech_type := UNDEFINED;
      endif;

      destroy_sd_instance(status_sdd);

      DEBUG2(
        printf("ok_status_vc:  On Create: exit\n", "");
      )

    }                                           /* end actions on create    */

end VC ok_status_vc

/*--------------------------------------------------------------------------*\
|  Name: grid_snap_values_vc
|
|  Description:
|    View controller used to display a form that allows the user to 
|    view/modify grid snap values.
\*--------------------------------------------------------------------------*/
VC: grid_snap_values_vc

   Creation condition: (set_grid_snap_values)

   Variables:
/*
**  Used to highlight an entry_widget 
*/
   current_focus: NULL;
/* 
**  Set to True when an error is detected during entry 
*/
   error_flag: False;
/* 
**  Local variables.
*/
   xgrid_local: xgrid;
   ygrid_local: ygrid;
   widthgrid_local: widthgrid;
   heightgrid_local: heightgrid;
/* 
**  Placeholders for the instantiation of possible error message boxes 
*/
   xgrid_error: NULL;
   ygrid_error: NULL;
   widthgrid_error: NULL;
   heightgrid_error: NULL;

  Objects:

    grid_shell: XawTopLevelShell {
      Attributes:
        iconname: "Grid Snap";
        iconpixmap: "se_bitmap";
        title: "Grid Snap Interval Values";
    }

    grid_form: XawBboard {
      Attributes:
        parent: grid_shell;
        focus: current_focus;
        width: 302;
        height: 162;
    }
/*
**  Fields on entry form.
*/
    integer_field(xgrid,grid_form,20,10,      "X :",ygrid)
    integer_field(ygrid,grid_form,150,10,     "Width :",widthgrid)
    integer_field(widthgrid,grid_form,20,60,  "Y :",heightgrid)
    integer_field(heightgrid,grid_form,150,60,"Height:",xgrid)

     new_button(
       ok_button,
       grid_form,
       70,
       120,
       "OK",
       {
         xgrid := xgrid_local;
         ygrid := ygrid_local;
         widthgrid := widthgrid_local;
         heightgrid := heightgrid_local;

         set_grid_snap_values := false;		  
       }
     )

     new_button(
       cancel_button,
       grid_form,
       180,
       120,
       "Cancel",
       {
         set_grid_snap_values := false;		  
       }
     )

end VC grid_snap_values_vc;
