/* $Header: /u/04c/mnt/integ/source/de/src/RCS/gw.sl,v 1.25 1991/07/09 21:31:01 dvk Exp $ */
/*--------------------------------------------------------------------------*\
|   
|  Name:  Generic Widget
|
|  Description:  
|     This file contains the slang code which defines the UI for
|     command widget visualization.
|
|  Component of:
|     Dialogue editor dialogue.
|
|  Related files:
|     none.
|
|  Project:
|     Serpent
|     User Interface Project
|     Software Engineering Institute
|     Carnegie Mellon University
|     Pittsburgh, PA  15213
|
|  Version: 1.0
|
|  Project Leader:  
|     Len Bass
|     ljb@sei.cmu.edu
|
|  Author:  
|     Robert C. Seacord
|     rcs@sei.cmu.edu  
|
|  Change History:
|     October 9, 1990 : Module created.
|     $Log: gw.sl,v $
% Revision 1.25  1991/07/09  21:31:01  dvk
% These changes were made by Reed, and I had to retrofit them into the
% dialogue.  I have no idea what he changed, and neither does he.  Ain't
% it fun shutting a project down?
%
% Revision 1.24  1991/06/28  18:02:13  dvk
% Implemented grid snap
%
% Revision 1.23  1991/05/16  18:52:20  ljb
% put test for creation around attribute stuff
%
% Revision 1.22  1991/05/16  14:58:36  rcs
% fixed button positions on attribute form
%
% Revision 1.21  1991/05/14  15:45:17  rcs
% removed extraneous erronious extraterrestial debug stuff
%
% Revision 1.20  1991/05/10  18:42:58  ljb
% remove print statement
%
% Revision 1.19  1991/04/26  15:50:12  rcs
% fixed problem with attribute list
%
% Revision 1.18  1991/04/23  17:56:59  ljb
% change method of displaying attributes to pages based on a form
% rather than using box
%
% Revision 1.17  1991/04/12  13:25:42  ljb
% fix so pick will create new object
%
% Revision 1.16  1991/04/11  18:04:19  rcs
% *** empty log message ***
%
% Revision 1.15  91/03/21  17:14:33  rcs
% *** empty log message ***
% 
% Revision 1.14  91/03/19  19:57:04  rcs
% fixed some bugs
% 
% Revision 1.13  91/03/13  07:15:07  rcs
% checkin de ve.sl
% 
% Revision 1.12  91/02/13  15:03:20  little
% delete the toolkit object in the destroy actions for gw_vc
% 
% Revision 1.11  91/02/05  13:59:08  rm
% fixed bugs with select and pick
% 
% Revision 1.10  91/02/04  12:56:32  rm
% changed to support pick method
% 
% Revision 1.9  91/01/31  11:56:12  rm
% add support for fonts
% 
% Revision 1.8  91/01/31  10:44:35  rm
% changed to support color
% 
% Revision 1.7  90/12/15  12:03:19  little
% change vc which put up attribute editing menu to destroy the local att
% sdds when going away
% 
% Revision 1.6  90/12/05  19:13:16  rcs
% get mailbox from object instance and not global var
% 
% Revision 1.5  90/11/29  18:39:18  rcs
% *** empty log message ***
% 
% Revision 1.4  90/11/09  17:21:19  rcs
% *** empty log message ***
% 
% Revision 1.3  90/10/10  22:42:07  rcs
% new widget names
% 
% Revision 1.2  90/10/10  16:52:14  rm
% new sat names
% 
% Revision 1.1  90/10/09  22:11:22  rcs
% Initial revision
% 
|
\*--------------------------------------------------------------------------*\
|
|   Distribution: Approved for public release; distribution is unlimited.
|
|   Copyright (c) 1989  by  Carnegie  Mellon  University, Pittsburgh, PA.  The
|  Software Engineering  Institute  (SEI) is a federally  funded  research and
|  development center established  and  operated by Carnegie Mellon University
|  (CMU).  Sponsored  by  the  U.S.  Department  of   Defense  under  contract
|  F19628-85-C-0003,  the  SEI  is  supported  by  the  services  and  defense
|  agencies, with the U.S. Air Force as the executive contracting agent.
|
|    Permission to use,  copy,  modify, or  distribute  this  software and its
|  documentation for  any purpose and without fee  is hereby granted, provided
|  that  the above copyright notice appear  in  all copies and that both  that
|  copyright  notice  and   this  permission  notice  appear   in   supporting
|  documentation.   Further,  the  names  Software  Engineering  Institute  or
|  Carnegie  Mellon  University  may  not be used in  advertising or publicity
|  pertaining to distribution of the software without specific, written  prior
|  permission.  CMU makes no claims  or representations  about the suitability
|  of this software for any purpose.  This software is provided "as is" and no
|  warranty,  express  or  implied,  is  made  by  the  SEI  or CMU, as to the
|  accuracy  and  functioning of the program and related program material, nor
|  shall   the  fact of  distribution   constitute  any   such  warranty.   No
|  responsibility is assumed by the SEI or CMU in connection herewith.
|
\*--------------------------------------------------------------------------*/

/*------------------- constants --------------------------------------------*/

#undef DEBUG1
#undef DEBUG2
#undef DEBUG3

#define DEBUG1(statement) SERPENT_DEBUG1(gw_debug, statement)
#define DEBUG2(statement) SERPENT_DEBUG2(gw_debug, statement)
#define DEBUG3(statement) SERPENT_DEBUG3(gw_debug, statement)

/*------------------- includes ---------------------------------------------*/

#include "gt_type.h"

/*--------------------------------------------------------------------------*\
|  Name: gw_vc
|
|  Description:
|    The gw_vc instantiates on a new object_instance_sdd in 
|    the shared data base.  
\*--------------------------------------------------------------------------*/
VC: gw_vc

  Creation Condition: (
    (new("object_instance_sdd")) AND 
    (object_instance_sdd.tech = parent_technology)
  )
/*
**  Constants:
*/
#define current_name get_sd_value(current_id,"name")
#define current_value get_sd_value(current_id,"value")
#define current_type get_sd_value(current_id,"type")
#define current_priority get_sd_value(current_id,"priority")

  Variables:
    object_id: NULL;    
    display_attributes: false;
    display_priority1_attributes: false;
    display_instance: object_instance_sdd.visible;
    current_id;
    last_parent: "null";  /* the last parent, "null" if none		*/
    error_flag: false;
    gw_stage: true;
    widget_handle;	/* handle for glue widget		*/
    serpent_type;
    current_focus;

/*-----------------------variables for pagination--------------------*/
    max_page:0;
    current_page:0;
    max_mapped_page: 0;
    current_position:0;

/*
**  The gw_methods variable provides all the method definitions for
**  the generic object.
*/
    gw_methods: {
        DEBUG2(printf("gw_methods received %s.\n", 
                       get_sd_value(object_id,"method")))

/*
**  Only examine methods if the object exists.
*/
    if (id_exists(object_id)) then

/*-------------------------- Create new object--------------------------------
        if a select is received and the draw command is enabled, then
        a new object is to be created
------------------------------------------------------------------------*/

       if (get_sd_value(object_id,"method") = "select" and draw_command) then 

        DEBUG2(printf("gw_methods var: creating new object.\n",""))

/*
**  Create the object and get the head of the attribute list.
*/
	  create_object(object_id);

          if (create_object_flag) then

             attribute := get_alist_next(attribute_list,C_NULL);
/*
**  Make sure the first attribute is linked to the object instance sdd.
*/
             DEBUG3(
             printf("gw_methods var: parent = %s.\n",object_instance_sdd.name);
               printf("gw_methods var: creating attributes.\n","");
             )

             temp_name := glue_get_attribute_name(attribute);
  
             create_attr(temp_name,object_instance_sdi,
               glue_get_attribute_xtype(attribute),
               glue_get_attribute_priority(attribute),
               object_instance_sdd.name,object_instance_sdi,current_id)

             attribute := get_alist_next(attribute_list,attribute);
/*
**  Define the remainder of the attributes.
*/
             while (attribute <> C_NULL) do

               DEBUG3(
                 printf("gw_methods var: attribute = %s.\n", temp_name);
               )

               previous_id := current_id;
               temp_name := glue_get_attribute_name(attribute);
  
               create_attr(temp_name,object_instance_sdi,
                 glue_get_attribute_xtype(attribute),
                 glue_get_attribute_priority(attribute),
                 object_instance_sdd.name,previous_id,current_id)

               attribute := get_alist_next(attribute_list,attribute);

             end while;
/*
**  Null terminate the list and reset the draw_command.
*/
             put_sd_value(current_id,"attr_list",NULL);
             draw_command := false;
             put_sd_value(object_id,"method",UNDEFINED);
           end if;

/*-------------------------- Pick method ---------------------------------*/

      elsif (get_sd_value(object_id,"method") = "pick") then

        DEBUG2(printf("gw_methods var: pick method.\n",""))

        source_mailbox := technology_mailbox;
        source_tech_type := visualize_sdd.tech;
        source_id := object_instance_sdd;
        source_type := OBJECT_INSTANCE_TYPE;
        source_object_type := object_instance_sdd.type;
        message := string_append(object_instance_sdd.name," selected.");

/*------------------------ Move method -------------------------------------*/

      elsif (get_sd_value(object_id,"method") = "move") then

        DEBUG2(printf("move method detected.\n", "");)

        current_id := object_instance_sdd.attr_list;
/*
**  Search for affected attributes.
*/
        while (current_id <> NULL) do
/*
**  If the application attribute shared data is either x, y, horizdistance, 
**  or vertdistance modify the application data and the values displayed
**  on the edit attributes form, if present.
*/
          if ( 
            (current_name = "x") OR (current_name = "horizdistance") OR
            (current_name = "y") OR (current_name = "vertdistance")
          ) then
/*
**  Update the application.
*/
	    DEBUG3(	      
	      printf("gw_methods var: ABOUT TO ASSIGN APP VALUE.\n","");
	      printf("gw_methods var: current_id = %s.\n",current_id);
	      printf(
                "gw_methods var: value = %s.\n",
                get_sd_value(object_id, current_name)
              );
	    )

	    if (grid_snap) then
		if ((current_name = "x") OR
		    (current_name = "horizdistance")) then
			put_sd_value(object_id, current_name,
			  round_to_nearest(
			    get_sd_value(object_id, current_name), xgrid)
			);
			put_sd_value(current_id,"value",
			  round_to_nearest(
			    get_sd_value(object_id, current_name), xgrid)
			);
		elsif ((current_name = "y") OR
		      (current_name = "vertdistance")) then
			put_sd_value(object_id, current_name,
			  round_to_nearest(
			    get_sd_value(object_id, current_name), ygrid)
			);
			put_sd_value(current_id,"value",
			  round_to_nearest(
			    get_sd_value(object_id, current_name), ygrid)
			);
		end if;
	    else
		put_sd_value(current_id,"value",
		  get_sd_value(object_id, current_name)
		);
	    end if;
          end if;		/* x, y, horix, or vert attribute	*/
          current_id := get_sd_value(current_id,"attr_list");
          message := string_append(object_instance_sdd.name," moved.");
        end while;

/*-------------------------  Resize method ---------------------------------*/

      elsif (get_sd_value(object_id,"method") = "resize") then

        DEBUG2(printf("resize method detected.\n",""))

        current_id := object_instance_sdd.attr_list;
/*
**  Search for affected attributes.
*/
        while (current_id <> NULL) do
/*
**  If the application attribute shared data is either x, y, width, height
**  horizdistance or vertdistance plug in corresponding attribute of the 
**  object.
*/
          if ( 
            (current_name = "width") OR (current_name = "height") OR
            (current_name = "x") OR (current_name = "y") OR
            (current_name = "horizdistance") OR
            (current_name = "vertdistance")
          ) then
/*
**  Update the application.
*/
	    if (grid_snap) then
		if ((current_name = "x") OR
		    (current_name = "horizdistance")) then
			put_sd_value(object_id, current_name,
			  round_to_nearest(
			    get_sd_value(object_id, current_name), xgrid)
			);
			put_sd_value(current_id,"value",
			  round_to_nearest(
			    get_sd_value(object_id, current_name), xgrid)
			);
		elsif ((current_name = "y") OR
		      (current_name = "vertdistance")) then
			put_sd_value(object_id, current_name,
			  round_to_nearest(
			    get_sd_value(object_id, current_name), ygrid)
			);
			put_sd_value(current_id,"value",
			  round_to_nearest(
			    get_sd_value(object_id, current_name), ygrid)
			);
		elsif (current_name = "width") then
			put_sd_value(object_id, current_name,
			  round_to_nearest(
			    get_sd_value(object_id, current_name), widthgrid)
			);
			put_sd_value(current_id,"value",
			  round_to_nearest(
			    get_sd_value(object_id, current_name), widthgrid)
			);
		elsif (current_name = "height") then
			put_sd_value(object_id, current_name,
			  round_to_nearest(
			    get_sd_value(object_id, current_name), heightgrid)
			);
			put_sd_value(current_id,"value",
			  round_to_nearest(
			    get_sd_value(object_id, current_name), heightgrid)
			);
		end if;
	    else
		put_sd_value(current_id,"value",
		  get_sd_value(object_id, current_name)
		);
	    end if;
          end if;
          current_id := get_sd_value(current_id,"attr_list");
        end while;
        message := string_append(object_instance_sdd.name," resized.");
      end if;		/* method type				*/
/*
**  Reset method name.
*/
    end if;		/* object exists			*/
  }

  On Create: {

    DEBUG2(printf("gw_vc, on create:  invoked.\n", ""))

    widget_handle := glue_get_widget(
      technology_handle,object_instance_sdd.type
    );

    DEBUG3(
      printf("gw_vc, on create:  widget handle = %s.\n", widget_handle);
      printf(
        "gw_vc, on create:  technology_handle = %s.\n", technology_handle
      );
      printf(
        "gw_vc, on create: object_instance_sdd.type = %s.\n", 
	object_instance_sdd.type
      );
    )
/*
**  Add object instance name to hash table.
*/
    add_object(object_instance_sdd.name);
/*
**  Set message and reset draw command.
*/
    message := string_append(object_instance_sdd.name, " created.");
    draw_command := false;

    DEBUG2(printf("gw_vc, on create: exiting.\n",""))

  }
/*
**  Destroy any existing widget 
*/
  On Destroy: {
    if (object_id <> NULL) then 
      destroy_sd_instance(object_id);
   end if;
  }

/*--------------------------------------------------------------------------*\
|  Name: edit_attributes_vc
|
|  Description:
|    The edit_attributes_vc controls the display of the attributes form
|    associated with a particular gw instance.
\*--------------------------------------------------------------------------*/
  VC: edit_priority_attributes_vc

    Creation Condition:  (display_attributes)

    Variables:

      current_focus: NULL;      /* used to change the focus               */
      send_flag: 0;	/* used to collect text from text widgets	*/

    Objects:

      outer_attribute_form: XawBboard {
        Attributes:
          parent: workspace;
          width:  330;
          height: 300;
          allowUserMove: true;
#ifdef SMOT
          resizePolicy: false;
#endif
      }

      attribute_form_title_bar(
        gw_title,
        outer_attribute_form,
        string_append(object_instance_sdd.type,":"),
        100,
        object_instance_sdd.name,
        97,
        {
/*
   If this object is currently being edited in either the font
   or color selector, update the name.
*/
         if (ce_object_id = object_instance_sdd) then
           ce_object := gw_title_text.textBuffer;
         end if;
 
         if (fs_object_id = object_instance_sdd) then
           fs_object := gw_title_text.textBuffer;
         end if;
/*
**  Remove the old name of the object from the hash and 
**  add the new name.  Any references to the old name
**  will get munged.
**
**  ??? this shouldn't allow invalid names
*/          if (
            string_lower(object_instance_sdd.name) <>
            string_lower(gw_title_text.textBuffer)
          ) then
            remove_object(object_instance_sdd.name);
            object_instance_sdd.name := gw_title_text.textBuffer;
            add_object(object_instance_sdd.name);
            set_id(object_instance_sdd.name, object_id);
          end if;

          send_flag := 0;
	}
      )

      attribute_title_page: XawLabel {
         Attributes: 
           parent: gw_title_form; 
           borderWidth: 0; 
           background: "black"; 
           foreground: "white"; 
           height: 17; 
           horizDistance: gw_title_form.width - 100;
           vertDistance: 0; 
           label: string_append("Page ",string_append(current_page + 1, 
                    string_append(" of ",max_page + 1))); 
           width: 100; 
           justify: LEFT; 
        }

      attribute_viewport: XawBboard {
        Attributes:
          parent: outer_attribute_form;
          vertDistance: 22;
          width: 320;
          height: 215;
      }
/*
**  The next button pages to the next page
**   if we have already seen this page, there is nothing
**   more to be done, if we haven't seen page, map app attributes
*/
      sensitive_button(
        next_button,
        outer_attribute_form,
        (current_page < max_page),
        15,
        255,
        "Next",
        {
         if (current_page < max_page) then
            current_page := current_page + 1;
         end if;

        DEBUG3(printf("gw.sl: next button current page %s\n",current_page);)
        DEBUG3(printf("gw.sl: next button max mapped page %s\n",
                    max_mapped_page);)
         if (current_page > max_mapped_page) then

            max_mapped_page := current_page;	
            current_id := object_instance_sdd.attr_list;
            current_position := 0;

        DEBUG3(printf("gw.sl: next button looping through attributes\n","");)
          while (current_id <> NULL) do
/*
**             Only map first page
*/
        DEBUG3(printf("gw.sl: next button current name %s\n",current_name);)
        DEBUG3(printf("gw.sl: next_button current priority %s\n",
                              current_priority);)
/*
**             Only map priority = current page
*/
              if (current_priority = current_page) then
                 convert_types(current_type,serpent_type);
                 map_to_local_sd(serpent_type,current_position,current_page,
                         temp_id);
                 current_position := current_position + 1;
              end if;
             current_id := get_sd_value(current_id,"attr_list");
            end while;
           end if;
        }
      ) 
/*
**  Previous Page button.
*/
      sensitive_button(
        prev_button,
        outer_attribute_form,
        (current_page > 0),
        95,
        255,
        "Prev",
        {
/*
**  Go to the previous page unless we are already at the start.
*/
         if (current_page > 0) then
            current_page := current_page - 1;
         end if;
        }
      ) 
/*
**  The done button simply exists the form without saving 
**  any of the changes.
*/
      new_button(
        done_button,
        outer_attribute_form,
        175,
        255,
        "Done",
        {
          error_flag := false;
          display_attributes := false;
          display_priority1_attributes := false;
          edit_attr_form_not_displayed := true;
        }
      ) 

/*
**  The help button explains all this crap.
*/
      new_button(
        help_button,
        outer_attribute_form,
        255,
        255,
        "Help",
        {
          gw_attr_form_help := true;
        }
      ) 

    On Create: {
	DEBUG3(printf("gw.sl: entering editing vc attributes On Create\n","");)
/*  ??? do something different with focus
      current_focus := parent_attribute_text;
*/

      x_position := x_position + 20;
      y_position := y_position + 20;

#ifdef SAW
      outer_attribute_form.horizDistance := x_position;
      outer_attribute_form.vertDistance := y_position;
#endif

#ifdef SMOT
      outer_attribute_form.x := x_position;
      outer_attribute_form.y := y_position;
#endif
      current_page := 0;
      max_mapped_page := 0;
      max_page := 0;

      current_id := object_instance_sdd.attr_list;
      current_position := 0;
/*
**             Create shared data records for each attribute.  This is
**             necessary to prevent exponential evaluation of creation
**             conditions on these attributes.
*/
	DEBUG3(printf("gw.sl: looping through attributes\n","");)
      while (current_id <> NULL) do
/*
**             Only map first page
*/
	DEBUG3(printf("gw.sl: current name %s\n",current_name);)
	DEBUG3(printf("gw.sl: current priority %s\n",current_priority);)
           if (current_priority > max_page) then
             max_page := current_priority;
           end if;

           if (current_priority = 0) then
              convert_types(current_type,serpent_type);
	DEBUG3(printf("gw.sl: serpent_type %s\n",serpent_type);)
              map_to_local_sd(serpent_type,current_position,current_page,
                 temp_id);
              current_position := current_position + 1;
           end if;
           current_id := get_sd_value(current_id,"attr_list");
       end while;

    }


#define ATTR_WIDTH 130

#include "boolean.sl"
#include "int.sl"
#include "string.sl"
#include "color.sl"
#include "font.sl"
#include "widget.sl"
#include "parent.sl"

end VC edit_priority_attributes_vc;

/*--------------------------------------------------------------------------*\
|  Name: gw_build_vc
|
|  Description:
|    The gw_build_vc(s) create the actual generic widget to be displayed
|    to the end user.  The two VCs allow objects to be destroyed
|    and recreated to re-establish the parenting order.
\*--------------------------------------------------------------------------*/
   VC: gw_build_vc

     Creation Condition: 
       (display_instance AND flip_flop_flag AND gw_stage)

     variables:
        last_id;

     On Create: {
       DEBUG2(printf("gw_build_vc:  created.\n", ""))
/*
**  Destroy any existing widget.
*/
    if (object_id <> NULL) then 
      destroy_sd_instance(object_id);
    end if;
/*
**  Create the actual object instance.
*/
    DEBUG3(
      printf(
        "gw_build_vc, on create: object_instance_sdd.type = %s.\n", 
        object_instance_sdd.type
      );
      printf(
        "gw_build_vc, on create: object_instance_sdd.mailbox = %s.\n", 
        object_instance_sdd.mailbox
      );
    )

    object_id := create_sd_instance(
      object_instance_sdd.type,object_instance_sdd.mailbox
    );
    DEBUG3(printf("gw_build_vc, on create:  object_id = %s.\n", object_id))
/*
**  Set the id of the actual object in the hash table.
*/
    set_id(object_instance_sdd.name,object_id);


                      /* now check for any children that arrived before this
                        parent */
    current_id := reparenting_list;
    last_id := NULL;
    while (current_id <> NULL) do
       if (get_sd_value (current_id, "name") = object_instance_sdd.name) then
          put_sd_value (get_sd_value (current_id, "object"),
                      "parent", object_id);
          if (last_id = NULL) then
             reparenting_list := get_sd_value (current_id, "next");
          else
             put_sd_value (last_id, "next",
                         get_sd_value (current_id, "next"));
          endif;
          temp_id := current_id;
          current_id := get_sd_value (current_id, "next");
          delete_element (temp_id);
       else
          last_id := current_id;
          current_id := get_sd_value (current_id, "next");
       endif;
    end while;

/*
**  Set the value of each attribute in the actual object according
**  to the application values.
*/  
    current_id := object_instance_sdd.attr_list;

    while (current_id <> NULL) do

      DEBUG3(printf("gw_build_vc, current name = %s.\n", current_name))
/*
**  If the attribute has an access type of "not create" then do not
**  set this value on create.
*/
      if (
        glue_get_attr_access(
          widget_handle,current_name,SERPENT_DEFAULT
        ) <> AXS_NOT_CREATE
      ) then
/*
**  Attribute is of widget type.
*/
      if (current_type = GT_Widget) then
        DEBUG3(printf("gw_build_vc, on create:  type of GT_Widget.\n",""))
/*
**  If value is undefined or null.
*/
        if (
          (string_lower(current_value) = "undefined") OR
          (string_lower(current_value) = "null") OR
          (current_value = "") OR 
          (current_value = UNDEFINED) 
        ) then 
          DEBUG3(printf("gw_build_vc, on create: undef or null value.\n",""))
/*
**  If parent attribute, parent widget to background.
*/
          if (current_name = "parent") then

            DEBUG3(printf("gw_build_vc, on create: parent attr found.\n",""))

            put_sd_value(object_id,"parent",bboard_id);
/*
**  Not a parent attribute, so put real value in.
*/
          else
            DEBUG3(printf("gw_build_vc, on create: not parent attr.\n",""))
/*
**  If the value is "null" put NULL in, otherwise UNDEFINED.
*/
            if (string_lower(current_value) = "null") then
              put_sd_value(object_id,current_name,NULL);
            else
              put_sd_value(object_id,current_name,UNDEFINED);
            end if;		/* id null vs undefined		*/
          end if;			/* end if parent attribute	*/
/*
**  Else an object name is specified.
*/
        else
          DEBUG3(
            printf(
              "gw_build_vc, on create:  object name = %s.\n", current_value
            )
          )
/*
**  If the parent object exists go ahead and refer to it in this object.
*/
          if ( 
            object_exists_and_not_null(current_value) AND
            id_exists(get_id(current_value)) 
          ) then 
            DEBUG3(printf("gw_build_vc, on create: parent set.\n","")) 
            put_sd_value(object_id,"parent",get_id(current_value)); 
/*
**  if the parent object doesn't exist yet add this object to the reparenting
**  list to get processed when the referenced object is created.
*/
          else
            temp_id := reparenting_list; 
            reparenting_list := create_sd_instance("reparent_sdd","DM_BOX"); 
            put_sd_value(reparenting_list,"name",current_value); 
            put_sd_value(reparenting_list,"attr","parent"); 
            put_sd_value(reparenting_list,"object",object_id); 
            put_sd_value(reparenting_list,"next",temp_id); 
          end if; 
        end if; 
/*
**  Not an id.
*/
      else
        if (
          (string_lower(current_value) = "undefined") OR (current_value = "")
        ) then
          put_sd_value(object_id,current_name,UNDEFINED);
        else
          put_sd_value(object_id,current_name,current_value);
        end if;
      end if;
     end if;		/* access type not AXS_NOT_CREATE	*/
/*
**  Get next attribute on attribute list.
*/
      current_id := get_sd_value(current_id,"attr_list");
    end while;
/*
**  Hard code special attributes.
*/
    put_sd_value(object_id,"allowusermove",TRUE);
    put_sd_value(object_id,"allowuserresize",TRUE);
/*
**  Reset command parameters.
*/
    toolbox_mailbox := UNDEFINED;
    toolbox_tech_type := UNDEFINED;
    toolbox_object_type := UNDEFINED;
    toolbox_object := UNDEFINED;

       DEBUG2(printf("gw_build_vc:  on create exiting.\n", ""))
     }
/*
**  Set id of object name to null id so we don't try to parent to old
**  object.
*/
     On Destroy: {
       DEBUG2 ( printf("gw_build_vc:  destroyed.\n", ""););
       gw_stage := false;
                        /* Destroy any existing widget */
     }

  end VC gw_build_vc;

/*--------------------------------------------------------------------------*\
|  Name: gw_build_vc2
|
|  Description:
|    The gw_build_vc2 displays a command widget to represent the command
|    widget.  Certain attributes such as parent, allowUserMove etc
|    are held contant and methods to allow specification of attribute
|    values are defined.  
\*--------------------------------------------------------------------------*/
   VC: gw_build_vc2

     Creation Condition: 
       (display_instance AND (NOT flip_flop_flag) AND (NOT gw_stage))

     variables:
        last_id;

     On Create: {
       DEBUG2(printf("gw_build_vc2:  created.\n", ""))
/*
**  Destroy any existing widget.
*/
    if (object_id <> NULL) then 
      destroy_sd_instance(object_id);
    end if;
/*
**  Create the actual object instance.
*/
    object_id := create_sd_instance(
      object_instance_sdd.type,object_instance_sdd.mailbox
    );
    DEBUG3(printf("gw_build_vc2, on create:  object_id = %s.\n", object_id))
/*
**  Set the id of the actual object in the hash table.
*/
    set_id(object_instance_sdd.name,object_id);


                        /* now check for any children that arrived before this
                          parent */
    current_id := reparenting_list;
    last_id := NULL;
    while (current_id <> NULL) do
       if (get_sd_value (current_id, "name") = object_instance_sdd.name) then
          put_sd_value (get_sd_value (current_id, "object"),
                        "parent", object_id);
          if (last_id = NULL) then
             reparenting_list := get_sd_value (current_id, "next");
          else
             put_sd_value (last_id, "next",
                           get_sd_value (current_id, "next"));
          endif;
          temp_id := current_id;
          current_id := get_sd_value (current_id, "next");
          delete_element (temp_id);
       else
          last_id := current_id;
          current_id := get_sd_value (current_id, "next");
       endif;
    end while;

/*
**  Set the value of each attribute in the actual object according
**  to the application values.
*/  
    current_id := object_instance_sdd.attr_list;

    while (current_id <> NULL) do
/*
**  Attribute is of widget type.
*/
      if (current_type = GT_Widget) then
        DEBUG3(printf("gw_build_vc2, on create:  object type of GT_Widget.\n", ""))
/*
**  If value is undefined or null.
*/
        if (
          (string_lower(current_value) = "undefined") OR
          (string_lower(current_value) = "null") OR
          (current_value = "") OR 
          (current_value = UNDEFINED) 
        ) then 
          DEBUG3(printf("gw_build_vc2, on create:  undefined or null value.\n", ""))
/*
**  If parent attribute, parent widget to background.
*/
          if (current_name = "parent") then
            DEBUG3(printf("gw_build_vc2, on create: parent attribute found.\n",""))
            put_sd_value(object_id,"parent",bboard_id);
/*
**  not a parent attribute, so put real value in.
*/
          else
            DEBUG3(printf("gw_build_vc2, on create: not parent attr.\n",""))
/*
**  if the value is "null" put NULL in, otherwise UNDEFINED.
*/
            if (string_lower(current_value) = "null") then
              put_sd_value(object_id,current_name,NULL);
            else
              put_sd_value(
                object_id,current_name,UNDEFINED
              );
            end if;		/* id null vs undefined		*/
          end if;			/* end if parent attribute	*/
/*
**  Else an object name is specified.
*/
        else
          DEBUG3(
            printf(
              "gw_build_vc2, on create:  object name = %s.\n", 
	      current_value
            )
          )
/*
**  If the object exists go ahead and refer to it in this object.
*/
          if ( 
            object_exists_and_not_null(current_value) AND
            id_exists(get_id(current_value)) 
          ) then 
            put_sd_value(
              object_id,"parent",get_id(current_value)
            ); 
            DEBUG3(printf("gw_build_vc2, on create: parent set.\n","")) 
/*
**  if the object doesn't exist yet add this object to the reparenting
**  list to get processed when the referenced object is created.
*/
          else
            temp_id := reparenting_list; 
            reparenting_list := create_sd_instance("reparent_sdd","DM_BOX"); 
            put_sd_value( 
              reparenting_list,"name",current_value 
            ); 
            put_sd_value(reparenting_list,"attr","parent"); 
            put_sd_value(reparenting_list,"object",object_id); 
            put_sd_value(reparenting_list,"next",temp_id); 
          end if; 
        end if; 
/*
**  Not an id.
*/
      else
        if (
          (string_lower(current_value) = "undefined") OR
          (current_value = "")
        ) then
          put_sd_value(object_id,current_name,UNDEFINED);
        else
          put_sd_value(
            object_id,
            current_name,
            current_value
          );
        end if;
      end if;
/*
**  Get next attribute on attribute list.
*/
      current_id := get_sd_value(current_id,"attr_list");
    end while;
/*
**  Hard code special attributes.
*/
    put_sd_value(object_id,"allowusermove",TRUE);
    put_sd_value(object_id,"allowuserresize",TRUE);

       DEBUG2(printf("gw_build_vc2:  on create exiting.\n", ""))
     }

     On Destroy: {
       DEBUG2(
         printf("gw_build_vc2:  destroyed.\n", "");
       )
       gw_stage := true;
     }

  end VC gw_build_vc2;

end VC gw_vc;
