/*--------------------------------------------------------------------------*\
|   
|  Name:  Common Help Information (common_help.sl)
|
|  Description:  
|     This file contains more help information that is common to  
|     the structure editor and visualization tools.
|     The VC's which control the display of this 
|     information are based on globally defined variables.  This
|     allows access to the same help information from different 
|     parts of the dialogue as well as allowing multiple help
|     messages to be displayed simultaneously.
|
|  Component of:
|     Serpent editor dialogue layer.
|
|  Related files:
|     help.sl - contains more help information.
|
|  Project:
|     Serpent
|     User Interface Project
|     Software Engineering Institute
|     Carnegie Mellon University
|     Pittsburgh, PA  15213
|
|  Version: 1.0
|
|  Project Leader:  
|     Len Bass
|     ljb@sei.cmu.edu
|
|  Author:  
|     Robert C. Seacord
|     rcs@sei.cmu.edu  
|
|  Change History:
|     Jan 2, 1990 : Module created.
|
\*--------------------------------------------------------------------------*\
|
|   Distribution: Approved for public release; distribution is unlimited.
|
|   Copyright (c) 1989  by  Carnegie  Mellon  University, Pittsburgh, PA.  The
|  Software Engineering  Institute  (SEI) is a federally  funded  research and
|  development center established  and  operated by Carnegie Mellon University
|  (CMU).  Sponsored  by  the  U.S.  Department  of   Defense  under  contract
|  F19628-85-C-0003,  the  SEI  is  supported  by  the  services  and  defense
|  agencies, with the U.S. Air Force as the executive contracting agent.
|
|    Permission to use,  copy,  modify, or  distribute  this  software and its
|  documentation for  any purpose and without fee  is hereby granted, provided
|  that  the above copyright notice appear  in  all copies and that both  that
|  copyright  notice  and   this  permission  notice  appear   in   supporting
|  documentation.   Further,  the  names  Software  Engineering  Institute  or
|  Carnegie  Mellon  University  may  not be used in  advertising or publicity
|  pertaining to distribution of the software without specific, written  prior
|  permission.  CMU makes no claims  or representations  about the suitability
|  of this software for any purpose.  This software is provided "as is" and no
|  warranty,  express  or  implied,  is  made  by  the  SEI  or CMU, as to the
|  accuracy  and  functioning of the program and related program material, nor
|  shall   the  fact of  distribution   constitute  any   such  warranty.   No
|  responsibility is assumed by the SEI or CMU in connection herewith.
|
\*--------------------------------------------------------------------------*/

/*------------------------- Load Command Help ------------------------------*/
  help_template(
      load_cmd_help,
        "Load Help",
	   "Description:\n\nThe Load command is used to load a dialogue into the application. \nThe application then places the dialogue VC for the loaded dialogue \ninto shared memory.\n\nThe user must enter the name of the dialogue to load.",
              140 );


/*------------------------- Save Command Help ------------------------------*/
  help_template(
      save_cmd_help,
        "Save Help",
	   "Description:\n\nThe Save command is used to write a dialogue to a permanent store  \nwhich will be named the same as the current dialogue's name, with  \nthe filename extension <.slb> appended to the filename.\n\nThe dialogue name is saved in the dialogue shared data element.",
              140 );


/*------------------------- Save As.. Command Help -------------------------*/
  help_template(
      save_as_cmd_help,
        "Save As.. Help",
	   "Description:\n\nThe Save As.. command is used to save the current dialogue in a file\nwhich must be entered by the user.  The resulting file will also have\nthe filename extension <.slb> appended to the filename.\n\nThe user must enter the name that will be used to save the dialogue.",
              140 );


/*------------------------- Revert Command Help ----------------------------*/
  help_template(
      revert_cmd_help,
        "Revert Help",
	   "Description:\n\nReverts are nice.",
              140 );



/*------------------------- Import Command Help ----------------------------*/
  help_template(
      import_cmd_help,
        "Import Help",
	   "Description:\n\nThe Import command is used to read into the current dialogue a slang\nsource file,as opposed to a slang binary file. The name of the source\nfile to import is entered by the user.\n\nThe user must enter the name of the file to be imported.",
              140 );


/*------------------------- Export Command Help ----------------------------*/
  help_template(
      export_cmd_help,
        "Export Help",
	   "Description:\n\nThe Export command is used to save the current dialogue into a slang\nsource file, as opposed to a slang binary file. The name of the source\nfile to export is entered by the user.\n\nThe user must enter the name of the file to be exported.",
              140 );


/*------------------------- Quit Command Help ------------------------------*/
  help_template(
      quit_cmd_help,
        "Quit Help",
	   "Description:\n\nThe Quit command is used to  quit editing the current dialogue.  The\ndialogue will be removed (unloaded) from the current shared data.  No\nfurther action is required by the user.\n\nThe editor itself remains ready for further use.",
              140 );


/*------------------------- Copy Command Help ------------------------------*/
  help_template(
      copy_cmd_help,
        "Copy Help",
	   "Description:\n\nThe Copy command is used to copy VCs or Objects to other  VCs or the\ndialogue; or copy Variables to VCs or the dialogue.  The user chooses\nthe source and target for copying by clicking the  <N> (NODE)  button\nor the <S> (Subtree) button as the SOURCE, and the  <T> button as the\nTARGET. NODE means just that particular vc, object, or variable.  The\nSUBTREE option is for copying a VC and any inner (enclosed) VCs also.\n\n",
              140 );


/*------------------------- Delete Command Help ----------------------------*/
  help_template(
      delete_cmd_help,
        "Delete Help",
	   "Description:\n\nThe Delete command is used to delete VCs, Objects, or Variables from\nthe current dialogue. The user chooses the source object to delete by\nclicking the  <N> (NODE)  button or the <S> (Subtree) button.  A NODE\nmeans just that particular vc, object,or variable. The SUBTREE option\nis for deleting a VC and any inner (enclosed) VCs also.\n\n",
              140 );


/*------------------------- Move Command Help ------------------------------*/
  help_template(
      move_cmd_help,
        "Move Help",
	   "Description:\n\nThe Move command is used to move VCs or Objects to other  VCs or the\ndialogue; or move Variables to VCs or the dialogue.  The user chooses\nthe source and target for moving by clicking the <N> (NODE) button\nor the <S> (Subtree) button as the SOURCE, and the <T> button as the\nTARGET. NODE means just that particular vc, object, or variable.  The\nSUBTREE option is for moving a VC and any inner (enclosed) VCs also.\n\n",
              140 );


/*------------------------- Duplicate Command Help -------------------------*/
  help_template(
      repeat_cmd_help,
        "Duplicate Help",
	   "Description:\n\nThe Duplicate command is a subset of the copy command. But the TARGET\nis assumed to be the same parent (VC or dialogue) as the SOURCE VC,or\nObject, or Variable. The user chooses the SOURCE (<S> or <N> buttons)\nbut chhosing a TARGET is uneccessary.  See Copy command help for more\ndetails.\n\n",
              140 );

/*------------------- Command Widget ATTR Help -----------------------------*/
  help_template(
    gw_attr_form_help,
    "Command Widget Attributes Help",
    "Description:\n\nThis form is used to modify the attributes for a widget.\n  Select attribute names for specific help on each attribute. \n",
    180
  );
