/* $Header: /u/04b/mnt/ljb/RCS/help_menu.sl,v 1.20 1991/05/09 19:44:12 ljb Exp $ */
/*--------------------------------------------------------------------------*\
|   
|  Name:  Help Menu
|
|  Description:  
|     This file contains the help menu hierarchy from the system menu.
|
|  Component of:
|     Serpent dialogue editor dialogue layer.
|
|  Related files:
|     
|  Project:
|     Serpent
|     User Interface Project
|     Software Engineering Institute
|     Carnegie Mellon University
|     Pittsburgh, PA  15213
|
|  Version: 1.0
|
|  Project Leader:  
|     Len Bass
|     ljb@sei.cmu.edu
|
|  Author:  
|     Robert C. Seacord
|     rcs@sei.cmu.edu  
|
|  Change History:
|	June 6, 1990 : Module created.
|	$Log: help_menu.sl,v $
% Revision 1.20  1991/05/09  19:44:12  ljb
% fix so background is main form
%
% Revision 1.19  1991/04/11  18:07:51  rcs
% *** empty log message ***
%
% Revision 1.18  90/11/29  18:39:54  rcs
%  
% 
% Revision 1.17  90/11/09  17:21:39  rcs
% *** empty log message ***
% 
% Revision 1.16  90/10/10  22:42:46  rcs
% new widget names
% 
% Revision 1.15  90/10/10  16:54:16  rm
% new new sat names
% 
% Revision 1.14  90/09/19  23:36:46  rcs
% fixed geometry
% 
% Revision 1.13  90/07/12  11:07:28  rm
% fixed y offset
% 
% Revision 1.12  90/07/02  23:26:37  rcs
% *** empty log message ***
% 
% Revision 1.11  90/06/29  09:36:38  rm
% removed MENU_Y_OFFSET conflict
% 
% Revision 1.10  90/06/28  22:38:22  rm
% minor fixes 
% 
% Revision 1.9  90/06/28  17:29:11  rm
% checking in again 
%  
|
\*--------------------------------------------------------------------------*\
|
|   Distribution: Approved for public release; distribution is unlimited.
|
|   Copyright (c) 1989  by  Carnegie  Mellon  University, Pittsburgh, PA.  The
|  Software Engineering  Institute  (SEI) is a federally  funded  research and
|  development center established  and  operated by Carnegie Mellon University
|  (CMU).  Sponsored  by  the  U.S.  Department  of   Defense  under  contract
|  F19628-85-C-0003,  the  SEI  is  supported  by  the  services  and  defense
|  agencies, with the U.S. Air Force as the executive contracting agent.
|
|    Permission to use,  copy,  modify, or  distribute  this  software and its
|  documentation for  any purpose and without fee  is hereby granted, provided
|  that  the above copyright notice appear  in  all copies and that both  that
|  copyright  notice  and   this  permission  notice  appear   in   supporting
|  documentation.   Further,  the  names  Software  Engineering  Institute  or
|  Carnegie  Mellon  University  may  not be used in  advertising or publicity
|  pertaining to distribution of the software without specific, written  prior
|  permission.  CMU makes no claims  or representations  about the suitability
|  of this software for any purpose.  This software is provided "as is" and no
|  warranty,  express  or  implied,  is  made  by  the  SEI  or CMU, as to the
|  accuracy  and  functioning of the program and related program material, nor
|  shall   the  fact of  distribution   constitute  any   such  warranty.   No
|  responsibility is assumed by the SEI or CMU in connection herewith.
|
\*--------------------------------------------------------------------------*/

#undef DEBUG1
#undef DEBUG2
#undef DEBUG3

#define DEBUG1(statement) SERPENT_DEBUG1(help_menu_debug, statement)
#define DEBUG2(statement) SERPENT_DEBUG2(help_menu_debug, statement)
#define DEBUG3(statement) SERPENT_DEBUG3(help_menu_debug, statement)

#define CURH_POS 290
#define MENU_VERTOFFSET 30
#define MENU_WIDTH 148
#define FORM_WIDTH 150
#define ITEM_HEIGHT 20


/*-------------------------------- HELP MENU -------------------------------*/

Help_Button : XawMenuButton {
    Attributes:
        parent          : system_menu_form;
        label           : "Help";
        horizDistance   : 290;
        menuname        : "xawmenushell";
        bordercolor     : "black";
        background      : "black";
        foreground      : "white";
}

Help_Shell : XawMenuShell {
    Attributes:
        parent          : Help_Button;
}

Commands_help_menu_item : XawSimpleMenuBSB {
    Attributes:
        parent          : Help_Shell;
        label           : "Commands";
        sensitive       : true;
        rightmargin     : 25;
        leftmargin      : 5;
    Methods:
        notify : {
          commands_help_menu := true;
          slang_constructs_help_menu := false;
          athena_objects_help_menu := false;
          motif_objects_help_menu := false;
	}
}

Slang_help_menu_item : XawSimpleMenuBSB {
    Attributes:
        parent          : Help_Shell;
        label           : "Slang";
        sensitive       : true;
        rightmargin     : 25;
        leftmargin      : 5;
        after           : Commands_help_menu_item;
    Methods:
        notify : {
          slang_constructs_help_menu := true;
          athena_objects_help_menu := false;
          commands_help_menu := false;
          motif_objects_help_menu := false;
	}
}

Athena_help_menu_item: XawSimpleMenuBSB {
    Attributes:
        parent          : Help_Shell;
        label           : "Athena Widgets";
        sensitive       : true;
        rightmargin     : 25;
        leftmargin      : 5;
        after           : Slang_help_menu_item;
    Methods:
        notify : {
          commands_help_menu := false;
          slang_constructs_help_menu := false;
          athena_objects_help_menu := true;
          motif_objects_help_menu := false;
	}
}

Motif_help_menu_item: XawSimpleMenuBSB {
    Attributes:
        parent          : Help_Shell;
        label           : "Motif Widgets";
        sensitive       : true;
        rightmargin     : 25;
        leftmargin      : 5;
        after           : Athena_help_menu_item;
    Methods:
        notify : {
          commands_help_menu := false;
          slang_constructs_help_menu := false;
          athena_objects_help_menu := false;
          motif_objects_help_menu := true;
	}
}

/*--------------------------------------------------------------------------*\
|  Name: commands_help_menu_vc
|
|  Description:
|    Second Level Menu called from Commands - 1 offset from top level
|    System, Edit, Prototype
\*--------------------------------------------------------------------------*/
  VC: commands_help_menu_vc

    Creation condition: (commands_help_menu)

    Variables:
      edit_commands_help_menu: false;
      prototype_commands_help_menu: false;
      system_commands_help_menu: false;

    Objects:
 
       commands_help_menu_form: XawBboard {
         Attributes:
           parent: workspace;
           width: FORM_WIDTH;
           height: ITEM_HEIGHT * 4;
	   borderWidth: 2;
           vertDistance: MENU_Y_OFFSET;
           horizDistance: MENU_WIDTH + CURH_POS;
       }

       menu_item(
         system_help_item, 
         commands_help_menu_form, 
         0, 
         "System",
         {
           if (NOT system_commands_help_menu) then
             system_commands_help_menu := true;
             edit_commands_help_menu := false;
             prototype_commands_help_menu := false;
           end if;
         }
       )
       menu_item(
         edit_help_item, 
         commands_help_menu_form, 
         1, 
         "Edit",
         {
           if (NOT edit_commands_help_menu) then
             edit_commands_help_menu := true;
             prototype_commands_help_menu := false;
             system_commands_help_menu    := false;
           end if;
         }
       )
       menu_item(
         prototype_help_item, 
         commands_help_menu_form, 
         2, 
         "Prototype",
         {
           if (NOT prototype_commands_help_menu) then
             prototype_commands_help_menu := true;
             system_commands_help_menu    := false;
             edit_commands_help_menu      := false;
           end if;
         }
       )
       menu_item(
         close_main_help_item, 
         commands_help_menu_form, 
         3, 
         "Close Menu",
         {
/* shut menus down with this view controller */
           commands_help_menu           := false;
           system_commands_help_menu	:= false;
           edit_commands_help_menu	:= false;
           prototype_commands_help_menu := false;
         }
       )

/*--------------------------------------------------------------------------*\
|  Name: system_commands_help_menu_vc
|
|  Description:
|    Help menu for system commands. 2 OFFSET from top level menu
\*--------------------------------------------------------------------------*/
  VC: system_commands_help_menu_vc

    Creation condition: (system_commands_help_menu)

    Objects:
 
       system_commands_help_menu_form: XawBboard {
         Attributes:
           parent: workspace;
           width: FORM_WIDTH;
           height: ITEM_HEIGHT * 7;
	   borderWidth: 2;
           vertDistance: MENU_Y_OFFSET;
           horizDistance: MENU_WIDTH * 2 + CURH_POS;
       }

       menu_item(
         load_help_item, 
         system_commands_help_menu_form, 
         0, 
         "Load",
         {
           if (NOT load_cmd_help) then
             load_cmd_help := true;
           end if;
         }
       )

       menu_item(
         save_help_item, 
         system_commands_help_menu_form, 
         1, 
         "Save",
         {
           if (NOT save_cmd_help) then
             save_cmd_help := true;
           end if;
         }
       )

       menu_item(
         save_as_help_item, 
         system_commands_help_menu_form, 
         2, 
         "Save As",
         {
           if (NOT save_as_cmd_help) then
             save_as_cmd_help := true;
           end if;
         }
       )

       menu_item(
         import_help_item, 
         system_commands_help_menu_form, 
         3, 
         "Import",
         {
           if (NOT import_cmd_help) then
             import_cmd_help := true;
           end if;
         }
       )

       menu_item(
         export_help_item, 
         system_commands_help_menu_form, 
         4, 
         "Export",
         {
           if (NOT export_cmd_help) then
             export_cmd_help := true;
           end if;
         }
       )

       menu_item(
         quit_help_item, 
         system_commands_help_menu_form, 
         5, 
         "Quit",
         {
           if (NOT quit_cmd_help) then
             quit_cmd_help := true;
           end if;
         }
       )
       menu_item(
         close_sys_cmds_menu_item, 
         system_commands_help_menu_form, 
         6, 
         "Close Menu",
         {
           system_commands_help_menu := false;
         }
       )

  end VC system_commands_help_menu_vc;

/*--------------------------------------------------------------------------*\
|  Name: edit_commands_help_menu_vc
|
|  Description:
|    Help menu for edit commands.  2 offset from top menu and 2 down
\*--------------------------------------------------------------------------*/
  VC: edit_commands_help_menu_vc

    Creation condition: (edit_commands_help_menu)

    Objects:
 
       edit_commands_help_menu_form: XawBboard {
         Attributes:
           parent: workspace;
           width: FORM_WIDTH;
           height: ITEM_HEIGHT * 3;
	   borderWidth: 2;
           vertDistance:  MENU_VERTOFFSET + 20;
           horizDistance: MENU_WIDTH * 2 + CURH_POS;
       }

       menu_item(
         copy_help_item, 
         edit_commands_help_menu_form,
         0, 
         "Copy",
         {
           if (NOT copy_cmd_help) then
             copy_cmd_help := true;
           end if;
         }
       )

       menu_item(
         delete_help_item, 
         edit_commands_help_menu_form,
         1, 
         "Delete",
         {
           if (NOT delete_cmd_help) then
             delete_cmd_help := true;
           end if;
         }
       )

       menu_item(
         close_edit_menu_help_item, 
         edit_commands_help_menu_form,
         2, 
         "Close Menu",
         {
           edit_commands_help_menu := false;
         }
       )

  end VC edit_commands_help_menu_vc;

/*--------------------------------------------------------------------------*\
|  Name: prototype_commands_help_menu_vc
|
|  Description:
|    Help menu for edit commands.  2 offset from top menu and 3 down
\*--------------------------------------------------------------------------*/

  VC: prototype_commands_help_menu_vc

    Creation condition: (prototype_commands_help_menu)

    Objects:
 
       prototype_commands_help_menu_form: XawBboard {
         Attributes:
           parent: workspace;
           width: FORM_WIDTH;
           height: ITEM_HEIGHT * 4;
	   borderWidth: 2;
           vertDistance:  MENU_VERTOFFSET + 40;
           horizDistance: MENU_WIDTH * 2 + CURH_POS;
       }

       menu_item(
         prototype_cmd_help_item, 
         prototype_commands_help_menu_form,
         0, 
         "On",
         {
           if (NOT prototype_on_cmd_help) then
             prototype_on_cmd_help := true;
           end if;
         }
       )

       menu_item(
         realize_help_item, 
         prototype_commands_help_menu_form,
         1, 
         "Realize",
         {
           if (NOT realize_cmd_help) then
             realize_cmd_help := true;
           end if;
         }
       )

       menu_item(
         display_attributes_cmd_help_item, 
         prototype_commands_help_menu_form,
         2, 
         "Display Attributes",
         {
           if (NOT display_attributes_cmd_help) then
             display_attributes_cmd_help := true;
           end if;
         }
       )

       menu_item(
         close_prototype_menu_help_item, 
         prototype_commands_help_menu_form,
         3, 
         "Close Menu",
         {
           prototype_commands_help_menu := false;
         }
       )

  end VC prototype_commands_help_menu_vc;
  end VC commands_help_menu_vc;

/*--------------------------------------------------------------------------*\
|  Name: Slang Constructs menu
|
|  Description:
|    Submenu for Slang constructs Header stuff and Body stuff
|               1 offset and 2nd down
\*-------------------------------------------------------------------------*/

  VC: slang_construct_help_menu_vc

    Creation condition: (slang_constructs_help_menu)

    Variables:
      slang_header_item_help   : false;
      slang_body_item_help     : false;

    Objects:

       slang_construct_help_form: XawBboard {
         Attributes:
           parent: workspace;
           width: FORM_WIDTH;
           height: ITEM_HEIGHT * 3;
	   borderWidth: 2;
           vertDistance:  MENU_VERTOFFSET + 20;
           horizDistance: MENU_WIDTH + CURH_POS;
       }

       menu_item(
         header_item_cmd_help, 
         slang_construct_help_form,
         0, 
         "Slang Header Items",
         {
           if (NOT slang_header_item_help) then
             slang_header_item_help := true;
             slang_body_item_help := false;
           end if;
         }
       )
       menu_item(
         body_item_cmd_help, 
         slang_construct_help_form,
         1, 
         "Slang Body Items",
         {
           if (NOT slang_body_item_help) then
             slang_body_item_help := true;
           slang_header_item_help := false;
           end if;
         }
       )
       menu_item(
         close_slangc_menu__help, 
         slang_construct_help_form,
         2, 
         "Close Menu",
         {
           slang_constructs_help_menu := false;
           slang_header_item_help := false;
           slang_body_item_help := false;
         }
       )

/*--------------------------------------------------------------------------*\
|  Name: Slang Header Items menu
|
|  Description:
|    Submenu for Slang constructs Header 
|               2 offset and 2 down
\*-------------------------------------------------------------------------*/

  VC: slang_header_item_help_menu_vc

    Creation condition: (slang_header_item_help)

    Objects:

       slangc_header_help_form: XawBboard {
         Attributes:
           parent: workspace;
           width: FORM_WIDTH;
           height: ITEM_HEIGHT * 10;
	   borderWidth: 2;
           vertDistance:  MENU_VERTOFFSET + 20;
           horizDistance: MENU_WIDTH * 2 + CURH_POS;
       }

       menu_item(
         prologue_help_item, 
         slangc_header_help_form,
         0, 
         "Prologue",
         {
           if (NOT prologue_help) then
             prologue_help := true;
           end if;
         }
       )

       menu_item(
         macros_help_item, 
         slangc_header_help_form,
         1, 
         "Macros",
         {
           if (NOT macros_help) then
             macros_help := true;
           end if;
         }
       )

       menu_item(
         externs_help_item, 
         slangc_header_help_form,
         2, 
         "Externs",
         {
           if (NOT externs_help) then
             externs_help := true;
           end if;
         }
       )

       menu_item(
         sdd_help_item, 
         slangc_header_help_form,
         3, 
         "Shared Data",
         {
           if (NOT sdd_help) then
             sdd_help := true;
           end if;
         }
       )

       menu_item(
         functions_help_item, 
         slangc_header_help_form,
         4, 
         "Function Library",
         {
           if (NOT functions_help) then
             functions_help := true;
           end if;
         }
       )
       menu_item(
         comments_help_item, 
         slangc_header_help_form,
         5, 
         "Comments",
         {
           if (NOT comments_help) then
             comments_help := true;
           end if;
         }
       )
       menu_item(
         includes_help_item, 
         slangc_header_help_form,
         6, 
         "Includes",
         {
           if (NOT includes_help) then
             includes_help := true;
           end if;
         }
       )

       menu_item(
         initialization_help_item, 
         slangc_header_help_form,
         7, 
         "Initialization",
         {
           if (NOT initialization_help) then
             initialization_help := true;
           end if;
         }
       )

       menu_item(
         termination_help_item, 
         slangc_header_help_form,
         8, 
         "Termination",
         {
           if (NOT termination_help) then
             termination_help := true;
           end if;
         }
       )


       menu_item(
         close_slangc_header_help_item, 
         slangc_header_help_form,
         9, 
         "Close Menu",
         {
           slang_header_item_help := false;
         }
       )
end VC slang_header_item_help;

/*--------------------------------------------------------------------------*\
|  Name: Slang Body Items menu
|
|  Description:
|    Submenu for Slang constructs Body items
|               2 offset and 3 down
\*-------------------------------------------------------------------------*/

  VC: slang_body_item_help_menu_vc

    Creation condition: (slang_body_item_help)

    Objects:

       slangc_body_help_form: XawBboard {
         Attributes:
           parent: workspace;
           width: FORM_WIDTH;
           height: ITEM_HEIGHT * 8;
	   borderWidth: 2;
           vertDistance:  MENU_VERTOFFSET + 40;
           horizDistance: MENU_WIDTH * 2 + CURH_POS;
       }

       menu_item(
         objects_help_item, 
         slangc_body_help_form,
         0, 
         "Objects",
         {
           if (NOT objects_help) then
             objects_help := true;
           end if;
         }
       )

       menu_item(
         vcs_help_item, 
         slangc_body_help_form,
         1, 
         "VC's",
         {
           if (NOT vcs_help) then
             vcs_help := true;
           end if;
         }
       )

       menu_item(
         variables_help_item, 
         slangc_body_help_form,
         2, 
         "Variables",
         {
           if (NOT variables_help) then
             variables_help := true;
           end if;
         }
       )

       menu_item(
         method_help_item, 
         slangc_body_help_form,
         3, 
         "Methods",
         {
           if (NOT method_help) then
             method_help := true;
           end if;
         }
       )
       menu_item(
         on_create_help_item, 
         slangc_body_help_form,
         4, 
         "On Create",
         {
           if (NOT on_create_help) then
             on_create_help := true;
           end if;
         }
       )
       menu_item(
         on_destroy_help_item, 
         slangc_body_help_form,
         5, 
         "On Destroy",
         {
           if (NOT on_destroy_help) then
             on_destroy_help := true;
           end if;
         }
       )

       menu_item(
         termination_help_item, 
         slangc_body_help_form,
         6, 
         "Creation Condition",
         {
           if (NOT creation_conditions_help) then
             creation_conditions_help := true;
           end if;
         }
       )
       menu_item(
         close_slangc_body_help_item, 
         slangc_body_help_form,
         7, 
         "Close Menu",
         {
           slang_body_item_help := false;
         }
       )

end VC slang_body_item_help_menu_vc;
end VC slang_construct_help_menu_vc;

#if 0
/*--------------------------------------------------------------------------*\
|  Name: Athena Objects menu
|
|  Description:
|    Submenu for Athena Objects
|               1 offset and 3rd down
\*-----------------------------------------------------------------------*/

  VC: athena_objects_help_menu_vc

    Creation condition: (athena_objects_help_menu)

    Variables:
      attr1_help_menu   : false;
      attr2_help_menu   : false;
      attr3_help_menu   : false;
      attr4_help_menu   : false;
      technologies_help_menu    : false;
      methods_help_menu     : false;

    Objects:

       athenao_help_form: XawBboard {
         Attributes:
           parent: workspace;
           width: FORM_WIDTH;
           height: ITEM_HEIGHT * 7;
	   borderWidth: 2;
           vertDistance:  MENU_VERTOFFSET + 40;
           horizDistance: MENU_WIDTH + CURH_POS;
       }

       menu_item(
         object_item_help, 
         athenao_help_form,
         0, 
         "Technology",
         {
           if (NOT technologies_help_menu) then
             technologies_help_menu := true;
            methods_help_menu := false;
            attr1_help_menu := false;
            attr2_help_menu := false;
            attr3_help_menu := false;
            attr4_help_menu := false;

           end if;
         }
       )
       menu_item(
         methods_help, 
         athenao_help_form,
         1, 
         "Methods",
         {
           if (NOT methods_help_menu) then
             methods_help_menu := true;
            technologies_help_menu := false;
            attr1_help_menu := false;
            attr2_help_menu := false;
            attr3_help_menu := false;
            attr4_help_menu := false;

           end if;
         }
       )
       menu_item(
         attributes_1_help, 
         athenao_help_form,
         2, 
         "Attributes_1",
         {
           if (NOT attr1_help_menu) then
             attr1_help_menu := true;
            methods_help_menu := false;
            technologies_help_menu := false;
            attr2_help_menu := false;
            attr3_help_menu := false;
            attr4_help_menu := false;

           end if;
         }
         )
       menu_item(
         attributes_2_help, 
         athenao_help_form,
         3, 
         "Attributes_2",
         {
           if (NOT attr2_help_menu) then
             attr2_help_menu := true;
            technologies_help_menu := false;
            methods_help_menu := false;
            attr1_help_menu := false;
            attr3_help_menu := false;
            attr4_help_menu := false;

           end if;
         }
       )
       menu_item(
         attributes_3_help, 
         athenao_help_form,
         4, 
         "Attributes_3",
         {
           if (NOT attr3_help_menu) then
             attr3_help_menu := true;
            technologies_help_menu := false;
            methods_help_menu := false;
            attr1_help_menu := false;
            attr2_help_menu := false;
            attr4_help_menu := false;

           end if;
         }
       )
       menu_item(
         attributes_4_help, 
         athenao_help_form,
         5, 
         "Attributes_4",
         {
           if (NOT attr4_help_menu) then
             attr4_help_menu := true;
            technologies_help_menu := false;
            methods_help_menu := false;
            attr1_help_menu := false;
            attr2_help_menu := false;
            attr3_help_menu := false;

           end if;
         }
       )

       menu_item(
         close_atheno_menu__help, 
         athenao_help_form,
         6, 
         "Close Menu",
         {
            athena_objects_help_menu := false;
            technologies_help_menu := false;
            methods_help_menu := false;
            attr1_help_menu := false;
            attr2_help_menu := false;
            attr3_help_menu := false;
            attr4_help_menu := false;
         }
       )

/*--------------------------------------------------------------------------*\
|  Name: technologies_help_menu_vc
|
|  Description:
|    All the help menus instantiated for attributes.
|
\*--------------------------------------------------------------------------*/

  VC: technologies_help_menu_vc

    Creation condition: (technologies_help_menu)
 
    Objects:

       tech_help_menu_form: XawBboard {
         Attributes:
           parent: workspace;
           width: FORM_WIDTH;
           height: ITEM_HEIGHT * 5;
	   borderWidth: 2;
           vertDistance: MENU_VERTOFFSET + 40; 
           horizDistance: MENU_WIDTH * 2 + CURH_POS;
       }
       menu_item(
         XawCommand_help_item, 
         tech_help_menu_form, 
         0, 
         "Command Widget",
         {
           if (NOT XawCommand_help) then
             XawCommand_help := true;
           end if;
         }
       )
       menu_item(
         XawLabel_help_item, 
         tech_help_menu_form, 
         1, 
         "Label Widget",
         {
           if (NOT XawLabel_help) then
             XawLabel_help := true;
           end if;
         }
       )
       menu_item(
         XawText_help_item, 
         tech_help_menu_form, 
         2, 
         "Form Widget",
         {
           if (NOT XawText_help) then
             XawText_help := true;
           end if;
         }
       )
       menu_item(
         XawBboard_help_item, 
         tech_help_menu_form, 
         3, 
         "Text Widget",
         {
           if (NOT XawBboard_help) then
             XawBboard_help := true;
           end if;
         }
       )
       menu_item(
         close_tech_help_item, 
         tech_help_menu_form, 
         4, 
         "Close Menu",
         {
           if (technologies_help_menu) then
            technologies_help_menu  := false;
           end if;
         }
       )

end VC technologies_help_menu_vc;

/*--------------------------------------------------------------------------*\
|  Name: menthods_help_menu_vc
|
|  Description:
|    All the help menus instantiated for methods.
|
\*--------------------------------------------------------------------------*/

  VC: methods_help_menu_vc

    Creation condition: (methods_help_menu)
 
    Objects:

       method_help_menu_form: XawBboard {
         Attributes:
           parent: workspace;
           width: FORM_WIDTH;
           height: ITEM_HEIGHT * 6;
	   borderWidth: 2;
           vertDistance: MENU_VERTOFFSET + 60; 
           horizDistance: MENU_WIDTH * 2 + CURH_POS;
       }
       menu_item(
         notify_method_help_item, 
         method_help_menu_form, 
         0, 
         "Notify",
         {
           if (NOT notify_method_help) then
             notify_method_help := true;
           end if;
         }
       )
       menu_item(
         select_method_help_item, 
         method_help_menu_form, 
         1, 
         "Select",
         {
           if (NOT select_method_help) then
             select_method_help := true;
           end if;
         }
       )
       menu_item(
         move_method_help_item, 
         method_help_menu_form, 
         2, 
         "Move",
         {
           if (NOT move_method_help) then
             move_method_help := true;
           end if;
         }
       )
       menu_item(
         resize_method_help_item, 
         method_help_menu_form, 
         3, 
         "Resize",
         {
           if (NOT resize_method_help) then
             resize_method_help := true;
           end if;
         }
       )
       menu_item(
         send_method_help_item, 
         method_help_menu_form, 
         4, 
         "Send",
         {
           if (NOT send_method_help) then
             send_method_help := true;
           end if;
         }
       )
       menu_item(
         close_method_help_item, 
         method_help_menu_form, 
         5, 
         "Close Menu",
         {
           if (methods_help_menu) then
            methods_help_menu  := false;
           end if;
         }
       )

end VC methods_help_menu_vc;

/*--------------------------------------------------------------------------*\
|  Name: attr1_help_menu_vc
|
|  Description:
|    All the help menus instantiated for attributes.
|    submenu 1 3 offset down3
\*--------------------------------------------------------------------------*/

  VC: attr1_help_menu_vc

    Creation condition: (attr1_help_menu)
 
    Objects:

       attr1_help_menu_form: XawBboard {
         Attributes:
           parent: workspace;
           width: FORM_WIDTH;
           height: ITEM_HEIGHT * 11;
	   borderWidth: 2;
           vertDistance: MENU_VERTOFFSET + 80;
           horizDistance: MENU_WIDTH * 2+ CURH_POS;
       }

       menu_item(
         parent_attr_help_item, 
         attr1_help_menu_form, 
         0, 
         "Parent",
         {
           if (NOT parent_help) then
             parent_help := true;
           end if;
         }
       )

       menu_item(
         x_attr1_help_item, 
         attr1_help_menu_form, 
         1, 
         "X",
         {
           if (NOT x_help) then
             x_help := true;
           end if;
         }
       )

       menu_item(
         y_attr_help_item, 
         attr1_help_menu_form, 
         2, 
         "Y",
         {
           if (NOT y_help) then
             y_help := true;
           end if;
         }
       )

       menu_item(
         width_attr_help_item, 
         attr1_help_menu_form, 
         3, 
         "Width",
         {
           if (NOT width_help) then
             width_help := true;
           end if;
         }
       )

       menu_item(
         height_attr_help_item, 
         attr1_help_menu_form, 
         4, 
         "Height",
         {
           if (NOT height_help) then
             height_help := true;
           end if;
         }
       )

       menu_item(
         vert_dist_attr_help_item, 
         attr1_help_menu_form, 
         5, 
         "Vertical Distance",
         {
           if (NOT vertDistance_help) then
             vertDistance_help := true;
           end if;
         }
       )

       menu_item(
         horiz_dist_attr_help_item, 
         attr1_help_menu_form, 
         6, 
         "Horizontal Distance",
         {
           if (NOT horizDistance_help) then
             horizDistance_help := true;
           end if;
         }
       )

       menu_item(
         font_help_item, 
         attr1_help_menu_form, 
         7, 
         "Fonts",
         {
           if (NOT font_help) then
             font_help := true;
           end if;
         }
       )

       menu_item(
         label_text_help_item, 
         attr1_help_menu_form, 
         8, 
         "Label Text",
         {
           if (NOT label_text_help) then
             label_text_help := true;
           end if;
         }
       )

       menu_item(
         justify_help_item, 
         attr1_help_menu_form, 
         9, 
         "Justify",
         {
           if (NOT justify_help) then
             justify_help := true;
           end if;
         }
       )

       menu_item(
         close_attr1_menu_help_item, 
         attr1_help_menu_form, 
         10, 
         "Close Menu",
         {
           if (attr1_help_menu) then
            attr1_help_menu  := false;
           end if;
         }
       )

end VC attr1_help_menu_vc;

/*--------------------------------------------------------------------------*\
|  Name: attr2_help_menu_vc
|
|  Description:
|    All the help menus instantiated for attributes.
|    submenu 1 3 offset down4
\*--------------------------------------------------------------------------*/

  VC: attr2_help_menu_vc

    Creation condition: (attr2_help_menu)
 
    Objects:

       attr2_help_menu_form: XawBboard {
         Attributes:
           parent: workspace;
           width: FORM_WIDTH;
           height: ITEM_HEIGHT * 11;
	   borderWidth: 2;
           vertDistance: MENU_VERTOFFSET + 100;
           horizDistance: MENU_WIDTH * 2 + CURH_POS;
       }

       menu_item(
         border_color_help_item, 
         attr2_help_menu_form, 
         0, 
         "Border Color",
         {
           if (NOT border_color_help) then
             border_color_help := true;
           end if;
         }
       )

       menu_item(
         borderWidth_help_item, 
         attr2_help_menu_form, 
         1, 
         "Border Width",
         {
           if (NOT borderWidth_help) then
             borderWidth_help := true;
           end if;
         }
       )

       menu_item(
         background_color_help_item, 
         attr2_help_menu_form, 
         2, 
         "Background Color",
         {
           if (NOT background_color_help) then
             background_color_help := true;
           end if;
         }
       )

       menu_item(
         foreground_color_help_item, 
         attr2_help_menu_form, 
         3, 
         "Foreground Color",
         {
           if (NOT foreground_color_help) then
             foreground_color_help := true;
           end if;
         }
       )

       menu_item(
         sensitive_attr_help_item, 
         attr2_help_menu_form, 
         4, 
         "Sensitive",
         {
           if (NOT sensitive_help) then
             sensitive_help := true;
           end if;
         }
       )

       menu_item(
         resizable_help_item, 
         attr2_help_menu_form, 
         5, 
         "Resizable",
         {
           if (NOT resizable_help) then
             resizable_help := true;
           end if;
         }
       )

       menu_item(
         allow_user_resize_help_item, 
         attr2_help_menu_form, 
         6, 
         "Allow Resize",
         {
           if (NOT allow_user_resize_help) then
             allow_user_resize_help := true;
           end if;
         }
       )

       menu_item(
         user_move_help_item, 
         attr2_help_menu_form, 
         7, 
         "Allow User Move",
         {
           if (NOT user_move_help) then
             user_move_help := true;
           end if;
         }
       )

       menu_item(
         user_resize_help_item, 
         attr2_help_menu_form, 
         8, 
         "Allow User Resize",
         {
           if (NOT user_resize_help) then
             user_resize_help := true;
           end if;
         }
       )

       menu_item(
         maintain_size_help_item, 
         attr2_help_menu_form, 
         9, 
         "Maintain Size",
         {
           if (NOT maintain_size_help) then
             maintain_size_help := true;
           end if;
         }
       )

       menu_item(
         close_attr1_menu_help_item,
         attr2_help_menu_form, 
         10, 
         "Close Menu",
         {
           if (attr2_help_menu) then
            attr2_help_menu  := false;
           end if;
         }
       )

end VC attr2_help_menu_vc;

/*--------------------------------------------------------------------------*\
|  Name: attr3_help_menu_vc
|
|  Description:
|    All the help menus instantiated for attributes.
|    submenu 1 3 offset down5
\*--------------------------------------------------------------------------*/

  VC: attr3_help_menu_vc

    Creation condition: (attr3_help_menu)
 
    Objects:

       attr3_help_menu_form: XawBboard {
         Attributes:
           parent: workspace;
           width: FORM_WIDTH;
           height: ITEM_HEIGHT * 10;
	   borderWidth: 2;
           vertDistance: MENU_VERTOFFSET + 120;
           horizDistance: MENU_WIDTH * 2 + CURH_POS;
       }

       menu_item(
         resize_height_help_item, 
         attr3_help_menu_form, 
         0, 
         "Resize Height",
         {
           if (NOT resize_height_help) then
             resize_height_help := true;
           end if;
         }
       )

       menu_item(
         resize_width_help_item, 
         attr3_help_menu_form, 
         1, 
         "Resize Width",
         {
           if (NOT resize_width_help) then
             resize_width_help := true;
           end if;
         }
       )

       menu_item(
         edit_type_help_item, 
         attr3_help_menu_form, 
         2, 
         "Edit Type",
         {
           if (NOT edit_type_help) then
             edit_type_help := true;
           end if;
         }
       )

       menu_item(
         editable_help_item, 
         attr3_help_menu_form, 
         3, 
         "Editable",
         {
           if (NOT editable_help) then
             editable_help := true;
           end if;
         }
       )

       menu_item(
         word_break_help_item, 
         attr3_help_menu_form, 
         4, 
         "Word Break",
         {
           if (NOT word_break_help) then
             word_break_help := true;
           end if;
         }
       )

       menu_item(
         textBuffer_help_item, 
         attr3_help_menu_form, 
         5, 
         "Text Buffer",
         {
           if (NOT textBuffer_help) then
             textBuffer_help := true;
           end if;
         }
       )

       menu_item(
         send_buffer_help_item, 
         attr3_help_menu_form, 
         6, 
         "Send Buffer",
         {
           if (NOT send_buffer_help) then
             send_buffer_help := true;
           end if;
         }
       )


       menu_item(
         from_horiz_help_item, 
         attr3_help_menu_form, 
         7, 
         "From Horizontal",
         {
           if (NOT from_horiz_help) then
             from_horiz_help := true;
           end if;
         }
       )

       menu_item(
         from_vert_help_item, 
         attr3_help_menu_form, 
         8, 
         "From Vertical",
         {
           if (NOT from_vert_help) then
             from_vert_help := true;
           end if;
         }
       )

       menu_item(
         close_attr3_menu_help_item,
         attr3_help_menu_form, 
         9, 
         "Close Menu",
         {
           if (attr3_help_menu) then
            attr3_help_menu  := false;
           end if;
         }
       )

end VC attr3_help_menu_vc;

/*--------------------------------------------------------------------------*\
|  Name: attr4_help_menu_vc
|
|  Description:
|    All the help menus instantiated for attributes.
|    submenu 1 3 offset down6
\*--------------------------------------------------------------------------*/

  VC: attr4_help_menu_vc

    Creation condition: (attr4_help_menu)
 
    Objects:

       attr4_help_menu_form: XawBboard {
         Attributes:
           parent: workspace;
           width: FORM_WIDTH;
           height: ITEM_HEIGHT * 10;
	   borderWidth: 2;
           vertDistance: MENU_VERTOFFSET + 140;
           horizDistance: MENU_WIDTH * 2 + CURH_POS;
       }

       menu_item(
         mapped_when_managed_help_item, 
         attr4_help_menu_form, 
         0, 
         "Mapped When Managed",
         {
           if (NOT mapped_when_managed_help) then
             mapped_when_managed_help := true;
           end if;
         }
       )

       menu_item(
         max_height_help_item, 
         attr4_help_menu_form, 
         1, 
         "Max Height",
         {
           if (NOT max_height_help) then
             max_height_help := true;
           end if;
         }
       )

       menu_item(
         min_height_help_item, 
         attr4_help_menu_form, 
         2, 
         "Min Height",
         {
           if (NOT min_height_help) then
             min_height_help := true;
           end if;
         }
       )

       menu_item(
         internal_width_help_item, 
         attr4_help_menu_form, 
         3, 
         "Internal Width",
         {
           if (NOT internal_width_help) then
             internal_width_help := true;
           end if;
         }
       )

       menu_item(
         internal_height_help_item, 
         attr4_help_menu_form, 
         4, 
         "Internal Height",
         {
           if (NOT internal_height_help) then
             internal_height_help := true;
           end if;
         }
       )

       menu_item(
         scroll_horiz_help_item, 
         attr4_help_menu_form, 
         5, 
         "Scroll Horizontal",
         {
           if (NOT scroll_horizontal_help) then
             scroll_horizontal_help := true;
           end if;
         }
       )

       menu_item(
         scroll_vertical_help_item, 
         attr4_help_menu_form, 
         6, 
         "Scroll Vertical",
         {
           if (NOT scroll_vertical_help) then
             scroll_vertical_help := true;
           end if;
         }
       )

       menu_item(
         scroll_on_overflow_help_item, 
         attr4_help_menu_form, 
         7, 
         "Scroll Overflow",
         {
           if (NOT scroll_on_overflow_help) then
             scroll_on_overflow_help := true;
           end if;
         }
       )

       menu_item(
         max_length_help_item, 
         attr4_help_menu_form, 
         8, 
         "Max Length",
         {
           if (NOT max_length_help) then
             max_length_help := true;
           end if;
         }
       )

       menu_item(
         close_attr4_menu_help_item,
         attr4_help_menu_form, 
         9, 
         "Close Menu",
         {
           if (attr4_help_menu) then
            attr4_help_menu  := false;
           end if;
         }
       )

end VC attr4_help_menu_vc;
end VC athena_objects_help_menu_vc;

#endif
