/*--------------------------------------------------------------------------*\
|   
|  Name:  Slang Help (help_sl.sl)
|
|  Description:  
|     This file contains help information for the Slang language
|     components.
|
|  Component of:
|     Serpent editor dialogue layer.
|
|  Related files:
|     help.sl - contains more help information.
|
|  Project:
|     Serpent
|     User Interface Project
|     Software Engineering Institute
|     Carnegie Mellon University
|     Pittsburgh, PA  15213
|
|  Version: 1.0
|
|  Project Leader:  
|     Len Bass
|     ljb@sei.cmu.edu
|
|  Author:  
|     Robert C. Seacord
|     rcs@sei.cmu.edu  
|
|  Change History:
|     Jan 2, 1990 : Module created.
|
\*--------------------------------------------------------------------------*\
|
|   Distribution: Approved for public release; distribution is unlimited.
|
|   Copyright (c) 1989  by  Carnegie  Mellon  University, Pittsburgh, PA.  The
|  Software Engineering  Institute  (SEI) is a federally  funded  research and
|  development center established  and  operated by Carnegie Mellon University
|  (CMU).  Sponsored  by  the  U.S.  Department  of   Defense  under  contract
|  F19628-85-C-0003,  the  SEI  is  supported  by  the  services  and  defense
|  agencies, with the U.S. Air Force as the executive contracting agent.
|
|    Permission to use,  copy,  modify, or  distribute  this  software and its
|  documentation for  any purpose and without fee  is hereby granted, provided
|  that  the above copyright notice appear  in  all copies and that both  that
|  copyright  notice  and   this  permission  notice  appear   in   supporting
|  documentation.   Further,  the  names  Software  Engineering  Institute  or
|  Carnegie  Mellon  University  may  not be used in  advertising or publicity
|  pertaining to distribution of the software without specific, written  prior
|  permission.  CMU makes no claims  or representations  about the suitability
|  of this software for any purpose.  This software is provided "as is" and no
|  warranty,  express  or  implied,  is  made  by  the  SEI  or CMU, as to the
|  accuracy  and  functioning of the program and related program material, nor
|  shall   the  fact of  distribution   constitute  any   such  warranty.   No
|  responsibility is assumed by the SEI or CMU in connection herewith.
|
\*--------------------------------------------------------------------------*/


/*------------------------- Macros Help ------------------------------------*/
  help_template(
      macros_help,
        "Macros Help",
	   "Description:\n\nSlang uses the same preprocessor as the C programming language.  This\npreprocessor is a simple macro preprocessor that processes the source\ntext of a Slang program before the compiler pass processes the  Slang\nprogram.  See page 29 of the Slang Reference Manual for a list of the\nlegal preprocessor commands.\n\n",
              180 );


/*------------------------- Externs Help -----------------------------------*/
  help_template(
      externs_help,
        "Externs Help",
	   "Description:\n\nSlang  provides a mechanism to invoke  externally defined C functions\nfrom within a dialogue.  The C function must be declared as  external\nin the Slang dialogue. See page 55 in the Slang Reference Manual.\n\n",
              180 );


/*------------------------- Shared Data Help -------------------------------*/
  help_template(
      sdd_help,
        "Shared Data Help",
	   "Description:\n\nShared Data is information that is  communicated between the dialogue\nand the application,or solely within the dialogue. Shared data exists\nin the shared database and it is defined  externally in a shared data\ndefinition file and is instantiated at runtime by either the dialogue\nor the application.\n\n",
              180 );


/*------------------------- Methods Help -----------------------------------*/
  help_template(
      method_help,
        "Methods Help",
	   "Description:\n\nMethods  provide a way for handling  end-user interactions which take\nplace in the  dialogue by specifying actions to be taken for specific\nend-user generated events . Each objet type has a fixed collection of\nmethods. Methods are executed once for each user-generated event.\n\n",
              180 );


/*------------------------- Objects Help -----------------------------------*/
  help_template(
      objects_help,
        "Objects Help",
	   "Description:\n\nInteraction Objects, or simply objects, are entities that are defined\nby a given I/O technology and are used to interact with the end-user.\nObjects are specified in a  dialogue and presented to the end user by\nthe presentation layer.Objects have attributes to define how they are\npresented; their characteristics. These are specified by the dialogue\ndeveloper or defined by the technology.\n\n",
              180 );


/*------------------------- View Controllers Help --------------------------*/
  help_template(
      vcs_help,
        "View Controllers Help",
	   "Description:\n\nView Controllers are used to group interaction objects and variables,\nand  control the circumstances under which they are  presented to the\nend user.VCs have creation conditions under which the view controller\nis instantiated. When it is instantiated, the objects defined for the\nview controller are displayed to the end user.\n\n",
              180 );

