/* $Header: /u/04c/mnt/integ/source/de/src/RCS/menus.sl,v 1.35 1991/06/19 21:50:31 dvk Exp $ */
/*--------------------------------------------------------------------------*\
|   
|  Name:  menus
|
|  Description:  
|     This file contains the slang for the system menu bar.
|
|  Component of:
|     Serpent visualization editor dialogue layer.
|
|  Related files:
|     help_menus.sl - contains the slang source for the help menus.
|
|  Project:
|     Serpent
|     User Interface Project
|     Software Engineering Institute
|     Carnegie Mellon University
|     Pittsburgh, PA  15213
|
|  Version: 1.0
|
|  Project Leader:  
|     Len Bass
|     ljb@sei.cmu.edu
|
|  Author:  
|     Robert C. Seacord
|     rcs@sei.cmu.edu  
|
|  Change History:
|	Feb. 24, 1989 : Module created.
|	$Log: menus.sl,v $
% Revision 1.35  1991/06/19  21:50:31  dvk
% Duplicated items now are offset from the original
%
% Revision 1.34  1991/05/30  21:46:36  little
% added copy of attribute's priority information
%
% Revision 1.33  1991/04/11  18:06:25  rcs
% *** empty log message ***
%
% Revision 1.32  91/03/21  17:15:27  rcs
% *** empty log message ***
% 
% Revision 1.31  91/03/19  20:00:20  rcs
% fixed duplicate, added new to system menu
% 
% Revision 1.30  91/03/13  07:13:59  rcs
% new stuff
% 
% Revision 1.29  91/03/06  09:32:41  mpottier
% *** empty log message ***
% 
% Revision 1.28  91/02/01  16:33:09  mpottier
% Linked layout selection with toolkits
% 
% Revision 1.27  91/02/01  14:43:42  mpottier
% ADDED ATHENA MENUS w/ BITMAPS
% 
% Revision 1.26  91/01/08  14:10:07  rm
% no changes
% 
% Revision 1.25  90/11/29  18:43:01  rcs
% *** empty log message ***
% 
% Revision 1.24  90/11/09  17:23:16  rcs
% *** empty log message ***
% 
% Revision 1.23  90/10/10  22:44:23  rcs
% new widget names
% 
% Revision 1.22  90/10/09  22:16:42  rcs
% new sat attribute names & generic editor stuff
% 
% Revision 1.21  90/10/09  16:55:00  clc
% Added Change Grid Snap Values to the edit menu.
% 
% Revision 1.20  90/09/25  21:38:46  rcs
% sort of eliminated realize command
% 
% Revision 1.19  90/09/17  21:41:38  rcs
% fixed naming for duplicate command
% 
% Revision 1.18  90/08/29  21:53:23  rcs
% *** empty log message ***
% 
% Revision 1.17  90/08/27  20:43:36  rcs
% *** empty log message ***
% 
% Revision 1.16  90/08/22  18:26:55  rcs
% *** empty log message ***
% 
% Revision 1.15  90/07/13  12:48:59  rcs
% leaving for 2 weeks
% 
% Revision 1.14  90/07/02  23:25:15  rcs
% *** empty log message ***
% 
% Revision 1.13  90/06/25  19:34:42  rcs
% *** empty log message ***
% 
% Revision 1.12  90/06/18  12:01:53  rcs
% updated menus and interactions
% 
% Revision 1.11  90/06/01  09:01:22  clc
% gave a decent message for exit_sure_text widget.
% 
% Revision 1.10  90/05/29  18:40:49  rcs
% new style menu bars
% 
% Revision 1.7  90/05/10  12:53:31  rcs
% *** empty log message ***
% 
% Revision 1.6  90/03/23  14:19:39  rcs
% fixed someting
% 
% Revision 1.5  90/03/15  11:37:51  rcs
% shut off help menu; add type abbr to drawables
% 
% Revision 1.4  90/03/08  13:09:55  rcs
% fixed up some of the font stuff
% 
% Revision 1.3  90/03/07  10:13:03  rcs
% changed contents of exit menu
% 
% Revision 1.2  90/03/01  11:37:36  rcs
% make the actuals for some methods smaller
% 
% Revision 1.1  90/02/28  11:43:43  rcs
% Initial revision
% 
|
\*--------------------------------------------------------------------------*\
|
|   Distribution: Approved for public release; distribution is unlimited.
|
|   Copyright (c) 1989  by  Carnegie  Mellon  University, Pittsburgh, PA.  The
|  Software Engineering  Institute  (SEI) is a federally  funded  research and
|  development center established  and  operated by Carnegie Mellon University
|  (CMU).  Sponsored  by  the  U.S.  Department  of   Defense  under  contract
|  F19628-85-C-0003,  the  SEI  is  supported  by  the  services  and  defense
|  agencies, with the U.S. Air Force as the executive contracting agent.
|
|    Permission to use,  copy,  modify, or  distribute  this  software and its
|  documentation for  any purpose and without fee  is hereby granted, provided
|  that  the above copyright notice appear  in  all copies and that both  that
|  copyright  notice  and   this  permission  notice  appear   in   supporting
|  documentation.   Further,  the  names  Software  Engineering  Institute  or
|  Carnegie  Mellon  University  may  not be used in  advertising or publicity
|  pertaining to distribution of the software without specific, written  prior
|  permission.  CMU makes no claims  or representations  about the suitability
|  of this software for any purpose.  This software is provided "as is" and no
|  warranty,  express  or  implied,  is  made  by  the  SEI  or CMU, as to the
|  accuracy  and  functioning of the program and related program material, nor
|  shall   the  fact of  distribution   constitute  any   such  warranty.   No
|  responsibility is assumed by the SEI or CMU in connection herewith.
|
\*--------------------------------------------------------------------------*/

#undef DEBUG1
#undef DEBUG2
#undef DEBUG3

#define DEBUG1(statement) SERPENT_DEBUG1(se_debug, statement)
#define DEBUG2(statement) SERPENT_DEBUG2(se_debug, statement)
#define DEBUG3(statement) SERPENT_DEBUG3(se_debug, statement)

#define MENU_Y_OFFSET 23


/*----------------------------- Dialogue Menu ------------------------------*/


Dialog_Button : XawMenuButton {
    Attributes:
	parent		: system_menu_form;
	label		: "System";
	horizDistance	: 0;
	bordercolor	: "black";
	background	: "black";
	foreground	: "white";
	menuname	: "xawmenushell";
}

Dialogue_Shell : XawMenuShell {
    Attributes:
	parent 		: Dialog_Button;
}

New_menu_item : XawSimpleMenuBSB {
    Attributes:
	parent 		: Dialogue_Shell;
	label		: "New";
	sensitive	: (current_dialogue_sd = NULL);
	rightmargin	: 25;
	leftmargin	: 5;
    Methods:
	Notify : {
        /*--- Set the current command name in case of bad status.---*/
          	current_command_name := "New";
                message := "New dialogue created.";
	    	make_command(selected_command,new_dialogue_cmd)
        }
}

Load_menu_item : XawSimpleMenuBSB {
    Attributes:
	parent 		: Dialogue_Shell;
	label		: "Load";
	sensitive	: (current_dialogue_sd = NULL);
	rightmargin	: 25;
	leftmargin	: 5;
	after		: New_menu_item;
    Methods:
	Notify : {
        /*--- Set the current command name in case of bad status.---*/
          	current_command_name := "Load";
	/*--- If file name not defined, get file name.           ---*/
        	display_get_load_file_name_form := true;
                message := "";
        }
}

Save_menu_item : XawSimpleMenuBSB {
    Attributes:
        parent          : Dialogue_Shell;
        label           : "Save";
        sensitive       : (current_dialogue_sd <> NULL);
	rightmargin	: 25;
	leftmargin	: 5;
	after		: Load_menu_item;
    Methods:
        notify : {
	/*--- Set the current command name in case of bad status. --*/
        	current_command_name := "Save";
          	save_filename := current_dialogue_filename;

	/*-- Not sure how dialogue_name will be at first. So check it out.--*/
          	if ( (current_dialogue_filename  = "" ) OR
	     	(current_dialogue_filename = "Unnamed")) then

	/*-- Filename is not defined. Treat it like a "Save As..". --*/
             	display_get_file_name_form := true;
	  	else

	/*--  Name is defined. Just do a "Save".
	      Create a new command_sdd element to tell application that 
              this is a request for a save. --*/
	    		make_command_and_parameter(
	      		selected_command,
	      		parameter_list,
	      		save_dialogue_cmd,
	      		current_dialogue_sd)

 	    		make_another_parameter(
	      		parameter_list,
	      		current_dialogue_filename)

	/*-- Force overwrite in this instance. --*/
	    		make_another_parameter(
	      		parameter_list,
	      		true)

	  	endif;
          	message := "";

        }
}

Save_As_menu_item : XawSimpleMenuBSB {
    Attributes:
        parent          : Dialogue_Shell;
        label           : "Save As...";
        sensitive       : (current_dialogue_sd <> NULL);
        rightmargin     : 10;
	after		: Save_menu_item;
    Methods:
        notify : {
	/*-- Set the current command name in case of bad status. --*/
          current_command_name := "Save";
	/*-- Doesn't matter if filename set or not. 
             Give user a chance to change it. --*/
          display_get_file_name_form := true;

          message := "";

        }
}

 Seperator_line1 : XawSmeLine
 {
  Attributes:
        parent          : Dialogue_Shell; 
        after           : Save_As_menu_item;
}


Import_menu_item : XawSimpleMenuBSB {
    Attributes:
        parent          : Dialogue_Shell;
        label           : "Import";
        sensitive       : (current_dialogue_sd = NULL);
	rightmargin	: 25;
	leftmargin	: 5;
	after		: Seperator_line1;
    Methods:
        notify : {
	/* Set the current command name in case of bad status.*/
          current_command_name := "Import";
	/* Reset the menu and print up the import form.n*/
          display_import_menu := true;
          message := "";
	}
}

Export_menu_item : XawSimpleMenuBSB {
    Attributes:
        parent          : Dialogue_Shell;
        label           : "Export";
        sensitive       : (current_dialogue_sd <> NULL);
	rightmargin	: 25;
	leftmargin	: 5;
	after		: Import_menu_item;
    Methods:
        notify : {
	/* Set the current command name in case of bad status.*/
          current_command_name := "Export";
	/* Reset the menu and print up the export form. */
	  display_export_menu := true;
          message := "";
        }
}

 Seperator_line2 : XawSmeLine
 {
  Attributes:
        parent          : Dialogue_Shell; 
        after           : Export_menu_item;
}


Run_menu_item : XawSimpleMenuBSB {
    Attributes:
        parent          : Dialogue_Shell;
        label           : "Run";
        sensitive       : true;
	rightmargin	: 25;
	leftmargin	: 5;
	after		: Seperator_line2;
    Methods:
        notify : {
	/* Set the current command name in case of bad status.*/
          current_command_name := "Run";
	/* Display the run command form and reset the menu and message area.*/
          display_run_form := true;
          message := "";
        }
}

Unload_menu_item : XawSimpleMenuBSB {
    Attributes:
        parent          : Dialogue_Shell;
        label           : "Unload";
        sensitive       : (current_dialogue_sd <> NULL);
	rightmargin	: 25;
	leftmargin	: 5;
	after		: Run_menu_item;
    Methods:
        notify : {
	/* Set the current command name in case of bad status.*/

          current_command_name := "Unload";

	/* If dialogue has changed in places, give user a chance to change
   	his or her mind about just quitting if there have been any 
   	changes in current dialogue.*/

          if (dialogue_changed) then
	    display_confirm_quit := true;

	/* Create request to application to quit.*/

	  else
            make_command_and_parameter(
              selected_command,
              parameter_list,
              unload_dialogue_cmd,
              current_dialogue_sd 
            )

	/* Reset current dialogue globals.*/

	    current_dialogue_sd := NULL;
            current_dialogue_filename := "";

	/* If there is no dialogue we don't want to allow prototyping.*/

            prototype := false;

          endif;
          message := "";

        }
}

Serpent_menu_item : XawSimpleMenuBSB {
    Attributes:
        parent          : Dialogue_Shell;
        label           : "Serpent";
        sensitive       : true;
	rightmargin	: 25;
	leftmargin	: 5;
	after		: Unload_menu_item;
    Methods:
        notify : {
          display_about_serpent := true;
          message := "";
        }
}

 Seperator_Line3 : XawSmeLine
 {
  Attributes:
	parent		: Dialogue_Shell;
	after		: Serpent_menu_item;
}

Quit_menu_item : XawSimpleMenuBSB {
    Attributes:
        parent          : Dialogue_Shell;
        label           : "Quit";
        sensitive       : true;
	rightmargin	: 25;
	leftmargin	: 5;
	after		: Seperator_line3;
    Methods:
        notify : {
	if (dialogue_changed) then
	  display_confirm_exit := true;
          message := "";
	else
          exit();
	endif;

      }
}

/*---------------------------------- Edit Menu -----------------------------*/

Edit_Button : XawMenuButton {
    Attributes:
        parent          : system_menu_form;
        label           : "Edit";
        horizDistance   : 70;
	bordercolor	: "black";
	background	: "black";
	foreground	: "white";
        menuname        : "xawmenushell";
}

Edit_Shell : XawMenuShell {
    Attributes:
        parent          : Edit_Button;
}

display_attr_menu_item : XawSimpleMenuBSB {
    Attributes:
        parent          : Edit_Shell;
        label           : "Edit Attributes";
        sensitive: ((source_id <> NULL) AND (edit_attr_form_not_displayed));
        rightmargin     : 25;
        leftmargin      : 5;
    Methods:
        notify : {

/*
**  Set the display_attributes variable in the view controller
**  associated with the object instance identified by source_id to
**  true.
*/
          put_variable_value(
            get_vc(source_id,"gw_vc"),"display_attributes",true
          );
/*
**  Reset the display attribute parameters.
*/
          source_id := NULL;
          source_object_type := UNDEFINED;
/*
**  Reset the menu bar and status area.
*/
          edit_attr_form_not_displayed := false;
          message := "";
        }
}

 Seperator_line4 : XawSmeLine
 {
  Attributes:
        parent          : Edit_Shell;
        after           : display_attr_menu_item;
}


/*
   Copy command.  The copy command is active whenever the source
   and target are selected since there is no combintation of
   selectable source and target that are not valid for copy.
*/

Copy_menu_item : XawSimpleMenuBSB {
    Attributes:
        parent          : Edit_Shell;
	after		: Seperator_line4;
        label           : "Copy";
        sensitive       :  (
          		   (source_id <> NULL) AND
          		   (target_id <> NULL) AND
          		   (source_type <> OBJECT_INSTANCE_TYPE) AND
          		   (source_type <> DIALOGUE_TYPE)
        		   );
	rightmargin	: 25;
	leftmargin	: 5;
    Methods:
        notify : {
          DEBUG2(
            printf("Copy Menu Item:  notify method call.\n", "");
          )
	/* Set the current command name in case of bad status.*/

          current_command_name := "Copy";

	/* Determine the type of what is being copied and set the command
   	   type and message accordingly.*/

          if (source_type = VC_TYPE) then
            command_type := copy_vc_cmd;
          elsif ( source_type = VARIABLE_TYPE ) then
            command_type := copy_variable_cmd;
          else
            command_type := copy_object_cmd;
          endif;
	
	/* Create the command and set the first parameter to the source_id. */

          make_command_and_parameter(
            selected_command, parameter_list, command_type, source_id 
          )

	/*  Create another (subtree) parameter if a VC_TYPE. */

          if (source_type = VC_TYPE) then
            make_another_parameter(parameter_list, subtree)
          endif;

	/* Create another parameter for ID of target.*/

          make_another_parameter(parameter_list, target_id)

	/* Set the status message.*/

          message := string_append(
            string_append(source_name, " copied to "), target_name
          );

	/* Reset the command operands.*/

          source_id := NULL;
          target_id := NULL;
          target_name := UNDEFINED;
          source_type := UNDEFINED;
          target_type := UNDEFINED;

          DEBUG2(
            printf("Copy Menu Item:  notify method exit.\n", "");
          )
        }
}


/* Delete command. */

Delete_menu_item : XawSimpleMenuBSB {
    Attributes:
        parent          : Edit_Shell;
        label           : "Delete";
        sensitive       : ((source_id <> NULL) AND
          		  (source_type <> DIALOGUE_TYPE));
	after		: Copy_menu_item;
	rightmargin	: 25;
	leftmargin	: 5;
    Methods:
        notify : {
          DEBUG2(
            printf("Delete Menu Item:  notify method call.\n", "");
          )
	/* Set the current command name in case of bad status.*/

          current_command_name := "Delete";

	/* Assume the delete will work and set the status message.*/

          message := string_append(
            get_sd_value(source_id, "name"), " deleted"
          );

	/* If source type is an object instance delete the attributes here
   	   in the dialogue.*/

          if (source_type = OBJECT_INSTANCE_TYPE) then

	/* Delete the attributes.*/

            while (source_id <> NULL) do
              next_id := get_sd_value(source_id, "attr_list");
              destroy_sd_instance(source_id);
              source_id := next_id;
            end while;

	/* Else send the appropriate command to the application.*/

          else
            if (source_type = VC_TYPE) then
              command_type := delete_vc_cmd;
            elsif (source_type = VARIABLE_TYPE) then
              command_type := delete_variable_cmd;
            elsif (source_type = OBJECT_TYPE) then
              command_type := delete_object_cmd;
            else
              printf("Delete:  unknown object type.\n", "");
            endif;

            make_command_and_parameter(
              selected_command, parameter_list, command_type, source_id 
            )

	/* Create another parameter if a VC_TYPE. Objects and Variables
	   are always NODE.*/

             if (source_type = VC_TYPE) then
               make_another_parameter(parameter_list, subtree)
             endif;

           end if;

	/* Reset the command operands.*/

          source_id := NULL;
          source_type := UNDEFINED;
          source_object_type := UNDEFINED;

          message := "";

          DEBUG2(printf("Delete Menu Item:  notify method exit.\n", "");)

        }
}

Duplicate_menu_item : XawSimpleMenuBSB {
    Attributes:
        parent          : Edit_Shell;
        label           : "Duplicate";
        sensitive       : ((source_id <> NULL) AND
		          (source_type <> DIALOGUE_TYPE));
	after		: Delete_menu_item;
	rightmargin	: 25;
	leftmargin	: 5;
    Methods:
        notify : {
/*  Set the current command name in case of bad status.*/

          current_command_name := "Duplicate";

/*
**  Assume the command is going to work and set the status message.
*/
         message := string_append(
           get_sd_value(source_id,"name")," duplicated"
         );
/*
**  If source type is an object instance create a copy here 
**   in the dialogue.
*/
          if (source_type = OBJECT_INSTANCE_TYPE) then
/*
**  Create an object instance record.
*/
            object_instance_sdi := create_sd_instance(
              "object_instance_sdd","SE_BOX"
            );

            DEBUG3(
              printf("object_instance_sdi = %s.\n",object_instance_sdi);
            )

            put_sd_value(object_instance_sdi,"name",
              string_append(source_object_type,
                get_sd_value(current_dialogue_sd,"count")
              )
            ); 
/*
**  dialogue_sdd.count := dialogue_sdd.count + 1; 
*/
            put_sd_value(current_dialogue_sd,"count",
              get_sd_value(current_dialogue_sd,"count") + 1
            );
            put_sd_value(object_instance_sdi,"mailbox",source_mailbox);
            put_sd_value(object_instance_sdi,"tech",source_tech_type);
            put_sd_value(object_instance_sdi,"type",source_object_type);
/*
            DEBUG3(
              printf(
                "object_instance_sdi.name = %s.\n",
                get_sd_value(object_instance_sdi,"name")
              );
              printf(
                "object_instance_sdi.type = %s.\n",
                get_sd_value(object_instance_sdi,"type")
              );
            )
*/
            put_sd_value(object_instance_sdi,"visible",TRUE);
/*
   Copy the attributes.  source_id contains the id of the existing 
   attribute we are currently interested in.  previous_id contains
   a pointer to the last element in the list.  current_id is the
   new attribute.
*/
           source_id := get_sd_value(source_id,"attr_list");
           previous_id := object_instance_sdi;
/*
   Create a new attribute instance for each attribute in the existing 
   attribute.
*/
           while (source_id <> NULL) do
/*
   Create a new attribute instance.
*/
             current_id := create_sd_instance(
               "object_instance_attribute_sdd","SE_BOX"
             );
/*
   Make the last element in the list point to the current element.
*/
             put_sd_value(previous_id,"attr_list",current_id);
/*
**  Set the name and type of the current attribute to the name of the 
**  source attribute.
*/
             put_sd_value(current_id,"name",get_sd_value(source_id,"name"));
             put_sd_value(current_id,"type",get_sd_value(source_id,"type"));
             put_sd_value(current_id,"priority",
			  get_sd_value(source_id,"priority"));
/*
   Set the parent object for the attribute to the newly created
   object instance.
*/
             put_sd_value(current_id,"object",object_instance_sdi);
/*
   If the attribute is horizDistance or vertDistance increment
   the values by 25, otherwise simply copy over the old attribute value.
*/
             if (
               (get_sd_value(source_id,"name") = "horizdistance") OR 
               (get_sd_value(source_id,"name") = "x") OR 
               (get_sd_value(source_id,"name") = "y") OR 
               (get_sd_value(source_id,"name") = "vertdistance")
             ) then
               put_sd_value(current_id,"value",
                 get_sd_value(source_id,"value") + 25
               );
             else
               put_sd_value(
                 current_id,"value",get_sd_value(source_id,"value")
               );
            end if;

            DEBUG3(
              printf(
                "attribute.value = %s.\n",get_sd_value(current_id,"value")
              )
            )
/*
   Update both pointers.
*/
             previous_id := current_id;
             source_id := get_sd_value(source_id,"attr_list");
 
           end while;
/*
   Make sure the last attribute has a NULL pointer.
*/
           put_sd_value(previous_id,"attr_list",NULL);
/*
   Else not an object instance -> send command to application.
*/
         else
/*
   Determine the type of what is being copied and set the command
   type and other parameters accordingly.
*/
           if (source_type = VC_TYPE) then
             command_type := copy_vc_cmd;
           elsif (source_type = VARIABLE_TYPE) then
             command_type := copy_variable_cmd;
           else
             command_type := copy_object_cmd;
           endif;
/*
   Create the command and set the first parameter to the source_id.
*/
           make_command_and_parameter(
             selected_command,parameter_list,command_type,source_id 
           )
/*
   Create another (subtree) parameter if a VC_TYPE. 
*/
           if (source_type = VC_TYPE) then
             make_another_parameter(parameter_list,subtree)
           endif;
/*
   Create another parameter for ID of target.
*/
           make_another_parameter(parameter_list,source_vc_id)
         end if;		/*  end if source is an object Instance */
/*
   Reset the command operands.
*/
          source_id := NULL;
          source_object_type := UNDEFINED;
          source_type := UNDEFINED;
 
/*
          DEBUG2(printf("Duplicate Menu Item:  notify method exit.\n","");)
*/
        }
}

Move_menu_item : XawSimpleMenuBSB {
    Attributes:
        parent          : Edit_Shell;
        label           : "Move";
        sensitive       : ((source_id <> NULL) AND
  			  (source_type <> OBJECT_INSTANCE_TYPE) AND
          		  (source_type <> DIALOGUE_TYPE));
	after		: Duplicate_menu_item;
	rightmargin	: 25;
	leftmargin	: 5;
    Methods:
        notify : {

          DEBUG2(
            printf("Move Menu Item:  notify method call.\n", "");
          )
/*
   Set the current command name in case of bad status.
*/
          current_command_name := "Move";
/*
   Determine the type of what is being copied and set the command
   type accordingly.
*/
          if (source_type = VC_TYPE) then
            command_type := move_vc_cmd;
          elsif (source_type = VARIABLE_TYPE) then
            command_type := move_variable_cmd;
          else
            command_type := move_object_cmd;
          endif;
/*
   Create the command and set the first parameter to the source_id.
*/
          make_command_and_parameter(
            selected_command, parameter_list, command_type, source_id 
          )
/*
  Create another (subtree) parameter if a VC_TYPE. 
*/
          if (source_type = VC_TYPE) then
            make_another_parameter(parameter_list, subtree)
          endif;
/*
  Create another parameter for ID of target.
*/
          make_another_parameter(parameter_list, target_id)
/*
   Set the status message.
*/
          message := string_append(
            string_append(source_name, " moved to "), target_name
          );
/*
   Reset the command operands.
*/
          source_id := NULL;
          target_id := NULL;
          target_name := UNDEFINED;
          source_type := UNDEFINED;
          target_type := UNDEFINED;

          DEBUG2(
            printf("Move Menu Item:  notify method exit.\n", "");
          )

        }
}

 Seperator_line5 : XawSmeLine
 {
  Attributes:
        parent          : Edit_Shell; 
        after           : Move_menu_item;
}


Clear_menu_item : XawSimpleMenuBSB {
    Attributes:
        parent          : Edit_Shell;
        label           : "Clear Operands";
        sensitive       : ((source_id <> NULL) OR
          		  (target_id <> NULL));
	rightmargin	: 25;
	leftmargin	: 5;
	after		: Seperator_line5;
    Methods:
        notify : {
          DEBUG2(
            printf("Clear Operands Menu Item:  notify method call.\n", "");
          )
/*
**  Reset the command operands.
*/
          source_id := NULL;
          target_id := NULL;
          source_object_type := UNDEFINED;
          source_tech_type := UNDEFINED;
          target_name := UNDEFINED;
          source_type := UNDEFINED;
          target_type := UNDEFINED;

	  toolbox_object := UNDEFINED;
          toolbox_mailbox := UNDEFINED;
          toolbox_tech_type := UNDEFINED;
          toolbox_object_type := UNDEFINED;
/*
   Update message.
*/
          message := "All command operands have been reset.";

          DEBUG2(
            printf("Clear Operands Menu Item:  notify method exit.\n", "");
          )

        }
} 

/*-------------------------- LAYOUT MENU---------------------------------*/

Prototype_Button : XawMenuButton {
    Attributes:
        parent          : system_menu_form;
        label           : "Layout";
        horizDistance   : 130;
        menuname        : "xawmenushell";
	bordercolor	: "black";
	background	: "black";
	foreground	: "white";
}

Prototype_Shell : XawMenuShell {
    Attributes:
        parent          : Prototype_Button;
}

/*
**  This menu item allows the user to turn on the protoyper if
**  it is off or turn it off if it is on.  The prototyper can 
**  only be turned on if there is a loaded dialogue.
*/

Athena_menu_item : XawSimpleMenuBSB {
    Attributes:
        parent          : Prototype_Shell;
        label           : "Athena Layout";
        sensitive       : (current_dialogue_sd <> NULL);
        rightbitmap     : {if (athena_prototype) then 
                              rightbitmap := "check.sbm";
			   else
			      rightbitmap := "nocheck.sbm";
                           end if;}
	rightmargin	: 25;
	leftmargin	: 5;
    Methods:
        notify : {
	  if (athena_prototype) then
	    destroy_sd_instance(athena_id);
            message := "Athena visualization off";
	  else
	    athena_id := create_sd_instance("visualize_sdd", "DM_BOX");
	    put_sd_value(athena_id, "tech", "sat");
            message := "Athena visualization on";

          if (athena_toolkit = false) then
            athena_toolbox_id := create_sd_instance("toolbox_sdd","DM_BOX");
            put_sd_value(athena_toolbox_id,"tech","sat");
            put_sd_value(athena_toolbox_id,"mailbox","SAT_BOX");
            message := "Athena toolbox displayed";
            athena_toolkit := true;
          end if;
	  end if;

          athena_prototype := NOT athena_prototype;
	}
}

Motif_menu_item : XawSimpleMenuBSB {
    Attributes:
        parent          : Prototype_Shell;
        label           : "Motif Layout";
        sensitive       :  (current_dialogue_sd <> NULL);
        rightbitmap     :  {if (motif_prototype) then 
                               rightbitmap := "check.sbm";
			    else
			       rightbitmap := "nocheck.sbm";
			    end if;}
	rightmargin	: 25;
	leftmargin	: 5;
	after		: Athena_menu_item;
    Methods:
        notify : {
	  if (motif_prototype) then
	    destroy_sd_instance(motif_id);
            message := "Motif visualization off";
	  else
	    motif_id := create_sd_instance("visualize_sdd", "DM_BOX");
	    put_sd_value(motif_id, "tech", "smo");
            message := "Motif visualization on";
          if (motif_toolkit = false) then
            motif_toolbox_id := create_sd_instance("toolbox_sdd","DM_BOX");
            put_sd_value(motif_toolbox_id,"tech","smo");
            put_sd_value(motif_toolbox_id,"mailbox","SMO_BOX");
            message := "Motif toolbox displayed";
            motif_toolkit := true;
          end if;

	  end if;

          motif_prototype := NOT motif_prototype;
	}
}

 Seperator_line6 : XawSmeLine
 {
  Attributes:
        parent          : Prototype_Shell; 
        after           : Motif_menu_item;
}

Instantiate_menu_item : XawSimpleMenuBSB {
    Attributes:
        parent          : Prototype_Shell;
        label           : "Instantiate";
        sensitive       :  ((source_id <> NULL) AND
                           ((source_type = VC_TYPE) OR 
                            (source_type = DIALOGUE_TYPE)));
	rightmargin	: 25;
	leftmargin	: 5;
	after		: Seperator_line6;
    Methods:
        notify : {
          DEBUG2(
            printf("Instantiate Menu Item:  notify method call.\n", "");
          )
/*
   Set the current command name in case of bad status.
*/
          current_command_name := "Instantiate";
/*
   Send the instantiate command and parameters.
*/
          make_command_and_parameter(
            selected_command, parameter_list, instantiate_cmd, source_id 
          )

          make_another_parameter(parameter_list, subtree)
/*
   Set the status message.
*/
          message := string_append(source_name, " instantiated");
/*
   Reset the command operands.
*/
          source_id := NULL;
          source_type := UNDEFINED;

          DEBUG2(
            printf("Instantiate Menu Item:  notify method exit.\n", "");
          )
	}
}

Remove_menu_item : XawSimpleMenuBSB {
    Attributes:
	after		: Instantiate_menu_item;
        parent          : Prototype_Shell;
        label           : "Remove";
        sensitive       :  ((source_id <> NULL) AND
        		   ((source_type = VC_TYPE) OR 
			   (source_type = DIALOGUE_TYPE)));
	rightmargin	: 25;
	leftmargin	: 5;
    Methods:
        notify : {
          DEBUG2(
            printf("Remove Menu Item:  notify method call.\n", "");
          )
/*
   Set the current command name in case of bad status.
*/
          current_command_name := "Remove";
/*
   Send the remove command and parameters.
*/
          make_command_and_parameter(
            selected_command, parameter_list, remove_cmd, source_id 
          )

          make_another_parameter(parameter_list, subtree)
/*
   Set the status message.
*/
          message := string_append(source_name, " removed");
/*
   Reset the command operands.
*/
          source_id := NULL;
          source_type := UNDEFINED;

          DEBUG2(
            printf("Remove Menu Item:  notify method exit.\n", "");
          )
	}
}

Uninstantiate_menu_item : XawSimpleMenuBSB {
    Attributes:
	after		: Remove_menu_item;
        parent          : Prototype_Shell;
        label           : "Uninstantiate"; 
        sensitive       : ((source_id <> NULL) AND
          		  ((source_type = VC_TYPE) OR 
			  (source_type = DIALOGUE_TYPE)));
	rightmargin	: 25;
	leftmargin	: 5;
    Methods:
        notify : {
          DEBUG2(
            printf("Uninstantiate Menu Item:  notify method call.\n", "");
          )
/*
   Set the current command name in case of bad status.
*/
          current_command_name := "Uninstantiate";
/*
   Send the uninstantiate command and parameters.
*/
          make_command_and_parameter(
            selected_command, parameter_list, uninstantiate_cmd, source_id 
          )

          make_another_parameter(parameter_list, subtree)
/*
   Set the status message.
*/
          message := string_append(source_name, " uninstantiated");
/*
   Reset the command operands.
*/
          source_id := NULL;
          source_type := UNDEFINED;

          DEBUG2(
            printf("Uninstantiate Menu Item:  notify method exit.\n", "");
          )
	}
}

 Seperator_line7 : XawSmeLine
 {
  Attributes:
        parent          : Prototype_Shell; 
        after           : Uninstantiate_menu_item;
}


/*
   This menu item allows the user to turn on the protoyper if
   it is off or turn it off if it is on.  The prototyper can 
   only be turned on if there is a loaded dialogue.
*/
Grid_menu_item : XawSimpleMenuBSB {
    Attributes:
	after		: Seperator_line7;
        parent          : Prototype_Shell;
        label           : "Grid Snap";
        sensitive       : (prototype);
        rightbitmap    : {if (grid_snap) then 
		              rightbitmap := "check.sbm";
                          else
                              rightbitmap := "nocheck.sbm";
			   end if;}
	rightmargin	: 25;
	leftmargin	: 5;
    Methods:
        notify : {
          grid_snap := NOT grid_snap;
          if (grid_snap) then
            message := "Grid Snap On";
          else
            message := "Grid Snap Off";
          end if;
	}
}

GSVals_menu_item : XawSimpleMenuBSB {
    Attributes:
	after		: Grid_menu_item;
        parent          : Prototype_Shell;
        label           : "Grid Snap Values"; 
        sensitive       : (prototype);
	rightmargin	: 25;
	leftmargin	: 5;
    Methods:
        notify : {
          message := "Set grid snap values";
	  set_grid_snap_values := true;
	}
}

/*-------------------------------- TOOLKITS MENU --------------------------*/

DrawM_Button : XawMenuButton {
    Attributes:
        parent          : system_menu_form;
        label           : "Toolkits";
        horizDistance   : 205;
        menuname        : "xawmenushell";
	bordercolor	: "black";
	background	: "black";
	foreground	: "white";
}

DrawM_Shell : XawMenuShell {
    Attributes:
        parent          : DrawM_Button;
}

/*
**  This menu item allows the user to turn on/off the toolboxes
**  for the various toolkits.
*/

AthenaT_menu_item : XawSimpleMenuBSB {
    Attributes:
        parent          : DrawM_Shell;
        label           : "Athena Toolkit";
        sensitive       : true;
        rightbitmap     : {if (athena_toolkit) then 
			      rightbitmap := "check.sbm";
		           else
                              rightbitmap := "nocheck.sbm";
			   end if;}
	rightmargin	: 25;
	leftmargin	: 5;
    Methods:
        notify : {
/*
**  If athena_toolkit is true this is a request to revove the 
**  toolbox.
*/
	  if (athena_toolkit) then
	    destroy_sd_instance(athena_toolbox_id);
            message := "Athena toolbox removed";
	  else
	    athena_toolbox_id := create_sd_instance("toolbox_sdd","DM_BOX");
	    put_sd_value(athena_toolbox_id,"tech","sat");
	    put_sd_value(athena_toolbox_id,"mailbox","SAT_BOX");
            message := "Athena toolbox displayed";
	  end if;

          athena_toolkit := NOT athena_toolkit;
          
	}
}

MotifT_menu_item : XawSimpleMenuBSB {
    Attributes:
	after		: AthenaT_menu_item;
        parent          : DrawM_Shell;
        label           : "Motif Toolkit";
        sensitive       : true;
	rightbitmap     : {if (motif_toolkit) then 
			      rightbitmap := "check.sbm";
                           else
                              rightbitmap := "nocheck.sbm";
			   end if;}
	rightmargin	: 25;
	leftmargin	: 5;
    Methods:
        notify : {
	  if (motif_toolkit) then
	    destroy_sd_instance(motif_toolbox_id);
            message := "Motif toolbox removed";
	  else
	    motif_toolbox_id := create_sd_instance("toolbox_sdd","DM_BOX");
	    put_sd_value(motif_toolbox_id,"tech","smo");
	    put_sd_value(motif_toolbox_id,"mailbox","SMO_BOX");
            message := "Motif toolbox displayed";
	  end if;

          motif_toolkit := NOT motif_toolkit;

	}
}

#include "help_menu.sl"
