/* $Header: /usr/users/rcs/serpent/sun/de/src/RCS/utils.sl,v 1.29 1991/05/17 21:13:39 rcs Exp $ */
/*--------------------------------------------------------------------------*\
|     
|  Name:  Utilities (utils.sl)
|
|  Description:  
|     This file contains macros to implement various general utilites
|     in the editor dialogue including buttons and menus.
|
|  Component of:
|     Serpent editor dialogue layer.
|
|  Related files:
|     utils.sl - contains the slang source for slang utilities.
|
|  Project:
|     Serpent
|     User Interface Project
|     Software Engineering Institute
|     Carnegie Mellon University
|     Pittsburgh, PA  15213
|
|  Version: 1.0
|
|  Project Leader:  
|     Len Bass
|     ljb@sei.cmu.edu
|
|  Author:  
|     Robert C. Seacord
|     rcs@sei.cmu.edu  
|
|  Change History:
|	Feb. 24, 1989 : Module created.
|	$Log: utils.sl,v $
% Revision 1.29  1991/05/17  21:13:39  rcs
% *** empty log message ***
%
% Revision 1.28  1991/04/26  15:51:32  rcs
% added sensitive button macro
%
% Revision 1.27  1991/03/21  17:16:05  rcs
% *** empty log message ***
%
% Revision 1.26  91/03/13  07:16:12  rcs
% *** empty log message ***
% 
% Revision 1.25  90/11/29  18:44:48  rcs
% *** empty log message ***
% 
% Revision 1.24  90/11/09  17:23:47  rcs
% *** empty log message ***
% 
% Revision 1.23  90/10/10  22:45:01  rcs
% new widget names
% 
% Revision 1.22  90/10/10  16:58:13  rm
% new sat names
% 
% Revision 1.21  90/10/09  22:17:55  rcs
% new sat attribute names & generic editor stuff
% 
% Revision 1.20  90/08/29  21:54:19  rcs
% *** empty log message ***
% 
% Revision 1.19  90/08/27  20:44:43  rcs
% *** empty log message ***
% 
% Revision 1.18  90/08/22  18:27:49  rcs
% *** empty log message ***
% 
% Revision 1.17  90/07/02  23:28:35  rcs
% *** empty log message ***
% 
% Revision 1.16  90/06/25  19:36:46  rcs
% *** empty log message ***
% 
% Revision 1.15  90/06/18  12:02:34  rcs
% update integ
% 
% Revision 1.14  90/05/10  12:53:57  rcs
% *** empty log message ***
% 
% Revision 1.13  90/03/23  14:20:22  rcs
% *** empty log message ***
% 
% Revision 1.12  90/03/19  11:17:39  rcs
% oops, wrong planet
% 
% Revision 1.11  90/03/14  10:50:43  rcs
% fixed compilation bug
% 
% Revision 1.10  90/03/14  08:42:01  rm
% commented out allow_resize
% 
% Revision 1.9  90/03/08  14:55:11  rm
% new I added the font attribute for label & textBuffer
% 
% Revision 1.7  90/02/28  11:44:49  rcs
% added the motif stuff, maybe fixed a few things
% 
% Revision 1.6  89/12/22  15:17:18  trm
% no changes.
% 
% Revision 1.5  89/12/20  15:04:46  trm
% changed editable_title_bar to accept methods 
% instead of having a fixed method. also, some
% x-y attributes made to depend on vert-horiz.
% 
% Revision 1.4  89/12/18  11:49:39  rcs
% made x and y dependent on horiz, vert in button macro
% 
% Revision 1.3  89/12/14  08:13:16  trm
% some more integration adjustments.
% 
% Revision 1.2  89/12/08  16:08:42  trm
% added (fvalue = "") to editable_title_bar.
% 
% Revision 1.1  89/11/29  09:39:52  trm
% Initial revision
% 
% Revision 1.3  89/10/12  11:13:48  trm
% took out menu2 and menu3 macros. not needed.
% 
% Revision 1.2  89/10/06  17:01:49  rcs
% nothing here either
% actually, i removed duplicate defines
% 
% Revision 1.1  89/09/28  13:33:25  rcs
% Initial revision
% 
|
\*--------------------------------------------------------------------------*\
|
|   Distribution: Approved for public release; distribution is unlimited.
|
|   Copyright (c) 1989  by  Carnegie  Mellon  University, Pittsburgh, PA.  The
|  Software Engineering  Institute  (SEI) is a federally  funded  research and
|  development center established  and  operated by Carnegie Mellon University
|  (CMU).  Sponsored  by  the  U.S.  Department  of   Defense  under  contract
|  F19628-85-C-0003,  the  SEI  is  supported  by  the  services  and  defense
|  agencies, with the U.S. Air Force as the executive contracting agent.
|
|    Permission to use,  copy,  modify, or  distribute  this  software and its
|  documentation for  any purpose and without fee  is hereby granted, provided
|  that  the above copyright notice appear  in  all copies and that both  that
|  copyright  notice  and   this  permission  notice  appear   in   supporting
|  documentation.   Further,  the  names  Software  Engineering  Institute  or
|  Carnegie  Mellon  University  may  not be used in  advertising or publicity
|  pertaining to distribution of the software without specific, written  prior
|  permission.  CMU makes no claims  or representations  about the suitability
|  of this software for any purpose.  This software is provided "as is" and no
|  warranty,  express  or  implied,  is  made  by  the  SEI  or CMU, as to the
|  accuracy  and  functioning of the program and related program material, nor
|  shall   the  fact of  distribution   constitute  any   such  warranty.   No
|  responsibility is assumed by the SEI or CMU in connection herewith.
|
\*--------------------------------------------------------------------------*/

/*--------------------------------------------------------------------------*\
|
|  Macro:  DEBUG
|
|  Description:
|     The DEBUG macros allow three levels of debug.  DEBUG1 is used
|     for to print error conditions, DEBUG2 is used to print out 
|     control flow messages, and DEBUG3 is used to print random debug 
|     messages.
| 
|  Definition:								     */

#ifndef NDEBUG

#define SERPENT_DEBUG1(flag,statements)\
  if(flag > 0) then\
    statement;\
    sflush(SSTDOUT);\
  end if;

#define SERPENT_DEBUG2(flag,statement)\
  if(flag > 1) then\
    statement;\
    sflush(SSTDOUT);\
  end if;

#define SERPENT_DEBUG3(flag,statement)\
  if(flag > 2) then\
    statement;\
    sflush(SSTDOUT);\
  end if;

#else

#define SERPENT_DEBUG1(flag,statement)
#define SERPENT_DEBUG2(flag,statement)
#define SERPENT_DEBUG3(flag,statement)

#endif

/*
|  Parameters:
|     statements - a list of statements to be executed if debug is on.
|
\*--------------------------------------------------------------------------*/

/*--------------------------------------------------------------------------*\
|  Macros: data access
|
|  Description:
|    The following macros are used to get/put variables in specific,
|    often referenced locations.  This will become obsolete when dot
|    notation arrives.
\*--------------------------------------------------------------------------*/
#define get_local(variable) get_variable_value(get_parent_vc(SELF),"variable")
#define put_local(variable,value)\
	put_variable_value(get_parent_vc(SELF),"variable",value)

#define get_grandparent(thing) get_parent_vc(get_parent_vc(thing))
#define get_great_grandparent(thing)\
	get_parent_vc(get_parent_vc(get_parent_vc(thing)))

#define get_one_up(variable)\
	get_variable_value(get_grandparent(SELF),"variable")
#define put_one_up(variable,value)\
	put_variable_value(get_grandparent(SELF),"variable",valu

/*--------------------------------------------------------------------------*\
|  Macro: button
|
|  Description:
|    Creates a button object.
\*--------------------------------------------------------------------------*/
#define button(name,parent_id,vertical_distance,down_from,horizontal_distance,away_from,text,method)\
name: XawCommand {\
  Attributes:\
    parent: parent_id;\
    vertDistance: vertical_distance;\
    y: vertDistance;\
    fromVert: down_from;\
    horizDistance: horizontal_distance;\
    x: horizDistance;\
    fromHoriz: away_from;\
    label: text;\
    width: 50;\
    height: 20;\
  Methods:\
    notify: method\
}

/*--------------------------------------------------------------------------*\
|  Macro: new_button
|
|  Description:
|    Creates a button object that uses absolute positions from parent.
\*--------------------------------------------------------------------------*/
#define new_button(name,fparent,xpos,ypos,text,method)\
name: XawCommand {\
Attributes:\
    parent: fparent;\
    horizDistance: xpos;\
    vertDistance: ypos;\
    x: horizDistance;\
    y: vertDistance;\
    label: text;\
    width: 50;\
    height: 20;\
  Methods:\
    notify: method\
}

/*--------------------------------------------------------------------------*\
|  Macro: sensitive_button
|
|  Description:
|    Creates a button object that uses absolute positions from parent 
|    and is sensitive.
\*--------------------------------------------------------------------------*/
#define sensitive_button(name,fparent,sensitivity,xpos,ypos,text,method)\
name: XawCommand {\
  Attributes:\
    parent: fparent;\
    sensitive: sensitivity; \
    horizDistance: xpos;\
    vertDistance: ypos;\
    x: horizDistance;\
    y: vertDistance;\
    label: text;\
    width: 50;\
    height: 20;\
  Methods:\
    notify: method\
}

/*--------------------------------------------------------------------------*\
|  Macro: error_button
|
|  Description:
|    Creates a button that uses absolute positions from parent and error
|    hilighting.
\*--------------------------------------------------------------------------*/
#define error_button(name,fparent,xpos,ypos,text,method)\
name: XawCommand {\
Attributes:\
    parent: fparent;\
    vertDistance: ypos;\
    horizDistance: xpos;\
    label: text;\
    width: 50;\
    height: 20;\
    borderColor: error_border_color; \
    background: error_background_color; \
    foreground: error_foreground_color; \
  Methods:\
    notify: method\
}

/*--------------------------------------------------------------------------*\
|  Macro: big_button
|
|  Description:
|    Creates a slightly larger button object.
\*--------------------------------------------------------------------------*/
#define big_button(name,parent_id,vertical_distance,down_from,horizontal_distance,away_from,text,method)\
name: XawCommand {\
  Attributes:\
    parent: parent_id;\
    vertDistance: vertical_distance;\
    fromVert: down_from;\
    horizDistance: horizontal_distance;\
    fromHoriz: away_from;\
    label: text;\
    width: 60;\
    height: 20;\
  Methods:\
    notify: method\
}

/*--------------------------------------------------------------------------*\
|  Macro: big_button
|
|  Description:
|    Creates a slightly larger button object.
\*--------------------------------------------------------------------------*/
#define new_big_button(name,parent_id,xpos,ypos,text,method)\
name: XawCommand {\
  Attributes:\
    parent: parent_id;\
    horizDistance: xpos;\
    vertDistance: ypos;\
    label: text;\
    width: 60;\
    height: 20;\
  Methods:\
    notify: method\
}

/*--------------------------------------------------------------------------*\
|  Macro: menu_item
|
|  Description:
|    Creates a menu item object.
|
| Definition:                                                              */

#define menu_item(name,parent_id,position,text,method)\
  name: XawCommand {\
    Attributes:\
      parent: parent_id;\
      vertDistance: (position) * 20;\
      label: text;\
      y: vertDistance;\
      width: 148;\
      height: 18;\
      borderColor: "white";\
      horizDistance: 0;\
      justify: LEFT;\
    Methods:\
      notify: method\
  }

/*
\*--------------------------------------------------------------------------*/

/*--------------------------------------------------------------------------*\
|  Macro: menu_entry
|
|  Description:
|    Creates a menu item object.
|
| Definition:                                                              */

#define menu_entry(name,parent_id,text,method)\
  name: XawCommand {\
    Attributes:\
      parent: parent_id;\
      label: text;\
      width: 130;\
      horizDistance: 0;\
      height: 18;\
      borderColor: "white";\
      resize: false;\
      justify: LEFT;\
    Methods:\
      notify: method\
  }

/*
\*--------------------------------------------------------------------------*/

/*--------------------------------------------------------------------------*\
|  Macro: fast_menu_entry
|
|  Description:
|    Creates a menu item object.
|
| Definition:                                                              */

#define fast_menu_entry(name,parent_id,flabel,ftext,fid,vcid,ftype,method)\
  name: XawCommand {\
    Attributes:\
      parent: parent_id;\
      label: flabel;\
      width: 130;\
      horizDistance: 0;\
      height: 18;\
      borderColor: "white";\
      resize: false;\
      justify: LEFT;\
   foreground: {\
     if (source_id = fid AND NOT subtree) then\
       foreground := "white";\
     else\
       foreground := "black";\
     end if;\
   }\
   background: {\
     if (source_id = fid AND NOT subtree) then\
       background := "black";\
     else\
       background := "white";\
     end if;\
   }\
    Methods:\
      notify: method\
      pick: {\
        subtree := false;\
        source_name := ftext;\
        source_vc_id := vcid; \
        source_id   := fid;\
        source_type := ftype;\
      }\
  }

/*
\*--------------------------------------------------------------------------*/

/*--------------------------------------------------------------------------*\
|  Macro: insert_button
|
|  Description:
|    Creates a menu item object.
|
| Definition:                                                              */

#define insert_button(name,parent_id,method)\
  name: XawCommand {\
    Attributes:\
      parent: parent_id;\
      vertDistance: 20;\
      label: "New";\
      font: "-adobe-times-*-i-*-*-12*";\
      y: vertDistance;\
      width: 100;\
      height: 16;\
      horizDistance: 24;\
    Methods:\
      notify: method\
  }

/*
\*--------------------------------------------------------------------------*/

/*--------------------------------------------------------------------------*\
|  Macro: sensitive_insert_button
|
|  Description:
|    Creates a sensitive insert button.
|
| Definition:                                                              */

#define sensitive_insert_button(name,parent_id,sensitivity,method)\
  name: XawCommand {\
    Attributes:\
      parent: parent_id;\
      horizDistance: 24;\
      vertDistance: 20;\
      x: 24;\
      y: 20;\
      label: "New";\
      font: "-adobe-times-*-i-*-*-12*";\
      sensitive: sensitivity;\
      width: 100;\
      height: 16;\
    Methods:\
      notify: method\
  }

/*
\*--------------------------------------------------------------------------*/

/*--------------------------------------------------------------------------*\
|  Macro: menu_bar_item
|
|  Description:
|    Creates an item on the main system menu bar.
|
\* Definition:                                                              */

#define menu_bar_item(name,parent_id,distance,text,method)\
  name: XawCommand {\
    Attributes:\
      parent: parent_id;\
      horizDistance: distance;\
      label: text;\
      width: 67;\
      height: 18;\
      foreground: "white";\
      background: "black";\
      vertDistance: 0;\
      justify: LEFT;\
    Methods:\
      notify: method\
  }

/*
|  Parameters:
|     name - 
|     parent_id - 
|     distance - 
|     text - 
|     method - 
\*--------------------------------------------------------------------------*/

/*--------------------------------------------------------------------------*\
|
|  Macro:  title_bar
|
|  Description:
|     The title_bar macro provides a menu bar that contains a single 
|     uneditable string.
|
\* Definition:                                                              */

#define title_bar(fname,fparent,flabel,fwidth)\
     fname/**/1: XawLabel {\
       Attributes:\
         parent: fparent;\
         borderWidth: 0;\
         background: "black";\
         foreground: "white";\
         height: 18;\
         label: flabel;\
         width: fwidth;\
         horizDistance: 1;\
         vertDistance: 1;\
         justify: LEFT;\
     }

/*
|
|  Parameters:
|     fname - The name of the objects.
|     fparent - parent (form) of the object.
|     flabel - Label text for first field.
|     fwidth - width of the label in bits.
|
\*--------------------------------------------------------------------------*/

/*--------------------------------------------------------------------------*\
|
|  Macro:  editable_title_bar
|
|  Description:
|     The editable_title_bar macro creates an editable title bar 
|     including a label widget, which displays a title, an editable field 
|     for a name, and a command button which will cause the value in the 
|     editable field to be returned.
|
|
\* Definition:                                                              */

#define editable_title_bar(fname,fparent,flabel,fwidth1,fvalue,fwidth2,dmethod)\
       fname/**/_label: XawLabel {\
	 Attributes:\
	   parent: fparent;\
	   borderWidth: 0;\
	   background: "black";\
	   foreground: "white";\
	   height: 20;\
	   label: flabel;\
	   width: fwidth1;\
	   horizDistance: 1;\
	   vertDistance: 1;\
	   justify: LEFT;\
	}\
\
	fname/**/_text: XawTextentry {\
	 Attributes:\
	   parent: fparent;\
	   borderWidth: 0;\
	   background: "black";\
	   foreground: "white";\
	   width: fwidth2;\
	   height: 20;\
	   textBuffer: set_text_name(textBuffer,fvalue); \
	   vertDistance: 1;\
	   horizDistance: fwidth1;\
	   sendBuffer: send_flag;\
	 Methods:\
	   send: dmethod\
	}
	
/*
|  Parameters:
|     fname	- unique name.
|     fparent	- parent (form) of the object.
|     flabel	- text widget label.
|     fwidth1	- width of the label in bits.
|     fvalue	- contents of editable field.
|     fwidth2	- width of the editable field.
|
\*--------------------------------------------------------------------------*/


/*--------------------------------------------------------------------------*\
|
|  Macro:  non_editable_title_bar
|
|  Description:
|     The non_editable_title_bar macro concatentates two strings into a 
|     title bar.
|
\* Definition:                                                              */

#define non_editable_bar(fname,fparent,flabel,fwidth1,fvalue,fwidth2)\
fname/*filler*/_label: XawLabel {\
 Attributes:\
   parent: fparent;\
   borderWidth: 0;\
   background: "black";\
   foreground: "white";\
   height: 20;\
   label: string_append(flabel,fvalue);\
   width: fwidth1 + fwidth2;\
   horizDistance: 1;\
   vertDistance: 1;\
   justify: LEFT;\
}
 
/*						
|  Parameters:
|     fname	- unique name.
|     fparent	- parent (form) of the object.
|     flabel	- text widget label.
|     fwidth1	- width of the label in bits.
|     fvalue	- contents of second, non-editable field.
|     fwidth2	- width of the the second field.
\*--------------------------------------------------------------------------*/

/*--------------------------------------------------------------------------*\
|
|  Macro:  get_integer_field
|
|  Description:
|     The get_integer macro gets the integer value for a grid value
|     or generates an error message if the value is illegal.
|
\* Definition:                                                              */

#define get_integer_field(name,fnext)\
  {\
    DEBUG2(\
      printf("get_integer_field:  integer = name.\n",""); \
      printf("get_integer_field:  name = %s.\n", name); \
      printf("get_integer_field:  textBuffer = %s.\n",textBuffer); \
    ) \
    if (current_focus = NULL) then\
      current_focus := SELF; \
    end if; \
    if (NOT string_is_integer(textBuffer)) then\
\
      error_flag := true; \
\
      name/**/_error := create_sd_instance("error_sdd","DM_BOX"); \
      put_sd_value(name/**/_error,"title",quotify(name)); \
      put_sd_value(name/**/_error,"message",\
        "The specified interval value is not an integer."\
      ); \
      put_sd_value(name/**/_error,"height",1); \
      put_sd_value(name/**/_error,"self",name/**/_error); \
\
      name/**/_text.background := "black"; \
      name/**/_text.foreground := "white"; \
    else\
      if (textBuffer = "") then\
        textBuffer := name; \
      else \
        name/**/_local := textBuffer; \
        DEBUG3(\
          printf("get_integer_field:  new defined value.\n",""); \
          printf("get_integer_field:  name = %s.\n",name); \
          printf("get_integer_field:  textBuffer = %s.\n",textBuffer); \
        ) \
      end if; \
      name/**/_text.background := "white"; \
      name/**/_text.foreground := "black"; \
      if (id_exists(name/**/_error)) then\
        destroy/**/_sd_instance(name/**/_error); \
      end if; \
    end if; \
\
    put_sd_value(current_focus,"font","6x13");\
    current_focus := fnext/**/_text;\
    fnext/**/_text.font := "*";\
\
    DEBUG2(\
      printf("get_integer_field:  exit.\n",""); \
    ) \
  }

/*
|  Parameters:
|     name - the attribute name.
|     fnext - id of the text object to receive text input focus
|
\*--------------------------------------------------------------------------*/

/*--------------------------------------------------------------------------*\
|  Macro: integer_field
|
|  Description:
|    The integer_field macro is used to edit any text attribute.
\*--------------------------------------------------------------------------*/
#define integer_field(fname,fparent,fhoriz,fvert,flabel,fnext)\
fname/**/_label: XawLabel {\
Attributes: \
   parent: fparent; \
   label: flabel; \
   height: 20; \
   width: 60; \
   horizDistance: fhoriz; \
   vertDistance: fvert; \
   justify: LEFT; \
   borderColor: "white"; \
}\
\
fname/**/_text: XawTextentry {\
 Attributes: \
   parent: fparent; \
   width: 50; \
   height: 20; \
   vertDistance: fvert + 2; \
   horizDistance: fhoriz + 70; \
   borderColor: "white"; \
   textBuffer: fname; \
 Methods: \
   send: get_integer_field(fname,fnext) \
   tab: { \
     put_sd_value(current_focus,"font","6x13");\
     current_focus := fnext/**/_text;\
     fnext/**/_text.font := "*";\
   }\
   focus: {\
     put_sd_value(current_focus,"font","6x13");\
     current_focus := SELF;\
     font := "*";\
   }\
}
