/* $Header: /usr/users/rcs/serpent/sun/de/src/RCS/utils2.sl,v 1.30 1991/05/17 21:14:05 rcs Exp $ */
/*--------------------------------------------------------------------------*\
|   
|  Name:  Utilities II (utils2.sl)
|
|  Description:  
|     This file contains more macros to implement various general utilites
|     in the editor dialogue paging stuff and help templates and scroll bars.
|
|  Component of:
|     Serpent editor dialogue layer.
|
|  Related files:
|     utils2.sl - contains the slang source for slang utilities.
|
|  Project:
|     Serpent
|     User Interface Project
|     Software Engineering Institute
|     Carnegie Mellon University
|     Pittsburgh, PA  15213
|
|  Version: 1.0
|
|  Project Leader:  
|     Len Bass
|     ljb@sei.cmu.edu
|
|  Author:  
|     Robert C. Seacord
|     rcs@sei.cmu.edu  
|
|  Change History:
|	Feb. 24, 1989 : Module created.
|	$Log: utils2.sl,v $
% Revision 1.30  1991/05/17  21:14:05  rcs
% *** empty log message ***
%
% Revision 1.29  1991/03/21  17:16:22  rcs
% *** empty log message ***
%
% Revision 1.28  91/03/19  20:02:14  rcs
% nuthin that i can remember
% 
% Revision 1.27  90/11/29  18:46:44  rcs
% *** empty log message ***
% 
% Revision 1.26  90/11/09  17:24:04  rcs
% *** empty log message ***
% 
% Revision 1.25  90/10/10  22:45:38  rcs
% new widget names
% 
% Revision 1.24  90/10/10  16:59:15  rm
% new sat names
% 
% Revision 1.23  90/10/09  22:21:30  rcs
% new sat attribute names & generic editor stuff
% 
% Revision 1.22  90/09/19  23:37:36  rcs
% fixed geometry
% 
% Revision 1.21  90/08/29  21:55:13  rcs
% *** empty log message ***
% 
% Revision 1.20  90/08/27  21:22:17  rcs
% *** empty log message ***
% 
% Revision 1.19  90/08/27  20:44:03  rcs
% *** empty log message ***
% 
% Revision 1.17  90/08/22  18:28:05  rcs
% *** empty log message ***
% 
% Revision 1.16  90/07/02  23:29:15  rcs
% *** empty log message ***
% 
% Revision 1.15  90/06/25  19:37:06  rcs
% *** empty log message ***
% 
% Revision 1.14  90/06/18  12:03:04  rcs
% update integ
% 
% Revision 1.13  90/05/10  12:54:14  rcs
% *** empty log message ***
% 
% Revision 1.12  90/03/19  11:18:15  rcs
% position of help template
% 
% Revision 1.11  90/03/14  08:43:04  rm
% no need to check out
% 
% Revision 1.10  90/03/08  15:07:32  rm
% added font attribute for label & textBuffer
% 
% Revision 1.9  90/02/28  11:45:16  rcs
% i dunno
% 
% Revision 1.8  90/01/09  16:40:47  trm
% temporarily took out text_template to 
% work around a compile problem.
% 
% Revision 1.7  90/01/09  15:01:18  trm
% got rid of the "create_text" template, and
% added text_template to take place of text_sdd.
% 
% Revision 1.6  90/01/04  18:01:38  dvk
% In all slang/sdd files as a result of lexer/parser changes: 1) Changed
% all instances of "else if" to "elsif".  2) Changed variables named "create"
% to "create_it" or "create_btn" as needed ("create" is now a reserved word).
% 
% Revision 1.5  89/12/22  15:18:07  trm
% added create_text_sdd macro, but haven't 
% used it yet.
% 
% Revision 1.3  89/12/14  08:13:45  trm
% some more integration adjustments.
% 
% Revision 1.2  89/12/08  16:08:07  trm
% added several macros.
% 
% Revision 1.1  89/11/29  09:42:51  trm
% Initial revision
% 
% Revision 1.3  89/10/13  11:04:05  trm
% added set_error macro.
% 
% Revision 1.2  89/10/05  15:43:57  trm
% added macros for scroll (paging) and attr_vc stuff.
% 
|
\*--------------------------------------------------------------------------*\
|
|   Distribution: Approved for public release; distribution is unlimited.
|
|   Copyright (c) 1989  by  Carnegie  Mellon  University, Pittsburgh, PA.  The
|  Software Engineering  Institute  (SEI) is a federally  funded  research and
|  development center established  and  operated by Carnegie Mellon University
|  (CMU).  Sponsored  by  the  U.S.  Department  of   Defense  under  contract
|  F19628-85-C-0003,  the  SEI  is  supported  by  the  services  and  defense
|  agencies, with the U.S. Air Force as the executive contracting agent.
|
|    Permission to use,  copy,  modify, or  distribute  this  software and its
|  documentation for  any purpose and without fee  is hereby granted, provided
|  that  the above copyright notice appear  in  all copies and that both  that
|  copyright  notice  and   this  permission  notice  appear   in   supporting
|  documentation.   Further,  the  names  Software  Engineering  Institute  or
|  Carnegie  Mellon  University  may  not be used in  advertising or publicity
|  pertaining to distribution of the software without specific, written  prior
|  permission.  CMU makes no claims  or representations  about the suitability
|  of this software for any purpose.  This software is provided "as is" and no
|  warranty,  express  or  implied,  is  made  by  the  SEI  or CMU, as to the
|  accuracy  and  functioning of the program and related program material, nor
|  shall   the  fact of  distribution   constitute  any   such  warranty.   No
|  responsibility is assumed by the SEI or CMU in connection herewith.
|
\*--------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------*\
|   
|  Macro:  help_template
|
|  Description:  
|     The help_template provides the base form for help information.
|
|  Definition:								   */

#define set_color(fhilite, fcolor, monochrome) \
  { \
      if (display.color) then \
        fhilite/**/_color := fcolor; \
      else \
        fhilite/**/_color := monochrome; \
      end if; \
  }

/*						
|  Parameters:
|     fhilite - type of hiliting.
|     fcolor - color to use for color diplays
|     monochrome - color to use for monochrome displays (black or white)
\*--------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------*\
|   
|  Macro:  help_template
|
|  Description:  
|     The help_template provides the base form for help information.
|
|  Definition:								   */

#define help_template(fvar,flabel,ftext,ftext_height)\
  VC : fvar/**/_vc\
\
  Creation Condition : (fvar)\
\
  Objects:\
\
    fvar/**/_form: XawBboard {\
      Attributes:\
        parent: workspace;\
        width: 504;\
        height: ftext_height + 102;\
        allowUserMove: true;\
        horizDistance: 300;\
        vertDistance: 200;\
    }\
\
    fvar/**/_title: XawLabel {\
      Attributes:\
        parent: fvar/**/_form;\
        background: "black";\
        foreground: "white";\
        height: 18;\
        label: flabel;\
        width: 500;\
        horizDistance: 1;\
        vertDistance: 1;\
        justify: CENTER;\
    }\
\
    fvar/**/_text: XawText {\
      Attributes:\
        parent: fvar/**/_form;\
        borderColor: "white";\
        textBuffer: ftext;\
        vertDistance: 40;\
        horizDistance: 40;\
        editType: READ;\
        width: 420;\
        height: ftext_height;\
    }\
\
    button(\
      ok_button,\
      fvar/**/_form,\
      ftext_height + 60,	/* distance from top of form	*/\
      NULL,\
      225,	/* distance from left edge of form  */\
      NULL,\
      "OK",\
      {\
        fvar := false;\
      }\
    )\
\
end VC fvar/**/_vc

/*
\*-------------------------------------------------------------------------*/

/*--------------------------------------------------------------------------*\
|  Macro: select_item
|
|  Description:
|    Creates a selectable menu item object.
\*--------------------------------------------------------------------------*/
#define select_item(name,parent_id,position,text,selectable,smethod)\
name/**/_select_button: XawCommand {\
  Attributes:\
    parent: parent_id;\
    vertDistance: position * 20 + 10;\
    label: {\
      if (selectable) then\
        label := "X";\
      else\
        label := "";\
      end if;\
    }\
    width: 14;\
    height: 14;\
    horizDistance: 5;\
    justify: LEFT;\
  Methods:\
    notify:  smethod \
}\
\
name/**/_label: XawLabel {\
  Attributes:\
    parent: parent_id;\
    vertDistance: position * 20 + 10;\
    label: text;\
    width: 168;\
    height: 18;\
    borderColor: "white";\
    horizDistance: 30;\
    justify: LEFT;\
}

/*--------------------------------------------------------------------------*\
|  Macro: set_error
|
|  Description:
|    Creates a error_sdd to be displayed.
|
|  Parameters:
|     err_msg	    - the error message
|     err_title	    - the error form title
|     err_id  	    - variable to contain id of error_sdd
|     err_flag      - variable to set to indicat error_sdd created
\*--------------------------------------------------------------------------*/
#define set_error(err_msg,err_title,err_id,err_flag)\
  err_flag := true; \
  err_id := create_sd_instance("error_sdd","DM_BOX"); \
  put_sd_value(err_id,"title",err_title); \
  put_sd_value(err_id,"message",err_msg); \
  put_sd_value(err_id,"height",string_count_chars(err_msg,"\n") + 1);\
  put_sd_value(err_id,"self",err_id);

/*--------------------------------------------------------------------------*\
|  Macro: make_command
|
|  Description:
|    Used to create a command_sdd and the first parameter since most 
|    commands only need the one parameter.
|
|    ??? type and self components not used by dialogue
|
|  Parameters:
|     cmd_sdi     - a variable to contain the command_sdd ID.
|     cmd         - the command to pass to the application.
\*--------------------------------------------------------------------------*/
#define make_command(cmd_sdi,cmd)\
  cmd_sdi := create_sd_instance("command_sdd" ,"SE_BOX");\
  put_sd_value(cmd_sdi,"type",cmd);\
  put_sd_value(cmd_sdi,"parameters",NULL);

/*--------------------------------------------------------------------------*\
|  Macro: make_command_and_parameter
|
|  Description:
|    Used to create a command_sdd and the first parameter since most 
|    commands only need the one parameter.
|
|    ??? type and self components not used by dialogue
|
|  Parameters:
|     cmd_sdi     - a variable to contain the command_sdd ID.
|     parm_sdi    - a variable to contain the parameter_sdd ID.
|     cmd         - the command to pass to the application.
|     value       - the value to pass to the application.
\*--------------------------------------------------------------------------*/
#define make_command_and_parameter(cmd_sdi,parm_sdi,cmd,pvalue)\
  cmd_sdi := create_sd_instance("command_sdd" ,"SE_BOX");\
  put_sd_value(cmd_sdi,"type",cmd);\
  parm_sdi := create_sd_instance("parameter_sdd","SE_BOX");\
  put_sd_value(cmd_sdi,"parameters",parm_sdi);\
  put_sd_value(parm_sdi,"value",pvalue);\
  put_sd_value(parm_sdi,"next",NULL);

/*--------------------------------------------------------------------------*\
|  Macro: make_another_parameter
|
|  Description:
|    Used to create a parameter_sdd AFTER one has done a 
|    make_command_and_parameter first. (or otherwise has created such).
|
|  NOTE: ######## temp_id better be declared somewhere #########
|        ######## AND parm_sdi better be set to a valid parameter_sdd ID #####
|    ??? type and self components not used by dialogue
|
|  Parameters:
|     parm_sdi    - the ID of the previous parameter_sdd.
|     value       - the value to pass to the application.
\*--------------------------------------------------------------------------*/
#define make_another_parameter(parm_sdi,pvalue)\
  temp_id := create_sd_instance("parameter_sdd","SE_BOX");\
  put_sd_value(parm_sdi,"next",temp_id);\
  parm_sdi := temp_id;\
  put_sd_value(parm_sdi,"value",pvalue);\
  put_sd_value(parm_sdi,"next",NULL);

/*--------------------------------------------------------------------------*\
|  Macro: adjust_x_and_y_for_new_menu
|
|  Description:
|    Makes the x-y changes necessary for a new menu starting position.
|
|  Parameters:
|     xpos    - the x position
|     ypos    - the y position
\*--------------------------------------------------------------------------*/
#define adjust_x_and_y_for_new_menu(xpos,ypos)\
   if (positive_Y_direction) then\
     if ((ypos + Y_ADJUSTMENT) > (DISPLAY_HEIGHT - MAX_POSITION)) then \
       positive_Y_direction := false; \
       xpos := START_X_POSITION; \
       ypos := DISPLAY_HEIGHT - MAX_POSITION; \
     else\
       xpos := xpos + X_ADJUSTMENT; \
       ypos := ypos + Y_ADJUSTMENT; \
     endif;\
   elsif ((ypos - Y_ADJUSTMENT) < MAX_POSITION) then \
     positive_Y_direction := true; \
     xpos := START_X_POSITION; \
     ypos := START_Y_POSITION; \
   else\
     xpos := xpos + X_ADJUSTMENT; \
     ypos := ypos - Y_ADJUSTMENT; \
   endif;

/*--------------------------------------------------------------------------*\
|
|  Macro:  make_node_button
|
|  Description:
|     The make_node_button creates the Node selector button on forms.
|
\* Definition:                                                              */

#define make_node_button(fname,fparent,ftext,fid,vcid,ftype,fvert,fhoriz)\
fname/**/_node: XawCommand {\
   Attributes:\
   parent: fparent;\
   borderWidth: 1;\
   label: "N";\
   foreground: {\
     if (source_id = fid AND NOT subtree) then\
       foreground := "white";\
     else\
       foreground := "black";\
     end if;\
   }\
   background: {\
     if (source_id = fid AND NOT subtree) then\
       background := "black";\
     else\
       background := "white";\
     end if;\
   }\
   height: 20;\
   width: 20;\
   horizDistance: fhoriz;\
   vertDistance: fvert;\
  Methods:\
    notify: {\
     subtree := false;\
     source_name := ftext;\
     source_vc_id := vcid; \
     source_id   := fid;\
     source_type := ftype;\
    }\
}

/*						
|  Parameters:
|     fname	- unique name.
|     fparent	- parent (form) of the object.
|     flabel	- text widget label.
|     fwidth1	- width of the label in bits.
|     fvalue	- contents of second, non-editable field.
|     fwidth2	- width of the the second field.
\*--------------------------------------------------------------------------*/
 
/*--------------------------------------------------------------------------*\
|
|  Macro:  make_subtree_button
|
|  Description:
|     The make_node_button is something new to try.
|
\* Definition:                                                              */
#define make_subtree_button(fname,fparent,ftext,fid,vcid,ftype,fvert,fhoriz)\
\
fname/**/_subtree: XawCommand {\
 Attributes:\
   parent: fparent;\
   borderWidth: 1;\
   label: "S";\
   background: {\
     if (source_id = fid AND subtree) then\
       background := "black";\
     else\
       background := "white";\
     end if;\
   }\
   foreground: {\
     if (source_id = fid AND subtree) then\
       foreground := "white";\
     else\
       foreground := "black";\
     end if;\
   }\
   height: 20;\
   width: 20;\
   horizDistance: fhoriz;\
   vertDistance: fvert;\
  Methods:\
    notify: {\
     subtree := true;\
     source_name := ftext;\
     source_id   := fid;\
     source_vc_id := vcid; \
     source_type := ftype;\
    }\
}

/*						
|  Parameters:
|     fname	- unique name.
|     fparent	- parent (form) of the object.
|     flabel	- text widget label.
|     fwidth1	- width of the label in bits.
|     fvalue	- contents of second, non-editable field.
|     fwidth2	- width of the the second field.
\*--------------------------------------------------------------------------*/
 
/*--------------------------------------------------------------------------*\
|
|  Macro:  make_target_button
|
|  Description:
|     The make_node_button is something new to try.
|
\* Definition:                                                              */
#define make_target_button(fname,fparent,ftext,fid,ftype,fvert,fhoriz)\
\
fname/**/_target: XawCommand {\
 Attributes:\
   parent: fparent;\
   borderWidth: 1;\
   label: "T";\
   background: {\
     if (target_id = fid) then\
       background := "black";\
     else\
       background := "white";\
     end if;\
   }\
   foreground: {\
     if (target_id = fid) then\
       foreground := "white";\
     else\
       foreground := "black";\
     end if;\
   }\
   height: 20;\
   width: 20;\
   horizDistance: fhoriz;\
   vertDistance: fvert;\
  Methods:\
    notify: {\
     target_name := ftext;\
     target_id := fid;\
     target_type := ftype;\
    }\
}
	
/*						
|  Parameters:
|     fname	- unique name.
|     fparent	- parent (form) of the object.
|     flabel	- text widget label.
|     fwidth1	- width of the label in bits.
|     fvalue	- contents of second, non-editable field.
|     fwidth2	- width of the the second field.
\*--------------------------------------------------------------------------*/

/*--------------------------------------------------------------------------*\
|  Macro: sensitive_menu_item
|
|  Description:
|    Creates a sensitive menu_item.
\*--------------------------------------------------------------------------*/
#define sensitive_menu_item(name,parent_id,activate,position,text,smethod)\
name: XawCommand {\
Attributes:\
    parent: parent_id;\
    vertDistance: (position) * 20;\
    label: text;\
    width: 148;\
    height: 18;\
    borderColor: "white";\
    horizDistance: 0;\
    justify: LEFT;\
    sensitive: activate;\
    y: vertDistance;\
  Methods:\
    notify: smethod\
}

/*--------------------------------------------------------------------------*\
|  Macro: set_text_name
|
|  Description:
|    Set the {label|text}_text attribute of an object.
|
|  Parameters:
|     stext   	         - the text to use.
|     attribute_to_use   - the attribute_to_use
\*--------------------------------------------------------------------------*/
#define set_text_name(attribute_to_use,stext)\
{ \
  if ((stext = UNDEFINED) OR (stext = "" ) OR (stext = "Unnamed")) then \
    attribute_to_use := "Unnamed"; \
  else \
    attribute_to_use := stext; \
  endif; \
}

/*--------------------------------------------------------------------------*\
|  Macro: append_text_name
|
|  Description:
|    Appends back to the end of front and assigns to the specified variable
|    or attribute.
|
|  Parameters:
|     memory - the attribute or variable in which to stuff this
|     front   - front part of the string
|     back   - back part of the string
\*--------------------------------------------------------------------------*/
#define append_text_name(memory,front,back)\
{ \
  if ((back = UNDEFINED) OR (back = "" ) OR (back = "Unnamed")) then \
    memory := string_append(front,"Unnamed");\
  else \
    memory := string_append(front,back);\
  endif; \
}
 
/*-------------------------------------------------------------------------*\
|   
|  Macro:  text_template
|
|  Description:  
|     The text_template provides the base form for textual in/output to 
|     components. Another (inner) VC is also provided to give the user
|     a chance to save any changes if the textual information has not
|     been saved already.
|
|  Definition:								   */

#define text_template(display_var,title,text_body,parent_name,help_variable)\
VC: display_var/**/_text_vc\
\
    Creation condition: (display_var)\
\
    Variables: \
      save_changes: false;\
\
    Objects:\
\
      display_var/**/_text_form: XawBboard {\
        Attributes:\
          parent: workspace;\
          width: 410;\
          height: 251;\
          allowUserMove: true;\
          vertDistance: DISPLAY_HEIGHT / 2 - height / 2;\
          horizDistance: DISPLAY_WIDTH / 2 - width / 2;\
      }\
\
      title_bar(\
        text_title,\
        display_var/**/_text_form,\
        append_text_name(label,title, parent_name),\
        408\
      )\
\
      display_var/**/_text: XawText {\
        Attributes:\
          parent: display_var/**/_text_form;\
          width: 400;\
          height: 168;\
          vertDistance: 23;\
          textBuffer: text_body; \
        Methods:\
          send: {\
/*   Return text buffer in specified location. */\
\
	      text_body := textBuffer;\
\
/* Set the displayed variable to false so this text can be selected again. */\
              display_var := false;\
          }\
      }\
\
      button(\
        ok_button,\
        display_var/**/_text_form,\
        20,\
        display_var/**/_text,\
        105,\
        NULL,\
        "OK",\
        {\
          display_var/**/_text.sendBuffer := 1;\
          dialogue_changed:= true;\
          message := ""; \
        }\
      )\
\
       button(\
        cancel_button,\
        display_var/**/_text_form,\
        20,\
        display_var/**/_text,\
        175,\
        NULL,\
        "Cancel",\
        {\
/* Set the displayed variable to false so this text can be selected again. */\
          display_var := false;\
          message := ""; \
        }\
      )\
\
       button(\
        help_button,\
        display_var/**/_text_form,\
        20,\
        display_var/**/_text,\
        245,\
        NULL,\
        "Help",\
        {\
          help_variable := true;\
          message := ""; \
        }\
      )\
\
      On Destroy: {\
/* If the display_var is still set, but the VC is going to be */\
/*   destroyed, then give user a chance to save any changes.         */\
        if (display_var) then \
          save_changes := true; \
        endif; \
      }\
\
end VC display_var/**/_text_vc
 

