/* $Header: /usr/users/rnk/RCS/ve.sl,v 1.29 1991/06/21 19:39:17 rnk Exp $ */
/*--------------------------------------------------------------------------*\
|   
|  Name:  Visuation Editor (ve)
|
|  Description:  
|     This file contains the  implementation for the visualization
|     editor.
|     
|  Component of:
|     Serpent editor dialogue layer.
|
|  Related files:
|     de.slang - contains the slang source for the serpent editor.
|
|  Project:
|     Serpent
|     User Interface Project
|     Software Engineering Institute
|     Carnegie Mellon University
|     Pittsburgh, PA  15213
|
|  Version: 1.0
|
|  Project Leader:  
|     Len Bass
|     ljb@sei.cmu.edu
|
|  Author:  
|     Robert C. Seacord
|     rcs@sei.cmu.edu  
|
|  Change History:
|       $Log: ve.sl,v $
% Revision 1.29  1991/06/21  19:39:17  rnk
% changed xmtoplevelshell to xmapplicationshell
%
% Revision 1.28  1991/05/16  14:24:48  ljb
% do not create object if error in object type
%
% Revision 1.27  1991/05/10  18:41:52  ljb
% no change
%
% Revision 1.26  1991/04/26  15:50:52  rcs
% use de_techs instead of techs
% fixed problem creating attribute list
%
% Revision 1.25  1991/04/11  15:21:56  ljb
% change so that pick method works to place object on background bb
%
% Revision 1.24  1991/03/21  17:16:39  rcs
% *** empty log message ***
%
% Revision 1.23  91/03/13  07:15:43  rcs
% checkin 
% 
% Revision 1.22  91/02/05  13:59:41  rm
% fixed bugs with select and pick
% 
% Revision 1.21  91/02/04  13:35:43  rm
% added fs_attr to create shared data valued so display could be updated
% 
% Revision 1.20  91/02/04  12:59:13  rm
% changed to support pick method
% 
% Revision 1.19  90/11/29  18:47:04  rcs
% *** empty log message ***
% 
% Revision 1.18  90/11/09  17:24:24  rcs
% *** empty log message ***
% 
% Revision 1.17  90/10/10  22:46:38  rcs
% new widget names
% 
% Revision 1.16  90/10/09  22:22:29  rcs
% new sat attribute names & generic editor stuff
% 
% Revision 1.15  90/09/25  21:39:22  rcs
% fixed staging problem
% 
% Revision 1.14  90/09/17  21:42:27  rcs
% *** empty log message ***
% 
% Revision 1.13  90/09/11  20:37:46  rcs
% *** empty log message ***
% 
% Revision 1.12  90/08/30  21:34:28  rcs
% *** empty log message ***
% 
% Revision 1.11  90/08/29  21:56:47  rcs
% *** empty log message ***
% 
% Revision 1.10  90/08/22  18:28:21  rcs
% *** empty log message ***
% 
% Revision 1.9  90/07/02  23:29:38  rcs
% *** empty log message ***
% 
% Revision 1.8  90/06/25  19:38:57  rcs
% *** empty log message ***
% 
% Revision 1.7  90/05/22  15:30:08  rcs
% changes to support color editor
% 
% Revision 1.6  90/05/14  22:38:22  rcs
% *** empty log message ***
% 
% Revision 1.5  90/05/10  17:53:21  rm
% 
% added include for ce_editor.sl
% 
% 
% Revision 1.4  90/05/09  11:23:41  rcs
% roger, over.
% 
% Revision 1.3  90/02/28  11:45:56  rcs
% i'm not even sure this file is being used
% 
% Revision 1.2  90/01/04  18:01:57  dvk
% In all slang/sdd files as a result of lexer/parser changes: 1) Changed
% all instances of "else if" to "elsif".  2) Changed variables named "create"
% to "create_it" or "create_btn" as needed ("create" is now a reserved word).
% 
% Revision 1.1  89/11/29  09:43:17  trm
% Initial revision
% 
% Revision 1.2  89/10/06  17:04:32  rcs
% i don't know
% 
% Revision 1.1  89/09/28  13:34:30  rcs
% Initial revision
% 
|       Revision 1.3  89/06/20  14:22:17  rcs
|       modified ve to work as editor component vs stand alone
| 
|       Revision 1.2  89/06/19  16:24:18  ljb
|       fix up rcs header
|
|	Feb. 24, 1989 : Module created.
|
\*--------------------------------------------------------------------------*\
|
|   Distribution: Approved for public release; distribution is unlimited.
|
|   Copyright (c) 1989  by  Carnegie  Mellon  University, Pittsburgh, PA.  The
|  Software Engineering  Institute  (SEI) is a federally  funded  research and
|  development center established  and  operated by Carnegie Mellon University
|  (CMU).  Sponsored  by  the  U.S.  Department  of   Defense  under  contract
|  F19628-85-C-0003,  the  SEI  is  supported  by  the  services  and  defense
|  agencies, with the U.S. Air Force as the executive contracting agent.
|
|    Permission to use,  copy,  modify, or  distribute  this  software and its
|  documentation for  any purpose and without fee  is hereby granted, provided
|  that  the above copyright notice appear  in  all copies and that both  that
|  copyright  notice  and   this  permission  notice  appear   in   supporting
|  documentation.   Further,  the  names  Software  Engineering  Institute  or
|  Carnegie  Mellon  University  may  not be used in  advertising or publicity
|  pertaining to distribution of the software without specific, written  prior
|  permission.  CMU makes no claims  or representations  about the suitability
|  of this software for any purpose.  This software is provided "as is" and no
|  warranty,  express  or  implied,  is  made  by  the  SEI  or CMU, as to the
|  accuracy  and  functioning of the program and related program material, nor
|  shall   the  fact of  distribution   constitute  any   such  warranty.   No
|  responsibility is assumed by the SEI or CMU in connection herewith.
|
\*--------------------------------------------------------------------------*/

#undef DEBUG1
#undef DEBUG2
#undef DEBUG3

#define DEBUG1(statement) SERPENT_DEBUG1(ve_debug, statement)
#define DEBUG2(statement) SERPENT_DEBUG2(ve_debug, statement)
#define DEBUG3(statement) SERPENT_DEBUG3(ve_debug, statement)

#define width_default 70
#define height_default 35

#include "gt_type.h"

/*--------------------------------------------------------------------------*\
|  Name: ve_vc
|
|  Description:
|    The ve_vc is used to control the use of the visulation editor.
|    The visulation editor can be turned on and off from the
|    main system menu.  
\*--------------------------------------------------------------------------*/
VC: ve_vc

  Creation Condition : (new("visualize_sdd"))

  Variables:

    x_attr_value;		/* these are used to position attribute */
    y_attr_value;		/*   forms			 	*/

    x_position: START_X_POSITION;
    y_position: START_Y_POSITION;
/* 
** Variables required for color editor 
*/
    ce_editor: FALSE;
    ce_attr;
    ce_object;
    ce_object_id;
    ce_attr_id;
    ce_object_instance_id;
/*
**  Variables required for font selector.
*/
    fontsel: FALSE;		/* turn selector on/off		*/
    fs_attr;
    fs_object;			/* object for which font is being selected */
    fs_object_id;		/* id of object	*/
    fs_attr_id;			/* id of font attribute	*/
    fs_object_instance_id;
/* 
**  Used to determine if parent needs to be re-evaluated.
*/
    reparenting_list: NULL;
/* 
**  Used to store the technology handle of the technology for which
**  this instantiation of the visualization editor was created.
*/
    technology_mailbox;
    parent_technology: visualize_sdd.tech;
    technology_handle;
    attribute_handle;
    attribute_list;
    attribute;
/*
**  Object ids for visualization area objects.
*/
    bboard_id;
    shell_id;

    create_object_flag;
    temp_name;
    id_table;
/*
**  Select method for the top level bboard.
*/
    select_method: {
      DEBUG3(printf("select_method var:  invoked with value %s.\n", get_sd_value(bboard_id,"method")))
/*
** Select method.
*/
      if (get_sd_value(bboard_id,"method") = "select" or
          get_sd_value(bboard_id,"method") = "pick") then      
/*
**  Set method to undefined so this doesn't execute again.
*/
        put_sd_value(bboard_id,"method",UNDEFINED);

        DEBUG3(printf("select_method var:  select method.\n", ""))
/*
** If toolbox_object_type is defined, draw an object otherwise ignore.
*/
        if (toolbox_object_type <> UNDEFINED) then
          DEBUG3(printf("select_method var:  object not undefined.\n", ""))
/*
**   Create the object and get the head of the attribute list.
*/
          create_object(bboard_id);
          DEBUG3(printf("select_method var:  object created.\n", ""))

          if (create_object_flag) then
             attribute := get_alist_next(attribute_list, C_NULL);
/*
**  Make sure the first attribute is linked to the object instance sdd.
*/
             temp_name := glue_get_attribute_name(attribute);

             create_attr(temp_name,object_instance_sdi,
               glue_get_attribute_xtype(attribute),
               glue_get_attribute_priority(attribute),
               "NULL",object_instance_sdi,
               current_id)

             attribute := get_alist_next(attribute_list, attribute);	    
/*
**  Define the remainder of the attributes.
*/
             while (attribute <> C_NULL) do

               previous_id := current_id;
               temp_name := glue_get_attribute_name(attribute);

               create_attr(temp_name,object_instance_sdi,
                 glue_get_attribute_xtype(attribute),
                 glue_get_attribute_priority(attribute),
	         "NULL",previous_id,current_id)

               attribute := get_alist_next(attribute_list, attribute);	    

             end while;
/*
**  Null terminate the list.
*/
            put_sd_value(current_id, "attr_list", NULL);

          end if;      /* end if object is valid type to be created */
 
        end if;        /* end if object type defined                   */

      end if; 		/* end if select method	                   */

      DEBUG3(printf("select_method var:  exiting.\n", ""))

    }

  On Create: {
/*
**  Create the shell widget and top level form based on the technology type 
**  and load the technology definitions.
*/
    if (visualize_sdd.tech = "sat") then

      sat_handle := glue_get_technology("de_sat");
      technology_handle := sat_handle;
      technology_mailbox := "SAT_BOX";      

      shell_id := create_sd_instance("xawtoplevelshell", "SAT_BOX");

      bboard_id := create_sd_instance("xawbboard", "SAT_BOX");
      put_sd_value(shell_id, "title", "Athena Visualization Area");
/*
**  If technology type is smo create smo widgets.
*/
    elsif (visualize_sdd.tech = "smo") then

      smo_handle := glue_get_technology("de_smo");
      technology_handle := smo_handle;
      technology_mailbox := "SMO_BOX";

      shell_id := create_sd_instance("xmapplicationshell", "SMO_BOX");

      bboard_id := create_sd_instance("xmbulletinboard", "SMO_BOX");
      put_sd_value(bboard_id, "resizepolicy", false);
      put_sd_value(shell_id, "title", "Motif Visualization Area");
/*
**  Error condition.
*/
    else
      printf("ve_vc: unknown technology in On Create for.\n", "");
    end if;
/*
**  Attributes common to both technologies.
*/
    put_sd_value(shell_id, "iconname", "Serpent");
    put_sd_value(shell_id, "iconpixmap", "ve_bitmap");

    put_sd_value(bboard_id, "parent", shell_id);
    put_sd_value(bboard_id, "width", display.width/2);
    put_sd_value(bboard_id, "height", display.height/2);
    put_sd_value(bboard_id, "bordercolor", "white");

  }

  On Destroy: {
    destroy_sd_instance(shell_id);
    destroy_sd_instance(bboard_id);
  }

/*----- Include the source code for generic widget visualization -----------*/

#include "gw.sl"

/*----- Include the source code for the color editor -----------------------*/

#include "ce_editor.sl"

/*----- Include the source code for the font selector ----------------------*/

#include "fontsel.sl"

end VC ve_vc;
