/* $Header: /usr/users/rcs/serpent/source/de/src/RCS/ve_macros.sl,v 1.52 1991/06/19 20:01:32 rcs Exp $ */
/*--------------------------------------------------------------------------*\
|   
|  Name:  Visulatization Macros (ve_macros.sl)
|
|  Description:  
|     This file contains macros to support the visualization editor.
|
|  Component of:
|     Serpent editor dialogue layer.
|
|  Related files:
|     ve_macros.sl - contains the slang source for slang utilities.
|
|  Project:
|     Serpent
|     User Interface Project
|     Software Engineering Institute
|     Carnegie Mellon University
|     Pittsburgh, PA  15213
|
|  Version: 1.0
|
|  Project Leader:  
|     Len Bass
|     ljb@sei.cmu.edu
|
|  Author:  
|     Robert C. Seacord
|     rcs@sei.cmu.edu  
|
|  Change History:
|	Feb. 24, 1989 : Module created.
|	$Log: ve_macros.sl,v $
% Revision 1.52  1991/06/19  20:01:32  rcs
% updated for motif 1.1 defines
%
% Revision 1.51  1991/05/17  21:14:42  rcs
% *** empty log message ***
%
% Revision 1.50  1991/05/17  14:10:26  ljb
% prevent visualization of several more object types
%
% Revision 1.49  1991/05/16  19:52:32  ljb
% set error flag for xawsmeline
%
% Revision 1.48  1991/05/16  19:47:23  ljb
% set error if simplemenu
%
% Revision 1.47  1991/05/16  18:47:14  ljb
% no change
%
% Revision 1.46  1991/05/16  14:37:12  ljb
% set flag about whether object can be created
% put in hack to not display xawsimplemenubsb
%
% Revision 1.45  1991/05/15  19:12:02  rcs
% played with size of attribute labels
%
% Revision 1.44  1991/05/10  18:43:45  ljb
% set test for non widget
%
% Revision 1.43  1991/05/09  19:56:53  ljb
% turn off help stuff
%
% Revision 1.42  1991/04/23  17:58:51  ljb
% add macros to support change background to form rather than box
%
% Revision 1.41  1991/04/11  18:07:18  rcs
% *** empty log message ***
%
% Revision 1.40  91/03/21  17:16:54  rcs
% *** empty log message ***
% 
% Revision 1.39  91/03/19  20:01:22  rcs
% tried to prevent creation of shell widgets
% 
% Revision 1.38  91/03/13  07:16:30  rcs
% *** empty log message ***
% 
% Revision 1.37  91/01/31  10:18:11  rm
% changed title bar for edit attributes form
% 
% Revision 1.36  91/01/31  10:14:11  rm
% changed with of edit attribute box and label
% 
% Revision 1.35  90/12/05  19:12:27  rcs
% added mailbox field to object instance
% 
% Revision 1.34  90/11/29  18:47:24  rcs
% *** empty log message ***
% 
% Revision 1.33  90/11/09  17:25:47  rcs
% *** empty log message ***
% 
% Revision 1.32  90/10/10  22:47:03  rcs
% new widget names
% 
% Revision 1.31  90/10/09  22:21:59  rcs
% new sat attribute names & generic editor stuff
% 
% Revision 1.30  90/10/04  19:46:10  clc
% changed change_x_coordinate macro to change_snapped_coordinate
% changed change_y_coordinate macro to change_snapped_coordinate
% 
% Revision 1.29  90/09/25  21:39:47  rcs
% *** empty log message ***
% 
% Revision 1.28  90/09/21  00:07:49  rcs
%  fixed parent instantiation order problem
% 
% Revision 1.27  90/09/19  23:41:39  rcs
% fixed geometry
% 
% Revision 1.26  90/09/19  17:15:02  rm
% changed attribute_title_bar from 20 to 18
% 
% Revision 1.18  90/05/22  15:33:10  rcs
% changes to support color editor
% 
% Revision 1.13  90/03/16  14:45:39  rm
% more work on help
% 
% Revision 1.12  90/03/16  13:50:50  rm
% fix help stuf
% 
% Revision 1.7  90/03/15  10:47:17  rm
% changed macros get_string_attr & change_attribute
% 
% Revision 1.6  90/03/14  10:29:16  rcs
% new coordinate macros
% 
% Revision 1.5  90/03/08  15:26:27  rcs
% changed coordinate stuff
% 
% Revision 1.3  90/02/28  11:46:48  rcs
% changes to support coordinates plus lots of new macros
% 
% Revision 1.2  90/01/04  18:02:13  dvk
% In all slang/sdd files as a result of lexer/parser changes: 1) Changed
% all instances of "else if" to "elsif".  2) Changed variables named "create"
% to "create_it" or "create_btn" as needed ("create" is now a reserved word).
% 
% Revision 1.1  89/11/29  09:43:49  trm
% Initial revision
% 
% Revision 1.1  89/09/28  13:35:02  rcs
% Initial revision
% 
|
\*--------------------------------------------------------------------------*\
|
|   Distribution: Approved for public release; distribution is unlimited.
|
|   Copyright (c) 1989  by  Carnegie  Mellon  University, Pittsburgh, PA.  The
|  Software Engineering  Institute  (SEI) is a federally  funded  research and
|  development center established  and  operated by Carnegie Mellon University
|  (CMU).  Sponsored  by  the  U.S.  Department  of   Defense  under  contract
|  F19628-85-C-0003,  the  SEI  is  supported  by  the  services  and  defense
|  agencies, with the U.S. Air Force as the executive contracting agent.
|
|    Permission to use,  copy,  modify, or  distribute  this  software and its
|  documentation for  any purpose and without fee  is hereby granted, provided
|  that  the above copyright notice appear  in  all copies and that both  that
|  copyright  notice  and   this  permission  notice  appear   in   supporting
|  documentation.   Further,  the  names  Software  Engineering  Institute  or
|  Carnegie  Mellon  University  may  not be used in  advertising or publicity
|  pertaining to distribution of the software without specific, written  prior
|  permission.  CMU makes no claims  or representations  about the suitability
|  of this software for any purpose.  This software is provided "as is" and no
|  warranty,  express  or  implied,  is  made  by  the  SEI  or CMU, as to the
|  accuracy  and  functioning of the program and related program material, nor
|  shall   the  fact of  distribution   constitute  any   such  warranty.   No
|  responsibility is assumed by the SEI or CMU in connection herewith.
|
\*--------------------------------------------------------------------------*/

#define ATTRIBUTE_HEIGHT 20

#define quotify(value) "value"

/*--------------------------------------------------------------------------*\
|  Macro: create_object
|
|  Description:
|    The create_object macro creates an object_instance_sdd
|    sets the appropriate fields.
\*--------------------------------------------------------------------------*/
#define create_object(fparent) \
  DEBUG2( \
    printf("create_object: call.\n",""); \
    printf("create_object: object type = %s.\n",toolbox_object_type); \
    printf("create_object: widget type %s\n",glue_get_widget_type( \
       glue_get_widget(technology_handle,toolbox_object_type))); \
  ) \
\
  if (glue_get_widget_type( \
    glue_get_widget(technology_handle,toolbox_object_type) \
  ) <> WT_WIDGET OR toolbox_object_type = "xawsimplemenubsb"\
                 OR toolbox_object_type = "xawsimplemenu"\
                 OR toolbox_object_type = "xawviewport"\
                 OR toolbox_object_type = "xawsmeline") then \
    set_error("It is not possible to visualize this type of object.", \
      "Create Object Instance",error_sdi,error_flag \
    ) \
    create_object_flag := FALSE;\
  else \
    create_object_flag := TRUE;\
    if (grid_snap) then \
      x_attr_value := make_integer( \
        get_sd_value(fparent, "selectedx")/xgrid + 0.5) * xgrid; \
      y_attr_value := make_integer( \
        get_sd_value(fparent, "selectedy")/ygrid + 0.5) * ygrid; \
    else \
      x_attr_value := get_sd_value(fparent, "selectedx"); \
      y_attr_value := get_sd_value(fparent, "selectedy"); \
    end if; \
/* \
**  Create an object instance and get the list of attributes. \
*/ \
    object_instance_sdi := create_sd_instance( \
      "object_instance_sdd","SE_BOX" \
    ); \
    attribute_list := glue_get_attribute_alist( \
      technology_handle,toolbox_object_type \
    ); \
\
    put_sd_value( \
      object_instance_sdi,\
      "name",\
      string_append(toolbox_object_type,dialogue_sdd.count) \
    ); \
\
    message := string_append( \
      string_append(toolbox_object_type,dialogue_sdd.count)," created." \
    ); \
\
    dialogue_sdd.count := dialogue_sdd.count + 1; \
    put_sd_value(object_instance_sdi,"type",toolbox_object_type); \
    put_sd_value(object_instance_sdi,"tech",parent_technology); \
    put_sd_value(object_instance_sdi,"mailbox",toolbox_mailbox);\
    put_sd_value(object_instance_sdi,"visible",TRUE); \
/* \
** Automatically select created object. \
*/ \
    source_mailbox := technology_mailbox; \
    source_tech_type := visualize_sdd.tech; \
    source_id := object_instance_sdi; \
    source_type := OBJECT_INSTANCE_TYPE; \
    source_object_type := toolbox_object_type; \
  end if; \
\
  DEBUG2(printf("create_object: exit.\n",""))

/*						
|  Parameters:
|     fparent - the id of the parent object.
|
\*--------------------------------------------------------------------------*/

/*--------------------------------------------------------------------------*\
|  Macro: create_attr
|
|  Description:
|    The create_attr macro creates an object_instance_attribute_sdd
|    instance and sets the appropriate fields.
|
|  IMPORTANT NOTE:
|    If you leave a space between first two parms in the macro the 
|    macro will not work.
|
\* Definition:                                                              */

#define create_attr(fname,fparent,ftype,fpriority,fvalue,fprev,fcur)\
fcur := create_sd_instance("object_instance_attribute_sdd","SE_BOX"); \
put_sd_value(fprev,"attr_list",fcur); \
put_sd_value(fcur,"name",fname); \
put_sd_value(fcur,"object",fparent); \
put_sd_value(fcur,"type",ftype); \
put_sd_value(fcur,"priority",fpriority); \
put_sd_value(fcur,"value",UNDEFINED); \
/* \
/**  Plug in editor default values for certain attributes. \
*/ \
if ((fname = "x") OR (fname = "horizdistance")) then \
  put_sd_value(fcur,"value",x_attr_value); \
elsif ((fname = "y") OR (fname = "vertdistance")) then \
  put_sd_value(fcur,"value",y_attr_value); \
elsif (fname = "parent") then \
  put_sd_value(fcur,"value",fvalue); \
/* ??? GT_StringTable may need to be added here */\
elsif (ftype = GT_String) then \
  put_sd_value(fcur,"value",get_sd_value(object_instance_sdi,"name")); \
end if;

/*
|  Parameters:
|     fname - attribute name
|     fparent - object instance
|     ftype - x type of the attribute
|     fvalue - attribute value
|     fprev - linked list management
|     fcur - linked list management
\*--------------------------------------------------------------------------*/

/*--------------------------------------------------------------------------*\
|  Name:  map_to_local_sd
|
|  Description:
|    The map_to_local_sd maps the application attribute shared data
|    into local shared data in order to reduce the number of elements
|    the creation conditions for the view controllers to display/edit
|    attribute values needs to examine.  
|
\* Definition:								    */

#define map_to_local_sd(fxtype,fprev,pagnum,ftemp) \
ftemp := create_sd_instance(string_append(fxtype,"_xtype_sdd"), "DM_BOX"); \
put_sd_value(ftemp,"attribute",current_id); \
put_sd_value(ftemp,"position",fprev); \
put_sd_value(ftemp,"page_number",pagnum);\

/*
|  Parameters:
|     fxtype - the xtype of the attribute into which the attribute
|              is to be mapped.
|     fprev - the number of the attribute within the form
|
\*--------------------------------------------------------------------------*/


/*--------------------------------------------------------------------------*\
|  Macro: string_attribute_get 
|
|  Description:
|    Used to get a string value from the text buffer and put it in the 
|    local variable for the specified attribute and updates focus.
|
\* Definition:                                                              */

#define string_attribute_get(name,fnext)\
  {\
    put_sd_value(name/**/_sdi,"value",textBuffer);\
    put_sd_value(current_focus,"font","6x13");\
    inner_attribute_form.focus := fnext/**/_attribute_text;\
    current_focus := fnext/**/_attribute_text;\
    fnext/**/_attribute_text.font := "*";\
  }

/*						
|  Parameters:
|     name - the attribute name.
|     fnext - id of the text object to receive text input focus
|
\*--------------------------------------------------------------------------*/

/*--------------------------------------------------------------------------*\
|  Macro: change_snapped_coordinate
|
|  Description:
|    This change_snapped_coordinate macro is used to update a
|    coordinate after a move or resize operation after snapping
|    the value to a grid (if appropriate).
|
\* Definition:                                                              */

#define change_snapped_coordinate(name, grid)\
  DEBUG3(\
    printf("change_snapped_coordinate: name = %s.\n",name); \
  )\
  if (grid_snap) then \
    put_sd_value(name/**/_sdi,"value",make_integer(name/grid+0.5)*grid); \
  else \
    put_sd_value(name/**/_sdi,"value",name); \
  end if;

/*						
|  Parameters:
|     name - the attribute name.
|     grid - the grid interval value.
|
\*--------------------------------------------------------------------------*/

/*--------------------------------------------------------------------------*\
|
|  Macro:  integer_attribute_get
|
|  Description:
|     The get_integer macro gets the integer value for an attribute
|     or generates an error message if the value is illegal.
|
\* Definition:                                                              */

#define integer_attribute_get(name,fnext)\
  {\
    DEBUG2(\
      printf("integer_attribute_get:  integer = name.\n",""); \
      printf("integer_attribute_get:  name = %s.\n",get_sd_value(name/**/_sdi,"value")); \
      printf("integer_attribute_get:  textBuffer = %s.\n",textBuffer); \
    ) \
    if (string_lower(textBuffer) = "null") then\
      error_flag := true; \
\
      name/**/_error := create_sd_instance("error_sdd","DM_BOX"); \
      put_sd_value(name/**/_error,"title",quotify(name)); \
      put_sd_value(name/**/_error,"message",\
        "NULL is an invalid value for this attribute."\
      ); \
      put_sd_value(name/**/_error,"height",\
        string_count_chars(\
          "NULL is an invalid value for this attribute.",\
          "\n"\
        ) + 1\
      ); \
      put_sd_value(name/**/_error,"self",name/**/_error); \
\
      name/**/_attribute_text.background := "black"; \
      name/**/_attribute_text.foreground := "white"; \
\
    elsif (NOT string_is_integer(textBuffer)) then\
\
      error_flag := true; \
\
      name/**/_error := create_sd_instance("error_sdd","DM_BOX"); \
      put_sd_value(name/**/_error,"title",quotify(name)); \
      put_sd_value(name/**/_error,"message",\
        "The specified attribute value is not an integer."\
      ); \
      put_sd_value(name/**/_error,"height",\
        string_count_chars(\
          "The specified attribute value is not an integer.",\
          "\n"\
        ) + 1\
      ); \
      put_sd_value(name/**/_error,"self",name/**/_error); \
\
      name/**/_attribute_text.background := "black"; \
      name/**/_attribute_text.foreground := "white"; \
    else\
      if (textBuffer = "") then\
        put_sd_value(name/**/_sdi,"value",UNDEFINED); \
      else\
        put_sd_value(name/**/_sdi,"value",textBuffer); \
    DEBUG3(\
      printf("integer_attribute_get:  new defined value.\n",""); \
      printf("integer_attribute_get:  name = %s.\n",get_sd_value(name/**/_sdi,"value")); \
      printf("integer_attribute_get:  textBuffer = %s.\n",textBuffer); \
    ) \
      end if; \
      name/**/_attribute_text.background := "white"; \
      name/**/_attribute_text.foreground := "black"; \
      if (id_exists(name/**/_error)) then\
        destroy/**/_sd_instance(name/**/_error); \
      end if; \
    end if; \
\
    put_sd_value(current_focus,"font","6x13");\
    inner_attribute_form.focus := fnext/**/_attribute_text;\
    current_focus := fnext/**/_attribute_text;\
    fnext/**/_attribute_text.font := "*";\
\
    DEBUG2(\
      printf("integer_attribute_get:  exit.\n",""); \
    ) \
  }

/*						
|  Parameters:
|     name - the attribute name.
|     fnext - id of the text object to receive text input focus
|
\*--------------------------------------------------------------------------*/

/*--------------------------------------------------------------------------*\
|
|  Macro:  get_coordinate_attribute
|
|  Description:
|     The get_coordinate_attribute macro gets the integer value for an 
|     attribute or generates an error message if the value is illegal.
|
\* Definition:                                                              */

#define get_coordinate_attribute(name)\
          {\
            if (string_lower(textBuffer) = "null") then\
              error_flag := true; \
\
              name/**/_error := create_sd_instance("error_sdd","DM_BOX"); \
              put_sd_value(name/**/_error,"title",quotify(name)); \
              put_sd_value(name/**/_error,"message",\
                "NULL is an invalid value for this attribute."\
              ); \
              put_sd_value(name/**/_error,"height",\
                string_count_chars(\
                  "NULL is an invalid value for this attribute.",\
                  "\n"\
                ) + 1\
              ); \
              put_sd_value(name/**/_error,"self",name/**/_error); \
\
              name/**/_attribute_text.background := "black"; \
              name/**/_attribute_text.foreground := "white"; \
\
            elsif (NOT string_is_integer(textBuffer)) then\
\
              error_flag := true; \
\
              name/**/_error := create_sd_instance("error_sdd","DM_BOX"); \
              put_sd_value(name/**/_error,"title",quotify(name)); \
              put_sd_value(name/**/_error,"message",\
                "The specified attribute value is not an integer."\
              ); \
              put_sd_value(name/**/_error,"height",\
                string_count_chars(\
                  "The specified attribute value is not an integer.",\
                  "\n"\
                ) + 1\
              ); \
              put_sd_value(name/**/_error,"self",name/**/_error); \
\
              name/**/_attribute_text.background := "black"; \
              name/**/_attribute_text.foreground := "white"; \
            else\
              name/**/_temp := textBuffer; \
              name/**/_attribute_text.background := "white"; \
              name/**/_attribute_text.foreground := "black"; \
              if (id_exists(name/**/_error)) then\
                destroy/**/_sd_instance(name/**/_error); \
              end if; \
            end if; \
\
	  }

/*						
|  Parameters:
|     name - the attribute name.
|
\*--------------------------------------------------------------------------*/

/*--------------------------------------------------------------------------*\
|
|  Macro:  attribute_form_title_bar
|
|  Description:
|     The attribute_form_title_bar macro creates an editable title bar 
|     including a label widget,which displays a title,an editable field 
|     for a name,and a command button which will cause the value in the 
|     editable field to be returned.
|
|
\* Definition:                                                              */

#define attribute_form_title_bar(fname,fparent,flabel,fwidth1,fvalue,fwidth2,dmethod)\
      fname/**/_form:  XawBboard { \
        Attributes: \
          parent: fparent; \
          width: 330; \
          height: 17; \
          background: "black"; \
          borderWidth: 0; \
          horizDistance: 1; \
          vertDistance: 1; \
      } \
\
       fname/**/_label: XawLabel {\
	 Attributes: \
	   parent: fname/**/_form; \
	   borderWidth: 0; \
	   background: "black"; \
	   foreground: "white"; \
	   height: 17; \
           horizDistance: 0; \
           vertDistance: 0; \
	   label: flabel; \
	   width: fwidth1; \
	   justify: LEFT; \
	}\
\
	fname/**/_text: XawTextentry {\
	 Attributes: \
	   parent: fname/**/_form; \
	   borderWidth: 0; \
	   background: "black"; \
	   foreground: "white"; \
	   width: fwidth2; \
	   height: 17; \
	   textBuffer: set_text_name(textBuffer,fvalue); \
	   horizDistance: fwidth1; \
           vertDistance: 0; \
	 Methods: \
	   send: dmethod\
	}\

/*
|  Parameters:
|     fname	- unique name.
|     fparent	- parent (form) of the object.
|     flabel	- text widget label.
|     fwidth1	- width of the label in bits.
|     fvalue	- contents of editable field.
|     fwidth2	- width of the editable field.
|
\*--------------------------------------------------------------------------*/

/*--------------------------------------------------------------------------*\
|  Macro: convert_types
|
|  Description:
|    Used to change an X type to a serpent type
|
\* Definition:                                                              */

#define convert_types(in_type,out_type)\
          if (in_type = GT_Boolean) then\
            out_type := "boolean";\
          elsif (in_type = GT_caddr_t) then\
            out_type := "xxx";\
          elsif (in_type = GT_Cardinal) then\
            out_type := "int";\
          elsif (in_type = GT_KeySym) then\
            out_type := "xxx";\
          elsif (in_type = GT_char_star) then\
            out_type := "xxx";\
          elsif (in_type = GT_Dimension) then\
            out_type := "int";\
          elsif (in_type = GT_float) then\
            out_type := "float";\
          elsif (in_type = GT_int) then\
            out_type := "int";\
          elsif (in_type = GT_Pixel) then\
            out_type := "pixel";\
          elsif (in_type = GT_Pixmap) then\
            out_type := "string";\
          elsif (in_type = GT_Pointer) then\
            out_type := "xxx";\
          elsif (in_type = GT_Position) then\
            out_type := "int";\
          elsif (in_type = GT_short) then\
            out_type := "int";\
          elsif (in_type = GT_String) then\
            out_type := "string";\
          elsif (in_type = GT_unsigned_char) then\
            out_type := "int";\
          elsif (in_type = GT_Widget) then\
            if (get_sd_value(current_id, "name") = "parent") then\
              out_type := "parent";\
            else\
              out_type := "widget";\
            end if;\
          elsif (in_type=GT_XmCreatePopupChildProc) then\
            out_type := "xxx";\
          elsif (in_type = GT_XmFontList) then\
            out_type := "xfontstruct";\
          elsif (in_type = GT_XmString) then\
            out_type := "string";\
          elsif (in_type = GT_XmStringDirection) then\
            out_type := "int";\
          elsif (in_type = GT_XmTextPosition) then\
            out_type := "int";\
          elsif (in_type = GT_XtCallbackList) then\
            out_type := "string";\
          elsif (in_type = GT_XtOrderProc) then\
            out_type := "string";\
          elsif (in_type = GT_XtTranslations) then\
            out_type := "xxx";\
          elsif (in_type = GT_XmStringTable) then\
            out_type := "xxx";\
          elsif (in_type = GT_XmStringList) then\
            out_type := "xxx";\
          elsif (in_type = GT_XtProc) then\
            out_type := "string";\
          elsif (in_type = GT_unsigned_int) then\
            out_type := "int";\
          elsif (in_type = GT_XFontStruct) then\
            out_type := "xfontstruct";\
           elsif (in_type = GT_Accelerators) then\
            out_type := "string";\
          elsif (in_type = GT_Cursor) then\
            out_type := "xxx";\
          elsif (in_type=GT_XawTextSelectType_star) then\
            out_type := "xxx";\
          elsif (in_type = GT_focus) then\
            out_type := "widget";\
          elsif (in_type = GT_top) then\
            out_type := "xxx";\
          elsif (in_type = GT_bottom) then\
            out_type := "xxx";\
          end if;


/*--------------------------------------------------------------------------*\
|  Macro: attribute_box
|
|  Description:
|    Used to define the boundary for an attribute field
|
\* Definition:   xstring is the basis for the labels generated               */

#define   attribute_box(xstring)\
xstring/**/_attr_box: XawBboard {\
    Attributes:\
      parent: attribute_viewport;\
      height: ATTRIBUTE_HEIGHT + 8;\
      width: attribute_viewport.width;\
      vertdistance:xstring/**/_xtype_sdd.position * (ATTRIBUTE_HEIGHT + 8);\
      borderColor: "white";\
      borderWidth: 0;\
      mappedwhenmanaged: current_page = xstring/**/_xtype_sdd.page_number;\
  }

/*--------------------------------------------------------------------------*\
|  Macro: attribute_label
|
|  Description:
|    Used to define the text command widget for an attribute field
|
\* Definition:   xstring is the basis for the labels generated             */

#define attribute_label(xstring)\
 xstring/**/_attr_label: XawLabel {\
    Attributes:\
      parent: xstring/**/_attr_box;\
      label: string_append(attr_name,":");\
      height: ATTRIBUTE_HEIGHT;\
      width: ATTR_WIDTH - 3;\
      justify: LEFT;\
      borderColor: "white";\
      borderWidth: 0;\
  }
