#include "sat.ill"

||| 

/* This is the slang program which constructs a calculator It has one vc
and multiple objects.  The three variables carry the accumulator, the
decimal position and the current operator.  */

#define number_font "*times-bold-r-n*--20*"
#define button_font "*times-bold-r-n*--14*"

#define calculate(number) if (decimalpos = 0) then\
              display := 10 * display + number;\
           elsif (decimalpos = -1) then\
              display := number;\
              decimalpos := 0;\
           else\
              display := display + number / (10 ** \
                    decimalpos);\
              decimalpos :=decimalpos + 1;\
           endif;

#define set_operator(operator)\
              op := operator;\
              decimalpos := -1;\
              accumulator := display;

#define operate(symbol) decimalpos := -1;\
               accumulator := accumulator symbol display;\
               display := accumulator;


   VARIABLES:

   display : 0;
   accumulator : 0;
   decimalpos : 0;
   op : "";
/*
   The variable decimalpos serves three purposes.  
      If it is 0 then any numbers entered into the display are
        appended to the right of the current display but to the left of 
        the decimal point.
      if it is -1 then any number entered into the display erases the current
            display and sets display to number entered
      if it is positive then it represents the position to the right of
            the decimal point*/

   OBJECTS:


        main_background:     XawBboard
        {ATTRIBUTES:
           width:  300;
           height: 500;
         }   

/*-----------------------------------------------------------------------
|    Object: display on top of calculator
|
---------------------------------------------------------------------*/

        display_widget: XawLabel
        {ATTRIBUTES:

          parent: main_background;
          vertDistance: 20;
          horizDistance: 70;
          height: 40;
          width: 200;
          justify: 2;
          label: display;
          borderWidth: 3;
          font: number_font;
         }

/*-----------------------------------------------------------------------
|    Object: quit button for calculator
|
---------------------------------------------------------------------*/

        digit_off: XawCommand
        {ATTRIBUTES:

          parent: main_background;
          vertDistance: 20;
          horizDistance: 10;
          height: 40;
          width: 50;
          label: "OFF";
          borderWidth: 2;
          font: button_font;

         METHODS:
          notify:{
            exit();
	  }
        }


/*------------------------------------------------------------------------
|       Object: display  digit 7  
------------------------------------------------------------------------*/

	digit7: XawCommand
	{ATTRIBUTES:
           parent: main_background;  
	   label: "7";
	   width: 50;
	   height: 50;
           vertDistance: 100;
           horizDistance: 20;
           borderWidth: 2;
           font: number_font;

         METHODS:
          notify: {
             calculate (7)
          }
	}

/*------------------------------------------------------------------------
|       Object: display  digit 8  
------------------------------------------------------------------------*/

	digit8: XawCommand
	{ATTRIBUTES:
           parent: main_background;  
	   label: "8";
	   width: 50;
	   height: 50;
           vertDistance: 100;
           horizDistance: 90;
           borderWidth: 2;
           font: number_font;

         METHODS:
          notify: {
            calculate (8)
          }
	}

/*------------------------------------------------------------------------
|       Object: display  digit 9  
------------------------------------------------------------------------*/

	digit9: XawCommand
	{ATTRIBUTES:
           parent: main_background;  
	   label: "9";
	   width: 50;
	   height: 50;
           vertDistance: 100;
           horizDistance: 160;
           borderWidth: 2;
           font: number_font;

         METHODS:
          notify: {
            calculate (9)
          }
	}

/*------------------------------------------------------------------------
|       Object: display  digit 4  
------------------------------------------------------------------------*/

	digit4: XawCommand
	{ATTRIBUTES:
           parent: main_background;  
	   label: "4";
	   width: 50;
	   height: 50;
           vertDistance: 170;
           horizDistance: 20;
           borderWidth: 2;
           font: number_font;

         METHODS:
          notify: {
           calculate (4)
          }
	}

/*------------------------------------------------------------------------
|       Object: display  digit 5  
------------------------------------------------------------------------*/
	digit5: XawCommand
	{ATTRIBUTES:
           parent: main_background;  
	   label: "5";
	   width: 50;
	   height: 50;
           vertDistance: 170;
           horizDistance: 90;
           borderWidth: 2;
           font: number_font;

         METHODS:
          notify: {
           calculate (5)
          }
	}

/*------------------------------------------------------------------------
|       Object: display  digit 6
------------------------------------------------------------------------*/

	digit6: XawCommand
	{ATTRIBUTES:
           parent: main_background;  
	   label: "6";
	   width: 50;
	   height: 50;
           vertDistance: 170;
           horizDistance: 160;
           borderWidth: 2;
           font: number_font;


         METHODS:
          notify: {
           calculate (6)
          }
	}


	digit1: XawCommand
	{ATTRIBUTES:
           parent: main_background;  
	   label: "1";
	   width: 50;
	   height: 50;
           vertDistance: 240;
           horizDistance: 20;
           borderWidth: 2;
           font: number_font;


         METHODS:
          notify: {
           calculate (1)
          }
	}

	digit2: XawCommand
	{ATTRIBUTES:
           parent: main_background;  
	   label: "2";
	   width: 50;
	   height: 50;
           vertDistance: 240;
           horizDistance: 90;
           borderWidth: 2;
           font: number_font;


         METHODS:
          notify: {
            calculate (2)
          }
	}

	digit3: XawCommand
	{ATTRIBUTES:
           parent: main_background;  
	   label: "3";
	   width: 50;
	   height: 50;
           vertDistance: 240;
           horizDistance: 160;
           borderWidth: 2;
           font: number_font;


         METHODS:
          notify: {
           calculate (3)
          }
	}

	digit0: XawCommand
	{ATTRIBUTES:
           parent: main_background;  
	   label: "0";
	   width: 50;
	   height: 50;
           vertDistance: 310;
           horizDistance: 90;
           borderWidth: 2;
           font: number_font;


         METHODS:
          notify: {
            calculate (0)
          }
	}

	cleardisplay: XawCommand
	{ATTRIBUTES:
           parent: main_background;  
	   label: "CE";
	   width: 50;
	   height: 50;
           vertDistance: 310;
           horizDistance: 20;
           borderWidth: 2;
           font: number_font;


         METHODS:
          notify: {

          display := 0;
          decimalpos := 1;
          }
	}

	decimal: XawCommand
	{ATTRIBUTES:
           parent: main_background;  
	   label: ".";
	   width: 50;
	   height: 50;
           vertDistance: 310;
           horizDistance: 160;
           borderWidth: 2;
           font: number_font;

         METHODS:
          notify: {

         if(decimalpos = 0) then
            decimalpos := 1;
         elsif ( decimalpos = -1) then
             display := 0;
             decimalpos := 1;
         endif;

          }
	}

	clearaccum: XawCommand
	{ATTRIBUTES:
           parent: main_background;  
	   label: "C";
	   width: 30;
	   height: 30;
           vertDistance: 100;
           horizDistance: 230;
           borderWidth: 2;
           font: button_font;


         METHODS:
          notify: {

            display := 0;
            decimalpos := 0;
            accumulator := 0;


          }
	}

	divide: XawCommand
	{ATTRIBUTES:
           parent: main_background;  
	   label: "DIV";
	   width: 30;
	   height: 30;
           vertDistance: 140;
           horizDistance: 230;
           borderWidth: 2;
           font: button_font;


         METHODS:
          notify: {
           set_operator("div")
          }
	}

	multiply: XawCommand
	{ATTRIBUTES:
           parent: main_background;  
	   label: "X";
	   width: 30;
	   height: 30;
           vertDistance: 180;
           horizDistance: 230;

           borderWidth: 2;
           font: button_font;


         METHODS:
          notify: {
            set_operator("mult")
          }
	}

	subtract: XawCommand
	{ATTRIBUTES:
           parent: main_background;  
	   label: "-";
	   width: 30;
	   height: 30;
           vertDistance: 260;
           horizDistance: 230;
           borderWidth: 2;
           font: button_font;
         METHODS:
          notify: {
            set_operator ("sub")
          }
	}

	add: XawCommand
	{ATTRIBUTES:
           parent: main_background;  
	   label: "+";
	   width: 30;
	   height: 30;
           vertDistance: 220;
           horizDistance: 230;
           borderWidth: 2;
           font: button_font;
         METHODS:
          notify: {
            set_operator("add")
          }
	}

	equal: XawCommand
	{ATTRIBUTES:
           parent: main_background;  
	   label: "=";
	   width: 30;
	   height: 40;
           vertDistance: 320;
           horizDistance: 230;
           borderWidth: 2;
           font: button_font;


         METHODS:
          notify: {
            If (op = "div") then
               operate (/)
            elsif (op = "mult") then
               operate (*)
            elsif (op = "add") then
               operate (+)
            elsif (op = "sub") then
               operate (-)
            endif;
          }
	}

