#include "sat.ill"
#include "fontsel.ill"

|||

#include "fonts.h"

#define DEFAULT_FONT    "9X15BOLD"
#define TOPLINE_TOP	10
#define TOPLINE_HEIGHT	20
#define DOIT_WIDTH	50
#define SAMPLE_TOP	TOPLINE_TOP+TOPLINE_HEIGHT+10
#define SAMPLE_HEIGHT	50
#define SAMPLE_OFFSET	10
#define NAME_TOP	SAMPLE_TOP+SAMPLE_HEIGHT+10
#define NAME_HEIGHT	20
#define NAME_WIDTH	215
#define NAME_OFFSET	SAMPLE_OFFSET
#define SLANT_TOP	SAMPLE_TOP+SAMPLE_HEIGHT+10
#define SLANT_HEIGHT	20
#define SLANT_WIDTH	80
#define SLANT_OFFSET	NAME_OFFSET+NAME_WIDTH+10
#define WEIGHT_TOP	\
	    SAMPLE_TOP+SAMPLE_HEIGHT+10+(howmany_of(FONT_SLANT)+2)*SLANT_HEIGHT
#define WEIGHT_HEIGHT	SLANT_HEIGHT
#define WEIGHT_WIDTH	SLANT_WIDTH
#define WEIGHT_OFFSET	SLANT_OFFSET
#define SIZE_TOP	SAMPLE_TOP+SAMPLE_HEIGHT+10
#define SIZE_HEIGHT	20
#define SIZE_WIDTH	50
#define SIZE_OFFSET	WEIGHT_OFFSET+WEIGHT_WIDTH+10

EXTERNALS:
    integer howmany_of(integer);
    string fetch_val(integer,integer);
    boolean font_exists(string,string,string,string);
    integer int_max(integer,integer);
    string font_str(string,string,string,string);
    void ipb_start_recording (string, string);

VC : font_palette

    CREATION CONDITION: (TRUE)

    VARIABLES:
	i;
	max;
	fid;
	cur_name : "*";
	cur_size : "*";
	cur_slant : "*";
	cur_weight : "*";
	cur_name_id;
	cur_size_id;
	cur_slant_id;
	cur_weight_id;
	cur_name_idx : 0;	/* TODO: initialize to the current settings */
	cur_size_idx : 0;
	cur_slant_idx : 0;
	cur_weight_idx : 0;

    OBJECTS:
	palette : XawBboard {
	    ATTRIBUTES:
		width : SIZE_OFFSET+SIZE_WIDTH+10;
		height : int_max( howmany_of(FONT_SIZE)*SIZE_HEIGHT,
				  howmany_of(FONT_NAME)*NAME_HEIGHT )+NAME_TOP;
		allowUserMove : TRUE;
		horizDistance : 100;
		vertDistance : 250;
		x : 0;
		y : 0;

	    METHODS:
		move: {
		    horizDistance := x;
		    vertDistance := y;
		    }
	    }

	apply : XawCommand {
	    ATTRIBUTES:
		parent : palette;
		width : DOIT_WIDTH;
		height : TOPLINE_HEIGHT;
		borderWidth : 3;
		label : "Apply";
		horizDistance : NAME_OFFSET;
		vertDistance : TOPLINE_TOP;
	    }

	title : XawLabel {
	    ATTRIBUTES:
		parent : palette;
		width : palette.width-2*DOIT_WIDTH-55;
		height : TOPLINE_HEIGHT;
		borderWidth : 0;
		label : "Font Palette";
		horizDistance : NAME_OFFSET+DOIT_WIDTH+10;
		vertDistance : TOPLINE_TOP;
	    }

	done : XawCommand {
	    ATTRIBUTES:
		parent : palette;
		width : DOIT_WIDTH;
		height : TOPLINE_HEIGHT;
		borderWidth : 3;
		label : "Done";
		horizDistance : (SIZE_OFFSET+SIZE_WIDTH)-DOIT_WIDTH;
		vertDistance : TOPLINE_TOP;
	    METHODS:
		notify : {
		    exit();
		    }
	    }

	sample : XawText {
	    ATTRIBUTES:
		parent : palette;
		width : (SIZE_OFFSET+SIZE_WIDTH)-SAMPLE_OFFSET;
		height : SAMPLE_HEIGHT;
		font : font_str(cur_name,cur_size,cur_slant,cur_weight);
		textBuffer : "Font Sample";
		horizDistance : NAME_OFFSET;
		vertDistance : SAMPLE_TOP;
                editType: 2;
                
	    }

    ON CREATE: {
	ipb_start_recording ("fontsel.record", "Erik"); 
	i := 0;
	max := howmany_of(FONT_NAME);
	WHILE (i < max) DO
	    fid := create_sd_instance("fontname", "FONTSEL_BOX");
	    put_sd_value(fid, "idx", i);
	    put_sd_value(fid, "vert", NAME_TOP+(i*NAME_HEIGHT));
	    put_sd_value(fid, "name", fetch_val(FONT_NAME, i));
	    i := i + 1;
	END WHILE;
	i := 0;
	max := howmany_of(FONT_SIZE);
	WHILE (i < max) DO
	    fid := create_sd_instance("fontsize", "FONTSEL_BOX");
	    put_sd_value(fid, "idx", i);
	    put_sd_value(fid, "vert", SIZE_TOP+(i*SIZE_HEIGHT));
	    put_sd_value(fid, "size", fetch_val(FONT_SIZE, i));
	    i := i + 1;
	END WHILE;
	i := 0;
	max := howmany_of(FONT_SLANT);
	WHILE (i < max) DO
	    fid := create_sd_instance("fontslant", "FONTSEL_BOX");
	    put_sd_value(fid, "idx", i);
	    put_sd_value(fid, "vert", SLANT_TOP+(i*SLANT_HEIGHT));
	    put_sd_value(fid, "slant", fetch_val(FONT_SLANT, i));
	    i := i + 1;
	END WHILE;
	i := 0;
	max := howmany_of(FONT_WEIGHT);
	WHILE (i < max) DO
	    fid := create_sd_instance("fontweight", "FONTSEL_BOX");
	    put_sd_value(fid, "idx", i);
	    put_sd_value(fid, "vert", WEIGHT_TOP+(i*WEIGHT_HEIGHT));
	    put_sd_value(fid, "weight", fetch_val(FONT_WEIGHT, i));
	    i := i + 1;
	END WHILE;
	}

    VC : font_name
	CREATION CONDITION: ( new("fontname") )

	OBJECTS:
	    selector : XawCommand {
		ATTRIBUTES:
		    parent: palette;
		    height: NAME_HEIGHT;
		    width: NAME_WIDTH;
		    label: fontname.name;
		    sensitive: font_exists(fontname.name,cur_size,cur_slant,cur_weight);
		    font: DEFAULT_FONT;
		    horizDistance : NAME_OFFSET;
		    vertDistance : fontname.vert;
		METHODS:
		    notify : {
			put_sd_value(cur_name_id, "foreground", "black");
			put_sd_value(cur_name_id, "background", "white");
			foreground := "white";
			background := "black";
			cur_name := fontname.name;
			cur_name_id := selector;
			cur_name_idx := fontname.idx;
			}
		}

	ON CREATE: {
	    IF (fontname.idx = cur_name_idx) THEN
		cur_name := fontname.name;
		cur_name_id := selector;
		selector.foreground := "white";
		selector.background := "black";
	    END IF;
	    }
    END VC font_name;

    VC : font_size
	CREATION CONDITION: ( new("fontsize") )

	OBJECTS:
	    selector : XawCommand {
		ATTRIBUTES:
		    parent: palette;
		    height: SIZE_HEIGHT;
		    width: SIZE_WIDTH;
		    label: fontsize.size;
		    sensitive: font_exists(cur_name,fontsize.size,cur_slant,cur_weight);
		    font: DEFAULT_FONT;
		    horizDistance : SIZE_OFFSET;
		    vertDistance : fontsize.vert;
		METHODS:
		    notify : {
			put_sd_value(cur_size_id, "foreground", "black");
			put_sd_value(cur_size_id, "background", "white");
			foreground := "white";
			background := "black";
			cur_size := fontsize.size;
			cur_size_id := selector;
			cur_size_idx := fontsize.idx;
			}
		}

	ON CREATE: {
	    IF (fontsize.idx = cur_size_idx) THEN
		cur_size := fontsize.size;
		cur_size_id := selector;
		selector.foreground := "white";
		selector.background := "black";
	    END IF;
	    }
    END VC font_size;

    VC : font_slant
	CREATION CONDITION: ( new("fontslant") )

	OBJECTS:
	    selector : XawCommand {
		ATTRIBUTES:
		    parent: palette;
		    height: SLANT_HEIGHT;
		    width: SLANT_WIDTH;
		    label: fontslant.slant;
		    sensitive: font_exists(cur_name,cur_size,fontslant.slant,cur_weight);
		    font: DEFAULT_FONT;
		    horizDistance : SLANT_OFFSET;
		    vertDistance : fontslant.vert;
		METHODS:
		    notify : {
			put_sd_value(cur_slant_id, "foreground", "black");
			put_sd_value(cur_slant_id, "background", "white");
			foreground := "white";
			background := "black";
			cur_slant := fontslant.slant;
			cur_slant_id := selector;
			cur_slant_idx := fontslant.idx;
			}
		}

	ON CREATE: {
	    IF (fontslant.idx = cur_slant_idx) THEN
		cur_slant := fontslant.slant;
		cur_slant_id := selector;
		selector.foreground := "white";
		selector.background := "black";
	    END IF;
	    }
    END VC font_slant;

    VC : font_weight
	CREATION CONDITION: ( new("fontweight") )

	OBJECTS:
	    selector : XawCommand {
		ATTRIBUTES:
		    parent: palette;
		    height: WEIGHT_HEIGHT;
		    width: WEIGHT_WIDTH;
		    label: fontweight.weight;
		    sensitive: font_exists(cur_name,cur_size,cur_slant,fontweight.weight);
		    font: DEFAULT_FONT;
		    horizDistance : WEIGHT_OFFSET;
		    vertDistance : fontweight.vert;
		METHODS:
		    notify : {
			put_sd_value(cur_weight_id, "foreground", "black");
			put_sd_value(cur_weight_id, "background", "white");
			foreground := "white";
			background := "black";
			cur_weight := fontweight.weight;
			cur_weight_id := selector;
			cur_weight_idx := fontweight.idx;
			}
		}

	ON CREATE: {
	    IF (fontweight.idx = cur_weight_idx) THEN
		cur_weight := fontweight.weight;
		cur_weight_id := selector;
		selector.foreground := "white";
		selector.background := "black";
	    END IF;
	    }
    END VC font_weight;

END VC font_palette;
