#include "sat.ill"

|||

/*-------------------------------------------------------------------------*\
|   This demonstrates the use of Slang to produce a menu bar 
\*-------------------------------------------------------------------------*/

Externals:
  void system(string);
  void printf(string, string);
  string getenv(string);

#include "sstring.ext"

Variables:
  athena_widget_menu: false;
  motif_widget_menu: false;
  dev_tools_menu : FALSE;
  serpent_base_path;
  system_command;

Objects:

  menu_bar_form: XawBboard  {
    Attributes:
      height:450;
      width: 500;
  }

  menu_bar: XawBboard {
    Attributes:
      parent: menu_bar_form;
      height: 350;
      width: 475;
      y: 20;
      vertDistance: 20;
      x: 20; 
      horizDistance: 20;
      borderWidth: 0;
  }

  menu0_item: XawCommand   {
    Attributes:
      parent: menu_bar;
      y: 10;
      vertDistance: 10;
      x: 10;
      horizDistance: 10;
      height: 20;
      width: 110;
      label: "Dev Tools";
      font: "9x15bold";
    Methods:
      notify: {
        dev_tools_menu := TRUE;
      }
   }

  menu1_item: XawCommand   {
    Attributes:
      parent: menu_bar;
      vertDistance: 10;
      horizDistance: 120;
      height        : 20;
      width         : 110;
      label          : "Athena";
      font: "9x15bold";
    Methods:
      notify:  {
        athena_widget_menu := TRUE;
      }
   }

  menu2_item: XawCommand   {

    Attributes:
      parent        : menu_bar;
      vertDistance: 10;
      horizDistance: 230;
      height        : 20;
      width         : 110;
      label          : "Motif";
      font: "9x15bold";

    Methods:

      notify:  {
        motif_widget_menu := TRUE;
      }

    }

     quit_menu_item:  XawCommand { 

       ATTRIBUTES:
         parent:  menu_bar;
         height: 20;
         width: 110;
         vertDistance: 10;
         horizDistance: 340;
         label: "QUIT";
      font: "9x15bold";

       METHODS:
         notify:  {
           exit ();
         }
   }

/*--------------------- Athena Widgets ------------------------------------*/

VC:  dev_tools_menu_vc

Creation Condition:  (dev_tools_menu)

Objects:

  menu1_bulletin_board: XawBboard {
    Attributes:
      parent: menu_bar;
      vertDistance: 30;
      horizDistance: 10;
      borderWidth: 2;
      height: 100;
      width: 175;
  }

  item1_menu_item: XawCommand  {

    Attributes:
      parent: menu1_bulletin_board;
      vertDistance: 13;
      horizDistance: 0;
      justify: 0;
      height: 20;
      width: 170;
      label: "Dialogue Editor";
      font: "9x15bold";

    Methods:
      notify: {
        system("(cd $SERPENT_BASE_PATH/de/src; serpent ded) &");
        dev_tools_menu := false;
      }
    }

  remove_menu_item: XawCommand   {

    Attributes:
      parent: menu1_bulletin_board;
      justify: 0;
     vertDistance: 33;
      horizDistance: 0;
      borderWidth: 1;
      height: 20;
      width: 170;
      label: "Close";
      font: "9x15bold";
    Methods:

      notify: {
        dev_tools_menu := FALSE;
      }
   }

  ENDVC dev_tools_menu_vc

/*--------------------- Athena Widgets ------------------------------------*/

VC:  athena_widget_menu_vc

Creation Condition:  (athena_widget_menu)

/*
   The Athena demos are:  calc, concent, counter, group, icsec,
   layout, monitor, proto, sigchi, spider, visprog, visu.
*/

Objects:

  menu1_bulletin_board: XawBboard {
    Attributes:
      parent: menu_bar;
      vertDistance: 33;
      horizDistance: 120;
      borderWidth: 2;
      height: 300;
      width: 140;
  }

  item1_menu_item: XawCommand  {

    Attributes:
      parent: menu1_bulletin_board;
      vertDistance: 10;
      horizDistance: 0;
      justify: 0;
      height: 20;
      width: 140;
      borderWidth: 1;
      label: "Counter";
      font: "9x15bold";
    Methods:
      notify: {
        system("(cd $SERPENT_BASE_PATH/demos/sat/counter; serpent counter) &");

        athena_widget_menu := false;
      }

    }

  item2_menu_item: XawCommand   {

    Attributes:
      parent: menu1_bulletin_board;
      vertDistance: 33;
      horizDistance: 0;
      justify: 0;
      height: 20;
      width: 140;
      borderWidth: 1;
      label: "Concentration";
      font: "9x15bold";

    Methods:
      notify:
      { 
        system("(cd $SERPENT_BASE_PATH/demos/sat/concent; serpent concent) &");
        athena_widget_menu := false; 
      }
   }

  item3_menu_item: XawCommand   {
    Attributes:
      parent: menu1_bulletin_board;
     vertDistance: 53;
      horizDistance: 0;
      justify: 0;
      height: 20;
      width: 140;
      borderWidth: 1;
      label: "Calculator";
      font: "9x15bold";
    Methods:
      notify:
      { 
        system("(cd $SERPENT_BASE_PATH/demos/sat/calc; serpent calc) &");
        athena_widget_menu := false; 
      }
   }

  item4_menu_item: XawCommand   {
    Attributes:
      parent: menu1_bulletin_board;
     vertDistance: 73;
      horizDistance: 0;
      justify: 0;
      height: 20;
      width: 140;
      borderWidth: 1;
      label: "Grouping";
      font: "9x15bold";
    Methods:
      notify:
      { 
        system("(cd $SERPENT_BASE_PATH/demos/sat/group; serpent group) &");
        athena_widget_menu := false; 
      }
   }

  item5_menu_item: XawCommand   {
    Attributes:
      parent: menu1_bulletin_board;
     vertDistance: 93;
      horizDistance: 0;
      justify: 0;
      height: 20;
      width: 140;
      borderWidth: 1;
      label: "Layout";
      font: "9x15bold";
    Methods:
      notify:
      { 
        system("(cd $SERPENT_BASE_PATH/demos/sat/layout; serpent layout) &");
        athena_widget_menu := false; 
      }
   }

  item6_menu_item: XawCommand   {
    Attributes:
      parent: menu1_bulletin_board;
     vertDistance: 113;
      horizDistance: 0;
      justify: 0;
      height: 20;
      width: 140;
      borderWidth: 1;
      label: "SIGCHI Talk";
      font: "9x15bold";
    Methods:
      notify:
      { 
    system(
     "(cd $SERPENT_BASE_PATH/demos/sat/sigchi; serpent sigchi) &"
    );
        athena_widget_menu := false; 
      }
   }

  item7_menu_item: XawCommand   {
    Attributes:
      parent: menu1_bulletin_board;
     vertDistance: 133;
      horizDistance: 0;
      justify: 0;
      height: 20;
      width: 140;
      borderWidth: 1;
      label: "Spider";
      font: "9x15bold";
    Methods:
      notify:
      { 
        system("(cd $SERPENT_BASE_PATH/demos/sat/spider; serpent spider) &");
        athena_widget_menu := false; 
      }
   }

  item8_menu_item: XawCommand   {
    Attributes:
      parent: menu1_bulletin_board;
     vertDistance: 153;
      horizDistance: 0;
      justify: 0;
      height: 20;
      width: 140;
      borderWidth: 1;
      label: "Vis Programmer";
      font: "9x15bold";
    Methods:
      notify:
      { 
        system("(cd $SERPENT_BASE_PATH/demos/sat/visprog; serpent visprog) &");
        athena_widget_menu := false; 
      }
   }
  item9_menu_item: XawCommand   {
    Attributes:
      parent: menu1_bulletin_board;
     vertDistance: 173;
      horizDistance: 0;
      justify: 0;
      height: 20;
      width: 140;
      borderWidth: 1;
      label: "Color Palette";
      font: "9x15bold";
    Methods:
      notify:
      { 
        system("(cd $SERPENT_BASE_PATH/demos/sat/color; serpent color) &");
        athena_widget_menu := false; 
      }
   }
  item10_menu_item: XawCommand   {
    Attributes:
      parent: menu1_bulletin_board;
     vertDistance: 193;
      horizDistance: 0;
      justify: 0;
      height: 20;
      width: 140;
      borderWidth: 1;
      label: "Font Selector";
      font: "9x15bold";
    Methods:
      notify:
      { 
        system("(cd $SERPENT_BASE_PATH/demos/sat/fontsel; serpent fontsel) &");
        athena_widget_menu := false; 
      }
   }
  item11_menu_item: XawCommand   {
    Attributes:
      parent: menu1_bulletin_board;
     vertDistance: 213;
      horizDistance: 0;
      justify: 0;
      height: 20;
      width: 140;
      borderWidth: 1;
      label: "Icsec";
      font: "9x15bold";
    Methods:
      notify:
      { 
        system("(cd $SERPENT_BASE_PATH/demos/sat/icsec; serpent icsec) &");
        athena_widget_menu := false; 
      }
   }
  item12_menu_item: XawCommand   {
    Attributes:
      parent: menu1_bulletin_board;
     vertDistance: 233;
      horizDistance: 0;
      justify: 0;
      height: 20;
      width: 140;
      borderWidth: 1;
      label: "Monitor";
      font: "9x15bold";
    Methods:
      notify:
      { 
        system("(cd $SERPENT_BASE_PATH/demos/sat/monitor; serpent monitor) &");
        athena_widget_menu := false; 
      }
   }
  item13_menu_item: XawCommand   {
    Attributes:
      parent: menu1_bulletin_board;
     vertDistance: 253;
      horizDistance: 0;
      justify: 0;
      height: 20;
      width: 140;
      borderWidth: 1;
      label: "Prototyper";
      font: "9x15bold";
    Methods:
      notify:
      { 
        system("(cd $SERPENT_BASE_PATH/demos/sat/proto; serpent proto) &");
        athena_widget_menu := false; 
      }
   }

  remove_menu_item: XawCommand   {
    Attributes:
      parent: menu1_bulletin_board;
      justify: 0;
      vertDistance: 273;
      horizDistance: 0;
      borderWidth: 1;
      height: 20;
      width: 140;
      label: "Close";
      font: "9x15bold";
    Methods:
      notify: {
        athena_widget_menu := FALSE;
      }
   }

  ENDVC athena_widget_menu_vc

/*--------------------- Motif Widgets ------------------------------------*/

VC:  motif_widget_menu_vc

Creation Condition:  (motif_widget_menu)

/*
   The Motif demos are:  calc, concent, counter, grouping, 
   menubar, sigchi, spider, vis_prog.
*/

Objects:

  menu1_bulletin_board: XawBboard {
    Attributes:
      parent: menu_bar;
      vertDistance: 33;
      horizDistance: 230;
      borderWidth: 2;
      height: 250;
      width: 140;
  }

  item1_menu_item: XawCommand  {

    Attributes:
      parent: menu1_bulletin_board;
      vertDistance: 13;
      horizDistance: 0;
      justify: 0;
      height: 20;
      width: 140;
      borderWidth: 1;
      label: "Counter";
      font: "9x15bold";

    Methods:
      notify: {
        system("(cd $SERPENT_BASE_PATH/demos/smo/counter; serpent counter) &");
        motif_widget_menu := false;
      }

    }

  item2_menu_item: XawCommand   {

    Attributes:
      parent: menu1_bulletin_board;
     vertDistance: 33;
      horizDistance: 0;
      justify: 0;
      height: 20;
      width: 140;  
      borderWidth: 1;
      label: "Concentration";
      font: "9x15bold";

    Methods:
      notify:
      { 
        system("(cd $SERPENT_BASE_PATH/demos/smo/concent; serpent concent) &");
        motif_widget_menu := false; 
      }
   }

  item3_menu_item: XawCommand   {
    Attributes:
      parent: menu1_bulletin_board;
     vertDistance: 53;
      horizDistance: 0;
      justify: 0;
      height: 20;
      width: 140;
      borderWidth: 1;
      label: "Calculator";
      font: "9x15bold";
    Methods:
      notify: { 
        system("(cd $SERPENT_BASE_PATH/demos/smo/calc; serpent calc) &");
        motif_widget_menu := false; 
      }
   }

  item4_menu_item: XawCommand   {
    Attributes:
      parent: menu1_bulletin_board;
     vertDistance: 73;
      horizDistance: 0;
      justify: 0;
      height: 20;
      width: 140;
      borderWidth: 1;
      label: "Grouping";
      font: "9x15bold";
    Methods:
      notify: { 
        system("(cd $SERPENT_BASE_PATH/demos/smo/group; serpent group) &");
        motif_widget_menu := false; 
      }
   }

  item5_menu_item: XawCommand   {
    Attributes:
      parent: menu1_bulletin_board;
     vertDistance: 93;
      horizDistance: 0;
      justify: 0;
      height: 20;
      width: 140;
      borderWidth: 1;
      label: "Menu Bar";
      font: "9x15bold";
    Methods:
      notify: { 
    system(
    "(cd $SERPENT_BASE_PATH/demos/smo/menubar; serpent menubar) &"
    );
        motif_widget_menu := false; 
      }
   }

  item6_menu_item: XawCommand   {
    Attributes:
      parent: menu1_bulletin_board;
     vertDistance: 113;
      horizDistance: 0;
      justify: 0;
      height: 20;
      width: 140;
      borderWidth: 1;
      label: "SIGCHI Talk";
      font: "9x15bold";
    Methods:
      notify: { 
        system("(cd $SERPENT_BASE_PATH/demos/smo/sigchi; serpent sigchi) &");
        motif_widget_menu := false; 
      }
   }


  item7_menu_item: XawCommand   {
    Attributes:
      parent: menu1_bulletin_board;
     vertDistance: 133;
      horizDistance: 0;
      justify: 0;
      height: 20;
      width: 140;
      borderWidth: 1;
      label: "Spider";
      font: "9x15bold";
    Methods:
      notify: { 
        system("(cd $SERPENT_BASE_PATH/demos/smo/spider; serpent spider) &");
        motif_widget_menu := false; 
      }
   }

  item8_menu_item: XawCommand   {
    Attributes:
      parent: menu1_bulletin_board;
     vertDistance: 153;
      horizDistance: 0;
      justify: 0;
      height: 20;
      width: 140;
      borderWidth: 1;
      label: "Vis Programmer";
      font: "9x15bold";
    Methods:
      notify: { 
        system("(cd $SERPENT_BASE_PATH/demos/smo/visprog; serpent visprog) &");
        motif_widget_menu := false; 
      }
   }
  item9_menu_item: XawCommand   {
    Attributes:
      parent: menu1_bulletin_board;
     vertDistance: 173;
      horizDistance: 0;
      justify: 0;
      height: 20;
      width: 140;
      borderWidth: 1;
      label: "Color Palette";
      font: "9x15bold";
    Methods:
      notify: { 
        system("(cd $SERPENT_BASE_PATH/demos/smo/color; serpent color) &");
        motif_widget_menu := false; 
      }
   }
  item10_menu_item: XawCommand   {
    Attributes:
      parent: menu1_bulletin_board;
     vertDistance: 193;
      horizDistance: 0;
      justify: 0;
      height: 20;
      width: 140;
      borderWidth: 1;
      label: "Font Selector";
      font: "9x15bold";
    Methods:
      notify: { 
        system("(cd $SERPENT_BASE_PATH/demos/smo/fontsel; serpent fontsel) &");
        motif_widget_menu := false; 
      }
   }

  remove_menu_item: XawCommand   {
    Attributes:
      parent: menu1_bulletin_board;
      justify: 0;
     vertDistance: 213;
      horizDistance: 0;
      borderWidth: 1;
      height: 20;
      width: 140;
      label: "Close";
      font: "9x15bold";
    Methods:
      notify: {
        motif_widget_menu := FALSE;
      }
   }

  ENDVC motif_widget_menu_vc













