    VC:	dialog
  
      /*
      ** Sub-VC to "sensor":
      **   The dialog VC controls the creation of dialog XawBoxes, which allow the
      **   user to change various sensor attributes.  A dialog XawBox is created
      **   when a sensor is selected.
      */
  
      CREATION CONDITION:	(display_dialog)
  
#     define LABEL_HEIGHT	(25)
#     define LABEL_WIDTH	(75)
  
      VARIABLES:
  
        count:		2;
  
      OBJECTS:
  
        the_dialog_form:	XawBboard        {
  
        ATTRIBUTES:
  
  	parent:		     the_window;
  	width:		     LABEL_WIDTH * 2 + 7;
  	height:		     (4 * LABEL_HEIGHT) + SENSOR_HEIGHT +25;
  	borderWidth:	     2;
  	borderColor:	     "white";

  	vertDistance:	     TOP_TO_MID_CC + (CC_HEIGHT / 2) + 20;
  	horizDistance:	     SIDE_TO_MIDDLE - LABEL_WIDTH;

  
        } /* end the_dialog_form */
  
        name_label:	XawLabel        {
  
  	ATTRIBUTES:
  
  	  parent:		the_dialog_form;
  	  width:		LABEL_WIDTH * 2;
  	  height:		LABEL_HEIGHT - 2;  
  	  label:		sensor_sdd.site;
          borderWidth: 0;  
          horizDistance: 0;
        } 			/* end name_label */
  
        status_label:	XawLabel     {
  
  	ATTRIBUTES:
  
  	  parent:		the_dialog_form;
  	  width:		LABEL_WIDTH;
  	  height:		LABEL_HEIGHT;
  	  vertDistance:	LABEL_HEIGHT+10;
  	  horizDistance:	0;
  	  label:		"STATUS";
  	  justify:		LEFT;  
        }				 /* end status_label */
  

        status_text:	XawText        {
  
  	ATTRIBUTES:
  
  	  parent:		the_dialog_form;
  	  width:		LABEL_WIDTH;
  	  height:		LABEL_HEIGHT;

  	  vertDistance:	LABEL_HEIGHT+10;
  	  horizDistance:	LABEL_WIDTH;
  	  editType:		2;
  	  length:		50;
  
  	  textBuffer:	  {
  	    IF (sensor_sdd.status = GREEN_STATUS) THEN
  	      textBuffer := "green";  
  	    ELSIF (sensor_sdd.status = YELLOW_STATUS) THEN
  	      textBuffer := "yellow";
  	    ELSIF (sensor_sdd.status = RED_STATUS) THEN
  	      textBuffer := "red"; 
  	    /* ELSE do nothing */  
  	    ENDIF;
  	  }
  
  	METHODS:
  
  	  send:  {
  	      IF (textBuffer = "green") THEN
		sensor_sdd.status := GREEN_STATUS;  
  	      ELSIF (textBuffer = "yellow") THEN
		sensor_sdd.status := YELLOW_STATUS;
  	      ELSIF (textBuffer = "red") THEN
		sensor_sdd.status := RED_STATUS;
  	  /*  ELSE do nothing */
  	      ENDIF;
  	      display_dialog := FALSE;
  	  }
  
        } /* end status_text */
  
        etro_label:  XawLabel        {  
  	ATTRIBUTES:
  	  parent:		the_dialog_form;
  	  width:		LABEL_WIDTH;
  	  height:		LABEL_HEIGHT;
  	  vertDistance:	2 * LABEL_HEIGHT+10;
  	  horizDistance:	0;
  	  label:		"ETRO";
  	  justify:		LEFT;  
        } /* end etro_label */
  
        etro_text:  XawText        {  
  	ATTRIBUTES:
  	  parent:		the_dialog_form;
  	  width:		LABEL_WIDTH;
  	  height:		LABEL_HEIGHT;
  	  vertDistance:	2 * LABEL_HEIGHT+10;
  	  horizDistance:	LABEL_WIDTH;
  	  editType:		2;
  	  length:		50;  
  	  textBuffer: sensor_sdd.etro;
  	METHODS:  
  	  send:	  {
            sensor_sdd.etro := textBuffer;
  	  }
  
        } /* end etro_text */
  
        rfo_label: XawLabel        {
  
  	ATTRIBUTES:
    	  parent:		the_dialog_form;
  	  width:		LABEL_WIDTH;
  	  height:		LABEL_HEIGHT;
  	  vertDistance:	3 * LABEL_HEIGHT+10;
  	  horizDistance:	0;
  	  label:		"RFO";
  	  justify:		LEFT;
  
        } /* end rfo_label */
  
        rfo_text:	XawText      {
  
  	ATTRIBUTES:
    	  parent:		the_dialog_form;
  	  width:		LABEL_WIDTH;
  	  height:		LABEL_HEIGHT;
  	  vertDistance:	3 * LABEL_HEIGHT+10;
  	  horizDistance:	LABEL_WIDTH;
  	  textBuffer:		sensor_sdd.rfo;  
        } /* end rfo_text */
  
        ok_button: XawCommand
  
        {
  
  	ATTRIBUTES:
  	  parent:		the_dialog_form;
  	  width:		SENSOR_WIDTH;
  	  height:		SENSOR_HEIGHT;
  	  vertDistance:	4 * LABEL_HEIGHT + 15;
  	  horizDistance:	45;  
  	  label:		"OK";
  
  	METHODS:
  
  	  notify:	  {
  	      status_text.sendBuffer := 1;
  	      etro_text.sendBuffer := 1;
  	  }
  
        } /* end ok_button */
  
    ENDVC  dialog

