  VC:  sensor

    /*
    ** Sub-VC to "dog":
    **   The sensor VC controls the creation of each sensor, including the
    **   lines from the sensor to the correlation centers.
    */

    CREATION CONDITION: (new ("sensor_sdd"))

#   define sensor_parent the_window

    VARIABLES:

      sensor_yloc;	/* set during ON CREATE */
      cc_line_hook_y:	sensor_yloc + (SENSOR_HEIGHT / 2);
      display_dialog:	FALSE;

    OBJECTS:

      right_sensor:  XawCommand      {

      ATTRIBUTES:
        parent:			sensor_parent;
        width:			SENSOR_WIDTH;
        height:			SENSOR_HEIGHT;
        borderWidth:		3;
        borderColor:		"white";
        background:	{
	  IF (sensor_sdd.status = GREEN_STATUS) THEN
		background := "green";
          ELSIF (sensor_sdd.status = YELLOW_STATUS) THEN
		background := "yellow";
          ELSIF (sensor_sdd.status = RED_STATUS) THEN
		background := "red";
          ENDIF;
	}
        foreground:	{
          IF (sensor_sdd.status = RED_STATUS) THEN
		foreground := "white";
          ELSE
		foreground := "black";
          ENDIF;
	}
	vertDistance:		sensor_yloc;
	horizDistance:		RIGHT_SENSOR_HOOK;
        label:		sensor_sdd.site_abbr;

      METHODS:
/*
**  Set display_dialog to true to force the display of a dialog XawBox.
*/
	notify: 	{
	  display_dialog := TRUE;
	}

      }

      left_sensor: XawCommand      {

      ATTRIBUTES:
        parent:			sensor_parent;
        width:			SENSOR_WIDTH;
        height:			SENSOR_HEIGHT;
        borderWidth:		3;
        borderColor:		"white";
        background:
	{
	  IF (sensor_sdd.status = GREEN_STATUS) THEN
		background := "green";
          ELSIF (sensor_sdd.status = YELLOW_STATUS) THEN
		background := "yellow";
          ELSIF (sensor_sdd.status = RED_STATUS) THEN
		background := "red";
       /* ELSE do nothing */
          ENDIF;
	}
        foreground:	{
          IF (sensor_sdd.status = RED_STATUS) THEN
            foreground := "white";
          ELSE
            foreground := "black";
          ENDIF;
	}
	vertDistance:		sensor_yloc;
	horizDistance:		SENSOR_TO_SIDE;
        label:		sensor_sdd.site_abbr;
      METHODS:
	notify:	{
	  /*
	  ** Set display_dialog to true to force the display of a dialog XawBox.
	  */
	  display_dialog := TRUE;
	}
      }

      ON CREATE:
      {
	/*
	** Increment the sensor number (located in the main VC, "dog").
	** Using that number, determine the Y location of the sensor that
	** caused the instantiation of this VC.
	*/
	sensor_number := sensor_number + 1;
	sensor_yloc   := SENSOR_TO_TOP + 
		   ( (sensor_number - 1) * (SENSOR_HEIGHT + SENSOR_TO_SENSOR));
      }

#include "etro.sl"
#include "dialog.sl"

  ENDVC  sensor
