#include "smo.ill"

||| 

/* This is the slang program which constructs a calculator It has one vc
and multiple objects.  The three variables carry the accumulator, the
decimal position and the current operator.  */

#define number_font "*times-bold-r-n*--20*"
#define button_font "*times-bold-r-n*--14*"
#define calculate(number) if (decimalpos = 0) then\
              display := 10 * display + number;\
           elsif (decimalpos = -1) then\
              display := number;\
              decimalpos := 0;\
           else\
              display := display + number / (10 ** \
                    decimalpos);\
              decimalpos :=decimalpos + 1;\
           endif;

#define set_operator(operator)\
              op := operator;\
              decimalpos := -1;\
              accumulator := display;

#define operate(symbol) decimalpos := -1;\
               accumulator := accumulator symbol display;\
               display := accumulator;


   VARIABLES:

   display : 0;
   accumulator : 0;
   decimalpos : 0;
   op : "";
/*
   The variable decimalpos serves three purposes.  
      If it is 0 then any numbers entered into the display are
        appended to the right of the current display but to the left of 
        the decimal point.
      if it is -1 then any number entered into the display erases the current
            display and sets display to number entered
      if it is positive then it represents the position to the right of
            the decimal point*/

   OBJECTS:


        main_background:     XmBulletinBoard
        {ATTRIBUTES:
           width:  300;
           height: 500;
           resizePolicy: 0;
         }   

/*-----------------------------------------------------------------------
|    Object: display on top of calculator
|
---------------------------------------------------------------------*/

        display_widget: XmLabel
        {ATTRIBUTES:

          parent: main_background;
          y: 20;
          x: 65;
          height: 40;
          width: 210;
          alignment: 2;
          labelString: display;
          borderWidth: 3;
          borderColor: "black";
          background: "white";
          recomputeSize: FALSE;
          fontList: number_font;
         }

/*------------------------------------------------------------------------
|       Object: display  off button 
------------------------------------------------------------------------*/

        digit_off: XmPushButton
        {ATTRIBUTES:
           parent: main_background;
           labelString: "OFF";
           width: 35;
           height: 40;
           alignment: 1;
           y: 20;
           x: 15;
           borderColor: "black";
           borderWidth: 3;
           fontList: button_font;


         METHODS:
          notify: {
             exit();
          }
        }


/*------------------------------------------------------------------------
|       Object: display  digit 7  
------------------------------------------------------------------------*/

	digit7: XmPushButton
	{ATTRIBUTES:
           parent: main_background;  
	   labelString: "7";
	   width: 50;
	   height: 50;
	   alignment: 1;
           y:100;
           x: 20;
           borderColor: "black";
           borderWidth: 2;
           fontList: number_font;


         METHODS:
          notify: {
             calculate (7)
          }
	}

/*------------------------------------------------------------------------
|       Object: display  digit 7  
------------------------------------------------------------------------*/

	digit8: XmPushButton
	{ATTRIBUTES:
           parent: main_background;  
	   labelString: "8";
	   width: 50;
	   height: 50;
	   alignment: 1;
           y: 100;
           x: 90;
           borderColor: "black";
           borderWidth: 2;
           fontList: number_font; 


         METHODS:
          notify: {
            calculate (8)
          }
	}

/*------------------------------------------------------------------------
|       Object: display  digit 7  
------------------------------------------------------------------------*/

	digit9: XmPushButton
	{ATTRIBUTES:
           parent: main_background;  
	   labelString: "9";
	   width: 50;
	   height: 50;
	   alignment: 1;
           y: 100;
           x: 160;
           borderColor: "black";
           borderWidth: 2;
           fontList: number_font;


         METHODS:
          notify: {
            calculate (9)
          }
	}

/*------------------------------------------------------------------------
|       Object: display  digit 7  
------------------------------------------------------------------------*/

	digit4: XmPushButton
	{ATTRIBUTES:
           parent: main_background;  
	   labelString: "4";
	   width: 50;
	   height: 50;
	   alignment: 1;
           y: 170;
           x:  20;
           borderColor: "black";
           borderWidth: 2;
           fontList: number_font;


         METHODS:
          notify: {
           calculate (4)
          }
	}

/*------------------------------------------------------------------------
|       Object: display  digit 5  
------------------------------------------------------------------------*/
	digit5: XmPushButton
	{ATTRIBUTES:
           parent: main_background;  
	   labelString: "5";
	   width: 50;
	   height: 50;
	   alignment: 1;
           y: 170;
           x:  90;
           borderColor: "black";
           borderWidth: 2;
           fontList: number_font;


         METHODS:
          notify: {
           calculate (5)
          }
	}

	digit6: XmPushButton
	{ATTRIBUTES:
           parent: main_background;  
	   labelString: "6";
	   width: 50;
	   height: 50;
	   alignment: 1;
           y: 170;
           x: 160;
           borderColor: "black";
           borderWidth: 2;
           fontList: number_font;


         METHODS:
          notify: {
           calculate (6)
          }
	}

	digit1: XmPushButton
	{ATTRIBUTES:
           parent: main_background;  
	   labelString: "1";
	   width: 50;
	   height: 50;
	   alignment: 1;
           y: 240;
           x:  20;
           borderColor: "black";
           borderWidth: 2;
           fontList: number_font;


         METHODS:
          notify: {
           calculate (1)
          }
	}

	digit2: XmPushButton
	{ATTRIBUTES:
           parent: main_background;  
	   labelString: "2";
	   width: 50;
	   height: 50;
	   alignment: 1;
           y: 240;
           x: 90;
           borderColor: "black";
           borderWidth: 2;
           fontList: number_font;


         METHODS:
          notify: {
            calculate (2)
          }
	}

	digit3: XmPushButton
	{ATTRIBUTES:
           parent: main_background;  
	   labelString: "3";
	   width: 50;
	   height: 50;
	   alignment: 1;
           y: 240;
           x: 160;
           borderColor: "black";
           borderWidth: 2;
           fontList: number_font;


         METHODS:
          notify: {
           calculate (3)
          }
	}

	digit0: XmPushButton
	{ATTRIBUTES:
           parent: main_background;  
	   labelString: "0";
	   width: 50;
	   height: 50;
	   alignment: 1;
           y: 310; 
           x:  90;
           borderColor: "black";
           borderWidth: 2;
           fontList: number_font;


         METHODS:
          notify: {
            calculate (0)
          }
	}

	cleardisplay: XmPushButton
	{ATTRIBUTES:
           parent: main_background;  
	   labelString: "CE";
	   width: 50;
	   height: 50;
	   alignment: 1;
           y: 310;
           x:  20;
           borderColor: "black";
           borderWidth: 2;
           fontList: number_font;


         METHODS:
          notify: {

          display := 0;
          decimalpos := 1;
          }
	}

	decimal: XmPushButton
	{ATTRIBUTES:
           parent: main_background;  
	   labelString: ".";
	   width: 50;
	   height: 50;
	   alignment: 1;
           y: 310;
           x: 160;
           borderColor: "black";
           borderWidth: 2;
           fontList: number_font;


         METHODS:
          notify: {

           if(decimalpos = 0) then
             decimalpos := 1;
           elsif ( decimalpos = -1) then
             display := 0;
             decimalpos := 1;
           endif;

          }
	}

	clearaccum: XmPushButton
	{ATTRIBUTES:
           parent: main_background;  
	   labelString: "C";
	   width: 35;
	   height: 30;
	   alignment: 1;
           y: 100;
           x: 230;
           borderColor: "black";
           borderWidth: 2;
           fontList: button_font;


         METHODS:
          notify: {

            display := 0;
            decimalpos := 0;
            accumulator := 0;


          }
	}

	divide: XmPushButton
	{ATTRIBUTES:
           parent: main_background;  
	   labelString: "/";
	   width: 35;
	   height: 30;
	   alignment: 1;
           y: 140;
           x: 230;
           borderColor: "black";
           borderWidth: 2;
           fontList: button_font;


         METHODS:
          notify: {
           set_operator("div")
          }
	}

	multiply: XmPushButton
	{ATTRIBUTES:
           parent: main_background;  
	   labelString: "X";
	   width: 35;
	   height: 30;
	   alignment: 1;
           y: 180;
           x: 230;
           borderColor: "black";
           borderWidth: 2;
           fontList: button_font;
 

         METHODS:
          notify: {
            set_operator("mult")
          }
	}


	add: XmPushButton
	{ATTRIBUTES:
           parent: main_background;  
	   labelString: "+";
	   width: 35;
	   height: 30;
	   alignment: 1;
           y: 220;
           x: 230;
           borderColor: "black";
           borderWidth: 2;
           fontList: button_font;


         METHODS:
          notify: {
            set_operator("add")
          }
	}

        subtract: XmPushButton
        {ATTRIBUTES:
           parent: main_background;
           labelString: "-";
           width: 35;
           height: 30;
           alignment: 1;
           y: 260;
           x: 230;

           borderColor: "black";
           borderWidth: 2;
           fontList: button_font;


         METHODS:
          notify: {
            set_operator ("sub")
          }
        }

	equal: XmPushButton
	{ATTRIBUTES:
           parent: main_background;  
	   labelString: "=";
	   width: 35;
	   height: 40;
	   alignment: 1;
           y: 320;
           x: 230;
           borderColor: "black";
           borderWidth: 2;
           fontList: number_font;


         METHODS:
          notify: {
            If (op = "div") then
               operate (/)
            elsif (op = "mult") then
               operate (*)
            elsif (op = "add") then
               operate (+)
            elsif (op = "sub") then
               operate (-)
            endif;
          }
	}

