/*
 * Clock demo - fourth pass
 *
 * This demo program shows the clock demo in its fourth stage of development,
 * where the interface has completely changed, leaving the application
 * program untouched.
 */
#include "smo.ill"
#include "threeA.ill"

|||

#include "glueXm.h"


OBJECTS :

    palette : XmBulletinBoard {
	ATTRIBUTES :
	    height : 100;
	    width : 300;
	    }

    quit : XmPushButton {
	ATTRIBUTES :
	    parent : palette;
	    labelstring : "Quit";
	    borderwidth : 1;
	    shadowthickness : 3;
	    height : palette.height - 40;
	    width : height;
	    x : palette.width - (width + 20);
	    y : palette.height - (height + 20);
	METHODS :
	    notify : { exit(); }
	    }
	    
    /*=====================================================*/

    VC : current_time
	CREATION CONDITION : ( new("sd_time") )

	OBJECTS:
	    hours : XmScale {
		ATTRIBUTES :
		    parent : palette;
		    minimum : 0;
		    maximum : 23;
		    value : sd_time.hrs;
		    showvalue : true;
		    orientation : XmHORIZONTAL;
		    processingDirection : XmMAX_ON_RIGHT;
		    height : 15;
		    width : 200;
		    x : 10;
		    y : 5;
		METHODS :
		    value_changed : { sd_time.hrs := value; }
		    }

	    minutes : XmScale {
		ATTRIBUTES :
		    parent : palette;
		    minimum : 0;
		    maximum : 59;
		    value : sd_time.mins;
		    showvalue : true;
		    orientation : XmHORIZONTAL;
		    processingDirection : XmMAX_ON_RIGHT;
		    height : 15;
		    width : 200;
		    x : 10;
		    y : 55;
		METHODS :
		    value_changed : { sd_time.mins := value; }
		    }
    
	ENDVC current_time
