/*
 * Clock demo - first pass
 *
 * This demo program shows the clock demo in its first stage of development,
 * where only the objects are displayed, but there is as yet no dialogue
 * actions, and no application.  The radio buttons and checkboxes "work",
 * but that is only because of the Motif binding - they do not "do" anything.
 */
#include "smo.ill"

|||

#include "glueXm.h"

OBJECTS :

	palette : XmBulletinBoard {
		ATTRIBUTES :
			height : 200;
			width : 375;
			}

	quit : XmPushButton {
		ATTRIBUTES :
			parent : palette;
			labelstring : "Quit";
			height : 35;
			width : 40;
			x : palette.width - width - 10;
			y : palette.height - height - 10;
		METHODS :
			notify : { exit(); }
			}

	FormatSelector : XmRowColumn {
		ATTRIBUTES :
			parent : palette;
			height : 100;
			width : 200;
			x : 95;
			y : 65;
			packing : XmPACK_COLUMN;
			numcolumns : 1;
			orientation : XmVERTICAL;
			radiobehavior : true;
			radioalwaysone : true;
			}

	Button1 : XmToggleButton {
		ATTRIBUTES :
			parent : FormatSelector;
			labelString : "12 Hour";
			indicatortype : XmONE_OF_MANY;
			borderwidth : 1;
			width : 75;
			height : 30;
			set : false;
			}

	Button2 : XmToggleButton {
		ATTRIBUTES :
			parent : FormatSelector;
			labelString : "24 Hour";
			indicatortype : XmONE_OF_MANY;
			borderwidth : 1;
			width : 75;
			height : 30;
			set : true;
			}

	Show_Date : XmToggleButton {
		ATTRIBUTES :
			parent : palette;
			labelString : "Show Date";
			borderwidth : 1;
			x : 200;
			y : 80;
			width : 80;
			height : 20;
			set : false;
			}
	
	Set_Time : XmToggleButton {
		ATTRIBUTES :
			parent : palette;
			labelString : "Set";
			borderwidth : 1;
			x : 320;
			y : 20;
			width : 40;
			height : 20;
			set : false;
			}

	hours : XmLabel {
		ATTRIBUTES :
			parent : palette;
			fontlist : "*-courier-bold-r-*-*-34-*";
			labelstring : "13";
			recomputesize : false;
			borderwidth : 1;
			height : 25;
			width : 40;
			x : 115;
			y : 15;
			}

	colon : XmLabel {
		ATTRIBUTES :
			parent : palette;
			fontlist : "*-courier-bold-r-*-*-34-*";
			labelstring : ":";
			recomputesize : false;
			borderwidth : 1;
			height : 25;
			width : 15;
			x : 155;
			y : 15;
			}

	minutes : XmLabel {
		ATTRIBUTES :
			parent : palette;
			fontlist : "*-courier-bold-r-*-*-34-*";
			labelstring : "05";
			recomputesize : false;
			borderwidth : 1;
			height : 25;
			width : 40;
			x : 170;
			y : 15;
			}

	AM_PM : XmLabel {
		ATTRIBUTES :
			parent : palette;
			fontlist : "*-courier-bold-r-*-*-24-*";
			labelstring : "AM";
			recomputesize : false;
			borderwidth : 1;
			height : 23;
			width : 40;
			x : 215;
			y : 17;
			}

	today : XmLabel {
		ATTRIBUTES :
			parent : palette;
			fontlist : "*-times-bold-r-*-*-20-*";
			labelstring : "February 12, 1991";
			recomputesize : false;
			borderwidth : 1;
			height : 35;
			width : 200;
			x : 85;
			y : 130;
			}
	
	hrs_up : XmArrowButton {
		ATTRIBUTES :
			parent : palette;
			arrowdirection : XmARROW_UP;
			shadowthickness : 0;
			borderwidth : 1;
			height : 12;
			width : 12;
			x : 100;
			y : 15;
			}

	hrs_down : XmArrowButton {
		ATTRIBUTES :
			parent : palette;
			arrowdirection : XmARROW_DOWN;
			shadowthickness : 0;
			borderwidth : 1;
			height : 12;
			width : 12;
			x : 100;
			y : 30;
			}

	mins_up : XmArrowButton {
		ATTRIBUTES :
			parent : palette;
			arrowdirection : XmARROW_UP;
			shadowthickness : 0;
			borderwidth : 1;
			height : 12;
			width : 12;
			x : 213;
			y : 15;
			}

	mins_down : XmArrowButton {
		ATTRIBUTES :
			parent : palette;
			arrowdirection : XmARROW_DOWN;
			shadowthickness : 0;
			borderwidth : 1;
			height : 12;
			width : 12;
			x : 213;
			y : 30;
			}
