#include "serpent.h"
#include "threeA.h"
#include <sys/time.h>

#define NO_CHANGE 999

void find_time (cur_time)
sd_time *cur_time;
{
    struct timeval tv;
    struct timezone tz;
    struct tm *now;
    static char *month[] = {
	"January", "February", "March", "April", "May", "June",
	"July", "August", "September", "October", "November", "December" };

    gettimeofday (&tv, &tz);
    now = localtime (&tv.tv_sec);
    cur_time->hrs = now->tm_hour;
    cur_time->mins = now->tm_min;
    (void) sprintf (cur_time->date, "%s %d, %d", month[now->tm_mon],
			now->tm_mday, now->tm_year+1900);
}

void adjust_time (cur_time, delta)
sd_time *cur_time, *delta;
{
    cur_time->hrs += delta->hrs;
    cur_time->mins += delta->mins;
}

main ()
{
    sd_time cur_time, from_dlg, delta;
    transaction_type trans;
    id_type id;

    serpent_init (MAIL_BOX, ILL_FILE);
    trans = start_transaction ();
    find_time (&cur_time);
    id = add_shared_data (trans, "sd_time", NULL, &cur_time);
    commit_transaction (trans);

    delta.hrs = delta.mins = 0;

    while (1) {
	sleep (5);
	find_time (&cur_time);
	from_dlg.hrs = from_dlg.mins = NO_CHANGE;
	while (trans = get_transaction_no_wait ()) {
	    id = get_first_changed_element (trans);
	    incorporate_changes (trans, id, &from_dlg);
	    if (from_dlg.hrs != NO_CHANGE)
		delta.hrs = from_dlg.hrs - cur_time.hrs;
	    if (from_dlg.mins != NO_CHANGE)
		delta.mins = from_dlg.mins - cur_time.mins;
	    purge_transaction (trans);
	    }
	adjust_time (&cur_time, &delta);
	trans = start_transaction ();
	put_shared_data (trans, id, "sd_time", NULL, &cur_time);
	commit_transaction (trans);
	}
}
