#include "smo.ill"
#include "fontsel.ill"

|||

#include "fonts.h"

#define TOPLINE_TOP	10
#define TOPLINE_HEIGHT	20
#define DOIT_WIDTH	50
#define SAMPLE_TOP	TOPLINE_TOP+TOPLINE_HEIGHT+10
#define SAMPLE_HEIGHT	40
#define SAMPLE_OFFSET	10
#define NAME_TOP	SAMPLE_TOP+SAMPLE_HEIGHT+50
#define NAME_HEIGHT	20
#define NAME_WIDTH      210
#define NAME_OFFSET	SAMPLE_OFFSET
#define SLANT_TOP	SAMPLE_TOP+SAMPLE_HEIGHT+50
#define SLANT_HEIGHT	20
#define SLANT_WIDTH	80
#define SLANT_OFFSET	NAME_OFFSET+NAME_WIDTH+10
#define WEIGHT_TOP	\
	    SAMPLE_TOP+SAMPLE_HEIGHT+50+(howmany_of(FONT_SLANT)+2)*SLANT_HEIGHT
#define WEIGHT_HEIGHT	SLANT_HEIGHT
#define WEIGHT_WIDTH	SLANT_WIDTH
#define WEIGHT_OFFSET	SLANT_OFFSET
#define SIZE_TOP	SAMPLE_TOP+SAMPLE_HEIGHT+50
#define SIZE_HEIGHT	20
#define SIZE_WIDTH	50
#define SIZE_OFFSET	WEIGHT_OFFSET+WEIGHT_WIDTH+10
#define FONTSTRING_TOP  SAMPLE_TOP + 40
                         

EXTERNALS:
    integer howmany_of(integer);
    string fetch_val(integer,integer);
    boolean font_exists(string,string,string,string);
    integer int_max(integer,integer);
    string font_str(string,string,string,string);

Objects:

display: screenObject {}

  On Create: {
    recording_on("fontsel.rec", "dialogue recording");
  }

VC : font_palette

    CREATION CONDITION: (display.width <> UNDEFINED)

    VARIABLES:
	i;
	max;
	fid;
	cur_name : "*";
	cur_size : "*";
	cur_slant : "*";
	cur_weight : "*";
	cur_name_id;
	cur_size_id;
	cur_slant_id;
	cur_weight_id;
	cur_name_idx : 0;	/* TODO: initialize to the current settings */
	cur_size_idx : 0;
	cur_slant_idx : 0;
	cur_weight_idx : 0;
 
    OBJECTS:

	shell : XmApplicationShell {
	    ATTRIBUTES :
		height : palette.height;
		width : palette.width;
		allowShellResize : true;
		}

	palette : XmBulletinBoard {
	    ATTRIBUTES:
		parent : shell;
		width : SIZE_OFFSET+SIZE_WIDTH+10;
		height : int_max( howmany_of(FONT_SIZE)*SIZE_HEIGHT,
				  howmany_of(FONT_NAME)*NAME_HEIGHT )+NAME_TOP;
		x : 100;
		y : 250;
             }
	apply : XmPushButton {
	    ATTRIBUTES:
		parent : palette;
		width : DOIT_WIDTH;
		height : TOPLINE_HEIGHT;
		borderWidth : 3;
		labelString : "Apply";
		alignment : 1;
		x : NAME_OFFSET;
		y : TOPLINE_TOP;
	    }

	title : XmLabel {
	    ATTRIBUTES:
		parent : palette;
		width : palette.width-(2*DOIT_WIDTH);
		height : TOPLINE_HEIGHT-5;
		borderWidth : 0;
                fontList : "*cour*b*r*n*14*";
		labelString : "Font Palette";
		alignment : 1;
		x : NAME_OFFSET+DOIT_WIDTH+6;
		y : TOPLINE_TOP;
	    }

	done : XmPushButton {
	    ATTRIBUTES:
		parent : palette;
		width : DOIT_WIDTH;
		height : TOPLINE_HEIGHT;
		borderWidth : 3;
		labelString : "Done";
		alignment : 1;
		x : (SIZE_OFFSET+SIZE_WIDTH)-DOIT_WIDTH;
		y : TOPLINE_TOP;
	    METHODS:
		notify : {
		    exit();
		    }
	    }

	sample : XmLabel {
	    ATTRIBUTES:
		parent : palette;
		width : (SIZE_OFFSET+SIZE_WIDTH)-SAMPLE_OFFSET;
		height : SAMPLE_HEIGHT;
		borderWidth : 1;
		fontList : font_str(cur_name,cur_size,cur_slant,cur_weight);
		labelString : {
			if (display.color) then
				labelString := "Color Font Sample";
			else
				labelString := "Font Sample";
			endif;
			}
                alignment: 1;
                recomputeSize: FALSE;
		x : NAME_OFFSET;
		y : SAMPLE_TOP;
	    }

	fontstring : XmLabel {
	    ATTRIBUTES:
		parent : palette;
		width : (SIZE_OFFSET+SIZE_WIDTH)-SAMPLE_OFFSET;
		height : SAMPLE_HEIGHT;
		borderWidth : 1;
		fontList : "*cour*b*r*n*10*";
		labelString : font_str(cur_name,cur_size,cur_slant,cur_weight);
                alignment: 1;
                recomputeSize: FALSE;
		x : NAME_OFFSET;
		y : FONTSTRING_TOP;
	    }

    ON CREATE: {
	i := 0;
	max := howmany_of(FONT_NAME);
	WHILE (i < max) DO
	    fid := create_sd_instance("fontname", "DM_BOX");
	    put_sd_value(fid, "idx", i);
	    put_sd_value(fid, "vert", NAME_TOP+(i*NAME_HEIGHT));
	    put_sd_value(fid, "name", fetch_val(FONT_NAME, i));
	    i := i + 1;
	END WHILE;
	i := 0;
	max := howmany_of(FONT_SIZE);
	WHILE (i < max) DO
	    fid := create_sd_instance("fontsize", "DM_BOX");
	    put_sd_value(fid, "idx", i);
	    put_sd_value(fid, "vert", SIZE_TOP+(i*SIZE_HEIGHT));
	    put_sd_value(fid, "size", fetch_val(FONT_SIZE, i));
	    i := i + 1;
	END WHILE;
	i := 0;
	max := howmany_of(FONT_SLANT);
	WHILE (i < max) DO
	    fid := create_sd_instance("fontslant", "DM_BOX");
	    put_sd_value(fid, "idx", i);
	    put_sd_value(fid, "vert", SLANT_TOP+(i*SLANT_HEIGHT));
	    put_sd_value(fid, "slant", fetch_val(FONT_SLANT, i));
	    i := i + 1;
	END WHILE;
	i := 0;
	max := howmany_of(FONT_WEIGHT);
	WHILE (i < max) DO
	    fid := create_sd_instance("fontweight", "DM_BOX");
	    put_sd_value(fid, "idx", i);
	    put_sd_value(fid, "vert", WEIGHT_TOP+(i*WEIGHT_HEIGHT));
	    put_sd_value(fid, "weight", fetch_val(FONT_WEIGHT, i));
	    i := i + 1;
	END WHILE;
	}

    VC : font_name
	CREATION CONDITION: ( new("fontname") )

	OBJECTS:
	   selector : XmPushButton {
		ATTRIBUTES:
		    parent: palette;
		    height: NAME_HEIGHT;
		    width: NAME_WIDTH;
                    foreground : "black";
		    labelString: fontname.name;
		    recomputeSize: FALSE;
		    sensitive: font_exists(fontname.name,cur_size,cur_slant,cur_weight);
		    fontList: "*cour*b*r*n*14*";
		    alignment: 1;
		    x : NAME_OFFSET;
		    y : fontname.vert;
		METHODS:
		    notify : {
                        if (display.color) then
                          put_sd_value(cur_name_id,"background","cornflower blue");
                          background := "tan";
                        else
                          put_sd_value(cur_name_id,"background","white");
                          background := "black";
                          put_sd_value(cur_name_id,"foreground","black");
                          foreground := "white";
                        endif;
			cur_name := fontname.name;
			cur_name_id := selector;
			cur_name_idx := fontname.idx;
			}
		}

	ON CREATE: {
	    IF (fontname.idx = cur_name_idx) THEN
		cur_name := fontname.name;
		cur_name_id := selector;
                if (display.color) then 
                  selector.background := "tan";
                else
                  selector.foreground := "white";
                  selector.background := "black";
                endif; 
	    END IF;
	    }
    END VC font_name;

    VC : font_size
	CREATION CONDITION: ( new("fontsize") )

	OBJECTS:
	    selector : XmPushButton {
		ATTRIBUTES:
		    parent: palette;
		    height: SIZE_HEIGHT;
		    width: SIZE_WIDTH;
                    foreground : "black";
		    labelString: fontsize.size;
		    recomputeSize: FALSE;
		    sensitive: font_exists(cur_name,fontsize.size,cur_slant,cur_weight);
		    fontList: "*cour*b*r*n*14*";
		    alignment: 1;
		    x : SIZE_OFFSET;
		    y : fontsize.vert;
		METHODS:
		    notify : {
                        if (display.color) then
                          put_sd_value(cur_size_id,"background","cornflower blue");
                          background := "tan";
                        else
                          put_sd_value(cur_size_id,"background","white");
                          background := "black";
                          put_sd_value(cur_size_id,"foreground","black");
                          foreground := "white";
                        endif;
			cur_size := fontsize.size;
			cur_size_id := selector;
			cur_size_idx := fontsize.idx;
			}
		}

	ON CREATE: {
	    IF (fontsize.idx = cur_size_idx) THEN
		cur_size := fontsize.size;
		cur_size_id := selector;
                if (display.color) then 
                  selector.background := "tan";
                else
                  selector.foreground := "white";
                  selector.background := "black";
                endif;
	    END IF;
	    }
    END VC font_size;

    VC : font_slant
	CREATION CONDITION: ( new("fontslant") )

	OBJECTS:
	    selector : XmPushButton {
		ATTRIBUTES:
		    parent: palette;
		    height: SLANT_HEIGHT;
		    width: SLANT_WIDTH;
                    foreground : "black";
		    labelString: fontslant.slant;
		    recomputeSize: FALSE;
		    sensitive: font_exists(cur_name,cur_size,fontslant.slant,cur_weight);
		    fontList: "*cour*b*r*n*14*";
		    alignment: 1;
		    x : SLANT_OFFSET;
		    y : fontslant.vert;
		METHODS:
		    notify : {
                        if (display.color) then
                          put_sd_value(cur_slant_id,"background","cornflower blue");
                          background := "tan";
                        else
                          put_sd_value(cur_slant_id,"background","white");
                          background := "black";
                          put_sd_value(cur_slant_id,"foreground","black");
                          foreground := "white";
                        endif;
			cur_slant := fontslant.slant;
			cur_slant_id := selector;
			cur_slant_idx := fontslant.idx;
			}
		}

	ON CREATE: {
	    IF (fontslant.idx = cur_slant_idx) THEN
		cur_slant := fontslant.slant;
		cur_slant_id := selector;
                if (display.color) then
                  selector.background := "tan";
                else
                  selector.foreground := "white";
                  selector.background := "black";
                endif;
	    END IF;
	    }
    END VC font_slant;

    VC : font_weight
	CREATION CONDITION: ( new("fontweight") )

	OBJECTS:
	    selector : XmPushButton {
		ATTRIBUTES:
		    parent: palette;
		    height: WEIGHT_HEIGHT;
		    width: WEIGHT_WIDTH;
                    foreground : "black";
		    labelString: fontweight.weight;
		    recomputeSize: FALSE;
		    sensitive: font_exists(cur_name,cur_size,cur_slant,fontweight.weight);
		    fontList: "*cour*b*r*n*14*";
		    alignment: 1;
		    x : WEIGHT_OFFSET;
		    y : fontweight.vert;
		METHODS:
		    notify : {
                        if (display.color) then
                          put_sd_value(cur_weight_id,"background","cornflower blue");
                          background := "tan";
                        else
                          put_sd_value(cur_weight_id,"background","white");
                          background := "black";
                          put_sd_value(cur_weight_id,"foreground","black");
                          foreground := "white";
                        endif;
			cur_weight := fontweight.weight;
			cur_weight_id := selector;
			cur_weight_idx := fontweight.idx;
			}
		}

	ON CREATE: {
	    IF (fontweight.idx = cur_weight_idx) THEN
		cur_weight := fontweight.weight;
		cur_weight_id := selector;
                if (display.color) then
                  selector.background := "tan";
                else
                  selector.foreground := "white";
                  selector.background := "black";
                endif;
	    END IF;
	    }
    END VC font_weight;

END VC font_palette;
