#include "smo.ill"

|||

/*----------------------------------------------------------------------------
|  This demonstrates the use of Slang to produce a menu bar with two tear off
|   menus.  Initially there is a menu bar presented to the user with two
|   options - Menu_1 and Menu_2.  When the user chooses one of those options
|   another menu comes up, the user must position this menu and it stays up
|   until the user chooses "Remove" on that menu.
|------------------------------------------------------------------------*/

Variables:

  display_menu1_submenu : FALSE;
  display_menu2_submenu : FALSE;
  display_sub_item_submenu : FALSE;

Objects:

  menu_bar_bulletin_board: bulletin_board_widget
  {
    Attributes:

    height:500;
    width: 500;
    resize_policy: 0;
  }
  menu_bar: bulletin_board_widget
  {
    Attributes:
    parent: menu_bar_bulletin_board;
    height:55;
    width: 175;
    y:20;
    x:20; 
    border_width: 3;

  }

  menu1_item: push_button_widget
   {
    Attributes:
      parent: menu_bar;

      y: 10;
      x: 10;
      height        : 20;
      width         : 50;
      label_string          : "Menu_1";
      border_width: 0;
    Methods:

      notify:
      {
        display_menu1_submenu := TRUE;
      }
   }

  menu2_item: push_button_widget
   {
    Attributes:

      parent        : menu_bar;

      y: 10;
      x: 60;
      height        : 20;
      width         : 50;

      label_string          : "Menu_2";

    Methods:

      notify:
      {
        display_menu2_submenu := TRUE;
      }

    }

     quit_menu_item:  push_button_widget

     { ATTRIBUTES:

       parent:  menu_bar;
       height: 20;
       width: 50;
       y: 10;
       x: 110;
       label_string: "QUIT";
/*       alignment: 1; */

    METHODS:

      notify:
        {
         exit ();
        }
   }


/*-------- menu1 view controller ----------------*/

VC:  menu1_submenu

Creation Condition:  (display_menu1_submenu)

Objects:

  menu1_bulletin_board: bulletin_board_widget {
    Attributes:
      parent: menu_bar;

      y: 30;
      x: 0;
      border_width: 2;
      height: 100;
      width: 70;

}

  item1_menu_item: push_button_widget
  {
    Attributes:
    
      parent        : menu1_bulletin_board;

      y: 0;
      x: 0;
      alignment: 0;
      height: 20;
      width: 70;
      border_width: 1;
      label_string: "Item 1";
      background_color: "white";
      foreground_color: "black";

    Methods:
/*   This method would be invoked when the end-user selected the blue
     button
      notify:{ code would be placed here to set something to blue
     }*/
    }

  item2_menu_item: push_button_widget 
  {
    Attributes:
      parent        : menu1_bulletin_board;


      y: 33;
      x: 0;
      alignment: 0;
      height: 20;
      width: 70;
      border_width: 1;
      label_string: "Item 2 ->";
      background_color: "black";
      foreground_color: "white";
    Methods:

      notify:
      { 
        display_sub_item_submenu := TRUE; 
      }
   }

  remove_menu_item: push_button_widget
   {

    Attributes:
      parent        : menu1_bulletin_board;
      alignment: 0;
      y: 53;
      x: 0;
      border_width: 1;
      height: 20;
      width: 70;

      label_string: "Close";

    Methods:

      notify:
      {
        display_menu1_submenu := FALSE;
      }
   }

  ENDVC colors_submenu

/*-------- sub_item_submenu view controller ----------------*/

VC:  sub_item_submenu

Creation Condition:  (display_sub_item_submenu)

Objects:

  sub_item_bulletin_board: bulletin_board_widget {
    Attributes:
      parent: menu_bar;

      y: 62;
      x: 90;
      border_width: 2;
      height: 100;
      width: 70;

}

  itema_menu_item: push_button_widget
  {
    Attributes:
    
      parent:  sub_item_bulletin_board;

      y: 0;
      x: 0;
      alignment: 0;
      height: 20;
      width: 70;
      border_width: 1;
      label_string: "Item A";
      background_color: "white";
      foreground_color: "black";

    Methods:
/*   This method would be invoked when the end-user selected the blue
     button
      notify:{ code would be placed here to set something to blue
     }*/
    }

  itemb_menu_item: push_button_widget 
  {
    Attributes:
      parent:  sub_item_bulletin_board;


      y: 33;
      x: 0;
      alignment: 0;
      height: 20;
      width: 70;
      border_width: 1;
      label_string: "Item B";
      background_color: "black";
      foreground_color: "white";
    Methods:
/*   This method would be invoked when the end-user selected the red
     button
      notify:{ code would be placed here to set something to red
     }*/
   }

  remove_menu_item: push_button_widget
   {

    Attributes:
      parent:  sub_item_bulletin_board;
      alignment: 0;
      y: 53;
      x: 0;
      border_width: 1;
      height: 20;
      width: 70;

      label_string: "Close";

    Methods:

      notify:
      {
        display_sub_item_submenu := FALSE;
      }
   }

  ENDVC sub_item_submenu


