#include "smo.ill"
#include "glueXm.h"

|||

#define label(labelname,horiz,vert,widget_label)\
labelname: XmLabel {\
Attributes:\
  parent: workspace;\
  x:horiz;\
  y:vert;\
  width: 100;\
  height: 20;\
  borderWidth: 1;\
  labelString: widget_label;\
}

#define wig_pos   105  /* column position offset */
#define offset      5  /* allows widgets to be offset 5 columns */
#define row1        5  /* y pos for row 1  */
#define row2      130  /* y pos for row 2  */
#define row3      250  /* y pos for row 3  */
#define row4      390  /* y pos for row 4  */
#define wwide      90  /* width for each widget */
#define high       80  /* height for each widget */
#define row1label 100  /* position for 1st row of labels */
#define row2label 220  /* position for 2nd row of labels */

/* color stuff */
#define mainbackgnd  "sky blue"
#define backgnd_row1 "turquoise"
#define backgnd_row3 "medium aquamarine"
#define backgnd_row2 "wheat" 
/*
#define backgnd_row1 "turquoise"
#define backgnd_row2 "turquoise"
#define backgnd_row3 "turquoise"
*/


Variables:

display_secondary_widgets: false;
display_errorbox : false;

Objects:

display: screenObject {}

  On Create: {
    recording_on("pertab.rec", "dialogue recording");
  }
VC:  top_level

  Creation Condition: (display.width <> UNDEFINED)

Variables:
  counter: 0;

  Objects:

/* The TopLevelShell */

    se_shell: XmApplicationShell {
      Attributes:
        iconname: "PerTable";
        iconpixmap: "pertab.sbm";
        title: "Periodic Table";
    }

    workspace: XmBulletinBoard {
      Attributes:
        parent:  se_shell;
        width: display.width - 40;
        height: display.height - 100;
        borderColor: "white";
        resizepolicy: false;
        background: { if (display.color) then
                        background:= mainbackgnd;
                      else 
                        background:= "white";
                      endif;
                    }
    }


/*------------------------  The Widgets ----------------------------------*/

/* ---------  the first row ------------*/
/*
**  XmArrowButton Widget.
*/
    a_XmArrowButton: XmArrowButton {
      Attributes:
        parent: workspace;
        x: 0;
        y: 0;
        height: high;
        width: wwide;
        shadowthickness: 5;
        highlightthickness: 10;
        background: { if (display.color) then
                        background:= backgnd_row1;
                      endif;
                    }

      Methods:
/* this causes the arrow to change direction after each selection */
       notify: {
        counter:=counter+1;
        if (counter = 1) then
          arrowdirection := XmARROW_RIGHT;
        elsif (counter = 2) then
          arrowdirection := XmARROW_DOWN;
        elsif (counter = 3) then
          arrowdirection := XmARROW_LEFT;
        elsif (counter > 3) then
          counter:= 0;
          arrowdirection := XmARROW_UP;
        endif;
       }
    }

    label(arrowlabel,0,row1label,"XmArrowButton")

/*
**  XmBulletinBoard Widget.
*/

    a_XmBulletinBoard: XmBulletinBoard {
      Attributes:
        parent: workspace;
        x: wig_pos * 1 + 5;
        y: 0;
        height: high;
        width: wwide;
        borderWidth: 2; 
        marginwidth: 0;
        marginheight: 0;
        background: { if (display.color) then
                        background:= backgnd_row1;
                      endif;
                    }

    }

    label(bboardlabel,wig_pos*1,row1label,"XmBulletinBoard")

/*
**  XmCommand Widget.
*/

    a_XmCommand: XmCommand {
      Attributes:
        parent: workspace;
        x: wig_pos * 2;
        y: 0;
        shadowthickness: 1;
	height: high + 30;
	width: 100;
        promptstring: ">";
        borderWidth: 1; 
        command:"ls";
/*        historyitems: "XmCommand//Widget"; 
        historyitemcount: 2;
        historyvisibleitemcount: 3; */
        resizePolicy: XmRESIZE_NONE;     
        background: { if (display.color) then
                        background:= backgnd_row1;
                      endif;
                    }

    }


/*
**  Drawing Area Widget.
*/

    a_XmDrawingArea: XmDrawingArea {
      Attributes:
        parent: workspace;
        x: wig_pos * 3 + offset;
        y: row1;
	height: high;
        width: wwide;
        backgroundpixmap: "mDrawA.sbm";
        borderwidth: 1;
        background: { if (display.color) then
                        background:= backgnd_row1;
                      endif;
                    }

    }

    label(drawalabel,wig_pos*3,row1label,"XmDrawingArea")

/*
**  Drawn Button Widget.
*/
    a_XmDrawnButton: XmDrawnButton {
      Attributes:
        parent: workspace;
        x: wig_pos * 4 + offset;
        y: row1;
	height: high -20;
        width: wwide;
        backgroundpixmap: "serp.sbm";
        borderWidth: 1; 
        shadowthickness: 5;
        pushbuttonenabled: true;
        background: { if (display.color) then
                        background:= backgnd_row1;
                      endif;
                    }

    }

    label(drawblabel,wig_pos*4,row1label,"XmDrawnButton")

/*
**  Form Widget.
*/

    a_form: XmForm {
      Attributes:
        parent: workspace;
        x: wig_pos * 5 + 2;
        y: row1;
        borderwidth: 3;
        height: high;
        width: wwide;
        background: { if (display.color) then
                        background:= backgnd_row1;
                      endif;
                    }

    }

    label(formlabel,wig_pos*5,row1label,"XmForm")

/*
**  Frame Widget.
*/

    a_XmFrame: XmFrame {
      Attributes:
        parent: workspace;
        x: wig_pos * 6 + offset;
        y: row1;
        shadowthickness: 5;
	height: high;
        width: wwide;
        borderWidth: 1; 
        background: { if (display.color) then
                        background:= backgnd_row1;
                      endif;
                    }
        
    }

    label(framelabel,wig_pos*6,row1label,"XmFrame")

/*
**  Label Widget.
*/

    a_XmLabel: XmLabel {
      Attributes:
        parent: workspace;
        x: wig_pos*7+2;
        y: row1;
	height: high;
        width: wwide;
        borderwidth: 3;
        labelstring: "Label";
        fontlist: "*cour*b*-r-*14*";
        background: { if (display.color) then
                        background:= backgnd_row1;
                      endif;
                    }

    }

    label(labellabel,wig_pos*7,row1label,"XmLabel")

/*
**  List.
*/
/*
    a_XmList: XmList {
      Attributes:
        parent: workspace;
        x: wig_pos * 8 + offset;
        y: row1;
	height: high;
        width: wwide;
        items: "snarf.......me//foobie    //bletch    //hoowy!    ";
        itemCount: 4;
        visibleItemCount: 4;
        shadowthickness: 5;
        borderWidth: 1; 
        background: { if (display.color) then
                        background:= backgnd_row1;
                      endif;
                    }
    }

    label(listlabel,wig_pos*8,row1label,"XmList")
*/
/********** begin row two *********/

/*
**  Paned Window Widget.
*/
    a_XmPanedWindow: XmPanedWindow {
      Attributes:
        parent: workspace;
        x: 0;
        y: row2;
        height: high + 30;  
        width:  wwide;  
        marginwidth: 0;
        marginheight: 0;
        sashheight: 5;
        sashshadowthickness: 5;
        sashwidth:  5;
        separatoron: true;
        shadowthickness: 5;
        borderWidth: 2;
        allowresize: true;
        allowuserresize: true;
        background: { if (display.color) then
                        background:= backgnd_row2;
                      endif;
                    }
    }

    XmPainW_label: XmLabel {
      Attributes:
        parent: a_XmPanedWindow;
	labelString: "XmPanedWindow";
        height: 20;
        width: wwide;
        background: { if (display.color) then
                        background:= backgnd_row2;
                      endif;
                    }
    }
    aXmPanedWindow_label: XmLabel {
      Attributes:
        parent: a_XmPanedWindow;
	labelString: "Paned Window 2";
        width: wwide;
        height: 37;
        background: { if (display.color) then
                        background:= backgnd_row2;
                      endif;
                    }
    }
    bXmPanedWindow_label: XmLabel {
      Attributes:
        parent: a_XmPanedWindow;
	labelString: "Paned Window 1";
        width: wwide;
        height: 35;
        background: { if (display.color) then
                        background:= backgnd_row2;
                      endif;
                    }
    }

/*
**  Push Button Widget.
*/

    a_XmPushButton: XmPushButton {
      Attributes:
        parent: workspace;
        x: wig_pos*1 + offset;
        y: row2;
        height: high;
        width: wwide;
        shadowthickness: 5;
        labelstring: "Push";
        fontlist: "*cour*b*-r-*14*";
        background: { if (display.color) then
                        background:= backgnd_row2;
                      endif;
                    }
    }

    label(pushlabel,wig_pos*1,row2label,"XmPushButton")

/*
**  Scale Widget.
*/

    a_XmScale: XmScale {
      Attributes:
        parent: workspace;
        x: wig_pos*2;
        y: row2 + 20;
        height: high - 40;
        width: wwide;
        maximum: 10;
        minimum: 0;
        value: 5;
        processingDirection: XmMAX_ON_RIGHT;
        showvalue: true;
        borderWidth: 1;
        orientation: XmHORIZONTAL;
        shadowthickness: 5;
        background: { if (display.color) then
                        background:= backgnd_row2;
                      endif;
                    }
    }

    label(scalelabel,wig_pos*2,row2label,"XmScale")

/*
**  ScrollBar Widget
*/

    a_XmScrollB: XmScrollBar {
      Attributes:
        parent: workspace;
        x: wig_pos*3 + offset;
        y: row2;
        height: high;
        width: wwide;
        maximum: 75;
        minimum: 0;
        value: 25;
        borderWidth: 1;
        slidersize: 30;
        orientation: XmVERTICAL;
        shadowthickness: 5;
        background: { if (display.color) then
                        background:= backgnd_row2;
                      endif;
                    }
    }

    label(scrolblabel,wig_pos*3,row2label,"XmScrollBar")

/*
** Scrolled Window
*/

    a_XmScrolledWindow: XmScrolledWindow {
      Attributes:
        parent: workspace;
        x: wig_pos*4+offset;
        y: row2;
        shadowthickness: 2;
        height: high;
        width: wwide;
        scrollBarDisplayPolicy: XmAUTOMATIC;
        scrollingPolicy: XmAUTOMATIC;
        visualPolicy: XmCONSTANT;
        background: { if (display.color) then
                        background:= backgnd_row2;
                      endif;
                    }
    }

    label(scrolwinlabel,wig_pos*4,row2label,"XmScrolledWindow")

/* see end of file for vc with stuff for scrolled window */

/*
**  Separator Widget.
*/
    a_XmSeparator: XmSeparator {
      Attributes:
        parent: workspace;
        x: wig_pos*5 + offset;
        y: row2 + 20;
        height: high - 40;
        width: wwide;
        shadowthickness: 5;
        background: { if (display.color) then
                        background:= backgnd_row2;
                      endif;
                    }
    }
        
    label(seplabel,wig_pos*5,row2label,"XmSeparator")

/*
**  Text Widget.
*/

    a_XmText: XmText {
      Attributes:
        parent: workspace;
        x: wig_pos*6 + offset;
        y: row2;
        height: high;
        width: wwide;
        shadowthickness: 5;
        editmode: XmMULTI_LINE_EDIT;
        value: "Multi-Line\nEditing\nText Widget";
        background: { if (display.color) then
                        background:= backgnd_row2;
                      endif;
                    }
    }

    label(textlabel,wig_pos*6,row2label,"XmText")

/*
**  Toggle Widget.
*/

    a_XmToggle: XmToggleButton {
      Attributes:
        parent: workspace;
        x: wig_pos*7 + offset;
        y: row2;
        height: high/2;
        width: wwide;
        labelstring: "Toggle Me";
        shadowthickness: 5;
        set: True;
        background: { if (display.color) then
                        background:= backgnd_row2;
                      endif;
                    }
    }

    b_XmToggle: XmToggleButton {
      Attributes:
        parent: workspace;
        x: wig_pos*7 + offset;
        y: row2 + 40;
        height: high/2;
        width: wwide;
        labelstring: "Toggle You";
        shadowthickness: 5;
    }

    label(togglelabel,wig_pos*7,row2label,"XmToggle")

/*
** Radio Buttons (Toggle buttons in Row Column Widget)
*/

    XmBoard_Radio: XmBulletinBoard {
      Attributes:
        parent: workspace;
        x: wig_pos*8;
        y: row2;
        width:  wwide + 10;
        height: high + 30;
        borderwidth: 0;
        marginwidth: 0;
        marginheight: 0;
        resizepolicy: XmRESIZE_NONE;
     }

    arc: XmRowColumn {
      Attributes:
        parent: workspace;
        x: wig_pos*8+2;
        y: row2;
        height: 65;
        width: wwide + 5;
        packing: XmPACK_COLUMN;
        numcolumns: 1;
        marginwidth: 0;
        marginheight: 0;
        adjustlast: true;
        orientation: XmVERTICAL;
        radiobehavior: true;
        radioalwaysone: true;
    }

    label_area: XmLabel {
      Attributes:
        parent: workspace;
        borderwidth: 1;
        x: wig_pos * 8 + 2;
        y: row2label-8;
        marginright: 0;
        marginleft: 0;
        labelstring: " Radio Buttons \nTog Btns in RC";
        width: wwide + 10;
        height: 28;
    }

    rbutton3: XmToggleButton {

      ATTRIBUTES:
        parent: arc;
        labelString: "Radio 3     ";
        indicatortype: XmONE_OF_MANY;
        width: 75;
        height: 30;
        shadowthickness: 3;
        set: false;
        background: { if (display.color) then
                        background:= backgnd_row2;
                      endif;
                    }
      }
    rbutton2: XmToggleButton {

      ATTRIBUTES:
        parent: arc;
        labelString: "Radio 2     ";
        indicatortype: XmONE_OF_MANY;
        width: 75;
        height: 30;
        shadowthickness: 3;
        set: false;
        background: { if (display.color) then
                        background:= backgnd_row2;
                      endif;
                    }
      }

    rbutton1: XmToggleButton {

      ATTRIBUTES:
        parent: arc;
        labelString: "Radio 1     ";
        indicatortype: XmONE_OF_MANY;
        width: 75;
        height: 30;
        shadowthickness: 3;
        set: true;
        background: { if (display.color) then
                        background:= backgnd_row2;
                      endif;
                    }
      }

/********* end of row 2 **************/


/********* message box row ***********/
/*
**  Error Message Box.
*/

/*  For this demo the message box was used - in a real application
**  you would use the XmErrorDialog instead - the same is true
**  for the rest of the dialog boxes. 
*/
    a_XmErrorDialog: XmMessageBox {
      Attributes:
        parent: workspace;   
        x: 0;
        y: row3;
        shadowthickness: 5;
        height: 125;
	width: 175;
        dialogType: XmDIALOG_ERROR;
        borderWidth: 1;
        messagestring: "Error Information \nHere";
        background: { if (display.color) then
                        background:= backgnd_row3;
                      endif;
                    }
    }
/*
**  Information Message Box.
*/
    a_XmInformationDialog: XmMessageBox {
      Attributes:
        parent: workspace;   
        x: 185;
        y: row3;
        shadowthickness: 5;
        height: 125;
	width: 175;
        dialogType: XmDIALOG_INFORMATION;     
        borderWidth: 1;
        messagestring: "Some Information \nHere";
        background: { if (display.color) then
                        background:= backgnd_row3;
                      endif;
                    }
    }


/*
**  Question Box.
*/
    a_XmQuestionDialog: XmMessageBox {
      Attributes:
        parent: workspace;
        x: 360;
        y: row3;
        shadowthickness: 5;
        height: 125;
        width: 175;
        dialogType: XmDIALOG_QUESTION;
        borderWidth: 1;
        messagestring: "Question  \nHere";
        background: { if (display.color) then
                        background:= backgnd_row3;
                      endif;
                    }
    }

/*
**  Warning Message Box.
*/
    a_XmWarningDialog: XmMessageBox {
      Attributes:
        parent: workspace;
        x: 535;
        y: row3;
        shadowthickness: 5;
        height: 125;
        width: 175;
        dialogType: XmDIALOG_WARNING;
        borderWidth: 1;
        messagestring: "Warning Message \nHere";
        background: { if (display.color) then
                        background:= backgnd_row3;
                      endif;
                    }
    }


/*
**  Working Message Box.
*/
    a_XmWorkingDialog: XmMessageBox {
      Attributes:
        parent: workspace;   
        x: 710;
        y: row3;
        shadowthickness: 5;
        height: 125;
	width: 175;
        dialogType: XmDIALOG_WORKING;
        borderWidth: 1;
        messagestring: "Working Message \nHere";
        background: { if (display.color) then
                        background:= backgnd_row3;
                      endif;
                    }
    }

/*********** end of message box row *******/
/*
**  File Selection Box.
*/
    a_XmFileSelectionBox: XmFileSelectionBox {
      Attributes:
        parent: workspace;   
        x: 0;
	y: row4;
	height: 350;
	width: 250;
        borderWidth: 1;
        shadowthickness: 5;
        resizePolicy: XmRESIZE_NONE;
	allowUserMove: true;
	allowUserResize: true;
        background: { if (display.color) then
                        background:= backgnd_row1;
                      endif;
                    }
    }

    XmFileSelectionBox_label: XmLabel {
      Attributes:
        parent: workspace;
	labelString: "XmFileSelectionBox";
        x: 0;
        y: row4 - 25;
        borderwidth: 1;
        height: 22;
        width: 250;
    }


/*
**  Pull Down Menubar Widget.
*/

    menu_board: XmBulletinBoard {
      Attributes:
        parent: workspace;
        x: 475;
        y: row4;
        width:  300;
        height: 200;
        borderwidth: 3;
        allowusermove: true;
    }

    label_menubar: XmLabel {
      Attributes:
        parent: workspace;
        x: 475;
        y: row4-25;
        height: 22;
        width: 400;
        borderwidth: 1;
        labelstring: "Menu Bar Area";
        alignment: XmALIGNMENT_CENTER;
    }

    text_label: XmLabel {
      Attributes:
        parent: workspace;
        x: 475;
        y: row4 + 125;
        height: 50;
        width: 350;
        borderwidth: 2;
        fontlist: "*cour*b*-r-n*14*";
        labelstring: "This is the Font and the Color";
        alignment: XmALIGNMENT_CENTER;
    }

    a_menubar: XmMenuBar {
      Attributes:
        parent: menu_board;
	x: 1;
        y: 1;
        shadowthickness: 2;
    }

/* Popup Menu Stuff */
   popup_menu: XmCascadeButton {
      Attributes: 
        parent: a_menubar;
        labelstring: "Pop UP Mouse Btn 3 ";
        traversalon: true;
   }

   a_popup: XmPopup {
      Attributes:
        parent: popup_menu;
        rowColumnType: XmMENU_POPUP;
        popupenabled: true;
        subMenuId: popup_menu;
   }

   apop3: XmPushButton {
     Attributes:
       parent: a_popup;
       labelString: "POP 3";
   }
   apop2: XmPushButton {
     Attributes:
       parent: a_popup;
       labelString: "POP 2";
   }
   apop1: XmPushButton {
     Attributes:
       parent: a_popup;
       labelString: "POP 1";
   }

/* regular pull down menu */
   
    pull_down1: XmPullDown {
      Attributes:
        parent: a_menubar;
    }

    amen1: XmCascadeButton {
      Attributes:
        parent: a_menubar;
        labelstring: "Pull Down Menu 1";
        traversalon: true;
        submenuid: pull_down1;
    }
    
     apush3: XmPushButton {
       Attributes:
         parent: pull_down1;
         labelString: "Button_3";
    }
     apush2: XmPushButton {
       Attributes:
         parent: pull_down1;
         labelString: "Button_2";
    }
     apush1: XmPushButton {
       Attributes:
         parent: pull_down1;
         labelString: "Display Error Dialog";
       Methods:
         notify: {
           display_errorbox := true;
         }
    }


   character_menu: XmPullDown {
      Attributes: 
         parent: a_menubar;
   }

   character_button: XmCascadeButton {
      Attributes:
        parent: a_menubar;
        labelstring: "Text Attributes Menu";
        traversalon: true;
        submenuid: character_menu;
    }

    font_menu: XmPullDown {

      ATTRIBUTES:
        parent: character_menu;
        radioBehavior: TRUE;
    }

    font_a: XmToggleButton {

      ATTRIBUTES:
        parent: font_menu;
        labelString: "Helvetica";
        set: TRUE;  
        indicatoron: true;
      Methods:
        toggle: {
          if (set) then
            text_label.fontlist := "*helv*b*-r-n*18*";
          endif;
        }
    }

    font_b: XmToggleButton {

      ATTRIBUTES:
        parent: font_menu;
        labelString: "Times Roman";
        set: false; 
      Methods:
        toggle: {
          if (set) then
            text_label.fontlist := "*times*b*-r-n*18*";
          endif;
        }
    }

    font_c: XmToggleButton {

      ATTRIBUTES:
        parent: font_menu;
        labelString: "Courier";
        set: false; 
      Methods:
        toggle: {
          if (set) then
            text_label.fontlist := "*cour*b*-r-n*18*";
          endif;
        }
    }

    font_button: XmCascadeButton {

      ATTRIBUTES:
        parent: character_menu;
        labelString: "Fonts";
        submenuid: font_menu;
        
        width: 40;
      }

/* ...Text Size submenu */

    color_menu: XmPullDown {

      ATTRIBUTES:
        parent: character_menu;
        radioBehavior: TRUE;
    }

    color_a: XmToggleButton {

      ATTRIBUTES:
        parent: color_menu;
        labelstring:{ if (display.color) then
                        labelstring := "Green";
                     else
                        labelstring := "White";
                     endif;
                    }
      Methods:
        toggle: {
          if (set) then
            if (display.color) then
              text_label.foreground := "green";
            else
              text_label.foreground := "white";
              text_label.background := "black";
            endif;
          endif;
      }
    }

    color_b: XmToggleButton {

      ATTRIBUTES:
        parent: color_menu;
        fillonselect: true;
        labelstring:{ if (display.color) then
                        labelstring := "Maroon";
                     else
                        labelstring := "Black";
                     endif;
                    }
      Methods:
        toggle: {
          if (set) then
            if (display.color) then
              text_label.foreground := "maroon";
            else
              text_label.foreground := "black";
              text_label.background := "white";
            endif;
          endif;
        }
    }

    color_button: XmCascadeButton {

      ATTRIBUTES:
        parent: character_menu;
        labelString: "Colors";
        submenuid: color_menu;
        width: 40;
      }



/*   end of menu area  */

/*
**  Row Column Widget.
*/
  
     rc_frame: XmFrame {
      Attributes:
        parent: workspace;
        x: 290;
        y: 675;
        height: 205;
        width:  225;
        allowuserresize: true;
        allowusermove: true;
    }

    XmRowColumn_label: XmLabel {
      Attributes:
        parent: workspace;
	labelString: "XmRowColumn";
        x: 290;
        y: 650;
        borderwidth: 1;
        height: 25;
        width: 165;
    }

    a_XmRowColumn: XmRowColumn {
      Attributes:
        parent: rc_frame;
	x: 0;
        y: 0;
	height: 190;
	width: 180;
        packing: XmPACK_COLUMN;
        numcolumns: 3;
        allowusermove: true;
        allowuserresize: true;
    }

    rc_0: XmPushButton {
      Attributes:
        parent: a_XmRowColumn;
        height: 50;
        width: 50;
        labelstring: "WIDGETS";
        shadowthickness: 2;
    }
    rc_1: XmPushButton {
      Attributes:
        parent: a_XmRowColumn;
        height: 50;
        width: 50;
        labelstring: "BUTTON";
        shadowthickness: 2;
    }
    rc_2: XmPushButton {
      Attributes:
        parent: a_XmRowColumn;
        height: 50;
        labelstring: "PUSH";
        width: 50;
        shadowthickness: 2;
    }
    rc_3: XmPushButton {
      Attributes:
        parent: a_XmRowColumn;
        height: 50;
        labelstring: "ROWS OF";
        width: 50;
        shadowthickness: 2;
    }
    rc_4: XmPushButton {
      Attributes:
        parent: a_XmRowColumn;
        height: 50;
        labelstring: "WITH 3";
        width: 50;
        shadowthickness: 2;
    }
    rc_5: XmPushButton {
      Attributes:
        parent: a_XmRowColumn;
        height: 50;
        width: 50;
        labelstring: "WIDGET";
        shadowthickness: 2;
    }
    rc_6: XmPushButton {
      Attributes:
        parent: a_XmRowColumn;
        height: 50;
        labelstring: "COLUMN";
        width: 50;
        shadowthickness: 2;
    }
    rc_7: XmPushButton {
      Attributes:
        parent: a_XmRowColumn;
        height: 50;
        labelstring: "A ROW";
        width: 50;
        shadowthickness: 2;
    }
    rc_8: XmPushButton {
      Attributes:
        parent: a_XmRowColumn;
        height: 50;
        labelstring: "THIS IS";
        width: 50;
        shadowthickness: 2;
    }

    display_Button: XmPushButton {
      Attributes:
        parent: workspace;
        labelString: "PRESS HERE TO\n DISPLAY \n OTHER WIDGETS";
        x: 700;
        y: 650;
        width: 150;
        fontlist: "*cour*b*-r-*14*";
        height: 105;
        borderWidth: 1;
        shadowthickness: 5;
      Methods: 
        notify: {
          display_secondary_widgets := true;
          sensitive := false;
          }
     }

    Quit_Button: XmPushButton {
      Attributes:
        parent: workspace;
        labelString: "PRESS HERE \n TO \n QUIT";
        x: 850;
        y: 650;
        width: 125;
        fontlist: "*cour*b*-r-*14*";
        height: 105;
        borderWidth: 1;
        shadowthickness: 5;
        background: { if (display.color) then
                        background:= backgnd_row3;
                      endif;
                    }
      Methods: 
        notify: {
          exit();
          }
     }

/* main window work area */
/*
**  main window widget and children
*/

  main_win: XmMainWindow {
    Attributes:
      parent: workspace;
      x: 290;
      y: row4;
      height: 200;
      width:  150;
      borderwidth: 3;
      shadowthickness: 5;
      showseparator: true;
  }

    mainwin_label: XmLabel {
      Attributes:
        parent: workspace;
        x: 290;
        y: row4-25;
        width: 150;
        height: 22;
        labelstring: "XmMainWindow";
        borderwidth: 1;
    }

VC: Display_Error_Dialog

Creation Condition: (display_errorbox = true)
Objects:
b_XmErrorDialog: XmErrorDialog {
   Attributes:
     parent: workspace;
     shadowthickness: 5;
     dialogType: XmDIALOG_ERROR;
     messagestring: "Error Information \nHere";
     background: { if (display.color) then
                      background:= "salmon";
                   endif;
                 }
    }

ENDVC Display_Error_Dialog

VC: SECONDARY_OBJECTS

Creation Condition: (display_secondary_widgets = true)

Objects:

    scrolwin_List: XmList {
      Attributes:
        parent: a_XmScrolledWindow;
        x: 0;
        y: 0;
        height: 100;
        width: 100;
        items: "This is    //a//Scrolled.....Window//Howdy! //Doody!!";
        itemCount: 5;
        visibleItemCount: 5;
        allowuserresize: true;
        allowusermove: true;
    }

/* menu bar for main window */


    mainwin_menubar: XmMenuBar {
      Attributes:
        parent: main_win;
    }

    pull_main: XmPullDown {
      Attributes:
        parent: mainwin_menubar;
    }

    cas1: XmCascadeButton {
      Attributes:
        parent: mainwin_menubar;
        labelstring: "Main Window Pull Down";
    }
     push3: XmPushButton {
       Attributes:
         parent: pull_main;
         labelString: "Button_3";
    }
     push2: XmPushButton {
       Attributes:
         parent: pull_main;
         labelString: "Button_2";
    }
     push1: XmPushButton {
       Attributes:
         parent: pull_main;
         labelString: "Button_1";
    }

/* command box for main window */

    mainwin_XmCommand: XmCommand {
      Attributes:
        parent: main_win;
        shadowthickness: 1;
        height: 125;
        width: 100;
        promptstring: ">";
        borderWidth: 1;
        command:"ls";
/*        historyitems: "XmCommand//Widget";
        historyitemcount: 2;
        historyvisibleitemcount: 3; */
        resizePolicy: XmRESIZE_NONE;
    }


    mainwin_scrolwin: XmScrolledWindow {
      Attributes:
        parent: main_win;
        height: 65;
        width: 85;
        scrollBarDisplayPolicy: XmAUTOMATIC;
        scrollingPolicy: XmAUTOMATIC;
        visualPolicy: XmCONSTANT;
    }
    a_XmList: XmList {
      Attributes:
        parent: mainwin_scrolwin;
        height: 100;
        width: 150;
        items: "snarf      //dog//foobie//bletch........and retch //hoowy! //doobie";
        itemCount: 6;
        visibleItemCount: 6;
    }


On Create: {

/* allow scrolled window contents to become instantiated */
        a_XmScrolledWindow.workwindow := scrolwin_List;

/* allow contents of main window to become instantiated */
        cas1.submenuid                := pull_main;
        main_win.menubar              := mainwin_menubar;
        main_win.commandwindow        := mainwin_XmCommand; 
        main_win.workwindow           := mainwin_scrolwin;
    }   

ENDVC SECONDARY_OBJECTS

end VC top_level;







