#include "smo.ill"

|||

/*-------------------------------------------------------------------------*\
|   This demonstrates the use of Slang to produce a menu bar 
\*-------------------------------------------------------------------------*/

Externals:
  void system(string);
  void printf(string, string);
  string getenv(string);

#include "sstring.ext"

Variables:
  serpent_base_path;
  system_command;

Objects:

  menu_bar_bulletin_board: XmBulletinBoard  {
    Attributes:
      height:500;
      width: 600;
  }

  menu_bar: XmMenuBar {
    Attributes:
      parent: menu_bar_bulletin_board;
      y: 20;
      x: 20; 
      borderWidth: 1;
      shadowthickness: 3;
  }
 
  devtoolspull_down: XmPullDown {
    Attributes:
      parent: menu_bar;
  }
  athenapull_down: XmPullDown {
    Attributes:
      parent: menu_bar;
  }
  motifpull_down: XmPullDown {
    Attributes:
      parent: menu_bar;
  }

  quitpull_down: XmPullDown {
    Attributes: 
      parent: menu_bar;
  }

  quit_menu:  XmCascadeButton { 
    ATTRIBUTES:
      parent:  menu_bar;
      labelString: "QUIT    ";
      fontList: "9x15bold";
      subMenuId: quitpull_down;
 }
 menu2_item: XmCascadeButton   {

    Attributes:
      parent: menu_bar;
      labelString: "Motif    ";
      fontList: "9x15bold";
      subMenuId: motifpull_down;
    }

  menu1_item: XmCascadeButton   {
    Attributes:
      parent: menu_bar;
      labelString: "Athena    ";
      fontList: "9x15bold";
      subMenuId: athenapull_down;      
   }

  menu0_item: XmCascadeButton   {
    Attributes:
      parent: menu_bar;
      labelString: "Dev Tools    ";
      fontList: "9x15bold";
      subMenuId: devtoolspull_down;
   }

/* -------------------- Quit Menu ------------------------------------*/

  quit_item: XmPushButton {
    Attributes:
      parent: quitpull_down;
      fontList: "9x15bold";
      shadowthickness: 3;
      labelstring: "Shut Down \nSerpent Demos";
    METHODS:
      notify:  {
        exit ();
      }
  }
/*--------------------- Dialogue Editor ----------------------------------*/

  itemd1_menu_item: XmPushButton  {
    Attributes:
      parent: devtoolspull_down;
      labelString: "Dialogue Editor";
      fontList: "9x15bold";
      shadowthickness: 3;
    Methods:
      notify: {
        system("(cd $SERPENT_BASE_PATH/de/src; serpent ded) &");
      }
    }

/*--------------------- Athena Widgets ------------------------------------*/

/*
   The Athena demos are:  calc, color, concent, counter, grouping, icsec,
    monitor, proto, sigchi, spider, vis_prog, visu.
*/

  itema1_menu_item: XmPushButton  {
    Attributes:
      parent: athenapull_down;
      shadowthickness: 3;
      labelString: "Counter";
      fontList: "9x15bold";
    Methods:
      notify: {
        system("(cd $SERPENT_BASE_PATH/demos/sat/counter; serpent counter) &");
      }
    }

  itema2_menu_item: XmPushButton   {
    Attributes:
      parent: athenapull_down;
      shadowthickness: 3;
      labelString: "Calculator";
      fontList: "9x15bold";
      after: itema1_menu_item;
    Methods:
      notify:
      { 
        system("(cd $SERPENT_BASE_PATH/demos/sat/calc; serpent calc) &");
      }
   }

  itema3_menu_item: XmPushButton   {
    Attributes:
      parent: athenapull_down;
      shadowthickness: 3;
      labelString: "Concentration";
      fontList: "9x15bold";
      after: itema2_menu_item;
    Methods:
      notify:
      { 
        system("(cd $SERPENT_BASE_PATH/demos/sat/concent; serpent concent) &");
      }
   }

  itema4_menu_item: XmPushButton   {
    Attributes:
      parent: athenapull_down;
      shadowthickness: 3;
      labelString: "Grouping";
      fontList: "9x15bold";
      after: itema3_menu_item;
    Methods:
      notify:
      { 
        system("(cd $SERPENT_BASE_PATH/demos/sat/group; serpent group) &");
      }
   }

  itema5_menu_item: XmPushButton   {
    Attributes:
      parent: athenapull_down;
      shadowthickness: 3;
      labelString: "Layout";
      fontList: "9x15bold";
      after: itema4_menu_item;
    Methods:
      notify:
      { 
        system("(cd $SERPENT_BASE_PATH/demos/sat/layout; serpent layout) &");
      }
   }

  itema6_menu_item: XmPushButton   {
    Attributes:
      parent: athenapull_down;
      shadowthickness: 3;
      labelString: "SIGCHI Talk";
      fontList: "9x15bold";
      after: itema5_menu_item;
    Methods:
      notify:
      { 
    system(
     "(cd $SERPENT_BASE_PATH/demos/sat/sigchi; serpent sigchi) &"
    );
      }
   }

  itema7_menu_item: XmPushButton   {
    Attributes:
      parent: athenapull_down;
      shadowthickness: 3;
      labelString: "Spider";
      fontList: "9x15bold";
      after: itema6_menu_item;
    Methods:
      notify:
      { 
        system("(cd $SERPENT_BASE_PATH/demos/sat/spider; serpent spider) &");
      }
   }

  itema8_menu_item: XmPushButton   {
    Attributes:
      parent: athenapull_down;
      shadowthickness: 3;
      labelString: "Vis Programmer";
      fontList: "9x15bold";
      after: itema7_menu_item;
    Methods:
      notify:
      { 
        system("(cd $SERPENT_BASE_PATH/demos/sat/visprog; serpent visprog) &");
      }
   }
  itema9_menu_item: XmPushButton   {
    Attributes:
      parent: athenapull_down;
      shadowthickness: 3;
      labelString: "Color Palette";
      fontList: "9x15bold";
      after: itema8_menu_item;
    Methods:
      notify:
      { 
        system("(cd $SERPENT_BASE_PATH/demos/sat/color; serpent color) &");
      }
   }
  itema10_menu_item: XmPushButton   {
    Attributes:
      parent: athenapull_down;
      shadowthickness: 3;
      labelString: "Font Selector";
      fontList: "9x15bold";
      after: itema9_menu_item;
    Methods:
      notify:
      { 
        system("(cd $SERPENT_BASE_PATH/demos/sat/fontsel; serpent fontsel) &");
      }
   }

  itema11_menu_item: XmPushButton   {
    Attributes:
      parent: athenapull_down;
      shadowthickness: 3;
      labelString: "Icsec";
      fontList: "9x15bold";
      after: itema10_menu_item;
    Methods:
      notify:
      { 
        system("(cd $SERPENT_BASE_PATH/demos/sat/icsec; serpent icsec) &");
      }
   }
  itema12_menu_item: XmPushButton   {
    Attributes:
      parent: athenapull_down;
      shadowthickness: 3;
      labelString: "Monitor";
      fontList: "9x15bold";
      after: itema11_menu_item;
    Methods:
      notify:
      { 
        system("(cd $SERPENT_BASE_PATH/demos/sat/monitor; serpent monitor) &");
      }
   }
  itema13_menu_item: XmPushButton   {
    Attributes:
      parent: athenapull_down;
      shadowthickness: 3;
      labelString: "Prototyper";
      fontList: "9x15bold";
      after: itema12_menu_item;
    Methods:
      notify:
      { 
        system("(cd $SERPENT_BASE_PATH/demos/sat/proto; serpent proto) &");
      }
   }



/*--------------------- Motif Widgets ------------------------------------*/

  item1_menu_item: XmPushButton  {
    Attributes:
      parent: motifpull_down;
      shadowthickness: 3;
      labelString: "Counter";
      fontList: "9x15bold";
    Methods:
      notify: {
        system("(cd $SERPENT_BASE_PATH/demos/smo/counter; serpent counter) &");
      }
    }

  item2_menu_item: XmPushButton   {
    Attributes:
      parent: motifpull_down;
      shadowthickness: 3;
      labelString: "Concentration";
      fontList: "9x15bold";
      after: item1_menu_item;
    Methods:
      notify:
      { 
        system("(cd $SERPENT_BASE_PATH/demos/smo/concent; serpent concent) &");
      }
   }

  item3_menu_item: XmPushButton   {
    Attributes:
      parent: motifpull_down;
      shadowthickness: 3;
      labelString: "Calculator";
      fontList: "9x15bold";
      after: item2_menu_item;
    Methods:
      notify: { 
        system("(cd $SERPENT_BASE_PATH/demos/smo/calc; serpent calc) &");
      }
   }

  item4_menu_item: XmPushButton   {
    Attributes:
      parent: motifpull_down;
      shadowthickness: 3;
      labelString: "Grouping";
      fontList: "9x15bold";
      after: item3_menu_item;
    Methods:
      notify: { 
        system("(cd $SERPENT_BASE_PATH/demos/smo/group; serpent group) &");
      }
   }

  item5_menu_item: XmPushButton   {
    Attributes:
      parent: motifpull_down;
      shadowthickness: 3;
      labelString: "Layout";
      fontList: "9x15bold";
      after: item4_menu_item;
    Methods:
      notify: { 
    system(
    "(cd $SERPENT_BASE_PATH/demos/smo/layout; serpent layout) &"
    );
      }
   }

  item6_menu_item: XmPushButton   {
    Attributes:
      parent: motifpull_down;
      shadowthickness: 3;
      labelString: "SIGCHI Talk";
      fontList: "9x15bold";
      after: item5_menu_item;
    Methods:
      notify: { 
        system("(cd $SERPENT_BASE_PATH/demos/smo/sigchi; serpent sigchi) &");
      }
   }

  item7_menu_item: XmPushButton   {
    Attributes:
      parent: motifpull_down;
      shadowthickness: 3;
      labelString: "Spider";
      fontList: "9x15bold";
      after: item6_menu_item;
    Methods:
      notify: { 
        system("(cd $SERPENT_BASE_PATH/demos/smo/spider; serpent spider) &");
      }
   }

  item8_menu_item: XmPushButton   {
    Attributes:
      parent: motifpull_down;
      shadowthickness: 3;
      labelString: "Vis Programmer";
      fontList: "9x15bold";
      after: item7_menu_item;
    Methods:
      notify: { 
        system("(cd $SERPENT_BASE_PATH/demos/smo/visprog; serpent visprog) &");
      }
   }

  item9_menu_item: XmPushButton   {
    Attributes:
      parent: motifpull_down;
      shadowthickness: 3;
      labelString: "Color Palette";
      fontList: "9x15bold";
      after: item8_menu_item;
    Methods:
      notify: { 
        system("(cd $SERPENT_BASE_PATH/demos/smo/color; serpent color) &");
      }
   }

  item10_menu_item: XmPushButton   {
    Attributes:
      parent: motifpull_down;
      shadowthickness: 3;
      labelString: "Font Selector";
      fontList: "9x15bold";
      after: item9_menu_item;
    Methods:
      notify: { 
        system("(cd $SERPENT_BASE_PATH/demos/smo/fontsel; serpent fontsel) &");
      }
   }

  item11_menu_item: XmPushButton   {
    Attributes:
      parent: motifpull_down;
      shadowthickness: 3;
      labelString: "All The Motif Widgets";
      fontList: "9x15bold";
      after: item10_menu_item;
    Methods:
      notify: { 
        system("(cd $SERPENT_BASE_PATH/demos/smo/pertab; serpent pertab) &");
      }
   }


