#include "smo.ill"

|||

#define MAX_SLIDES 19

#ifdef mc68000

#define DISPLAY_WIDTH 1100
#define DISPLAY_HEIGHT 850

#else

#define DISPLAY_WIDTH 1000
#define DISPLAY_HEIGHT 830

#endif

#define TITLE_FONT "*times-bold-r-n*--34*"
#define BULLET_FONT "*times-bold-r-n*--34*"
#define SUBBULLET_FONT "*times-bold-r-n*--25*"

#define FONT_20 "*times-bold-r-n*--20*"
#define FONT_24 "*times-bold-r-n*--24*"
#define FONT_25 "*times-bold-r-n*--25*"

#define BULLET_OFFSET 50
#define SUBBULLET_OFFSET 100

#define LEFT 0
#define CENTER 1
#define RIGHT 2

#define cnext(fname,fparent,fhoriz) \
fname: XmPushButton {\
Attributes:\
  parent: fparent;\
  labelString: "Next";\
  fontList: TITLE_FONT;\
  width: 170;\
  height: 50;\
  y: DISPLAY_HEIGHT - 75;\
  x: fhoriz;\
  borderColor: "black";\
 Methods:\
  notify: {\
    if (slide < MAX_SLIDES) then\
      slide := slide + 1;\
    endif;\
  }\
}

#define cprev(fname,fparent,fhoriz) \
fname: XmPushButton {\
Attributes:\
  parent: fparent;\
  labelString: "Previous";\
  fontList: TITLE_FONT;\
  width: 170;\
  height: 50;\
  y: DISPLAY_HEIGHT - 75;\
  x: fhoriz;\
  borderColor: "black";\
 Methods:\
  notify: {\
    if (slide > 1) then\
      slide := slide - 1;\
    endif;\
  }\
}

#define cquit(fname,fparent,fhoriz) \
fname: XmPushButton {\
Attributes:\
  parent: fparent;\
  labelString: "Quit";\
  fontList: TITLE_FONT;\
  width: 170;\
  height: 50;\
  y: DISPLAY_HEIGHT - 55;\
  x: fhoriz;\
  borderColor: "black";\
 Methods:\
  notify: {\
    exit();\
  }\
}

#define cXmForm(fname) \
fname: XmBulletinBoard {\
Attributes:\
  parent: toplevel;\
  height: DISPLAY_HEIGHT;\
  width: DISPLAY_WIDTH;\
  resizePolicy: 0;\
}

#define major_heading(fname, fparent, flabel, ffy) \
fname: XmLabel {\
Attributes:\
  parent: fparent;\
  fontList: TITLE_FONT;\
  labelString: flabel;\
  y: ffy;\
  x: 0;\
  borderColor: "white";\
  height: 50;\
  width: DISPLAY_WIDTH;\
  alignment: CENTER;\
}

#define minor_heading(fname, fparent, flabel, ffy, ffont) \
fname: XmLabel {\
Attributes:\
  parent: fparent;\
  fontList: ffont;\
  labelString: flabel;\
  y: ffy;\
  x: 0;\
  borderColor: "white";\
  height: 50;\
  width: DISPLAY_WIDTH;\
  alignment: CENTER;\
}

#define title(fname,flabel) \
fname: XmLabel {\
Attributes:\
  parent: slide_XmForm;\
  fontList: TITLE_FONT;\
  labelString: flabel;\
  y: 150;\
  alignment: CENTER;\
  borderColor: "white";\
  height: 50;\
  width: DISPLAY_WIDTH;\
}

#define bullet(fname, flabel, ffy)\
fname: XmLabel {\
Attributes:\
  parent: slide_XmForm;\
  fontList: BULLET_FONT;\
  labelString: flabel;\
  y: ffy;\
  x: BULLET_OFFSET;\
  borderColor: "white";\
  height: 50;\
}

#define subbullet(fname, flabel, ffy)\
fname: XmLabel {\
Attributes:\
  parent: slide_XmForm;\
  fontList: SUBBULLET_FONT;\
  labelString: flabel;\
  y: ffy;\
  x: SUBBULLET_OFFSET;\
  borderColor: "white";\
}

variables:

  main_talk : false;

objects:

    slide_XmForm: XmBulletinBoard {
      Attributes:
        height: DISPLAY_HEIGHT;
        width: DISPLAY_WIDTH;
        resizePolicy: 0;
    }

vc: title_slide_vc

  creation condition:  (NOT main_talk)

  objects:

    major_heading(j1, slide_XmForm, "Serpent, A Media Independent User", 200)
    major_heading(j2, slide_XmForm, "Interface Management System", 260)
    minor_heading(j3, slide_XmForm, "Software Engineering Institute", 350, FONT_25)
    minor_heading(j4, slide_XmForm, "Carnegie Mellon University", 400, FONT_20)
    minor_heading(j5, slide_XmForm, "Pittsburgh, PA 15213", 450, FONT_20)
    minor_heading(j6, slide_XmForm, "Sponsored by the U.S. Department of Defense", 600, FONT_25)

    next_button: XmPushButton {
      Attributes:
        parent: slide_XmForm;
       labelString: "Next";
       fontList: BULLET_FONT;
       width: 170;
       height: 50;
       y: DISPLAY_HEIGHT - 100;
       x: DISPLAY_WIDTH - 220;
       borderColor: "black";
     Methods:
       notify: {
         main_talk := true;
       }
    }

end vc title_slide_vc;


vc: main_talk_vc

  creation condition:  (main_talk)

  variables:

   slide : 1;

  objects:

#if 0
    death_star: pixmap_object {
      Attributes:
        parent: slide_XmForm;
        x: 10;
        y: 10;
        bitmap_file: "death_star.bitmap";
    }
#endif

    cmu_logo: XmLabel {
      Attributes:
        parent: slide_XmForm;
        fontList: FONT_24;
        labelString: "Carnegie Mellon University";
        y: 	50;
        x: 150;
        borderColor: "white";
        height: 30;
        alignment: LEFT;
    }

    sei_logo: XmLabel {
      Attributes:
        parent: slide_XmForm;
        fontList: FONT_24;
        labelString: "Software Engineering Institute";
        y: 	80;
        x: 150;
        borderColor: "white";
        height: 30;
        alignment: LEFT;
    }

    bar: XmLabel {
      Attributes:
        parent: slide_XmForm;
        labelString: "";
        background: "black";
        y: 	110;
        x: 150;
        height: 2;
        width: DISPLAY_WIDTH - 250;
    }

    cnext(next, slide_XmForm, DISPLAY_WIDTH - 220)
    cprev(prev, slide_XmForm, DISPLAY_WIDTH - 420)
    cquit(quit, slide_XmForm, DISPLAY_WIDTH - 985)
/*--------------------- Introduction ---------------------------------------*/

vc: slide1_vc

  creation condition:  (slide = 1)

  objects:

    title(j1, "Introduction")
    bullet(j2, "* Motivation", 250)
    bullet(j3, "* Requirements", 320)
    bullet(j4, "* Serpent UIMS", 390)
    subbullet(j5, "- use as prototyping tool", 460)
    subbullet(j6, "- features to support production", 510)
    subbullet(j7, "- editor", 560)

end vc slide1_vc

/*--------------------- Current User Interface Life Cycle ------------------*/

vc: slide2_vc

  creation condition:  (slide = 2)

  objects:

    title(j1, "Current User Interface Life Cycle")
    bullet(j2, "* Prototype displays using prototyping tool", 250)
    bullet(j3, "* Implement prototype using user interface toolkit", 320)
    bullet(j4, "* Modify implementation to reflect errors in original", 390)
    bullet(j5, "  prototype or user enhancements", 450)
    bullet(j6, "* Best case scenario.  In reality, prototyping not", 520)
    bullet(j7, "  always done.", 580)

end vc slide2_vc

/*--------------------- Problems of Current Approach -----------------------*/

vc: slide3_vc

  creation condition:  (slide = 3)

  objects:

    title(j1, "Problems of Current Approach")
    bullet(j2, "* Prototype is thrown away after serving as model", 250)
    bullet(j3, "  for implementation", 310)
    bullet(j4, "* Mismatch between prototyping tool and", 380)
    bullet(j5, "  implementation toolkit", 440)
    bullet(j6, "* User Interface toolkits are complicated and difficult", 510)
    bullet(j7, "  to use", 570)
    bullet(j8, "* Integration of new input/output media usually", 640)
    bullet(j9, "  requires total re-engineering of application", 700)

end vc slide3_vc

/*--------------------- Incremental Development ----------------------------*/

vc: slide4_vc

  creation condition:  (slide = 4)

  objects:

    title(j1, "Incremental Development")
    bullet(j2, "* Use same tool for prototyping and for production", 250)
    subbullet(j3, "- prototype is not thrown away", 320)
    subbullet(j4, "- constrains prototypes to easily implementable solutions", 370)
    subbullet(j5, "- requires tool that supports both aspects", 420)
    bullet(j6, "* Integrate new media to tool", 490)
    subbullet(j7, "- requires portion of application system be media independent", 560)
    subbullet(j8, "- requires extensible tool", 610)
    subbullet(j9, "- evolution from one presentation mechanism to another", 660)

end vc slide4_vc

/*--------------------- Requirement for UI Tool ----------------------------*/

vc: slide5_vc

  creation condition: (slide = 5)

  objects:

    title(j1, "Requirement for UI Tool")
    bullet(j2, "* For use as prototyper", 250)
    subbullet(j3, "- interactive drawing editor", 320)
    subbullet(j4, "- simulation of behavior", 370)
    bullet(j5, "* For use in production", 440)
    subbullet(j6, "- support for abstraction", 510)  
    subbullet(j7, "- inclusion of arbitrary application functionality", 560)  
    subbullet(j8, "- extensible in term of media", 610)
    subbullet(j9, "- reasonable performance", 660)  

end vc slide5_vc

/*--------------------- Serpent --------------------------------------------*/

vc: slide6_vc

  creation condition: (slide = 6)

  objects:

    title(j1, "Serpent")
    bullet(j2, "* General purpose user interface management system", 250)
    bullet(j3, "* Supports incremental development of user interface", 320)
    bullet(j4, "* Multiple media for presentation", 390)
    bullet(j5, "* Language for specification of user interface", 460)  
    bullet(j6, "* Interactive editor (under development) using ", 530)  
    bullet(j7, "  Serpent language for UI specification and execution", 590)
    bullet(j8, "* X11 Athena Widget Toolkit set currently used for", 660)
    bullet(j9, "  presentation", 720)

end vc slide6_vc

/*--------------------- Serpent as Prototyping Tool ------------------------*/

vc: slide7_vc
  creation condition: (slide = 7)
  objects:

    title(j1, "Serpent as Prototyping Tool")
    bullet(j2, "* Editor includes drawing component", 250)
    bullet(j3, "* Editor outputs Serpent language", 320)
    bullet(j4, "* Language has facility for recording user", 390)
    bullet(j5, "  performance data", 450)

end vc slide7_vc

/*--------------------- Serpent as Production Tool -------------------------*/

vc: slide8_vc
  creation condition: (slide = 8)
  objects:

    title(j1, "Serpent as Production Tool")
    bullet(j2, "* Supports arbitrary applications", 250)
    bullet(j3, "* Supports multiple media, simultaneously, for user", 320)
    bullet(j35, "  interactions", 380)
    bullet(j4, "* Extensible in input/output media supported", 450)
    bullet(j5, "* Supports", 520)
    subbullet(j6, "- media independent application", 590)  
    subbullet(j7, "- user control of task sequencing", 640)  
    subbullet(j8, "- consistency of data presentation", 690)

end vc slide8_vc

/*--------------------- Slang, UI Specification Language -------------------*/

vc: slide9_vc

  creation condition: (slide = 9)

  objects:

    title(j1, "Slang, UI Specification Language")
    bullet(j2, "* Based on production model", 250)
    subbullet(j3, "- data driven", 320)  
    subbullet(j4, "- allows multiple threads of control", 370)  
    bullet(j5, "* Multiple views of the same data", 440)
    subbullet(j6, "- implemented with constraint mechanism", 510)  
    subbullet(j7, "- dependent values automatically re-evaluated", 560)  
    subbullet(j8, "  when independent values modified", 600)  

end vc slide9_vc

/*--------------------- Interaction Objects --------------------------------*/

vc: slide10_vc

  creation condition: (slide = 10)

  objects:

    title(j1, "Interaction Objects")
    bullet(j2, "* Slang provides language for manipulating arbitrary", 250)
    bullet(j3, "  interaction objects", 310)
    bullet(j4, "* Interaction objects contain", 380)
    subbullet(j5, "- attributes for presentation", 450)  
    subbullet(j6, "- methods for interaction", 500)  
    bullet(j7, "* Slang allows for extensible presentation technologies", 570)
    subbullet(j8, "- X11 Athena Widget Toolkit, Motif, and digital", 640)  
    subbullet(j9, "  mapping system currently supported", 680)  
    subbullet(j10, "- video and gesturing system planned", 730)  

end vc slide10_vc

/*--------------------- Constraint Mechanism -------------------------------*/

vc: slide11_vc

  creation condition: (slide = 11)

  objects:

    title(j1, "Constraint Mechanism")
    bullet(j2, "* Uses one way constraints", 250)
    bullet(j3, "* Implemented using `eager evaluation' technique", 320)
    bullet(j4, "  at run-time", 370)
    bullet(j5, "* Automatically used to maintain data items in", 440)
    bullet(j6, "  appropriate states", 490)
    subbullet(j7, "- object attributes and variables are automatically", 560)
    subbullet(j8, "  re-evaluated based on constraints", 600)
    subbullet(j9, "- calculations within methods are not re-evaluated", 650)

end vc slide11_vc

/*--------------------- View Controllers - 1 -------------------------------*/

vc: slide12_vc

  creation condition: (slide = 12)

  objects:

    title(j1, "View Controllers - 1")
    bullet(j2, "* Slang productions are called `view controllers'", 250)
    bullet(j3, "* Map application objects into technology objects", 320)
    bullet(j4, "* Collects objects that have common existence", 390)
    bullet(j5, "  condition", 440)


end vc slide12_vc

/*--------------------- View Controllers - 2 -------------------------------*/

vc: slide13_vc

  creation condition: (slide = 13)

  objects:

    title(j1, "View Controllers - 2")
    bullet(j2, "* Are templates which, when instantiated, make", 250)
    bullet(j3, "  collection of objects visible", 290)
    bullet(j4, "* Have `creation conditions' to control instantiation", 360)
    bullet(j5, "* Bound to particular instance of application data", 430)
    bullet(j6, "  which causes instantiation", 480)
    bullet(j7, "* Can be nested", 550)

end vc slide13_vc

/*--------------------- Serpent Architecture -------------------------------*/

vc: slide14_vc

  creation condition:  (slide = 14)

  objects:

    title(j1, "Serpent Architecture")

    application_label: XmLabel {
      Attributes:
        parent: slide_XmForm;
        fontList: FONT_20;
        labelString: "Application Layer";
        y: 240;
        x: DISPLAY_WIDTH / 2 - 200;
        width: 400;
        height: 75;
        borderColor: "black";
        borderWidth: 1;

    }

    arrow1: XmLabel {
      Attributes:
        parent: slide_XmForm;
        labelString: "";
        background: "black";
        foreground: "black";
        y: 	315;
        x: DISPLAY_WIDTH / 2;
        height: 25;
        width: 6;
        borderColor: "black";
        borderWidth: 1;
    }

    serpent_XmForm: XmBulletinBoard {
      Attributes:
        parent: slide_XmForm;
        height: 400;
        width: 600;
        y: 340;
        x: DISPLAY_WIDTH / 2 - 300;
        borderWidth: 1;
        borderColor: "black";
        resizePolicy: 0;
 
    }

    arrow2: XmLabel {
      Attributes:
        parent: serpent_XmForm;
        labelString: "";
        background: "black";
        foreground: "black";
        y: 	0;
        x: 299;
        height: 25;
        width: 6;
        borderWidth: 1;
        borderColor: "black";
    }

    dialogue_label: XmLabel {
      Attributes:
        parent: serpent_XmForm;
        fontList: FONT_20;
        labelString: "Dialogue Layer";
        y: 25;
        x: 100;
        width: 400;
        height: 75;
        borderColor: "black";
        borderWidth: 1;
    }

    arrow3: XmLabel {
      Attributes:
        parent: serpent_XmForm;
        labelString: "";
        foreground: "black";
        background: "black";
        y: 	100;
        x: 300;
        height: 50;
        width: 6;
        borderWidth: 1;
    }

    presentation_label: XmLabel {
      Attributes:
        parent: serpent_XmForm;
        fontList: FONT_20;
        labelString: "Presentation Layer";
        y: 150;
        x: 100;
        width: 400;
        height: 75;
        borderColor: "black";
        borderWidth: 1;
    }

    x_label: XmLabel {
      Attributes:
        parent: serpent_XmForm;
        fontList: FONT_20;
        labelString: "X Window System";
        y: 225;
        x: 100;
        width: 200;
        height: 75;
        borderColor: "black";
        borderWidth: 1;
    }

    other_label: XmLabel {
      Attributes:
        parent: serpent_XmForm;
        fontList: FONT_20;
        labelString: "I/O Technologies";
        y: 225;
        x: 300;
        width: 200;
        height: 75;
        borderColor: "black";
        borderWidth: 1;
    }

    serpent_label: XmLabel {
      Attributes:
        parent: serpent_XmForm;
        fontList: FONT_20;
        labelString: "Serpent";
        y: 325;
        x: 0;
        width: 600;
        height: 50;
    }

end vc slide14_vc

/*--------------------- Communication Between Layers -----------------------*/

vc: slide15_vc

  creation condition: (slide = 15)

  objects:

    title(j1, "Communication Between Layers")
    bullet(j2, "* Same for both applications and I/O technologies", 250)
    bullet(j3, "* Data format description for application or", 320)
    bullet(j4, "  technology generated from special Serpent interface", 370)
    bullet(j5, "  description language", 420)
    bullet(j6, "* Communications bundled into transactions", 490)

end vc slide15_vc

/*--------------------- Communication Mechanism ----------------------------*/

vc: slide16_vc

  creation condition: (slide = 16)

  objects:

    title(j1, "Communication Mechanism")
    bullet(j2, "* In terms of records and components of records", 250)
    bullet(j3, "* From perspective of application", 320)
    subbullet(j4, "- C Structures", 390)
    subbullet(j5, "- Ada Packages", 440)
    bullet(j6, "* From perspective of technology objects", 510)
    subbullet(j7, "- attributes", 580)
    subbullet(j8, "- methods", 630)

end vc slide16_vc

/*--------------------- Serpent Editor - 1 -------------------------------*/

vc: slide17_vc

  creation condition: (slide = 17)

  objects:

    title(j1, "Serpent Editor - 1")
    bullet(j2, "* Layouts of user interface are best specified or", 250)
    bullet(j3, "  examined graphically", 300)
    bullet(j4, "* Logic, dependencies and calculations are best", 370)
    bullet(j5, "  specified textually", 420)
    bullet(j6, "* Serpent editor has two portions", 490)
    subbullet(j7, "- structure editor for textual specification", 560)
    subbullet(j8, "- graphical editor for visualization of layout", 610)
    bullet(j9, "* Mechanism for moving between portions", 680)

end vc slide17_vc

/*--------------------- Serpent Editor - 2 -------------------------------*/

vc: slide18_vc

  creation condition: (slide = 18)

  objects:

    title(j1, "Serpent Editor - 2")
    bullet(j2, "* Implemented using Serpent", 250)
    bullet(j3, "* Currently over 5000 lines of Slang", 320)
    bullet(j4, "* Application layer", 390)
    subbullet(j5, "- has commands such as create vc, add object to vc, etc.", 460)
    subbullet(j6, "- saves and restores user interface specifications", 510)
    bullet(j7, "* User interface portion", 580)
    subbullet(j8, "- has forms for structured input", 650)
    subbullet(j9, "- manages layout for realization", 700)

end vc slide18_vc

/*--------------------- Summary -------------------------------*/

vc: slide19_vc

  creation condition: (slide = 19)

  objects:

    title(j1, "Summary")
    bullet(j2, "* Serpent  is a media independent UIMS which", 250)
    bullet(j3, "  supports incremental development of user", 300)
    bullet(j35, "  interfaces through", 350)
    subbullet(j4, "- features which support prototyping", 420)
    subbullet(j5, "- power which supports production", 470)
    subbullet(j6, "- providing an application programming interface", 520)
    subbullet(j7, "  which is constant through changes in the user", 560)
    subbullet(j8, "  interface or in input/output technology", 600)
    subbullet(j9, "- extensibility in user interface technologies", 650)

end vc slide19_vc

end vc main_talk_vc;
