  VC:  sensor

    /*
    ** Sub-VC to "dog":
    **   The sensor VC controls the creation of each sensor, including the
    **   lines from the sensor to the correlation centers.
    */

    CREATION CONDITION: (new ("sensor_sdd"))

#   define sensor_parent the_window

    VARIABLES:

      sensor_yloc;	/* set during ON CREATE */
      cc_line_hook_y:	sensor_yloc + (SENSOR_HEIGHT / 2);
      display_dialog:	FALSE;

    OBJECTS:

      right_sensor: XmPushButton

      {

      ATTRIBUTES:

        /* core stuff */

        parent:			sensor_parent;

        width:			SENSOR_WIDTH;
        height:			SENSOR_HEIGHT;

        borderWidth:		3;

        background:
	{
	  IF (sensor_sdd.status = GREEN_STATUS) THEN
		background := "spring green";
          ELSIF (sensor_sdd.status = YELLOW_STATUS) THEN
		background := "gold";
          ELSIF (sensor_sdd.status = RED_STATUS) THEN
		background := "orange red";
          ENDIF;
	}


        foreground:
	{
          IF (sensor_sdd.status = RED_STATUS) THEN
		foreground := "white";
          ELSE
		foreground := "black";
          ENDIF;
	}

        y:                      sensor_yloc;
        x:                      RIGHT_SENSOR_HOOK;

        labelString:		sensor_sdd.site_abbr;
        alignment:		CENTER;

      METHODS:

	notify:
	{
	  /*
	  ** Set display_dialog to true to force the display of a dialog XawBox.
	  */
	  display_dialog := TRUE;
	}

      }

      left_sensor: XmPushButton

      {

      ATTRIBUTES:


        parent:			sensor_parent;

        width:			SENSOR_WIDTH;
        height:			SENSOR_HEIGHT;

        borderWidth:		3;

        background:
	{
	  IF (sensor_sdd.status = GREEN_STATUS) THEN
		background := "spring green";

          ELSIF (sensor_sdd.status = YELLOW_STATUS) THEN
		background := "gold";

          ELSIF (sensor_sdd.status = RED_STATUS) THEN
		background := "orange red";

       /* ELSE do nothing */

          ENDIF;
	}


        foreground:
	{
          IF (sensor_sdd.status = RED_STATUS) THEN
            foreground := "white";
          ELSE
            foreground := "black";
          ENDIF;
	}

        y:                      sensor_yloc;
        x:                      SENSOR_TO_SIDE;

        labelString:		sensor_sdd.site_abbr;
        alignment:		CENTER;


      METHODS:

	notify:
	{
	  /*
	  ** Set display_dialog to true to force the display of a dialog XawBox.
	  */
	  display_dialog := TRUE;
	}
      }

      ON CREATE:
      {
	/*
	** Increment the sensor number (located in the main VC, "dog").
	** Using that number, determine the Y location of the sensor that
	** caused the instantiation of this VC.
	*/
	sensor_number := sensor_number + 1;
	sensor_yloc   := SENSOR_TO_TOP + 
		   ( (sensor_number - 1) * (SENSOR_HEIGHT + SENSOR_TO_SENSOR));
      }

#include "etro.sl"
#include "dialog.sl"

  ENDVC  sensor
