
/*--------------------------------------------------------------------------*\
|
|  Name:  Spider Chart Dialog
|
|  Description:
|     Manages the dialog and display for the spider chart demo.  This dialog
|     is associated with the Sensor Site Status application.
|
| $Log:	spider.sl,v $
% Revision 1.9  90/11/27  13:51:51  ejh
% spider.ill => spiderA.ill
% 
% Revision 1.8  90/11/21  15:15:45  rm
% changed widget names
% 
% Revision 1.7  90/10/26  15:41:25  rm
% changed to new smo names
% 
% Revision 1.6  90/09/06  15:32:29  rm
% no change
% 
% Revision 1.5  90/09/06  14:59:54  rm
% let background color be cadet blue on mips 
% commented out background color = black
% 
% Revision 1.4  90/09/05  19:56:07  rcs
% removed useless attributes
% removed useless attributes
% 
% Revision 1.3  90/08/28  16:29:53  rm
% changed to smo
% 
% Revision 1.2  90/03/16  16:14:27  rm
% added resize policy
% 
% Revision 1.1  90/02/27  13:45:40  rm
% Initial revision
% 
% Revision 1.2  90/02/07  21:35:37  ejh
% added a blank line after '|||'
% 
% Revision 1.1  89/10/10  23:43:54  serpent
% Initial revision
% 
Revision 1.3  89/09/01  15:10:40  ljb
make work under saw

Revision 1.2  89/08/18  08:56:29  trm
no changes. just checkin' checkin.   trm.

Revision 1.1  89/08/01  14:58:00  serpent
initial_checkin

| Revision 1.5  89/03/27  16:22:12  bmc
| - VC "dialog" is now a sub-VC to "sensor".
| 
| Revision 1.4  89/03/24  13:31:11  bmc
| Most calls to get_component_value and put_component_value replaced
| by direct access to variables.  Removed all calls to get_local.
| Removed all uses of and definitions for get_grandparent_vc and
| company.
| 
| Revision 1.3  89/03/22  16:22:25  bmc
| - Correlation centers are now part of the main VC, and come into being
|   immediately.  They are no longer tied to an spplication shared data
|   element.
| - All constants are now upper case.  (Consistent with C)
| - Various cosmetic changes made.
| 
\*---------------------- Copyright 1987 CMU --------------------------------*/

#include "spiderA.ill"
#include "smo.ill"
|||

/* definitions shared with application */
#include "shared.h"

#include "defines.sl"
#include "nsl.sl"

  /*
  ** The top level VC holds variables and owns the main display
  ** window.  It also contains constant display items, such as the correlation
  ** centers, which never change.
  */


  VARIABLES:

    sensor_number:  0;				/* # assigned to next sensor */

  OBJECTS:

    the_window: XmBulletinBoard		/* the parent of 'em all */

    {

    ATTRIBUTES:

      width:		   XMAX;
      height:		   YMAX;
      resizePolicy: 0;
/*      background:    "black"; */
    }


    cmc_cc: XmLabel			/* CMC correlation center */

    {

    ATTRIBUTES:

      /* core stuff */

      parent:		    the_window;

      width:		    CC_WIDTH;
      height:		    CC_HEIGHT;
      background:	    "green";
      y:                    CC_YLOC;
      x:                    LEFT_CC_SENSOR_HOOK;

      labelString:	    "CMC";
      alignment:		    CENTER;


    }

    quit_button: XmPushButton
    {
      Attributes:
        parent:            the_window;
        width: 40;
        height: 40;
        y: 10;
        x: 400;
        labelString: "QUIT";
        borderWidth: 3;
        alignment: 1;

    METHODS:

      notify:
        {
         exit ();
        }
    }

    oft_cc:  XmLabel

    {

    ATTRIBUTES:
      parent:		    the_window;
      width:		    CC_WIDTH;
      height:		    CC_HEIGHT;
      background:	    "green";
      y:                    CC_YLOC;
      x:                    SIDE_TO_MIDDLE + CC_LINE_OFFSET;
      labelString:	    "OFT";
      alignment:            CENTER;
    }


    non_selectable_line(cc_to_cc_line,
                        the_window,
                        CC_FROM_X,
                        TOP_TO_MID_CC,
                        CC_TO_X-CC_FROM_X,
                        "x",
                        "green")

    non_selectable_line(cc_left_line,
                        the_window,
                        LEFT_CC_SENSOR_HOOK - CC_LINE_STUB,
                        TOP_TO_MID_CC,
                        CC_LINE_STUB,
                        "x",
                        "green")

    non_selectable_line(cc_right_line,
                        the_window,
                        RIGHT_CC_SENSOR_HOOK,
                        TOP_TO_MID_CC,
                        CC_LINE_STUB,
                        "x",
                        "green")

    non_selectable_line(cc_left_vert,
                        the_window,
                        LEFT_CC_SENSOR_HOOK - CC_LINE_STUB,
                        SENSOR_TO_TOP,
                        YMAX - SENSOR_TO_TOP - SENSOR_TO_BOTTOM,
                        "y",
                        "green")

    non_selectable_line(cc_right_vert,
                        the_window,
                        RIGHT_CC_SENSOR_HOOK + CC_LINE_STUB,
                        SENSOR_TO_TOP,
                        YMAX - SENSOR_TO_TOP - SENSOR_TO_BOTTOM,
                        "y",
                        "green")

    
#include "sensor.sl"

#include "lines.sl"
