/* $Header: /u/04c/mnt/integ/source/dm/include/RCS/d22.h,v 1.26 90/12/29 10:17:10 little Exp $ */


/*
$Log:	d22.h,v $
 * Revision 1.26  90/12/29  10:17:10  little
 * change dgr_sne to also hold the ids for the two items
 * 
 * Revision 1.25  90/12/06  20:24:30  little
 * speed things up by keeping the original_name_prop, template_prop, and
 * type_prop in the dob_object in addition to the sym tab
 * 
 * Revision 1.24  90/12/01  13:38:27  little
 * modified d22_pot_fl_entity and added d22_st_pfle_info to support threads
 * in pfl.
 * 
 * Revision 1.23  90/11/01  15:45:47  little
 * no changes
 * 
 * Revision 1.22  90/10/10  15:43:01  dvk
 * Added d22_header type
 * 
 * Revision 1.21  90/10/09  16:20:01  little
 * change d22_pot_fl_entity to have an id instead of dob_object
 * 
 * Revision 1.20  90/10/04  19:21:36  little
 * BIG change to the propagate mechanism
 * 
 * Revision 1.19  90/10/01  13:16:18  little
 * add potential firing line stuff
 * 
 * Revision 1.18  90/07/19  11:48:42  little
 * fix so EXTERN can be redefined w/o cpp warning messages
 * 
 * Revision 1.17  90/02/14  22:15:23  ejh
 * fixed include structure
 * 
 * Revision 1.16  90/01/12  15:04:59  dvk
 * Deleted d22_slang _source and added new variables to support shared
 * strings (d22_cur_type, d22_cur_obj, etc.)
 * 
 * Revision 1.15  89/12/27  14:55:11  ejh
 * changed d22_ftl_err to d22_fatal
 * 
 * Revision 1.14  89/12/21  16:46:55  little
 * change d22_fatal_error.h to d22_ftl_err.h
 * 
 * Revision 1.13  89/12/21  11:52:17  little
 * add support for slang file name output during dm run-time error print
 * 
 * Revision 1.12  89/11/02  16:25:45  little
 * put the debug macros un NDEBUG control
 * 
 * Revision 1.11  89/10/02  13:31:04  rcs
 * removed stupid include of serpent.h
 * 
 * Revision 1.10  89/09/20  12:08:18  little
 * change runtime error printout to better highlight the real error with a
 * shit load of *s
 * 
 * Revision 1.9  89/08/29  17:43:26  little
 * change definition of d22_slang_source so the addition rt error print
 * works with the new way the compiler is generating the string
 * >> .
 * change god to eve
 * 
 * Revision 1.8  89/06/09  13:39:49  little
 * add definition of d22_monitor
 * 
 * Revision 1.7  89/05/26  10:53:18  little
 * changes definition of d22_sne from a list to be a pointer to a dgr_sne.
 * 
 * Revision 1.6  89/02/09  16:38:53  ejh
 * added copyright notice
 * 
 * Revision 1.5  89/01/04  15:40:56  little
 * add printing of d22_slang_source to FATAL_ERROR
 * 
 * Revision 1.4  88/11/04  16:59:24  little
 * change DEBUG1 to also print global d22_slang_source which will contain
 * vc name, object, att name, var name, etc.
 * 
 * Revision 1.3  88/10/27  18:47:44  little
 * add definition for d22_temp_free_list
 * 
 * Revision 1.2  88/10/12  15:58:03  little
 * add d22_recording_on flag
 * 
*/

/*--------------------------------------------------------------------------*\
|
|   Distribution: Approved for public release; distribution is unlimited.
|
|   Copyright (c) 1989  by  Carnegie  Mellon  University, Pittsburgh, PA.  The
|  Software Engineering  Institute  (SEI) is a federally  funded  research and
|  development center established  and  operated by Carnegie Mellon University
|  (CMU).  Sponsored  by  the  U.S.  Department  of   Defense  under  contract
|  F19628-85-C-0003,  the  SEI  is  supported  by  the  services  and  defense
|  agencies, with the U.S. Air Force as the executive contracting agent.
|
|    Permission to use,  copy,  modify, or  distribute  this  software and its
|  documentation for  any purpose and without fee  is hereby granted, provided
|  that  the above copyright notice appear  in  all copies and that both  that
|  copyright  notice  and   this  permission  notice  appear   in   supporting
|  documentation.   Further,  the  names  Software  Engineering  Institute  or
|  Carnegie  Mellon  University  may  not be used in  advertising or publicity
|  pertaining to distribution of the software without specific, written  prior
|  permission.  CMU makes no claims  or representations  about the suitability
|  of this software for any purpose.  This software is provided "as is" and no
|  warranty,  express  or  implied,  is  made  by  the  SEI  or CMU, as to the
|  accuracy  and  functioning of the program and related program material, nor
|  shall   the  fact of  distribution   constitute  any   such  warranty.   No
|  responsibility is assumed by the SEI or CMU in connection herewith.
|
\*--------------------------------------------------------------------------*/

#ifndef	d22
#define	d22

#include	"global.h"
#include	"cus.h"
#include	"listPack.h"
#include	"alistPack.h"
#include	"d22_fatal.h"
#include	"dgr.h"
#include 	"dob.h"
#include 	"iid.h"

/*
	?? need to coordinate with the definition of god text in c22.h
*/
#define d22_god_text "EVE"

/*
	?? need to coordinate this number within dm and across to compiler
*/
#define MAX_FILE_NAME_LENGTH 257

#ifdef EXTERN
#undef EXTERN
#endif

#ifdef d22_TOP
#  define EXTERN
#else
#  define EXTERN extern
#endif

EXTERN cus_code_type d22_cur_type;
EXTERN char * d22_cur_attr;
EXTERN char * d22_cur_obj;
EXTERN char * d22_cur_vc;
EXTERN char * d22_cur_var;
EXTERN char * d22_slang_file;

typedef struct {
    int slang_line_num;
    char * slang_file;
    cus_code_type cur_type;
    char * str1, * str2;
    caddr_t cur_vc;
    dgr_sne * sne;
    } d22_header;

EXTERN int d22_debug;
EXTERN LIST d22_firing_line;
EXTERN dgr_sne *d22_sne;
EXTERN ASTACK d22_save_sne;
EXTERN int d22_slang_line_num;
EXTERN cus_sym d22_god_vc;
EXTERN boolean d22_xactions_open;
EXTERN boolean d22_recording_on;
EXTERN caddr_t d22_temp_free_list;
EXTERN boolean d22_monitor;


			/* this structure for each item on d22_pfl. */
typedef struct d22_dumb_name {
    int type;			/* set or ref type of access to item */
    iid_id_type the_object;	/* the item */
    int component_position;	/* component if sd, otherwise not used  */
    } d22_pot_fl_entity;

			/* this is form of data in the pfl_prop in the
			   symbol table.  it is used to point the the front
			   and back of the thread for a particular entity
			   on d22_pfl, it also records the snippet call
			   level to which it belongs. */
typedef struct {
    d22_pot_fl_entity *first;
    d22_pot_fl_entity *last;
    int level;
    } d22_st_pfle_info;


			/* this is used to keep track of which level we in are
			   when snippet call snippets.  it is incremented just
			   before we do something which can cause a snippet
			   call and then decremented once that potential is
			   over.  */
EXTERN int d22_pot_fl_time_stamp;

			/* potential firing line */
EXTERN LIST d22_pfl;

			/* save area for potential firing line, used so 
			   dgr_run_snippet can be reenterant */
EXTERN ASTACK d22_save_pfl;


#ifndef NDEBUG
extern void dmsg_slang_context();

#define DEBUG1(statement)\
   if (d22_debug > 0)\
      {\
        statement;\
	dmsg_slang_context(__FILE__, __LINE__, 1);\
      }

#define DEBUG2(statement)\
   if (d22_debug > 1)\
      {\
        statement;\
	fprintf (stderr, "	file %s, line %d\n", __FILE__, __LINE__);\
        fflush (stderr);\
      }

#define DEBUG3(statement)\
   if (d22_debug > 2)\
      {\
        statement;\
	fprintf (stderr, "	file %s, line %d\n", __FILE__, __LINE__);\
        fflush (stderr);\
      }
#else
#define DEBUG1(statement)
#define DEBUG2(statement)
#define DEBUG3(statement)
#endif

#undef EXTERN
#endif	/* ifndef d22 */
