/*
$Header: /u/04c/mnt/integ/source/dm/include/RCS/d22_debug.h,v 1.9 90/11/19 11:31:39 rcs Exp $
*/

/*
$Log:	d22_debug.h,v $
 * Revision 1.9  90/11/19  11:31:39  rcs
 * added abort command to debug1
 * 
 * Revision 1.8  90/03/17  11:45:38  rcs
 * memory leak fix
 * 
 * Revision 1.7  90/01/12  15:04:28  dvk
 * Modified error message handling to used shared strings from Slang
 * 
 * Revision 1.6  89/12/21  11:52:52  little
 * add support for slang file name output during dm run-time error print
 * 
 * Revision 1.5  89/11/02  17:22:48  little
 * put the debug macros under NDEBUG
 * 
 * Revision 1.4  89/09/20  12:09:25  little
 * no changes
 * 
 * Revision 1.3  89/08/29  17:41:44  little
 * change definition of d22_slang_source so the addition rt error print
 * works with the new way the compiler is generating the string
 * 
 * Revision 1.2  89/02/09  16:40:29  ejh
 * added copyright notice
 * 
 * Revision 1.1  88/11/04  16:58:13  little
 * Initial revision
 * 
*/

/*--------------------------------------------------------------------------*\
|
|   Distribution: Approved for public release; distribution is unlimited.
|
|   Copyright (c) 1989  by  Carnegie  Mellon  University, Pittsburgh, PA.  The
|  Software Engineering  Institute  (SEI) is a federally  funded  research and
|  development center established  and  operated by Carnegie Mellon University
|  (CMU).  Sponsored  by  the  U.S.  Department  of   Defense  under  contract
|  F19628-85-C-0003,  the  SEI  is  supported  by  the  services  and  defense
|  agencies, with the U.S. Air Force as the executive contracting agent.
|
|    Permission to use,  copy,  modify, or  distribute  this  software and its
|  documentation for  any purpose and without fee  is hereby granted, provided
|  that  the above copyright notice appear  in  all copies and that both  that
|  copyright  notice  and   this  permission  notice  appear   in   supporting
|  documentation.   Further,  the  names  Software  Engineering  Institute  or
|  Carnegie  Mellon  University  may  not be used in  advertising or publicity
|  pertaining to distribution of the software without specific, written  prior
|  permission.  CMU makes no claims  or representations  about the suitability
|  of this software for any purpose.  This software is provided "as is" and no
|  warranty,  express  or  implied,  is  made  by  the  SEI  or CMU, as to the
|  accuracy  and  functioning of the program and related program material, nor
|  shall   the  fact of  distribution   constitute  any   such  warranty.   No
|  responsibility is assumed by the SEI or CMU in connection herewith.
|
\*--------------------------------------------------------------------------*/

#ifndef d22_debug
#define d22_debug

#ifndef NDEBUG
extern void dmsg_slang_context();

#define DM_RT_DEBUG1(flag, statement)\
if (flag > 0) \
   { \
   fprintf (stderr, "\n\nDM ERROR, "); \
   dmsg_slang_context(__FILE__, __LINE__, 1); \
   statement; \
   fflush(stderr); \
   abort();\
   }
#else
#define DM_RT_DEBUG1(flag, statement)\
if (flag > 0) \
   { \
   fprintf (stderr, "\n\nDM ERROR, "); \
   dmsg_slang_context(__FILE__, __LINE__, 0); \
   statement; \
   fflush(stderr); \
   abort();\
   }
#endif

#endif

