/* $Header: /u/04c/mnt/integ/source/dm/include/RCS/din.h,v 1.12 91/01/02 17:53:22 dvk Exp $ */


/*--------------------------------------------------------------------------*\
|
|   Distribution: Approved for public release; distribution is unlimited.
|
|   Copyright (c) 1989  by  Carnegie  Mellon  University, Pittsburgh, PA.  The
|  Software Engineering  Institute  (SEI) is a federally  funded  research and
|  development center established  and  operated by Carnegie Mellon University
|  (CMU).  Sponsored  by  the  U.S.  Department  of   Defense  under  contract
|  F19628-85-C-0003,  the  SEI  is  supported  by  the  services  and  defense
|  agencies, with the U.S. Air Force as the executive contracting agent.
|
|    Permission to use,  copy,  modify, or  distribute  this  software and its
|  documentation for  any purpose and without fee  is hereby granted, provided
|  that  the above copyright notice appear  in  all copies and that both  that
|  copyright  notice  and   this  permission  notice  appear   in   supporting
|  documentation.   Further,  the  names  Software  Engineering  Institute  or
|  Carnegie  Mellon  University  may  not be used in  advertising or publicity
|  pertaining to distribution of the software without specific, written  prior
|  permission.  CMU makes no claims  or representations  about the suitability
|  of this software for any purpose.  This software is provided "as is" and no
|  warranty,  express  or  implied,  is  made  by  the  SEI  or CMU, as to the
|  accuracy  and  functioning of the program and related program material, nor
|  shall   the  fact of  distribution   constitute  any   such  warranty.   No
|  responsibility is assumed by the SEI or CMU in connection herewith.
|
\*--------------------------------------------------------------------------*/

/*
$Log:	din.h,v $
 * Revision 1.12  91/01/02  17:53:22  dvk
 * Sweeping changes throughout dialogue manager for new interpreter code
 * 
 * Revision 1.11  90/11/01  15:46:13  little
 * no changes
 * 
 * Revision 1.10  90/10/08  16:34:51  dvk
 * shortened SD_QUALIFIER_STRING from "THIS_BE_SD_" to "SD_" to speed up
 * initialization and lookup.  Also changed ESCAPE header from '#' to '\n'
 * to make the files more readable (it occasionally matters...)
 * 
 * Revision 1.9  90/07/19  11:54:37  little
 * add defininition for din_validate_firing
 * 
 * Revision 1.8  90/02/14  22:15:55  ejh
 * fixed include structure
 * 
 * Revision 1.7  90/01/19  16:24:32  dvk
 * Changed strlen calculations of constant strings to simple constants
 * 
 * Revision 1.6  89/12/23  22:02:11  ejh
 * no change
 * 
 * Revision 1.5  89/07/24  14:57:47  little
 * ops removal
 * 
 * Revision 1.4  89/02/15  18:08:32  little
 * add definition for din_get_dm_name and copyright notice
 * 
 * Revision 1.3  88/11/02  13:31:09  little
 * add the second parameter to the definition of din_minor_cycle
 * 
 * Revision 1.2  88/10/03  09:05:57  little
 * remode definition for din_init_interface routine
 * 
*/

#ifndef	din
#define	din

#include	"global.h"
#include	"cus.h"

#ifdef	din_TOP
#  define EXTERN
#else
#  define EXTERN extern
#endif

EXTERN	boolean	din_debug;

/* !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
 *
 *	ALL ESCAPE SEQUENCE STRINGS MUST BE OF THE SAME LENGTH AND
 *	OF COURSE THEY HAVE TO BE UNIQUE.  MAKE SURE THAT THE DEFINITION
 *	OF ESCAPE_LENGTH IS CORRECT!
 *
 *  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
 */
#define ESCAPE_LENGTH 2
#define SYMBOL_ESCAPE "\nS"
#define PROPERTY_ESCAPE "\nP"
#define OPEN_LIST_ESCAPE "\n("
#define CLOSE_LIST_ESCAPE "\n)"
#define INTEGER_ESCAPE "\nI"
#define BEGIN_SYMBOL_ENTRY_ESCAPE "\nB"
#define END_SYMBOL_ENTRY_ESCAPE "\nE"
#define STRING_ESCAPE "\nG"

#define	MAX_CYCLES	10

/* the following is used to qualify sd element templates when they are put
 * into the "static" sym tab at dm initialize time
 *
 * MAKE SURE the length matches the string!!!
 */
#define SD_QUALIFIER_STRING "SD_"
#define SD_QUALIFIER_LENGTH 3

/*
 * These types are used to define the size of length markers in the
 * generated symbol table file.
 */
typedef short		string_length;
typedef unsigned char	id_length;
typedef unsigned char	symtype_length;
typedef unsigned char	proptype_length;

/*  -------------------------------------------------  din_get_st_data */
void din_get_st_data (
/*	stream:	in	*FILE */
	);

/*  -------------------------------------------------  din_get_st_entry */
boolean din_get_st_entry (
/*	stream:	in	*FILE */
	);

/*  -------------------------------------------------  din_get_dm_name */
char *din_get_dm_name (
	);

/*  -------------------------------------------------  din_get_element */
char *din_get_element (
/*	stream:	in	*FILE */
	);

/*  -------------------------------------------------  din_get_symbol */
cus_sym din_get_symbol (
/*	stream:	in	*FILE */
	);

/*  -------------------------------------------------  din_read_symbol */
cus_sym din_read_symbol (
/*	stream:	in	*FILE */
	);

/*  -------------------------------------------------  din_get_prop */
boolean din_get_prop (
/*	stream:	in	*FILE,
	symbol:	in	cus_sym */
	);

/*  -------------------------------------------------  din_read_integer */
char *din_read_integer (
/*	stream:	in	*FILE */
	);

/*  -------------------------------------------------  din_read_list */
char *din_read_list (
/*	stream:	in	*FILE */
	);

/* -------------------------------------------     cds_string_write */
void cds_string_write (
/*	stream:		in	*FILE,
	the_string:	in	string */
	);

/*  -------------------------------------------------  din_read_string */
char *din_read_string (
/*	stream:	in	*FILE */
	);

/* ------------------------------------------------    din_process_tap_info */
void din_process_tap_info (
/*	file_name:	in	string */
	);

/* -------------------------------------------    din_terminate_interface */
void din_terminate_interface (
	);

/* ----------------------------------------------------   din_main  */
void din_main (
	);

/* ----------------------------------------------   din_start_transactions */
void din_start_transactions (
	);

/* ----------------------------------------------   din_commit_transactions */
void din_commit_transactions (
	);

/* -------------------------------------------   din_rollback_transactions */
void din_rollback_transactions (
	);

/* -------------------------------------------   din_process_xaction */
boolean din_process_xaction (
/*	wait:	in	boolean */
	);

/* -------------------------------------------   din_abnormal_termination */
void din_abnormal_termination (
	);

/* -------------------------------------------   din_init */
void din_init (
/*	dialogue : in string */
	);

/* -------------------------------------------   din_cleanup */
void din_cleanup (
	);


/*--------------------------------------------------------------------------*\
|  Routine: din_validate_firing
|
|  Description:
|     checks to see if the snippet/sne combination has been fired too
|       many times in the major cycle
\*--------------------------------------------------------------------------*/
void din_validate_firing (
/* dgr_sne the_sne */
	);


#endif

