static char rcsid [] =
	"$Header: /u/04c/mnt/integ/source/dm/src/RCS/din_int.c,v 1.15 91/01/07 00:37:47 ejh Exp $";

/*
$Log:	din_int.c,v $
 * Revision 1.15  91/01/07  00:37:47  ejh
 * include Xos.h to get the right value of rindex
 * 
 * Revision 1.14  91/01/02  17:52:06  dvk
 * Sweeping changes throughout dialogue manager for new interpreter code
 * 
 * Revision 1.13  90/11/12  14:51:29  rcs
 * no change
 * 
 * Revision 1.12  90/05/23  15:36:01  clc
 * added use of SERPENT_DATA_PATH
 * 
 * Revision 1.11  90/02/14  22:19:04  ejh
 * fixed include structure
 * 
 * Revision 1.10  89/10/23  19:47:47  ejh
 * declared fopen
 * 
 * Revision 1.9  89/08/29  17:39:45  little
 * change god to eve
 * 
 * Revision 1.8  89/05/25  17:35:47  little
 * rearrange include order becasue of changes to d22_sne int d22.h
 * 
 * Revision 1.7  89/02/09  17:34:02  ejh
 * added copyright notice
 * 
 * Revision 1.6  89/01/06  17:16:03  little
 * no change
 * 
 * Revision 1.5  89/01/06  17:14:55  little
 * no change
 * 
 * Revision 1.4  89/01/06  17:01:45  little
 * no change
 * 
 * Revision 1.3  89/01/06  16:58:36  little
 * no change
 * 
 * Revision 1.2  88/10/03  09:12:01  little
 * add dm shared data
 * 
*/

/*--------------------------------------------------------------------------*\
|
|   Distribution: Approved for public release; distribution is unlimited.
|
|   Copyright (c) 1989  by  Carnegie  Mellon  University, Pittsburgh, PA.  The
|  Software Engineering  Institute  (SEI) is a federally  funded  research and
|  development center established  and  operated by Carnegie Mellon University
|  (CMU).  Sponsored  by  the  U.S.  Department  of   Defense  under  contract
|  F19628-85-C-0003,  the  SEI  is  supported  by  the  services  and  defense
|  agencies, with the U.S. Air Force as the executive contracting agent.
|
|    Permission to use,  copy,  modify, or  distribute  this  software and its
|  documentation for  any purpose and without fee  is hereby granted, provided
|  that  the above copyright notice appear  in  all copies and that both  that
|  copyright  notice  and   this  permission  notice  appear   in   supporting
|  documentation.   Further,  the  names  Software  Engineering  Institute  or
|  Carnegie  Mellon  University  may  not be used in  advertising or publicity
|  pertaining to distribution of the software without specific, written  prior
|  permission.  CMU makes no claims  or representations  about the suitability
|  of this software for any purpose.  This software is provided "as is" and no
|  warranty,  express  or  implied,  is  made  by  the  SEI  or CMU, as to the
|  accuracy  and  functioning of the program and related program material, nor
|  shall   the  fact of  distribution   constitute  any   such  warranty.   No
|  responsibility is assumed by the SEI or CMU in connection herewith.
|
\*--------------------------------------------------------------------------*/

#define	memoryPack

#include	<stdio.h>
#include	<X11/Xos.h>
#include	<global.h>
#include	<listPack.h>
#include	<cus.h>
#include	<isc.h>
#include	<isd.h>
#include	<d22.h>
#include	<din.h>
#include	<ufa.h>
#include	<u22.h>
#include	<ipb.h>

/*
?  no dm ill file defines need to be in an h for compiler & dm
*/
#define DATA_PATH_ENV_VAR_NAME "SERPENT_DATA_PATH"

/* ------------------------------------------------    din_process_tap_info */
void din_process_tap_info (file_name)
string file_name;
{  FILE *dm_init_file;
   char mailbox_name [MAX_FILE_NAME_LENGTH];
   char ill_file_name [MAX_FILE_NAME_LENGTH];
   string data_search_paths, full_data_path;
   LIST tap_list;
   isd_process tap;
   char dm_box_name[50];
   boolean found_dm_box = FALSE;
   char *modified_cmd;
   /*
   **  Remove path information from the command name.
   */
   if ((modified_cmd = rindex(din_get_dm_name (), '/')) != NULL)
     modified_cmd++;
   else
     modified_cmd = din_get_dm_name ();
   /*
   **  Convert command name into environmental variable format.
   */
   strcpy(dm_box_name, modified_cmd);
   u22_convert_string_inplace(dm_box_name, UPPERCASE);
   strcat(dm_box_name, "_BOX");

   if (!getenv (DATA_PATH_ENV_VAR_NAME)) {
      fprintf(stderr, "%s environment var not present\n",
              DATA_PATH_ENV_VAR_NAME);
      exit(1);
   }

   data_search_paths = u22_copy_string (getenv (DATA_PATH_ENV_VAR_NAME));

   if (!strlen (data_search_paths)) {
      data_search_paths [0] = '.';
      data_search_paths [1] = '\0';
      }


   full_data_path = ufa_full_file_name (data_search_paths, file_name);
   if (full_data_path == NULL)
      FATAL_ERROR (fprintf (stderr, "CANNOT FIND %s FILE, BAILING OUT\n,",
		file_name));

   dm_init_file = fopen (full_data_path, "r");
   if (dm_init_file == NULL)
      FATAL_ERROR (fprintf (stderr, "CANNOT OPEN %s FILE, BAILING OUT\n,",
		full_data_path));
   tap_list = make_list ();
   /*
    *  Scan file for mailbox names and ill files.
    */
   while (fscanf (dm_init_file, "%s%s", mailbox_name, ill_file_name) != EOF) {
      /* 
       *  we need to do special processing for the DM 
       */
      if (!strcmp (mailbox_name, dm_box_name)) {
	  found_dm_box = TRUE;
	  if (!strcmp (ill_file_name, NO_ILL_FILE))
	       isd_dm_init_sdd (NULL);
	  else
	       isd_dm_init_sdd (ill_file_name);
	  if (get_status ())
	       FATAL_ERROR (
		  isc_print_status ("din_init: bad status from isd_dm_init of")
	       );
	  }
       else {
	   tap = isd_create_process_definition (mailbox_name, ill_file_name);
	   if (get_status())
	       FATAL_ERROR (isc_print_status (
   "din_process_tap_info: problems with isd_create_process_definition status = "
				   )
	       );
	    add_to_tail (tap_list, tap);
	   }
	 }
    /*
     * If we didn't fined the dm box name, we have to initialize it anyway
     * (just means that there is no dialogue shared data, but the DM uses
     * the shared data model anyway to communicate with Six, etc.)
     */
    if (!found_dm_box)
       isd_dm_init_sdd (NULL);

   if (list_length (tap_list) < 1)
      FATAL_ERROR (fprintf (stderr, "dm found no taps\n"));

   cus_put_prop (d22_god_vc, taps_prop, tap_list);

   fclose (dm_init_file);
}

/* -------------------------------------------    din_terminate_interface */
void din_terminate_interface ()
{
   LIST tap_list;
   isd_process tap;
   cus_sym god_vc;


   god_vc = cus_look_up (d22_god_text);
   if (!god_vc)
      FATAL_ERROR (fprintf (stderr, "terminate_interface cannot find EVE\n"));
   tap_list = (LIST) cus_get_prop (god_vc, taps_prop);
   loop_through_list (tap_list, tap, isd_process) {
      isd_destroy_process_definition (tap);
      if (get_status())
         FATAL_ERROR (isc_print_status (
"din_term_inter: problems with isd_destroy_process_definition status = "));
      }
   isd_dm_cleanup ();
   if (get_status())
      FATAL_ERROR (isc_print_status
		("din_term_inter: problems with isd_cleanup status = "));
}
