static char rcsid[] = "$Header: /u/04c/mnt/integ/source/dm/src/RCS/dmsg.c,v 1.5 90/10/12 10:01:34 little Exp $";

/*--------------------------------------------------------------------------*\
|
|  Name:  Dialogue message maker - dmsg
|
|  Description: 
|     Prints out messages commonly used in fatal errors, debugging, etc.
|
|  Component of
|     Dialogue Manager Layer
|
|  Project
|     SERPENT System
|     User Interface Prototyping
|     Software Engineering Institute
|     Carnegie Mellon University
|     Pittsburgh, PA  15213
|
|  Change History
|
$Log:	dmsg.c,v $
 * Revision 1.5  90/10/12  10:01:34  little
 * fix dmsg_setup to define and use the second parameter is was being
 * called with
 * 
 * Revision 1.4  90/10/10  15:42:41  dvk
 * Added dmsg_setup
 * 
 * Revision 1.3  90/09/11  20:35:04  rcs
 * *** empty log message ***
 * 
 * Revision 1.2  90/02/14  22:20:13  ejh
 * fixed include structure
 * 
 * Revision 1.1  90/01/12  15:09:41  dvk
 * Initial revision
 * 
|     January 9, 1990 : Module created
|
\*--------------------------------------------------------------------------*\
|
|   Distribution: Approved for public release; distribution is unlimited.
|
|   Copyright (c) 1990  by  Carnegie  Mellon  University, Pittsburgh, PA.  The
|  Software Engineering  Institute  (SEI) is a federally  funded  research and
|  development center established  and  operated by Carnegie Mellon University
|  (CMU).  Sponsored  by  the  U.S.  Department  of   Defense  under  contract
|  F19628-85-C-0003,  the  SEI  is  supported  by  the  services  and  defense
|  agencies, with the U.S. Air Force as the executive contracting agent.
|
|    Permission to use,  copy,  modify, or  distribute  this  software and its
|  documentation for  any purpose and without fee  is hereby granted, provided
|  that  the above copyright notice appear  in  all copies and that both  that
|  copyright  notice  and   this  permission  notice  appear   in   supporting
|  documentation.   Further,  the  names  Software  Engineering  Institute  or
|  Carnegie  Mellon  University  may  not be used in  advertising or publicity
|  pertaining to distribution of the software without specific, written  prior
|  permission.  CMU makes no claims  or representations  about the suitability
|  of this software for any purpose.  This software is provided "as is" and no
|  warranty,  express  or  implied,  is  made  by  the  SEI  or CMU, as to the
|  accuracy  and  functioning of the program and related program material, nor
|  shall   the  fact of  distribution   constitute  any   such  warranty.   No
|  responsibility is assumed by the SEI or CMU in connection herewith.
|
\*--------------------------------------------------------------------------*/

#include	<stdio.h>
#include	"cus.h"
#include	"d22.h"

void dmsg_setup (hdr, the_sne)
d22_header *hdr;
dgr_sne *the_sne;
{
    d22_cur_type = hdr->cur_type;
    switch (hdr->cur_type) {
	case cus_ATTR:
	    d22_cur_attr = hdr->str1;
	    d22_cur_obj = hdr->str2;
	    break;
	case cus_METH:
	    d22_cur_obj = hdr->str2;
	    break;
	case cus_VAR:
	    d22_cur_var = hdr->str2;
	    break;
	}
    d22_cur_vc = hdr->cur_vc;
    d22_slang_file = hdr->slang_file;
    d22_slang_line_num = hdr->slang_line_num;
    d22_sne = the_sne;
}

void dmsg_slang_context(file,line,full)
{
    fprintf (stderr, "at or near line %d, ", d22_slang_line_num);
    fprintf (stderr, "in Slang file %s\n\tSlang element:", d22_slang_file);
    switch (d22_cur_type) {
	case cus_ATTR:
	    fprintf (stderr, "attribute = %s, object = %s, vc = %s\n",
				d22_cur_attr, d22_cur_obj, d22_cur_vc);
	    break;
	case cus_CREATE:
	    fprintf (stderr, "create action, vc = %s\n", d22_cur_vc);
	    break;
	case cus_DESTROY:
	    fprintf (stderr, "destroy action, vc = %s\n", d22_cur_vc);
	    break;
	case cus_METH:
	    fprintf (stderr, "methods, object = %s, vc = %s\n",
				d22_cur_obj, d22_cur_vc);
	    break;
	case cus_CCOND:
	    fprintf (stderr, "creation condition, vc = %s\n", d22_cur_vc);
	    break;
	case cus_VAR:
	    fprintf (stderr, "variable = %s, vc = %s\n",
				d22_cur_var, d22_cur_vc);
	    break;
	case cus_UNKNOWN:
	    fprintf (stderr, "<UNKNOWN LOCATION>\n");
	    break;
	}
    if (full)
	fprintf (stderr, "\tDM runtime library file: %s, line %d\n",
	    file, line);
    fflush(stderr);
}

void dmsg_fatal_1(file,line)
{
    fprintf (stderr, "\n\n***********************************************\n");
    fprintf (stderr, "!!!!!     DM FATAL ERROR, ");
    dmsg_slang_context(file, line, 1);
}
