static char rcsid [] = "$Header: /u/04c/mnt/integ/source/dm/src/RCS/dob_make.c,v 1.15 91/01/08 17:06:56 dvk Exp $";

/*
$Log:	dob_make.c,v $
 * Revision 1.15  91/01/08  17:06:56  dvk
 * Added new routine dob_make_real_CONSTANT_adi, cleaned up other stuff
 * 
 * Revision 1.14  90/08/14  11:52:27  rcs
 * added new make buffer constant routine
 * 
 * Revision 1.13  90/02/14  22:21:10  ejh
 * fixed include structure
 * 
 * Revision 1.12  90/01/19  16:39:45  dvk
 * Added new routine dob_make_id_CONSTANT_adi
 * 
 * Revision 1.11  90/01/12  15:02:25  dvk
 * Added new routines dob_make_integer_CONSTANT_adi and dob_...boolean...
 * 
 * Revision 1.10  89/12/23  21:57:54  ejh
 * no change
 * 
 * Revision 1.9  89/05/25  17:37:09  little
 * rearrange include order becasue of changes to d22_sne int d22.h
 * 
 * Revision 1.8  89/05/19  17:20:47  bmc
 * Adjusted to accomodate new definition of 'dro_atomic_data_item'.
 * See 'dro.h' for more information.
 * 
 * Revision 1.7  89/02/09  17:38:24  ejh
 * added copyright notice
 * 
 * Revision 1.6  89/01/24  16:58:54  rcs
 * added dob_make_id_constant_adi routine
 * 
 * Revision 1.4  88/12/21  19:17:48  rcs
 * fixed dob_make_real_constant_adi to create a real contant
 * and not a string
 * 
 * Revision 1.3  88/12/14  11:08:03  little
 * add dob_make_undefined_adi routine
 * 
 * Revision 1.2  88/10/07  15:40:14  little
 * not modified.
 * 
*/

/*--------------------------------------------------------------------------*\
|
|   Distribution: Approved for public release; distribution is unlimited.
|
|   Copyright (c) 1989  by  Carnegie  Mellon  University, Pittsburgh, PA.  The
|  Software Engineering  Institute  (SEI) is a federally  funded  research and
|  development center established  and  operated by Carnegie Mellon University
|  (CMU).  Sponsored  by  the  U.S.  Department  of   Defense  under  contract
|  F19628-85-C-0003,  the  SEI  is  supported  by  the  services  and  defense
|  agencies, with the U.S. Air Force as the executive contracting agent.
|
|    Permission to use,  copy,  modify, or  distribute  this  software and its
|  documentation for  any purpose and without fee  is hereby granted, provided
|  that  the above copyright notice appear  in  all copies and that both  that
|  copyright  notice  and   this  permission  notice  appear   in   supporting
|  documentation.   Further,  the  names  Software  Engineering  Institute  or
|  Carnegie  Mellon  University  may  not be used in  advertising or publicity
|  pertaining to distribution of the software without specific, written  prior
|  permission.  CMU makes no claims  or representations  about the suitability
|  of this software for any purpose.  This software is provided "as is" and no
|  warranty,  express  or  implied,  is  made  by  the  SEI  or CMU, as to the
|  accuracy  and  functioning of the program and related program material, nor
|  shall   the  fact of  distribution   constitute  any   such  warranty.   No
|  responsibility is assumed by the SEI or CMU in connection herewith.
|
\*--------------------------------------------------------------------------*/

#define	memoryPack

#include	<stdio.h>
#include	<memoryPack.h>
#include	<isc.h>
#include	<d22.h>
#include	<dob.h>
#include	<dro.h>
#include	<dob_make.h>

/* --------------------------------------------------- dob_make_CONSTANT_adi */
static dro_atomic_data_item dob_make_CONSTANT_adi()
{  dro_atomic_data_item ret_val;
   dob_data_object handle;

   handle = dob_CONSTANT_create();
   if (get_status())
      FATAL_ERROR(isc_print_status(
       "dob_make_CONSTANT_adi: problems with dob_CONSTANT_create status = "));
   ret_val.dob_handle = handle;
   ret_val.component_name =  NULL;
   return(ret_val);
}

/* ------------------------------------------ dob_make_boolean_CONSTANT_adi */
dro_atomic_data_item dob_make_boolean_CONSTANT_adi(value)
int value;
{  dro_atomic_data_item adi;

   adi = dob_make_CONSTANT_adi();
   dob_variable_tell(adi.dob_handle, idd_boolean, (caddr_t) value);
   return(adi);
}

/* ------------------------------------------- dob_make_real_CONSTANT_adi */
dro_atomic_data_item dob_make_real_CONSTANT_adi(value)
double value;
{  dro_atomic_data_item adi;

   adi = dob_make_CONSTANT_adi();
   dob_variable_tell(adi.dob_handle, idd_real, (caddr_t) &value);
   return(adi);
}

/* ------------------------------------------- dob_make_integer_CONSTANT_adi */
dro_atomic_data_item dob_make_integer_CONSTANT_adi(value)
int value;
{  dro_atomic_data_item adi;

   adi = dob_make_CONSTANT_adi();
   dob_variable_tell(adi.dob_handle, idd_integer, (caddr_t) value);
   return(adi);
}

/* ----------------------------------------------- dob_make_id_CONSTANT_adi */
dro_atomic_data_item dob_make_id_CONSTANT_adi(value)
int value;
{  dro_atomic_data_item adi;

   adi = dob_make_CONSTANT_adi();
   dob_variable_tell(adi.dob_handle, idd_id, (caddr_t) value);
   return(adi);
}

/* ------------------------------------------- dob_make_string_constant_adi */
dro_atomic_data_item dob_make_string_constant_adi(value)
string value;
{  dro_atomic_data_item adi;

   adi = dob_make_constant_adi();
   dob_variable_tell(adi.dob_handle, idd_string, (caddr_t)value);
   return(adi);
}

/* ------------------------------------------ dob_make_buffer_constant_adi */

dro_atomic_data_item dob_make_buffer_constant_adi(value)
idd_buffer_type *value;
{  dro_atomic_data_item adi;

   adi = dob_make_constant_adi();
   dob_variable_tell(adi.dob_handle, idd_buffer,(caddr_t)value);
   return(adi);
}

/* ------------------------------------------ dob_make_boolean_constant_adi */

dro_atomic_data_item dob_make_boolean_constant_adi(value)
int value;
{  dro_atomic_data_item adi;

   adi = dob_make_constant_adi();
   dob_variable_tell(adi.dob_handle, idd_boolean, (caddr_t) value);
   return(adi);
}

/* --------------------------------------------------- dob_make_integer_adi */
dro_atomic_data_item dob_make_integer_constant_adi(value)
int value;
{  dro_atomic_data_item adi;

   adi = dob_make_constant_adi();
   dob_variable_tell(adi.dob_handle, idd_integer, (caddr_t) value);
   return(adi);
}

/* -----------------------------------------dob_make_id_constant_adi */
dro_atomic_data_item dob_make_id_constant_adi(value)
iid_id_type value;
{  dro_atomic_data_item adi;

   adi = dob_make_constant_adi ();
   dob_variable_tell (adi.dob_handle, idd_id, (caddr_t) value);
   return (adi);
}

/* --------------------------------------------------- dob_make_real_adi */
dro_atomic_data_item dob_make_real_constant_adi (value)
double value;
{  dro_atomic_data_item adi;

   adi = dob_make_constant_adi ();
   dob_variable_tell (adi.dob_handle, idd_real, (caddr_t)&value);
   return (adi);
}

/* -------------------------------------------------- dob_make_constant_adi */
dro_atomic_data_item dob_make_constant_adi ()
{  dro_atomic_data_item ret_val;
   dob_data_object handle;

   handle = dob_temp_create ();
   if (get_status ())
      FATAL_ERROR (isc_print_status (
	"dob_make_constant_adi: problems with dob_temp_create status = "));
   ret_val.dob_handle = handle;
   ret_val.component_name =  NULL;
   return (ret_val);
}

/* ------------------------------------------------- dob_make_undefined_adi */
dro_atomic_data_item dob_make_undefined_adi ()
{  dro_atomic_data_item ret_val;
   dob_data_object handle;

				/* by temps are initailly undefined */
   ret_val = dob_make_constant_adi ();
   return (ret_val);
}

/* --------------------------------------------------- dob_make_adi */
dro_atomic_data_item dob_make_adi (the_handle, the_name)
dob_data_object the_handle;
string the_name;
{  dro_atomic_data_item ret_val;

   ret_val.dob_handle = the_handle;
   ret_val.component_name = the_name;
   return (ret_val);
}
