static char rcsid [] =
	"$Header: /u/04c/mnt/integ/source/dm/src/RCS/dpg.c,v 1.37 91/02/12 15:32:06 little Exp $";

/*
$Log:	dpg.c,v $
 * Revision 1.37  91/02/12  15:32:06  little
 * change to support new dgr_sne component names & types
 * 
 * Revision 1.36  90/12/29  10:14:35  little
 * change dgr_sne to also hold the ids for the two items
 * 
 * use the id part of the dgr_sne to dtermine if the corresponding dob_object
 * acutally exists
 * 
 * Revision 1.35  90/12/06  20:21:40  little
 * speed things up by keeping the original_name_prop, template_prop, and
 * type_prop in the dob_object in addition to the sym tab
 * 
 * Revision 1.34  90/12/01  13:37:27  little
 * add threads to pfl stuff so it runs much faster.  we do have to sort
 * the pfl every time in process_pfl
 * 
 * Revision 1.33  90/11/01  17:21:20  little
 * no changes
 * 
 * Revision 1.32  90/10/16  11:19:20  little
 * speend up dpg_process_pfl a little by using else if when stepping through
 * the pfl entries
 * 
 * Revision 1.31  90/10/09  16:19:30  little
 * fix up new propagate stuff so it works right
 * 
 * Revision 1.29  90/10/04  19:21:08  little
 * BIG change to the propagate mechanism
 * 
 * Revision 1.28  90/10/02  15:09:44  little
 * add a checkout to the method processing in dpg_propagate_modify
 * 
 * Revision 1.27  90/10/01  13:15:52  little
 * add potential firing line stuff
 * 
 * Revision 1.26  90/09/17  17:34:59  little
 * change things so the attribute named method will propogate modify
 * 
 * Revision 1.24  90/08/16  17:59:35  rcs
 * no changes
 * 
 * Revision 1.23  90/08/06  14:05:18  little
 * no changes
 * 
 * Revision 1.22  90/06/08  21:45:28  little
 * 
 * no changes, sorry erik
 * 
 * Revision 1.21  90/03/20  17:28:13  rcs
 * fixed PEE deletion problem in propogate delete
 * 
 * Revision 1.20  90/03/17  11:44:28  rcs
 * memory leak problem
 * 
 * Revision 1.19  90/02/14  22:21:27  ejh
 * fixed include structure
 * 
 * Revision 1.18  90/01/12  15:07:38  dvk
 * Changed to understand new use of constant_sym
 * 
 * Revision 1.17  89/12/23  21:58:20  ejh
 * no change
 * 
 * Revision 1.16  89/08/25  15:44:09  bmc
 * Fixed bug associated with VC deletion.  (SPR #91)
 * Also changed an incorrect diagnostic.
 * 
 * Revision 1.15  89/08/03  21:00:57  bmc
 * No longer prints out 'fnork did not have a method handler' message when
 * there's no method handler.
 * 
 * Revision 1.14  89/07/25  21:50:24  bmc
 * - Changed 'is_reserved_word_prop' to newly-created 'sd_template_prop'.
 * - Dpg_propagate_delete now gets PET id from VC template, not VC instance.
 * 
 * Revision 1.13  89/07/20  16:43:50  bmc
 * Changes for OPS/83 removal.
 * 
 * Revision 1.12  89/05/30  16:24:44  trm
 * changed "#ifdef 0" to more compatible  "if 0".  trm
 * 
 * Revision 1.11  89/05/26  10:59:38  little
 * change thins to work with the new sne structure (dgr_sne)
 * 
 * Revision 1.10  89/05/19  17:29:51  bmc
 * Changed to call 'dob' routines with differently-typed parameters.
 * 
 * Revision 1.9  89/02/09  17:39:18  ejh
 * added copyright notice
 * 
 * Revision 1.8  89/01/30  13:39:51  rcs
 * added support for object_sym
 * 
 * Revision 1.7  89/01/04  11:36:46  rcs
 * no changes
 * 
 * Revision 1.6  88/11/02  13:34:43  little
 * change the error processing for a non-existant method to just print
 * the error and not do a FATAL_ERROR
 * 
 * Revision 1.5  88/10/24  17:12:37  little
 * dpg_propagate_modify has a new (third) parameter.  this is the component
 * name, if there is one otherwise it is "", of the compponent being modified.
 * if the compnonent is "method" the appropriate snippet for the method
 * will be added to the firing line and the component reference list
 * will not be used.
 * 
 * Revision 1.4  88/10/04  17:48:53  little
 * add parent id parameter to dpg_propagate_create
 * 
 * Revision 1.3  88/10/03  09:25:52  little
 * guard some error printout wth debug statements.  they were forgotten on
 * last checkin.
 * 
 * Revision 1.2  88/10/03  09:13:33  little
 * fix names used to set ops components
 * 
*/

/*--------------------------------------------------------------------------*\
|
|   Distribution: Approved for public release; distribution is unlimited.
|
|   Copyright (c) 1989  by  Carnegie  Mellon  University, Pittsburgh, PA.  The
|  Software Engineering  Institute  (SEI) is a federally  funded  research and
|  development center established  and  operated by Carnegie Mellon University
|  (CMU).  Sponsored  by  the  U.S.  Department  of   Defense  under  contract
|  F19628-85-C-0003,  the  SEI  is  supported  by  the  services  and  defense
|  agencies, with the U.S. Air Force as the executive contracting agent.
|
|    Permission to use,  copy,  modify, or  distribute  this  software and its
|  documentation for  any purpose and without fee  is hereby granted, provided
|  that  the above copyright notice appear  in  all copies and that both  that
|  copyright  notice  and   this  permission  notice  appear   in   supporting
|  documentation.   Further,  the  names  Software  Engineering  Institute  or
|  Carnegie  Mellon  University  may  not be used in  advertising or publicity
|  pertaining to distribution of the software without specific, written  prior
|  permission.  CMU makes no claims  or representations  about the suitability
|  of this software for any purpose.  This software is provided "as is" and no
|  warranty,  express  or  implied,  is  made  by  the  SEI  or CMU, as to the
|  accuracy  and  functioning of the program and related program material, nor
|  shall   the  fact of  distribution   constitute  any   such  warranty.   No
|  responsibility is assumed by the SEI or CMU in connection herewith.
|
\*--------------------------------------------------------------------------*/

#define dpg_TOP
#define	memoryPack

#include	<stdio.h>
#include	"string.h"
#include	"global.h"
#include	"listPack.h"
#include	"cus.h"
#include	"isc.h"
#include	"d22.h"
#include	"dpg.h"
#include	"dob.h"
#include	"dgr.h"
#include 	"iid.h"


#undef DEBUG1
#undef DEBUG2
#undef DEBUG3

#define DEBUG1(statement) SERPENT_DEBUG1(dpg_debug, statement)
#define DEBUG2(statement) SERPENT_DEBUG2(dpg_debug, statement)
#define DEBUG3(statement) SERPENT_DEBUG3(dpg_debug, statement)

/*
??? need to put METHOD_NAME in a header file
*/
#define METHOD_NAME "method"

#define rget_ste(object,entry,ret_val)\
   if (!(entry = dob_get_symbol_entry (object)))\
      {set_status (dpg_no_st_entry);\
      return (ret_val);\
      }

#define get_ste(object,entry)\
   if (!(entry = dob_get_symbol_entry (object)))\
      {set_status (dpg_no_st_entry);\
      return;\
      }

#define validate_status(return_status)\
   if (get_status ())\
      {set_status (return_status);\
      return;\
      }


#define pfl_SET 0
#define pfl_REF 1


/*--------------------------------------------------------------------------*\
|  Routine: copy_sne
|
|  Description:
|     copys a sne (probably automatic data) into a more persistant
|	area, the heap
\*--------------------------------------------------------------------------*/
static dgr_sne *copy_sne (sne)
dgr_sne *sne;
{
   dgr_sne *new_sne;

   if ((new_sne = (dgr_sne *) make_node (sizeof (dgr_sne))) !=
	(dgr_sne *) NULL)
      {new_sne-> routine = sne-> routine ;
      new_sne-> self_vc_object = sne-> self_vc_object ;
      new_sne-> self_vc_id = sne-> self_vc_id;
      new_sne-> sd_handle_object = sne-> sd_handle_object;
      new_sne-> sd_handle_id = sne-> sd_handle_id;
      }

   return (new_sne);
}				/* end copy_sne */

/*--------------------------------------------------------------------------*\
|  Routine: add_to_prop_list (LOCAL)
|
|  Description: 
|     Local routine to add a value to a property list.  This routine takes
|     care of locating the symbol table entry, extracting the list, and 
|     adding the value.
|
|  Arguments:
|     symbol   - The symbol whose property is to be changed.
|     property - The property to be changed.  WARNING: This property MUST
|                be a list.  This routine does NOT check!
|     value    - The value to be added to the list (usually a pointer to the
|                real data).
|  Return Value:
|     false - Something didn't work.  The error was reported.
|     true  - Everything worked fine.
|
\*--------------------------------------------------------------------------*/
static boolean add_to_prop_list (symbol, prop_name, value)
cus_sym		  symbol;
cus_property_type prop_name;
caddr_t		  value;
{  LIST list;

   set_status (ok);

   list = (LIST) cus_get_prop (symbol, prop_name);
   rcheck_status ("add_to_prop_list: can't get property value from list\n",
      false);

   rcheck_null (list, "add_to_prop_list: unexpected null property list\n",
      null_memory_ptr, false);

   add_to_head (list, value);

   return (true);
}				/* end add_to_prop_list */


/*--------------------------------------------------------------------------*\
|  Routine: get_object_prop (LOCAL)
|
|  Description: 
|     Get a property from the symbol table entry associated with a DOB
|     object.
|
\*--------------------------------------------------------------------------*/
static caddr_t get_object_prop (object, prop_name)
dob_data_object object;
cus_property_type prop_name;
{
   cus_sym ste;

   rget_ste (object, ste, NULL);
   return ((caddr_t) cus_get_prop (ste, prop_name));
}				/* end get_object_prop */


/*--------------------------------------------------------------------------*\
|  Routine: dpg_make_pfle
|
|  Description:
|	makes a new d22_st_pfle_info entity, with the current snippet level.
\*--------------------------------------------------------------------------*/
static d22_st_pfle_info *dpg_make_pfle ()
{  d22_st_pfle_info *pfle;

   pfle = (d22_st_pfle_info *) make_node (sizeof (d22_st_pfle_info));
   if (!pfle)
      FATAL_ERROR (fprintf (stderr,
			    "dpg_make_pfle: can't make_node for pfle\n"););
   pfle-> first = NULL;
   pfle-> last = NULL;
   pfle-> level = d22_pot_fl_time_stamp;
   return (pfle);
}					/* end dpg_make_pfle */


/*--------------------------------------------------------------------------*\
|  Routine: dpg_make_pfle_array
|
|  Description:
|	creates an array for pointers to d22_st_pfle_info entities for a
|	sd element.  the array is set as the elements pfl_prop in the sym tab
\*--------------------------------------------------------------------------*/
static d22_st_pfle_info **dpg_make_pfle_array (st_entry)
cus_sym st_entry;
{  int i, num_components;
   d22_st_pfle_info **pfle_array;

   set_status (ok);

   num_components = (int) cus_get_prop (st_entry, num_components_prop);
   if (!num_components)
      FATAL_ERROR (fprintf (stderr,
                      "dpg_propagate_reference: no num_components_prop\n"););

                        /* Determine the size of the array based on the number
                           of components in the sd element.  Create the pfle
                           property array.  This array keeps the 
			   d22_st_pfle_info entity (if it exists) for the
			   thread for each component.
                        */
   pfle_array = (d22_st_pfle_info **)
                    make_node (num_components * (sizeof(d22_st_pfle_info *)));
   if (!pfle_array)
      FATAL_ERROR (fprintf (stderr,
                 "dpg_make_pfle_array: couldn't make_node for pfle_array\n"););
   for (i = 0; i < num_components; i++)
      pfle_array [i] = NULL;
   cus_put_prop (st_entry, pfl_prop, pfle_array);
   return (pfle_array);
}					/* end dpg_make_pfle_array */


/*--------------------------------------------------------------------------*\
|  Routine: dpg_get_pfle_list
|
|  Description:
|	get the pfle list from the pfl_stack_prop for the input entity
|	(variable or sd component).  this list is used to stake pfles
|	when snippets call snippets.
\*--------------------------------------------------------------------------*/
static LIST dpg_get_pfle_list (ste, component_position, item_type)
cus_sym ste;
int component_position;
cus_sym_type item_type;
{  LIST pfle_list;
   LIST *pfle_list_array;
   int i, num_components;

   pfle_list = NULL;

   if ((item_type == sd_sym) || (item_type == object_sym))
      {pfle_list_array = (LIST *) cus_get_prop (ste, pfl_stack_prop);
			/* ko if it is not there */
      set_status (ok);
      if (!pfle_list_array)
         {num_components =  (int) cus_get_prop (ste, num_components_prop);
         pfle_list_array = (LIST *) make_node (num_components * (sizeof(LIST)));
         if (!pfle_list_array)
            FATAL_ERROR (fprintf (stderr,
		       "dpg_get_pfle_list: cannot create pfle_list_array\n"););
         for (i = 0; i < num_components; i++)
            pfle_list_array [i] = NULL;
         cus_put_prop (ste, pfl_stack_prop, pfle_list_array);
         check_status ("dpg_get_pfle_list: bad status put pfl_stack_prop");
         }
      pfle_list = pfle_list_array [component_position];
      if (!pfle_list)
         {pfle_list = make_list ();
         if (!pfle_list)
            FATAL_ERROR (fprintf (stderr,
			   "dpg_get_pfle_list: cannot create pfle_list\n"););
         pfle_list_array [component_position] = pfle_list;
         }
      }

   else if (item_type == variable_sym)
      {pfle_list = (LIST) cus_get_prop (ste, pfl_stack_prop);
			/* ok if not there */
      set_status (ok);
      if (!pfle_list)
         {pfle_list = make_list ();
         if (!pfle_list)
            FATAL_ERROR (fprintf (stderr,
			"dpg_get_pfle_list: cannot create pfle_list\n"););
         cus_put_prop (ste, pfl_stack_prop, pfle_list);
         }
      }

   return (pfle_list);
}					/* end dpg_get_pfle_list */


/*--------------------------------------------------------------------------*\
|  Routine: dpg_reset_pfle
|
|  Description: 
|	sets an entity's (variable or sd component) pfl_prop to the input pfle
\*--------------------------------------------------------------------------*/
static void dpg_reset_pfle (st_entry, component_position, item_type, pfle)
cus_sym st_entry;
int component_position;
cus_sym_type item_type;
d22_st_pfle_info *pfle;
{  
   d22_st_pfle_info **pfle_array;
   LIST pfle_list;

   set_status (ok);

   if ((item_type == sd_sym) || (item_type == object_sym))
      {pfle_array = (d22_st_pfle_info **) cus_get_prop (st_entry, pfl_prop);
      if (!pfle_array)
         FATAL_ERROR (fprintf (stderr, "dpg_reset_pfle: no pfle_array\n"););
      pfle_array [component_position] = pfle;
      }

   else if (item_type == variable_sym)
      cus_put_prop (st_entry, pfl_prop, pfle);

   set_status (ok);
   return;
}					/* end dpg_reset_pfle */


/*--------------------------------------------------------------------------*\
|  Routine: dpg_push_pfle
|
|  Description:
|	pushes an entity's (variable or sd component) current pfle (it is
|	passed in cause we alread
|	had it and no sense getting it again) on the entity's pfle_list
\*--------------------------------------------------------------------------*/
static void dpg_push_pfle (ste, component_position, item_type, pfle)
cus_sym ste;
int component_position;
cus_sym_type item_type;
d22_st_pfle_info *pfle;
{  LIST pfle_list;

   pfle_list = dpg_get_pfle_list (ste, component_position, item_type);
   if (!pfle_list)
      FATAL_ERROR (fprintf (stderr, "dpg_push_pfle: got a NULL pfle_list\n"););
   add_to_head (pfle_list, pfle);
   set_status (ok);

   return;
}                                       /* end dpg_push_pfle */


/*--------------------------------------------------------------------------*\
|  Routine: dpg_get_pfle
|
|  Description:
|	fetches an entity's (variable or sd component) pfle_prop
\*--------------------------------------------------------------------------*/
static d22_st_pfle_info *dpg_get_pfle (object, component_position)
dob_data_object object;
int component_position;
{  cus_sym_type item_type;
   d22_st_pfle_info *pfle;
   cus_sym st_entry;
   d22_st_pfle_info **pfle_array;
   LIST pfle_list;

   set_status (ok);

   item_type = ((data_object_record *) object)-> obj_sym_type;

   pfle = NULL;
   switch (item_type)
      {case sd_sym:
      case object_sym:
         get_ste (object, st_entry);
         pfle_array = (d22_st_pfle_info **) cus_get_prop (st_entry, pfl_prop);
			/* ok if not there */
         set_status (ok);
         if (!pfle_array)
            {pfle_array = dpg_make_pfle_array (st_entry);
            cus_put_prop (st_entry, pfl_prop, pfle_array);
            }
         pfle = pfle_array [component_position];
         if (pfle && ((pfle-> level) != d22_pot_fl_time_stamp))
            {dpg_push_pfle (st_entry, component_position, item_type, pfle);
            pfle = NULL;
            }
         if (!pfle)
            {pfle = dpg_make_pfle ();
            pfle_array [component_position] = pfle;
            }
         break;
      case variable_sym:
         get_ste (object, st_entry);
         pfle = (d22_st_pfle_info *) cus_get_prop (st_entry, pfl_prop);
			/* ok if not there */
         set_status (ok);
         if (pfle && ((pfle-> level) != d22_pot_fl_time_stamp))
            {dpg_push_pfle (st_entry, -1, item_type, pfle);
            pfle = NULL;
            }
         if (!pfle)
            {pfle = dpg_make_pfle ();
            cus_put_prop (st_entry, pfl_prop, pfle);
            }
         break;
      }
   set_status (ok);
   return (pfle);
}					/* end dpg_get_pfle */


/*--------------------------------------------------------------------------*\
|  Routine: dpg_pop_pfle
|
|  Description:
|	pops the top entry from an entity's (variable or sd component)
|	current pfle_list puts it  in the entity's pfle_prop
\*--------------------------------------------------------------------------*/
static void dpg_pop_pfle (the_object, component_position)
dob_data_object the_object;
int component_position;
{  cus_sym_type item_type;
   LIST pfle_list;
   cus_sym st_entry;
   d22_st_pfle_info *pfle;

   set_status (ok);

   pfle = (d22_st_pfle_info *) dpg_get_pfle (the_object, component_position);
   if (pfle)
      free_node (pfle);

   item_type = ((data_object_record *) the_object)-> obj_sym_type;

   get_ste (the_object, st_entry);
   pfle_list = dpg_get_pfle_list (st_entry, component_position, item_type);
   if (pfle_list)
      pfle = (d22_st_pfle_info *) get_from_head (pfle_list);
   else
      pfle = NULL;
   dpg_reset_pfle (st_entry, component_position, item_type, pfle);

   return;
}					/* end dpg_pop_pfle */


/*--------------------------------------------------------------------------*\
|  Routine: dpg_create_pot_fle
|
|  Description:
|	make a d22_pot_fl_entity structure and initialize it
\*--------------------------------------------------------------------------*/
static d22_pot_fl_entity *dpg_create_pot_fle (object, component_position,
					      the_type)
dob_data_object object;
int component_position;
int the_type;
{  d22_pot_fl_entity *pot_fle;

   pot_fle = (d22_pot_fl_entity *) make_node (sizeof (d22_pot_fl_entity));
   if (!pot_fle)
      FATAL_ERROR (fprintf (stderr,
              "dpg_make_pot_fle couldn't create a d22_pot_fl_entity\n"););

   pot_fle->type = the_type;
   pot_fle->the_object = object->id;
   pot_fle->component_position = component_position;
   return (pot_fle);
}					/* end dpg_create_pot_fle */


/*--------------------------------------------------------------------------*\
|  Routine: dpg_make_pot_fle
|
|  Description:
|	create a pfle and put it on d22_pfl
\*--------------------------------------------------------------------------*/
static void dpg_make_pot_fle (object, component_position, the_type)
dob_data_object object;
int component_position;
int the_type;
{  d22_pot_fl_entity *pot_fle;
   d22_st_pfle_info *pfle;

   set_status (ok);

   if (!(pfle = dpg_get_pfle (object, component_position)))
      return;
   if (!(pfle-> first))
      {pfle-> first = dpg_create_pot_fle (object, component_position, the_type);
      add_to_tail (d22_pfl, pfle-> first);
      }
   else if (!(pfle-> last))
      {if (pfle-> first-> type != the_type)
         {pfle-> last = dpg_create_pot_fle (object, component_position,
					    the_type);
         add_to_tail (d22_pfl, pfle-> last);
         }
      }
   return;
}					/* end dpg_make_pot_fle */


/*--------------------------------------------------------------------------*\
|  Routine: dpg_propagate_reference
|
|  Description:
|     adds the currently executing snippet, referenced entity (variable or
|	sd component), & a reference indicator to d22_pfl
\*--------------------------------------------------------------------------*/
void dpg_propagate_reference (object, component_position)
dob_data_object object;
int component_position;
{  

   set_status (ok);

			/* If there is no current sne return immediatly.  */
   if (d22_sne == (dgr_sne *) NULL)
      return;

   dpg_make_pot_fle (object, component_position, pfl_REF);

   return;
}				/* end dpg_propagate_reference */


/*--------------------------------------------------------------------------*\
|  Routine: dpg_propagate_modify
|
|  Description:
|     adds the currently executing snippet, modified entity (variable or
|	sd component), & a modify indicator to d22_pfl
\*--------------------------------------------------------------------------*/
void dpg_propagate_modify (object, component_position, component_name)
dob_data_object object;
int component_position;
string component_name;
{  cus_sym_type item_type;
   int meth_snippet;
   cus_sym st_entry, template;
   dob_data_object template_object;
   dgr_sne *sne;

   set_status (ok);

   dpg_make_pot_fle (object, component_position, pfl_SET);

			/* Switch on the appropriate symbol type.  */
   item_type = ((data_object_record *) object)-> obj_sym_type;

   switch (item_type)
      {case sd_sym:
      case object_sym:
         get_ste (object, st_entry);
         if (!strcmp (component_name, METHOD_NAME))
			/* If the sd component being set is the one named
			   method, get the method snippet number from the
			   object's template and run it immediately.  */
			/* Get the template for the object  */
            {template_object = (dob_data_object) cus_get_prop (st_entry,
							      template_prop);
			/* ok if not there */
            set_status (ok);
			/* if there is a template, see if there is a method
			   to run */
            if (template_object && (template_object != dob_null_object))
               {
			/* Get the method snippet.  */
               get_ste (template_object, template);
               meth_snippet = (int) cus_get_prop (template,
					       fixed_method_snippet_prop);
			/* we do not want status to reflect if we did not find
			   a snippet which is ok, we just do not run the one
			   we did not find */
               set_status(ok);
			/* If there is a method snippet a build a sne and run
			   it */
               if (meth_snippet)
                  {sne = (dgr_sne *) (make_node (sizeof (dgr_sne)));
                  sne-> routine = meth_snippet;
                  sne-> self_vc_object = object;
                  sne-> self_vc_id = object->id;
                  sne-> sd_handle_object = dob_null_object;
                  sne-> sd_handle_id = iid_null_id;
                  dgr_run_snippet (sne);
                  free_node (sne);
	          }
               }
            }

      }

   return;
}					/* end dpg_propagate_modify */

static void dpg_pfl_del ();
static void dpg_pfl_cre ();

/*--------------------------------------------------------------------------*\
|  Routine: dpg_propagate_create
|
|  Description:
|     	react to the creation of an entiry wrt firing line processing
\*--------------------------------------------------------------------------*/
void dpg_propagate_create (object, parent)
dob_data_object object;
dob_data_object parent;
{  cus_sym_type item_type;
   cus_sym object_ste, template_ste, sub_vc_ste, sd_ste;
   dob_data_object template_object, shared_data, shared_data_template;
   LIST list, potential_vcs, temp_list;
   dgr_sne *pee, *partial_pee;
   dgr_sne pee_buffer;
   dgr_snippet pet_id;

   set_status (ok);

   item_type = ((data_object_record *) object)-> obj_sym_type;

   switch (item_type) {
      case sd_sym:
      case object_sym:
         get_ste (object, object_ste);
	 template_object = (dob_data_object)cus_get_prop
				(object_ste, sd_template_prop);
			/* ok if not there */
         set_status (ok);
	 if (template_object == dob_null_object)
            {
	    set_status (dpg_no_template_entry);
            return;
            }
         get_ste (template_object, template_ste);

/*
   The following must be accomplished:

   1. Add the handle of the SD instance to the instance in the S.D.
      template.  (Already done in DOB.)
   2. Zero the list of bound VCs (i.e, created_vcs_prop).  (Already
      done in DOB.)
   3. Add the Pet Environment (PEE) for each potential VC interested in
      an S.D. of this type, to the firing line.
*/
	 potential_vcs = (LIST) cus_get_prop (template_ste,
		potential_vcs_prop);
	 check_status (
	 "dpg_pfl_cre: can't get potential_vcs_prop from sym. tab.\n"
	 );
	 if (list_length (potential_vcs) > 0)
	    {
	    loop_through_list (potential_vcs, partial_pee, dgr_sne *)
	       {
	       			/*
		    		   Allocate a new PEE, copy the partial
		    		   PEE into it, and flesh it out with the
		    		   handle of the shared data element.  The
		    		   PEE is assumed to be freed in the
		    		   associated, compiler-generated PET.
	       			*/
	       pee = copy_sne (partial_pee);
	       check_null ((char *) pee,
		  "dpg_pfl_cre: failed to allocate PEE\n",
		  out_of_memory);
	       pee -> sd_handle_object = object;
	       pee -> sd_handle_id = object->id;
	       add_to_head (d22_firing_line, (NODE) pee);
	       } /* end loop */
	    } /* end if */
         break;

      case variable_sym:
	 break;

      case vc_sym:
         get_ste (object, object_ste);
	 template_object = (dob_data_object)cus_get_prop
					(object_ste, template_prop);
         set_status (ok);
	 if (template_object == dob_null_object)
            {
	    set_status (dpg_no_template_entry);
            return;
            }
         get_ste (template_object, template_ste);
				 /*
				   The sub_vcs_prop, for a template, specifies
				   the symbols of the sub-VC templates 
				   attached to this VC template.  
				 */
	 list = (LIST) cus_get_prop (template_ste, sub_vcs_prop);
	 check_status (
	    "dpg_pfl_cre: can't get sub_vcs_prop from sym. tab.\n");
	 			/*
				  Loop through the list of potential sub-VCs,
				  registering them for possible creation.
	 			*/
	 loop_through_list (list, sub_vc_ste, cus_sym)
	    {
				/*
			   	   Build partial PET environment (PEE) from
			   	   sub-VC's PET id and parent (i.e., the
			   	   just-created) VC's handle.
				*/
	    pet_id = (dgr_snippet) cus_get_prop
				(sub_vc_ste, value_snippet_prop);
	    check_status (
              "dpg_pfl_cre: can't get value_snippet_prop from sym tab.\n");

				/* pee_buffer contains the partial PEE */
	    pee_buffer.routine       = pet_id;
			/* parent vc of this sub-vc */
	    pee_buffer.self_vc_object = object;
	    pee_buffer.self_vc_id = object->id;
	    pee_buffer.sd_handle_object = dob_null_object;
	    pee_buffer.sd_handle_id = iid_null_id;
				/*
				   Does this VC depend on the creation of a
				   shared data element?  Creating_sd_prop, for
				   a template, refers to the shared data
				   template that a VC of this 'type' is 
				   interested in.  (Got that?)  Since it's
				   a template, it isn't a dob_handle; rather,
				   it's a symbol table pointer.  (Trust me.)
				*/
	    sd_ste = (cus_sym) cus_get_prop (sub_vc_ste, creating_sd_prop);
			/* ok if not there */
            set_status (ok);
	    if (sd_ste != (cus_sym) NULL) /* sub-VC depends on shared data */
	       {
	       			/*
				   Sub-VC depends on creation of shared data.
				   First, add the partial PEE to the potential
				   VC list for the shared data template.  Be
				   sure to use a copy, not the real PEE.
				*/
	       pee = copy_sne (& pee_buffer);
	       check_null ((char *) pee,
		  "dpg_pfl_cre: failed to allocate PEE\n",
		  out_of_memory);

	       (void) add_to_prop_list (sd_ste, potential_vcs_prop, pee);
				/*
				   Next, for every instance of this type of
				   shared data out there, we have to create
				   a PET for this sub-VC and place it on the
				   firing line.  We already have the partial
				   PEE; we just need the shared data instance
				   handles.
				*/
	       temp_list = (LIST) cus_get_prop (sd_ste, instances_prop);
			/* ok if not there */
               set_status (ok);
	       loop_through_list (temp_list, shared_data, dob_data_object)
		  {
		  pee = copy_sne (& pee_buffer);
		  check_null ((char *) pee,
		     "dpg_pfl_cre: failed to allocate PEE\n",
		     out_of_memory);
		  pee -> sd_handle_object = shared_data;
		  pee -> sd_handle_id = shared_data->id;
		  add_to_head (d22_firing_line, (NODE) pee);
		  } /* end loop */
	       } /* end if sub-vc depends on creation of shared data */

	    else /* doesn't depend on creation of a shared data element */
	       {
				/*
				   Simply add the partial PEE to the firing
				   line.  In the case of variables and
				   shared data components the partial PEE
				   contains all the information we need,
				   since the only missing parameter is a
				   shared data handle that doesn't apply.
				*/
	       pee = copy_sne (& pee_buffer);
	       add_to_head (d22_firing_line, (NODE) pee);
	       } /* end else doesn't depend on creation of shared data */
	    } /* end loop through all sub VCs */
         break;

      case temp_sym:
      case constant_sym:
         return;
         break;
      default:
         set_status (dpg_unknown_type);
         return;
         break;
      }

   return;
}					/* end dpg_pfl_cre*/


/*--------------------------------------------------------------------------*\
|  Routine: dpg_propagate_delete
|
|  Description:
|     propagates deletion of a data base object
\*--------------------------------------------------------------------------*/
void dpg_propagate_delete (object)
dob_data_object object;
{  cus_sym_type item_type;
   cus_sym vc_ste;
   dob_data_object vc;
   dgr_sne *pee;
   dgr_snippet pet_id;
   LIST list;

   set_status (ok);

   item_type = ((data_object_record *) object)-> obj_sym_type;

			/* Switch on the symbol type.  */
   switch (item_type) {
      case sd_sym:   
      case object_sym: {
						 /* LOCAL DATA */
	 dob_data_object parent_vc;
	 dob_data_object vc_template;
	 cus_sym vc_template_ste;
	 dgr_sne pee_buffer;

			/* We have to locate the list of VCs bound to this
			   piece of data and force their PETs to be
			   re-evaluated to see if they, too, must be deleted.  
			   The list is stored in the created_vcs_prop of in the
			   symbol table entry for the shared data.  */
	 list = (LIST) get_object_prop(object, created_vcs_prop);
			/* ok if not there */
         set_status(ok);
	 if ( list_length (list) > 0)
			/* VCs are bound  */
            {loop_through_list(list, vc, dob_data_object)
			/* The PEE is built from the data handle, the parent VC
			   and the PET id.  The PET id comes from the VC
			   template, not the VC instance.  */
               {get_ste(vc, vc_ste);
			/* Zero out the creating SD property for this bound
			   VC.  */
	       cus_put_prop(vc_ste, creating_sd_prop, (caddr_t)NULL);

	       vc_template = (dob_data_object)cus_get_prop(
                 				vc_ste, template_prop);
			/* ok if not there */
	       set_status(ok);
			/* If there is no template, set status and bug out */
	       if (vc_template == dob_null_object)
                  {set_status(dpg_no_template_entry);
		  return;
                  }

	       get_ste(vc_template, vc_template_ste);
	       pet_id = (dgr_snippet) cus_get_prop(vc_template_ste,
						     value_snippet_prop);
	       check_status(
	"dpg_propagate_delete: can't get value_snippet_prop from sym tab.\n");

	       parent_vc = (dob_data_object) cus_get_prop(vc_ste,
							    parent_vc_prop);
	       check_status(
	     "dpg_propagate_delete: can't get parent vc from symbol table\n");

	       pee_buffer.routine       = pet_id;
	       pee_buffer.self_vc_object = parent_vc;
	       pee_buffer.self_vc_id = parent_vc->id;
	       pee_buffer.sd_handle_object = object;
	       pee_buffer.sd_handle_id = object->id;
			/* Place a copy of the PEE on the firing line.  */
	       pee = copy_sne(& pee_buffer);
	       check_null((char *) pee,
	          "dpg_propagate_delete: failed to allocate PEE\n",
	          out_of_memory);
	       add_to_head(d22_firing_line, (NODE) pee);
	       } /* end loop */
	    } /* end if there were bound VCs */
	 } /* end case */
	 break;

      case vc_sym:
	 {cus_sym object_ste, sd_ste, template_ste;
	 dob_data_object creating_sd, sd_template, vc_template;
	 LIST copy_of_list, partial_pee_list;
			/* Traverse the list of sub-VCs, removing their partial
			   PEEs from any shared data templates they may be
			   on */
         get_ste(object, object_ste);

	 list = (LIST) cus_get_prop(object_ste, sub_vcs_prop);
			/* ok if not there */
         set_status(ok);
	 if (list && list_length(list) > 0)
	    loop_through_list(list, vc, dob_data_object)
               {get_ste(vc, vc_ste);
			/* Does sub-VC depend on a shared data element? */
	       creating_sd = (dob_data_object)cus_get_prop
					(vc_ste, creating_sd_prop);
			/* ok if not there */
               set_status(ok);
	       if ( (creating_sd != (dob_data_object) NULL) &&
		    (creating_sd != dob_null_object) )
			/* Sub-VC depends on a shared data element.  Remove its
			   partial PEE from the template for that shared data
			   element */
                  {sd_template = (dob_data_object) get_object_prop
				(creating_sd, sd_template_prop);
			/* ok if not there */
                  set_status(ok);
		  if ( (sd_template != dob_null_object) &&
		       (sd_template != (dob_data_object) NULL) )
                     {partial_pee_list = (LIST) get_object_prop
					(sd_template, potential_vcs_prop);
		     check_status(
 		       "dpg_propagate_delete: can't get potential_vcs_prop\n");
			/* Run down the list of partial pees, deleting any that
			   match this PET and parent VC.  We can't loop through
			   a list and modify its contents at the same time, so
			   we'll loop through a temporary copy.
			   POSSIBLE TUNING: replace copy with list element
				            look-ahead.  */
		vc_template = (dob_data_object) cus_get_prop(vc_ste,
							     template_prop);
			/* ok if not there */
                set_status(ok);
			/* If there is no template, set status and bug out.  */
               if (vc_template == dob_null_object)
                  {set_status(dpg_no_template_entry);
                  return;
	          }

		get_ste(vc_template, template_ste);

    	       	pet_id = (dgr_snippet)cus_get_prop (template_ste,
						    value_snippet_prop);
	       check_status(
	"dpg_propagate_delete: can't get value_snippet_prop from sym tab.\n");

		     copy_of_list = copy_list(partial_pee_list, NOT_NODES);
		     check_null(copy_of_list,
			"dpg_propagate_delete: can't copy list\n",
			out_of_memory);

		     loop_through_list(copy_of_list, pee, dgr_sne *)
                        {if ( (pee->self_vc_object == object) &&
			     (pee->routine == pet_id) )
                           {delete_list_node (partial_pee_list, pee);
			    }
                        } /* end loop */
		     free_list(copy_of_list, NOT_NODES);

                  } 		/* end if we have a template 		*/
	       }	 	/* end if sub-VC depends on sd element	*/
	    }			/* end loop 				*/
	 }			/* end case 				*/
	 break;

      case variable_sym:
      case temp_sym:
      case constant_sym:
	 break;

      default:
         set_status(dpg_unknown_type);
         return;
	 break;

      } /* end switch */
   return;
}					/* end dpg_pfl_del */


/*--------------------------------------------------------------------------*\
|  Routine: dpg_pfl_set 
|
|  Description:
|     process a set for a pfl entry
\*--------------------------------------------------------------------------*/
static void dpg_pfl_set (object, component_position)
dob_data_object object;
int component_position;
{  LIST use_list, *use_array;
   cus_sym st_entry;
   cus_sym_type item_type;
   dgr_sne *a_sne;

   set_status (ok);

			/* Switch on the appropriate symbol type.  */
   item_type = ((data_object_record *) object)-> obj_sym_type;

   switch (item_type)
      {case sd_sym:
      case object_sym:
         get_ste (object, st_entry);
			/* Get the data item's dependency
   			   list.  Dependency lists are kept by component. 
			   NOTE: we also do this for the sd component named
			   method
			*/
         use_array = (LIST *) cus_get_prop (st_entry, ask_prop);
			/* ok if not there */
         set_status (ok);
                        /* if we have never set the ask_prop for the element,
                           there is be no use_list for the sd component */

         if (!use_array)
            use_list = NULL;
         else
            {use_list = use_array [component_position];
            use_array [component_position] = make_list ();
            }
         break;
      case variable_sym:
			/* Get the list of thingies that use this variable and
			   add them to the firing line.  */
         get_ste(object, st_entry);
         use_list = (LIST) cus_get_prop(st_entry, ask_prop);
                        /* ok if not there */
         set_status (ok);
         cus_put_prop (st_entry, ask_prop, NULL);
         break;
      case temp_sym:
      case constant_sym:
         return;
         break;
      default:
         set_status (dpg_unknown_type);
         return;
         break;
      }
			/* Return if there is no use list */
   if (!use_list)
      return;
			/* Free list and return if the use list is empty */
   if (list_length(use_list) < 1)
      {free_list (use_list, NOT_NODES);
      return;
      }
			/* There are things on the use list, append them to
			   the firing line.  if current snippet is on use_list,
			   do not put it (the snippet) on firing line */
   loop_through_list (use_list, a_sne, dgr_sne *)
      {if (!d22_sne)
         {add_to_tail (d22_firing_line, a_sne);
         }
      else if ((a_sne-> routine == d22_sne -> routine) &&
          (a_sne-> self_vc_object == d22_sne-> self_vc_object) &&
          (a_sne-> sd_handle_object == d22_sne-> sd_handle_object))

			/* NOTE: this is a do nothing.  it is done this way
			         to make the logic easier to code */
         {1;
         }
      else
         {add_to_tail (d22_firing_line, a_sne);
         }
      }
   free_list (use_list, NOT_NODES);

   return;
}					/* end dpg_pfl_set */


/*--------------------------------------------------------------------------*\
|  Routine: dpg_pfl_ref 
|
|  Description:
|     process a reference for a pfl entry
\*--------------------------------------------------------------------------*/
static void dpg_pfl_ref (object, component_position)
dob_data_object object;
int component_position;
{  cus_sym_type item_type;
   LIST use_list;
   cus_sym st_entry;
   LIST *use_array;
   int i, num_components;

   set_status (ok);

			/* If there is no current sne return immediatly.  */
   if (d22_sne == (dgr_sne *) NULL)
      return;

			/* Get the symbol type of the object and switch on it*/
   item_type = ((data_object_record *) object)-> obj_sym_type;

   switch (item_type)
      {case sd_sym:
      case object_sym:
			/* Get the array of use_lists defined for the shared
			   data element or object.  */
         get_ste (object, st_entry);
         use_array = (LIST *) cus_get_prop (st_entry, ask_prop);
                        /* ok if not there */
         set_status (ok);
                        /* if we have never set the ask_prop, set it now */
         if (!use_array)
            {num_components = (int) cus_get_prop (st_entry,
                                                  num_components_prop);
            if (!num_components)
               FATAL_ERROR (fprintf (stderr,
				    "dpg_pfl_ref: no num_components_prop\n"););

                        /* Determine the size of the array based on the number
                           of sd components in the element.  Create the ask
                           property array.  This array of lists keeps track of
                           who references each sd component in the item.  The
                           array is indexed by the component's position within
                           the element.  */
            use_array = (LIST *) make_node (num_components * (sizeof(LIST)));
            for (i = 0; i < num_components; i++)
               use_array [i] = NULL;
            cus_put_prop (st_entry, ask_prop, use_array);
            }
                        /* if the particular component never had the list
                           initialized, do it now */
         use_list = use_array [component_position];
         if (!use_list)
            {use_list = make_list ();
            use_array [component_position] = use_list;
            }
         break;
      case variable_sym:
			/* Get the use list for the variable symbol.  */
         get_ste (object, st_entry);
         use_list = (LIST) cus_get_prop (st_entry, ask_prop);
                        /* ok if not there */
         set_status (ok);
                        /* if the ask_prop had not been set yet, do it now */
         if (!use_list)
            {use_list = make_list ();
            cus_put_prop (st_entry, ask_prop, use_list);
            }
         break;
      case temp_sym:
      case constant_sym:
         return;
         break;
      default:
         set_status (dpg_unknown_type);
         return;
         break;
      }

			/* put the currently executing snippet on the object's
			   use list */

   add_to_head (use_list, d22_sne);
   return;
}					/* end dpg_pfl_ref */


/*--------------------------------------------------------------------------*\
|  Routine: dpg_process_pfl
|
|  Description:
|     processe the potential firing line
\*--------------------------------------------------------------------------*/
void dpg_process_pfl ()
{  d22_pot_fl_entity *pfl_entry0, *pfl_entry1;
   dob_data_object an_object;

   if (!d22_pfl)
      FATAL_ERROR (fprintf (stderr, "dpg_process_pfl: d22_pfl is NULL\n"););

   pfl_entry0 = (d22_pot_fl_entity *) get_list_next (d22_pfl, NULL);
   while (pfl_entry0)
      {an_object = dob_get_object_from_id (pfl_entry0->the_object);
                        /* if object not there anymore, nothing to do */
      if (!an_object)
         {pfl_entry0 = (d22_pot_fl_entity *) get_list_next (d22_pfl,
							    pfl_entry0);
         continue;
         }
      pfl_entry1 = (d22_pot_fl_entity *) get_list_next (d22_pfl, pfl_entry0);
      dpg_pop_pfle (an_object, pfl_entry0-> component_position);
      if (pfl_entry1 &&
          (an_object == dob_get_object_from_id (pfl_entry1-> the_object)) &&
          (pfl_entry0-> component_position == pfl_entry1-> component_position))
         {if (pfl_entry0-> type == pfl_SET)
            {dpg_pfl_set (an_object,
			  pfl_entry0-> component_position);
            }
         else
            {dpg_pfl_set (an_object,
			  pfl_entry0-> component_position);
            dpg_pfl_ref (an_object,
			 pfl_entry0-> component_position);
            }
         pfl_entry0 = (d22_pot_fl_entity *) get_list_next (d22_pfl, pfl_entry1);
         }
      else
         {if (pfl_entry0-> type == pfl_SET)
            dpg_pfl_set (an_object,
			 pfl_entry0-> component_position);
         else
            dpg_pfl_ref (an_object,
			 pfl_entry0-> component_position);
         pfl_entry0 = pfl_entry1;
         }
      }

   free_list (d22_pfl, AND_NODES);

   return;
}					/* end dpg_process_pfl */


