static char rcsid[]= "$Header: /u/04c/mnt/integ/source/externs/src/RCS/sstdio.c,v 1.1 90/11/16 16:40:01 rcs Exp $";
/*--------------------------------------------------------------------------*\
|   
|  Name:  sstdio.c
|
|  Description:  
|     This file contains standard I/O functions for Slang dialogues.
|
|  Component of:
|     Function libraries.
|
|  Related files:
|     sstdio.ext - Slang declarations of the functions.
|
|  Project:
|     Serpent
|     User Interface Project
|     Software Engineering Institute
|     Carnegie Mellon University
|     Pittsburgh, PA  15213
|
|  Version: 1.0
|
|  Project Leader:  
|     Len Bass
|     ljb@sei.cmu.edu
|
|  Author:  
|     Robert C. Seacord
|     rcs@sei.cmu.edu  
|
|  History:
|     $Log:	sstdio.c,v $
 * Revision 1.1  90/11/16  16:40:01  rcs
 * Initial revision
 * 
|
\*--------------------------------------------------------------------------*\
|
|   Distribution: Approved for public release; distribution is unlimited.
|
|   Copyright (c) 1989  by  Carnegie  Mellon  University, Pittsburgh, PA.  The
|  Software Engineering  Institute  (SEI) is a federally  funded  research and
|  development center established  and  operated by Carnegie Mellon University
|  (CMU).  Sponsored  by  the  U.S.  Department  of   Defense  under  contract
|  F19628-85-C-0003,  the  SEI  is  supported  by  the  services  and  defense
|  agencies, with the U.S. Air Force as the executive contracting agent.
|
|    Permission to use,  copy,  modify, or  distribute  this  software and its
|  documentation for  any purpose and without fee  is hereby granted, provided
|  documentation.   Further,  the  names  Software  Engineering  Institute  or
|  pertaining to distribution of the software without specific, written  prior
|  permission.  CMU makes no claims  or representations  about the suitability
|  of this software for any purpose.  This software is provided "as is" and no
|  warranty,  express  or  implied,  is  made  by  the  SEI  or CMU, as to the
|  accuracy  and  functioning of the program and related program material, nor
|  shall   the  fact of  distribution   constitute  any   such  warranty.   No
|
\*--------------------------------------------------------------------------*/

#include <stdio.h>		/* system standard io */
#include "sstdio.h"		/* serpent standard io	*/

/*--------------------------------------------------------------------------*\
|  Routine: sflush
|
|  Description:
|     Flushes either standard error or standard out.
\*--------------------------------------------------------------------------*/
int sflush(stream)
int stream;
{
  if (stream == SSTDOUT) {
    fflush(stdout);
  }
  else if (stream == SSTDERR) {
    fflush(stderr);
  }
}
