/* $Header: /u/04c/mnt/integ/source/glue/include/RCS/gcm.h,v 1.2 90/11/30 10:51:16 rcs Exp $ */

/*--------------------------------------------------------------------------*\
|
|   Distribution: Approved for public release; distribution is unlimited.
|
|   Copyright (c) 1989  by  Carnegie  Mellon  University, Pittsburgh, PA.  The
|  Software Engineering  Institute  (SEI) is a federally  funded  research and
|  development center established  and  operated by Carnegie Mellon University
|  (CMU).  Sponsored  by  the  U.S.  Department  of   Defense  under  contract
|  F19628-85-C-0003,  the  SEI  is  supported  by  the  services  and  defense
|  agencies, with the U.S. Air Force as the executive contracting agent.
|
|    Permission to use,  copy,  modify, or  distribute  this  software and its
|  documentation for  any purpose and without fee  is hereby granted, provided
|  that  the above copyright notice appear  in  all copies and that both  that
|  copyright  notice  and   this  permission  notice  appear   in   supporting
|  documentation.   Further,  the  names  Software  Engineering  Institute  or
|  Carnegie  Mellon  University  may  not be used in  advertising or publicity
|  pertaining to distribution of the software without specific, written  prior
|  permission.  CMU makes no claims  or representations  about the suitability
|  of this software for any purpose.  This software is provided "as is" and no
|  warranty,  express  or  implied,  is  made  by  the  SEI  or CMU, as to the
|  accuracy  and  functioning of the program and related program material, nor
|  shall   the  fact of  distribution   constitute  any   such  warranty.   No
|  responsibility is assumed by the SEI or CMU in connection herewith.
|
\*--------------------------------------------------------------------------*/


/*
$Log:	gcm.h,v $
 * Revision 1.2  90/11/30  10:51:16  rcs
 * *** empty log message ***
 * 
 * Revision 1.1  90/08/12  14:35:12  rnk
 * Initial revision
 * 
 */


#ifndef gcm
#define gcm

/*#########################################################################*\
 * This module defines those types and constants which are shared between  *
 * glue_intf and glue routines.                                            *
\*#########################################################################*/


/*==========================================================================
 * The ValueType enumeration provides a switch to interpret the value
 * field in an attribute.  Depending on the type, the value field will
 * be understood to contain a default value, no value, or the current
 * value of an attribute.  This latter type is used by the technology
 * interface only, and not by the general Glue interface.
 */

#define VAL_SERP_DEFAULT 0
#define VAL_TECH_DEFAULT 1
#define VAL_NONE 2
#define VAL_CURRENT 3

/*
**  For compatability with code that used the enumeration.
*/
#define ValueType int

/*==========================================================================
 * The WidgetType enumeration provides a switch to interpret the widget_type
 * field in an attribute.  Depending on the type, the widget_type field will
 * be understood to refer to a normal widget, an override shell widget, or a 
 * window manager shell widget.
 */

#define WT_NONE 0
#define WT_WIDGET 1
#define WT_WM_SHELL 2
#define WT_OVERRIDE_SHELL 3

/*
**  For compatability with code that used the enumeration.
*/
#define WidgetType int

/*==========================================================================
 * These #defines enumerate the various access types that are allowed
 * on attributes within a widget
 */
#define AXS_NONE	0
#define AXS_CREATE	1
#define AXS_SET		2
#define AXS_GET		4
#define AXS_TECH	8
#define AXS_SERPENT	16
#define AXS_ALL	(AXS_CREATE | AXS_SET | AXS_GET | AXS_TECH | AXS_SERPENT)
#define AXS_NOT_CREATE 30

#endif
