/* $Header: /usr/users/rnk/serpent/source/glue/include/RCS/gt_type.h,v 1.7 1991/06/14 02:32:42 rnk Exp $ */

/*
 * This file describes the interface to the GLUE data extraction routines
 */

/*--------------------------------------------------------------------------*\
|
|   Distribution: Approved for public release; distribution is unlimited.
|
|   Copyright (c) 1989  by  Carnegie  Mellon  University, Pittsburgh, PA.  The
|  Software Engineering  Institute  (SEI) is a federally  funded  research and
|  development center established  and  operated by Carnegie Mellon University
|  (CMU).  Sponsored  by  the  U.S.  Department  of   Defense  under  contract
|  F19628-85-C-0003,  the  SEI  is  supported  by  the  services  and  defense
|  agencies, with the U.S. Air Force as the executive contracting agent.
|
|    Permission to use,  copy,  modify, or  distribute  this  software and its
|  documentation for  any purpose and without fee  is hereby granted, provided
|  that  the above copyright notice appear  in  all copies and that both  that
|  copyright  notice  and   this  permission  notice  appear   in   supporting
|  documentation.   Further,  the  names  Software  Engineering  Institute  or
|  Carnegie  Mellon  University  may  not be used in  advertising or publicity
|  pertaining to distribution of the software without specific, written  prior
|  permission.  CMU makes no claims  or representations  about the suitability
|  of this software for any purpose.  This software is provided "as is" and no
|  warranty,  express  or  implied,  is  made  by  the  SEI  or CMU, as to the
|  accuracy  and  functioning of the program and related program material, nor
|  shall   the  fact of  distribution   constitute  any   such  warranty.   No
|  responsibility is assumed by the SEI or CMU in connection herewith.
|
\*--------------------------------------------------------------------------*/


/*
$Log: gt_type.h,v $
 * Revision 1.7  1991/06/14  02:32:42  rnk
 * changed char type to KeySym and added XmNavigationType
 *
 * Revision 1.6  1990/10/07  16:59:48  rnk
 * added "top" and "bottom" types
 *
 * Revision 1.5  90/10/05  10:47:20  rcs
 * changed from enumeration to defines
 * 
 * Revision 1.4  90/08/01  23:16:16  rnk
 * added type for focus
 * 
 * Revision 1.3  90/06/22  15:49:20  rnk
 * added new types
 * 
 * Revision 1.2  90/06/06  16:10:06  dvk
 * Added a bunch of new types
 * 
 * Revision 1.1  90/05/17  16:22:16  dvk
 * Initial revision
 * 
 */

#ifndef gtt
#define gtt

/*==========================================================================
 * The GT_TYPES enumeration lists the technology types which are understood
 * by the glue interface.  The values expressed here are also reflected in
 * the Glue parser, which only recognizes these values.  Make sure you change
 * the parser (gay.y) if you change this enum.
 *
 * NOTE: *NEVER* add entries to the middle of the table - *ALWAYS* add to
 * the end in front of GT_LAST
 *
 * NOTE:  the enumeration was changed to a collection of defines so
 *	  it could be included in a slang program (the generic editor) - rCs
 */


#define GT_ILLEGAL -1
#define GT_Boolean 0
#define GT_caddr_t 1
#define GT_Cardinal 2
#define GT_KeySym 3
#define GT_char_star 4
#define GT_Colormap 5
#define GT_Dimension 6
#define GT_float 7
#define GT_int 8
#define GT_Pixel 9
#define GT_Pixmap 10
#define GT_Pointer 11
#define GT_Position 12
#define GT_Screen 13
#define GT_short 14
#define GT_String 15
#define GT_unsigned_char 16
#define GT_Widget 17
#define GT_Window 18
#define GT_XID 19
    /*
     * In an attempt to keep various programs which use the GT_TYPE
     * enumeration up-to-date, we define a "LAST" entry in the table.
     * In the future, there will be more than one "LAST" entry, keyed
     * by the version number.  If your dependent code requires that you
     * know *all* the entries in this table, then have your code test
     * for an enumerated value greater than the latest "LAST" value.
     * The current "LAST" value is also written to the technology file.
     * For an example, see test_intf.c
     *
     * If you need to add more entries to this table, add them AFTER
     * GT_LAST_V1 and before GT_LAST.  Then, at the end of your list,
     * create a new entry called GT_LAST_V2, and so on.
     */
#define GT_XmCreatePopupChildProc 20
#define GT_XmFontList 21
#define GT_XmString 22
#define GT_XmStringDirection 23
#define GT_XmTextPosition 24
#define GT_XtCallbackList 25
#define GT_XtOrderProc 26
#define GT_XtTranslations 27
#define				GT_LAST_V2 28
#define GT_XmStringTable 29
#define GT_XmStringList 30
#define GT_XtProc 31
#define GT_WidgetClass 32
#define GT_unsigned_int 33
#define GT_MethodName 34
#define				GT_LAST_V3 35
#define GT_WidgetList 36
#define GT_XFontStruct 37
#define GT_Accelerators 38
#define GT_Cursor 39
#define GT_XawTextSelectType_star 40
#define				GT_LAST_V4 41
#define GT_focus 42
#define				GT_LAST_V5 43
#define GT_top 44
#define GT_bottom 45
#define GT_XmNavigationType 46
#define				GT_LAST_V6 47
    /*
     * This next entry is really the last entry in the table. 
     */
#define				GT_LAST 48

/*
**  For compatability with code that used the enumeration.
*/
#define GT_TYPE int

#endif
