/* $Header: /u/04c/mnt/integ/source/glue/include/RCS/tx_fmt.h,v 1.4 90/10/03 17:55:23 rnk Exp $ */

/*--------------------------------------------------------------------------*\
|
|   Distribution: Approved for public release; distribution is unlimited.
|
|   Copyright (c) 1989  by  Carnegie  Mellon  University, Pittsburgh, PA.  The
|  Software Engineering  Institute  (SEI) is a federally  funded  research and
|  development center established  and  operated by Carnegie Mellon University
|  (CMU).  Sponsored  by  the  U.S.  Department  of   Defense  under  contract
|  F19628-85-C-0003,  the  SEI  is  supported  by  the  services  and  defense
|  agencies, with the U.S. Air Force as the executive contracting agent.
|
|    Permission to use,  copy,  modify, or  distribute  this  software and its
|  documentation for  any purpose and without fee  is hereby granted, provided
|  that  the above copyright notice appear  in  all copies and that both  that
|  copyright  notice  and   this  permission  notice  appear   in   supporting
|  documentation.   Further,  the  names  Software  Engineering  Institute  or
|  Carnegie  Mellon  University  may  not be used in  advertising or publicity
|  pertaining to distribution of the software without specific, written  prior
|  permission.  CMU makes no claims  or representations  about the suitability
|  of this software for any purpose.  This software is provided "as is" and no
|  warranty,  express  or  implied,  is  made  by  the  SEI  or CMU, as to the
|  accuracy  and  functioning of the program and related program material, nor
|  shall   the  fact of  distribution   constitute  any   such  warranty.   No
|  responsibility is assumed by the SEI or CMU in connection herewith.
|
\*--------------------------------------------------------------------------*/


/*
$Log:	tx_fmt.h,v $
 * Revision 1.4  90/10/03  17:55:23  rnk
 * added num_convs to TX structure (for convenience routine support)
 * 
 * Revision 1.3  90/06/06  16:13:59  dvk
 * Added num_procs to TX structure
 * 
 * Revision 1.2  90/05/18  17:21:12  dvk
 * Added num_classes to TX structure
 * 
 * Revision 1.1  90/05/17  16:22:50  dvk
 * Initial revision
 * 
 */

#ifndef tx_fmt
#define tx_fmt

#define TX_MAGIC	412-268-7791	/* It's my office phone number... */

typedef long str_idx;
typedef short count;

typedef struct {
    long magic;		/* Technology magic number */ 
    long string_size;	/* Size (in bytes) of the strng table */
    count num_classes;	/* # of X classes in technology */
    count num_procs;	/* # of special procedures ref'd by technology */
    count num_convs;	/* # of convenience routines ref'd by technology */
    count num_widgets;	/* # of widgets in technology */
    } TX;

#endif
