%{
        static char rcsid [] = "$Header: /u/04c/mnt/integ/source/glue/src/RCS/gay.y,v 1.26 1991/07/12 12:59:14 ejh Exp $";

/*--------------------------------------------------------------------------*\
|
|  Name:	gay.y
|
|  Description:
|	This is the parser for GLUE.
|
|  Component of:
|	GLUE processor
|
|  Related files:
|	many yacc, lex, and c files
|
|  Project:
|	SERPENT System
|	User Interface Prototyping
|	Software Engineering Institute
|	Carnegie Mellon University
|	Pittsburgh, PA  15213
|
|  Version: 1.0
|
|  Owner:  
|	Len Bass
|	ljb@sei.cmu.edu
|
|  Author:  
|	Daniel V. Klein
|	dvk@sei.cmu.edu
|
|  Change History:
$Log: gay.y,v $
 * Revision 1.26  1991/07/12  12:59:14  ejh
 * added defines for sgi
 *
 * Revision 1.25  1991/06/14  02:29:45  rnk
 * changed char type to KeySym, added XmNavigationType and removed XmStringList
 *
 * Revision 1.24  1991/04/24  20:13:52  rcs
 * removed overly restrictive error checking
 *
 * Revision 1.23  1991/04/17  21:35:21  dvk
 * Added support for negative numbers in default or priority values
 *
 * Revision 1.22  1991/04/12  12:16:16  ejh
 * changed #elif to else and if
 *
 * Revision 1.21  1991/04/02  16:46:43  dvk
 * Added check to test for type mismatch when technology default is given
 *
 * Revision 1.20  91/03/18  18:46:16  dvk
 * Added "priority" attribute component.
 * 
 * Revision 1.19  90/10/12  03:04:26  ejh
 * took into account all the machines/os's we know about: added support for
 * apollo and sunos4.1 (sun and sparc)
 * 
 * Revision 1.18  90/10/07  16:58:35  rnk
 * added "top" and "bottom" types and removed the "no default value for
 * non-technology attribute" warning message
 * 
 * Revision 1.17  90/10/03  18:05:23  rnk
 * added support for convenience routines
 * 
 * Revision 1.16  90/09/01  20:11:26  ejh
 * added test for hp in declarations of yypact, etc.: on hp, they're int
 * rather than short
 * 
 * Revision 1.15  90/09/01  19:57:34  ejh
 * took out include of strings.h; put in include of X11/Xos.h to get the
 * definition of index, as is *strongly* suggested by the X folks
 * 
 * Revision 1.14  90/08/24  13:19:43  rnk
 * fixed widget_type error message
 * 
 * Revision 1.13  90/08/14  22:48:15  rnk
 * modified widget_type to allow a type of "none" (i.e., not a widget).
 * 
 * Revision 1.12  90/08/09  18:01:15  rnk
 * added code to parse widget_type and technology_default fields
 * 
 * Revision 1.10  90/07/16  14:50:38  dvk
 * Rick requested that class and include file be optional - they now are
 * 
 * Revision 1.9  90/07/02  18:04:19  dvk
 * Added "-w" switch to turn off "missing default value" warning
 * messages from the parser.
 * 
 * Revision 1.8  90/06/22  15:42:26  rnk
 * added new types to tech_map and updated GT_LAST check
 * 
 * Revision 1.7  90/06/06  16:10:56  dvk
 * Added support for routine-valued parameters
 * 
 * Revision 1.6  90/06/01  17:36:03  dvk
 * Okay, so u22_convert_string_inplace was not the right routine to
 * use in that last change.  So sue me...
 * 
 * Revision 1.5  90/06/01  16:01:33  dvk
 * Okay, only Serpent names get changed to lower case, not the X names
 * 
 * Revision 1.4  90/06/01  12:02:56  dvk
 * Attribute names (and Serpent names) are now converted to lower
 * case by the parser.
 * 
 * Revision 1.3  90/05/30  15:14:47  dvk
 * Changed include of <string.h> to <strings.h> (stupid Sun system...)
 * 
 * Revision 1.2  90/05/21  12:12:16  dvk
 * ID attributes cannot be initialized, so changed error message
 * so that it doesn't complain about uninitialized ID's
 * 
 * Revision 1.1  90/05/17  16:09:59  dvk
 * Initial revision
 * 
|
\*--------------------------------------------------------------------------*\
|
|   Distribution: Approved for public release; distribution is unlimited.
|
|   Copyright (c) 1989  by  Carnegie  Mellon  University, Pittsburgh, PA.  The
|  Software Engineering  Institute  (SEI) is a federally  funded  research and
|  development center established  and  operated by Carnegie Mellon University
|  (CMU).  Sponsored  by  the  U.S.  Department  of   Defense  under  contract
|  F19628-85-C-0003,  the  SEI  is  supported  by  the  services  and  defense
|  agencies, with the U.S. Air Force as the executive contracting agent.
|
|    Permission to use,  copy,  modify, or  distribute  this  software and its
|  documentation for  any purpose and without fee  is hereby granted, provided
|  that  the above copyright notice appear  in  all copies and that both  that
|  copyright  notice  and   this  permission  notice  appear   in   supporting
|  documentation.   Further,  the  names  Software  Engineering  Institute  or
|  Carnegie  Mellon  University  may  not be used in  advertising or publicity
|  pertaining to distribution of the software without specific, written  prior
|  permission.  CMU makes no claims  or representations  about the suitability
|  of this software for any purpose.  This software is provided "as is" and no
|  warranty,  express  or  implied,  is  made  by  the  SEI  or CMU, as to the
|  accuracy  and  functioning of the program and related program material, nor
|  shall   the  fact of  distribution   constitute  any   such  warranty.   No
|  responsibility is assumed by the SEI or CMU in connection herewith.
|
\*--------------------------------------------------------------------------*/

#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include <X11/Xos.h>
#include "u22.h"
#include "alistPack.h"
#include "idd.h"
#include "g22.h"
#include "gal.h"
#include "gen.h"
#include "gt_type.h"

#if defined(hpux) || defined (apollo)
#  define ACTTYPE int
#  define SYYN yy_n
#else
#  if defined(sun) || defined(sparc)
#    ifdef SunOS4_1
#      define ACTTYPE int
#      define SYYN yy_n
#    endif
#  endif
#endif

#ifndef ACTTYPE
#  define ACTTYPE short
#  ifdef sgi
#    define SYYN yy_n
#  else
#    define SYYN yyn
#  endif
#endif

/*
 * Global variables referenced within this module
 */
extern short no_warnings;
extern short num_class_warn;
extern short num_include_warn;

/*
 * Local variables within this module
 */
static ALIST	equiv_list;
static WIDGET *	cur_w;
static METH *	cur_m;
static ATTR *	cur_a;
static int 	default_clash;

static int cur_access, access_checklist, access_direction;

/*
 * This is the list of valid types for GLUE : Serpent equivalences.
 */
#define LEGAL		1
#define ILLEGAL		0
#define VECTOR		1
#define SCALAR		0
#define PROC		1
#define NO_PROC		0
#define DEFAULT_OK	1
#define NO_DEFAULTS	0

struct serp_map {
	char *sname;
	idd_data_types stype;
	short legal, rng, is_proc, dflt;
	}
    serp_map[] = {
	{ "boolean",   idd_boolean,      LEGAL,   SCALAR, NO_PROC, DEFAULT_OK },
	{ "buffer",    idd_buffer,       LEGAL,   SCALAR, NO_PROC, DEFAULT_OK },
	{ "integer",   idd_integer,      LEGAL,   SCALAR, PROC,    DEFAULT_OK },
	{ "real",      idd_real,         LEGAL,   SCALAR, NO_PROC, DEFAULT_OK },
	{ "string",    idd_string,       LEGAL,   VECTOR, NO_PROC, DEFAULT_OK },
	{ "id",        idd_id,           LEGAL,   SCALAR, NO_PROC, NO_DEFAULTS},
	{ "undefined", idd_no_data_type, ILLEGAL, SCALAR, NO_PROC, NO_DEFAULTS}
    };
#define NUM_STYPES sizeof(serp_map)/sizeof(struct serp_map)

/*
 * Warning! check the error message at the beginning of the parser (where
 * the test of GT_LAST is made) if you add anything to this table.
 */
struct tech_map {
	char *tname;
	GT_TYPE gt_type;
	}
    tech_map[] = {
	{ "Boolean",			GT_Boolean },
	{ "caddr_t",			GT_caddr_t },
	{ "Cardinal", 			GT_Cardinal },
	{ "KeySym",			GT_KeySym },
	{ "char_star",			GT_char_star },
	{ "Colormap", 			GT_Colormap },
	{ "Dimension",			GT_Dimension },
	{ "float",			GT_float },
	{ "int",			GT_int },
	{ "Pixel",			GT_Pixel },
	{ "Pixmap",			GT_Pixmap },
	{ "Pointer",			GT_Pointer },
	{ "Position",			GT_Position },
	{ "Screen", 			GT_Screen },
	{ "short",			GT_short },
	{ "String",			GT_String },
	{ "unsigned_char",		GT_unsigned_char },
	{ "Widget",			GT_Widget },
	{ "Window",			GT_Window },
	{ "XID",			GT_XID },
	{ "XmCreatePopupChildProc",	GT_XmCreatePopupChildProc },
	{ "XmFontList",			GT_XmFontList },
	{ "XmString",			GT_XmString },
	{ "XmStringDirection",		GT_XmStringDirection },
	{ "XmTextPosition",		GT_XmTextPosition },
	{ "XtCallbackList",		GT_XtCallbackList },
	{ "XtOrderProc",		GT_XtOrderProc },
	{ "XtTranslations",		GT_XtTranslations },
	{ "XmStringTable",		GT_XmStringTable },
	{ "XmNavigationType",		GT_XmNavigationType },
	{ "XtProc",			GT_XtProc },
	{ "WidgetClass",		GT_WidgetClass },
	{ "unsigned_int",		GT_unsigned_int },
	{ "MethodName",			GT_MethodName },
	{ "WidgetList",			GT_WidgetList },
	{ "XFontStruct",		GT_XFontStruct },
	{ "Accelerators", 		GT_Accelerators },
	{ "Cursor", 			GT_Cursor },
	{ "XawTextSelectType_star",	GT_XawTextSelectType_star},
	{ "focus", 			GT_focus },
	{ "top", 			GT_top },
	{ "bottom", 			GT_bottom }
    };
#define NUM_TTYPES sizeof(tech_map)/sizeof(struct tech_map)

/*VARARGS1*/
void yyerror(str,arg1,arg2)
char *str;
char *arg1,*arg2;
{
    extern char	lextext [];
    extern char * lextp;
    extern char * yyfile;
    extern int yylineno;
    int len;
    char *tab;

    fprintf (stderr,"\n\"%s\", line %d: ",yyfile,yylineno);
    fprintf (stderr, str, arg1, arg2);
    /*
     * Change tabs into spaces, so the error arrow goes to the
     * correct position on the page.
     */
    while (((tab=index(lextext, '\t')) != NULL) && (tab < lextp))
	*tab = ' ';
    fprintf (stderr, "\n%s", lextext);
    fprintf (stderr, "%.*s^\n", (lextp-lextext)-1,
    "------------------------------------------------------------------------");
}

/*
 *	This is a "magic" routine, garnered from "Introduction to Compiler
 * Construction with Unix" by Schreiner & Friedman.  Embellishments are by
 * yours truly.  It is called instead of yyerror on a syntax error.  This
 * call is managed by altering the code to yyparse in the Makefile.
 */
static void yyexpecting(SYYN, yystate,YYFLAG,YYLAST)
short SYYN, yystate,YYFLAG,YYLAST;
{
    register short x,t;
    char buf[15];
    char expecting[255];
    static char *tokens[] = {
#include "gay_token.h"
	0 };

    extern ACTTYPE yypact[], yyact[], yychk[];
    
    if ((SYYN = yypact[yystate]) > YYFLAG && SYYN < YYLAST) {
	expecting[0] = '\0';		/* Make it null to start */
	for (x = SYYN>0 ? SYYN : 0; x < YYLAST; x++) {
	    t = x - SYYN;
	    if (yychk[yyact[x]] == t) {
		if (t == 0)
		    strcat(expecting,"[end of file] ");
		else if (t == '\n')
		    strcat(expecting,"'\\n' ");
		else if (t > 256 && t < 256+(sizeof tokens / sizeof tokens[0]))
		    strcat(expecting,tokens[t-257]);
		else if (isascii(t) && isprint(t)) {
		    sprintf(buf, "'%c' ", t);
		    strcat(expecting, buf);
		    }
		else if (t < 256) {
		    sprintf(buf, "char %04.3o ", t);
		    strcat(expecting, buf);
		    }
		else {
		    sprintf(buf, "token %d ", t);
		    strcat(expecting, buf);
		    }
		}
	    }
	if (strcmp (expecting, "'}' ") == 0)
	    yyerror ("Expecting '}' - possible missing separator (',' or ';')");
	else
	    yyerror("Expecting one of: %s",expecting);
	}
    else
	yyerror("Syntax error - is this a legal statement?");
    
}

/*
 * A couple of simple error routines to save on string space
 */

static void widget_error (s)
char *s;
{
    yyerror ("Duplicate %s in widget '%s'", s, cur_w->name);
}

static void attribute_error (s)
char *s;
{
    yyerror ("Duplicate %s in attribute '%s' in widget '%s'",
			s, cur_a->xname, cur_w->name);
}

/*
 * This is the data structure used to keep track of X :: Serpent equivalence
 * types.  It is simply a pair of char*'s.
 *
 *	lhs : left-hand-side (X name)
 *	rhs : right-hand-side (Serpent equivalent name)
 *	range : for ranged types (i.e., string), the maximum value
 *	gt_type : the technology type as an enumerated type
 */
typedef struct {
	char *lhs;
	idd_data_types rhs;
	int range;
	short is_proc;
	GT_TYPE gt_type;
    } EQUIV;

/*
 * Utility routines for dealing with equivalence types
 */
static int find_equiv (e1, e2)
EQUIV *e1, *e2;
{
    return (strcmp (e1->lhs, e2->lhs) == 0);
}

/*
 * Utility routines for dealing with widgets types
 */
static int find_widget (w1, w2)
WIDGET *w1, *w2;
{
    return (strcmp (w1->name, w2->name) == 0);
}

static int find_method (m1, m2)
METH *m1, *m2;
{
    return (strcmp (m1->name, m2->name) == 0);
}

static int find_xname (a1, a2)
ATTR *a1, *a2;
{
    return (strcmp (a1->xname, a2->xname) == 0);
}

static int find_sname (a1, a2)
ATTR *a1, *a2;
{
    return (strcmp (a1->sname, a2->sname) == 0);
}

/*
 * Local routines and defines for dealing with access types
 */
#define DO_EITHER	0
#define DO_ON		1
#define DO_OFF		2
#define DO_BOTH		3

static void add_access (str, whichway)
char *str;
int whichway;
{
    int access;

    (void) u22_convert_string_inplace (str, LOWERCASE);
    if (strcmp (str, "all") == 0) {
	access = AXS_ALL;
	if (whichway == 0) {
	    yyerror ("Access type '!all' is meaningless");
	    return;
	    }
	}
    else if (strcmp (str, "create") == 0)
	access = AXS_CREATE;
    else if (strcmp (str, "set") == 0)
	access = AXS_SET;
    else if (strcmp (str, "get") == 0)
	access = AXS_GET;
    else if (strcmp (str, "technology") == 0)
	access = AXS_TECH;
    else if (strcmp (str, "serpent") == 0)
	access = AXS_SERPENT;
    else {
	yyerror ("Unknown ACCESS type");
	return;
	}
    if ((access_checklist & access) != 0)
	yyerror ("Duplicate use of ACCESS type %s%s", str,
	    access_checklist == AXS_ALL ? " (use \"all\" by itself)" : "");
    access_checklist |= access;
    if (whichway == 1)
	cur_access |= access;
    else
	cur_access &= ~access;
}

%}

%union {
    int ival;
    float rval;
    char *cptr;
    ALIST alst;
    struct { idd_data_types stype; int range; short is_proc; } nrng;
    struct { idd_data_types stype; XYZZY val; } dflt;
    };

%token		<ival> ACCESS
%token		<ival> ATTRIBUTES
%token		<ival> BOOLEAN
%token		<ival> CHECK_ROUTINE
%token		<ival> CONVENIENCE_ROUTINE
%token		<ival> CLASS
%token		<cptr> C_ROUTINE
%token		<cptr> C_STRING
%token		<cptr> C_TOKEN
%token		<ival> DESCRIPTION
%token		<ival> INCLUDE_FILE
%token		<ival> INTEGER
%token		<ival> METHODS
%token		<ival> PARAMETERS
%token		<ival> PRIORITY
%token		<rval> REAL
%token		<ival> SERPENT_DEFAULT
%token		<ival> TECHNOLOGY_DEFAULT
%token		<ival> SERPENT_NAME
%token		<ival> WIDGET_TYPE 
%token		<ival> USERDEF
%token		<ival> X_TYPE

%type		<nrng> serpent_type
%type		<ival> opt_range
%type		<ival> opt_proc
%type		<ival> signed_integer
%type		<dflt> default_value
%type		<alst> parm_list
%type		<cptr> attr_name

%%

glue		: /* Do this before anything */
		    {
		    if (GT_LAST > (GT_LAST_V6 + 1)) {
			fputs ("Warning!  The GT_TYPE enum type has been changed without changing the parser!\nYou need to modify gay.y\n", stderr);
			exit (1);
			}

		    FindTokens();
		    equiv_list = make_alist ();
		    widget_list = make_alist();
		    tech_description = NULL;
		    saddle_command = NULL;
		    }
		  map_list ';'

map_list	: mapping
		| map_list ';' mapping
		;

mapping		: global_var
		| type_equiv
		| widget_defn
		;

/**************************************************************************/

global_var	: C_TOKEN '=' C_STRING
		    {
		    (void) u22_convert_string_inplace ($1, LOWERCASE);
		    if (strcmp ($1, "description") == 0) {
			if (tech_description == NULL)
			    tech_description = $3;
			else
			    yyerror ("Duplicate technology description");
			}
		    else if (strcmp ($1, "saddle_command") == 0) {
			if (saddle_command == NULL)
			    saddle_command = $3;
			else
			    yyerror ("Duplicate Saddle command");
			}
		    else
			yyerror ("Unknown keyword '%s'", $1);
		    }

/**************************************************************************/

type_equiv	: C_TOKEN ':' serpent_type
		    {
		    EQUIV *equiv;
		    EQUIV temp;
		    int i;
		    int found = 0;
		    GT_TYPE gt_type;

		    for (i = 0; i < NUM_TTYPES; i++ ) {
			if (strcmp($1, tech_map[i].tname) == 0) {
			    gt_type = tech_map[i].gt_type;
			    found++;
			    break;
			    }
			}
		    if (found == 0)
			yyerror ("Warning: Technology type '%s' is unknown.  You may need to rebuild Glue", $1);

		    temp.lhs = $1;
		    equiv = (EQUIV *) search_alist (equiv_list, &temp, find_equiv);
		    if (equiv == NULL) {
			equiv = (EQUIV *) make_node (sizeof(EQUIV));
			equiv->lhs = $1;
			equiv->rhs = $3.stype;
			equiv->range = $3.range;
			equiv->is_proc = $3.is_proc;
			equiv->gt_type = gt_type;
			(void) add_to_atail (equiv_list, equiv);
			}
		    else {
			if ( $3.stype != equiv->rhs ) {
			    equiv->rhs = $3.stype;
			    equiv->range = $3.range;
			    equiv->is_proc = $3.is_proc;
			    equiv->gt_type = gt_type;
			    yyerror ("Warning: Redeclaration of equivalence type '%s'", $1);
			    }
			}
		    }

serpent_type	: C_TOKEN opt_range opt_proc
		    {
		    int i;
		    int found = 0;

		    (void) u22_convert_string_inplace ($1, LOWERCASE);
		    for (i = 0; i < NUM_STYPES; i++ ) {
			if (strcmp($1, serp_map[i].sname) == 0) {
			    found++;
			    if (serp_map[i].legal == LEGAL)
				$$.stype = serp_map[i].stype;
			    else {
				yyerror ("Equivalence type '%s' not allowed.  Using 'integer'.", $1);
				$$.stype = idd_integer;
				}
			    if (serp_map[i].rng == VECTOR && $2 < 0) {
				yyerror ("Equivalence type '%s' needs a size modifier", $1);
				$$.range = 0;
				}
			    else if (serp_map[i].rng == SCALAR && $2 >= 0) {
				yyerror ("Size modifier illegal for equivalence type '%s'", $1);
				$$.range = -1;
				}
			    else
				$$.range = $2;
			    if (serp_map[i].is_proc == NO_PROC && $3 > 0) {
				yyerror ("Equivalence type '%s' cannot have an associated procedure", $1);
				$$.is_proc = 0;
				}
			    else
				$$.is_proc = $3;
			    break;
			    }
			}
		    if ( ! found) {
			yyerror ("Unknown equivalence type '%s'.  Using 'integer'.\n", $1);
			$$.stype = idd_integer;
			$$.range = -1;
			$$.is_proc = 0;
			}
		    }

opt_range	: /* nothing - empty */
		    {
		    $$ = -1;
		    }
		| '[' INTEGER ']'
		    {
		    $$ = $2;
		    }
		;

opt_proc	: /* nothing - empty */
		    {
		    $$ = 0;
		    }
		| '+' C_TOKEN
		    {
		    (void) u22_convert_string_inplace ($2, LOWERCASE);
		    if (strcmp ($2, "procedure") == 0)
			$$ = 1;
		    else {
			yyerror ("Unknown equivalence modifier");
			$$ = 0;
			}
		    }
		;

/**************************************************************************/

widget_defn	: C_TOKEN '{'
		    {
		    WIDGET temp;
		    
		    (void) u22_convert_string_inplace ($1, LOWERCASE);
		    temp.name = $1;
		    cur_w = (WIDGET *) search_alist (widget_list, &temp, find_widget);
		    if (cur_w != NULL) {
			yyerror ("Duplicate widget type '%s'", $1);
			}
		    else {
			cur_w = (WIDGET *) make_node (sizeof (WIDGET));
			cur_w->name = $1;
			cur_w->description = NULL;
			cur_w->userdef = NULL;
			cur_w->class = NULL;
			cur_w->include_name = NULL;
			cur_w->attrs = make_alist();
			cur_w->methods = make_alist();
			cur_w->check_rtne = NULL;
			cur_w->conv_rtne = NULL;
			cur_w->widget_type = WT_NONE ;
			}
		    FindKeywords();
		    }
		  component_list opt_semi '}'
		    {
		    if (cur_w->include_name == NULL) {
			if (no_warnings)
			    num_include_warn++;
			else
			    yyerror ("WARNING: Widget '%s' should have a INCLUDE_FILE listed",
					cur_w->name);
			}
		    if (cur_w->class == NULL) {
			cur_w->class = "";
			if (no_warnings)
			    num_class_warn++;
			else
			    yyerror ("WARNING: Widget '%s' should have a CLASS listed",
					cur_w->name);
			}
		    (void) add_to_atail (widget_list, cur_w);
		    FindTokens();
		    }

component_list	: component
		| component_list ';' component
		| error ';'
		    { yyerror ("Unknown widget component"); }
		;

component	: class_type
		| include_name
		| check_routine
		| conv_routine
		| description
		| userdef
		| widget_type
		| attribute_set
		| method_set
		;

class_type	: CLASS  '='
		    {
		    FindTokens();
		    }
		  C_TOKEN
		    {
		    if (cur_w->class == NULL)
			cur_w->class = $4;
		    else
			widget_error ("CLASS");
		    FindKeywords();
		    }

include_name	: INCLUDE_FILE '='
		    {
		    FindTokens();
		    }
		  C_STRING
		    {
		    if (cur_w->include_name == NULL)
			cur_w->include_name = $4;
		    else
			widget_error ("INCLUDE_NAME");
		    FindKeywords();
		    }

check_routine	: CHECK_ROUTINE '='
		    {
		    FindTokens();
		    }
		  C_TOKEN
		    {
		    if (cur_w->check_rtne == NULL)
			cur_w->check_rtne = $4;
		    else
			widget_error ("CHECK_ROUTINE");
		    FindKeywords();
		    }

conv_routine	: CONVENIENCE_ROUTINE '='
		    {
		    FindTokens();
		    }
		  C_TOKEN
		    {
		    if (cur_w->conv_rtne == NULL)
			cur_w->conv_rtne = $4;
		    else
			widget_error ("CONVENIENCE_ROUTINE");
		    FindKeywords();
		    }

description	: DESCRIPTION '=' C_STRING
		    {
		    if (cur_w->description == NULL)
			cur_w->description = $3;
		    else
			widget_error ("DESCRIPTION");
		    FindKeywords();
		    }

userdef		: USERDEF '=' C_STRING
		    {
		    if (cur_w->userdef == NULL)
			cur_w->userdef = $3;
		    else
			widget_error ("USERDEF");
		    FindKeywords();
		    }

widget_type	: WIDGET_TYPE '=' C_TOKEN
		    {
                    if (cur_w->widget_type == WT_NONE) {
		      if (!strcmp($3,"shell"))
			cur_w->widget_type = WT_WM_SHELL;
		      else if (!strcmp($3,"override"))
			cur_w->widget_type = WT_OVERRIDE_SHELL;
		      else if (!strcmp($3,"widget"))
			cur_w->widget_type = WT_WIDGET;
		      else if (!strcmp($3,"none"))
			cur_w->widget_type = WT_NONE;
		      else
 			yyerror ("Invalid widget_type '%s' in widget '%s'", 
				 $3, cur_w->name); 
		      }
		    else
                      widget_error ("WIDGET_TYPE");
		    FindKeywords();
		    }


/**************************************************************************/

attribute_set	: ATTRIBUTES '='
		    {
		    FindTokens();
		    }
		  '{' attribute_list opt_semi '}'
		    {
		    FindKeywords();
		    }

attribute_list	: attribute
		| attribute_list opt_sep attribute
		;

attribute	: attr_name ':'
		    {
                    default_clash = 0 ;

		    cur_a = (ATTR *) make_node (sizeof(ATTR));
		    cur_a->xname = $1;
		    cur_a->sname = NULL;
		    cur_a->xtype = GT_ILLEGAL;
		    cur_a->stype = idd_no_data_type;
		    cur_a->range = -1;
		    cur_a->val_type = VAL_NONE;
		    cur_a->description = NULL;
		    cur_a->userdef = NULL;
		    cur_a->access = AXS_NONE;
		    cur_a->priority = 0;
		    cur_a->widget = cur_w;
		    FindKeywords();
		    }
		  '{' attr_parts opt_semi '}'
		    {
		    int i;
		    /*
		     * If there is no Serpent name given, make it the same
		     * as the X name of the attribute.
		     */
		    if (cur_a->sname == NULL)
			cur_a->sname = u22_convert_string (cur_a->xname, LOWERCASE);
		    /*
		     * If no access clause given make it access ALL
		     */
		    if (cur_a->access == AXS_NONE)
			cur_a->access = AXS_ALL;

		    /*
		     * You gotta specify an X type clause
		     */
		    if (cur_a->xtype == GT_ILLEGAL) {
			yyerror ("Attribute '%s' must have a X_TYPE specified",
					cur_a->xname);
			}

		    /*
		     * Check to see if 2 defaults were given for an attribute
		     */
		    if (default_clash)
		        yyerror ("Warning: Technology default for '%s' in '%s' will be overwritten by Serpent default", cur_a->xname, cur_w->name);
		    /*
		     * Verify that the default and serpent types agree (they
		     * agree if they match, or if a string is used as a
		     * default value for a buffer type, or if a string is
		     * used as a default for a type with is_proc set).
		     */
		    if ((cur_a->val_type == VAL_SERP_DEFAULT) ||
		        (cur_a->val_type == VAL_TECH_DEFAULT)) {
/*
			if (cur_a->stype == idd_id)
			    yyerror ("Attribute '%s' of type id cannot have a default value", cur_a->xname);
			else if ( ! ((cur_a->stype == cur_a->dtype) ||
				     (cur_a->stype == idd_buffer && cur_a->dtype == idd_string) ||
				     (cur_a->is_proc && cur_a->dtype == idd_string)))
			    yyerror ("X_TYPE and default value type mismatch for attribute '%s'", cur_a->xname);
*/
		    }
		    /*
		     * Finally, add this to the end of the attribute ALIST
		     */
		    (void) add_to_atail (cur_w->attrs, cur_a);
		    FindTokens();
		    }

attr_name	: C_STRING
		    {
		    ATTR temp;

		    temp.xname = $1;
		    if (search_alist (cur_w->attrs, &temp, find_xname))
			yyerror ("Duplicate attr '%s' in widget '%s'",
					$1, cur_w->name);
		    $$ = $1;
		    }
		| C_TOKEN
		    {
		    yyerror ("Attribute '%s' not a \"string\" (missing #define?)", $1);
		    $$ = $1;
		    }
		;

attr_parts	: attr_part
		| attr_parts ';' attr_part
		;

attr_part	: SERPENT_NAME '=' C_STRING
		    {
		    ATTR temp;

		    temp.sname = u22_convert_string_inplace ($3, LOWERCASE);
		    if (cur_a->sname != NULL ||
			  search_alist (cur_w->attrs, &temp, find_sname))
			attribute_error ("SERPENT_NAME");
		    else
			cur_a->sname = $3;
		    }
		| DESCRIPTION '=' C_STRING
		    {
		    if (cur_a->description == NULL)
			cur_a->description = $3;
		    else
			attribute_error ("DESCRIPTION");
		    }
		| USERDEF '=' C_STRING
		    {
		    if (cur_a->userdef == NULL)
			cur_a->userdef = $3;
		    else
			attribute_error ("USERDEF");
		    }
		| X_TYPE '='
		    {
		    FindTokens();
		    }
		  C_TOKEN
		    {
		    EQUIV *equiv;
		    EQUIV temp;
		    
		    if (cur_a->xtype == GT_ILLEGAL) {
			temp.lhs = $4;
			equiv = (EQUIV *) search_alist (equiv_list, &temp, find_equiv);
			if (equiv == NULL) {
			    yyerror ("Type '%s' has no Serpent equivalent", $4);
			    cur_a->xtype = GT_caddr_t;
			    cur_a->stype = idd_integer;
			    cur_a->range = -1;
			    cur_a->is_proc = 0;
			    }
			else {
			    cur_a->xtype = equiv->gt_type;
			    cur_a->stype = equiv->rhs;
			    cur_a->range = equiv->range;
			    cur_a->is_proc = equiv->is_proc;
			    }
			}
		    else
			attribute_error ("X_TYPE");
		    FindKeywords();
		    }
		| SERPENT_DEFAULT '='
		    {
		    FindTokensOrValues();
		    }
		  default_value
		    {
		    if (cur_a->val_type == VAL_NONE) {
			cur_a->val_type = VAL_SERP_DEFAULT;
			cur_a->dtype = $4.stype;
			cur_a->val = $4.val;
			}
		    else if (cur_a->val_type == VAL_TECH_DEFAULT) {
                        default_clash = 1 ;
			cur_a->val_type = VAL_SERP_DEFAULT;
			cur_a->dtype = $4.stype;
			cur_a->val = $4.val;
			}
		    else 
			attribute_error ("SERPENT_DEFAULT");
		    FindKeywords();
		    }
		| TECHNOLOGY_DEFAULT '='
		    {
		    FindTokensOrValues();
		    }
		  default_value
		    {
		    if (cur_a->val_type == VAL_NONE) {
			cur_a->val_type = VAL_TECH_DEFAULT;
			cur_a->dtype = $4.stype;
			cur_a->val = $4.val;
			}
		    else if (cur_a->val_type == VAL_SERP_DEFAULT) 
                        default_clash = 1 ;
		    else 
			attribute_error ("TECHNOLOGY_DEFAULT");
		    FindKeywords();
		    }
		| ACCESS '='
		    {
		    access_direction = DO_EITHER;
		    access_checklist = 0;
		    FindTokens();
		    }
		  access_list
		    {
		    if (cur_a->access == 0) {
			if (access_direction == DO_BOTH &&
				access_checklist != AXS_ALL)
			    yyerror ("Mixed mode ACCESS must list all tyeps!");
			if (((cur_access & (AXS_TECH|AXS_SERPENT)) != 0) &&
			    ((cur_access & (AXS_SET|AXS_GET|AXS_CREATE)) != 0))
			    cur_a->access = cur_access;
			else {
			    yyerror ("ACCESS denies all access!");
			    }
			}
		    else
			attribute_error ("ACCESS");
		    FindKeywords();
		    }
		| PRIORITY '=' signed_integer
		    {
		    cur_a->priority = $3;
		    }
		| error
		    { yyerror ("Unknown attribute component"); }
		;

default_value	: C_STRING
		    {
		    $$.stype = idd_string;
		    $$.val.s = $1;
		    }
		| C_TOKEN
		    {
		    $$.stype = idd_string;
		    $$.val.s = $1;
		    }
		| REAL
		    {
		    $$.stype = idd_real;
		    $$.val.r = $1;
		    }
		| signed_integer
		    {
		    $$.stype = idd_integer;
		    $$.val.i = $1;
		    }
		| BOOLEAN
		    {
		    $$.stype = idd_boolean;
		    $$.val.i = $1;
		    }
		;

signed_integer	: INTEGER
		    {
		    $$ = $1;
		    }
		| '-' INTEGER
		    {
		    $$ = - $2;
		    }
		;

access_list	: access
		| access_list "," access
		;

access		: C_TOKEN
		    {
		    if (access_direction == DO_EITHER) {
			cur_access = 0;
			access_direction = DO_ON;
			}
		    else if (access_direction == DO_OFF)
			access_direction = DO_BOTH;
		    add_access ($1, 1);
		    }
		| "!" C_TOKEN
		    {
		    if (access_direction == DO_EITHER) {
			cur_access = AXS_ALL;
			access_direction = DO_OFF;
			}
		    else if (access_direction == DO_ON)
			access_direction = DO_BOTH;
		    add_access ($2, 0);
		    }


/**************************************************************************/

method_set	: METHODS '='
		    {
		    FindTokens();
		    }
		 '{' method_list opt_sep '}'
		    {
		    FindKeywords();
		    }

method_list	: method
		| method_list opt_sep method
		;

method		: C_TOKEN ':'
		    {
		    METH temp;

		    (void) u22_convert_string_inplace ($1, LOWERCASE);
		    temp.name = $1;
		    if (search_alist (cur_w->methods, &temp, find_method))
			yyerror ("Duplicate method '%s' in widget '%s'",
					$1, cur_w->name);
		    cur_m = (METH *) make_node (sizeof(METH));
		    cur_m->name = $1;
		    cur_m->rtne = NULL;
		    cur_m->parms = (ALIST) NULL;
		    cur_m->description = NULL;
		    cur_m->userdef = NULL;
		    cur_m->widget = cur_w;
		    FindKeywords();
		    }
		 '{' method_parts opt_semi '}'
		    {
		    if (cur_m->parms == (ALIST) NULL)
			cur_m->parms = make_alist ();
		    (void) add_to_atail (cur_w->methods, cur_m);
		    FindTokens();
		    }

method_parts	: method_part
		| method_parts ';' method_part
		;

method_part	: PARAMETERS '='
		    {
		    FindTokens();
		    }
		 parm_list
		    {
		    if (cur_m->parms == (ALIST) NULL)
			cur_m->parms = $4;
		    else
			yyerror ("Duplicate PARAMETER list in method '%s' in widget '%s'", cur_m->name, cur_w->name);
		    FindKeywords();
		    }
		| DESCRIPTION '=' C_STRING
		    {
		    if (cur_m->description == NULL)
			cur_m->description = $3;
		    else
			yyerror ("Duplicate DESCRIPTION in method '%s' in widget '%s'", cur_m->name, cur_w->name);
		    FindKeywords();
		    }
		| USERDEF '=' C_STRING
		    {
		    if (cur_m->userdef == NULL)
			cur_m->userdef = $3;
		    else
			yyerror ("Duplicate USERDEF in method '%s' in widget '%s'", cur_m->name, cur_w->name);
		    FindKeywords();
		    }
		| C_ROUTINE '='
		    {
		    FindTokens();
		    }
		  C_TOKEN
		    {
		    if (cur_m->rtne == NULL)
			cur_m->rtne = $4;
		    else
			yyerror ("Duplicate C_ROUTINE in method '%s' in widget '%s'", cur_m->name, cur_w->name);
		    FindKeywords();
		    }
		| error
		    { yyerror ("Unknown method component"); }
		;

parm_list	: /* null string - no parameters */
		    {
		    $$ = make_alist ();
		    }
		| C_STRING
		    {
		    ALIST names = make_alist ();
		    PARM *parm = (PARM *) make_node (sizeof (PARM));
		    parm->name = u22_convert_string_inplace ($1, LOWERCASE);
		    (void) add_to_atail (names, parm);
		    $$ = names;
		    }
		| parm_list ',' C_STRING
		    {
		    PARM *parm = (PARM *) make_node (sizeof (PARM));
		    parm->name = u22_convert_string_inplace ($3, LOWERCASE);
		    (void) add_to_atail ($1, parm);
		    $$ = $1;
		    }

/**************************************************************************/

opt_semi	:
		| ';'
		;

opt_sep		:
		| ';'
		| ','
		;
