	static char rcsid [] = "$Header: /u/04c/mnt/integ/source/glue/src/RCS/gft.c,v 1.4 90/09/01 19:54:28 ejh Exp $";

/*--------------------------------------------------------------------------
|
|  Name:	gft.c
|
|  Description:
|	This module locates a technology file in a path list
|
|  Component of:
|	GLUE interface
|
|  Related files:
|	gft.h
|
|  Project:
|	SERPENT System
|	User Interface Prototyping
|	Software Engineering Institute
|	Carnegie Mellon University
|	Pittsburgh, PA  15213
|
|  Version: 1.0
|
|  Owner:  
|	Len Bass
|	ljb@sei.cmu.edu
|
|  Author:  
|	Daniel V. Klein
|	dvk@sei.cmu.edu
|
|  Change History:
$Log:	gft.c,v $
 * Revision 1.4  90/09/01  19:54:28  ejh
 * took out include of strings.h; added include of X11/Xos.h to get rindex,
 * as *strongly* suggested by the X folks
 * 
 * Revision 1.3  90/05/30  15:15:14  dvk
 * Changed include of <string.h> to <strings.h> (stupid Sun system...)
 * 
 * Revision 1.2  90/05/18  17:16:24  dvk
 * Miffed the header - fixed it.
 * 
 * Revision 1.1  90/05/18  17:11:53  dvk
 * Initial revision
 * 
|
\*--------------------------------------------------------------------------
|
|   Distribution: Approved for public release; distribution is unlimited.
|
|   Copyright (c) 1989  by  Carnegie  Mellon  University, Pittsburgh, PA.  The
|  Software Engineering  Institute  (SEI) is a federally  funded  research and
|  development center established  and  operated by Carnegie Mellon University
|  (CMU).  Sponsored  by  the  U.S.  Department  of   Defense  under  contract
|  F19628-85-C-0003,  the  SEI  is  supported  by  the  services  and  defense
|  agencies, with the U.S. Air Force as the executive contracting agent.
|
|    Permission to use,  copy,  modify, or  distribute  this  software and its
|  documentation for  any purpose and without fee  is hereby granted, provided
|  that  the above copyright notice appear  in  all copies and that both  that
|  copyright  notice  and   this  permission  notice  appear   in   supporting
|  documentation.   Further,  the  names  Software  Engineering  Institute  or
|  Carnegie  Mellon  University  may  not be used in  advertising or publicity
|  pertaining to distribution of the software without specific, written  prior
|  permission.  CMU makes no claims  or representations  about the suitability
|  of this software for any purpose.  This software is provided "as is" and no
|  warranty,  express  or  implied,  is  made  by  the  SEI  or CMU, as to the
|  accuracy  and  functioning of the program and related program material, nor
|  shall   the  fact of  distribution   constitute  any   such  warranty.   No
|  responsibility is assumed by the SEI or CMU in connection herewith.
|
\*--------------------------------------------------------------------------*/
#include <stdio.h>
#include <string.h>
#include <X11/Xos.h>

/*==========================================================================
 * Find a technology file by looking for the file (or file.tx) in the
 * current directory or in SERPENT_DATA_PATH
 */
FILE *glue_find_tech (name)
char *name;
{
    FILE *fd;
    char file[512], env[512];
    char *slash, *dot, *sdp;
    short add_tx = 0;
    extern char *getenv();

    /*
     * First, see if we need to add ".tx" to the name.  The check is to see
     * if there is no dot in the last component, we need to add .tx
     */
    slash = rindex (name, '/');
    dot = rindex (name, '.');
    if (dot == NULL)
	add_tx++;
    else
	if (slash != NULL && slash > dot)
	    add_tx++;
    if (*name == '/' || (sdp=getenv ("SERPENT_DATA_PATH")) == NULL) {
	(void) strcpy (file, name);
	if (add_tx)
	    (void) strcat (file, ".tx");
	return (fopen (file, "r"));
	}
    else {
	sdp = strtok (strcpy (env, sdp), " ");
	while (sdp != NULL) {
	    (void) strcat (strcat (strcpy (file, sdp), "/"), name);
	    if (add_tx)
		(void) strcat (file, ".tx");
	    if ((fd=fopen (file, "r")) != NULL)
		return fd;
	    sdp = strtok (NULL, " ");
	    }
	}
    return (FILE *)NULL;
}
