--+
--|
--| Package spec:	CA_CONV
--|
--| Defines conversion routines and types between C and Ada
--|
--+
with system;
  use system;
with Text_IO; use Text_IO;

package ca_conv is

  type int is range -( 2**31 )..( 2**31 )-1 ;
  for int'size use 32;

  type int_ptr is access integer;

  type short is range -( 2**15 )..( 2**15 )-1 ;
  for short'size use 16;

  type char is range -( 2**7 )..( 2**7 )-1 ;
  for char'size use 8;

  type c_string is access character;	-- This is char *

  type integer_pointer is access integer;	-- This is int *

  type real_pointer is access long_float;	-- This is real *

  type bool is new boolean;
  for bool'size use 8;

  type c_handle is range -( 2**31 )..( 2**31 )-1 ;
  for c_handle'size use 32;

  procedure ada_to_c_string (in_string : in string; out_string : out string);

  procedure c_to_ada_string (in_string : in c_string;
                             out_string : out string);

end ca_conv;
