--+
--|
--| Package body:	CA_CONV
--|
--| Defines conversion routines and types between C and Ada
--|
--+
with unchecked_conversion;

package body ca_conv is

  use system;

  type a_string is access string;

  function fetch_char is new system.fetch (element_type => character);

  function c_strlen (src : c_string) return natural is
    len : natural := 0;
    start : system.address;
    cur : character;
  begin
    start := src.all'address;
    loop
	cur := fetch_char (from => start + integer (len));
	exit when cur = ascii.nul;
	len := len + 1;
    end loop;
    return len;
  end c_strlen;

  procedure c_to_ada_string (in_string : in c_string; 
                             out_string : out string) is
    len : natural;
    c_start : system.address;
    c_cur : character;
  begin
    len := out_string'LENGTH;
    for idx in 0..len-1 loop
        out_string(idx + 1) := ASCII.NUL;
    end loop;
    len := c_strlen (in_string);
    c_start := in_string.all'address;
    for idx in 0..len-1 loop
	c_cur := fetch_char (from => c_start + integer (idx));
	out_string(idx + 1) := c_cur;
    end loop;
    return;
  end c_to_ada_string;

  function addr_to_cstr is new unchecked_conversion (system.address, c_string);

  procedure ada_to_c_string (in_string : in string; out_string : out string) is

  begin
        out_string := in_string & ASCII.NUL;
    return;
  end;

end ca_conv;
