/* $Header: /u/04c/mnt/integ/source/int/include/RCS/ist.h,v 1.2 91/02/18 16:27:02 rcs Exp $ */
/*--------------------------------------------------------------------------*\
| 
|  Name:  Interface Status Codes (ist)
|
|  Description:  
|     This file contains a collection of defines for status codes that
|     can be used by either C or Slang programs.
|
|  Component of:
|     Interface Layer.
|     Dialogue Layer.
|
|  Related files:
|     ist.h - contains the external definition for the status codes.
|
|  Project:
|     Serpent
|     User Interface Prototyping
|     Software Engineering Institute
|     Carnegie Mellon University
|     Pittsburgh, PA  15213
|
|  Version: 1.0
|
|  Project Leader:  
|     Len Bass
|     ljb@sei.cmu.edu
|
|  Author:  
|     Robert C. Seacord
|     rcs@sei.cmu.edu  
|
|  Change History:
|     Aug. 2, 1990 : Module created.
|     $Log:	ist.h,v $
 * Revision 1.2  91/02/18  16:27:02  rcs
 * new status code name
 * 
 * Revision 1.1  90/08/14  10:55:59  rcs
 * Initial revision
 * 
|
\*--------------------------------------------------------------------------*\
|
|   Distribution: Approved for public release; distribution is unlimited.
|
|   Copyright (c) 1989  by  Carnegie  Mellon  University, Pittsburgh, PA.  The
|  Software Engineering  Institute  (SEI) is a federally  funded  research and
|  development center established  and  operated by Carnegie Mellon University
|  (CMU).  Sponsored  by  the  U.S.  Department  of   Defense  under  contract
|  F19628-85-C-0003,  the  SEI  is  supported  by  the  services  and  defense
|  agencies, with the U.S. Air Force as the executive contracting agent.
|
|    Permission to use,  copy,  modify, or  distribute  this  software and its
|  documentation for  any purpose and without fee  is hereby granted, provided
|  that  the above copyright notice appear  in  all copies and that both  that
|  copyright  notice  and   this  permission  notice  appear   in   supporting
|  documentation.   Further,  the  names  Software  Engineering  Institute  or
|  Carnegie  Mellon  University  may  not be used in  advertising or publicity
|  pertaining to distribution of the software without specific, written  prior
|  permission.  CMU makes no claims  or representations  about the suitability
|  of this software for any purpose.  This software is provided "as is" and no
|  warranty,  express  or  implied,  is  made  by  the  SEI  or CMU, as to the
|  accuracy  and  functioning of the program and related program material, nor
|  shall   the  fact of  distribution   constitute  any   such  warranty.   No
|  responsibility is assumed by the SEI or CMU in connection herewith.
|
\*--------------------------------------------------------------------------*/

#define	ok 					0
#define invalid_handle				1
#define invalid_id				2
#define not_available				3
#define out_of_memory				4
#define system_operation_failed			5
#define null_memory_ptr				6
#define invalid_request				7
#define not_found				8
#define empty					9
#define bad_parameter				10
/*
   Interface status codes.
*/
#define already_recording			11
#define invalid_transaction_handle    		12
#define invalid_process_handle			13
#define invalid_received_transaction_handle	14
#define null_element_name			15
#define null_component_name			16
#define null_mailbox_name			17
#define null_ill_file_name			18
#define element_not_a_record			19
#define overflow				20
#define undefined_conversion			21
#define io_failure                            	22
#define end_of_file                           	23
#define inconsistent_jour_file                	24
#define invalid_journal_file                  	25
#define invalid_change_type			26
#define not_implemented				27
#define shm_out_of_bounds			28
#define component_not_changed			29
/*
   Dialogue compiler status codes
*/
#define c22_no_sd_definition                  	30
/*
   Symbol table status codes
*/
#define cus_no_property				31
#define cus_null_symbol				32
/*
   Dialogue compiler status codes
*/
/*
   Object base status codes
*/
#define invalid_data_type			33
#define invalid_symbol				34
#define symbol_not_found			35
#define invalid_shared_data			36
#define invalid_data_object			37
/*
   Dialogue manager runtime status codes.
*/
#define illegal_boolean_operation		38
#define operation_undefined_types		39
#define operation_undefined_type		39
#define unknown_handling			40
#define handling_undefined			41
#define illegal_conversion			42
#define failed_conversion			43
#define illegal_assignment			44
#define illegal_arithmetic_operation		45
#define null_operand				46
#define null_first_operand			47
#define null_second_operand			48
/*
   Dialogue manager runtime status codes.
*/
#define dpg_unknown_type                      	49
#define dpg_no_st_entry                       	50
#define dpg_no_ops_wme                        	51
#define dpg_bad_ops_store_symbol              	52
#define dpg_bad_ops_store_symbol_array        	53
#define dpg_no_id_name                        	54
#define dpg_cannot_make_wme                   	55
#define dpg_no_template_entry                 	56
#define dpg_cannot_get_symbol_type            	57
#define dpg_cannot_get_ask_prop               	58
#define dra_cannot_find_element			59
/*
   Dialogue Editor Application (DEA) status codes.
*/
#define invalid_dialogue 			60
#define invalid_vc 				61
#define invalid_list 				62
#define invalid_integer 			63
#define invalid_string 				64
#define invalid_buffer 				65
#define invalid_object                        	66
#define invalid_attribute                     	67
#define invalid_method                        	68
#define invalid_object_instance               	69
#define invalid_variable	                70
/*
   Serpent X status codes.
*/
/*
   Add new status codes here:
*/
#define removed_data_object			71	/* database status */
#define file_already_exists			72
#define file_not_found				73
#define invalid_bin_file			74
#define invalid_src_file			75

/*
\*--------------------------------------------------------------------------*/
