/*    $Header: /u/04c/mnt/integ/source/int/src/RCS/ipb.c,v 1.23 91/03/26 17:31:43 dvk Exp $       */
/*    $Log:	ipb.c,v $
 * Revision 1.23  91/03/26  17:31:43  dvk
 * replaced use of idd_create_component_alist and for_all_alist with
 * the more direct for_all_hashtable
 * 
 * Revision 1.22  91/03/11  16:48:53  dvk
 * Changed idd_create_component_list to idd_create_component_alist
 * 
 * Revision 1.21  91/01/02  18:12:12  dvk
 * Changed from hardwired "DM_BOX" to global #defined value
 * 
 * Revision 1.20  90/12/01  14:13:36  little
 * fix ipb_record so it does not crap out things if the recording file
 * could not be opened for write.
 * 
 * Revision 1.19  90/08/22  11:17:52  rcs
 * nno change
 * 
 * Revision 1.18  90/06/06  17:41:03  clc
 * On file_name exec_monitor, open a pipe to the command exec_monitor
 * in ipb_start_recording
 * 
 * Revision 1.17  90/02/14  22:00:34  ejh
 * fixed include structure
 * 
 * Revision 1.16  89/12/06  20:43:11  clc
 * Added fflush (fp) at the end of record_transaction
 * 
 * Revision 1.15  89/11/22  13:00:57  rcs
 * fixed output of undefined buffesr
 * 
 * Revision 1.13  89/09/19  15:41:05  ljb
 * reverse order of ipc_send calls and journaling calls
 * other process was modifying changes prior to journaling
 * 
 * Revision 1.12  89/07/18  13:17:49  bmc
 * Now correctly checks for null pointer after opening recording file.
 * 
 * Revision 1.11  89/06/05  09:03:38  ljb
 * make work with "remove" and fix minor bugs
 * 
 * Revision 1.7  89/06/01  15:21:02  ejh
 * fixed buffer recording; turned status tests into io_test
 * 
 * Revision 1.6  89/02/09  19:03:56  ejh
 * added copyright notice
 * 
 * Revision 1.5  88/11/02  21:43:28  rcs
 * changed debug1 to debug2 for call, exit and parameters
 * 
 * Revision 1.4  88/11/02  14:32:54  rcs
 * moved debug variable to include file - rCs
 * 
 * Revision 1.3  88/10/13  18:17:01  little
 * fix record to "work" in the presence of dm sd
 * 
 * Revision 1.2  88/10/12  14:35:39  ljb
 * fix bug which recorded wrong names and data
 *           */
/*--------------------------------------------------------------------------*\
| 
|  Name:  Playback abstraction (ipb)
|
|  Description:  
|     The playback abstraction provides entries to record and playback 
|     transactions within the interface layer.
|
|  Component of:
|     Interface Layer.
|
|  Related files:
|     ipb.c - contains the implementation for the record abstraction.
|     ipb.h - contains the external definition for the playback abstr.
|     ipb2.c - contains implementation of the formatting program for the
|              recorded file
|     ipb3.c - contains implementation of the playback abstr
|     ipbtest.c - test file.
|
|  Project:
|     SERPENT System
|     User Interface Prototyping
|     Software Engineering Institute
|     Carnegie Mellon University
|     Pittsburgh, PA  15213
|
|  Version: 1.0
|
|  Owner:  
|     Len Bass
|     ljb@sei.cmu.edu
|
|  Author:  
|     Len Bass
|     ljb@sei.cmu.edu  
|
|  Change History:
|     Feb. 23, 1988 : Module created.
|
\*--------------------------------------------------------------------------*\
|
|   Distribution: Approved for public release; distribution is unlimited.
|
|   Copyright (c) 1989  by  Carnegie  Mellon  University, Pittsburgh, PA.  The
|  Software Engineering  Institute  (SEI) is a federally  funded  research and
|  development center established  and  operated by Carnegie Mellon University
|  (CMU).  Sponsored  by  the  U.S.  Department  of   Defense  under  contract
|  F19628-85-C-0003,  the  SEI  is  supported  by  the  services  and  defense
|  agencies, with the U.S. Air Force as the executive contracting agent.
|
|    Permission to use,  copy,  modify, or  distribute  this  software and its
|  documentation for  any purpose and without fee  is hereby granted, provided
|  that  the above copyright notice appear  in  all copies and that both  that
|  copyright  notice  and   this  permission  notice  appear   in   supporting
|  documentation.   Further,  the  names  Software  Engineering  Institute  or
|  Carnegie  Mellon  University  may  not be used in  advertising or publicity
|  pertaining to distribution of the software without specific, written  prior
|  permission.  CMU makes no claims  or representations  about the suitability
|  of this software for any purpose.  This software is provided "as is" and no
|  warranty,  express  or  implied,  is  made  by  the  SEI  or CMU, as to the
|  accuracy  and  functioning of the program and related program material, nor
|  shall   the  fact of  distribution   constitute  any   such  warranty.   No
|  responsibility is assumed by the SEI or CMU in connection herewith.
|
\*--------------------------------------------------------------------------*/

#define	ipb_TOP
#define	memoryPack

#include	<stdio.h>
#include	<errno.h>
#include	<sys/time.h>

#include	<hashPack.h>
#include	<listPack.h>
#include	<string.h>

#include	<ubs.h>
#include	<ubo.h>
#include	<ush.h>
#include	<isc.h>
#include	<isd.h>
#include	<isd_priv.h>
#include	<iid.h>
#include	<idd.h>
#include	<ipc.h>
#include	<ipb.h>

#define	DEBUG1(statement)  SERPENT_DEBUG1(ipb_debug, statement)
#define	DEBUG2(statement)  SERPENT_DEBUG2(ipb_debug, statement)
#define	DEBUG3(statement)  SERPENT_DEBUG3(ipb_debug, statement)

struct	timezone	tzp;
FILE			*fp;
string			fred_buffer;
isd_trans		transaction;
iid_id_type		id;
HASH			id_hash;
process_record		*cur_process;
element_change_record	*current_element;
isd_change_type		change;
LIST			changed_component_list;

extern	process_record	in_box;

/*--------------------------------------------------------------------------*\
|  Routine: ipb_start_recording
| 
|  Description:  
|     The start recording routine enables recording.
\*--------------------------------------------------------------------------*/

void	ipb_start_recording (file_name, message)
string	file_name,
	message;

    {
    string	dial_name;
    int		len;

    set_status (ok);
    check_null (isc_validate (&in_box, isc_process_record_vs),
	"ipb_start_recording: invalid_process_record\n",
	invalid_process_handle);
    if (in_box.recording)
	{
	set_status (already_recording);
	DEBUG1 (fprintf(stderr, "ipb_start_recording: already_recording\n"));
	return;
	}

    if (!strcmp(file_name, "exec_monitor")) {
     in_box.record_fp = popen ("exec_monitor", "w");
     check_null (in_box.record_fp,
        "ipb_start_recording: Couldn't open a pipe to exec_monitor\n",
	io_failure);
    }
    else {
      in_box.record_fp = fopen (file_name, "w");
      if (in_box.record_fp)
         in_box.recording = on;
      else {
         in_box.recording = false;
         fprintf (stderr,
		"\ncould not open file named %s for transaction recording\n\n",
		file_name);
         return;
         }
      }

/* 
  write out file header.  The header consists of the string "JOURNAL:"
  followed by the dialogue name, the message (from the parameter list)
*/

    io_test (fwrite ("JOURNAL:", 8, 1, in_box.record_fp));
    dial_name = isd_get_dialogue_name ();
    len = strlen (dial_name) + 1;           /* allow for terminator*/
    io_test (fwrite (&len, sizeof(len), 1, in_box.record_fp));
    io_test (fwrite (dial_name, len, 1, in_box.record_fp));
    len = strlen (message) + 1;             /*allow for terminator*/
    io_test (fwrite (&len, sizeof (len), 1, in_box.record_fp));
    io_test (fwrite (message, len, 1, in_box.record_fp));

/*
   write out the owner record.  This consists of owner mailbox name, ill
   file name, mailbox name
*/

    len = strlen (in_box.ill_file_name) + 1;
    io_test (fwrite (&len, sizeof (len), 1, in_box.record_fp));
    io_test (fwrite (in_box.ill_file_name, len, 1, in_box.record_fp));
    len = strlen (in_box.mailbox_name) + 1;
    io_test (fwrite (&len, sizeof(len), 1, in_box.record_fp));
    io_test (fwrite (in_box.mailbox_name, len, 1, in_box.record_fp));
}	/* end ipb_start_recording */

/*--------------------------------------------------------------------------*\
|  Routine: ipb_write_component
|
|  Description:
|    The write change routine writes the changes for one component to the file
|
\*--------------------------------------------------------------------------*/

static void	ipb_write_component (changes, component)
ubs_bitstring	changes;
idd_component	component;
{
    int			name_len;
    idd_buffer_type	*the_buffer;
    string		temp_string;

/*  
    this is a local routine called with an component name of an element
    change record which is to be recorded to the file.  The output of this
    routine is:  component name, value
*/

    if (ubs_test_bit (changes, component->position)) {
/*
   Write out the size and name of the component.
*/
	name_len = strlen(component->name) + 1;      /*allow for terminator*/
	io_test(fwrite(&name_len, sizeof(name_len), 1, fp));
	io_test(fwrite(component->name, name_len, 1, fp));
/*
   Write out data.
*/
	io_test(fwrite(current_element->data + component->offset,
			component->length, 1, fp));
/*
   If data type is buffer write out the body of the buffer as well.
*/
	if(component->type == idd_buffer) {
	    the_buffer = (idd_buffer_type *)(current_element->data +
				component->offset);
/*
   Write out the buffer body if it is not empty or undefined.
*/
            if (ubo_defined(the_buffer) && ubo_not_empty(the_buffer)) {
  	      io_test(fwrite(the_buffer->body, the_buffer->length, 1, fp));
	    }
	}
    }

}	/* end ipb_write_component */

/*--------------------------------------------------------------------------*\
|  Routine: ipb_write_element
|
|  Description:
|    The write element writes the identification for one changed element
|    to the file
|
\*--------------------------------------------------------------------------*/

static void	ipb_write_element (nada,change_element)
string			nada;
element_change_record	*change_element;

{
    int		name_length,
		len;
    idd_element element;

/*
   this is a local routine which is called to write out the next element in
   the change list.  it writes out: element name, change type, id prior
   calls the component writing routine to record the components and the
   values and writes out a trailer.
*/

    current_element = change_element;
    name_length = strlen (current_element->element_name) + 1;  

/*
      allow for terminator
*/
    io_test (fwrite (&name_length, sizeof (name_length), 1, fp));
    io_test (fwrite (current_element->element_name, name_length, 1, fp));
    io_test (fwrite (&current_element->change_type,
	sizeof (current_element->change_type), 1, fp));
    io_test (fwrite (&current_element->id, sizeof (current_element->id), 1,
	fp));

/* if we are deleting an element then there is nothing more to do here*/

   if (current_element->change_type == isd_remove)
	return;

    /*
     * We have written the element specific information.
     * Look up the element within the data definition
     */
    element = (idd_element) get_from_hashtable(cur_process->data_definition,
		current_element->element_name);
    check_null(element, "isd_int_sd_element: element not found.\n",
	      not_found);
    if (element->components == -1) {      /* not a record */
      set_status(element_not_a_record);
      DEBUG1(isc_print_status("ipb_write_element"));
      }
    /*
     * Loop through the hashtable, and call set_comp_undefined for each
     * component you find there.
     */
    for_all_hashtable(element->component_table,
	current_element->changed_components, ipb_write_component);
    len = NULL;
    io_test (fwrite (&len, sizeof (len), 1, fp));
}	/* end ipb_write_element */

/*--------------------------------------------------------------------------*\
|  Routine: ipb_add_corr
| 
|  Description:  
|     The add correspondent routine adds a new participant to the
|     journaling file
\*--------------------------------------------------------------------------*/

void	ipb_add_corr (process_box)
process_record	*process_box;

{
    int	len;

    io_test (fwrite ("PARTN:", 6, 1, in_box.record_fp));
    len = strlen (process_box->ill_file_name) + 1;
    io_test (fwrite (&len, sizeof (len), 1, in_box.record_fp));
    io_test (fwrite (process_box->ill_file_name, len, 1, in_box.record_fp));
    len = strlen (process_box->mailbox_name) + 1;
    io_test (fwrite (&len, sizeof (len), 1, in_box.record_fp));
    io_test (fwrite (process_box->mailbox_name, len, 1, in_box.record_fp));

}	/* end ipb_add_corr */

/*--------------------------------------------------------------------------*\
|  Routine: ipb_record_transaction
| 
|  Description:  
|     The record transaction routine writes a transaction to record_fp.
\*--------------------------------------------------------------------------*/

void	ipb_record_transaction (change_table, sender_mbx, receiver_mbx)
HASH		change_table;
ipc_mailbox	sender_mbx,
		receiver_mbx;

    {
    int			len;
    struct	timeval	tod;
    process_record	*sender,
			*receiver;

    set_status (ok);
/*
   First find out if this transaction is to be recorded and determine
   the file pointer
*/
    if (in_box.recording == false)
	return;
    fp = in_box.record_fp;
/*
   then find out if the change table is empty
*/
    if (!change_table)
	return;
/*  
   now retrieve sender and receiver process records and make sure all are
   partipicants in the recording file
*/
    sender = (process_record *) isd_getfrom_process_table (sender_mbx);
    if (sender->recording == false)
	{
	ipb_add_corr (sender);
	sender->recording = true;
	}
    receiver = (process_record *) isd_getfrom_process_table (receiver_mbx);
    if (receiver->recording == false)
	{
	ipb_add_corr (receiver);
	receiver->recording = true;
	}
    cur_process = sender;
    if (strcmp (sender->mailbox_name, DM_BOX) == 0)
	cur_process = receiver;
/*
   Each transaction has time of day, sender and receiver
*/
    io_test (fwrite ("TRANS:", 6, 1, fp));
    gettimeofday (&tod, &tzp);
    io_test (fwrite (&tod, sizeof (tod), 1, fp));

    len = strlen (sender->mailbox_name) + 1;          /*allow for terminator*/
    io_test (fwrite (&len, sizeof (len), 1, fp));
    io_test (fwrite (sender->mailbox_name, len, 1, fp));

    len = strlen (receiver->mailbox_name) + 1;      /* allow for terminator*/
    io_test (fwrite (&len, sizeof (len), 1, fp));
    io_test (fwrite (receiver->mailbox_name, len, 1, fp));

/*
   now write out the elements and the changes
*/
    for_all_hashtable (change_table, NULL, ipb_write_element);
    check_status ("ipb_record_transaction: for_all_hashtable");
    len = NULL;
    io_test (fwrite (&len, sizeof (len), 1, fp));      /*end of element list*/

    fflush(fp);

}	/* end ipb_write_transaction */

/*--------------------------------------------------------------------------*\
|  Routine: ipb_stop_recording
| 
|  Description:  
|     The stop recording routine causes the transaction manager to stop
|     recording the operations associated with a given process.
\*--------------------------------------------------------------------------*/

void	ipb_stop_recording ()

{

    set_status (ok);
/*
 * Close recording file and set recording to "off"
 */
    if (fclose (in_box.record_fp) == EOF)
	set_status (io_failure);
    in_box.recording = false;
}
