	static char rcsid [] = "$Header: /usr/users/little/serpent/sun/saddle/src/RCS/acg.c,v 1.18 1991/08/23 19:24:58 little Exp $";

/*--------------------------------------------------------------------------*\
|
|  Name:  acg.c
|
|  Description:
|	This is most of the SADDLE code generator back end, missing only the
|	ada representation clause part
|
|  Component of:
|	SADDLE processor
|
|  Project:
|	SERPENT System
|	User Interface Prototyping
|	Software Engineering Institute
|	Carnegie Mellon University
|	Pittsburgh, PA  15213
|
|  Change History:
$Log: acg.c,v $
 * Revision 1.18  1991/08/23  19:24:58  little
 * generate the correct types for the ada package
 *
 * Revision 1.17  1991/06/18  20:56:05  little
 * fix a call to u22_concat_string to have a NULL terminating parameter
 *
 * Revision 1.16  1991/03/22  11:38:05  ejh
 * changed ill code generator to create, compile, and run ada program
 *
 * Revision 1.15  91/03/01  15:34:27  ejh
 * took out printing of first column (0 or 1) in second part of ill file that
 * used to be used for sorting
 * 
 * Revision 1.14  91/02/08  15:41:15  rcs
 * modified ada generation to include access types for records
 * 
 * Revision 1.13  90/12/20  15:10:13  ejh
 * made a REAL a long_float for hpux
 * 
 * Revision 1.12  90/12/20  14:58:42  ejh
 * no change
 * 
 * Revision 1.11  90/12/20  14:51:15  ljb
 * change real to float in ada code generation
 * 
 * Revision 1.10  90/12/20  12:44:03  ejh
 * changed serpent_type_definitions to s_types; declared getenv () for use
 * in acg_ada_code
 * 
 * Revision 1.9  90/12/20  12:29:32  ejh
 * took out the #define of ADA_EXT; ada package name is now DD_NAME (env. var.)
 * 
 * Revision 1.8  90/08/20  17:21:22  dvk
 * Changed generated file to be a table (and a routine to dump the table)
 * instead of a whole heap of fprintf's.  This was motivated by the fact that
 * smo.sdd would not compile because it ran out of temporary string space
 * on the Vax.
 * 
 * Revision 1.7  90/02/19  20:51:11  ejh
 * fixed includes; changed environment variable names
 * 
 * Revision 1.6  89/12/14  11:33:52  ejh
 * took out declarations of fopen
 * 
 * Revision 1.5  89/10/18  10:24:12  ejh
 * added checks on fopen; switched over to u22_convert_string and
 * u22_copy_string
 * 
 * Revision 1.4  89/02/09  19:29:00  ejh
 * added copyright notice
 * 
 * Revision 1.3  89/01/12  01:00:18  ejh
 * added the constant string magic_number to all output files
 * 
 * Revision 1.2  89/01/11  16:16:50  ejh
 * new preamble in ill file; no path info in file names in output files
 * 
 * Revision 1.1  88/12/06  14:26:27  ejh
 * Initial revision
 * 
|	22 Nov 1988:	created; includes all of the old code generator files:
|			saddle_c.c, saddle_ada.c, saddle_ill.c
|
\*--------------------------------------------------------------------------*\
|
|   Distribution: Approved for public release; distribution is unlimited.
|
|   Copyright (c) 1989  by  Carnegie  Mellon  University, Pittsburgh, PA.  The
|  Software Engineering  Institute  (SEI) is a federally  funded  research and
|  development center established  and  operated by Carnegie Mellon University
|  (CMU).  Sponsored  by  the  U.S.  Department  of   Defense  under  contract
|  F19628-85-C-0003,  the  SEI  is  supported  by  the  services  and  defense
|  agencies, with the U.S. Air Force as the executive contracting agent.
|
|    Permission to use,  copy,  modify, or  distribute  this  software and its
|  documentation for  any purpose and without fee  is hereby granted, provided
|  that  the above copyright notice appear  in  all copies and that both  that
|  copyright  notice  and   this  permission  notice  appear   in   supporting
|  documentation.   Further,  the  names  Software  Engineering  Institute  or
|  Carnegie  Mellon  University  may  not be used in  advertising or publicity
|  pertaining to distribution of the software without specific, written  prior
|  permission.  CMU makes no claims  or representations  about the suitability
|  of this software for any purpose.  This software is provided "as is" and no
|  warranty,  express  or  implied,  is  made  by  the  SEI  or CMU, as to the
|  accuracy  and  functioning of the program and related program material, nor
|  shall   the  fact of  distribution   constitute  any   such  warranty.   No
|  responsibility is assumed by the SEI or CMU in connection herewith.
|
\*--------------------------------------------------------------------------*/

#define	acg_TOP
#define	memoryPack

#include	"global.h"
#include	"listPack.h"
#include	<stdio.h>
#include	"idd.h"

#include	"u22.h"
#include	"a22.h"
#include	"acg.h"

void	acg_c_code (file_part, mailbox_name, short_name, ill_short_name,
	    magic_number)
string	file_part,
	mailbox_name,
	short_name,
	ill_short_name,
	magic_number;

    {

#define	H_EXT	".h"
#define	HSDD	"_H_SDD"

    FILE	*hfp;
    boolean	in_record = FALSE;
    string	h_file,
		define_name;
    a22_saddle_node	*this_node,
			*comment_node,
			*record_pointer,
			*id_pointer = NULL;

/*	build .h file name and open it */

    h_file = u22_concat_string (file_part, H_EXT, NULL);

    DEBUG2 (fprintf (stderr, "building %s\n", h_file));

    hfp = fopen (h_file, "w");
    if (hfp == NULL)
	{
	fprintf (stderr, "couldn't open %s\n", h_file);
	exit (-1);
	}

/*	tell 'em what version of SADDLE this is */

    fprintf (hfp, "/* %s */\n\n", a22_saddle_magic_id);

/*	protect against the multiple inclusion problem */

    define_name = u22_concat_string (u22_convert_string (short_name,
	UPPERCASE), HSDD, NULL);
    fprintf (hfp, "#ifndef %s\n", define_name);
    fprintf (hfp, "#define %s\n\n", define_name);

/*	include serpent.h */

    fprintf (hfp, "#include\t\"serpent.h\"\n\n");

/*	provide pointers to the mail box and .ill file for this sdd, and the
	magic number for this run */

    fprintf (hfp, "#define MAIL_BOX \"%s\"\n", mailbox_name);
    fprintf (hfp, "#define ILL_FILE \"%s\"\n", ill_short_name);
    fprintf (hfp, "#define SERPENT_CONTROL_NUMBER \"%s\"\n\n", magic_number);

/*	print out the executable instructions */

    this_node = (a22_saddle_node *) get_list_head (a22_saddle_list);
    fprintf (hfp, "/* execution command:\t%s */\n\n", this_node -> name);

/*	starting at the second node in the list, read in the type; if not
	appropriate for C, skip it, otherwise, write out the appropriate C
	equivalent; if we get past the bottom, close the output file, then
	stop */

    while ((this_node = (a22_saddle_node *) get_list_next (a22_saddle_list,
	this_node)) != NULL)
	{

	DEBUG3 (fprintf (stderr, "acg_c_code: name: %s, type: %d\n",
	    this_node -> name, this_node -> stype));

	switch (this_node -> stype)

	    {

/*	for dd and end_dd, just skip it */

	    case RECORD:

/*	if it's a record it must be a typedef; save a pointer to this record
	so that at the end of the record, we can pick up the name; print out
	any inline comment; set a flag showing we're inside a record */

		fprintf (hfp, "typedef struct\t{");
		record_pointer = this_node;
		comment_node = (a22_saddle_node *) get_list_next
		    (a22_saddle_list, this_node);
		if (comment_node -> stype == INLINE_COMMENT)
		    {
		    fprintf (hfp, "\t/* %s */",	comment_node -> name);
		    this_node = comment_node;
		    }
		fprintf (hfp, "\n");
		in_record = TRUE;
		break;

	    case END_RECORD:

/*	pick up the name from the last record typedef; reset the flag to show
	we're not currently in a record */

		fprintf (hfp, "\t}\t%s;", record_pointer -> name);
		comment_node = (a22_saddle_node *) get_list_next
		    (a22_saddle_list, this_node);
		if (comment_node -> stype == INLINE_COMMENT)
		    {
		    fprintf (hfp, "\t/* %s */",	comment_node -> name);
		    this_node = comment_node;
		    }
		fprintf (hfp, "\n\n");
		in_record = FALSE;
		break;

	    case BOOLEAN:
	    case INTEGER:
	    case REAL:
	    case STRING:
	    case BUFFER:
	    case ID:

/*	if we're not in a record, this must be a scalar, so typedef */

		if (!in_record)
		    fprintf (hfp, "typedef");
		if (this_node -> stype == BOOLEAN)
		    fprintf (hfp, "\tboolean\t%s;", this_node -> name);
		else if (this_node -> stype == INTEGER)
		    fprintf (hfp, "\tint\t%s;", this_node -> name);
		else if (this_node -> stype == REAL)
		    fprintf (hfp, "\tdouble\t%s;", this_node -> name);
		else if (this_node -> stype == STRING)
		    fprintf (hfp, "\tchar\t%s [%d];", this_node -> name,
			this_node -> size);
		else if (this_node -> stype == BUFFER)
		    fprintf (hfp, "\tbuffer\t%s;", this_node -> name);
		else if (this_node -> stype == ID)
		    {
		    fprintf (hfp, "\tid_type\t%s;\t/* ", this_node -> name);
		    id_pointer = this_node;
		    }
		comment_node = (a22_saddle_node *) get_list_next
		    (a22_saddle_list, this_node);
		if (comment_node -> stype == INLINE_COMMENT)
		    {
		    if (this_node -> stype == ID)
			fprintf (hfp, "%s ", comment_node -> name);
		    else
			fprintf (hfp, "\t/* %s */", comment_node -> name);
		    this_node = comment_node;
		    }
		if (id_pointer != NULL)
		    {
		    if (id_pointer -> id_of == NULL)
			fprintf (hfp, "(no element pointer) */");
		    else
			fprintf (hfp, "(ID OF %s) */", id_pointer -> id_of);
		    id_pointer = NULL;
		    }
		fprintf (hfp, "\n");
		if (!in_record)
		    fprintf (hfp, "\n");
		break;

	    case COMMENT:

		fprintf (hfp, "\n/*\n");

/*	pick up all the comments we find and put them between a single pair
	of comment delimiters */

		comment_node = this_node;
		while (comment_node -> stype == COMMENT)
		    {
		    fprintf (hfp, "%s\n", comment_node -> name);
		    this_node = comment_node;
		    comment_node = (a22_saddle_node *) get_list_next
			(a22_saddle_list, comment_node);
		    }
		fprintf (hfp, "*/\n\n");
		break;

	    default:

		break;

	    }	/* end switch */
	}	/* end while */

/*	when done, print the endif, close the .h file, and print a success
	message */

    fprintf (hfp, "#endif\n");
    fclose (hfp);

    DEBUG2 (fprintf (stderr, "done building %s\n", h_file));
    return;

    }

void	acg_ada_code (file_part, mailbox_name, short_name, ill_short_name,
	    magic_number)
string	file_part,
	mailbox_name,
	short_name,
	ill_short_name,
	magic_number;

    {

    FILE	*afp;
    boolean	in_record = FALSE;
    char	record_name[33];		/* rCs */
    string	ada_file,
		getenv ();
    a22_saddle_node	*this_node,
			*comment_node,
			*id_pointer = NULL,
			*record_pointer;

/*	build .a file name and open it */

    ada_file = u22_concat_string (file_part, ADA_EXT, NULL);

    DEBUG2 (fprintf (stderr, "building %s\n", ada_file));

    afp = fopen (ada_file, "w");
    if (afp == NULL)
	{
	fprintf (stderr, "couldn't open %s\n", ada_file);
	exit (-1);
	}

/*	tell 'em which version of SADDLE this is */

    fprintf (afp, "-- %s\n\n", a22_saddle_magic_id);

/*	make sure the serpent data package is used */

    fprintf (afp, "with s_types;\n");
    fprintf (afp, "use s_types;\n\n");

/*	print out the executable instructions */

    this_node = (a22_saddle_node *) get_list_head (a22_saddle_list);
    fprintf (afp, "-- execution command:\t%s\n\n", this_node -> name);

/*	starting at the second node in the list, read in the type; if not
	appropriate for Ada, skip it, otherwise, write out the appropriate Ada
	equivalent; if we get past the bottom, close the output file, then
	stop */

    while ((this_node = (a22_saddle_node *) get_list_next (a22_saddle_list,
	this_node)) != NULL)
	{
	switch (this_node -> stype)

	    {

/*	for end_dd, just skip it */

	    case DD:

/*	declare the package name, and provide pointers to the mail box and
	.ill file for this sdd, and the magic number for this run */

		fprintf (afp, "package %s is \n\n", getenv ("DD_NAME"));
		fprintf (afp, "\tMAIL_BOX: constant string := \"%s\";\n",
		    mailbox_name);
		fprintf (afp, "\tILL_FILE: constant string := \"%s\";\n",
		    ill_short_name);
		fprintf (afp, "\tSERPENT_CONTROL_NUMBER: constant string ");
		fprintf (afp, ":= \"%s\";\n\n", magic_number);
		break;

	    case RECORD:

/*	declare the record; print out any inline comment; set a flag showing
	we're inside a record */

		fprintf (afp, "\ttype %s is record", this_node -> name);
/*
**  Save the reocrd name for later use.  - rCs
*/
		strncpy(record_name, this_node->name, 33);
		record_name[32] = '\0';

		comment_node = (a22_saddle_node *) get_list_next
		    (a22_saddle_list, this_node);
		if (comment_node -> stype == INLINE_COMMENT)
		    {
		    fprintf (afp, "\t-- %s", comment_node -> name);
		    this_node = comment_node;
		    }
		fprintf (afp, "\n");
		in_record = TRUE;
		break;

	    case END_RECORD:

/*	end the record; reset the flag to show we're not currently in a
	record */

		fprintf (afp, "\tend record;");

		comment_node = (a22_saddle_node *) get_list_next
		    (a22_saddle_list, this_node);
		if (comment_node -> stype == INLINE_COMMENT)
		    {
		    fprintf (afp, "\t-- %s", comment_node -> name);
		    this_node = comment_node;
		    }
		fprintf (afp, "\n\n");
		in_record = FALSE;
/*
**  Add an access type to allow dynamic allocation of variables - rCs
*/
		fprintf(afp, "\ttype %s_ptr is access %s;\n\n", record_name,
			record_name);

		break;

	    case BOOLEAN:
	    case INTEGER:
	    case REAL:
	    case STRING:
	    case BUFFER:
	    case ID:

/*	if we're not in a record, this must be a scalar, so type; otherwise,
	component of an element */

		if (!in_record)
		    fprintf (afp, "\tsubtype %s is ", this_node -> name);
		else
		    fprintf (afp, "\t\t%s:\t", this_node -> name);
		if (this_node -> stype == BOOLEAN)
		    fprintf (afp, "integer;");
		else if (this_node -> stype == INTEGER)
		    fprintf (afp, "integer;");
		else if (this_node -> stype == REAL)

/* 	real must be 8 bytes */	

#ifdef hpux
		    fprintf (afp, "long_float;");
#else
		    fprintf (afp, "float;");
#endif
		else if (this_node -> stype == STRING)
		    fprintf (afp, "string (1..%d);", this_node -> size);
		else if (this_node -> stype == BUFFER)
		    fprintf (afp, "buffer;");
		else if (this_node -> stype == ID)
		    {
		    fprintf (afp, "id_type;");
		    id_pointer = this_node;
		    }
		comment_node = (a22_saddle_node *) get_list_next
		    (a22_saddle_list, this_node);
		if (comment_node -> stype == INLINE_COMMENT)
		    {
		    fprintf (afp, "\t-- %s\n", comment_node -> name);
		    this_node = comment_node;
		    }
		if (id_pointer != NULL)
		    {
		    if (id_pointer -> id_of == NULL)
			fprintf (afp, "\t-- (no element pointer)\n");
		    else
			fprintf (afp, "\t-- (ID OF %s)\n",
			    id_pointer -> id_of);
		    id_pointer = NULL;
		    }
		else if (this_node != comment_node)
		    fprintf (afp, "\n");
		if (!in_record)
		    fprintf (afp, "\n");
		break;

	    case COMMENT:

/*	pick up all the comments we find and put them between a single pair
	of comment delimiters */

		fprintf (afp, "-- %s\n", this_node -> name);
		comment_node = this_node;
		while (comment_node -> stype == COMMENT)
		    {
		    this_node = comment_node;
		    fprintf (afp, "-- %s\n", comment_node -> name);
		    comment_node = (a22_saddle_node *) get_list_next
			(a22_saddle_list, comment_node);
		    }
		fprintf (afp, "\n");
		break;

	    default:

		break;

	    }	/* end switch */
	}	/* end while */

/*	when done, finish the .a file, close it, and print a success message */

    fprintf (afp, "end %s;\n", getenv ("DD_NAME"));
    fclose (afp);
    DEBUG2 (fprintf (stderr, "done building %s\n", ada_file));
    return;

    }

void	acg_ill_code (file_part, mailbox_name, short_name, ill_short_name,
	    language, magic_number)
string	file_part,
	short_name,
	mailbox_name,
	ill_short_name,
	language,
	magic_number;

    {

#define	THE	"the_"
#define	DOT	"."
#define	TIC	"'"
#define	H_EXT	".h"

    string	element_name,
		component_name,
		variable_name,
		variable_component_name,
		package_name,
		procedure_name,
		h_file,
		include_file,
		ill_file_temp2,
		getenv ();
    FILE	*cfp,
		*hfp,
		*t1fp;
    idd_data_types	ill_type;
    boolean	in_record = FALSE,
                c_language = TRUE;
    a22_saddle_node	*this_node;
    int		count = 0;

    if (strcmp (language, "c"))
        c_language = FALSE;

/*	build the names of the files that will be added to and open them */

    cfp = fopen (getenv ("SECOND_C"), "w");
    h_file = getenv ("SECOND_H");
    hfp = fopen (h_file, "w");
    t1fp = fopen (getenv ("ILL1"), "w");
    ill_file_temp2 = getenv ("ILL2");
    if (cfp == NULL || hfp == NULL || t1fp == NULL)
	{
	fprintf (stderr, "could not open an intermediate file; make sure\n");
	fprintf (stderr, "that you have write permission in this\n");
	fprintf (stderr, "directory and run saddle again\n");
	exit (-1);
	}

/*	print the header stuff for the first part of the ill file */

    fprintf (t1fp, "<<\n%s\n", a22_saddle_magic_id);
    fprintf (t1fp, "%s\n", magic_number);
    fprintf (t1fp, "%s\n", short_name);
    fprintf (t1fp, "%s\n", ill_short_name);
    fprintf (t1fp, "%s\n", mailbox_name);
    fprintf (t1fp, "%s_EXE\n", u22_convert_string (short_name, UPPERCASE));

    this_node = (a22_saddle_node *) get_list_head (a22_saddle_list);
    fprintf (t1fp, "%s\n|||\n", this_node -> name);
    fclose (t1fp);

    DEBUG2 (fprintf (stderr, "building ill file generator\n"));

/*	the .ill file will be created by the program, and the .h file will
	be included by it */

    include_file = u22_concat_string (file_part, H_EXT, NULL);

    if (c_language)
        {
/*	standard includes for a serpent program */

        fprintf (cfp, "#include\t<stdio.h>\n");
        fprintf (cfp, "#include\t\"serpent.h\"\n");
        fprintf (cfp, "#include\t\"string.h\"\n");

/*	include the SADDLE generated C declarations; include the file that
	will hold the variable declarations for each element */

        fprintf (cfp, "#include\t\"%s\"\n", include_file);
        fprintf (cfp, "#include\t\"%s\"\n\n", h_file);

/*	start the program; open the temp2 file; print appropriate messages */

        fprintf (cfp, "main ()\n{\n");
        fprintf (cfp, "char *rec_name;\n");
        fprintf (cfp, "caddr_t rec_addr;\n");
        fprintf (cfp, "FILE\t*ifp = fopen (\"%s\", \"w\");\n", ill_file_temp2);
        fprintf (cfp, "struct diddle {int type; char *name; caddr_t addr;\n");
	fprintf (cfp, "int size; int ill; };\n");
        fprintf (cfp, "struct diddle *dp;\n");
        fprintf (cfp, "static struct diddle diddle[] = {\n");
        fprintf (hfp, "/* all of the record types */\n\n");
        }

    else
        {
/*      start the ada program */

	fprintf (cfp, "with System; use System;\n");
        fprintf (cfp, "with Text_IO; use Text_IO;\n");
	fprintf (cfp, "with S_Types; use S_Types;\n\n");
        fprintf (cfp, "with %s; use %s;\n", short_name, short_name);
	package_name = u22_concat_string (THE, short_name, NULL);
	fprintf (cfp, "with %s; use %s;\n\n", package_name, package_name);
	procedure_name = getenv ("PROCEDURE_NAME");
        fprintf (cfp, "procedure %s is\n\n", procedure_name);
        fprintf (cfp, "\tpackage Int_IO is new Integer_IO(integer); ");
        fprintf (cfp, "use Int_IO;\n");
	fprintf (cfp, "\tft:\tfile_type;\n\tfm:\tfile_mode := out_file;\n");
        fprintf (cfp, "begin\n\n");
	fprintf (cfp, "create (ft, fm, \"%s\", \"\");\nset_output (ft);\n",
	    ill_file_temp2);

	/* start the declarations file */

	fprintf (hfp, "with %s; use %s;\n\n", short_name, short_name);
	fprintf (hfp, "package %s is\n\n", package_name);
        }

    while ((this_node = (a22_saddle_node *) get_list_next (a22_saddle_list,
	this_node)) != NULL) {
	component_name = u22_copy_string (this_node -> name);
	switch (this_node -> stype) {
	    case RECORD:

/*	element name is the name in the saddle record; to make the variable
	name, add 'the_' to the front of the element name; when it's a record
	declaration, variable component name is equal to variable name; print
	the declaration in the .h file; show that we're in a record */

		element_name = u22_copy_string (this_node -> name);
		variable_name = u22_concat_string (THE, element_name, NULL);
		variable_component_name = u22_copy_string (variable_name);
		if (c_language)
		    fprintf (hfp, "\t%s\t%s;\n", element_name, variable_name);
		else
		    fprintf (hfp, "\t%s:\t%s;\n", variable_name, element_name);
		ill_type = idd_record;
		in_record = TRUE;
		break;

	    case END_RECORD:

/*	jump out of the record */

		in_record = FALSE;
		break;

	    case BOOLEAN:
	    case INTEGER:
	    case REAL:
	    case STRING:
	    case BUFFER:
	    case ID:

/*	if we're not in a record, this is a scalar; compute element name,
	component name, and variable component name as in RECORD */

		if (!in_record)
		    {
		    element_name = u22_copy_string (component_name);
		    variable_name = u22_concat_string (THE, element_name,
			NULL);
		    variable_component_name = u22_copy_string (variable_name);
		    if (c_language)
		        fprintf (hfp, "\t%s\t%s;\n", element_name,
			    variable_name);
		    else
		        fprintf (hfp, "\t%s:\t%s;\n", variable_name,
			    element_name);
		    }
		else

/*	if we are in a record, append the component name onto the variable
	name (with a DOT in between) to get the variable component name */

		    variable_component_name = u22_concat_string
		        (variable_name, DOT, component_name, NULL);

/*	set the type */

		if (this_node -> stype == INTEGER)
		    ill_type = idd_integer;
		else if (this_node -> stype == REAL)
		    ill_type = idd_real;
		else if (this_node -> stype == STRING)
		    ill_type = idd_string;
		else if (this_node -> stype == BUFFER)
		    ill_type = idd_buffer;
		else if (this_node -> stype == ID)
		    ill_type = idd_id;
		else if (this_node -> stype == BOOLEAN)
		    ill_type = idd_boolean;
		break;

	    default:

		break;

	    }	/* end switch */

	if (this_node -> stype == RECORD || this_node -> stype == INTEGER
	    || this_node -> stype == REAL || this_node -> stype == STRING
	    || this_node -> stype == BUFFER || this_node -> stype == ID
	    || this_node -> stype == BOOLEAN)

/*	print out the element name and component name (both in lower case);
	print out %d's for the rest of the fields in the ill file record */

	    {
	    count++;
	    if (c_language)
	        if (this_node -> stype == RECORD)
		    fprintf (cfp, "  { 0, \"%s\", ", element_name);
		else
		    fprintf (cfp, "  { 1, \"%s\", ", component_name);
	    else
	        if (this_node -> stype == RECORD)
		    {
		    fprintf (cfp, "text_io.put (\"%s \");\n", element_name);
		    fprintf (cfp, "text_io.put (\"%s \");\n", element_name);
		    }
		else
		    {
		    fprintf (cfp, "text_io.put (\"%s \");\n", element_name);
		    fprintf (cfp, "text_io.put (\"%s \");\n", component_name);
		    }

/*	this is where we compute the offset, from the address of the variable
	component name minus the address of the variable name (beginning of
	the record); if either of the names represents a string, append [0]
	to the end */

	    if (c_language)
	        {
	        fprintf (cfp, "(caddr_t)&%s", variable_component_name);
	        if (this_node -> stype == STRING)
		    fprintf (cfp, " [0]");

/*	finally, compute the size and print it and the type */

	        fprintf (cfp, ", sizeof(%s), ", variable_component_name);
	        fprintf (cfp, "%d },\n", ill_type);
	        }
	    else
	        {
		fprintf (cfp,
		    "int_io.put ((%s'address - %s'address));\n",
		    variable_component_name, variable_name);
		fprintf (cfp, "int_io.put ((%s'size) / storage_unit);\n",
		    variable_component_name);
		fprintf (cfp, "text_io.put_line (\" %d\");\n", ill_type);
	        }
	    }
	}	/* end while */

/*	close the .ill file in main and print out a success message */

    if (c_language)
        {
	fprintf (cfp, "};\n\n");
	fprintf (cfp, "for (dp = diddle; dp < &diddle[%d]; dp++) {\n", count);
	fprintf (cfp, "  if (dp->type == 0) {\n");
	fprintf (cfp, "    rec_name = dp->name;\n");
	fprintf (cfp, "    rec_addr = dp->addr;\n");
	fprintf (cfp, "    fprintf (ifp, \"%%s\\t%%s\\t0\", dp->name, dp->name);\n");
	fprintf (cfp, "    }\n");
	fprintf (cfp, "  else {\n");
	fprintf (cfp, "    fprintf (ifp, \"%%s\\t%%s\\t%%d\", rec_name, dp->name, dp->addr-rec_addr);\n");
	fprintf (cfp, "    }\n");
	fprintf (cfp, "  fprintf (ifp, \"\\t%%d\\t%%d\\n\", dp->size, dp->ill);\n");
	fprintf (cfp, "  }\n");
	fprintf (cfp, "fclose (ifp);\n");
	fprintf (cfp, "return (0);\n}\n");
        }

/*	close both ill generator files and print out a success message */

    else
        {
	fprintf (cfp, "close (ft);\n");
        fprintf (cfp, "end %s;\n", procedure_name);
	fprintf (hfp, "end %s;\n", package_name);
        }

    fclose (hfp);
    fclose (cfp);

    DEBUG2 (fprintf (stderr, "done building ill file generator\n"));

    return;

    }

