/* $Header: /u/04c/mnt/integ/source/six/include/RCS/sct.h,v 1.2 90/06/21 15:44:37 rnk Exp $ */

/*--------------------------------------------------------------------------*\
|
|  Name:
|	sct.h
|
|  Description:
|	The interface to the color table for Six.
|
|  Component of:
|	Six
|
|  Related files:
|	sct.c
|
|  Project:
|	SERPENT System
|	User Interface Prototyping
|	Software Engineering Institute
|	Carnegie Mellon University
|	Pittsburgh, PA  15213
|
|  Version:
|	1.0
|
|  Owner:  
|	Len Bass
|	ljb@sei.cmu.edu
|
|  Author:
|	Rick Kazman
|	rnk@sei.cmu.edu
|
|  Change History:
 $Log:	sct.h,v $
 * Revision 1.2  90/06/21  15:44:37  rnk
 * fixed header
 * 
 * Revision 1.1  90/06/21  13:55:51  rnk
 * Initial revision
 * 
\*--------------------------------------------------------------------------*\
|
|   Distribution: Approved for public release; distribution is unlimited.
|
|   Copyright (c) 1989  by  Carnegie  Mellon  University, Pittsburgh, PA.  The
|  Software Engineering  Institute  (SEI) is a federally  funded  research and
|  development center established  and  operated by Carnegie Mellon University
|  (CMU).  Sponsored  by  the  U.S.  Department  of   Defense  under  contract
|  F19628-85-C-0003,  the  SEI  is  supported  by  the  services  and  defense
|  agencies, with the U.S. Air Force as the executive contracting agent.
|
|    Permission to use,  copy,  modify, or  distribute  this  software and its
|  documentation for  any purpose and without fee  is hereby granted, provided
|  that  the above copyright notice appear  in  all copies and that both  that
|  copyright  notice  and   this  permission  notice  appear   in   supporting
|  documentation.   Further,  the  names  Software  Engineering  Institute  or
|  Carnegie  Mellon  University  may  not be used in  advertising or publicity
|  pertaining to distribution of the software without specific, written  prior
|  permission.  CMU makes no claims  or representations  about the suitability
|  of this software for any purpose.  This software is provided "as is" and no
|  warranty,  express  or  implied,  is  made  by  the  SEI  or CMU, as to the
|  accuracy  and  functioning of the program and related program material, nor
|  shall   the  fact of  distribution   constitute  any   such  warranty.   No
|  responsibility is assumed by the SEI or CMU in connection herewith.
|
\*--------------------------------------------------------------------------*/

#ifndef sct_H
#define sct_H

/*--------------------------------------------------------------------------*\
|  Name: sct_make_color_table
|
|  Description:
|	sct_make_color_table constructs a hash table of XColor structures
|	which match the string color names in the array color_names. The table
|	key is the string itself. The hash table is called x_color_table. This
|	is a global variable which is changed by this function.
|
\*  Syntax:                                                                 */
	void sct_make_color_table (
	/*	NONE
	*/
	);
/*                                                                          *\
|  Parameters: None.
|
|  Returns: Nothing.
\*--------------------------------------------------------------------------*/

/*--------------------------------------------------------------------------*
|  Name: sct_get_pixel
|
|  Description:
|	sct_get_pixel retrieves the pixel value for a color from
|	xt_color_table. If the color does not exist, it returns (NULL).
|
\*  Syntax:                                                                 */
	Pixel	sct_get_pixel (
	/*
		color_name:	in	*char
	*/);
/*                                                                          *\
|  Parameters:
|	color_name	the color for which the user needs the pixel value.
|
|  Returns: XColor value of the color or NULL
\*--------------------------------------------------------------------------*/

#endif
