/* $Header: /u/04c/mnt/integ/source/six/include/RCS/six_meth.h,v 1.1 90/08/02 16:22:25 rnk Exp $ */

/*--------------------------------------------------------------------------*\
|
|  Name:
|	six_meth.h
|
|  Description:
|	Random declarations needed for methods code
|
|  Component of:
|	Six
|
|  Related files:
|	move.c resize.c notify.c etc.
|
|  Project:
|	SERPENT System
|	User Interface Prototyping
|	Software Engineering Institute
|	Carnegie Mellon University
|	Pittsburgh, PA  15213
|
|  Version:
|	1.0
|
|  Owner:  
|	Len Bass
|	ljb@sei.cmu.edu
|
|  Author:
|	Rick Kazman
|	rnk@sei.cmu.edu
|
|  Change History:
 $Log:	six_meth.h,v $
 * Revision 1.1  90/08/02  16:22:25  rnk
 * Initial revision
 *  
\*--------------------------------------------------------------------------*\
|
|   Distribution: Approved for public release; distribution is unlimited.
|
|   Copyright (c) 1989  by  Carnegie  Mellon  University, Pittsburgh, PA.  The
|  Software Engineering  Institute  (SEI) is a federally  funded  research and
|  development center established  and  operated by Carnegie Mellon University
|  (CMU).  Sponsored  by  the  U.S.  Department  of   Defense  under  contract
|  F19628-85-C-0003,  the  SEI  is  supported  by  the  services  and  defense
|  agencies, with the U.S. Air Force as the executive contracting agent.
|
|    Permission to use,  copy,  modify, or  distribute  this  software and its
|  documentation for  any purpose and without fee  is hereby granted, provided
|  that  the above copyright notice appear  in  all copies and that both  that
|  copyright  notice  and   this  permission  notice  appear   in   supporting
|  documentation.   Further,  the  names  Software  Engineering  Institute  or
|  Carnegie  Mellon  University  may  not be used in  advertising or publicity
|  pertaining to distribution of the software without specific, written  prior
|  permission.  CMU makes no claims  or representations  about the suitability
|  of this software for any purpose.  This software is provided "as is" and no
|  warranty,  express  or  implied,  is  made  by  the  SEI  or CMU, as to the
|  accuracy  and  functioning of the program and related program material, nor
|  shall   the  fact of  distribution   constitute  any   such  warranty.   No
|  responsibility is assumed by the SEI or CMU in connection herewith.
|
\*--------------------------------------------------------------------------*/

/* User defines and includes */
#include <stdio.h>
#define MAX_BOX_VECTORS         4
#define UL                      0
#define UR                      1
#define LL                      2
#define LR                      3
#define DrawBox() XDrawSegments(display, parent_win, DrawGC, box, num_vectors)
#define EVENTMASK (ButtonPressMask | ButtonReleaseMask | PointerMotionMask)
extern  Display *display;
extern  Cursor  ArrowCrossCursor ;
extern  GC      DrawGC ;

/* Store the vertices for the boundary box in a vertex list. 	  */
/* This code was taken from the uwm source and slightly modified. */
int StoreBox(box, ulx, uly, lrx, lry)
register XSegment box[];
int ulx, uly, lrx, lry ;
{
    box[0].x1 = ulx; box[0].y1 = uly; box[0].x2 = lrx; box[0].y2 = uly;
    box[1].x1 = lrx; box[1].y1 = uly; box[1].x2 = lrx; box[1].y2 = lry;
    box[2].x1 = lrx; box[2].y1 = lry; box[2].x2 = ulx; box[2].y2 = lry;
    box[3].x1 = ulx; box[3].y1 = lry; box[3].x2 = ulx; box[3].y2 = uly;
    return(4);
}
