/* $Header: /u/04c/mnt/integ/source/six/src/RCS/asend.c,v 1.5 90/10/10 18:08:35 rnk Exp $ */

/*--------------------------------------------------------------------------*\
|
|  Name:
|	asend.c
|
|  Description:
|	Athena send method code
|
|  Component of:
|	Six
|
|  Related files:
|	move.c resize.c notify.c etc.
|
|  Project:
|	SERPENT System
|	User Interface Prototyping
|	Software Engineering Institute
|	Carnegie Mellon University
|	Pittsburgh, PA  15213
|
|  Version:
|	1.0
|
|  Owner:  
|	Len Bass
|	ljb@sei.cmu.edu
|
|  Author:
|	Rick Kazman
|	rnk@sei.cmu.edu
|
|  Change History:
 $Log:	asend.c,v $
 * Revision 1.5  90/10/10  18:08:35  rnk
 * changed text_buffer to textbuffer
 * 
 * Revision 1.4  90/10/09  17:07:38  rnk
 * no change
 * 
 * Revision 1.3  90/08/13  19:15:39  rnk
 * changed method name to "send"
 * 
 * Revision 1.2  90/08/08  11:49:25  rnk
 * fixed routine to return buffers
 *  
\*--------------------------------------------------------------------------*\
|
|   Distribution: Approved for public release; distribution is unlimited.
|
|   Copyright (c) 1989  by  Carnegie  Mellon  University, Pittsburgh, PA.  The
|  Software Engineering  Institute  (SEI) is a federally  funded  research and
|  development center established  and  operated by Carnegie Mellon University
|  (CMU).  Sponsored  by  the  U.S.  Department  of   Defense  under  contract
|  F19628-85-C-0003,  the  SEI  is  supported  by  the  services  and  defense
|  agencies, with the U.S. Air Force as the executive contracting agent.
|
|    Permission to use,  copy,  modify, or  distribute  this  software and its
|  documentation for  any purpose and without fee  is hereby granted, provided
|  that  the above copyright notice appear  in  all copies and that both  that
|  copyright  notice  and   this  permission  notice  appear   in   supporting
|  documentation.   Further,  the  names  Software  Engineering  Institute  or
|  Carnegie  Mellon  University  may  not be used in  advertising or publicity
|  pertaining to distribution of the software without specific, written  prior
|  permission.  CMU makes no claims  or representations  about the suitability
|  of this software for any purpose.  This software is provided "as is" and no
|  warranty,  express  or  implied,  is  made  by  the  SEI  or CMU, as to the
|  accuracy  and  functioning of the program and related program material, nor
|  shall   the  fact of  distribution   constitute  any   such  warranty.   No
|  responsibility is assumed by the SEI or CMU in connection herewith.
|
\*--------------------------------------------------------------------------*/

    isd_trans trans;
    String text_buffer ;
    idd_buffer_type *temp_buffer ;
    Arg buf_args[1] ;
    int n = 0 ;
    INST *inst = glue_get_by_widget (w);

    XtSetArg(buf_args[n], XtNstring, &text_buffer) ; 
    n++;
    XtGetValues(w, buf_args, n) ;

    temp_buffer = (idd_buffer_type *) make_node(sizeof(idd_buffer_type));
    temp_buffer->length = strlen(text_buffer) + 1 ;
    temp_buffer->type = idd_string;
    temp_buffer->body = (caddr_t) u22_copy_string(text_buffer);

    /* Start the transation */
    trans = isd_start_transaction ();

    isd_put_shared_data (trans, inst->id, inst->template->name, 
			 "method", "send");
    isd_put_shared_data (trans, inst->id, inst->template->name, 
 			 "textbuffer", temp_buffer);

    /* Commit the transation */
    isd_commit_transaction (trans);

    free_node(temp_buffer->body) ;
    free_node(temp_buffer) ; 
