static char rcsid[] = "$Header: /u/04c/mnt/integ/source/six/src/RCS/sac.c,v 1.13 91/03/27 22:07:57 ejh Exp $" ;

/*--------------------------------------------------------------------------*\
|
|  Name:
|	Sac.c
|
|  Description:
|	This contains the check routines for Athena widgets.
|
|  Component of:
|	Six
|
|  Related files:
|	lots
|
|  Project:
|	SERPENT System
|	User Interface Prototyping
|	Software Engineering Institute
|	Carnegie Mellon University
|	Pittsburgh, PA  15213
|
|  Version:
|	1.0
|
|  Owner:  
|	Len Bass
|	ljb@sei.cmu.edu
|
|  Author:
|	Rick Kazman
|	rnk@sei.cmu.edu
|
|  Change History:
  $Log:	sac.c,v $
 * Revision 1.13  91/03/27  22:07:57  ejh
 * took out unused buf_attr in check_ABboard
 * 
 * Revision 1.12  91/03/27  22:04:58  ejh
 * took out unused variable called exit
 * 
 * Revision 1.11  90/11/13  15:18:02  rnk
 * changed screen_object to screenobject
 * 
 * Revision 1.10  90/10/12  15:09:49  rnk
 * *** empty log message ***
 * 
 * Revision 1.9  90/10/09  17:13:04  rnk
 * renamed serpent attributes to new standards
 * 
 * Revision 1.8  90/10/01  12:29:52  rnk
 * changed check routines to use XGetWIndowAttributes to find the size
 * of the current widget (because XtGetValues doesn't return the right
 * value if an attribute has defaulted).
 * 
 * Revision 1.7  90/08/23  20:41:37  rnk
 * remove geometry management from XtMoveWidget calls
 * 
 * Revision 1.6  90/08/21  21:52:26  rnk
 * added code to move/resize bboard widgets, and to set vertDistance and
 * horizDistance when x and y have changed.
 * 
 * Revision 1.5  90/08/20  10:00:26  rnk
 * added check routines for Label and Command widgets
 * 
 * Revision 1.4  90/08/17  17:43:02  rnk
 * fixed bug in check_ABboard and modified check_Screen to not send a
 * method to the dialog
 * 
 * Revision 1.3  90/08/15  17:10:18  rnk
 * added check_Screen routine
 * 
 * Revision 1.2  90/08/14  13:11:51  rnk
 * changed includes to get rid of warnings
 * 
 * Revision 1.1  90/08/13  19:18:35  rnk
 * Initial revision
 * 
/*--------------------------------------------------------------------------*\
|
|   Distribution: Approved for public release; distribution is unlimited.
|
|   Copyright (c) 1989  by  Carnegie  Mellon  University, Pittsburgh, PA.  The
|  Software Engineering  Institute  (SEI) is a federally  funded  research and
|  development center established  and  operated by Carnegie Mellon University
|  (CMU).  Sponsored  by  the  U.S.  Department  of   Defense  under  contract
|  F19628-85-C-0003,  the  SEI  is  supported  by  the  services  and  defense
|  agencies, with the U.S. Air Force as the executive contracting agent.
|
|    Permission to use,  copy,  modify, or  distribute  this  software and its
|  documentation for  any purpose and without fee  is hereby granted, provided
|  that  the above copyright notice appear  in  all copies and that both  that
|  copyright  notice  and   this  permission  notice  appear   in   supporting
|  documentation.   Further,  the  names  Software  Engineering  Institute  or
|  Carnegie  Mellon  University  may  not be used in  advertising or publicity
|  pertaining to distribution of the software without specific, written  prior
|  permission.  CMU makes no claims  or representations  about the suitability
|  of this software for any purpose.  This software is provided "as is" and no
|  warranty,  express  or  implied,  is  made  by  the  SEI  or CMU, as to the
|  accuracy  and  functioning of the program and related program material, nor
|  shall   the  fact of  distribution   constitute  any   such  warranty.   No
|  responsibility is assumed by the SEI or CMU in connection herewith.
|
\*--------------------------------------------------------------------------*/

#include	<stdio.h>
#include	<X11/Intrinsic.h>

#include	<X11/Xaw/Label.h>
#include	<X11/Xaw/Form.h> 

#include	"glueXt.h"
#include	"hashPack.h"	/* Hash table includes */
#include	"isd.h"
#include	"glue_intf.h"
#include	"glue_inst.h"
#include	"six.h"

/* Screen definitions created in Six.c */
extern int screen ;
extern boolean	is_color ;
extern int screen_height, screen_width ;
extern Display *display ;

/*=========================================================================*\
 * check_ACommand is the check routine for the Athena Command widget.  It 
 * performs non-standard actions to support text widget operations.
\*=========================================================================*/
void check_ACommand(widget_inst, change, change_list) 
     INST *widget_inst ;
     isd_change_type change ;
     LIST change_list;
{
  ATTR *x_attr, *y_attr, *h_attr, *w_attr, *bw_attr ;
  Arg local_args[10] ;
  XWindowAttributes w_info;

  SIX_DEBUG1(fprintf (stderr, "check_ACommand: entering\n")) ;

  if (change == isd_modify)
    {
      if (!XGetWindowAttributes(display,XtWindow(widget_inst->widget),&w_info))
        fprintf(stderr, "check_ACommand:  Can't get window attributes\n") ;

      x_attr = glue_get_attr_from_instance(widget_inst, "x", SERP_NAMES) ;
      y_attr = glue_get_attr_from_instance(widget_inst, "y", SERP_NAMES) ;
      h_attr = glue_get_attr_from_instance(widget_inst, "height", SERP_NAMES) ;
      w_attr = glue_get_attr_from_instance(widget_inst, "width", SERP_NAMES) ;
      bw_attr = glue_get_attr_from_instance(widget_inst, "borderwidth", 
					    SERP_NAMES) ;
      
      if ((x_attr->value.i != w_info.x && x_attr->val_type==VAL_CURRENT) 
	  || (y_attr->value.i != w_info.y && y_attr->val_type == VAL_CURRENT))
	  XtMoveWidget(widget_inst->widget, x_attr->value.i, y_attr->value.i) ;

      if ((h_attr->value.i !=w_info.height && h_attr->val_type==VAL_CURRENT) ||
	  (w_attr->value.i !=w_info.width && w_attr->val_type== VAL_CURRENT) ||
	  (bw_attr->value.i != w_info.border_width && 
	   bw_attr->val_type == VAL_CURRENT))
	XtResizeWidget(widget_inst->widget, w_attr->value.i, 
		       h_attr->value.i, bw_attr->value.i) ;
    }


  SIX_DEBUG1(fprintf (stderr, "check_ACommand: leaving\n")) ;

}


/*=========================================================================*\
 * check_ALabel is the check routine for the Athena Text widget.  It 
 * performs non-standard actions to support text widget operations.
\*=========================================================================*/
void check_ALabel(widget_inst, change, change_list) 
     INST *widget_inst ;
     isd_change_type change ;
     LIST change_list;
{
  ATTR *x_attr, *y_attr, *h_attr, *w_attr, *bw_attr ;
  Arg local_args[10] ;
  XWindowAttributes w_info;

  SIX_DEBUG1(fprintf (stderr, "check_ALabel: entering\n")) ;

  if (change == isd_modify)
    {
      if (!XGetWindowAttributes(display,XtWindow(widget_inst->widget),&w_info))
        fprintf(stderr, "check_ALabel:  Can't get window attributes\n") ;

      x_attr = glue_get_attr_from_instance(widget_inst, "x", SERP_NAMES) ;
      y_attr = glue_get_attr_from_instance(widget_inst, "y", SERP_NAMES) ;
      h_attr = glue_get_attr_from_instance(widget_inst, "height", SERP_NAMES) ;
      w_attr = glue_get_attr_from_instance(widget_inst, "width", SERP_NAMES) ;
      bw_attr = glue_get_attr_from_instance(widget_inst, "borderwidth", 
					    SERP_NAMES) ;
      
      if ((x_attr->value.i != w_info.x && x_attr->val_type==VAL_CURRENT) 
	  || (y_attr->value.i != w_info.y && y_attr->val_type == VAL_CURRENT))
	  XtMoveWidget(widget_inst->widget, x_attr->value.i, y_attr->value.i) ;

      if ((h_attr->value.i !=w_info.height && h_attr->val_type==VAL_CURRENT) ||
	  (w_attr->value.i !=w_info.width && w_attr->val_type== VAL_CURRENT) ||
	  (bw_attr->value.i != w_info.border_width && 
	   bw_attr->val_type == VAL_CURRENT))
	XtResizeWidget(widget_inst->widget, w_attr->value.i, 
		       h_attr->value.i, bw_attr->value.i) ;
    }

  SIX_DEBUG1(fprintf (stderr, "check_ALabel: leaving\n")) ;
}


/*=========================================================================*\
 * check_AText is the check routine for the Athena Text widget.  It 
 * performs non-standard actions to support text widget operations.
\*=========================================================================*/
void check_AText(widget_inst, change, change_list) 
     INST *widget_inst ;
     isd_change_type change ;
     LIST change_list;
{
  ATTR *x_attr, *y_attr, *h_attr, *w_attr, *bw_attr, *buf_attr ;
  Arg local_args[10] ;
  XWindowAttributes w_info;

  SIX_DEBUG1(fprintf (stderr, "check_AText: entering\n")) ;

  if (change == isd_modify)
    {
      if (!XGetWindowAttributes(display,XtWindow(widget_inst->widget),&w_info))
        fprintf(stderr, "check_AText:  Can't get window attributes\n") ;

      x_attr = glue_get_attr_from_instance(widget_inst, "x", SERP_NAMES) ;
      y_attr = glue_get_attr_from_instance(widget_inst, "y", SERP_NAMES) ;
      h_attr = glue_get_attr_from_instance(widget_inst, "height", SERP_NAMES) ;
      w_attr = glue_get_attr_from_instance(widget_inst, "width", SERP_NAMES) ;
      bw_attr = glue_get_attr_from_instance(widget_inst, "borderwidth", 
					    SERP_NAMES) ;
      
      buf_attr = glue_get_attr_from_instance(widget_inst, "sendbuffer", 
					     SERP_NAMES) ;

      if ((x_attr->value.i != w_info.x && x_attr->val_type==VAL_CURRENT) 
	  || (y_attr->value.i != w_info.y && y_attr->val_type == VAL_CURRENT))
	  XtMoveWidget(widget_inst->widget, x_attr->value.i, y_attr->value.i) ;

      if ((h_attr->value.i !=w_info.height && h_attr->val_type==VAL_CURRENT) ||
	  (w_attr->value.i !=w_info.width && w_attr->val_type== VAL_CURRENT) ||
	  (bw_attr->value.i != w_info.border_width && 
	   bw_attr->val_type == VAL_CURRENT))
	XtResizeWidget(widget_inst->widget, w_attr->value.i, 
		       h_attr->value.i, bw_attr->value.i) ;

      if (change == isd_modify && buf_attr->value.i == TRUE) 
	asend(widget_inst->widget, NULL, NULL, NULL) ;
    }

  SIX_DEBUG1(fprintf (stderr, "check_AText: leaving\n")) ;
}


/*=========================================================================*\
 * check_ABboard is the check routine for the bboard implementation of the
 * Athena form widget.  It adds a "weight" widget to the bottom, right
 * hand corner of the form and makes sure that the weight is the same
 * color as the form.
\*=========================================================================*/
void check_ABboard(widget_inst, change, change_list) 
     INST *widget_inst ;
     isd_change_type change ;
     LIST change_list;
{
  static Widget weight ;
  ATTR *x_attr, *y_attr, *h_attr, *w_attr, *bw_attr, *b_attr ;
  int n ;
  Arg local_args[10] ;
  string component_name ;
  Pixel color ;
  XWindowAttributes w_info;

  SIX_DEBUG1(fprintf (stderr, "check_ABboard: entering\n")) ;

  if (change == isd_create && widget_inst->widget != NULL)
    {
      /* Get the height and width of the container form */
      h_attr = glue_get_attr_from_instance(widget_inst, "height", SERP_NAMES) ;
      w_attr = glue_get_attr_from_instance(widget_inst, "width", SERP_NAMES) ;
      b_attr = glue_get_attr_from_instance(widget_inst, "background", 
					   SERP_NAMES) ;

      /* Set the weight widget's attributes */
      n = 0 ;
      XtSetArg(local_args[n], XtNhorizDistance, w_attr->value.i-1); n++;
      XtSetArg(local_args[n], XtNvertDistance, h_attr->value.i-1);  n++;
      XtSetArg(local_args[n], XtNwidth, 1) ; n++;
      XtSetArg(local_args[n], XtNheight, 1); n++;
      XtSetArg(local_args[n], XtNborderWidth, 0) ; n++;
      if (b_attr->value.s != NULL) 
	{
	  color = sct_get_pixel(b_attr->value.s) ;
	  if (color != BAD_COLOR) 
	    {
	      XtSetArg(local_args[n], XtNbackground, color); 
	      n++;
	    }
	}
      weight = XtCreateManagedWidget("", labelWidgetClass,
				     widget_inst->widget, local_args, n);
    }

  if (change == isd_modify)
    {
      if (!XGetWindowAttributes(display,XtWindow(widget_inst->widget),&w_info))
        fprintf(stderr, "check_ABboard:  Can't get window attributes\n") ;

      component_name = get_list_next(change_list, NULL);

      while (component_name != NULL)
	  if (!strcmp(component_name, "background"))
	    {
	      b_attr = glue_get_attr_from_instance(widget_inst, component_name,
						   SERP_NAMES) ;
	      color = sct_get_pixel(b_attr->value.s) ;
	      if (color != BAD_COLOR) 
		{
		  n = 0 ;
		  XtSetArg(local_args[n], XtNbackground, color); 
		  n++;
		  XtSetValues (widget_inst->widget, local_args, n);
		}
	      break ;
	    }
	  else
	    component_name = get_list_next(change_list, component_name);

      x_attr = glue_get_attr_from_instance(widget_inst, "x", SERP_NAMES) ;
      y_attr = glue_get_attr_from_instance(widget_inst, "y", SERP_NAMES) ;
      h_attr = glue_get_attr_from_instance(widget_inst, "height", SERP_NAMES) ;
      w_attr = glue_get_attr_from_instance(widget_inst, "width", SERP_NAMES) ;
      bw_attr = glue_get_attr_from_instance(widget_inst, "borderwidth", 
					    SERP_NAMES) ;

      if ((x_attr->value.i != w_info.x && x_attr->val_type==VAL_CURRENT) 
	  || (y_attr->value.i != w_info.y && y_attr->val_type == VAL_CURRENT))
	  XtMoveWidget(widget_inst->widget, x_attr->value.i, y_attr->value.i) ;

      if ((h_attr->value.i !=w_info.height && h_attr->val_type==VAL_CURRENT) ||
	  (w_attr->value.i !=w_info.width && w_attr->val_type== VAL_CURRENT) ||
	  (bw_attr->value.i != w_info.border_width && 
	   bw_attr->val_type == VAL_CURRENT))
	XtResizeWidget(widget_inst->widget, w_attr->value.i, 
		       h_attr->value.i, bw_attr->value.i) ;
    }

  SIX_DEBUG1(fprintf (stderr, "check_ABboard: leaving\n")) ;

}

/*=========================================================================*\
 * check_Screen is the check routine for the Screen object.  It 
 * sends screen info to the dialogue.
\*=========================================================================*/
void check_Screen(inst, change, change_list) 
     INST *inst ;
     isd_change_type change ;
     LIST change_list;
{
  isd_trans trans;

  SIX_DEBUG1(fprintf (stderr, "check_Screen: entering\n")) ;

  if (inst->widget != NULL)
    {
      /* Start the transation */
      trans = isd_start_transaction ();

      isd_put_shared_data(trans, inst->id, "screenobject", "screen", 
			  &screen);
      isd_put_shared_data(trans, inst->id, "screenobject", "display", 
			  display);
      isd_put_shared_data(trans, inst->id, "screenobject", "color", 
			  &is_color);
      isd_put_shared_data(trans, inst->id, "screenobject", "height", 
			  &screen_height);
      isd_put_shared_data(trans, inst->id, "screenobject", "width", 
			  &screen_width);

      /* Commit the transation */
      isd_commit_transaction (trans);
    }

  SIX_DEBUG1(fprintf (stderr, "check_Screen: leaving\n")) ;
}
