/* $Header: /u/04c/mnt/integ/source/six/src/RCS/select1.c,v 1.4 90/10/12 15:09:26 rnk Exp $ */

/*--------------------------------------------------------------------------*\
|
|  Name:
|	select1.c
|
|  Description:
|	Select method code
|
|  Component of:
|	Six
|
|  Related files:
|	move.c resize.c notify.c etc.
|
|  Project:
|	SERPENT System
|	User Interface Prototyping
|	Software Engineering Institute
|	Carnegie Mellon University
|	Pittsburgh, PA  15213
|
|  Version:
|	1.0
|
|  Owner:  
|	Len Bass
|	ljb@sei.cmu.edu
|
|  Author:
|	Rick Kazman
|	rnk@sei.cmu.edu
|
|  Change History:
 $Log:	select1.c,v $
 * Revision 1.4  90/10/12  15:09:26  rnk
 * changed attribute names to new style (no underscores)
 * 
 * Revision 1.3  90/10/10  18:08:57  rnk
 * changed attribute names to new format
 * 
 * Revision 1.2  90/10/09  17:09:04  rnk
 * Renamed serpent attributes
 * 
 * Revision 1.1  90/08/13  15:24:34  rnk
 * Initial revision
 *  
\*--------------------------------------------------------------------------*\
|
|   Distribution: Approved for public release; distribution is unlimited.
|
|   Copyright (c) 1989  by  Carnegie  Mellon  University, Pittsburgh, PA.  The
|  Software Engineering  Institute  (SEI) is a federally  funded  research and
|  development center established  and  operated by Carnegie Mellon University
|  (CMU).  Sponsored  by  the  U.S.  Department  of   Defense  under  contract
|  F19628-85-C-0003,  the  SEI  is  supported  by  the  services  and  defense
|  agencies, with the U.S. Air Force as the executive contracting agent.
|
|    Permission to use,  copy,  modify, or  distribute  this  software and its
|  documentation for  any purpose and without fee  is hereby granted, provided
|  that  the above copyright notice appear  in  all copies and that both  that
|  copyright  notice  and   this  permission  notice  appear   in   supporting
|  documentation.   Further,  the  names  Software  Engineering  Institute  or
|  Carnegie  Mellon  University  may  not be used in  advertising or publicity
|  pertaining to distribution of the software without specific, written  prior
|  permission.  CMU makes no claims  or representations  about the suitability
|  of this software for any purpose.  This software is provided "as is" and no
|  warranty,  express  or  implied,  is  made  by  the  SEI  or CMU, as to the
|  accuracy  and  functioning of the program and related program material, nor
|  shall   the  fact of  distribution   constitute  any   such  warranty.   No
|  responsibility is assumed by the SEI or CMU in connection herewith.
|
\*--------------------------------------------------------------------------*/

    isd_trans trans;
    INST *inst = glue_get_by_widget (w);
    ATTR *selected_x = glue_get_attr_from_instance (inst, "selectedx", 
						    SERP_NAMES);
    ATTR *selected_y = glue_get_attr_from_instance (inst, "selectedy", 
						    SERP_NAMES);
    Window window, sub_window ;		/* Current windows */
    Window root;                        /* Root query window. */
    int ptrmask;                        /* pointer status word */
    int root_x, root_y;                 /* root window coordinates */
    int cur_x, cur_y;                   /* current pointer position */

    window = XtWindow(w) ;

    /* Find the position of the pointer */
    XQueryPointer(display, window, &root, &sub_window,
                &root_x, &root_y, &cur_x, &cur_y, &ptrmask);
    selected_x->value.i = cur_x ;
    selected_y->value.i = cur_y ;

    /* Send this position to the interface */
    trans = isd_start_transaction ();

    /* Send the method name */
    isd_put_shared_data (trans, inst->id, inst->template->name, "method", 
			 "select");

    /* Send the changed attributes */
    isd_put_shared_data (trans, inst->id, inst->template->name, "selectedx", 
			 &selected_x->value.i);
    isd_put_shared_data (trans, inst->id, inst->template->name, "selectedy", 
			 &selected_y->value.i);

    /* Commit the transation */
    isd_commit_transaction (trans);


