static char rcsid[] = "$Header: /usr/users/rnk/serpent/source/six/src/RCS/smc.c,v 1.14 1991/06/14 02:35:51 rnk Exp $" ;

/*--------------------------------------------------------------------------*\
|
|  Name:
|	Smc.c
|
|  Description:
|	This contains the check routines for Motif widgets.
|
|  Component of:
|	Six
|
|  Related files:
|	lots
|
|  Project:
|	SERPENT System
|	User Interface Prototyping
|	Software Engineering Institute
|	Carnegie Mellon University
|	Pittsburgh, PA  15213
|
|  Version:
|	1.0
|
|  Owner:  
|	Len Bass
|	ljb@sei.cmu.edu
|
|  Author:
|	Rick Kazman
|	rnk@sei.cmu.edu
|
|  Change History:
  $Log: smc.c,v $
 * Revision 1.14  1991/06/14  02:35:51  rnk
 * added the check routine check_mBtn
 *
 * Revision 1.13  1991/03/14  13:44:12  rnk
 * added check routines for Dialog boxes and FileSelectionBox.  Also,
 * changed the parameters to check routines to include the widget's
 * arglist.
 *
 * Revision 1.12  91/02/27  16:33:53  rnk
 * changed scale_callback to return the method "value_changed"
 * 
 * Revision 1.11  91/02/20  16:19:54  rnk
 * added toggle_callback
 * 
 * Revision 1.10  91/01/07  17:34:11  rnk
 * removed check_MsgBox routine
 * 
 * Revision 1.9  90/12/21  11:30:29  rnk
 * added check routine for Message Box and callback for Scrollbar
 * 
 * Revision 1.8  90/11/13  15:18:32  rnk
 * changed screen_object to screenobject
 * 
 * Revision 1.7  90/11/12  18:20:08  rnk
 * added check_MainW routine
 * 
 * Revision 1.6  90/10/25  22:23:48  rnk
 * added scale_callback routine
 * 
 * Revision 1.5  90/10/12  15:10:14  rnk
 * changed attribute names to new style (no underscores)
 * 
 * Revision 1.4  90/10/04  13:48:55  rnk
 * added check_Popup and PopupEvent 
 * 
 * Revision 1.3  90/08/20  10:04:58  rnk
 * check_Screen no longer sends a method
 * 
 * Revision 1.1  90/08/13  19:18:57  rnk
 * Initial revision
 * 
/*--------------------------------------------------------------------------*\
|
|   Distribution: Approved for public release; distribution is unlimited.
|
|   Copyright (c) 1989  by  Carnegie  Mellon  University, Pittsburgh, PA.  The
|  Software Engineering  Institute  (SEI) is a federally  funded  research and
|  development center established  and  operated by Carnegie Mellon University
|  (CMU).  Sponsored  by  the  U.S.  Department  of   Defense  under  contract
|  F19628-85-C-0003,  the  SEI  is  supported  by  the  services  and  defense
|  agencies, with the U.S. Air Force as the executive contracting agent.
|
|    Permission to use,  copy,  modify, or  distribute  this  software and its
|  documentation for  any purpose and without fee  is hereby granted, provided
|  that  the above copyright notice appear  in  all copies and that both  that
|  copyright  notice  and   this  permission  notice  appear   in   supporting
|  documentation.   Further,  the  names  Software  Engineering  Institute  or
|  Carnegie  Mellon  University  may  not be used in  advertising or publicity
|  pertaining to distribution of the software without specific, written  prior
|  permission.  CMU makes no claims  or representations  about the suitability
|  of this software for any purpose.  This software is provided "as is" and no
|  warranty,  express  or  implied,  is  made  by  the  SEI  or CMU, as to the
|  accuracy  and  functioning of the program and related program material, nor
|  shall   the  fact of  distribution   constitute  any   such  warranty.   No
|  responsibility is assumed by the SEI or CMU in connection herewith.
|
\*--------------------------------------------------------------------------*/

#include	<stdio.h>
#include	<X11/Intrinsic.h>
#include	<Xm/Xm.h>
#include	<Xm/RowColumn.h>
#include	<Xm/Scale.h>
#include	<Xm/ScrollBar.h>
#include	<Xm/MainW.h>
#include	<Xm/MessageB.h>
#include	"isd.h"
#include	"glue_intf.h"
#include	"glue_inst.h"
#include	"six.h"

/* Screen definitions created in Six.c */
extern int screen ;
extern boolean	is_color ;
extern int screen_height, screen_width ;
extern Display *display ;

static char button_trans[] =
"Shift<Btn1Down>,<Btn1Up>:pick()\n\
Shift<Btn2Down>,<Btn2Motion>:resize()\n\
Shift<Btn2Down>,<Btn2Motion>,<Leave>,<Btn2Up>:resize()\n\
Shift<Btn2Down>,<Btn2Motion>,<Btn2Up>:resize()\n\
Shift<Btn3Down>,<Btn3Motion>:move()\n\
Shift<Btn3Down>,<Btn3Motion>,<Btn3Up>:move()\n\
Shift<Btn3Down>,<Btn3Motion>,<Leave>,<Btn3Up>:move()" ;

/*=========================================================================*\
 * check_MText is the check routine for the Motif Text widget.  It 
 * performs non-standard actions to support text widget operations.
\*=========================================================================*/
void check_MText(widget_inst, change, args, num_args)  
     INST *widget_inst ;
     isd_change_type change ;
     ArgList args ;
     Cardinal *num_args;
{
  ATTR *cur_attr ;

  SIX_DEBUG1(fprintf (stderr, "check_MText: entering\n")) ;

  cur_attr = glue_get_attr_from_instance(widget_inst, "sendbuffer", 
					 SERP_NAMES) ;
  if (change == isd_modify && cur_attr->value.i == TRUE) 
    msend(widget_inst->widget, NULL, NULL, NULL) ;

  SIX_DEBUG1(fprintf (stderr, "check_MText: leaving\n")) ;

}


/*=========================================================================*\
 * check_MainW is the check routine for the Motif Main Window widget.  It 
 * calls the routine XmMainWindowSetAreas to set up the widget properly.
\*=========================================================================*/
void check_MainW(widget_inst, change, args, num_args)  
     INST *widget_inst ;
     isd_change_type change ;
     ArgList args ;
     Cardinal *num_args;
{
  ATTR *com_attr, *menu_attr, *hscroll_attr, *vscroll_attr, *work_attr ;
  INST *com_inst, *menu_inst, *hscroll_inst, *vscroll_inst, *work_inst ;
  Widget com_w, menu_w, hscroll_w, vscroll_w, work_w ;

  SIX_DEBUG1(fprintf (stderr, "check_MainW: entering\n")) ;

  if (change == isd_create && widget_inst->widget != NULL)
    {
       com_attr = glue_get_attr_from_instance(widget_inst, "commandwindow", 
						 SERP_NAMES) ;
       if (com_attr->val_type != VAL_NONE && com_attr->value.i != iid_null_id)
	 {
	    com_inst = glue_get_by_id((iid_id_type) com_attr->value.i) ;
	    if (com_inst == NULL)
	      {
		 fprintf(stderr, "check_MainW: NULL command INST found\n");
		 exit(1) ;
	      }
	    else
	      com_w = com_inst->widget ;
	 }
       else
	 com_w = NULL ;

       menu_attr = glue_get_attr_from_instance(widget_inst, "menubar", 
						 SERP_NAMES) ;
       if (menu_attr->val_type != VAL_NONE && menu_attr->value.i !=iid_null_id)
	 {
	    menu_inst = glue_get_by_id((iid_id_type) menu_attr->value.i) ;
	    if (menu_inst == NULL)
	      {
		 fprintf(stderr, "check_MainW: NULL menu INST found\n");
		 exit(1) ;
	      }
	    else
	      menu_w = menu_inst->widget ;
	 }
       else
	 menu_w = NULL ;

       hscroll_attr = glue_get_attr_from_instance(widget_inst, 
				  "horizontalscrollbar", SERP_NAMES) ;
       if (hscroll_attr->val_type != VAL_NONE && 
	   hscroll_attr->value.i !=iid_null_id)
	 {
	    hscroll_inst = glue_get_by_id((iid_id_type) hscroll_attr->value.i);
	    if (hscroll_inst == NULL)
	      {
		 fprintf(stderr, "check_MainW: NULL hscroll INST found\n");
		 exit(1) ;
	      }
	    else
	      hscroll_w = hscroll_inst->widget ;
	 }
       else
	 hscroll_w = NULL ;

       vscroll_attr = glue_get_attr_from_instance(widget_inst, 
				  "verticalscrollbar", SERP_NAMES) ;
       if (vscroll_attr->val_type != VAL_NONE && 
	   vscroll_attr->value.i !=iid_null_id)
	 {
	    vscroll_inst = glue_get_by_id((iid_id_type) vscroll_attr->value.i);
	    if (vscroll_inst == NULL)
	      {
		 fprintf(stderr, "check_MainW: NULL vscroll INST found\n");
		 exit(1) ;
	      }
	    else
	      vscroll_w = vscroll_inst->widget ;
	 }
       else
	 vscroll_w = NULL ;

       work_attr = glue_get_attr_from_instance(widget_inst, "workwindow", 
						 SERP_NAMES) ;
       if (work_attr->val_type != VAL_NONE && work_attr->value.i !=iid_null_id)
	 {
	    work_inst = glue_get_by_id((iid_id_type) work_attr->value.i) ;
	    if (work_inst == NULL)
	      {
		 fprintf(stderr, "check_MainW: NULL vscroll INST found\n");
		 exit(1) ;
	      }
	    else
	      work_w = work_inst->widget ;
	 }
       else
	 work_w = NULL ;

       XmMainWindowSetAreas(widget_inst->widget, menu_w, com_w,
                            hscroll_w, vscroll_w, work_w) ;
    }

  SIX_DEBUG1(fprintf (stderr, "check_MainW: leaving\n")) ;

}


/*=========================================================================*\
 * PopupEvent is the event handler for popup menus (used by check_Popup)
\*=========================================================================*/
PopupEvent(widget, popup, event)
     Widget widget, popup ;
     XButtonEvent *event ;
{
  if (event->button != Button3)
    return ;
  XmMenuPosition(popup, event);
  XtManageChild(popup) ;
}


/*=========================================================================*\
 * check_Popup is the check routine for the Motif RowColumn widget,
 * configured as a Popup menu.  It performs non-standard actions such
 * as adding event handlers.
\*=========================================================================*/
void check_Popup(widget_inst, change, args, num_args)  
     INST *widget_inst ;
     isd_change_type change ;
     ArgList args ;
     Cardinal *num_args;
{
  ATTR *parent_attr ;
  INST *parent_inst ;

  SIX_DEBUG1(fprintf (stderr, "check_Popup: entering\n")) ;

  if (change == isd_create && widget_inst->widget != NULL)
    {
      parent_attr = glue_get_attr_from_instance(widget_inst, "parent", 
						SERP_NAMES) ;
      if (parent_attr->val_type != VAL_NONE &&
	  parent_attr->value.i != iid_null_id)
	{
	  parent_inst = 
	    glue_get_by_id((iid_id_type) parent_attr->value.i) ;
	  if (parent_inst == NULL) 
	    {
	      fprintf(stderr, "check_Popup: parent not found for id %d\n", 
		      parent_attr->value.i) ;
	      exit(1) ;
	    }
	  XtAddEventHandler(parent_inst->widget, ButtonPressMask, 0,
			    PopupEvent, widget_inst->widget) ;
	}
    }

  SIX_DEBUG1(fprintf (stderr, "check_Popup: leaving\n")) ;

}


/*=========================================================================*\
 * check_FSB is the check routine for the Motif File Selection box widget.
 * This routine makes sure that the FSB has a height and width specified.
\*=========================================================================*/
void check_FSB(inst, change, args, num_args)  
     INST *inst ;
     isd_change_type change ;
     ArgList args ;
     Cardinal *num_args;
{
  ATTR *width_attr, *height_attr ;

  SIX_DEBUG1(fprintf (stderr, "check_FSB: entering\n")) ;

  if (change == isd_create && inst->widget == NULL)
    {
      width_attr = glue_get_attr_from_instance(inst, "width", SERP_NAMES) ;
      height_attr = glue_get_attr_from_instance(inst, "height", SERP_NAMES) ;
      if (width_attr->val_type == VAL_NONE)
	{
	  XtSetArg(args[*num_args], width_attr->t_name, 350) ;
	  (*num_args)++;
	  width_attr->value.i = 350 ;
	  width_attr->val_type = VAL_CURRENT ;
	}

      if (height_attr->val_type == VAL_NONE)
	{
	  XtSetArg(args[*num_args], height_attr->t_name, 275) ;
	  (*num_args)++;
	  height_attr->value.i = 275 ;
	  height_attr->val_type = VAL_CURRENT ;
	}
    }

  SIX_DEBUG1(fprintf (stderr, "check_FSB: leaving\n")) ;
}


/*=========================================================================*\
 * check_mBtn is the check routine for the Motif Push and Toggle Button 
 * widgets.  This routine adds translations to the default translations.
\*=========================================================================*/
void check_mBtn(inst, change, args, num_args)  
     INST *inst ;
     isd_change_type change ;
     ArgList args ;
     Cardinal *num_args;
{

  SIX_DEBUG1(fprintf (stderr, "check_mBtn: entering\n")) ;

  if (change == isd_create && inst->widget != NULL)
    {
      XtAugmentTranslations(inst->widget, 
			    XtParseTranslationTable(button_trans)) ;
    }

  SIX_DEBUG1(fprintf (stderr, "check_mBtn: leaving\n")) ;
}


/*=========================================================================*\
 * check_Screen is the check routine for the Screen object.  It 
 * sends screen info to the dialogue.
\*=========================================================================*/
void check_Screen(inst, change, args, num_args) 
     INST *inst ;
     isd_change_type change ;
     ArgList args ;
     Cardinal *num_args;
{
  ATTR *s_attr ;
  isd_trans trans;

  SIX_DEBUG1(fprintf (stderr, "check_Screen: entering\n")) ;

  /* Start the transation */
  trans = isd_start_transaction ();

  isd_put_shared_data(trans, inst->id, "screenobject", "screen", 
		      &screen);
  isd_put_shared_data(trans, inst->id, "screenobject", "display", 
		      display);
  isd_put_shared_data(trans, inst->id, "screenobject", "color", 
		      &is_color);
  isd_put_shared_data(trans, inst->id, "screenobject", "height", 
		      &screen_height);
  isd_put_shared_data(trans, inst->id, "screenobject", "width", 
		      &screen_width);

  /* Commit the transation */
  isd_commit_transaction (trans);

  SIX_DEBUG1(fprintf (stderr, "check_Screen: leaving\n")) ;

}


/*=========================================================================*\
 * check_Dlg is the check routine for dialog boxes.  It makes the buttons
 * of the dialog boxes insensitive, if "deactivate" is true.
\*=========================================================================*/
void check_Dlg(inst, change, args, num_args) 
     INST *inst ;
     isd_change_type change ;
     ArgList args ;
     Cardinal *num_args;
{
  ATTR *deact_attr ;
  Widget OK, help, cancel ;
  Arg local_args[2] ;
  int n ;

  SIX_DEBUG1(fprintf (stderr, "check_Dlg: entering\n")) ;

  if (change == isd_create && inst->widget != NULL)
    {
      deact_attr = glue_get_attr_from_instance(inst, "deactivate", SERP_NAMES);

      if (deact_attr == NULL) return ;
      
      if (deact_attr->value.i == TRUE)
	{
	  OK = XmMessageBoxGetChild(inst->widget, XmDIALOG_OK_BUTTON) ;
	  if (OK != NULL)
	    {
	      n = 0 ;
	      XtSetArg(local_args[n], XmNsensitive, FALSE) ; n++ ;
	      XtSetValues(OK, local_args, n) ;
	    }
	  
	  help = XmMessageBoxGetChild(inst->widget, XmDIALOG_HELP_BUTTON) ;
	  if (help != NULL)
	    {
	      n = 0 ;
	      XtSetArg(local_args[n], XmNsensitive, FALSE) ; n++ ;
	      XtSetValues(help, local_args, n) ;
	    }
	  
	  cancel = XmMessageBoxGetChild(inst->widget, XmDIALOG_CANCEL_BUTTON) ;
	  if (cancel != NULL)
	    {
	      n = 0 ;
	      XtSetArg(local_args[n], XmNsensitive, FALSE) ; n++ ;
	      XtSetValues(cancel, local_args, n) ;
	    }
	}
    }      

  SIX_DEBUG1(fprintf (stderr, "check_Dlg: leaving\n")) ;

}


/*=========================================================================*\
 * scale_callback is the callback procedure for a scale widget.  It sends a 
 * "value" method to the dm.
\*=========================================================================*/
void	scale_callback (widget, client_data, scale)

Widget	widget;
caddr_t	client_data;
XmScaleCallbackStruct *scale;
{
  isd_trans trans;
  INST *inst = glue_get_by_widget(widget);

  trans = isd_start_transaction ();

  /* Send the method name */
  isd_put_shared_data(trans, inst->id, inst->template->name, "value", 
		      &(scale->value));

  isd_put_shared_data (trans, inst->id, inst->template->name, 
		       "method", "value_changed");

  isd_commit_transaction (trans);
}


/*=========================================================================*\
 * scroll_callback is the callback procedure for a scrollbar widget.  It 
 * sends a "value" method to the dm.
\*=========================================================================*/
void	scroll_callback (widget, client_data, scroll)

Widget	widget;
caddr_t	client_data;
XmScrollBarCallbackStruct *scroll;
{
  isd_trans trans;
  INST *inst = glue_get_by_widget(widget);

  trans = isd_start_transaction ();

  /* Send the new value */
  isd_put_shared_data(trans, inst->id, inst->template->name, "value", 
		      &(scroll->value));

  /* Send the method name */
  isd_put_shared_data (trans, inst->id, inst->template->name, 
		       "method", "value_changed");

  isd_commit_transaction (trans);
}


/*=========================================================================*\
 * toggle_callback is the callback procedure for a valueChangeCallback 
 * (in the toggle button).  It sends a "toggle" method and the state of
 * the button to the dm.
\*=========================================================================*/
void	toggle_callback (widget, client_data, toggle)

Widget	widget;
caddr_t	client_data;
XmToggleButtonCallbackStruct *toggle;
{
  isd_trans trans;
  INST *inst = glue_get_by_widget(widget);

  trans = isd_start_transaction ();

  /* Send the new value */
  isd_put_shared_data(trans, inst->id, inst->template->name, "set", 
		      &(toggle->set));

  /* Send the method name */
  isd_put_shared_data (trans, inst->id, inst->template->name, 
		       "method", "toggle");

  isd_commit_transaction (trans);
}


