/*      $Header: /usr/users/little/serpent/mips/utilities/include/RCS/cus.h,v 1.44 1991/04/24 23:54:42 little Exp $ */

/*--------------------------------------------------------------------------*\
|
|  Name:  cus.h 
|
|  Change History:
|	9 jun 88 - add change warning comment to the property enum typedef
|	10 may 88 - new module
|
|  Description:  
|	the header file utilized by users of the symbol table package
|
|  Component of:
|	compiler symbol table
|
|  Project:
|     SERPENT System
|     User Interface Prototyping
|     Software Engineering Institute
|     Carnegie Mellon University
|     Pittsburgh, PA  15213
|

$Log: cus.h,v $
 * Revision 1.44  1991/04/24  23:54:42  little
 * add object_count_prop.  not sure i'm gonna need it, but what the hey i
 * already had this checked out.
 *
 * Revision 1.43  1991/02/15  14:20:05  little
 * move definition for cus_sym_entry from cus_priv.h to cus.h to make some
 * things in dbx possible
 *
 * Revision 1.42  90/11/14  14:59:44  rcs
 * added constant
 * 
 * Revision 1.41  90/11/12  12:19:17  dvk
 * Added an external seed parameter to cus_gensym and cus_gensym_no_add
 * 
 * Revision 1.40  90/11/01  21:10:43  little
 * add num_components_prop
 * 
 * Revision 1.39  90/10/31  14:03:08  little
 * add pfl and pfl_stack props
 * 
 * Revision 1.38  90/09/17  19:11:52  dvk
 * Added declarations for routines cus_gensym_no_add and cus_create_sym
 * 
 * Revision 1.37  90/08/29  18:24:59  little
 * add counter_prop
 * 
 * Revision 1.36  90/07/09  16:36:15  dvk
 * Added collected_attr_assign_prop
 * 
 * Revision 1.35  90/07/02  17:57:32  little
 * added visible_prop
 * 
 * Revision 1.34  90/06/16  12:23:48  little
 * added a couple fo new symbol types
 * 
 * Revision 1.33  90/06/14  13:50:54  little
 * more changes to integrate visulization and structure editors
 * 
 * Revision 1.32  90/03/23  12:42:49  dvk
 * Oops.  No changes.
 * 
 * Revision 1.31  90/02/28  18:49:50  dvk
 * Deleted cus_get_sym_type_string (does the same thing as the routine
 * cus_type_print_val, and deleted a bunch of unused _prop's
 * 
 * Revision 1.30  90/02/14  21:45:02  ejh
 * fixed include structure
 * 
 * Revision 1.29  90/01/12  15:01:04  dvk
 * Added enum type for shared strings in compiled Slang code (cus_code_type)
 * 
 * Revision 1.28  90/01/08  18:37:58  bmc
 * Added active_display_prop and list_of_displays_prop
 * 
 * Revision 1.27  89/12/04  16:30:12  bmc
 * added object_technologies_prop
 * 
 * Revision 1.26  89/11/14  16:30:31  bmc
 * Added parent_dialogue_prop
 * 
 * Revision 1.25  89/11/13  10:45:14  rcs
 * added new property
 * 
 * Revision 1.24  89/11/08  11:54:29  little
 * add some properties needed by the dialogue editor
 * 
 * Revision 1.23  89/10/08  00:03:29  serpent
 * short names: referred to cus_priv.h instead of cus_private.h
 * 
 * Revision 1.22  89/10/02  13:28:11  rcs
 * removed stupid include of serpent.h
 * 
 * Revision 1.21  89/09/29  15:36:21  little
 * add name_text_prop, this is getting boring
 * 
 * Revision 1.20  89/09/29  14:09:01  little
 * add creation_condition_text_prop
 * 
 * Revision 1.19  89/09/29  14:02:19  little
 * add the comment text props
 * 
 * Revision 1.18  89/09/28  14:22:09  little
 * add the text snippet properties
 * 
 * Revision 1.17  89/09/26  18:08:37  bmc
 * Added properties for dialogue editor application
 * 
 * Revision 1.16  89/07/25  21:41:25  bmc
 * Added sd_template_prop
 * 
 * Revision 1.15  89/06/16  17:35:52  little
 * move the props added in the last change to the end of the list
 * 
 * Revision 1.14  89/06/16  16:32:14  bmc
 * Added potential_vcs_prop and saved_sne_prop to property enumeration.
 * 
 * Revision 1.13  89/06/14  11:00:03  little
 * change the sym tba init routine to take a param which indicates whether to
 * perform redefined processing
 * 
 * Revision 1.12  89/06/09  14:28:02  little
 * add last_prop_DO_NOT_USE as a "terminator" in prop enum list
 * 
 * Revision 1.11  89/04/07  17:47:37  ljb
 * add properties for saving shared data information across vcs
 *  and for user written functions
 * 
 * Revision 1.10  89/04/03  16:40:27  little
 * add the snippet_text_prop, which is used by the editor to keep the
 * text form of a snippet.
 * 
 * Revision 1.9  89/02/26  10:42:42  little
 * add cc_lineno_prop (it contains the input file line # on which the last
 * line of the cc appears)
 * 
 * Revision 1.8  89/02/10  14:29:46  ejh
 * added copyright notice
 * 
 * Revision 1.7  89/02/01  16:23:24  little
 * add alternate_print_string_prop 
 * 
 * Revision 1.6  89/01/18  14:20:03  ejh
 * new ill file preamble properties
 * 
 * Revision 1.5  89/01/17  16:29:07  little
 * add bound_elem_sym and bound_comp_sym to cus_sym_type
 * 
 * Revision 1.4  89/01/17  16:06:15  rcs
 * added header for cus_get_sym_type_string routine
 * 
 * Revision 1.3  88/12/20  15:31:29  ejh
 * removed extraneous comment props
 * 
 * Revision 1.2  88/12/20  13:14:55  little
 * add user_defined_prop and redefined_prop
 * 
|
|
\*--------------------------------------------------------------------------*\
|
|   Distribution: Approved for public release; distribution is unlimited.
|
|   Copyright (c) 1989  by  Carnegie  Mellon  University, Pittsburgh, PA.  The
|  Software Engineering  Institute  (SEI) is a federally  funded  research and
|  development center established  and  operated by Carnegie Mellon University
|  (CMU).  Sponsored  by  the  U.S.  Department  of   Defense  under  contract
|  F19628-85-C-0003,  the  SEI  is  supported  by  the  services  and  defense
|  agencies, with the U.S. Air Force as the executive contracting agent.
|
|    Permission to use,  copy,  modify, or  distribute  this  software and its
|  documentation for  any purpose and without fee  is hereby granted, provided
|  that  the above copyright notice appear  in  all copies and that both  that
|  copyright  notice  and   this  permission  notice  appear   in   supporting
|  documentation.   Further,  the  names  Software  Engineering  Institute  or
|  Carnegie  Mellon  University  may  not be used in  advertising or publicity
|  pertaining to distribution of the software without specific, written  prior
|  permission.  CMU makes no claims  or representations  about the suitability
|  of this software for any purpose.  This software is provided "as is" and no
|  warranty,  express  or  implied,  is  made  by  the  SEI  or CMU, as to the
|  accuracy  and  functioning of the program and related program material, nor
|  shall   the  fact of  distribution   constitute  any   such  warranty.   No
|  responsibility is assumed by the SEI or CMU in connection herewith.
|
\*--------------------------------------------------------------------------*/

#ifndef	CUS_H
#define	CUS_H

#include "idd.h"
#include "alistPack.h"
#include "global.h"

#define NO_CONTEXT 0
#define WITH_CONTEXT 1

#define NO_SEED 0

/*--------------------------------------------------------------------------*\
|  Description:  
|     the type of the snippet, used for debug printout
| 
\* Definition:                                                              */

typedef enum code_type {
	cus_ATTR,
	cus_CREATE,
	cus_DESTROY,
	cus_METH,
	cus_CCOND,
	cus_VAR,
	cus_UNKNOWN } cus_code_type;


/*--------------------------------------------------------------------------*\
|  Type: cus_symbol_table
|
|  Description:
|     Provides a handle to a symbol table.
|
\* Definition:                                                              */

typedef private			cus_symbol_table;
#define cus_no_symbol_table	((cus_symbol_table) NULL)
#define CUS_NO_SYMBOL_TABLE	cus_no_symbol_table

/*--------------------------------------------------------------------------*\
|  Description:  
|     the exported type for users to access contexts
| 
|	!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
|	DO NOT FORGET TO UPDATE THE NAME ARRAY WHEN MODIFYING THIS ENUM 
|		IT IS NAMED cus_symbol_type_print_value AND IS IN
|		THE FILE NAMED cus_priv.h
|
|	ALSO, DO NOT PUT IN ANY EXPLICIT ASSIGNMENTS FOR ENUM MEMBER
|		VALUES
|
|	ADD ALL NEW TYPES TO THE END OF THE LIST
|
|        ALSO, DO NOT FORGET TO UPDATE THE cus_sym_type_strings NAME 
|               ARRAY IN cus.c after modifying this enum.
|	!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
|
\* Definition:                                                              */
typedef int cus_context_type;

/*--------------------------------------------------------------------------*\
|  Description:  
|     the exported symbol type definition
| 
\* Definition:                                                              */
typedef enum sym_type {
   null_sym,
   vc_sym,
   object_sym,
   attribute_sym,
   function_sym,
   function_call_sym,
   variable_sym,
   snippet_sym,
   operator_sym,
   if_sym,
   while_sym,
   comment_sym,
   ill_data_definition_sym,
   assignment_sym,
   id_sym,
   sd_sym,
   temp_sym,
   constant_sym,
   ill_sym,
   bound_elem_sym,
   bound_comp_sym,
   method_sym,
   elsif_sym,
   exp_only_sym
   }  cus_sym_type;

/*--------------------------------------------------------------------------*\
|  Description:  
|     the exported legal property names
|
|	!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
|	DO NOT FORGET TO UPDATE THE NAME ARRAY WHEN MODIFYING THIS ENUM 
|		IT IS NAMED cus_property_type_print_value AND IS IN
|		THE FILE NAMED cus_priv.h
|
|	ADD ALL NEW PROPERTIES TO THE END OF THE LIST
|
|	ALSO, DO NOT PUT IN ANY EXPLICIT ASSIGNMENTS FOR ENUM MEMBER
|		VALUES
|	!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
|
\* Definition:                                                              */

typedef enum property_type {
   instances_prop,			/* list of instance ids	          */
   template_prop,			/* id of template	          */
   parent_vc_prop,			/* id of parent vc                */
   objects_prop,			/* list of object ids             */
   variables_prop,			/* list of variable ids           */
   sub_vcs_prop,			/* list of subvc ids              */
   creation_condition_prop,
   methods_prop,
   create_actions_snippet_prop,
   destroy_actions_snippet_prop,
   type_prop,				/* 10 */
   attributes_prop,
   value_snippet_prop,
   modified_snippet_prop,
   current_type_prop,			/* idd_data_types		  */
   current_value_prop,			/* value specified in variable	  */
   initial_value_snippet_prop,
   owned_context_prop,
   c_function_name_prop,
   num_operands_prop,
   data_definition_prop,		/* 20 */
   object_type_prop,
   is_reserved_word_prop,
   is_constant_prop,
   is_comment_prop,
   vc_comments_prop,
   variable_comments_prop,
   object_comments_prop,
   cc_used_vars_prop,
   ask_prop,
   u_name_prop,				/* 30 */
   fixed_method_snippet_prop,
   parent_object_prop,
   c_proc_number_prop,
   fixed_creation_condition_prop,

/*	ill file preamble stuff */

   generic_magic_id_prop,
   specific_magic_id_prop,
   ill_file_name_prop,
   mailbox_name_prop,
   execution_name_prop,
   exec_command_prop,			/* 40 */

   idd_handle_prop,
   id_prop,
   ill_files_prop,
   taps_prop,
   original_name_prop,
   creating_sd_prop,
   vce_prop,
   is_built_in_prop,
   fixed_method_prop,
   is_ok_id_name_prop,			/* 50 */
   created_vcs_prop,
   old_cc_used_vars_prop,
   pet_proc_name_prop,
   cc_uses_new_prop,
   user_defined_prop,
   redefined_prop,
   cc_lineno_prop,
   binary_operator_prop,		/* 60 */
   unary_operator_prop,
   snippet_text_prop,
   old_created_vcs_prop,		/*these three prop*/
   old_parent_vc_prop,			/*  were added to save*/ 
   old_owned_context_prop,		/*  information across vc use*/
   parameter_conversion_functions_prop,  /*for use with c functions*/
   returned_value_conversion_function_prop,
   potential_vcs_prop,                  /* list of vcs interested in s.d. */
   saved_sne_prop,
					/* 70 */
   sd_template_prop,                    /* SDD template for shared data item */

/* 	properties used solely by dialogue editor application */

   file_name_prop,			/* name of file containing dialogue */
   prologue_comments_prop,		/* comments from dialogue prologue */
   macros_prop,				/* macros from dialogue prologue */
   externs_prop,			/* dialogue external declarations,
					   also used by compiler */
   technologies_prop,			/* technologies used by dialogue */
   shared_data_prop,
   eve_vc_prop,				/* holds handle of top level vc */
   symbol_table_prop,			/* handle of containing symbol table */
   dialogue_context_prop,		/* sym. tab. context for a dialogue */

					/* 80 */
   value_snippet_text_prop,		/* attribute snippet text */
   create_actions_snippet_text_prop,	/* create actions snippet text */
   destroy_actions_snippet_text_prop,	/* destroy actions snippet text */
   initial_value_snippet_text_prop,	/* variable snippet text */

   vc_comments_text_prop,		/* text version of prop */
   variable_comments_text_prop,		/* text version of prop */
   object_comments_text_prop,		/* text version of prop */
   creation_condition_text_prop,	/* text version of prop */
   name_text_prop,			/* text version of prop */
   obj_type_text_prop,			/* text version of prop */
					/* 90 */
   method_text_prop,			/* text version of prop */

   external_type_string,
   dialogue_element_type_prop,		/* enumeration of element types	*/
   parent_dialogue_prop,		/* EVE's back pointer */

   object_technology_prop,		/* technology associated w/ object */
   object_instances_prop,
   ghost_p_prop,
   snippet_constant_p_prop,
   visible_prop,
   collected_attr_assign_prop,		/* Used in cam.c and csc.c */
   count_prop,
   pfl_prop,
   pfl_stack_prop,
   num_components_prop,
   object_count_prop,

/*
	ADD ALL PROPERTIES BEFORE THIS ONE
*/
   last_prop_DO_NOT_USE
 } cus_property_type;   /* END */


/*--------------------------------------------------------------------------*\
|  Description:
|       actual symbol concrete representation.  note that the properties type,
|       template, current_type, current_value, original_name, & redefined are
|       actually kept here instead of on the property list.
|
\* Definition:                                                              */

        typedef struct  cus_sym_entry {
                char *                  name;
                int                     ident;
                cus_sym_type            type;
                idd_data_types          current_type;
                caddr_t                 redefined;
                caddr_t                 template;
                caddr_t                 current_value;
                caddr_t                 original_name;
                ALIST                   properties;
           } cus_sym_entry;

typedef struct cus_sym_entry *cus_sym;


/*--------------------------------------------------    FUNCTIONS */

/*--------------------------------------------------------------------------*\
|  Routine: cus_create_sym_tab
|
|  Description:
|     make a symbol table item
|
\* Syntax:                                                  		    */
	void cus_create_sym_tab (
	  /* do_redefine_flag in : boolean */
	);

/*
|  Parameters:
|	do_redefine_flag - true indicates redefine processing should occur,
|	   false saays do not do redefine processing
|
|  Returns:
|	nothing
\*--------------------------------------------------------------------------*/

/*--------------------------------------------------------------------------*\
|  Routine: cus_create_sym
|
|  Description:
|	creates a symbol, but doesn't add it into the symbol table
|		(primarily used for unique symbols for which the handle
|		 is maintained, and which no lookups are done)
|	does not enter the name into the common string pool
\* Syntax:                                                  */
        cus_sym cus_create_sym (
/*           name : in string, */
/*           type : in cus_sym_type, */
	);
/*
|  Parameters:
|	name - the string name of the symbol
|	type - the type of the symbol
|  Returns:
|	The symbol handle.
\*--------------------------------------------------------------------------*/

/*--------------------------------------------------------------------------*\
|  Routine: cus_add_sym
|
|  Description:
|	adds a symbol to the symbol table (potentially)
|	also, adds the name of the symbol into a common string pool
\* Syntax:                                                  */
        cus_sym cus_add_sym (
/*           name : in string, */
/*           type : in cus_sym_type, */
/*           new : out int*, */
/*           worry_about_context : in int */
	);
/*
|  Parameters:
|	name - the string name of the symbol
|	type - the type of the symbol
|	new - indicator if anything was actually added to the table
|	worry_about_context - indicator as to if context should matter
|  Returns:
|	The symbol handle.
\*--------------------------------------------------------------------------*/

/*--------------------------------------------------------------------------*\
|  Routine: cus_delete_sym
|
|  Description:
|	Deletes a specified symbol from the symbol table.
|
\* Syntax:		                                                    */

        boolean cus_delete_sym(
	  /* sym : in out cus_sym */
	);

/*
|  Parameters:
|	sym - Symbol to be deleted.
|
|  Returns:
|	True if delete; false otherwise.
\*--------------------------------------------------------------------------*/

/*--------------------------------------------------------------------------*\
|  Routine: cus_look_up
|
|  Description:
|	look up a symbol in the table, if there return the handle, else
|	return NULL.
\* Syntax:                                                  */
	cus_sym cus_look_up (
/*           name : in char* */
	);
/*
|  Parameters:
|	name - the string representing the desired symbol
|  Returns:
|	the handle for the symbol or NULL.
\*--------------------------------------------------------------------------*/


/*--------------------------------------------------------------------------*\
|  Routine: cus_sym_representation
|
|  Description:
|	look up a symbol in the table, if there return the handle, else
|	return NULL.
\* Syntax:                                                  */
	char *cus_sym_representation (
/*           sym : in cus_sym */
	);
/*
|  Parameters:
|	sym - a symbol handle
|  Returns:
|	the print string representation for the symbol
\*--------------------------------------------------------------------------*/


/*--------------------------------------------------------------------------*\
|  Routine: cus_put_prop
|
|  Description:
|       (re)places a property value on the symbol's property list
\* Syntax:							*/
	void cus_put_prop (
/*            sym : in cus_sym, */
/*            property_name : in cus_property_type, */
/*            property_value : in char* */
	);
/*
|  Parameters:
|	sym - a symbol handle
|	property_name - the property to set
|	property_value - the value to place in the property list
|  Returns:
|	nothing
\*--------------------------------------------------------------------------*/


/*--------------------------------------------------------------------------*\
|  Routine: cus_get_prop
|
|  Description:
|       retrieves a property value from the symbol's property list
\* Syntax:							*/
	char *cus_get_prop (
/*            sym : in cus_sym, */
/*             property_name : in cus_property_type */
	);
/*
|  Parameters:
|	sym - a symbol handle
|	property_name - the property to fetch
|  Returns:
|	The value of the property_name property or NULL
\*--------------------------------------------------------------------------*/


/*--------------------------------------------------------------------------*\
|  Routine: cus_create_nu_context
|
|  Description:
|	creates a new context
\* Syntax:							*/
	cus_context_type cus_create_nu_context ();
/*
|  Parameters:
|	none
|  Returns:
|	The new context identifier
\*--------------------------------------------------------------------------*/


/*--------------------------------------------------------------------------*\
|  Routine: cus_activate_context
|
|  Description:
|	activate an existing context
\* Syntax:							*/
	void cus_activate_context (
/*            context : in cus_context_type */
	);
/*
|  Parameters:
|	context - the context to which the symbol table is to be configured
|  Returns:
|	nothing
\*--------------------------------------------------------------------------*/


/*--------------------------------------------------------------------------*\
|  Routine: cus_current_context
|
|  Description:
|	get the current symbol table contest
\* Syntax:							*/
	cus_context_type cus_current_context ();
/*
|  Parameters:
|	none
|  Returns:
|	The current context
\*--------------------------------------------------------------------------*/


/*--------------------------------------------------------------------------*\
|  Routine: cus_deactivate_context
|
|  Description:
|	"pops" back to the parent of the current context
\* Syntax:							*/
	cus_context_type cus_deactivate_context (
	);
/*
|  Parameters:
|	none
|  Returns:
|	The new context
\*--------------------------------------------------------------------------*/


/*--------------------------------------------------------------------------*\
|  Routine: cus_sym_context
|
|  Description:
|	find the context in which a symbol was defined
\* Syntax:							*/
	cus_context_type cus_sym_context (
/*           sym : in cus_sym */
	);
/*
|  Parameters:
|	sym - a symbol handle
|  Returns:
|	context in which sym was defined
\*--------------------------------------------------------------------------*/


/*--------------------------------------------------------------------------*\
|  Routine: cus_gensym
|
|  Description:
|	generate a unique symbol and place in the symbol table
\* Syntax:							*/
	cus_sym cus_gensym (
/*            prefix : in char* */
/*            type : in cus_sym_type */
/*            seed : in int* */
	);
/*
|  Parameters:
|	prefix - the prefix string, should be composed of printing
|		ascii characters.
|	type - type for the generated symbol
|	seed - the address of a seed counter (or 0, means use internal)
|  Returns:
|	The handle of the generated symbol.
\*--------------------------------------------------------------------------*/

/*--------------------------------------------------------------------------*\
|  Routine: cus_gensym_no_add
|
|  Description:
|	generate a unique symbol but don't place in the symbol table
\* Syntax:							*/
	cus_sym cus_gensym_no_add (
/*            prefix : in char* */
/*            type : in cus_sym_type */
/*            seed : in int* */
	);
/*
|  Parameters:
|	prefix - the prefix string, should be composed of printing
|		ascii characters.
|	type - type for the generated symbol
|	seed - the address of a seed counter (or 0, means use internal)
|  Returns:
|	The handle of the generated symbol.
\*--------------------------------------------------------------------------*/


/*--------------------------------------------------------------------------*\
|  Routine: cus_walk_sym_tab
|
|  Description:
|	walk through the entire symbol table applying a user defined function
|	to all the symbols
\* Syntax:							*/
	void cus_walk_sym_tab (
/*           the_funct : in int (*the_funct) () */
/*            the_thing : in char*) */
	);
/*
|  Parameters:
|	the_funct - a user supplied int valued function.
|	the_thing - the magic free parameter to the_funct.
|  Returns:
|	nothing
\*--------------------------------------------------------------------------*/


/*--------------------------------------------------------------------------*\
|  Routine: cus_is_sym
|
|  Description:
|	determine if the parameter is a symbol handle
\* Syntax:                                                      */
	int cus_is_sym (
/*	    sym : in cus_sym */
        );
/*
|  Parameters:
|	sym - the handle to be checked
|  Returns:
|	non-zero if the parameter is a symbol handle, zero otherwise
\*--------------------------------------------------------------------------*/


/*--------------------------------------------------------------------------*\
|  Routine: cus_string_constant
|
|  Description:
|	add a string constant to symbol table
\* Syntax:                                                      */
	cus_sym cus_string_constant (
/*	    the_string : in string */
        );
/*
|  Parameters:
|	the_string - string value of constant
|  Returns:
|	the resulting symbol
\*--------------------------------------------------------------------------*/


/*--------------------------------------------------------------------------*\
|  Routine: cus_genname
|
|  Description:
|	create a unique string
\* Syntax:                                                      */
	char *cus_genname (
/*	    prefix : in string */
        );
/*
|  Parameters:
|	prefix - the prefix string, should be composed of printing
|		ascii characters.
|  Returns:
|	pointer to the resulting "uniquified" string
\*--------------------------------------------------------------------------*/


/*--------------------------------------------------------------------------*\
|  Routine: cus_prop_print_val
|
|  Description:
|	get the print string for a propertY
\* Syntax:                                                      */
	string cus_prop_print_val (
/*	    property : in cus_property_type */
        );
/*
|  Parameters:
|	property - the property for which the print string is desired
|  Returns:
|	pointer to the resulting string
|
|  NOTE:
|	no check is made to ensure the property parameter is a valid property.
|	if it is not valid, rather startling strings will be returned
\*--------------------------------------------------------------------------*/


/*--------------------------------------------------------------------------*\
|  Routine: cus_type_print_val
|
|  Description:
|	get the print string for a propertY
\* Syntax:                                                      */
	string cus_type_print_val (
/*	    type : in cus_type_print_val */
        );
/*
|  Parameters:
|	type - the symbol type for which the print string is desired
|  Returns:
|	pointer to the resulting string
|
|  NOTE:
|	no check is made to ensure the type parameter is a valid type.
|	if it is not valid, rather startling strings will be returned
\*--------------------------------------------------------------------------*/


/*--------------------------------------------------------------------------*\
|  Routine: cus_print_property_list
|
|  Description:
|	print all the properties for a symbol
\* Syntax:                                                      */
	void cus_print_property_list (
/*	    stream: in FILE *, 		*/
/*	    sym: in cus_sym,		*/
/*	    indent: in string		*/
/*	    their_funct: in int (*) () */
        );
/*
|  Parameters:
|	stream - stream on which to print the property list
|	sym - symbol whose property list to be printer
|	indent - indentation to use for the print
|	their_funct - optional user supplied four parameter function which
|		is handed the properties, one at a time.  first parameter
|		is the stream on which to print, second parameter is the
|		indentation to use, third parameter
|		is the symbol,  & fourth parameter is a property.  this
|		provides for user control when printing the property values.
|		NULL should be used when the user want the default
|		property print as described below.
|  Returns:
|	nothing
|
|  NOTE:
|	the default print of is such that property values (w/the exception of
|	the type_prop) are not
|	printed because it is difficult to know what type each of the property
|	values are w/o apriori putting it in the cus code.
\*--------------------------------------------------------------------------*/

#endif
