/*      $Header: /usr/users/little/serpent/mips/utilities/include/RCS/cus_priv.h,v 1.20 1991/04/24 23:55:38 little Exp $ */

/*--------------------------------------------------------------------------*\
|
|  Name:  cus_priv.h
|
|  Description:  
|	the package internal header file for the compiler symbol table package 
|
|  Component of:
|	compiler symbol table package
|

$Log: cus_priv.h,v $
 * Revision 1.20  1991/04/24  23:55:38  little
 * add object_count_prop.  not sure i'm gonna need it, but what the hey i
 * already had this checked out.
 *
 * Revision 1.19  1991/02/15  14:21:24  little
 * move definition for cus_sym_entry from cus_priv.h to cus.h to make some
 * things in dbx possible
 *
 * Revision 1.18  90/11/01  21:11:20  little
 * add num_components_prop
 * 
 * Revision 1.17  90/10/31  14:03:36  little
 * add pfl and pfl_stack props
 * 
 * Revision 1.16  90/09/17  19:13:55  dvk
 * Rewrote declarations for cus_sym
 * 
 * Revision 1.15  90/08/29  18:25:27  little
 * add counter_prop
 * 
 * Revision 1.14  90/07/09  16:36:38  dvk
 * Added string for collected_attr_assign_prop
 * 
 * Revision 1.13  90/07/02  17:58:03  little
 * added visible_prop
 * 
 * Revision 1.12  90/06/16  12:24:21  little
 * added a couple of new symbol types
 * 
 * Revision 1.11  90/06/14  13:51:38  little
 * more changes to integrate visulization and structure editors
 * 
 * Revision 1.10  90/06/11  19:27:15  dvk
 * No changes
 * 
 * Revision 1.9  90/02/28  18:51:05  dvk
 * Moved cus_get_props, cus_put_props, cus_gensym_seed, cus_sym_tab,
 * and cus_context_seed into cus.c (data declarations don't belong
 * in a .h file!).  Deleted printing versions of _prop's that were
 * removed from cus.h
 * 
 * Revision 1.8  90/02/15  09:26:29  ejh
 * put ifndef around memoryPack
 * 
 * Revision 1.7  90/02/14  21:45:49  ejh
 * fixed include structure
 * 
 * Revision 1.6  90/01/08  18:38:45  bmc
 * Added active_display_prop and list_of_displays_prop 
 * 
 * Revision 1.5  89/12/04  16:29:35  bmc
 * added object_technologies_prop
 * 
 * Revision 1.4  89/11/15  14:46:45  bmc
 * fix compilation error
 * 
 * Revision 1.3  89/11/14  16:30:56  bmc
 * Added parent_dialogue_prop and a whole bunch of others that were
 * supposed to be there, but weren't.
 * 
 * Revision 1.2  89/11/08  11:55:04  little
 * add some properties needed by the dialogue editor
 * 
 * Revision 1.1  89/10/07  23:48:54  serpent
 * Initial revision
 * 
 * Revision 1.21  89/09/29  15:36:52  little
 *  add name_text_prop, this is getting boring
 * 
 * Revision 1.20  89/09/29  14:09:28  little
 * add creation_condition_text_prop
 * 
 * Revision 1.19  89/09/29  14:02:43  little
 * add the comment text props
 * 
 * Revision 1.18  89/09/28  14:23:56  little
 * add the text snippet properties
 * 
 * Revision 1.17  89/09/26  18:09:44  bmc
 * Added properties for dialogue editor application.
 * 
 * Revision 1.16  89/07/25  21:42:30  bmc
 * Added sd_template_prop
 * 
 * Revision 1.15  89/06/16  17:38:26  little
 * move the props added in the last change to the end of the list
 * 
 * Revision 1.14  89/06/16  16:37:59  bmc
 * Added potential_vcs_prop and saved_sne_prop to cus_property_type_print_value
 * array.
 * 
 * Revision 1.13  89/06/16  16:29:43  bmc
 * Checked out to test a CM problem, at Mr. CM's request.
 * 
 * Revision 1.12  89/06/09  14:29:46  little
 * add template, current_type, current_value, & original_name slots
 *   to symbol structure
 * add defintions for cus_prop_sets & cus_prop_gets which are arrays which
 *   are used to check count of prop usages
 * 
 * Revision 1.11  89/05/11  15:43:18  little
 * put the redefined_prop into the sy,bol structure (it used to be on the 
 * property list)
 * 
 * Revision 1.10  89/04/07  17:48:45  ljb
 * add properties for saving shared data info across vcs
 * and for user defined functions
 * 
 * Revision 1.9  89/04/03  16:41:32  little
 * add the snippet_text_prop, which is used by the editor to keep the
 * text form of a snippet.
 * 
 * Revision 1.8  89/02/26  10:44:04  little
 * add cc_lineno_prop
 * 
 * Revision 1.7  89/02/10  14:32:04  ejh
 * added copyright notice
 * 
 * Revision 1.6  89/02/01  16:24:12  little
 * add alternate_print_string_prop
 * 
 * Revision 1.5  89/01/26  16:31:38  little
 * delete some entries from property name array to bring it back into
 * correspondance with the property enum in cus.h
 * 
 * Revision 1.4  89/01/18  14:21:18  ejh
 * new ill file preamble properties
 * 
 * Revision 1.3  89/01/17  16:30:19  little
 * add bound_elem_sym and bound_comp_sym to cus_symbol_type_print_value
 * 
 * Revision 1.2  88/12/20  13:15:50  little
 * add user_defined_prop and redefined_prop
 * 
|
|
\*--------------------------------------------------------------------------*\
|
|   Distribution: Approved for public release; distribution is unlimited.
|
|   Copyright (c) 1989  by  Carnegie  Mellon  University, Pittsburgh, PA.  The
|  Software Engineering  Institute  (SEI) is a federally  funded  research and
|  development center established  and  operated by Carnegie Mellon University
|  (CMU).  Sponsored  by  the  U.S.  Department  of   Defense  under  contract
|  F19628-85-C-0003,  the  SEI  is  supported  by  the  services  and  defense
|  agencies, with the U.S. Air Force as the executive contracting agent.
|
|    Permission to use,  copy,  modify, or  distribute  this  software and its
|  documentation for  any purpose and without fee  is hereby granted, provided
|  that  the above copyright notice appear  in  all copies and that both  that
|  copyright  notice  and   this  permission  notice  appear   in   supporting
|  documentation.   Further,  the  names  Software  Engineering  Institute  or
|  Carnegie  Mellon  University  may  not be used in  advertising or publicity
|  pertaining to distribution of the software without specific, written  prior
|  permission.  CMU makes no claims  or representations  about the suitability
|  of this software for any purpose.  This software is provided "as is" and no
|  warranty,  express  or  implied,  is  made  by  the  SEI  or CMU, as to the
|  accuracy  and  functioning of the program and related program material, nor
|  shall   the  fact of  distribution   constitute  any   such  warranty.   No
|  responsibility is assumed by the SEI or CMU in connection herewith.
|
\*--------------------------------------------------------------------------*/

#ifndef	CUS_PRIVATE_H
#define	CUS_PRIVATE_H

#ifndef	memoryPack
#define	memoryPack
#endif

#include	"cus.h"

#define BASE_HASH_SIZE	599	/* The size of the base-level hashtable */
#define NAME_HASH_SIZE	1031	/* The size of the name hashtable */
#define HASH_SIZE	131	/* The size of non-base-level hashtable */
#define BASE_CONTEXT	2
#define HIDDEN_CONTEXT	1
#define SYM_IDENTIFIER	0x2AAA


/*--------------------------------------------------------------------------*\
|  Description:
|	Concrete represenation of a property.  The property names in the
|	property list are represented as Zimmerman list tag values.  The tag
|	value is simply the property name enum value.  An item of type
|	cus_priv_property is what is stored in the list element as the
|	property value.
\* Definition:                                                              */

	typedef	char * cus_priv_property;

#define	NULLst_sym	((cus_sym) 0)

/*--------------------------------------------------------------------------*\
|  Description:  
|     the symbol type print values
| 
\* Definition:                                                              */

static char *cus_symbol_type_print_value [] = {
	"null_sym",
	"vc_sym",
	"object_sym",
	"attribute_sym",
	"function_sym",
	"function_call_sym",
	"variable_sym",
	"snippet_sym",
	"operator_sym",
	"if_sym",
	"while_sym",
	"comment_sym",
	"ill_data_definition_sym",
	"assignment_sym",
	"id_sym",
	"sd_sym",
	"temp_sym",
	"constant_sym",
	"ill_sym",
	"bound_elem_sym",
	"bound_comp_sym",
	"method_sym",
	"elsif_sym",
   	"exp_only_sym"

	 };

/*--------------------------------------------------------------------------*\
|  Description:  
|     the property names print values
| 
\* Definition:                                                              */

static char *cus_property_type_print_value [] = {
	"instances_prop",			/* 0 */
	"template_prop",
	"parent_vc_prop",
	"objects_prop",
	"variables_prop",
	"sub_vcs_prop",
	"creation_condition_prop",
	"methods_prop",
	"create_actions_snippet_prop",
	"destroy_actions_snippet_prop",
	"type_prop",				/* 10 */
	"attributes_prop",
	"value_snippet_prop",
	"modified_snippet_prop",
	"current_type_prop",
	"current_value_prop",
	"initial_value_snippet_prop",
	"owned_context_prop",
	"c_function_name_prop",
	"num_operands_prop",
	"data_definition_prop",			/* 20 */
	"object_type_prop",
	"is_reserved_word_prop",
	"is_constant_prop",
	"is_comment_prop",
	"vc_comments_prop",
	"variable_comments_prop",
	"object_comments_prop",
	"cc_used_vars_prop",
	"ask_prop",
	"u_name_prop", 				/* 30 */
	"fixed_method_snippet_prop",
	"parent_object_prop",
	"c_proc_number_prop",
	"fixed_creation_condition_prop",
	"generic_magic_id_prop",
	"specific_magic_id_prop",
	"ill_file_name_prop",
	"mailbox_name_prop",
	"execution_name_prop",
	"exec_command_prop",			/* 40 */
	"idd_handle_prop",
	"id_prop",
	"ill_files_prop",
	"taps_prop",
	"original_name_prop",
	"creating_sd_prop",
	"vce_prop",
	"is_built_in_prop",
	"fixed_method_prop",
	"is_ok_id_name_prop",			/* 50 */
	"created_vcs_prop",
	"old_cc_used_vars_prop",
	"pet_proc_name_prop",
	"cc_uses_new_prop",
	"user_defined_prop",
	"redefined_prop",
	"cc_lineno_prop",
	"binary_operator_prop",			/* 60 */
	"unary_operator_prop",
	"snippet_text_prop",
	"old_created_vcs_prop",
	"old_parent_vc_prop",
	"old_owned_context_prop",
	"parameter_conversion_functions_prop",
	"returned_value_conversion_function_prop",
	"potential_vcs_prop",
	"saved_sne_prop",
	"sd_template_prop",			/* 70 */
	"file_name_prop",
	"prologue_comments_prop",
	"macros_prop",
	"externs_prop",
	"technologies_prop",
	"shared_data_prop",
	"eve_vc_prop",
	"symbol_table_prop",
	"dialogue_context_prop",
	"value_snippet_text_prop",		/* 80 */
	"create_actions_snippet_text_prop",
	"destroy_actions_snippet_text_prop",
 	"initial_value_snippet_text_prop",
	"vc_comments_text_prop",
	"variable_comments_text_prop",
	"object_comments_text_prop",
	"creation_condition_text_prop",
	"name_text_prop",
	"obj_type_text_prop",
	"method_text_prop",			/* 90 */
	"external_type_string",
	"dialogue_element_type_prop",
	"parent_dialogue_prop",
	"object_technology_prop",
	"object_instances_prop",
	"ghost_p_prop",
	"snippet_constant_p_prop",
	"visible_prop",
	"collected_attr_assign_prop",
	"count_prop",
   	"pfl_prop",
   	"pfl_stack_prop",
	"num_components_prop",
	"object_count_prop", 

/*
        ADD ALL PROPERTY PRINT VALUES BEFORE THE SLOP AREA BELOW
*/
	"THIS IS A NONEXISTENT PROPERTY, OOOOPS!!!",
	"THIS IS A NONEXISTENT PROPERTY, OOOOPS!!!",
	"THIS IS A NONEXISTENT PROPERTY, OOOOPS!!!",
	"THIS IS A NONEXISTENT PROPERTY, OOOOPS!!!",
	"THIS IS A NONEXISTENT PROPERTY, OOOOPS!!!",
	"THIS IS A NONEXISTENT PROPERTY, OOOOPS!!!"
	 };			/* END */

#endif

